//
// ASURA_AdObject.h
//
// Created by DWW 27/06/06
// 
// Copyright (C) 2006 Strangelite, All Rights Reserved.
//

#pragma once

#ifndef _ASURA_ADOBJECT_
#define _ASURA_ADOBJECT_

typedef enum
{
	ASURA_AD_BGR,
	ASURA_AD_BGRA,
	ASURA_AD_RGBA,
	ASURA_AD_ALPHA,
	ASURA_AD_RGB565,
	ASURA_AD_RGB5551,
	ASURA_AD_LUM,
}ASURA_AD_IMAGEFORMAT;

class Asura_AdObject
{
public:
	Asura_AdObject(void);

	const int GetTextureID()
	{
		return m_iTextureID;
	}

	const int GetObjectID()
	{
		return m_iObjectID;
	}

	void SetObjectID(const int iID)
	{
		m_iObjectID = iID;
	}

public:
				
	virtual bool Initialise(const char* zPlaceHolderFileName, const int iTextureID, const void *pData = 0);
	
	virtual bool Destroy(void);

	virtual bool Update(const float fFrameTime);

protected:
	
	bool Platform_RenderToTexture(void* pBits, int iWidth, int iHeight, int iByteSize, int iBytesPerPixel);
	bool Platform_CreateAdTexture(const int iWidth, const int iHeight, const ASURA_AD_IMAGEFORMAT xImageFormat);

	bool Platform_Initialise(void);
	bool Platform_Shutdown(void);
	bool Platform_Update(const float fFrameTime);

protected:
	// The texture place holder name to be used as an add in game (asura texture management)
	char*	m_zTextureFileName;

	// the id to the loaded texture place holder (asura texture management)
	int		m_iTextureID;

	// assigned when the object is created
	int		m_iObjectID; 

	// any other data used by the vendor specific ad engine the object may need that is not included in this object
	void*	m_pSpecficData;
};

#endif
