//*******************************************************************
//
// File: Asura_Affector.cpp                  
//
// Created: 9 Nov 2006
//
// Description: 
//
//*******************************************************************

// system libraries
#include "Core/Asura.h"

#if defined( ASURA_USE_AFFECTORS) && 1 == ASURA_USE_AFFECTORS

// main header
#include "Affectors/Asura_Affector.h"

// other libraries
#include "ChunkSystem/Asura_Chunk_Stream.h"
#include "Debugging/Asura_Assert.h"

// internal dependencies

//*******************************************************************
// Constants
//*******************************************************************

static const u_int	g_uChunkVersion	= 1;


//*******************************************************************
// Local Classes
//*******************************************************************


//*******************************************************************
// Local Data
//*******************************************************************


//*******************************************************************
// Function Definitions
//*******************************************************************

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Affector::ReadFromChunkStream
// Author       : Andy Tate
// Date         : 6-Dec-2006
////////////////////////////////////////////////////////////////////////////////

void Asura_Affector::ReadFromChunkStream (Asura_Chunk_Stream& xStream)
{
	u_int	uVersion;

	// Read the data...
	xStream >> uVersion;

	if(uVersion > g_uChunkVersion)
	{
		Asura_Assert(false, "Unexepcted version number for affector.");
	}
	else
	{
		Asura_ReadFromStream_Bitfield_Wrapper<u_int>	xBitfield(m_uFlags);

		xStream >> m_xPosition;
		xStream >> m_fRange;
		xStream >> m_fStrength;
		xStream >> xBitfield;
	}
}

/// End of function 'Asura_Affector::ReadFromChunkStream'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Affector::WriteToChunkStream
// Author       : Andy Tate
// Date         : 6-Dec-2006
////////////////////////////////////////////////////////////////////////////////

void Asura_Affector::WriteToChunkStream (Asura_Chunk_Stream& xStream) const
{
	Asura_WriteToStream_Bitfield_Wrapper<u_int>	xBitfield(m_uFlags);

	// Generate the bitfield...
	xBitfield.Add(m_bActive, 1);

	// Write the data...
	xStream << g_uChunkVersion;

	xStream << m_xPosition;
	xStream << m_fRange;
	xStream << m_fStrength;
	xStream << xBitfield;
}

/// End of function 'Asura_Affector::WriteToChunkStream'. ///

#endif //defined( ASURA_USE_AFFECTORS) && 1 == ASURA_USE_AFFECTORS

//*******************************************************************
//
// (c) 2006 Rebellion
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************


/// End of file. ///
