
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_Affector_Global.cpp
// Author : Andy Tate
// Date   : 8-Dec-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Affectors/Asura_Affector_Global.h"

// Asura independent header-files...
#include "ChunkSystem/Asura_Chunk_Stream.h"

// Asura platform header-files...

// Tools header-files...


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////

static const u_int	g_uChunkVersion	= 2;


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Affector_Global::ReadFromChunkStream
// Author       : Andy Tate
// Date         : 8-Dec-2006
////////////////////////////////////////////////////////////////////////////////

void Asura_Affector_Global::ReadFromChunkStream (Asura_Chunk_Stream& xStream)
{
	u_int	uVersion;

	// Read the data...
	xStream >> uVersion;

	if(uVersion > g_uChunkVersion)
	{
		Asura_Assert(false, "Unexepcted version number for affector.");
	}
	else
	{
		Asura_ReadFromStream_Bitfield_Wrapper<u_int>	xBitfield(m_uFlags);

		xStream >> m_fStrength;
		xStream >> xBitfield;

		if(uVersion > 1)
		{
			xStream >> m_fResponseScale;
		}
		else
		{
			m_fResponseScale	= 1.0f;
		}
	}
}

/// End of function 'Asura_Affector_Global::ReadFromChunkStream'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Affector_Global::WriteToChunkStream
// Author       : Andy Tate
// Date         : 8-Dec-2006
////////////////////////////////////////////////////////////////////////////////

void Asura_Affector_Global::WriteToChunkStream (Asura_Chunk_Stream& xStream) const
{
	Asura_WriteToStream_Bitfield_Wrapper<u_int>	xBitfield(m_uFlags);

	// Generate the bitfield...
	xBitfield.Add(m_bActive, 1);

	// Write the data...
	xStream << g_uChunkVersion;

	xStream << m_fStrength;
	xStream << xBitfield;
	xStream << m_fResponseScale;
}

/// End of function 'Asura_Affector_Global::WriteToChunkStream'. ///


/// End of file. ///
