//
// Asura_Animation_BoneDataModifier.cpp
//
// Created by Will Plano - 09/10/2008
// 
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

// I N C L U D E S ///////////////////////////////////////////////////////////
#include "Core/Asura.h"

// This file's header.
#include "Animation/Asura_Animation_BoneDataModifier.h"

// Asura
#include "Animation/Asura_Animation.h"

Asura_Animation_BoneDataModifier::Asura_Animation_BoneDataModifier( Asura_Animation* pxAnimation, u_int uUpdateTimersPriority /*= ASURA_ANIMATION_BONEDATAMODIFIER_PRIORITY_DONT_ADD*/, u_int uUpdateBoneDataPriority /*= ASURA_ANIMATION_BONEDATAMODIFIER_PRIORITY_DONT_ADD */ )
: m_pxAnimation( pxAnimation )
, m_uUpdateTimersPriority( uUpdateTimersPriority )
, m_uUpdateBoneDataPriority( uUpdateBoneDataPriority )
{
 	Asura_Assert( pxAnimation, "No animation specified" );
	if ( pxAnimation )
	{
		if ( uUpdateTimersPriority != ASURA_ANIMATION_BONEDATAMODIFIER_PRIORITY_DONT_ADD )
		{
			pxAnimation->AddToUpdateTimersList( this );
		}

		if ( uUpdateBoneDataPriority != ASURA_ANIMATION_BONEDATAMODIFIER_PRIORITY_DONT_ADD )
		{
			pxAnimation->AddToUpdateBoneDataList( this );
		}
	}
}

Asura_Animation_BoneDataModifier::~Asura_Animation_BoneDataModifier()
{
	if ( m_pxAnimation )
	{
		if ( m_uUpdateTimersPriority != ASURA_ANIMATION_BONEDATAMODIFIER_PRIORITY_DONT_ADD )
		{
			m_pxAnimation->RemoveFromUpdateTimersList( this );
		}

		if ( m_uUpdateBoneDataPriority != ASURA_ANIMATION_BONEDATAMODIFIER_PRIORITY_DONT_ADD )
		{
			m_pxAnimation->RemoveFromUpdateBoneDataList( this );
		}
	}
}
