
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_Hierarchy_Tween.cpp
// Author : Andy Tate
// Date   : 15-Sep-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Animation/Asura_Hierarchy_Tween.h"

// Asura independent header-files...
#include "Animation/Asura_Hierarchy.h"

// Asura platform header-files...

// Game independent header-files...

// Game platform header-files...

// Tools header-files...


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////

void Asura_Hierarchy_Tween::SetNumberOfBones(const u_int uNumberOfBones)
{
	if(uNumberOfBones != m_uNumberOfBones)
	{
		//clear out old data
		DeleteTweenStore();

		//and allocate new
		m_uFlags = 0;

		m_xVelocity.Zero();
		m_xAngularVelocityAxis	= Asura_Vector_3(0.0f, 0.0f, 1.0f);
		m_fAngularVelocityAngle	= 0.0f;
		m_xMovementOffsetPosition.Zero();
		m_xMovementOffsetQuat.Identity();
		m_pxBoneData	= new Asura_Hierarchy_TweenStore_BoneData[uNumberOfBones];

		m_uNumberOfBones = uNumberOfBones;
	}
}

void Asura_Hierarchy_Tween::DeleteTweenStore()
{
	delete [] m_pxBoneData;
	m_pxBoneData	= NULL;

	m_uFlags = 0;

	Invalidate();
}

void Asura_Hierarchy_Tween::Copy(const Asura_Hierarchy_Tween* pxTween)
{
	delete[](m_pxBoneData);

	m_pxBoneData				= new Asura_Hierarchy_TweenStore_BoneData[pxTween->m_uNumberOfBones];

	m_uFlags					= pxTween->m_uFlags;

	m_xVelocity					= pxTween->m_xVelocity;
	m_xAngularVelocityAxis		= pxTween->m_xAngularVelocityAxis;
	m_fAngularVelocityAngle		= pxTween->m_fAngularVelocityAngle;
	m_xMovementOffsetPosition	= pxTween->m_xMovementOffsetPosition;
	m_xMovementOffsetQuat		= pxTween->m_xMovementOffsetQuat;

	for(u_int u = 0; u < m_uNumberOfBones; u++)
	{
		m_pxBoneData[u]	= pxTween->m_pxBoneData[u];
	}
}


/// End of file. ///
