//
// Asura_Attractor_EntityRelative.h
//
// Created by RAR 11/10/06
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_ATTRACTOR_ENTITYRELATIVE_H__
#define __ASURA_ATTRACTOR_ENTITYRELATIVE_H__

#ifdef ASURA_USE_ATTRACTORS


#include "Attractors/Asura_Attractor_Compiled.h"


/*
	Asura_Attractor_EntityRelative

	Attractor that is positioned relative to an entity
*/
class Asura_Attractor_EntityRelative : public Asura_Attractor_Compiled
{

public:
	Asura_Attractor_EntityRelative();
	//update the current position.
	//returns false if the position is currently invalid
	bool UpdatePosition();

	virtual void GetNormal(Asura_Vector_3& xNormal) const;

#ifdef ASURA_TOOLS
	// When saving to chunk, we want the relative normal.
	void GetRelativeNormal(Asura_Vector_3& xNormal) const { Asura_Attractor_Compiled::GetNormal(xNormal); }
#endif //#ifdef ASURA_TOOLS

private:
	
	Asura_Guid m_uParentGuid;
	Asura_Vector_3 m_axRelativePosition[2];

	u_int m_uFrameStamp;
	bool m_bPositionValid;


	friend class Asura_Chunk_Attractors;
	friend class Tools_Attractor_System;
};

#endif // ASURA_USE_ATTRACTORS
#endif // __ASURA_ATTRACTOR_ENTITYRELATIVE_H__


