//*******************************************************************
//
// File: Asura_Botanical_Game_Render_Dynamic_Memory_Layout.h
//
// Created: 30 Nov 2006
//
// Description: 
//
//*******************************************************************

#ifndef _ASURA_BOTANICAL_GAME_RENDER_DYNAMIC_MEMORY_LAYOUT_H_
#define _ASURA_BOTANICAL_GAME_RENDER_DYNAMIC_MEMORY_LAYOUT_H_

// other libraries
#include "Botanicals/Asura_Botanical_Game_Render_Constants.h"

// internal dependencies

// forward declarations
class Asura_Chunk_Stream;
class Asura_BGR_Type;

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Class Definitions
//*******************************************************************

#if defined( ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA) && 1 == ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA
class Asura_BGR_DynamicMemoryLayout
{
public:
	void Clear();
	
	bool Process( Asura_Chunk_Stream& xStream);
#if defined( ASURA_TOOLS)
	bool Export( Asura_Chunk_Stream& xStream) const;
	
	bool SetupDynamicData( const Asura_BGR_Type& xType);
#endif

	bool HasDynamicSectionVersionData() const;

public:
	u_int m_uDynamicSizeInstance;

	const static u_int DYNAMIC_OFFSET_INVALID = 0xFFFFFFFFl;

	u_int m_uDynamicOffsetSectionData;
	u_int m_uDynamicOffsetStateData;
	u_int m_uDynamicOffsetUserData;
	u_int m_uDynamicOffsetInteractiveData;
};
#endif

#if defined( ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA) && 1 == ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA
class Asura_BGR_InteractiveBasic
{
public:
	float m_afPosition[3];
	float m_afVelocity[3];
};
#endif



//*******************************************************************
// Inline Function Definitions
//*******************************************************************

#if defined( ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA) && 1 == ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA
inline void Asura_BGR_DynamicMemoryLayout::Clear()
{
	this->m_uDynamicSizeInstance = 0;

	this->m_uDynamicOffsetSectionData = DYNAMIC_OFFSET_INVALID;
	this->m_uDynamicOffsetStateData = DYNAMIC_OFFSET_INVALID;
	this->m_uDynamicOffsetUserData = DYNAMIC_OFFSET_INVALID;
	this->m_uDynamicOffsetInteractiveData = DYNAMIC_OFFSET_INVALID;
}
#endif

#if defined( ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA) && 1 == ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA
inline bool Asura_BGR_DynamicMemoryLayout::HasDynamicSectionVersionData() const 
{ 
	return( DYNAMIC_OFFSET_INVALID != this->m_uDynamicOffsetSectionData);
}
#endif
//*******************************************************************
//
// (c) 2006 Rebellion
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif // _ASURA_BOTANICAL_GAME_RENDER_DYNAMIC_MEMORY_LAYOUT_H_
