//*******************************************************************
//
// File: Asura_Botanical_Game_Render_Instance_Transform.h
//
// Created: 30 Nov 2006
//
// Description: 
//
//*******************************************************************

#ifndef _ASURA_BOTANICAL_GAME_RENDER_INSTANCE_TRANSFORM_H_
#define _ASURA_BOTANICAL_GAME_RENDER_INSTANCE_TRANSFORM_H_

// other libraries

// internal dependencies

// forward declarations

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Class Definitions
//*******************************************************************
#if defined( ASURA_TOOLS)
class Asura_BGR_InstanceTransform
{
public:
	void Set( const Asura_Vector_3& xPosition, const Asura_Matrix_3x3& xOrientation, const float fScale);
	
	Asura_Matrix_3x3 GetOrientation() const;
	
public:
	Asura_AVector3 m_xPosition;
	float m_fScale;
	D3DXMATRIX m_xTransformMatrix;
};
#endif


//*******************************************************************
// Inline Function Definitions
//*******************************************************************

inline void Asura_BGR_Instance::GetInstanceData( Asura_BGR_InstanceTransform& xInstanceTransform) const
{
#if !defined( ASURA_DIRECT3D_BGR_INSTANCE_ENABLE_COMPRESSED_DATA)
	xInstanceTransform.m_xPosition = this->m_xPosition;
	
	xInstanceTransform.m_xTransformMatrix = this->m_xTransformMatrix;
#else
	xInstanceTransform.m_xPosition = Asura_AVector3( this->m_afPosition[0], this->m_afPosition[1], this->m_afPosition[2]);
	
	{
		xInstanceTransform.m_xTransformMatrix._11 = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][0]);
		xInstanceTransform.m_xTransformMatrix._21 = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][1]);
		xInstanceTransform.m_xTransformMatrix._31 = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][2]);
		xInstanceTransform.m_xTransformMatrix._41 = this->m_afPosition[0];
																																	
		xInstanceTransform.m_xTransformMatrix._12 = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[1][0]);
		xInstanceTransform.m_xTransformMatrix._22 = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[1][1]);
		xInstanceTransform.m_xTransformMatrix._32 = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[1][2]);
		xInstanceTransform.m_xTransformMatrix._42 = this->m_afPosition[1];
																																	
		xInstanceTransform.m_xTransformMatrix._13 = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[2][0]);
		xInstanceTransform.m_xTransformMatrix._23 = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[2][1]);
		xInstanceTransform.m_xTransformMatrix._33 = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[2][2]);
		xInstanceTransform.m_xTransformMatrix._43 = this->m_afPosition[2];
																																	
		xInstanceTransform.m_xTransformMatrix._14 = 0.0f;
		xInstanceTransform.m_xTransformMatrix._24 = 0.0f;
		xInstanceTransform.m_xTransformMatrix._34 = 0.0f;
		xInstanceTransform.m_xTransformMatrix._44 = 1.0f;
	}
#endif

	xInstanceTransform.m_fScale = 1.0f;
}

//*******************************************************************
//
// (c) 2006 Rebellion
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif // _ASURA_BOTANICAL_GAME_RENDER_INSTANCE_TRANSFORM_H_
