//*******************************************************************
//
// File: Asura_Botanical_Game_Render_Type_BasicInteractive.h
//
// Created: 30 Nov 2006
//
// Description: 
//
//*******************************************************************

#ifndef _ASURA_BOTANICAL_GAME_RENDER_TYPE_BASICINTERACTIVE_H_
#define _ASURA_BOTANICAL_GAME_RENDER_TYPE_BASICINTERACTIVE_H_

// other libraries
#include "Botanicals/Asura_Botanical_Game_Render_Constants.h"

// internal dependencies

// forward declarations

#if defined( ASURA_TOOLS)
	class Tools_BotanicalShape;
	class Asura_Chunk_Stream;
#endif

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Class Definitions
//*******************************************************************
#if defined( ASURA_BOTANICAL_SUPPORT_INTERACTIVE)
#include "Core/Asura_Maths.h"

class Asura_BGR_Type_BasicInteractive
{
public:

#if defined( ASURA_TOOLS)
	void Setup( const Tools_BotanicalShape& xToolShape);
#endif

	bool Process( Asura_Chunk_Stream& xStream);
#if defined( ASURA_TOOLS)
	bool Export( Asura_Chunk_Stream& xStream);
#endif

public:
	Asura_AVector3 m_xBonePosition0;
	Asura_AVector3 m_xBonePosition1;
	float m_fMass;
	float m_fBoneLength;
	float m_fDrag;
	float m_fSpringStrength;
	float m_fSpringLength;
	float m_fBoneWeightGamma;
#if defined( ASURA_TOOLS)
	bool m_bUsePaintedColoursAsWeights;
#endif
};
#endif


//*******************************************************************
// Inline Function Definitions
//*******************************************************************

//*******************************************************************
//
// (c) 2006 Rebellion
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif // _ASURA_BOTANICAL_GAME_RENDER_TYPE_BASICINTERACTIVE_H_
