//////////////////////////////////////////////////////////////////////////////
//
// Asura_Chunk_Blueprints.h
//
// Created by NJD - 06 September 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_CHUNK_BLUEPRINTS_H__
#define __ASURA_CHUNK_BLUEPRINTS_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// asura
#include "Blueprint/Asura_Blueprint_System.h"
#include "Core/Asura_Handle.h"
#include "Core/Asura_Hash.h"
#include "ChunkSystem/Asura_Chunk_Loaders.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Chunk_File_Stream;
class Asura_SaveBlock;
class Asura_String;

//////////////////////////////////////////////////////////////////////////////
//
// Asura_Chunk_Blueprints
//
//////////////////////////////////////////////////////////////////////////////

class Asura_Chunk_Blueprints : public Asura_Chunk_Header
{
public:
    bool Process( Asura_Handle hFile ) const;
    bool Process( Asura_Chunk_File_Stream& xStream ) const;

	// If the blueprints are being read in from a file this will set the file name (relative to Asura_Files/).
	static void GetCurrentBlueprintFileName( Asura_String& xFileName );

#ifdef ASURA_TOOLS
    static bool SaveBlueprints( const char* szFilename, const Asura_Hash_ID uBlueprintTypeHashID = ASURA_HASH_ID_UNSET );

	//RAR 12/12/2006 Made blueprint chunk creation public for use by export process
	static bool Create( Asura_SaveBlock& xSaveBlock, const Asura_Hash_ID uBlueprintTypeHashID );
    static bool Create( Asura_Chunk_Stream& xStream, const Asura_Hash_ID uBlueprintTypeHashID );
#endif

private:
	static Asura_Handle s_iCurrentFileHandle;

	enum { CURRENT_CHUNK_VERSION = 0 };
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__ASURA_CHUNK_BLUEPRINTS_H__
