//////////////////////////////////////////////////////////////////////////////
//
// Asura_Chunk_DSP.h
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#if !defined __ASURA_CHUNK_DSP_H__
#define __ASURA_CHUNK_DSP_H__

#if defined ASURA_USE_AUDIO_SYSTEM

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

#include "ChunkSystem/Asura_Chunk_Loaders.h"

/******************************************************************************/
/* Classes                                                                    */
/******************************************************************************/

////////////////////////////////////////////////////////////////////////////////
//
// Asura_Chunk_DSP
//
// Chunk containing properties of DSP effect chains
//
////////////////////////////////////////////////////////////////////////////////

class Asura_Chunk_DSP : public Asura_Chunk_Header
{
public:

	bool Process( const int iFileHandle );
	
	#ifdef ASURA_TOOLS
	static void Create( Asura_Chunk_Stream& xStream );
	static void Create( Asura_SaveBlock* pxSaveBlock );
	static bool SaveToolsData ();
	static const char* GetFilename ();
	#endif

	static const int iCURRENT_VERSION;
};

#endif // defined ASURA_USE_AUDIO_SYSTEM

#endif // !defined __ASURA_CHUNK_DSP_H__
