///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_Chunk_FSFXOverrides.h
// Author : Andy Southgate
// Date   : 22-Apr-2009
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_CHUNK_FSFXOVERRIDES_H__
#define __ASURA_CHUNK_FSFXOVERRIDES_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "ChunkSystem/Asura_Chunk_Loaders.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class Asura_Chunk_Stream;


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : Asura_Chunk_FSFXOverrides
// Author       : Andy Southgate
// Date         : 22-Apr-2009
//
// Description  : Class used for reading/writing FSFX override data.
////////////////////////////////////////////////////////////////////////////////

class Asura_Chunk_FSFXOverrides : public Asura_Chunk_Header
{
public:
	// Public functions...
	Asura_Chunk_FSFXOverrides  (void);
	//	~Asura_Chunk_FSFXOverrides ();

	// Reading function...
	bool	Process	(const Asura_Handle iFileHandle) const;

#if defined(ASURA_TOOLS)
	// Tools only save creation functions...
	static void	Create	(Asura_Chunk_Stream& xStream);
	static bool	Save	(const char* szFilename);
#endif	// defined(ASURA_TOOLS)


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private variables...

	// Private functions...
	Asura_Chunk_FSFXOverrides  (const Asura_Chunk_FSFXOverrides& xOther);

	Asura_Chunk_FSFXOverrides&	operator=	(const Asura_Chunk_FSFXOverrides& xOther);

};   // End of class 'Asura_Chunk_FSFXOverrides'.

#endif	// ifndef __ASURA_CHUNK_FSFXOVERRIDES_H__


/// End of file. ///
