//
// Asura_Chunk_FileInfo.h
//
// Created by Richard Rice - 07/12/05
// 
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CHUNK_FILEINFO_H__
#define __ASURA_CHUNK_FILEINFO_H__

#include "ChunkSystem/Asura_Chunk_Loaders.h"


//Enumeration of asura file types , so taht the tools can identify what type of file
//it is dealing with. These are added to teh file info chunk for new files.
//RAR 12/06/2005
enum AsuraFileType
{
	//not saved as file types , but used as return values
	AsuraFile_Unknown = -2,
	AsuraFile_Error = -1,

	//These values are saved out , so don't alter existing ones.
	AsuraFile_Environment = 0,
	AsuraFile_Shapes = 1,
	AsuraFile_Skin = 2,
	AsuraFile_Anim = 3,
	AsuraFile_Fragment = 4,
	AsuraFile_AnimFragment = 5,
	AsuraFile_Template = 6,

	AsuraFile_ResourcePacker = 7, //For files that are created by resource packer
	AsuraFile_Exported = 8,       //File was created by a level or character export.
	AsuraFile_AnimTable = 9,
	AsuraFile_TextureTiler = 10,  // chunk created by texture tiler tools mode
	AsuraFile_FaceAnim = 11, //File containing a single facial animation

};

// (MH - 08.01.2003) this class is required to cope with not knowing the uncompressed size
// of compressed files, and to prevent expensive seeks on the PS2. Other stuff might be 
// added later. It should be added as the first chunk of files which will be used with 
// loading bars.
// (RAR - 12.06.2005) Added file type , to indicate what type of file is being dealt with
class Asura_Chunk_FileInfo: public Asura_Chunk_Header
{

	public:

		bool Process(Asura_Handle iFileHandle) const;
#ifdef ASURA_TOOLS
		static void Create(class Asura_SaveBlock* pxSaveBlock, u_int uFileSize, AsuraFileType eFileType, bool bHasLocalisedFile = false);
        static void Create(char* pcBuffer, u_int uFileSize, AsuraFileType eFileType, bool bHasLocalisedFile = false);
        static void Create(Asura_Chunk_Stream& xStream, u_int uFileSize, AsuraFileType eFileType, bool bHasLocalisedFile = false);
        
        static AsuraFileType GetLastLoadedFileType() { return( s_eLastLoadedFileType);}
#endif
        static int GetChunkSize();

		enum ChunkFlags
		{
			ChunkFlag_HasLocalisedFile = 0x00000001,//Indicates that there is a localised file to go along with this one
		};

        
#ifdef ASURA_TOOLS
		static AsuraFileType s_eLastLoadedFileType;
#endif
};


#endif //__ASURA_CHUNK_FILEINFO_H__
