//
// Asura_Chunk_GI_Solution.h
//
// Created by KJFL - 2004-07-20 10:21:05
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_CHUNK_GI_SOLUTION_H__
#define __ASURA_CHUNK_GI_SOLUTION_H__

#include "ChunkSystem/Asura_Chunk_Loaders.h"
#include "Core/Asura_Handle.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_SaveBlock;
class Asura_Chunk_Stream;

// C L A S S E S /////////////////////////////////////////////////////////////

class Asura_Chunk_GI_Solution : public Asura_Chunk_Header
{

	public:
        
		bool Process( Asura_Handle hFile ) const;

		static bool Create( Asura_SaveBlock& xSaveBlock );
		static bool Create( Asura_Chunk_Stream& xStream );

	private:

		enum { CHUNK_VERSION = 3 };

		enum ChunkFlags
		{
			ChunkFlag_SamplesValid        = 0x00000001,
			ChunkFlag_SamplesUncompressed = 0x00000002,
		};


		u_int	m_uNumberOfSamples;
};


#endif//__ASURA_CHUNK_GI_SOLUTION_H__
