//
// Asura_Chunk_GUIMenu.h
//
// Created by Steven Keen - 5/12/2006
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifndef __ASURA_CHUNK_GUIMENU__
#define __ASURA_CHUNK_GUIMENU__

#ifdef ASURA_USE_GUI_MENU_SYSTEM

#include "ChunkSystem/Asura_Chunk_Loaders.h"
#include "GUIMenu/Asura_GUIMenu_Root.h"

class Asura_GUIMenu_Menu_Page;

class Asura_Chunk_GUIMenu : public Asura_Chunk_Header
{
public :
	bool Process(class Asura_Chunk_Stream& xStream) const;
	bool Process(Asura_Handle iFileHandle) const;

	bool ReadChunkData( Asura_Chunk_Stream& xStream) const;

#ifdef ASURA_TOOLS
	static void Create(const Asura_GUIMenu_Menu_Page* pxMenuPage,class Asura_Chunk_Stream& xStream);
	static void Create(const Asura_GUIMenu_Menu_Page* pxMenuPage,class Asura_SaveBlock* pxSaveBlock);
#endif
};

#ifdef ASURA_TOOLS
//Used for containing per-file data in tools
class Asura_Chunk_GUIMenu_File : public Asura_Chunk_Header
{
public :
	bool Process(class Asura_Chunk_Stream& xStream) const;
	bool Process(Asura_Handle iFileHandle) const;


	static void Create(const char* szFile,class Asura_Chunk_Stream& xStream);
	static void Create(const char* szFile,class Asura_SaveBlock* pxSaveBlock);
};
#endif //ASURA_TOOLS

//Used for storing animation sequences in tools and exported GUIMenu files
class Asura_Chunk_GUIMenu_AnimatorSequences : public Asura_Chunk_Header
{
public :
	bool Process(class Asura_Chunk_Stream& xStream) const;
	bool Process(Asura_Handle iFileHandle) const;

#ifdef ASURA_TOOLS
	static void Create(class Asura_Chunk_Stream& xStream);
	static void Create(class Asura_SaveBlock* pxSaveBlock);
#endif //ASURA_TOOLS
};

class Asura_Chunk_GUIMenu_Audio : public Asura_Chunk_Header
{
public :
	bool Process(class Asura_Chunk_Stream& xStream) const;
	bool Process(Asura_Handle iFileHandle) const;

#ifdef ASURA_TOOLS
	static void Create( class Asura_Chunk_Stream& xStream);
	static void Create( class Asura_SaveBlock* pxSaveBlock);
#endif
};

//Chunk containing the name and ID of a hashed localised text file to use with menu system
class Asura_Chunk_GUIMenu_TextPage : public Asura_Chunk_Header
{
public :
	bool Process(class Asura_Chunk_Stream& xStream) const;
	bool Process(Asura_Handle iFileHandle) const;

#ifdef ASURA_TOOLS
	static void Create(Asura_Hash_ID uPageID, class Asura_Chunk_Stream& xStream);
	static void Create(Asura_Hash_ID uPageID, class Asura_SaveBlock* pxSaveBlock);
#endif
};

#endif //ASURA_USE_GUI_MENU_SYSTEM
#endif //__ASURA_CHUNK_GUIMENU__

