//
// Asura_Chunk_HashedLocalisedText.h
//
// Created by Richard Rice - 09/12/2002
// 
// Copyright (C) 2002 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CHUNK_HASHEDLOCALISEDTEXT__
#define __ASURA_CHUNK_HASHEDLOCALISEDTEXT__

#include "Asura_Chunk_Loaders.h"

#if defined(HASHED_TEXT_FILE_UTILITY) || defined(ASURA_TOOLS)
#include "Core/Asura_Hash.h"
#include "Core/Asura_String.h"
#include "Misc/list_tem.hpp"
#endif

class Asura_Chunk_HashedLocalisedText : public Asura_Chunk_Header
{

public:

	bool Process(Asura_Handle iFileHandle) const;

#ifdef ASURA_TOOLS
	//get the text page ID from a chunk stream that is positioned just beyond the chunk header
	Asura_Hash_ID GetPageID(Asura_Chunk_Stream& xStream) const;
#endif

#if defined(HASHED_TEXT_FILE_UTILITY) || defined(ASURA_TOOLS)
	static void Create(const char* szPageName, List<Asura_Hash_ID>& xHashList, List<Asura_String>& xTextIDList,List<Asura_UnicodeChar*>& xStringList,class Asura_SaveBlock* pxSaveBlock);
#endif


	int m_iNumberOfStrings;
		
};


#endif //__ASURA_CHUNK_HASHEDLOCALISEDTEXT__
