//
// Asura_Chunk_Lights.h
//
// Created by Kevin Lea - 12/06/2001 11:18:47
// 
// Copyright (C) 2001 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CHUNK_LIGHTS_H__
#define __ASURA_CHUNK_LIGHTS_H__

#include "Core/Asura.h"
#include "Core/Asura_Handle.h"
#include "ChunkSystem/Asura_Chunk_Loaders.h"

class Asura_SaveBlock;

class Asura_Chunk_Lights : public Asura_Chunk_Header
{
	public:
		bool Process(Asura_Handle fileHandle) const;
		static void Create(Asura_SaveBlock& saveBlock);

		int NumberOfLights;

		float AmbientR;
		float AmbientG;
		float AmbientB;

};


class Asura_Chunk_LightVisibilities : public Asura_Chunk_Header
{
	public:
		bool Process(Asura_Handle fileHandle) const;
		static void Create(Asura_SaveBlock& saveBlock);

		int NumberOfVolumetricLights;
};

#ifdef ASURA_TOOLS
//Chunk for light scale values for each platform
class Asura_Chunk_LightScale : public Asura_Chunk_Header
{
	public:
		bool Process(Asura_Handle iFileHandle) const;
		static void Create(Asura_SaveBlock* pxSaveBlock);

		int m_iNumberOfScaleValues;
};
#endif // ASURA_TOOLS



#endif//__ASURA_CHUNK_LIGHTS_H__
