/**
*
* \file Asura_Chunk_LocalText.h
*
* Created by James Paulin - 30/07/2002 12:04:40
*
* Copyright (C) 2002 Rebellion, All Rights Reserved.
*
* \brief
*
**/
#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_CHUNK_LOCALTEXT_H__
#define __ASURA_CHUNK_LOCALTEXT_H__

#include "ChunkSystem/Asura_Chunk_Loaders.h"
#include "Core/Asura_Hash.h"

const int CHUNK_LOCAL_TEXT_VERSION = 4;  // change this if you modify this class structure or its interpretation
const int CHUNK_LOCAL_TEXT_VERSION_NO_LANGUAGE_DATA = 3; // Pre this version the chunks had no language data. Don't modify this!

class Asura_Chunk_LocalText : public Asura_Chunk_Header
{

	public:

		bool Process(Asura_Handle fileHandle) const;

        int NumEntries; // how many strings follow?

};


const int CHUNK_LOCAL_TEXT_PAGE_VERSION = 5;

class Asura_Chunk_LocalText_Page : public Asura_Chunk_Header
{
public:
	bool Process( Asura_Handle uFileHandle ) const;
	static void Create(void);

	Asura_Hash_ID m_uHashID;
	u_int m_uNumEntries;
};


#endif//__ASURA_CHUNK_LOCALTEXT_H__
