//
// Asura_Chunk_Material.h
//
// Created by Richard Rice - 11/02/03
// 
// Copyright (C) 2003 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CHUNK_MATERIAL_H__
#define __ASURA_CHUNK_MATERIAL_H__

#include "ChunkSystem/Asura_Chunk_Loaders.h"

#ifdef ASURA_TOOLS
class Asura_Chunk_Stream;
#endif
class Asura_Material;

class Asura_Chunk_Material : public Asura_Chunk_Header
{
public :
	bool Process(Asura_Handle iFileHandle) const;
	#ifdef ASURA_TOOLS
	static void Create(int iNumberOfMaterials,const Asura_Material* pxMaterials,Asura_SaveBlock* pxSaveBlock);
	static void Create(int iNumberOfMaterials,const Asura_Material* pxMaterials,Asura_Chunk_Stream& xStream);
	#endif

	int m_iNumberOfMaterials;

private:

#ifdef ASURA_TOOLS
    static void Project_WriteProjectFlags( Asura_Chunk_Stream& xStream, u_int uProjectFlags );
#endif

};


//material names go in a seperate chunk from the rest of the material data ,since they
//are only needed by the tools
class Asura_Chunk_MaterialNames : public Asura_Chunk_Header
{
public :
	bool Process(Asura_Handle iFileHandle) const;
	#ifdef ASURA_TOOLS
	static void Create(int iNumberOfMaterials,const Asura_Material* pxMaterials,Asura_SaveBlock* pxSaveBlock);
	static void Create(int iNumberOfMaterials,const Asura_Material* pxMaterials,Asura_Chunk_Stream& xStream);
	#endif

	int m_iNumberOfNamedMaterials;
};

#endif //__ASURA_CHUNK_MATERIAL_H__
