//////////////////////////////////////////////////////////////////////////////
//
// Asura_Chunk_ReverbPresets.h
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#if !defined __ASURA_CHUNK_REVERBPRESETS_H__
#define __ASURA_CHUNK_REVERBPRESETS_H__

#if defined ASURA_USE_AUDIO_SYSTEM

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

#include "ChunkSystem/Asura_Chunk_Loaders.h"

/******************************************************************************/
/* Classes                                                                    */
/******************************************************************************/

class Asura_Chunk_Stream;
class Asura_HashTree;

////////////////////////////////////////////////////////////////////////////////
//
// Asura_Chunk_ReverbPresets
//
// Collection of artist-defined reverb presets
//
////////////////////////////////////////////////////////////////////////////////

class Asura_Chunk_ReverbPresets : public Asura_Chunk_Header
{
public:

	bool Process( const int iFileHandle );
	bool Process( Asura_Chunk_Stream& xStream );

	#if defined ASURA_TOOLS
		static bool Create( Asura_Chunk_Stream& xStream );
		static bool Create( Asura_Chunk_Stream& xStream, const Asura_HashTree& xTree );
	#endif

	static const int iCURRENT_VERSION;
};

#endif // defined ASURA_USE_AUDIO_SYSTEM

#endif // !defined __ASURA_CHUNK_REVERBPRESETS_H__
