/////////////////////////////////////////////////////////////////////////////////////////
//
//	FILE:			Asura_Chunk_Shape.h
//
//	AUTHOR:			Richard M. Smith (8 August 2002)
//
/////////////////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _ASURA_CHUNK_SHAPE_H_
#define _ASURA_CHUNK_SHAPE_H_

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "ChunkSystem/Asura_Chunk_Loaders.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

#ifdef ASURA_TOOLS
class Asura_Mesh;
class Asura_SaveBlock;
class Asura_Shape;
template<typename T> class List;
#endif

// C L A S S E S /////////////////////////////////////////////////////////////

/*-------------------**
** Asura_Chunk_Shape **
**-------------------*/

class Asura_Chunk_Shape : public Asura_Chunk_Header
{
public:

	bool Process( Asura_Handle fileHandle ) const;
	bool Project_Process( const char* chunkBuffer );
#ifdef ASURA_TOOLS
	static void Create( Asura_Shape* pxShape, Asura_SaveBlock& xSaveBlock, const List<Asura_Mesh*>& xMeshList );
#endif
};

bool SaveShapes( const char* szFilename,bool bEnvShapes );



#endif // _ASURA_CHUNK_SHAPE_H_




////////////////////////////////////// End of file //////////////////////////////////////
