//
// Asura_Chunk_StartPosition.h
//
// Created by Kevin Lea - 12/06/2001 11:20:26
// 
// Copyright (C) 2001 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CHUNK_STARTPOSITION_H__
#define __ASURA_CHUNK_STARTPOSITION_H__

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "ChunkSystem/Asura_Chunk_Loaders.h"
#include "Core/Asura_Maths.h"

// C L A S S E S /////////////////////////////////////////////////////////////

class Asura_Chunk_StartPosition : public Asura_Chunk_Header
{
public:
	bool Process(Asura_Handle fileHandle) const;
#ifdef ASURA_TOOLS
	static void Create( const class Asura_Environment_StartPosition* start,int index,class Asura_SaveBlock* saveBlock);
	static void Create( const class Asura_Environment_StartPosition* pxStart,int iIndex,class Asura_Chunk_Stream& xStrean);
#endif

	Asura_Matrix_3x3 Orientation;
	Asura_Vector_3 Position;


#ifdef ASURA_TOOLS
	//For handling transfer of start positions from asura to ent file.
	//Need to keep track of which file it was loaded from.
	enum StartPositionFile
	{
		SPF_NONE,
		SPF_ASURA,
		SPF_ENTITY,
	};

	static StartPositionFile s_eStartPositionFile;
#endif //ASURA_TOOLS
};


#endif//__ASURA_CHUNK_STARTPOSITION_H__
