//
// Asura_Chunk_StreamingModuleNames.h
//
// Created by Richard Rice - 11/04/2006
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"
#if defined(ASURA_USE_STREAMING) && defined(ASURA_TOOLS)
#include "ChunkSystem/Asura_Chunk_StreamingModuleNames.h"

//asura
#include "ChunkSystem/Asura_SaveBlock.h"
#include "ChunkSystem/Asura_Chunk_Stream.h"

//tools
#include "Streaming/Tools_StreamingModuleNames.h"

#define ASURA_CHUNK_STREAMINGMODULENAMES_VERSION 1

bool Asura_Chunk_StreamingModuleNames::Process (Asura_Chunk_Stream& xStream) const
{
	// Is this the correct version?
	if (Version > ASURA_CHUNK_STREAMINGMODULENAMES_VERSION)
	{
		Asura_Assertf	(false, ("Unknown chunk version %d for streaming connections",Version));
		return			(false);
	}

	Tools_StreamingModuleNames::ReadFromChunkStream(xStream,Version);
	return true;
}

bool Asura_Chunk_StreamingModuleNames::Process(Asura_Handle iFileHandle) const
{
	Asura_Chunk_File_Stream	xStream (iFileHandle);
	return	(Process(xStream));
}

void Asura_Chunk_StreamingModuleNames::Create (Asura_Chunk_Stream& xStream)
{
	// Write the data...
	xStream.WriteChunk_Start	(ASURA_CHUNK_STREAMINGMODULENAMES, ASURA_CHUNK_STREAMINGMODULENAMES_VERSION, 0);

	Tools_StreamingModuleNames::WriteToChunkStream(xStream);

	xStream.WriteChunk_End	();
}

void Asura_Chunk_StreamingModuleNames::Create(Asura_SaveBlock* pxSaveBlock)
{
	Asura_Chunk_SaveBlock_Stream xStream (pxSaveBlock);
	Create(xStream);
}


#endif //defined(ASURA_USE_STREAMING) && defined(ASURA_TOOLS)
