//
// Asura_Chunk_Texture.h
//
// Created by Kevin Lea - 12/06/2001 11:20:45
// 
// Copyright (C) 2001 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CHUNK_TEXTURE_H__
#define __ASURA_CHUNK_TEXTURE_H__

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Asura_Chunk_Loaders.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_NameTree;
class Asura_SaveBlock;
class Asura_Chunk_Stream;

// C L A S S E S /////////////////////////////////////////////////////////////

class Asura_Chunk_TextureNames : public Asura_Chunk_Header
{
public:
	bool Process(Asura_Handle fileHandle) const;
#ifdef ASURA_TOOLS
	bool Process(const char* pcChunkbuffer) const;

	static void Create( const Asura_NameTree* pxNameTree, Asura_SaveBlock* pxSaveBlock);
	static void Create( const Asura_NameTree* pxNameTree, Asura_Chunk_Stream& xStream);
#endif

	int NumberOfTextures;
};

class Asura_Chunk_TextureFlags : public Asura_Chunk_Header
{
public:
	bool Process(Asura_Handle fileHandle) const;
	bool Process(Asura_Chunk_Stream& xStream) const;
#ifdef ASURA_TOOLS
	static void Create(int iNumberOfTextures, const int* piTextureFlags,Asura_SaveBlock* pxSaveBlock);
	static void Create(int iNumberOfTextures, const int* piTextureFlags, Asura_Chunk_Stream& xStream);
#endif

	int NumberOfTextures;
};

							
#endif//__ASURA_CHUNK_TEXTURE_H__
