//
// Asura_Chunk_Visibility.h
//
// Created by KJFL - 14 December 2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_CHUNK_VISIBILITY_H__
#define __ASURA_CHUNK_VISIBILITY_H__

#include "ChunkSystem/Asura_Chunk_Loaders.h"

class Asura_Chunk_Visibility : public Asura_Chunk_Header
{
	public:

		bool Process( Asura_Handle iFileHandle ) const;

		#if defined( ASURA_TOOLS )
		static bool Create( class Asura_Chunk_Stream& xStream );
		#endif

	private:

		enum { CHUNK_VERSION = 3 };

		// VERSION 0: KJFL - 15 December 2005 - old prototype, now deprecated
		//
		// VERSION 1: KJFL - 6 December 2007 - first version for new system,
		// visibility data has no compression and is just big (n*n) arrays.
		//
		// VERSION 2: KJFL - 19 December 2007 - compressed visible features.
		//
		// VERSION 3: KJFL - 21 December 2007 - dropped loading/saving some
		// unnecessary data from the viewcell nodes.
};

#endif//__ASURA_CHUNK_VISIBILITY_H__
