//
// Asura_Chunk_Water.h
//
// Created by Richard Rice - 06/01/2005
// 
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CHUNK_WATER_H__
#define __ASURA_CHUNK_WATER_H__

#include "ChunkSystem/Asura_Chunk_Loaders.h"
#include "Core/Asura_Maths.h"

struct Asura_Chunk_WaterPacket_Vertex;

class Asura_Chunk_WaterPacket : public Asura_Chunk_Header
{
public :
	bool Process(Asura_Handle iFileHandle) const;

	#ifdef ASURA_TOOLS
	static void Create(Asura_SaveBlock* pxSaveBlock,int iModuleIndex,int iNumVerts,Asura_Chunk_WaterPacket_Vertex* pxVerts);
	#endif
	
	int m_iModuleIndex;
	int m_iNumberOfVertices;
	//(followed in the chunk data by array of Asura_Chunk_WaterPacket_Vertex)
};

struct Asura_Chunk_WaterPacket_Vertex
{
	Asura_Vector_3 m_xPosition;
	float m_fRed;
	float m_fGreen;
	float m_fBlue;
	float m_fU;
	float m_fV;
};


class Asura_Chunk_WaterControl : public Asura_Chunk_Header
{
public :
	bool Process(Asura_Handle iFileHandle) const;

	#ifdef ASURA_TOOLS
	static void Create(Asura_SaveBlock* pxSaveBlock);
	#endif

	struct ChunkData_V0
	{
		float m_fWaterCycleScale1;
		float m_fWaterCycleScale2;
		float m_fWaterCycleScale3;	// in case we decide we want a third wave

		float m_fXScale1;
		float m_fXScale2;
		float m_fXScale3;

		float m_fZScale1;
		float m_fZScale2;
		float m_fZScale3;

		float m_fYScale1;
		float m_fYScale2;
		float m_fYScale3;

		float m_fFalloff1;
		float m_fFalloff2;
		float m_fFalloff3;

		float m_fThreshold;

		float m_fLightOffset;
		float m_fLightScale;

		float m_fAlphaLevel;
		float m_fReflection;

		bool  m_bUseLevelSun;
		float m_afSunDir[3];

		float m_afTexOffset[2];
		float m_afTexScale[2];

		u_int m_iFlags;

		float m_fHorizonVScale;		// controls V texture co-ordinate scale for horizon reflection
		float m_fHorizonVOffset;	// ditto for offset
		float m_fHorizonYScale;		// controls horizon effect normal scaling for flatter waves
		float m_fHorizonBrightness;	// controls how much less bright the horizon reflection is compared to the sun
	};

	struct ChunkData_V1 : ChunkData_V0
	{
		float m_fSubdivisionYScale;
		float m_fSunlightFalloffNear;
		float m_fSunlightFalloffFar;
	};
    
	struct ChunkData_V2 : ChunkData_V1
	{
		float m_afUVSpeeds[2];
	};

	struct ChunkData : ChunkData_V2
	{
		float m_fSunYScale;
		float m_fHorizonFresnelScale;
	};


};

#endif //__ASURA_CHUNK_WATER_H__
