//////////////////////////////////////////////////////////////////////////////
//
// Asura_ClassifiedList_System.h
//
// Copyright (c) 2004 Rebellion. All rights reserved.
//
// Description:
//
//     Mempool setting for classified lists
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_CLASSIFIEDLIST_SYSTEM_H___
#define ___ASURA_CLASSIFIEDLIST_SYSTEM_H___ 1

//#define DEBUG_CLASSIFICATION_ALLOCATIONS 1

#include "Core/Asura_MemPool.h"

class Asura_ClassifiedList_System
{
public:
	static void Initialise();
	static void Shutdown();
	static void Reset();

	// These use void pointers because they will be cast to templated types for use, so we need to be ambiguous
	// Note that the pointer size will be exactly that of the correct node, so please don't try to allocate something else from these pools.
	static void* AllocateClassificationNode();
	static void FreeClassificationNode(void* pxNode);

	static void* AllocateClassifiedNode();
	static void FreeClassifiedNode(void* pxNode);

private:
	static Asura_ResizingMempool* s_pxClassificationNodePool;
	static Asura_ResizingMempool* s_pxClassifiedNodePool;

#ifdef DEBUG_CLASSIFICATION_ALLOCATIONS
	static u_int s_uAllocatedClassifications;
	static u_int s_uAllocatedClassifieds;
#endif
};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_CLASSIFIEDLIST_SYSTEM_H___
