//
// Asura_MainLoop.h
//
// Created by RWM - 31/03/2009
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
// 

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_MAINLOOP_H__
#define __ASURA_MAINLOOP_H__

#include "Core/Asura_FunctionSequencer.h"

class Asura_MainLoop
{
public:
	static void Initialise();
	static void Shutdown();
	static void CreateDefaultRenderSequence();
	static void CreateDefaultUpdateSequence();

	static Asura_FunctionSequencer* GetRenderSequence() { return &s_xRenderSequence; }
	static Asura_FunctionSequencer* GetUpdateSequence() { return &s_xUpdateSequence; }

	static void Render();
	static void Update();

protected:
	static void Platform_ModifyDefaultRenderSequence();

	static Asura_FunctionSequencer s_xRenderSequence;
	static Asura_FunctionSequencer s_xUpdateSequence;
};

#endif//__ASURA_MAINLOOP_H__
