//
// Asura_MemoryManagement_Enums.h
//
// Created by KOR - 28/01/2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_MEMORYMANAGEMENT_ENUMS_H__
#define __ASURA_MEMORYMANAGEMENT_ENUMS_H__

#ifndef ASURA_MM_NUM_PROJECT_STATES
#define ASURA_MM_NUM_PROJECT_STATES (0)
#endif

// KOR - 30/10/2006 - Enumeration of states that you want to ensure the memory environment stays consistent at.
// To add project specific states, define ASURA_MM_NUM_PROJECT_STATES in your Asura_EngineConfiguration.h with
// the number of additional states. Then create a new enumeration e.g.
//enum PROJECT_MM_STATE_TYPES
//{
//	PROJECT_MM_STATE_PRE_FRONTEND_LOAD = ASURA_MM_FIRST_PROJECT_STATE,
//	PROJECT_MM_STATE_POST_FRONTEND_LOAD,
//};

enum ASURA_MM_STATE_TYPES
{
	ASURA_MM_STATE_PRE_LEVEL_LOAD = 0,
	ASURA_MM_STATE_POST_LEVEL_UNLOAD,
	ASURA_MM_STATE_PRE_DEVFRONTEND,
	ASURA_MM_STATE_PRE_FRONTEND,
	ASURA_MM_STATE_PRE_ATTRACTMODE,
	ASURA_MM_FIRST_PROJECT_STATE,
	ASURA_MM_STATE_NUM_TYPES = ASURA_MM_FIRST_PROJECT_STATE + ASURA_MM_NUM_PROJECT_STATES,
};

#endif//__ASURA_MEMORYMANAGEMENT_ENUMS_H__
