
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_Handler_System_Callbacks_Independent.h
// Author : Andy Tate
// Date   : 30-Jan-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_HANDLER_SYSTEM_CALLBACKS_INDEPENDENT_H__
#define __ASURA_HANDLER_SYSTEM_CALLBACKS_INDEPENDENT_H__

#if defined(ASURA_USE_MULTIPLE_HANDLERS)

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Handlers/Asura_Handler_System_Callbacks.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : Asura_Handler_System_Callbacks_Independent
// Author       : Andy Tate
// Date         : 29-Jan-2008
//
// Description  : Class used to instantiate platform-independent functions for use
//				  by the handler-system.
////////////////////////////////////////////////////////////////////////////////

class Asura_Handler_System_Callbacks_Independent : public Asura_Handler_System_Callbacks
{
public:
	// Public functions...
	Asura_Handler_System_Callbacks_Independent(void)	{}
//	virtual ~Asura_Handler_System_Callbacks_Independent();

	// Overridden functions to be overridden for platform/project/platform-project data...
	virtual bool	CreateHandlerData(u_int& uHandlerIndex, const Asura_Hash_ID uHandlerHash, const u_int uDataIndex, const char* szName, const Asura_Hash_ID uParentHandlerHash);
	virtual	bool	DestroyHandlerData(u_int& uHandlerIndex, const Asura_Hash_ID uHandlerHash, const u_int uDataIndex);
	virtual void	ReparentAllHandlerData(const Asura_Hash_ID uHandlerHash, const Asura_Hash_ID uParentHandlerHash);
	virtual void	SetAllHandlerData(const Asura_Hash_ID uHandlerHash, const u_int uDataIndex);

	virtual bool	CreateZoneData(u_int& uHandlerIndex, const Asura_Hash_ID uHandlerHash, const u_int uDataIndex, const char* szName, const Asura_Hash_ID uParentHandlerHash, const Asura_Hash_ID uZoneHash, const bool bAllowEnvironment);
	virtual bool	DestroyZoneData(u_int& uHandlerIndex, const Asura_Hash_ID uHandlerHash, const u_int uDataIndex, const bool bAllowEnvironment);
	virtual void	ReparentAllZoneData(const Asura_Hash_ID uHandlerHash, const Asura_Hash_ID uParentHandlerHash);
	virtual void	SetAllZoneData(const Asura_Hash_ID uHandlerHash, const u_int uDataIndex, const bool bAllowEnvironment);

#if defined(ASURA_LOGFILES_ENABLED)
	virtual void	CreateReport(const Asura_Hash_ID uHandlerHash, Asura_Stream& xOutputStream);
#endif	//defined(ASURA_LOGFILES_ENABLED)


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private variables...

	// Private functions...
	Asura_Handler_System_Callbacks_Independent(const Asura_Handler_System_Callbacks_Independent& xOther);

	Asura_Handler_System_Callbacks_Independent&	operator=(const Asura_Handler_System_Callbacks_Independent& xOther);

};   // End of class 'Asura_Handler_System_Callbacks'.

#endif	//defined(ASURA_USE_MULTIPLE_HANDLERS)

#endif	// ifndef __ASURA_HANDLER_SYSTEM_CALLBACKS_INDEPENDENT_H__


/// End of file. ///
