//*******************************************************************
//
// File: Asura_CPUProfile_MultiThreaded_Render.h
//
// Created: 22 May 2007 DLH
//
// Description: 
//
//*******************************************************************

#ifndef __ASURA_CPUPROFILE_MULTITHREADED_RENDER_H__
#define __ASURA_CPUPROFILE_MULTITHREADED_RENDER_H__

#if defined( ASURA_USE_PROFILING_SYSTEM)

// other libraries
#include "Core/Asura_LinkList.h"
#include "Core/Asura_Timers.h"
#include "Debugging/Asura_CPUProfile.h"

// internal dependencies

// forward declarations

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Class Definitions
//*******************************************************************
class Asura_CPUProfile_Renderer_ThreadData
{
public:
	Asura_CPUProfile_Renderer_ThreadData();
	
	static void Platform_Initialise();
	static void Platform_Shutdown();
	
#if defined( ASURA_USE_PROFILING_SYSTEM_MULTITHREADED)
	static void Platform_ThreadStart( const char* pszName);
	static void Platform_ThreadStop( void);
#endif
	
	static Asura_CPUProfile_Renderer_ThreadData* Platform_GetThreadData();
	static Asura_LinkList< Asura_CPUProfile_Renderer_ThreadData*>& Platform_GetAndLockThreadList();
	static void Platform_ReturnAndUnlockThreadList();
	
private:
	Asura_CPUProfile_Renderer_ThreadData( const Asura_CPUProfile_Renderer_ThreadData&);
	const Asura_CPUProfile_Renderer_ThreadData& operator= ( const Asura_CPUProfile_Renderer_ThreadData&);
	
public:
	char m_szThreadName[ 16];
	
	class Profile
	{
	public:
		Asura_TickCount m_uTimerStartTicks;
		Asura_TickCount m_uTimerEndTicks;
		Asura_TickCount m_uTimerTicks;

		const char* m_pszProfileName;

		u_int m_uInProfileDepth;
	};
	Profile m_axProfiles[ ASURA_CPU_PROFILE__MAX_TIMERS];
	
	Asura_TickCount m_uTimerCleared;
	
//	Asura_TickCount m_auTimerStartTicks[ASURA_CPU_PROFILE__MAX_TIMERS];
//	Asura_TickCount m_auTimerTicks[ASURA_CPU_PROFILE__MAX_TIMERS];

//	const char* m_paszProfileNames[ASURA_CPU_PROFILE__MAX_TIMERS];

	u_int m_uInProfileDepth;
	u_int m_uInProfile;
};


//*******************************************************************
// Inline Function Definitions
//*******************************************************************


//*******************************************************************
//
// (c) 2006 Rebellion
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif //defined( ASURA_USE_PROFILING_SYSTEM)
#endif // __ASURA_CPUPROFILE_MULTITHREADED_RENDER_H__
