//
// Asura_Debug_Texture_Viewer.h
//
// Created by KOR - 19 September 2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_DEBUG_TEXTURE_VIEWER_H__
#define __ASURA_DEBUG_TEXTURE_VIEWER_H__

#ifdef ASURA_USE_DEBUG_TEXTURE_VIEWER

#include "Input/Asura_ControlMap.h"

class Asura_Debug_Texture_Viewer
{
public:
	enum TRANSLUCENCY_MODE
	{
		TRANSLUCENCY_SOLID = 0,
		TRANSLUCENCY_ALPHABLACK,
		TRANSLUCENCY_ALPHAPINK,
		NUM_TRANSLUCENCY_MODES,
	};
	enum CONTROL_MAPPINGS
	{
		CONTROL_UP = 0,
		CONTROL_DOWN,
		CONTROL_LEFT,
		CONTROL_RIGHT,
		CONTROL_SELECT,
		CONTROL_CHANGETRANSLUCENCY,
		NUM_CONTROL_MAPPINGS,
	};
	static void Render();
	// Platforms may create their own control mappings, otherwise it will automatically add defaults.
	static Asura_ControlMap& GetControlMap() { return s_xControlMap; }
#ifdef ASURA_SUPPORT_COMMAND_CONSOLE
	static void AddConsoleCommands();
#endif
private:
	static void HandleControls();
	static void SetupAlpha();
	static void AddDefaultControlMappings();

	// Static data
	static bool s_bEnabled;
	static bool s_bIsSelected;
	static u_int s_uSelectedX;
	static u_int s_uSelectedY;
	static u_int s_uOffsetY;
	static u_int s_uNumCols;
	static u_int s_uNumRows;
	static u_int s_uMaxOffsetY;
	static TRANSLUCENCY_MODE s_eTranslucency;
	static Asura_ControlMap s_xControlMap;
};

#endif

#endif//__ASURA_DEBUG_TEXTURE_VIEWER_H__