/**
*
* \file Asura_ClientEntity_CutsceneController.h
*
* Created by Kevin Lea - 15/04/2002 12:12:20
*
* Copyright (C) 2002 Rebellion, All Rights Reserved.
*
* \brief
*
**/
#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_CLIENTENTITY_CUTSCENECONTROLLER_H__
#define __ASURA_CLIENTENTITY_CUTSCENECONTROLLER_H__
 
#include "Entity/Asura_Entity.h"
#include "Core/Asura_String.h"

class Asura_Message;
class Asura_NetMsg;
class Asura_Cutscene;

class Asura_ClientEntity_CutsceneController : public Asura_Entity_Renderable
{
	public:

		Asura_ClientEntity_CutsceneController();
		virtual ~Asura_ClientEntity_CutsceneController();

		virtual bool HandleMessage(const Asura_Message* pxMessage);
        virtual void Update(void);
		virtual void Render(void);

        const Asura_Cutscene* GetCutscene( void ) const { return m_pxCutscene; }
        bool IsInitialised( void ) const { return m_bInitialised; }

		Asura_Hash_ID GetCutsceneHash() const { return m_uCutsceneHash; }

	protected:
		Asura_Cutscene* GetCutscene() { return m_pxCutscene; }

	private:

		Asura_Cutscene* m_pxCutscene;
		bool m_bInitialised;
		bool m_bPlaying;
		Asura_Hash_ID m_uCutsceneHash;
};

struct Asura_Msg_ActivateCutscene
{
	Asura_Hash_ID m_uHash;
	float m_fTimer;
	u_int m_uEnabledEvents;
	u_char m_ucFlags;

	enum
	{
		FLAG_STARTS_ACTIVE				= 0x01,  // TODO - Is this actually needed? Only the separately loaded cutscenes seem to use it, and they aren't used in any current projects.
		FLAG_SKIP_MESSSAGES_AFTER_LOAD	= 0x02
	};

#ifdef ASURA_NETMSG_PACK_ALL_DATA
	void RegisterFields(Asura_NetMsg* pxNetMsg) const;
	static u_char GetNumFields() { return 4; }
#endif
};



#endif//__ASURA_CLIENTENTITY_CUTSCENECONTROLLER_H__
