//////////////////////////////////////////////////////////////////////////////
//
// Asura_Entity_Fragment.cpp
//
// Copyright (c) 2002 Rebellion. All rights reserved.
//
// Description:
//
//     Derived class of Ephemeron to create shape fragments.
//
// History:
//
//     (MH  - 28.11.2002) - Created.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////
#include "Core/Asura.h"
#include "Entity/Ephemera/Asura_Entity_Fragment.h"

#include "Entity/Asura_Entity_Classification.h"

// D E B U G V A R S /////////////////////////////////////////////////////////
DEBUGVAR float dbg_fFragmentMaxSpinRate = Asura_Maths::Deg360;
DEBUGVAR float dbg_fFragmentLifetime = 3.0f;

Asura_Entity_Fragment::Asura_Entity_Fragment(Asura_Hash_ID uShapeHashID, 
                                             const Asura_Vector_3& xPos, 
                                             const Asura_Matrix_3x3& xOrient, 
                                             const Asura_Vector_3& xInitialVelocity)
:Asura_Entity_Ephemeron(uShapeHashID, xPos, xOrient, xInitialVelocity, dbg_fFragmentMaxSpinRate, dbg_fFragmentLifetime)
{
	Classification = AsuraEntityClass_Fragment;
}

