
////////////////////////////////////////////////////////////////////////////////
//
// Asura_ClientEntity_FMVController.h
// Author    : Jason Turner
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
////////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CLIENTENTITY_FMVCONTROLLER_H__
#define __ASURA_CLIENTENTITY_FMVCONTROLLER_H__

#include "Core/Asura_LinkList.h"
#include "Core/Asura_String.h"
#include "Entity/Triggers/Asura_ClientEntity_Activatable.h"

#ifdef ASURA_TOOLS
#include "Entity/Asura_Entity_Classification.h"
#endif

class Asura_VideoToTexture;
class Asura_Message_FMVController_ClientCreate;

class Asura_ClientEntity_FMVController : public Asura_ClientEntity_Activatable
{
	typedef Asura_ClientEntity_Activatable PARENT;

	public:
		Asura_ClientEntity_FMVController(Asura_Guid uGuid);
		virtual ~Asura_ClientEntity_FMVController();

		static void CreateFromChunkStream( Asura_Guid uGuid, Asura_Chunk_Stream &xStream );

	protected :

		bool HandleMessage(const Asura_Message* pxMessage);
		void ProcessCreateMessage(const Asura_Message_FMVController_ClientCreate* pxData, float fTime);

		// Read from chunk stream
		virtual	bool IsFilledFromChunkBuffer(void) const { return false; }
		virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );

		virtual void OnDestruction();
		virtual void Update();

		virtual void PostCreateInitialise();

		#ifdef ASURA_TOOLS
		virtual bool CanBeIncludedInTemplate() const {return Classification == AsuraEntityClass_FMVController;}
		#endif

		Asura_String m_xFMVName;
		unsigned int m_uFlags;

		bool	m_bTriggered;

		friend class Tools_Entity_FMVController;

    private:
		void Destroy();

		Asura_ClientEntity_FMVController();

		Asura_LinkList<Asura_Guid> m_xLinkedSpeakerGuids;

		// if you change this, make sure ReadFromChunkStream/WriteToChunkStream still support old versions
		enum { CURRENT_CHUNK_VERSION = 1 };
		Asura_VideoToTexture*	m_pxVideoRenderer;
};

#endif //__ASURA_CLIENTENTITY_FMVCONTROLLER_H__
