
////////////////////////////////////////////////////////////////////////////////
//
// Asura_ClientEntity_FMVSpeaker.h
// Author    : Jason Turner
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
////////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CLIENTENTITY_FMVSPEAKER_H__
#define __ASURA_CLIENTENTITY_FMVSPEAKER_H__

#include "Core/Asura_String.h"
#include "Entity/Triggers/Asura_ClientEntity_Activatable.h"

#ifdef ASURA_TOOLS
#include "Entity/Asura_Entity_Classification.h"
#endif

class Asura_ClientEntity_FMVSpeaker : public Asura_ClientEntity_ActivatableWithPosition
{
	typedef Asura_ClientEntity_ActivatableWithPosition PARENT;

	public:
		Asura_ClientEntity_FMVSpeaker(Asura_Guid uGuid);
		virtual ~Asura_ClientEntity_FMVSpeaker();

		static void CreateFromChunkStream( Asura_Guid uGuid, Asura_Chunk_Stream &xStream );

		static Asura_ClientEntity_FMVSpeaker* FindEntity( const Asura_Guid uGuid ) { return s_xList.FindEntity( uGuid ); }
		static Asura_Hashed_List< Asura_ClientEntity_FMVSpeaker >* GetList() { return &s_xList; }

	protected :

		bool HandleMessage(const Asura_Message* pxMessage);

		// Read from chunk stream
		virtual	bool IsFilledFromChunkBuffer(void) const { return false; }
		virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );

		virtual void OnDestruction();

		float m_fInnerRange;
		float m_fOuterRange;

		#ifdef ASURA_TOOLS
		virtual bool CanBeIncludedInTemplate() const {return Classification == AsuraEntityClass_FMVSpeaker;}
		friend class Tools_Entity_FMVSpeaker;
		#endif

    private:
		friend class Asura_ClientEntity_FMVController;

		Asura_ClientEntity_FMVSpeaker();

		// if you change this, make sure ReadFromChunkStream/WriteToChunkStream still support old versions
		enum { CURRENT_CHUNK_VERSION = 1 };
		static Asura_Hashed_List< Asura_ClientEntity_FMVSpeaker > s_xList;
};

#endif //__ASURA_CLIENTENTITY_FMVSPEAKER_H__
