/**
*
* \file Asura_WorldSpace_Rectangle.cpp
*
* Created by Andrew Weinkove - 18/07/2002
*
* Copyright (C) 2002 Rebellion, All Rights Reserved.
*
* \brief
*
**/

#include "Core/Asura.h"

#include "Entity/Glass/Asura_WorldSpace_Rectangle.h"

#include "Debugging/Asura_Assert.h"


Asura_WorldSpace_Rectangle::Asura_WorldSpace_Rectangle()
: Dimensions(1.0f, 1.0f)
, CornerPosition(0.0f, 0.0f, 0.0f)
{
	Orientation.Identity();
}


Asura_Vector_3 Asura_WorldSpace_Rectangle::CalculateCentre() const
{
	return (CornerPosition + (Asura_Vector_3(Dimensions.x * 0.5f, Dimensions.y * 0.5f, 0.0f) * Orientation));
}

void Asura_WorldSpace_Rectangle::CalculateCorners( Asura_Vector_3 axCorners[4] ) const
{
	Asura_Vector_3 xXVector = Asura_Vector_3(Dimensions.x, 0.0f, 0.0f) * Orientation;
	Asura_Vector_3 xYVector = Asura_Vector_3(0.0f, Dimensions.y, 0.0f) * Orientation;

	axCorners[0] = CornerPosition;
	axCorners[1] = CornerPosition + xXVector;
	axCorners[2] = CornerPosition + xYVector;
	axCorners[3] = CornerPosition + xXVector + xYVector;
}

