//////////////////////////////////////////////////////////////////////////////
//
// Asura_ServerNode_OrientedNode.h
//
// Created by NJD - 12 October 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_SERVERNODE_ORIENTEDNODE_H__
#define __ASURA_SERVERNODE_ORIENTEDNODE_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// asura
#include "Core/Asura_Maths.h"
#include "Entity/Locations/Asura_ServerEntity_Node.h"

//////////////////////////////////////////////////////////////////////////////
//
// Asura_ServerNode_OrientedNode
//
//////////////////////////////////////////////////////////////////////////////

class Asura_ServerNode_OrientedNode : public Asura_ServerEntity_Node
{
    typedef Asura_ServerEntity_Node PARENT;

public:
    Asura_ServerNode_OrientedNode(Asura_Guid uGuid);

    void SetOrientation( const Asura_Euler_3& xOri )    { Asura_Quat xOriQ( xOri ); m_xOrientCQF.FromQuat( xOriQ ); }
    void SetOrientation( const Asura_Quat& xOri )       { m_xOrientCQF.FromQuat( xOri ); }
    void SetOrientation( const Asura_Matrix_3x3& xOri ) { Asura_Quat xOriQ( xOri ); m_xOrientCQF.FromQuat( xOriQ ); }
    void GetOrientation( Asura_Euler_3& xOri )	  const { Asura_Quat xOriQ; m_xOrientCQF.ToQuat( xOriQ ); xOriQ.ToEuler( xOri ); }
    void GetOrientation( Asura_Quat& xOri )		  const { m_xOrientCQF.ToQuat( xOri ); }
	void GetOrientation( Asura_Matrix_3x3& xOri ) const { Asura_Quat xOriQ; m_xOrientCQF.ToQuat( xOriQ ); xOriQ.ToMatrix( xOri ); }

	virtual bool IsBaseOrDerivativeOf( u_short usClassification ) const;

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

#ifdef ASURA_TOOLS
    virtual void ApplyChangesForTemplateInstance( class Tools_EntityTemplateInstance* pxInstance );
    virtual bool CanBeIncludedInTemplate() const;
#endif

	static void CreateFromChunkStream( Asura_Guid uGuid, Asura_Chunk_Stream& xStream );
    virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;
    virtual	void ReadFromChunkStream( Asura_Chunk_Stream& xStream );

private:
	Asura_Comp_Quat_Fast m_xOrientCQF;

private:
    enum { CURRENT_CHUNK_VERSION = 1 };
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__ASURA_SERVERNODE_ORIENTEDNODE_H__
