//
// Asura_ServerEntity_StreamingBackgroundSoundController.h
//
// Created by Richard Rice - 03/08/2007
// 
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _ASURA_SERVERENTITY_STREAMINGBACKGROUNDSOUNDCONTROLLER_H_
#define _ASURA_SERVERENTITY_STREAMINGBACKGROUNDSOUNDCONTROLLER_H_


#include "Entity/Asura_Entity.h"
#ifdef ASURA_TOOLS
#include "Entity/Asura_Entity_Classification.h"
#endif


//Entity for forwarding activate/deactivate messages to the streaming background sound system
class Asura_ServerEntity_StreamingBackgroundSoundController : public Asura_Entity_Server
{
	typedef Asura_Entity_Server PARENT;
	enum { CHUNK_VERSION = 0 };

public :
	static void Create(Asura_Guid uGuid, Asura_Chunk_Stream& xStream);
	Asura_ServerEntity_StreamingBackgroundSoundController(Asura_Guid uGuid);

	~Asura_ServerEntity_StreamingBackgroundSoundController();

	// override of HasClientEntities() - we don't have any.
	virtual bool HasClientEntities() const { return false; }

	void SetSoundID(u_int uID){m_uSoundID = uID;}
	u_int GetSoundID() const {return m_uSoundID;}

	virtual bool HandleMessage(const Asura_Message* pxMessage);

	virtual bool	CanBeSavedToChunk() const {return true;}
	virtual	bool	IsFilledFromChunkBuffer		(void) const{ return (false); }
	virtual	void	ReadFromChunkStream			(Asura_Chunk_Stream& xStream);
	virtual	void	WriteToChunkStream			(Asura_Chunk_Stream& xStream) const;

	#ifdef ASURA_TOOLS
	virtual void ApplyChangesForTemplateInstance(class Tools_EntityTemplateInstance* pxInstance);
	virtual bool CanBeIncludedInTemplate() const {return Classification == AsuraEntityClass_StreamingBackgroundSoundController;}
	#endif


protected :
	void SendFlagMessage(u_int uFlagsToSet, u_int uFlags);


private :

	u_int m_uSoundID;


#ifdef ASURA_TOOLS //entity list currently only needed by tools. RAR 09/05/2007
public :
	static Asura_ServerEntity_StreamingBackgroundSoundController* FindEntity( Asura_Guid uGuid )
	{
        return s_xList.FindEntity( uGuid );
    }
	static const Asura_Hashed_List<Asura_ServerEntity_StreamingBackgroundSoundController>* GetList( void )
    {
        return &s_xList;
    }

private:

	static Asura_Hashed_List<Asura_ServerEntity_StreamingBackgroundSoundController> s_xList;
#endif //ASURA_TOOLS

};

//Message used to forward activate/deactivate messages for attractors.
class Asura_Message_StreamingBackgroundSoundFlags
{
public :
	u_int m_uFlagsToSet;
	u_int m_uFlags;
	u_int m_uSoundID;
};

#endif //_ASURA_SERVERENTITY_STREAMINGBACKGROUNDSOUNDCONTROLLER_H_
