//
// Asura_ClientEntity_Activatable.h
//
// Created by Richard Rice - 10/11/2004
// 
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CLIENTENTITY_ACTIVATABLE_H__
#define __ASURA_CLIENTENTITY_ACTIVATABLE_H__

#include "Entity/Asura_Entity.h"


class Asura_ClientEntity_Activatable : public Asura_Entity_Client
{
	friend class Tools_Entity_Activatable_Object;

	public :
		Asura_ClientEntity_Activatable(Asura_Guid uGuid,const char*& pcChunkBuffer);

		Asura_ClientEntity_Activatable(Asura_Guid uGuid);
		virtual ~Asura_ClientEntity_Activatable() {};

		virtual void ReadFromChunkStream(Asura_Chunk_Stream& xStream);

		virtual bool HandleMessage(const Asura_Message* pxMessage);

		inline bool IsActive (void) const
		{
			return m_bActive;
		}

		inline void SetActive (const bool bActive)
		{
			m_bActive = bActive;
		}


	protected :

		virtual void OnActivation(){};
		virtual void OnDeactivation(){};
		virtual void OnTrigger() {}
		virtual void OnUnTrigger() {}
		virtual void OnDestruction();



		unsigned char m_bActive :1;

};



//variation of activatable that stores some extra position and orientation information ,
//but does nothing with it of its own accord.
//ART 31/08/05
class Asura_ClientEntity_ActivatableWithPosition : public Asura_ClientEntity_Activatable
{
public:
	// Public functions...

	Asura_ClientEntity_ActivatableWithPosition          (Asura_Guid uGuid = ASURA_GUID_UNREGISTERED);
	Asura_ClientEntity_ActivatableWithPosition          (Asura_Guid uGuid, const char*& pcChunkBuffer);
//	virtual ~Asura_ClientEntity_ActivatableWithPosition ();

	virtual void ReadFromChunkStream(Asura_Chunk_Stream& xStream);

	// Accessor functions...
	virtual	void	SetPositionAndOrientation	(const Asura_Vector_3& xPosition, const Asura_Matrix_3x3& xOrientation);

		
protected:
	// Protected variables...

	Asura_Vector_3		m_xPosition;
	Asura_Matrix_3x3	m_xOrientation;

	// Protected functions...

	// Virtual event functions...
//	virtual	void	OnActivation	(void);
//	virtual	void	OnDeactivation	(void);
//	virtual	void	OnTrigger		(void);
//	virtual	void	OnUnTrigger		(void);
//	virtual	void	OnDestruction	(void);
};



#endif //__ASURA_CLIENTENTITY_ACTIVATABLE_H__
