//
// Asura_ClientEntity_AdvancedVolumeTrigger.h
//
// Created by Richard Rice - 22/11/2004
// 
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CLIENTENTITY_ADVANCEDVOLUMETRIGGER_H__
#define __ASURA_CLIENTENTITY_ADVANCEDVOLUMETRIGGER_H__

#include "Entity/Triggers/Asura_ClientEntity_Trigger.h"
#include "Entity/Triggers/Asura_ServerEntity_AdvancedVolumeTrigger.h"

class Asura_ClientEntity_AdvancedVolumeTrigger : public Asura_ClientEntity_Trigger
{
	typedef Asura_ClientEntity_Trigger PARENT;

	friend class Tools_Entity_AdvancedVolumeTrigger;

	public :
		Asura_ClientEntity_AdvancedVolumeTrigger(Asura_Guid uGuid);
		Asura_ClientEntity_AdvancedVolumeTrigger(Asura_Guid uGuid,const char*& pcChunkBuffer);

		~Asura_ClientEntity_AdvancedVolumeTrigger();

		virtual void ReadFromChunkStream(Asura_Chunk_Stream& xStream);

		//checks to see if a point lies in any of the volumes associated with this trigger
		bool Contains(const Asura_Vector_3& xPosition);

	
	protected :
		bool IsTriggered(void);
		bool IsUnTriggered(void);
		void OnUnTrigger();
		virtual bool IsVolumeOccupied(){return false;}


		int        m_iListFlags;	//Bit-field of lists to use - limits max lists to 32.
        Asura_Guid m_uSpecificGuid; //Specific Guid to check

		int m_iNumberOfVolumes;
		Asura_OrientedVolume* m_pxVolumes;

		union
		{
			struct
			{
				unsigned int m_bHasAlreadyTriggered : 1,
							 m_bTriggerOnce			: 1,//Volume trigger is deactivated when un-triggered (so it only gets triggered once per activation)
							 m_bTriggerOnNotOccupied : 1,//Becomes triggered upon becoming unocupied instead
							 SpareBits				: 29;
			};
			unsigned int m_uFlags;
		};
};


#endif //__ASURA_CLIENTENTITY_ADVANCEDVOLUMETRIGGER_H__
