//////////////////////////////////////////////////////////////////////////////
//
// Asura_ClientEntity_SoundController.h
//
// Copyright (c) 2002 Rebellion. All rights reserved.
//
// Description:
//
//     entities which control phonons
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_CLIENTENTITY_SOUNDCONTROLLER_H___
#define ___ASURA_CLIENTENTITY_SOUNDCONTROLLER_H___ 1

#include "Entity/Asura_Entity.h"

class Asura_ClientEntity_SoundController : public Asura_Entity_Client
{

public:

	//constructor used by tools,  to ensure that we don't have to wait for a reload to get the client entity created
	Asura_ClientEntity_SoundController(Asura_Guid uGuid,Asura_Guid uPhononGuid, bool bInitiallyActive = true);
    virtual ~Asura_ClientEntity_SoundController( void );

    virtual bool HandleMessage(const Asura_Message* pxMessage);

	//functions used by cutscenes to alter just the local client version of a sound
	void Activate(bool bActive);
	void Trigger() {ProcessTriggerMessage();}
	void SetPosition(const Asura_Vector_3& xPos);

	#ifdef ASURA_TOOLS
	virtual void ApplyChangesForTemplateInstance(class Tools_EntityTemplateInstance* pxInstance);
	#endif


protected:
    
    Asura_ClientEntity_SoundController(Asura_Chunk_Stream& xStream);

    // state functions
    void ProcessActivationMessage();
    void ProcessDeactivationMessage();
    void ProcessTriggerMessage();

protected:

    // data
    Asura_Guid m_uPhononGuid;

// Static member fns
public:

	static void CreateFromChunkStream(Asura_Guid uGuid, Asura_Chunk_Stream& xStream)
	{
		Asura_Entity_System::SetNextClientGuid(uGuid);
		new Asura_ClientEntity_SoundController(xStream);
	}

    static Asura_ClientEntity_SoundController* FindEntity( Asura_Guid uGUID )
    {
        return s_xList.FindEntity( uGUID );
    }
	static const Asura_Hashed_List<Asura_ClientEntity_SoundController>* GetList( void )
    {
        return &s_xList;
    }

private:

    static Asura_Hashed_List<Asura_ClientEntity_SoundController> s_xList;

};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_CLIENTENTITY_SOUNDCONTROLLER_H___
