//
// Asura_ServerEntity_MusicTrigger.h
//
// Created by Richard Rice - 23/01/2004
// 
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_SERVERENTITY_METAMUSICTRIGGER_H__
#define __ASURA_SERVERENTITY_METAMUSICTRIGGER_H__

#if !defined(ASURA_SUPPORT_DYNAMIC_MUSIC_SYSTEM)

#include "Core/Asura_Hash.h"
#include "Entity/Triggers/Asura_ServerEntity_Activatable.h"

#ifdef ASURA_TOOLS
#include "Entity/Asura_Entity_Classification.h"
#endif


#define ASURA_METAMUSICTRIGGER_FLAG_HIGHPRIORITY 0x00000001
#define ASURA_METAMUSICTRIGGER_FLAG_AMBIENT 0x00000002
#define ASURA_METAMUSICTRIGGER_FLAG_TENSION 0x00000004
#define ASURA_METAMUSICTRIGGER_FLAG_ACTION 0x00000008
#define ASURA_METAMUSICTRIGGER_FLAG_CHANGETRACK 0x00000010
#define ASURA_METAMUSICTRIGGER_FLAG_RESTARTLASTTRACK 0x00000020

class Asura_ServerEntity_MetaMusicTrigger : public Asura_ServerEntity_Activatable
{
	public :
		Asura_ServerEntity_MetaMusicTrigger();	
		Asura_ServerEntity_MetaMusicTrigger(Asura_Guid uGuid) ;
		//constructor from load
		Asura_ServerEntity_MetaMusicTrigger(Asura_Guid uGuid,const char*& pcChunkBuffer);	
		virtual ~Asura_ServerEntity_MetaMusicTrigger(){};

		static void CreateFromChunkBuffer(Asura_Guid uGuid, const char*& pcChunkBuffer);

		#ifdef ASURA_TOOLS
		virtual bool CanBeIncludedInTemplate() const {return Classification == AsuraEntityClass_MetaMusicTrigger;}
		#endif

	protected:
		void OnTrigger();

		//virtual function overides for saving
		int GetChunkBufferSize();
		void FillInChunkBuffer(char*& pcChunkBuffer);

		virtual void WriteToChunkStream(Asura_Chunk_Stream& xStream) const;
		virtual void ReadFromChunkStream(Asura_Chunk_Stream& xStream);	
		
		Asura_Hash_ID m_uTrackID;
		u_int m_uFlags;


		friend class Tools_Entity_MetaMusicTrigger_Object;

};

#endif	//!defined(ASURA_SUPPORT_DYNAMIC_MUSIC_SYSTEM)

#endif //__ASURA_SERVERENTITY_METAMUSICTRIGGER_H__
