//
// Asura_ServerEntity_MusicTrigger.h
//
// Created by Richard Rice - 18/03/2003
// 
// Copyright (C) 2003 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_SERVERENTITY_MUSICTRIGGER_H__
#define __ASURA_SERVERENTITY_MUSICTRIGGER_H__

#if !defined(ASURA_SUPPORT_DYNAMIC_MUSIC_SYSTEM)

#include "Entity/Triggers/Asura_ServerEntity_Activatable.h"
#ifdef ASURA_TOOLS
#include "Entity/Asura_Entity_Classification.h"
#endif


#define ASURA_MUSICTRIGGER_FLAG_LOOPING 0x00000001

class Asura_ServerEntity_MusicTrigger : public Asura_ServerEntity_Activatable
{
	public :
		Asura_ServerEntity_MusicTrigger();	
		Asura_ServerEntity_MusicTrigger(Asura_Guid uGuid);
		//constructor from load
		Asura_ServerEntity_MusicTrigger(Asura_Guid uGuid,const char*& pcChunkBuffer);
		virtual ~Asura_ServerEntity_MusicTrigger(){};

		static void CreateFromChunkBuffer(Asura_Guid uGuid, const char*& pcChunkBuffer);
		
		#ifdef ASURA_TOOLS
		virtual bool CanBeIncludedInTemplate() const {return Classification == AsuraEntityClass_MusicTrigger;}
		#endif

	protected:
		void OnTrigger();

		//virtual function overides for saving
		int GetChunkBufferSize();
		void FillInChunkBuffer(char*& pcChunkBuffer);

		virtual void WriteToChunkStream(Asura_Chunk_Stream& xStream) const;
		virtual void ReadFromChunkStream(Asura_Chunk_Stream& xStream);	

		static void TestMusicTriggerStream(Asura_Guid uGuid, const char* pcChunkBuffer);

		int m_iMusicTrack;
		float m_fFadeTime;
		u_int m_uFlags;
		float m_fVolume;

		friend class Tools_Entity_MusicTrigger_Object;

};

#endif	//!defined(ASURA_SUPPORT_DYNAMIC_MUSIC_SYSTEM)

#endif //__ASURA_SERVERENTITY_MUSICTRIGGER_H__
