// ------------------------------------------------------------------------------------ //
//																						//
//	File: Asura_GUIMenu_Includes.h														//
//																						//
//	Description: this is the header file to include when calling the guimenu code		//
//																						//
//	Created: Steve Keen - 14/11/06														//
//																						//
//	Copyright (C) 2006 Rebellion (Derby), All Rights Reserved.							//
// ------------------------------------------------------------------------------------ //

#ifndef __ASURA_GUIMENU_INCLUDES_H__
#define __ASURA_GUIMENU_INCLUDES_H__

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#include "Core/Asura_Graph.h"
#include "Core/Asura_Hash.h"

// -- GUIMenu Headers --
#include "Asura_GUIMenu_Root.h"

// -- Local messaging --
#include "GUIMenu/Asura_GUIMenu_Message.h"
#include "GUIMenu/Asura_GUIMenu_MessagePump.h"

// -- Element Includes --
#include "Asura_GUIMenu_Element_Base.h"
#include "Asura_GUIMenu_Element_Image.h"
#include "Asura_GUIMenu_Element_Text.h"
#include "Asura_GUIMenu_Element_Path.h"

// -- Widget Includes --
#include "Asura_GUIMenu_Widget_Base.h"
#include "Asura_GUIMenu_Widget_Button.h"
#include "Asura_GUIMenu_Widget_CheckBox.h"
#include "Asura_GUIMenu_Widget_Slider.h"
#include "Asura_GUIMenu_Widget_TextBox.h"
#include "Asura_GUIMenu_Widget_TextListBox.h"
#include "Asura_GUIMenu_Widget_Group.h"
#include "Asura_GUIMenu_Widget_AnimatingImage.h"
#include "Asura_GUIMenu_Widget_ProgressBar.h"

// -- Menu Page Includes
#include "Asura_GUIMenu_Menu_Page.h"

// -- Singleton
#include "Asura_GUIMenu_System.h"


#endif // __ASURA_GUIMENU_INCLUDES_H__
