// ------------------------------------------------------------------------------------ //
//																						//
//	File: Asura_GUIMenu_OnScreenKeyboard.h												//
//																						//
//	Description: Header file the platform independant on screen keyboard				//
//																						//
//	Created: Steve Keen - 9/11/06														//
//																						//
//	Copyright (C) 2007 Rebellion (Derby), All Rights Reserved.							//
// ------------------------------------------------------------------------------------ //

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_GUIMENU_ONSCREENKEYBOARD_H__
#define __ASURA_GUIMENU_ONSCREENKEYBOARD_H__

#ifdef ASURA_USE_GUI_OSK

// -- Includes ------------------------------------------------------------------------
#include "Core/Asura_PlatformBasics.h"

// -- Typedef -------------------------------------------------------------------------

// -- Enums ---------------------------------------------------------------------------
enum Asura_GUIMenu_OSK_ExitType
{
	ASURA_GUIMENU_OSK_NOEXIT = 0,
	ASURA_GUIMENU_OSK_CANCEL,
	ASURA_GUIMENU_OSK_DONE
};

// -- Defines -------------------------------------------------------------------------
const u_int uASURA_GUIMENU_OSK_SCREEN = 0x685963fa;
const u_int uASURA_GUIMENU_OSK_TEXT_ENTRY = 0x01be3ee8;

// -- Structures ----------------------------------------------------------------------

// -- Class ---------------------------------------------------------------------------

class Asura_GUIMenu_OnScreenKeyboard
{
public:
	
	static void						Initialise( Asura_UnicodeChar* wszBuffer, u_int uBufferMaxChars);
	static void						Reset( void);
	static void						Shutdown(void);	

	static void						Update( void);

	static void 					LoadOSKData( const Asura_Char* pcFilenameOverride = NULL);
	static void 					SetOSKFilename( const Asura_Char* pcFilenameOverride);
	static void 					ResetOSKFilename( void);

	static Asura_GUIMenu_OSK_ExitType GetExitType( void);

protected:
	static void						ClearLocalVariables( void);

	static bool						ConsoleCmd_OSKButtonClick( const Asura_UnicodeChar* pcCmd, bool bInterrogate, bool bHelp);
	static bool						ConsoleCmd_OSKDeleteChar( bool bHelp);
	static bool						ConsoleCmd_OSKToggleCase( bool bHelp);

	static void						UpdateTextDisplay( void);

	static void 					ClearOSKFilename( void);

	static void						Platform_Update( void);
private:

	static void						UpdateEnableEnd( void );

	// -- OSK info --
	static bool						s_bOSKSetup;
	static bool						s_bUpperCaseOSK;
	static bool						s_bEnableEnd;
	static Asura_Hash_ID			s_uLastFocusedMenu;

	static Asura_UnicodeChar*		s_pwszOutputTextBuffer;

	static Asura_UnicodeChar*		s_pwszInternalTextBuffer;
	static u_int					s_uNumInternalTextBufferChars;
	static u_int					s_uCursorPos;

	static Asura_Char*				s_pcOSKFilename;

	static Asura_GUIMenu_OSK_ExitType	s_eExitType;

	static u_int					s_uTextInputFrameNumber;
};
#endif // ASURA_USE_GUI_OSK
#endif // __ASURA_GUIMENU_ONSCREENKEYBOARD_H__
