//
// Asura_Interface.cpp
//
// Created by Kevin Lea - 19/06/2001 15:55:54
// 
// Copyright (C) 2001 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

#ifdef ASURA_TOOLS

#include "Interface/Asura_Interface.h"

#include "Interface/Asura_Cursor.h"
#include "Interface/Asura_Menubar_System.h"
#include "Interface/Asura_Overlay_System.h"

#include "Misc/Tools_Modal_Overlay.h"

void Asura_Interface::Initialise(void)
{
	Asura_Menubar_System::Initialise();
	Asura_Overlay_System::Initialise();
}
void Asura_Interface::Shutdown(void)
{
	Asura_Menubar_System::Shutdown();
	Asura_Overlay_System::Shutdown();
}

void Asura_Interface::Update(void)
{
	Asura_Menubar_System::Update();

	Asura_Overlay_System::Update(Asura_Menubar_System::IsUsingMenus());
}

bool Asura_Interface::UsingMenusOrOverlays(void)
{
	if (Asura_Menubar_System::IsUsingMenus()) return true;
	if (Asura_Overlay_System::CursorIsOverAnOverlay()) return true;
	return false;
}
void Asura_Interface::Render(void)
{
	Asura_Overlay_System::Render();

	if (!Tools_Modal_Overlay::IsActive())
	{
		Asura_Menubar_System::Render();
	}
}
#endif // #ifdef ASURA_TOOLS
