//
// Asura_Mesh_PolygonFlags.h
//
// Created by KJFL - 09 February 2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_MESH_POLYGONFLAGS_H__
#define __ASURA_MESH_POLYGONFLAGS_H__

//////////
//First 8 flag bits are for common asura flags that will be needed in game
#define AsuraPolygonFlag_DoubleSided				0x00000001 // indicates platforms that have BFC as standard should treat this as double-sided
#define AsuraPolygonFlag_DontRender					0x00000002 // For invisible polygons
#define AsuraPolygonFlag_NoCollisions				0x00000004
#define AsuraPolygonFlag_IgnoreLOS					0x00000008 /// Kevin Lea - 12/12/2002 18:18:44 - in game 'ignored-by-LOS'
#define AsuraPolygonFlag_Physics_WalkableSurface	0x00000010 // KJFL - indicates that actors can walk or step over surface
#define AsuraPolygonFlag_IgnoreForIK				0x00000020 // Ignore poly in IK LOS test. ( but include in other LOS )

//Second 8 flag bits are reserved for project specific flags
#define AsuraPolygonFlag_ProjectSpecificFlags		0x0000ff00 // These 8 flag bits reserved for project specific use



//Last 16 flag bits are for flags that will only be available in tools
#define AsuraPolygonFlag_BlockWaypointLinks         0x00020000 // Links travelling over these polygons will be culled during waypoint/link generation.
#define AsuraPolygonFlag_SplayNormals               0x00040000 // Changes the vertex normal calculation so that they point more away from the polygon centre
#define AsuraPolygonFlag_DenseWaypoints             0x00080000 // Indicates that the waypoints generated on these polygons should use the dense radii settings.
#define AsuraPolygonFlag_Darken						0x00100000 // Halves the prelighting for this polygon. (exact scale value may be changed) RAR 07/03/2006
#define AsuraPolygonFlag_Water						0x00200000 // Polygons are used for defining the water effect. These polygons won't appear in the exported render/collision meshes(probably). RAR 10/12/2004
#define AsuraPolygonFlag_UseForEntityGISamples		0x00400000 // Polygons' vertices should be used as sample points for entity GI samples
#define AsuraPolygonFlag_IgnoreAmbientLight			0x00800000 // Polygon should ignore the ambient light when calculating prelighting
#define AsuraPolygonFlag_IgnoreWhenWaypointing		0x01000000 // Polygon will not stop a waypoint expanding through it.
#define AsuraPolygonFlag_IgnoreNormalForLighting	0x02000000 // Polygons marked with this are assumed to face towards any lights in prelighting. RAR 24/03/03
#define AsuraPolygonFlag_Step						0x04000000 // README: If we start running out of flags this is a prime candidate for removal.
#define AsuraPolygonFlag_DontBlockLight				0x08000000 // Polygon shouldn't block LOS tests for volumetric lights
#define AsuraPolygonFlag_DontExport					0x10000000 // Polygon shouldn't appear in PS2 level exports (and possibly other exports eventually)
#define AsuraPolygonFlag_Floor						0x20000000 // Polygon will be used to generate waypoints.
#define AsuraPolygonFlag_FullBright					0x40000000 // Prelighting should be at full brightness

// 0x80000000 reserved for temporary storage while in max - RAR 15/08/02


//Old polygon flag values
#define OldAsuraPolygonFlag_FullBright					0x00000001 // Prelighting should be at full brightness
#define OldAsuraPolygonFlag_Floor						0x00000002 
#define OldAsuraPolygonFlag_DontExport					0x00000004 // Polygon shouldn't appear in PS2 level exports (and possibly other exports eventually)
#define OldAsuraPolygonFlag_DontBlockLight				0x00000008 // Polygon shouldn't block LOS tests for volumetric lights
#define OldAsuraPolygonFlag_Step						0x00000010 
#define OldAsuraPolygonFlag_NoCollisions				0x00000020
#define OldAsuraPolygonFlag_IgnoreLOS					0x00000040 /// Kevin Lea - 12/12/2002 18:18:44 - in game 'ignored-by-LOS'
#define OldAsuraPolygonFlag_IgnoreNormalForLighting	    0x00000080 // Polygons marked with this are assumed to face towards any lights in prelighting. RAR 24/03/03
#define OldAsuraPolygonFlag_IgnoreWhenWaypointing		0x00000100 
#define OldAsuraPolygonFlag_DontRender					0x00000200 // For invisible polygons
#define OldAsuraPolygonFlag_DoubleSided				    0x00000400 // indicates platforms that have BFC as standard should treat this as double-sided
#define OldAsuraPolygonFlag_IgnoreAmbientLight			0x00000800 // Polygon should ignore the ambient light when calculating prelighting


#endif//__ASURA_MESH_POLYGONFLAGS_H__
