//
// Asura_Viewport.h
//
// Created by Kevin Lea - 12/06/2001 11:06:28
// 
// Copyright (C) 2001 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_VIEWPORT_H__
#define __ASURA_VIEWPORT_H__


// (BW - 03.03.09) This represents the dimensions of the current render target.
// To render to a region within that use Asura_Camera::SetViewingArea().
// Note that this does correspond to platform-specific hardware level "viewports",
// which represent the  current renderable area.
class Asura_Viewport
{
	public:

		static inline void Set(int width, int height)
		{
			Height = height;
			Width = width;

			CentreX = (float)(width/2);
			CentreY = (float)(height/2);

		//ProjX = CentreX;
		//	ProjY = CentreY;
		}

		static inline int GetWidth(void)
		{
			return Width;
		}
		
		static inline int GetHeight(void)
		{
			return Height;
		}

		static float CentreX;
		static float CentreY;

	private:
		static int Height;
		static int Width;


};

#endif//__ASURA_VIEWPORT_H__
