//////////////////////////////////////////////////////////////////////////////
//
// Asura_Rewards_System.cpp
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
// Description:
//
//     Engine class to unify platform Reward (achievement) systems
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#ifdef ASURA_USE_REWARDS

// This file's header.
#include "Rewards/Asura_Rewards_System.h"

#include "Debugging/Asura_Assert.h"

void Asura_Rewards_System::Initialise()
{
	Platform_Initialise();
}

void Asura_Rewards_System::Shutdown()
{
	Platform_Shutdown();
}

void Asura_Rewards_System::HandleEvent(Asura_Hash_ID uEventHash, int iEventData /*= 0*/)
{
	// NY - 30 March 2009 - always call both, rather making one conditional one whether the other has handled the event,
	// as it's entirely reasonable that both would need to handle the same event for different rewards
	Project_HandleEvent(uEventHash, iEventData);
	Project_Platform_HandleEvent(uEventHash, iEventData);
}

void Asura_Rewards_System::Reset()
{
	Platform_Reset();
}

#endif // #ifdef ASURA_USE_REWARDS
