/**
*
* \file Asura_BillboardPlant_System.h
*
* Created by Andrew Weinkove - 11/12/2002
*
* Copyright (C) 2002 Rebellion, All Rights Reserved.
*
**/

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_BILLBOARDPLANT_SYSTEM_H__
#define __ASURA_BILLBOARDPLANT_SYSTEM_H__

#ifdef ASURA_USE_BILLBOARD_PLANTS

class Asura_BillboardPlant_Batch;

class Asura_BillboardPlant_System
{
	friend class Tools_Level_Export;
	friend class Tools_SaveAsura;
public:
	static void Initialise();
	static void Shutdown();
	static void Reset();
	static void Update();
	static void Render();
	static void AllocateBatchPointers(unsigned uNumberOfBatches);
	static void SetBatchPointer(Asura_BillboardPlant_Batch *pxBatch, int iIndex);
#ifdef ASURA_TOOLS
	static unsigned GetNumberOfBatches();
	static Asura_BillboardPlant_Batch *GetBillboardPlantBatch(int iIndex);
	static void RemoveAllBatches();
	static void AddNewBatch(Asura_BillboardPlant_Batch *pxBatch);
#endif

private:
	static unsigned m_uNumberOfBillboardPlantBatches;
	static Asura_BillboardPlant_Batch **m_ppxBillboardPlantBatches;
};


#endif //ASURA_USE_BILLBOARD_PLANTS
#endif //__ASURA_PARTICLE_TEMPLATESTORE_H__
