//
// Asura_SimplexNoise_System.h
//
// Created by KOR - 16/10/2008
//
// A cheaper alternative to Perlin noise.
// Based on Ken Perlin: Real-Time Shading SIGGRAPH Course Notes - Chapter 2: Noise hardware
// http://www.csee.umbc.edu/~olano/s2002c36/ch02.pdf
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_SIMPLEXNOISE_SYSTEM_H__
#define __ASURA_SIMPLEXNOISE_SYSTEM_H__

class Asura_Vector_2;
class Asura_Vector_3;
class Asura_AVector3;

class Asura_SimplexNoise_System
{
public:
	static void Initialise();

	static float GetNoise(const Asura_Vector_2& xValue);
	static float GetNoise(const Asura_Vector_3& xValue);

	static void CalculateNoiseVector(const Asura_Vector_3& xPosition, Asura_Vector_3& xVector);
	static void CalculateNoiseVector(const Asura_AVector3& xPosition, Asura_AVector3& xVector);
	static void CalculateNoiseVector(const Asura_Vector_3& xPosition, const float fTime, Asura_Vector_3& xVector);
	static void CalculateNoiseVector(const Asura_AVector3& xPosition, const float fTime, Asura_AVector3& xVector);

private:
	static bool				s_bNoiseInitialised;
};

#endif//__ASURA_SIMPLEXNOISE_SYSTEM_H__
