//
// Asura_Sphere.h
//
// Created by Kevin Lea - 12/06/2001 11:10:22
// 
// Copyright (C) 2001 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_SPHERE_H__
#define __ASURA_SPHERE_H__

#include "Core/Asura_Maths.h"

typedef struct
{
	int v[3];
} TRI_FACE;
 
#define SPHERE_ORDER 3
//10
#define SPHERE_ORDER_AS_FLOAT ((float)SPHERE_ORDER)

#define SPHERE_RADIUS (1.0f)
#define SPHERE_FACES (8*SPHERE_ORDER*SPHERE_ORDER)
#define SPHERE_VERTICES (4*SPHERE_ORDER*SPHERE_ORDER+2)
#define SPHERE_INDICES (SPHERE_FACES*3)

#define SPHERE_TEXTURE_WRAP (16.0f)


class Asura_Sphere_Vertex
{
	public:

	float x;
	float y;
	float z;

	int Colour;
	float U;
	float V;	

	inline void operator = ( const Asura_Vector_3& v)
	{
		this->x = v.x;
		this->y = v.y;
		this->z = v.z;
	}
};


extern Asura_Sphere_Vertex SphereVertex[SPHERE_VERTICES];
extern unsigned short SphereIndices[SPHERE_INDICES];
															
#endif//__ASURA_SPHERE_H__
