
//
// Asura_EffectVolume_EffectState.h
//
// Created by Emil Popovic - 19/12/2008
// 
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif


#ifndef __ASURA_EFFECTVOLUME_EFFECTSTATE_H__
#define __ASURA_EFFECTVOLUME_EFFECTSTATE_H__


#include "Rendering/Asura_Fog.h"
#include "Entity/Triggers/EffectVolume/Asura_EffectVolume_Effect.h"



const Asura_Hash_ID uEFFECTVOLUME_EFFECTSTATE_FOG		= 0x857FD94B;	// Asura_Guid("EFFECTVOLUME_EFFECTSTATE_FOG")
#if defined(ASURA_USE_FSFX)
const Asura_Hash_ID uEFFECTVOLUME_EFFECTSTATE_FSFX		= 0x2A7B5F72;	// Asura_Guid("EFFECTVOLUME_EFFECTSTATE_FSFX")
#endif	//defined(ASURA_USE_FSFX)


//----------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------

class Asura_EffectVolume_EffectState
{
public:

	virtual void	ApplyToCamera( u_int uCameraIndex );
	virtual bool	Blend( Asura_EffectVolume_EffectState& xNewEffectState, float fStrength );

	Asura_Hash_ID	GetEffectTypeHash()	{return m_uEffectTypeHash;}

	Asura_EffectVolume_EffectState( Asura_Hash_ID uEffectTypeHash );
	virtual ~Asura_EffectVolume_EffectState();

protected:
	bool			m_bHashData;
	Asura_Hash_ID	m_uEffectTypeHash;
};

//----------------------------------------------------------------------------------------------------------------------------

class Asura_EffectVolume_EffectState_Fog : public Asura_EffectVolume_EffectState
{
	friend class Asura_EffectVolume_Effect_Fog;

public:
	virtual void ApplyToCamera( u_int uCameraIndex );
	virtual bool Blend( Asura_EffectVolume_EffectState& xNewEffectState, float fStrength );

	void InitialiseToCurrentExistingFog();

	Asura_EffectVolume_EffectState_Fog();

protected:
	Asura_Fog_Parameters m_xFogParameters;

	typedef Asura_EffectVolume_EffectState PARENT;
};

//----------------------------------------------------------------------------------------------------------------------------

#if defined(ASURA_USE_FSFX)

class Asura_EffectVolume_EffectState_FSFX : public Asura_EffectVolume_EffectState
{
public:
	virtual void ApplyToCamera( u_int uCameraIndex );
	virtual bool Blend( Asura_EffectVolume_EffectState& xNewEffectState, float fStrength );
	
	void BlendStrengthOnly( float fStrength );

	void SetTemplateParameter( const Asura_FSFXTemplate_Parameters& xTemplateParameter )	
	{
		m_xTemplateParameter = xTemplateParameter;
	}

	Asura_EffectVolume_EffectState_FSFX();

private:

	Asura_FSFXTemplate_Parameters m_xTemplateParameter;

	typedef Asura_EffectVolume_EffectState PARENT;
};

#endif	//defined(ASURA_USE_FSFX)


#endif//__ASURA_EFFECTVOLUME_EFFECTSTATE_H__