//
// Asura_PFX_Code_Effects.h
//
// Created by KOR - 09/09/2004
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_PFX_CODE_EFFECTS_H__
#define __ASURA_PFX_CODE_EFFECTS_H__

#include "Core/Asura_Handle.h"
#include "Core/Asura_Maths.h"
#include "Network/Asura_Guid.h"
#include "SpecialFX/PFX/Asura_PFX_Classes.h"
#include "SpecialFX/PFX/Asura_PFX_Effect.h"
#include "SpecialFX/PFX/Asura_PFX_System.h"


// KOR - example PFX code effect, based on the Dredd entity fire effect
const u_int ASURA_PFX_MAXFIREPARTICLES = 200;
class Asura_PFX_Entity_Fire : public Asura_PFX_Effect
{
	friend class Asura_PFX_System;

public:
	// Public interface functions.
	static int Create(const Asura_Vector_3& xPosition);
	static int Create(const Asura_Vector_3& xPosition, const Asura_Guid uOwnerGuid);
	void UpdatePosition(const class Asura_Animation* pxAnimation, const Asura_Vector_3 xPosition);
	void DieOut(bool bDieOut) { m_bDieOut = bDieOut; }

	void UpdatePhotonPosition(const Asura_Vector_3& xPosition);

private:
	// Constructors/destructor.
	Asura_PFX_Entity_Fire(const Asura_Vector_3& xPosition, const Asura_Guid uOwnerGuid);
	~Asura_PFX_Entity_Fire();
	
private:
	// Helper functions. 
	void Update(void);
	void Render(void);

private:
	// Data. 
	Asura_PFX_Particle m_axParticles[ASURA_PFX_MAXFIREPARTICLES];
	u_int m_uNumberOfActiveParticles;
	float m_fReleaseTimer;
	Asura_Vector_3 m_xPosition;
	Asura_Vector_3 m_xOffset;
	bool  m_bDieOut;
	
	class Asura_Photon* m_pxPhoton; // light from fire

	u_int m_uBone;
	u_int m_uNumberOfBones;
	Asura_Vector_3* m_pxBonePositions;
	Asura_Vector_3* m_pxBoneDirections;

    unsigned int m_uLastFramePosWasUpdated;
};

// KOR - messing around trying to create a Glimmer Rats soul wind
const u_int ASURA_PFX_MAXSOULWINDPARTICLES = 500;
class Asura_PFX_Entity_SoulWind : public Asura_PFX_Effect
{
	friend class Asura_PFX_System;

public:
	// Public interface functions.
	static int Create(const Asura_Vector_3& xPosition);
	static int Create(const Asura_Vector_3& xPosition, const Asura_Guid uOwnerGuid);
	void UpdatePosition(const class Asura_Animation* pxAnimation, const Asura_Vector_3 xPosition);
	void DieOut(bool bDieOut) { m_bDieOut = bDieOut; }

private:
	// Constructors/destructor.
	Asura_PFX_Entity_SoulWind(const Asura_Vector_3& xPosition, const Asura_Guid uOwnerGuid);
	~Asura_PFX_Entity_SoulWind();
	
private:
	// Helper functions. 
	void Update(void);
	void Render(void);

private:
	// Data. 
	class Asura_PFX_Particle m_axParticles[ASURA_PFX_MAXSOULWINDPARTICLES];
	u_int m_uNumberOfActiveParticles;
	float m_fReleaseTimer;
	Asura_Vector_3 m_xPosition;
	bool  m_bDieOut;
	
	u_int m_uNumberOfBones;
	Asura_Vector_3 m_axBonePosition[30];

	bool m_bRenderThisFrame;
    unsigned int m_uLastFramePosWasUpdated;
};

#endif//__ASURA_PFX_CODE_EFFECTS_H__
