//
// Asura_Streaming_Connection.cpp
//
// Created by Richard Rice - 06/03/2006
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

// RJT NOTE: Required for GCC builds as the file list generation doesn't account for VC project exclusion from build
#ifdef ASURA_USE_STREAMING

#include "Core/Asura.h"
#include "Streaming/Asura_Streaming_Connection.h"

#include "ChunkSystem/Asura_Chunk_Stream.h"

#if defined(ASURA_TOOLS)
#include "Load&Save/LevelExport/Tools_Level_Export.h"
#endif

void Asura_Streaming_Connection::ReadFromChunkStream(class Asura_Chunk_Stream& xStream,int iChunkVersion)
{
	xStream >> m_xZoneName;
	m_uToZoneHashID = Asura_GetHashID(m_xZoneName.GetString());

	xStream >> m_xRelativeOffset;

	int iTemp;
	xStream >> iTemp;
	m_bUseBoundingBoxForLoading = iTemp ? true : false;

	xStream >> m_xBoundingBoxForLoading;

	if(iChunkVersion >= 1 )
	{
		xStream >> iTemp;
		m_bLowDetail = iTemp ? true : false;
	}

	if(iChunkVersion >= 2)
	{
		#ifdef ASURA_TOOLS
		xStream >> m_xToolsFilename;
		#else
		//skip filename outside of tools
		xStream.SkipString();
		#endif
	}
}

#ifdef ASURA_TOOLS
void Asura_Streaming_Connection::WriteToChunkStream(class Asura_Chunk_Stream& xStream) const
{
	xStream << m_xZoneName;
	xStream << m_xRelativeOffset;

	xStream << (int)(m_bUseBoundingBoxForLoading ? 1 : 0);
	if(m_bUseBoundingBoxForLoading)
	{
		Asura_Bounding_Box	xBB(m_xBoundingBoxForLoading);
		Asura_Vector_3		xDisplacement(Tools_Level_Export::GetExportCentre());

		xBB.Displace(-xDisplacement);
		xStream << xBB;
	}
	else
	{
		xStream << m_xBoundingBoxForLoading;
	}

	xStream << (int)(m_bLowDetail ? 1 : 0);

	xStream << m_xToolsFilename;

}
#endif // ASURA_TOOLS

#endif	// ASURA_USE_STREAMING
