
//////////////////////////////////////////////////////////////////////////////
//
// Asura_UnitTest_HeapArray.cpp
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
// Description:
//
//     Unit tests for Asura_HeapArray class
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"
#include "Core/Asura_Core.h"
#include "Debugging/Asura_Assert.h"

#include "Core/Asura_HeapArray.h"

#include "UnitTest/Asura_UnitTest.h"

#ifdef ASURA_SUPPORT_UNITTEST

ASURA_UNITTEST(GeneralTests, HeapArray)
{
	Asura_HeapArray< int> xArray;
	
    ASURA_UNITTEST_CHECK_EQUAL( 0, xArray.Size() );
    
    xArray.SetSize( 4);
	
	xArray[0] = 10;
	xArray[1] = 16;
	xArray[2] = 32;
	xArray[3] = 64;
	
    ASURA_UNITTEST_CHECK_EQUAL( 4, xArray.Size() );
    ASURA_UNITTEST_CHECK_EQUAL( 64, xArray[3] );
    ASURA_UNITTEST_CHECK_EQUAL( 32, xArray[2] );
    ASURA_UNITTEST_CHECK_EQUAL( 16, xArray[1] );
    ASURA_UNITTEST_CHECK_EQUAL( 10, xArray[0] );
    
    xArray.Shrink( 2);
    
    ASURA_UNITTEST_CHECK_EQUAL( 2, xArray.Size() );
    ASURA_UNITTEST_CHECK_EQUAL( 16, xArray[1] );
    ASURA_UNITTEST_CHECK_EQUAL( 10, xArray[0] );

    xArray.Clear();
    
    ASURA_UNITTEST_CHECK_EQUAL( 0, xArray.Size() );
}

#endif // #ifdef ASURA_SUPPORT_UNITTEST
