//////////////////////////////////////////////////////////////////////////////
//
// Asura_Windows.cpp
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"
#include <windows.h>

// Engine independent.
#include "Core/Asura_Windows.h"

// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

//
// Asura_Windows.
//

#include "Core/Asura.h"
#include "Core/Asura_String.h"
#include "Core/Asura_Windows.h"
#include "Rendering/Asura_Viewport.h"
#include "Debugging/Asura_Assert.h"
//#include "Input/Asura_PlatformInput.h"
#include "zmouse.h"

bool			Asura_Windows::s_bFullScreen;
HINSTANCE		Asura_Windows::WindowhInstance;
int				Asura_Windows::WinLeftX, Asura_Windows::WinTopY;
int				Asura_Windows::WinWidth,Asura_Windows::WinHeight;
float			Asura_Windows::WinScaleX,Asura_Windows::WinScaleY;
bool			Asura_Windows::ApplicationIsActive;
char*			Asura_Windows::ApplicationName;
unsigned char	Asura_Windows::ToAsciiTable[256][256];
ASURA_KEYID		Asura_Windows::s_aeExtendedKeyPressed[256][2];
bool			Asura_Windows::s_bPauseWhileMinimised = false;
DWORD			Asura_Windows::s_uMainThreadID;
HWND*			Asura_Windows::s_pxWindowHandles;

void Asura_Windows::Initialise(HINSTANCE hInstance, HINSTANCE hPrevInstance, const char* szCmdLine, int nCmdShow, const LPVOID guid, bool bFullScreen)
{
	// assuming that this function is called by main thread...
	s_uMainThreadID = GetCurrentThreadId();
}

void Asura_Windows::Shutdown(void)
{}

HWND Asura_Windows::GetWindowHandle(u_int uWindowIndex /* = 0 */)
{
	return GetConsoleWindow();
}

bool Asura_Windows::InitialiseWindow(HINSTANCE hInstance, int nCmdShow){ return false; }
void  Asura_Windows::CheckForWindowsMessages(void){}
inline long FAR PASCAL Asura_Windows::WindowsMessageHandler(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam){}
const Asura_UnicodeChar* Asura_Windows::GetInputBuffer() { return NULL; }
u_int Asura_Windows::GetSizeOfInputBuffer()	{ return 0; }
void Asura_Windows::SetWindowSize(int iWidth,int iHeight)	{ }
bool Asura_Windows::IsMainThread(void) { return GetCurrentThreadId() == s_uMainThreadID; }
void Asura_Windows::PostShowDialogBox(void) {}
void Asura_Windows::PreShowDialogBox(void) {}

void Asura_Windows::SetWindowTitle(const char *szTitle)
{
#ifdef ASURA_ASSERT
	BOOL bWorked = 
#endif //ASURA_ASSERT
	SetConsoleTitle( szTitle );
	Asura_Assert( bWorked, "Failed to set console title" );
}
