//
// Asura_PC_DoubleFusionAdObject.h
//
// Created by Andy Eder - 31/06/2006 
//    (MOD by DWW 27/06/006)
// 
// Copyright (C) 2001 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __Asura_PC_DoubleFusionAdObject_H__
#define __Asura_PC_DoubleFusionAdObject_H__

// includes


// defines

#include "AdEngine/Asura_AdObject.h"
// forward declarations
//class ASURA_AdObject;
class IDFObject;


class Asura_PC_DoubleFusionAdObject : public Asura_AdObject
{
public:

	// ctor / dtor 
	Asura_PC_DoubleFusionAdObject();
	virtual ~Asura_PC_DoubleFusionAdObject();

	inline void SetID(const int iID)
	{
		m_iID = iID;
	}

	inline const int GetID() const
	{
		return m_iID;
	}

	inline const IDFObject* GetDFObject() const
	{
		return m_pxDFObject;
	}

public:
	virtual bool Update(const float fFrameTime);
	virtual bool Initialise(const char* zPlaceHolderFileName, const int iTextureID, const void *pData = 0);
	virtual bool Destroy(void);

private:

	int				m_iID;						// object ID (assigned by our own AdEngine system)
	IDFObject*		m_pxDFObject;				// ptr to DFObject associated with this DF enabled object
};


#endif // __Asura_PC_DoubleFusionAdObject_H__
