//
// ASURA_PC_DoubleFusionAdEngine.h
//
// Created by Andrew McMaster - 06/04/2006 
//  (Additional work: Andy Eder - 24/05/2006 onwards)
//                 (Additional work: DWW - 27/06/06 onwards)
// 
// Copyright (C) 2001 Rebellion, All Rights Reserved.
//

 
#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_PC_DOUBLEFUSIONADENGINE_H__
#define __ASURA_PC_DOUBLEFUSIONADENGINE_H__

// includes
#include "Core/Asura_LinkList.h"
#include "Core/Asura_PlatformBasics.h"	// MAX_PATH

#include "DoubleFusion/DFEngineHeader.h"


// defines
#define ASURA_DFAE_MAXCREATIVEOBJECTS	16			// maximum number of creative objects at any given time

// forward declarations
class IDFEngine;
class IDFObject;
class ASURA_DFEnabledObject;


class Asura_PC_DoubleFusionAdEngine
{
	public:

		Asura_PC_DoubleFusionAdEngine();

		bool Initialise(const char* cszProjectName);
		void Shutdown();

		static void StartZone(const Asura_UnicodeChar* pzZoneName);
		static void LeaveZone();
			
		///>>

		void SetIsInitialised(const bool bIsInitialised);
		static const bool GetIsInitialised();

//DeadCode AMM 04/09/2006 		static const char* GetRootDirectory();

		///>>

		int CreateDFObject(const char* cszObjectID, IDFObject** ppxDFObject);
		int DestroyDFObject(IDFObject* pxDFObject);

		///>>

		void Update(float fTime);

		static const char* DFErrorCodeToString(DFErrorCode eErrorCode);

		/////////////////////////////////////////////////////////////////////

		static Asura_PC_DoubleFusionAdEngine s_xAdEngine;

	protected:

	private:

		static IDFEngine*	m_pxAdEngine;							// ptr to instance of the DoubleFusion AdEngine
		static bool			m_bInitialised;							// whether or not the system has been initialised

		static Asura_UnicodeChar s_zCurrentZone[256];

};


#endif // __ASURA_PC_DOUBLEFUSIONADENGINE_H__
