//*******************************************************************
//
// File: Asura_Direct3D_Botanicals_Game_Render_Manager_Inlines.h
//
// Created: 1 Nov 2006
//
// Description: 
//
//*******************************************************************

#ifndef _ASURA_DIRECT3D_BOTANICALS_GAME_RENDER_MANAGER_INLINES_H_
#define _ASURA_DIRECT3D_BOTANICALS_GAME_RENDER_MANAGER_INLINES_H_

#if !defined( _ASURA_DIRECT3D_BOTANICALS_GAME_RENDER_MANAGER_H_INLINE_CODE_GUARD_)
	#error 'Asura_Direct3D_Botanicals_Game_Render_Manager_Inlines.h' must only be included in 'Asura_Direct3D_Botanicals_Game_Render_Manager.h'
#endif

#if defined( ASURA_USE_BOTANICALS)

// other libraries

// internal dependencies

// forward declarations

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Class Definitions
//*******************************************************************


//*******************************************************************
// Inline Function Definitions
//*******************************************************************

inline uint32 Asura_Direct3D_BGR_Manager::GetTypeFlags()
{
	// DLH - Version
	uint32 uFlags = 1
	// DLH - Data Types
#if defined( ASURA_DIRECT3D_BGR_INSTANCE_ENABLE_COMPRESSED_DATA)
	| 0x10000000
#endif
	| 0x40000000
	| 0x02000000
#if defined( ASURA_DIRECT3D_BGR_SUPPORT_SM11)
	| 0x01000000
#endif
#if defined( ASURA_DIRECT3D_BGR_SUPPORT_SM30)
	| 0x00800000
#endif
	;
	
	return( uFlags);
}
	
inline Asura_Direct3D_BGR_Instance* Asura_Direct3D_BGR_Instances_Header::GetDirect3DInstance( const uint32 uInstanceIndex) 
{ 
#if 0
	void* pInstanceBase = static_cast< void*>( this + 1);
	Asura_Direct3D_BGR_Instance* pxInstanceBase = static_cast< Asura_Direct3D_BGR_Instance*>( pInstanceBase);
	Asura_Assert( uInstanceIndex <= this->m_uInstanceCount, "Instance Index is out of range!");
	return( pxInstanceBase + uInstanceIndex);
#endif
	return( &(this->m_xArrayInstances[ uInstanceIndex]) );
}

inline const Asura_Direct3D_BGR_Instance* Asura_Direct3D_BGR_Instances_Header::GetDirect3DInstance( const uint32 uInstanceIndex) const
{ 
#if 0
	const void* pInstanceBase = static_cast< const void*>( this + 1);
	const Asura_Direct3D_BGR_Instance* pxInstanceBase = static_cast< const Asura_Direct3D_BGR_Instance*>( pInstanceBase);
	Asura_Assert( uInstanceIndex <= this->m_uInstanceCount, "Instance Index is out of range!");
	return( pxInstanceBase + uInstanceIndex);
#endif
	return( &(this->m_xArrayInstances[ uInstanceIndex]));
}

inline const Asura_BGR_Instance* Asura_Direct3D_BGR_Instances_Header::GetInstance( const uint32 uInstanceIndex) const
{
	const Asura_Direct3D_BGR_Instance* const pxDirect3DInstance = this->GetDirect3DInstance( uInstanceIndex);
	const Asura_BGR_Instance* const pxInstance = pxDirect3DInstance;
	
	return( pxInstance);
}

template< class Tvertex, class Tindex>
inline Asura_Direct3D_BGR_D3DBuffer< Tvertex, Tindex>::Asura_Direct3D_BGR_D3DBuffer()
{
	this->m_pxIndexBuffer = NULL;
	this->m_pxVertexBuffer = NULL;
	this->m_uIBSize = 0;
	this->m_uVBSize = 0;
	this->m_uVBOffset = 0;
	this->m_pxArrayIndex = NULL;
	this->m_pxArrayVertex = NULL;
}
	
template< class Tvertex, class Tindex>
inline bool Asura_Direct3D_BGR_D3DBuffer< Tvertex, Tindex>::Clear()
{
	this->ClearDirect3DData();
	
	this->m_uIBSize = 0;
	this->m_uVBSize = 0;
	this->m_uVBOffset = 0;
	
	return( true);
}

template< class Tvertex, class Tindex>
inline bool Asura_Direct3D_BGR_D3DBuffer< Tvertex, Tindex>::ClearDirect3DData()
{
	this->Unlock();
	
	SAFE_RELEASE( this->m_pxIndexBuffer);
	SAFE_RELEASE( this->m_pxVertexBuffer);
	
	return( true);
}
	
template< class Tvertex, class Tindex>
inline bool Asura_Direct3D_BGR_D3DBuffer< Tvertex, Tindex>::CreateDirect3DData( const bool bDynamic)
{
	HRESULT xResult;
	
	Direct3D_Device* pxD3DDevice = Asura_Direct3D::D3DDevice;

	if( 0 < this->m_uIBSize)
	{	
		Direct3D_IndexBuffer* pxIndexBuffer = NULL;
		DWORD uUseage = (false == bDynamic) ? D3DUSAGE_WRITEONLY : (D3DUSAGE_DYNAMIC | D3DUSAGE_WRITEONLY) ;
		xResult = pxD3DDevice->CreateIndexBuffer( this->m_uIBSize * sizeof( Tindex), uUseage, D3DFMT_INDEX16, D3DPOOL_DEFAULT , &pxIndexBuffer, NULL);
		if( ASURA_D3D_OK( xResult))
		{
			this->m_pxIndexBuffer = pxIndexBuffer;
		}
		else
		{
			Asura_Assert( false, "Cannot create IB!");
			return( false);
		}
	}
	
	if( 0 < this->m_uVBSize)
	{	
		Direct3D_VertexBuffer* pxVertexBuffer = NULL;
		DWORD uUseage = (false == bDynamic) ? D3DUSAGE_WRITEONLY : (D3DUSAGE_DYNAMIC | D3DUSAGE_WRITEONLY) ;
		xResult = pxD3DDevice->CreateVertexBuffer( this->m_uVBSize * sizeof( Tvertex), uUseage, 0, D3DPOOL_DEFAULT , &pxVertexBuffer, NULL);
		if( ASURA_D3D_OK( xResult))
		{
			this->m_pxVertexBuffer = pxVertexBuffer;
		}
		else
		{
			Asura_Assert( false, "Cannot create VB!");
			return( false);
		}
	}
	
	return( true);
}

template< class Tvertex, class Tindex>
inline bool Asura_Direct3D_BGR_D3DBuffer< Tvertex, Tindex>::Lock( const bool bDynamic)
{
	HRESULT xResult;
	
	this->Unlock();
	
	if( 0 < this->m_uIBSize)
	{
		Asura_Assert( NULL != this->m_pxIndexBuffer, "Cannot lock IB as the IB has not been created!");
		
		if( NULL != this->m_pxIndexBuffer)
		{
			void *pIBData = NULL;
			DWORD uFlags = (false == bDynamic) ? 0 : D3DLOCK_NOOVERWRITE ;
			xResult = this->m_pxIndexBuffer->Lock( 0, this->m_uIBSize * sizeof( Tindex), &pIBData, uFlags);
			if( ASURA_D3D_OK( xResult))
			{
				this->m_pxArrayIndex = static_cast< Tindex*>( pIBData);
			}
		}
		else
		{
			return( false);
		}
	}
	
	if( 0 < this->m_uVBSize)
	{
		Asura_Assert( NULL != this->m_pxVertexBuffer, "Cannot lock VB as the VB has not been created!");
		
		if( NULL != this->m_pxVertexBuffer)
		{
			void *pVBData = NULL;
			DWORD uFlags = (false == bDynamic) ? 0 : D3DLOCK_NOOVERWRITE ;
			xResult = this->m_pxVertexBuffer->Lock( 0, this->m_uVBSize * sizeof( Tvertex), &pVBData, uFlags);
			if( ASURA_D3D_OK( xResult))
			{
				this->m_pxArrayVertex = static_cast< Tvertex*>( pVBData);
			}
		}
		else
		{
			return( false);
		}
	}
	
	return( true);
}

template< class Tvertex, class Tindex>
inline bool Asura_Direct3D_BGR_D3DBuffer< Tvertex, Tindex>::Unlock()
{
	if( NULL != this->m_pxArrayIndex)
	{
		Asura_Assert( NULL != this->m_pxIndexBuffer, "The IB needs unlocking but the IB is not allocated!");
		this->m_pxArrayIndex = NULL;
		this->m_pxIndexBuffer->Unlock();
	}
	
	if( NULL != this->m_pxArrayVertex)
	{
		Asura_Assert( NULL != this->m_pxVertexBuffer, "The VB needs unlocking but the VB is not allocated!");
		this->m_pxArrayVertex = NULL;
		this->m_pxVertexBuffer->Unlock();
	}
	
	return( true);
}

template< class Tvertex, class Tindex>
inline void Asura_Direct3D_BGR_D3DBuffer< Tvertex, Tindex>::GetBufferBytes( uint32& uVertexBytes, uint32& uIndexBytes) const
{
	uVertexBytes = sizeof( Tvertex) * this->m_uVBSize;
	uIndexBytes = sizeof( Tindex) * this->m_uIBSize;
}

inline void Asura_Direct3D_BGR_Manager::AddToCache( const Asura_Direct3D_BGR_Instances_Header* pxInstanceHeader)
{
	if( NULL == pxInstanceHeader)
	{
		return;
	}
	
	const uint32 uInstanceHeaderInstanceCount = pxInstanceHeader->GetInstanceCount();
	if( 0 == uInstanceHeaderInstanceCount)
	{
		return;
	}
	
	const uint32 uIdTree = pxInstanceHeader->GetType().GetID();
	
	if( Asura_BGR_TypeID::INVALID_ID == uIdTree)
	{
		return;
	}
	
	Asura_Assert( uIdTree < this->m_xArrayTypeCache.Size(), "ID out of Range");
	Asura_Direct3D_BGR_CacheType& xCacheType = this->m_xArrayTypeCache[ uIdTree];
	if( NULL == xCacheType.m_pxTree)
	{
		return;
	}
	
	Asura_Assert( NULL != xCacheType.m_pxTree && uIdTree == xCacheType.m_pxTree->GetTreeId(), "Pointer or ID not Setup!");
	
	xCacheType.m_xListRegionDescriptions.Push_Back( pxInstanceHeader);
}


//*******************************************************************
//
// (c) 2006 Rebellion Ltd
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif // ASURA_USE_BOTANICALS

#endif // _ASURA_DIRECT3D_BOTANICALS_GAME_RENDER_MANAGER_INLINES_H_
