//*******************************************************************
//
// File: Asura_Platform_Botanical_Game_Render_Instance_Inline.h
//
// Created: 15 December 2006 DLH
//
// Description: 
//
//*******************************************************************

#ifndef __ASURA_PLATFORM_BOTANICAL_GAME_RENDER_INSTANCE_INLINE_H__
#define __ASURA_PLATFORM_BOTANICAL_GAME_RENDER_INSTANCE_INLINE_H__

// other libraries

// internal dependencies

// forward declarations

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Class Definitions
//*******************************************************************


//*******************************************************************
// Inline Function Definitions
//*******************************************************************

inline void Asura_BGR_Instance::GetInstancePosition( Asura_AVector3& xInstancePosition) const
{
#if !defined( ASURA_DIRECT3D_BGR_INSTANCE_ENABLE_COMPRESSED_DATA)
	xInstancePosition = this->m_xPosition;
#else
	xInstancePosition.SetX( this->m_afPosition[0]);
	xInstancePosition.SetY( this->m_afPosition[1]);
	xInstancePosition.SetZ( this->m_afPosition[2]);
#endif
}

inline void Asura_BGR_Instance::GetInstancePosition( Asura_Vector_3& xInstancePosition) const
{
#if !defined( ASURA_DIRECT3D_BGR_INSTANCE_ENABLE_COMPRESSED_DATA)
	xInstancePosition = this->m_xPosition;
#else
	xInstancePosition.SetX( this->m_afPosition[0]);
	xInstancePosition.SetY( this->m_afPosition[1]);
	xInstancePosition.SetZ( this->m_afPosition[2]);
#endif
}

inline void Asura_BGR_Instance::GetInstanceUp( Asura_AVector3& xInstanceUp) const
{
#if !defined( ASURA_DIRECT3D_BGR_INSTANCE_ENABLE_COMPRESSED_DATA)
	const D3DXMATRIX& xTransformMatrix = this->m_xTransformMatrix;

	xInstanceUp.SetX( xTransformMatrix._12);
	xInstanceUp.SetY( xTransformMatrix._22);
	xInstanceUp.SetZ( xTransformMatrix._32);
#else
	xInstanceUp.SetX( static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][1]));
	xInstanceUp.SetY( static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[1][1]));
	xInstanceUp.SetZ( static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[2][1]));
#endif
}

inline void Asura_BGR_Instance::GetOrientation( Asura_AMatrix3x3& xInstanceOrientation) const
{
#if !defined( ASURA_DIRECT3D_BGR_INSTANCE_ENABLE_COMPRESSED_DATA)
#error no Supported
#else
	xInstanceOrientation.SetColumn0( Asura_AVector3( this->m_aiTransformMatrix3x3[0][0], this->m_aiTransformMatrix3x3[1][0], this->m_aiTransformMatrix3x3[2][0]) * ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND);
	xInstanceOrientation.SetColumn1( Asura_AVector3( this->m_aiTransformMatrix3x3[0][1], this->m_aiTransformMatrix3x3[1][1], this->m_aiTransformMatrix3x3[2][1]) * ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND);
	xInstanceOrientation.SetColumn2( Asura_AVector3( this->m_aiTransformMatrix3x3[0][2], this->m_aiTransformMatrix3x3[1][2], this->m_aiTransformMatrix3x3[2][2]) * ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND);

	//	xInstanceOrientation.SetColumn0( Asura_AVector3( this->m_aiTransformMatrix3x3[0][0], this->m_aiTransformMatrix3x3[0][1], this->m_aiTransformMatrix3x3[0][2]) * ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND);
	//	xInstanceOrientation.SetColumn1( Asura_AVector3( this->m_aiTransformMatrix3x3[1][0], this->m_aiTransformMatrix3x3[1][1], this->m_aiTransformMatrix3x3[1][2]) * ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND);
	//	xInstanceOrientation.SetColumn2( Asura_AVector3( this->m_aiTransformMatrix3x3[2][0], this->m_aiTransformMatrix3x3[2][1], this->m_aiTransformMatrix3x3[2][2]) * ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND);
#endif
}

inline void Asura_BGR_Instance::GetOrientationTransposed( Asura_AMatrix3x3& xInstanceOrientation) const
{
#if !defined( ASURA_DIRECT3D_BGR_INSTANCE_ENABLE_COMPRESSED_DATA)
#error no Supported
#else
	xInstanceOrientation.SetColumn0( Asura_AVector3( this->m_aiTransformMatrix3x3[0][0], this->m_aiTransformMatrix3x3[0][1], this->m_aiTransformMatrix3x3[0][2]) * ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND);
	xInstanceOrientation.SetColumn1( Asura_AVector3( this->m_aiTransformMatrix3x3[1][0], this->m_aiTransformMatrix3x3[1][1], this->m_aiTransformMatrix3x3[1][2]) * ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND);
	xInstanceOrientation.SetColumn2( Asura_AVector3( this->m_aiTransformMatrix3x3[2][0], this->m_aiTransformMatrix3x3[2][1], this->m_aiTransformMatrix3x3[2][2]) * ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND);
#endif
}

inline void Asura_BGR_Instance::GetOrientation( Asura_Matrix_3x3& xInstanceOrientation) const
{
#if !defined( ASURA_DIRECT3D_BGR_INSTANCE_ENABLE_COMPRESSED_DATA)
#error no Supported
#else
	xInstanceOrientation.e11 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][0];
	xInstanceOrientation.e21 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[1][0];
	xInstanceOrientation.e31 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[2][0];
							   
	xInstanceOrientation.e12 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][1];
	xInstanceOrientation.e22 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[1][1];
	xInstanceOrientation.e32 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[2][1];
							   
	xInstanceOrientation.e13 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][2];
	xInstanceOrientation.e23 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[1][2];
	xInstanceOrientation.e33 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[2][2];
#endif
}

inline void Asura_BGR_Instance::GetOrientationTransposed( Asura_Matrix_3x3& xInstanceOrientation) const
{
#if !defined( ASURA_DIRECT3D_BGR_INSTANCE_ENABLE_COMPRESSED_DATA)
#error no Supported
#else
	xInstanceOrientation.e11 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][0];
	xInstanceOrientation.e12 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[1][0];
	xInstanceOrientation.e13 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[2][0];
						   
	xInstanceOrientation.e21 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][1];
	xInstanceOrientation.e22 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[1][1];
	xInstanceOrientation.e23 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[2][1];
						   
	xInstanceOrientation.e31 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][2];
	xInstanceOrientation.e32 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[1][2];
	xInstanceOrientation.e33 = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[2][2];
#endif
}

inline void Asura_BGR_Instance::GetOrientationInversed( Asura_Matrix_3x3& xInstanceOrientation) const
{
#if !defined( ASURA_DIRECT3D_BGR_INSTANCE_ENABLE_COMPRESSED_DATA)
#error no Supported
#else
	const float fLength = Asura_Vector_3( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][0], ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][1], ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][2]).Magnitude();
	const float fScale = ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND / (fLength * fLength);
	
	xInstanceOrientation.e11 = fScale * this->m_aiTransformMatrix3x3[0][0];
	xInstanceOrientation.e12 = fScale * this->m_aiTransformMatrix3x3[1][0];
	xInstanceOrientation.e13 = fScale * this->m_aiTransformMatrix3x3[2][0];
						   
	xInstanceOrientation.e21 = fScale * this->m_aiTransformMatrix3x3[0][1];
	xInstanceOrientation.e22 = fScale * this->m_aiTransformMatrix3x3[1][1];
	xInstanceOrientation.e23 = fScale * this->m_aiTransformMatrix3x3[2][1];
						   
	xInstanceOrientation.e31 = fScale * this->m_aiTransformMatrix3x3[0][2];
	xInstanceOrientation.e32 = fScale * this->m_aiTransformMatrix3x3[1][2];
	xInstanceOrientation.e33 = fScale * this->m_aiTransformMatrix3x3[2][2];
#endif
}

inline float Asura_BGR_Instance::GetScale(void) const
{
	const float fScale = Asura_Vector_3( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][0], ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][1], ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][2]).Magnitude();	
	return fScale;
};

inline void Asura_BGR_Instance::GetInstanceSpherical( float* afSphericalR, float* afSphericalG, float* afSphericalB) const
{
#if !defined( ASURA_DIRECT3D_BGR_INSTANCE_ENABLE_COMPRESSED_DATA)
	afSphericalR[ 0] = this->m_afSphericalR[0];
	afSphericalR[ 1] = this->m_afSphericalR[1];
	afSphericalR[ 2] = this->m_afSphericalR[2];
	afSphericalR[ 3] = this->m_afSphericalR[3];

	afSphericalG[ 0] = this->m_afSphericalG[0];
	afSphericalG[ 1] = this->m_afSphericalG[1];
	afSphericalG[ 2] = this->m_afSphericalG[2];
	afSphericalG[ 3] = this->m_afSphericalG[3];

	afSphericalB[ 0] = this->m_afSphericalB[0];
	afSphericalB[ 1] = this->m_afSphericalB[1];
	afSphericalB[ 2] = this->m_afSphericalB[2];
	afSphericalB[ 3] = this->m_afSphericalB[3];
#else
	for( u_int u = 0; u < 4; ++u )
	{
		afSphericalR[u] =
			static_cast< float >( m_auSphericalR[u] ) * m_fDecompSHScale + m_fDecompSHBias;

		afSphericalG[u] =
			static_cast< float >( m_auSphericalG[u] ) * m_fDecompSHScale + m_fDecompSHBias;

		afSphericalB[u] =
			static_cast< float >( m_auSphericalB[u] ) * m_fDecompSHScale + m_fDecompSHBias;
	}
#endif
}

template< class Tdata>
inline void Asura_BGR_Instance::GetInstanceData( Tdata& tData) const
{
#if !defined( ASURA_DIRECT3D_BGR_INSTANCE_ENABLE_COMPRESSED_DATA)
	{
		const D3DXMATRIX& xTransformMatrix = this->m_xTransformMatrix;

		tData.m_afTransform0[0] = xTransformMatrix._11;
		tData.m_afTransform0[1] = xTransformMatrix._21;
		tData.m_afTransform0[2] = xTransformMatrix._31;
		tData.m_afTransform0[3] = xTransformMatrix._41;

		tData.m_afTransform1[0] = xTransformMatrix._12;
		tData.m_afTransform1[1] = xTransformMatrix._22;
		tData.m_afTransform1[2] = xTransformMatrix._32;
		tData.m_afTransform1[3] = xTransformMatrix._42;

		tData.m_afTransform2[0] = xTransformMatrix._13;
		tData.m_afTransform2[1] = xTransformMatrix._23;
		tData.m_afTransform2[2] = xTransformMatrix._33;
		tData.m_afTransform2[3] = xTransformMatrix._43;
	}
#else
	{
		tData.m_afTransform0[0] = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][0]);
		tData.m_afTransform0[1] = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][1]);
		tData.m_afTransform0[2] = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[0][2]);
		tData.m_afTransform0[3] = this->m_afPosition[0];

		tData.m_afTransform1[0] = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[1][0]);
		tData.m_afTransform1[1] = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[1][1]);
		tData.m_afTransform1[2] = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[1][2]);
		tData.m_afTransform1[3] = this->m_afPosition[1];

		tData.m_afTransform2[0] = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[2][0]);
		tData.m_afTransform2[1] = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[2][1]);
		tData.m_afTransform2[2] = static_cast< float>( ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND * this->m_aiTransformMatrix3x3[2][2]);
		tData.m_afTransform2[3] = this->m_afPosition[2];
	}
#endif

	GetInstanceSpherical( tData.m_afSphericalR, tData.m_afSphericalG, tData.m_afSphericalB );
}

//*******************************************************************
//
// (c) 2006 Rebellion
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif // __ASURA_PLATFORM_BOTANICAL_GAME_RENDER_INSTANCE_INLINE_H__
