//*******************************************************************
//
// File: Asura_Direct3D_Carpet_Render.h      
//
// Created: 13 Jan 2006
//
// Description: 
//
//*******************************************************************

#ifndef _ASURA_DIRECT3D_CARPET_RENDER_H_
#define _ASURA_DIRECT3D_CARPET_RENDER_H_

#if defined( ASURA_USE_CARPET)

// other libraries

// internal dependencies

// forward declarations
struct D3DGenericVertex;

//*******************************************************************
// Constants
//*******************************************************************
//#define ASURA_DIRECT3D_CARPET_RENDER_USE_D3D_BUFFERS 1
#define ASURA_DIRECT3D_CARPET_RENDER_D3DFVF_VERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE|D3DFVF_TEX1)

//*******************************************************************
// Class Definitions
//*******************************************************************
struct Asura_Direct3D_Carpet_Render_Vertex
{
	float X,Y,Z;
	unsigned int Diffuse;
	float U;
	float V;
};

class Asura_Direct3D_Carpet_Render
{
public:
	static void Initialise();
	static void ShutDown();
	
	static void PreD3DReset();
	static void PostD3DReset();

	static void BeginRender( void);
	static void EndRender( void);
	
	static Asura_Direct3D_Carpet_Render_Vertex* GetDrawQuad();
	static void SetTextureID( const int iTextureID);
	static void RenderCache();
	
private:
	static bool CreateIndexBuffer();
	static bool CreateVertexBuffer();

	static uint32 s_uDrawCacheMaxQuads;
	static int s_iDrawCacheTextureID;
	static uint32 s_uDrawCacheUsed;
	static Asura_Direct3D_Carpet_Render_Vertex* s_paxDrawCacheVertexArray;

#if defined( ASURA_DIRECT3D_CARPET_RENDER_USE_D3D_BUFFERS)
	static Direct3D_IndexBuffer* s_pxIndexBuffer;
	static Direct3D_VertexBuffer* s_pxVertexBuffer;	
#else
	static uint16 s_axDrawCacheIndexArray[];
	static Asura_Direct3D_Carpet_Render_Vertex s_axDrawCacheVertexArray[];
#endif
	
};

//*******************************************************************
// Inline Function Definitions
//*******************************************************************

//*******************************************************************
//
// (c) 2006 Rebellion (Derby)
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif //define( ASURA_USE_CARPET)

#endif // _ASURA_PLATFORM_CARPET_RENDER_H_
