//
// Asura_Chunk_ResourceFile_PC_Character.h
//
// Created by KJL - 13/04/2003 15:49:33
//
// Copyright (C) 2003 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_CHUNK_RESOURCEFILE_PC_CHARACTER_H__
#define __ASURA_CHUNK_RESOURCEFILE_PC_CHARACTER_H__

#include "ChunkSystem/Asura_Chunk_ResourceFile.h"
#include "Core/Asura_Handle.h"

#if defined(ASURA_PC_DISABLE_PRESM3_SMOOTH_SKIN_RENDERER) && ASURA_PC_DISABLE_PRESM3_SMOOTH_SKIN_RENDERER
//#error The Pre-SM3 smooth skin renderer is disabled in the project config; please ensure that its files are removed and not referenced.
#endif

class Asura_Chunk_Stream;
class Asura_Direct3D_Character_Strip;

// Version Log
// 0  : ??
// 1  : multiple materials support
// 2  : VGP 20Mar2006 Added render bone map
// 3  : (MH - 26.05.2006) Added normal-map data
// 4  : (SB - 04/12/06) Added per strip ID for Simpsons and character chunking
static const int iASURA_CHUNK_PC_CHARACTER_VERSION = 4;

static const u_int uASURA_CHUNK_PC_CHARACTER_FLAG_HASNORMALMAPDATA = 0x00000001;
static const u_int uASURA_CHUNK_PC_CHARACTER_FLAG_TRILIST		   = 0x00000002;

class Asura_Chunk_ResourceFile_PC_Character : public Asura_Chunk_ResourceFile
{
    public:

        // M E T H O D S /////////////////////////////////////////////////////

        bool Process( Asura_Handle hFile );

		Asura_Direct3D_Character_Strip* ProcessFromChunkStream( Asura_Chunk_Stream& xStream, 
																bool bWarnIfMeshExists, 
																bool bConvertMaterialIDs  ) const;
};

#endif//__ASURA_CHUNK_RESOURCEFILE_PC_CHARACTER_H__
