//
// Asura_Chunk_ResourceFile_PC_D3DEffect.cpp
//
// Created by AJG - 09/06/2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

// This file's header.
#include "Asura_Chunk_ResourceFile_PC_D3DEffect.h"

#include "Core/Asura_Material_System.h"
#include "FileAccess/Asura_FileAccess.h"
#include "Rendering/Asura_Direct3D_Effects_System.h"

bool Asura_Chunk_ResourceFile_PC_D3DEffect::Process( Asura_Handle hFile )
{	  
	Asura_Assert(Version <= ASURA_CHUNK_RESOURCEFILE_PC_D3DEFFECT_VERSION, "Unrecognised D3D effect chunk version");

	Asura_Hash_ID uHashID;
	u_int uTextureTypeFlags;
	u_int uVertexShaderFlags;
	u_int uBinarySizeInBytes;
	Asura_FileAccess::ReadData(hFile, &uHashID, sizeof(u_int));
	Asura_FileAccess::ReadData(hFile, &uTextureTypeFlags, sizeof(u_int));
	Asura_FileAccess::ReadData(hFile, &uVertexShaderFlags, sizeof(u_int));
	Asura_FileAccess::ReadData(hFile, &uBinarySizeInBytes, sizeof(u_int));

	// Create a buffer for our binary (I'm hoping this isn't going to cause fragmentation when we go and create our effect, but I'm not entirely convinced it won't
	char* pcBinaryData = new char[uBinarySizeInBytes];

	if (pcBinaryData)
	{
		Asura_FileAccess::ReadData(hFile, pcBinaryData, uBinarySizeInBytes);

		Asura_Direct3D_Effect* pxEffect = Asura_Direct3D_Effects_System::LoadEffectFromMemory(uHashID, pcBinaryData, uBinarySizeInBytes );
		if (uHashID == Asura_GetHashID("Shared"))
		{
			Asura_Direct3D_Effects_System::SetSharedEffect(pxEffect);
		}

		// Delete our buffer
		delete[] pcBinaryData;
	}
	else
	{
		// I guess we didn't have enough memory for our effect binary. Oops.
		Asura_Assert(false, "Failed to load shader from chunk");
		Asura_FileAccess::SkipData(hFile, uBinarySizeInBytes);
	}

	return true;
}
