//*******************************************************************
//
// File: Asura_SEH_Handler.h              
//
// Created: 10 Jan 2006
//
// Description: 
//
//*******************************************************************

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _ASURA_SEH_HANDLER_H_
#define _ASURA_SEH_HANDLER_H_

#if defined( ASURA_ENABLE_SEH_HANDLING)

// other libraries
#include "Dbghelp.h"

// internal dependencies

// forward declarations

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Class Definitions
//*******************************************************************

class Asura_PC_SEH_Handler
{
public:
	static DWORD ProcessException( EXCEPTION_POINTERS * const pxExceptionPointers);
	static HANDLE GetProcess( void);
	static void SetProcess( const HANDLE xProcess);
	
	static const char* const GetReportTXT();
	static void AddToReportTXT( const char* const szText);
	
#if defined( ASURA_TOOLS)
	static const char* const GetReportXML();
	static void AddToReportXML( const char* const szText);
#endif
	
private:
	static bool GetFunctionInfo( const DWORD_PTR& iAddress );
	static bool GetStack( const EXCEPTION_POINTERS* pxExceptionPointers);

private:
	static char s_szReportTXT[];
#if defined( ASURA_TOOLS)
	static char s_szReportXML[];
#endif
	static HANDLE s_xProcessHandle;
};



//*******************************************************************
// Inline Function Definitions
//*******************************************************************


//*******************************************************************
//
// (c) 2006 Rebellion (Derby)
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif //defined( ASURA_ENABLE_SEH_HANDLING)

#endif // _ASURA_SEH_HANDLER_H_
