//////////////////////////////////////////////////////////////////////////////////////////
//
//  FILE        :  Asura_Platform_Time_System.cpp
//
//  CREATED     :  Adam A. Brown  (12.1.2004)
//
//  Copyright (C) 2004 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////


#include "Core/Asura.h"

// This file's header.
#include "Core/Asura_Time_System.h"

#include <time.h>

//------------------------------------------------------------------------------
////////////////////////////////////////////////////////////////////////////////
//
// Asura_Time_System
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
//
// Platform_GetCurrentDateAndTime
//
////////////////////////////////////////////////////////////////////////////////
void Asura_Time_System::Platform_GetCurrentDateAndTime()
{
	SYSTEMTIME xST;

	GetLocalTime(&xST);	

	s_xTime.m_ucSecond = static_cast<u_char>(xST.wSecond);
	s_xTime.m_ucMinute = static_cast<u_char>(xST.wMinute);
	s_xTime.m_ucHour = static_cast<u_char>(xST.wHour);
	s_xTime.m_ucDayOfWeek = static_cast<u_char>(xST.wDayOfWeek);
	s_xTime.m_ucDayOfMonth = static_cast<u_char>(xST.wDay-1);		//Asura dates are zero-based.
	s_xTime.m_ucMonth = static_cast<u_char>(xST.wMonth-1);		
	s_xTime.m_usYear = static_cast<u_short>(xST.wYear);
}

// in minutes, where UTC = local time + bias 
int Asura_Time_System::Platform_GetTimeZoneBias()
{
	TIME_ZONE_INFORMATION xTZ;
	GetTimeZoneInformation( &xTZ );
	return xTZ.Bias;
}

//------------------------------------------------------------------------------
////////////////////////////////////////////////////////////////////////////////
//
// Asura_Time
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
//
// Platform_FillFromLibCTime
//
////////////////////////////////////////////////////////////////////////////////

void Asura_Time::Platform_FillFromLibCTime(u_int uLibCTime)
{
	time_t xTimeT = uLibCTime;
	const tm* pxLibCTimeBlock = gmtime(&xTimeT);
	m_usYear		= static_cast< u_short >( pxLibCTimeBlock->tm_year + 1900 );
	m_ucMonth		= static_cast< u_char  >( pxLibCTimeBlock->tm_mon );
	m_ucDayOfMonth	= static_cast< u_char  >( pxLibCTimeBlock->tm_mday - 1 );
	m_ucHour		= static_cast< u_char  >( pxLibCTimeBlock->tm_hour );
	m_ucMinute		= static_cast< u_char  >( pxLibCTimeBlock->tm_min );
	m_ucSecond		= static_cast< u_char  >( pxLibCTimeBlock->tm_sec );
}
