//*******************************************************************
//
// File: Asura_PlatformFSFX_Bloom.cpp        
//
// Created: 2 Mar 2006
//
// Description: 
//
//*******************************************************************

// system libraries
#include "Core/Asura.h"

#if defined( ASURA_USE_FSFX)


// main header
#include "FSFX/Asura_FSFX_Component.h"
#include "FSFX/Asura_FSFX_System.h"
#include "FSFX/Asura_FSFX_Template.h"

#include "Rendering/Asura_Direct3D_BackBufferCapture.h"
#include "Rendering/Asura_ViewPort.h"
#include "Rendering/Asura_Render.h"


// other libraries
#include "SpecialFX/Asura_Glow_System.h"

// internal dependencies

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Local Classes
//*******************************************************************


//*******************************************************************
// Function Definitions
//*******************************************************************

/*
	Platform renderer for the effect
*/
void Asura_FSFX_Component_Bloom::Platform_Render( const float fIntensity )
{
	SCOPEDPIXEVENT(( 0xFFE0D0C0, L"FSFX: Bloom" ));

	const Asura_RGBA xGlowTintOld = Asura_Glow_System::GetGlowTint();
	const float fGlowLevelOld = Asura_Glow_System::GetGlowLevel();
	
	//Asura_Glow_System::Platform_Render( 0.5f, 0.5f, 0.5f, 0.5f);

	Asura_RGBA xBloomTint( this->m_fIntensityR / 100.0f, this->m_fIntensityG / 100.0f, this->m_fIntensityB / 100.0f, 1.0f);
	xBloomTint *= fIntensity;
	Asura_Glow_System::SetGlowTint( xBloomTint);
	Asura_Glow_System::SetGlowLevel( this->m_fThreshold / 100.0f);
	
	Asura_Glow_System::Render();
	
	Asura_Glow_System::SetGlowTint( xGlowTintOld);
	Asura_Glow_System::SetGlowLevel( fGlowLevelOld);

	Asura_Direct3D_BackBufferCapture::AdviseNextFrame();
}

//*******************************************************************
//
// (c) 2006 Rebellion (Derby)
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif //defined( ASURA_USE_FSFX)
