//
// Asura_Platform_NetSocket.h
//
// PC version
//
// Created by MH - 19.07.2004
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_PLATFORM_NETSOCKET_H__
#define __ASURA_PLATFORM_NETSOCKET_H__

#include <winsock2.h>

#ifdef ASURA_PC_SUPPORT_STEAMWORKS
#include "steam/steam_api.h"
#endif

// On the Xbox, use the VDP protocol which allows for combined game and voice data
// (game data is sent encrypted, voice unencrypted)
// On other platforms, we will want to use IPPROTO_UDP
#define ASURA_NETSOCKET_PROTOCOL IPPROTO_UDP
#define ASURA_QOSSOCKET_PROTOCOL IPPROTO_UDP

// On PC use the UDP datagram socket type.
#define ASURA_QOSSOCKET_SOCKETTYPE	SOCK_DGRAM

// Specify a virtual port for the QoS socket under Steamworks.
// Note: The lobby socket currently defaults to using vport 0.
#define ASURA_PC_STEAMWORKS_QOSSOCKET_VPORT						(2)
#define ASURA_PC_STEAMWORKS_DEFAULT_VPORT						(3)

// On XBox the IP+VDP header size ranges from 44 to 51, so say 48 on average.
// On PC/PS2 IP+UDP header size is 28 bytes
#define ASURA_NETSOCKET_PROTOCOL_PACKETHEADERSIZE (28)

// 3658 is the IANA-registered PS2 port. 1000 should be used by Xbox as it gives the smallest packet header.
// On PC it doesn't matter, but we might as well use the PS2 one so we can easily do PC vs PS2 games.
#define ASURA_NETSOCKET_DEFAULTPORT (3658)

struct  Asura_NetAddress
{
	Asura_NetAddress(unsigned int uAddress = 0U);
	bool operator ==(const Asura_NetAddress& other) const;

	u_int m_uAddress;
	#ifdef ASURA_PC_SUPPORT_STEAMWORKS
	CSteamID m_xSteamID;
	#endif
};

#endif//__ASURA_PLATFORM_NETSOCKET_H__
