///////////////////////////////////////////////////////////////////////////////
//
// File: Asura_PC_SteamworksQosSocket.h
//
// Created by Martin G.Harris (23/4/2009)
// 
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ASURA_PC_STEAMWORKSQOSSOCKET_H__
#define ASURA_PC_STEAMWORKSQOSSOCKET_H__ 1

#ifdef ASURA_ENABLE_QOS_SYSTEM

// Includes
#include "Network/Asura_Qos_System.h"

////////////////////////////////
// Asura_QosSocket_Steamworks //
////////////////////////////////
class Asura_QosSocket_Steamworks : public Asura_QosSocket
{
protected:
	Asura_QosSocket_Steamworks();

public:
	virtual ~Asura_QosSocket_Steamworks();

protected:
	u_short m_usLocalPort;
};

///////////////////////////////////////
// Asura_QosSocket_Steamworks_Server //
///////////////////////////////////////
class Asura_QosSocket_Steamworks_Server : public Asura_QosSocket_Steamworks
{
public:
	Asura_QosSocket_Steamworks_Server();
	virtual ~Asura_QosSocket_Steamworks_Server();

	virtual void CreateSocket(Asura_Qos_Listener* pxListener, u_short usLocalPort);
	virtual void CloseSocket();
	virtual bool SendTo(const Asura_Qos_NetConnection* pxDestination, const char* pcData, int iDataLength);
	virtual bool Receive(Asura_Qos_Listener* pxListener, u_int uWaitTimeSeconds = 0);

protected:
	SNetListenSocket_t m_xListenSocket;

private:
//	STEAM_CALLBACK( Asura_QosSocket_Steamworks_Server, OnSocketStatusCallback, SocketStatusCallback_t, m_pfnCallbackSocketStatus );
};

///////////////////////////////////////
// Asura_QosSocket_Steamworks_Client //
///////////////////////////////////////
class Asura_QosSocket_Steamworks_Client : public Asura_QosSocket_Steamworks
{
public:
	Asura_QosSocket_Steamworks_Client();
	virtual ~Asura_QosSocket_Steamworks_Client();

	virtual void CreateSocket(Asura_Qos_Listener* pxListener, u_short usLocalPort);
	virtual void CloseSocket();
	virtual bool SendTo(const Asura_Qos_NetConnection* pxDestination, const char* pcData, int iDataLength);
	virtual bool Receive(Asura_Qos_Listener* pxListener, u_int uWaitTimeSeconds = 0);

	// Return true if any low-level handshaking is finished.
	virtual bool IsReady() const;

protected:
	SNetSocket_t m_xSocket;

	Asura_NetAddress m_xRemoteAddress;	// Remote address IPv4
	u_short m_usRemotePort;				// Remote port

//	STEAM_CALLBACK( Asura_QosSocket_Steamworks_Client, OnSocketStatusCallback, SocketStatusCallback_t, m_pfnCallbackSocketStatus );
};



#endif //#ifdef ASURA_ENABLE_QOS_SYSTEM


#endif //ASURA_PC_STEAMWORKSQOSSOCKET_H__

