
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_PSP_SCEUtility_LoadListHandler.h
// Author : Andy Tate
// Date   : 6-Oct-2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_PSP_SCEUTILITY_LOADLISTHANDLER_H__
#define __ASURA_PSP_SCEUTILITY_LOADLISTHANDLER_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "PSPEmul/SCEUtility/Asura_PSP_SCEUtility_FileListHandler.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

class Asura_PSP_SCEUtility_LoadListHandler : public Asura_PSP_SCEUtility_FileListHandler
{
public:
	// Public typedefs...

	typedef bool ValidationFunction (const void* pxData, const u_int uDataSize, const u_int uBufferSize);


	// Public functions...

	Asura_PSP_SCEUtility_LoadListHandler          (const int iMaxSaveSlots, void* pvData, const u_int uDataSize, const u_int uBufferSize, ValidationFunction* pfnValidation);
//	virtual ~Asura_PSP_SCEUtility_LoadListHandler ();

	// Virtual functions...
//	virtual	bool									Update					(bool& bCancelled);
//	virtual	void									Render					(void);


protected:
	// Protected variables...

	// Variables relating to the data to be saved...
	void*				m_pvData;
	u_int				m_uDataSize;
	u_int				m_uBufferSize;

	// The validation function to be called upon successful load...
	ValidationFunction*	m_pfnValidation;


	// Protected functions...

	// Virtual functions...
			bool									OnSelect				(Asura_PSP_SCEUtility_FileData& xFileData);

//	virtual void									RenderTitle				(const float fScreenScale) const;
//	virtual void									RenderNoSlotsMessage	(const float fScreenScale) const;
//	virtual	void									RenderSlot				(const float fScreenScale, const Asura_PSP_SCEUtility_FileData& xFileData) const;
	virtual	void									RenderEmptySlot			(const float fScreenScale, const Asura_PSP_SCEUtility_FileData& xFileData) const;


private:
	// Private variables...


	// Private functions...

	Asura_PSP_SCEUtility_LoadListHandler  (void);
	Asura_PSP_SCEUtility_LoadListHandler  (const Asura_PSP_SCEUtility_LoadListHandler& xOther);

			Asura_PSP_SCEUtility_LoadListHandler&	operator=				(const Asura_PSP_SCEUtility_LoadListHandler& xOther);

};   // End of class 'Asura_PSP_SCEUtility_LoadListHandler'.


#endif   // ifndef __ASURA_PSP_SCEUTILITY_LOADLISTHANDLER_H__


/// End of file. ///
