//
// Asura_Direct3D_Fog.h
//
// Created by RJF - 18 August 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_DIRECT3D_FOG_H__
#define __ASURA_DIRECT3D_FOG_H__

#include "Rendering/Asura_Direct3D.h"

class Asura_Direct3D_Effect;
class Asura_Direct3D_EffectParameterBlock;


class Asura_Direct3D_Fog
{
public:
	static void Initialise();
	static void Shutdown();
	static void Reset();

	static void UpdateForNewParameters();
	static void Render();

	static Direct3D_Texture* GetTexture() { return s_pxFogTexture; }

private:

	static Asura_Direct3D_EffectParameterBlock* s_pxParamBlock;
	static Asura_Direct3D_Effect* s_pxEffect;
	static Direct3D_Texture* s_pxFogTexture;
};





class Asura_Direct3D_FogEffectParameters
{
public:
	Asura_Direct3D_FogEffectParameters() {m_pxEffect = NULL;}

	void Apply(bool bEnabled, ASURA_TRANSLUCENCY_MODE eTranslucency);
	void Capture(Asura_Direct3D_Effect *pxEffect);

private:
	Asura_Direct3D_Effect *m_pxEffect;

	D3DXHANDLE m_xFogEnabledHandle;
	D3DXHANDLE m_xTextureHandle;
	D3DXHANDLE m_xFogParamsHandle;
	D3DXHANDLE m_xColourHandle;
};


#endif//__ASURA_DIRECT3D_FOG_H__