#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_DIRECT3D_MRPSHADERCOMPILE_H__
#define __ASURA_DIRECT3D_MRPSHADERCOMPILE_H__

#if defined(ASURA_USE_MATERIAL_RESPONSE_SYSTEM)
#if ((ASURA_LOAD_EFFECT_FILES == 1) && !defined( ASURA_NO_LOAD_EFFECTS_FILES_FROM_FILES)) || defined(ASURA_TOOLS)

#include "Core/Asura_MemoryManagement_DebugOff.h"
#include <d3dx9.h>
#include "Core/Asura_MemoryManagement_DebugOn.h"

#include <windows.h>
#include "Core/Asura_Hashtree.h"


class Asura_Direct3D_MRPShaderCompile
{
	static void SetPercentageBits( const float fValue, Asura_Hash_ID& uHash, u_int& uBit );
	static Asura_TemplateHashTree< ID3DXBuffer* > s_xShaderTree;
	static bool s_bLoadShadersFromFile;

	static void RecompileShadersTraverseFunction(Asura_Hash_ID uHash, struct ID3DXBuffer** pxData);
	static bool Asura_Direct3D_MRPShaderCompile::RecompileShaders(void* pvContext);

public:
	static bool GetLoadShadersFromFile( ) { return s_bLoadShadersFromFile;}

	static void SetLoadShadersFromFile( bool bLoadShadersFromFile );


	static bool GetMRPSMacrosFromHash( const Asura_Hash_ID uHash, D3DXMACRO* const pxMacros, bool& bSkin, bool& bDeferred );

#ifdef ASURA_TOOLS
	static void AddMRPShader( const Asura_Hash_ID uHash, const Asura_Hash_ID uMaterial1, const Asura_Hash_ID uMaterial2 );
#endif

	static void AddMRPShader( Asura_Hash_ID uHash, void **ppData, u_int *puShaderSize );

	static void ResetLoadedShaderList() { 	s_xShaderTree.Reset(); }

	static ID3DXBuffer* CompileMRPShader( const D3DXMACRO* const pxMacros, const bool bSkin, const bool bDeferred );

	static int GetNumShaders() { return s_xShaderTree.GetNumberOfNodes();}
	static Asura_TemplateHashTree< ID3DXBuffer* > &GetShaderTree() { return s_xShaderTree;}

};
#endif
#endif
#endif