//////////////////////////////////////////////////////////////////////////////////////////
//
//  FILE        :  Asura_Direct3D_ShadowBuffer_DepthTexture.h
//
//  CREATED     :  Richard J. Fine  (16.11.2004)
//
//  Copyright (C) 2004 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_DIRECT3D_SHADOWBUFFER_DEPTHTEXTURE_H__
#define __ASURA_DIRECT3D_SHADOWBUFFER_DEPTHTEXTURE_H__

#include "Rendering/Asura_Direct3D_ShadowBuffer.h"

class Asura_Direct3D_ShadowBufferStrategy_DepthTexture : public Asura_Direct3D_ShadowBufferStrategy
{

public:

	Direct3D_Texture* m_pxDepthTexture;
	Direct3D_Surface* m_pxDepthSurface;
	Direct3D_Texture* m_pxDummyColourRTTexture;
	Direct3D_Surface* m_pxDummyColourRT;

	Direct3D_Surface* m_pxOldRT;
	Direct3D_Surface* m_pxOldDS;

	Direct3D_BaseTexture* m_pxOldTexture;

	/*DWORD m_uOldAlphaBlend;
	DWORD m_uOldSrcBlend;
	DWORD m_uOldDestBlend;*/

	Asura_Direct3D_ShadowBufferStrategy_DepthTexture(Asura_Direct3D_ShadowBuffer* pxParent);
	~Asura_Direct3D_ShadowBufferStrategy_DepthTexture();

	void CreateResources();
	void ReleaseResources();
	void Clean();
	void BeginCollectingShadows();
	void EndCollectingShadows();
	void BeginRenderingShadows();
	void EndRenderingShadows();

	static bool IsSupported();

	float GetZScale();
};

#endif//__ASURA_DIRECT3D_SHADOWBUFFER_DEPTHTEXTURE_H__
