//////////////////////////////////////////////////////////////////////////////////////////
//
//  FILE        :  Asura_Direct3D_Utilities.h
//
//  CREATED     :  Richard J. Fine  (11.11.2004)
//
//  Copyright (C) 2004 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_DIRECT3D_UTILITIES_H__
#define __ASURA_DIRECT3D_UTILITIES_H__

#include "Rendering/Asura_Direct3D.h"

// Utility functions and classes for using Direct3D
// Be warned that some only exist in assert-enabled builds
// If you use them, it is your responsibility to surround your code with #ifdefs

#ifdef ASURA_ASSERT

class Asura_Direct3D_StateString
{
public:
	// D3DRENDERSTATETYPE lists a max render state ID of 209
	enum { NUMBER_OF_STATES = 210 };

private:
	static char szString[NUMBER_OF_STATES+1];

public:
	static void MakeString();
	static const char* GetString() { return szString; }
	static void WriteToDebugger();
	static void WriteCurrentStates() { MakeString(); WriteToDebugger(); }

};

class Asura_Direct3D_StateFreeze
{
	Asura_Direct3D_StateString initial;
public:
	void BeginFreeze()
	{
		initial.MakeString();
	}
	
	// MH (14.06.05) - VS.NET was complaining that final was unused in function below so I added this.
	void ForceUseToFixWarning(class Asura_Direct3D_StateString&) {}
	void CheckFreeze()
	{
		Asura_Direct3D_StateString final; 
		ForceUseToFixWarning(final);
		final.MakeString();
		const char* i=initial.GetString();
		const char* f=final.GetString();
		for(u_int u = 0; u < Asura_Direct3D_StateString::NUMBER_OF_STATES; ++u)
		{
			Asura_Assert(i[u] == f[u], "State freeze failed");
		}
	}
};

#endif

#endif//__ASURA_DIRECT3D_UTILITIES_H__
