//	
//	Asura_PlatformRenderGlass.h
//	
//	Created by Pete Ellacott - 28/11/2002
//	
//	Copyright (C) 2002 Rebellion, All Rights Reserved.
//	
//	PC Glass rendering implementation
//	

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#include "Entity/Glass/Asura_ClientEntity_Glass.h"

#include "Camera/Asura_Camera.h"
#include "Rendering/Asura_Render.h"

// P R O T O T Y P E S ///////////////////////////////////////////////////////

extern void Render_Rectangle( const Asura_WorldSpace_Rectangle& xRect, u_int uColour, int iTexIdx, const float* pfUs, const float* pfVs, bool bWireframe );

// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

void Asura_ClientEntity_Glass::Platform_Render( unsigned uCamVisFlags )
{
	extern void Render_Rectangle( const Asura_WorldSpace_Rectangle& xRect, u_int uColour, int iTexIdx, const float* pfUs, const float* pfVs, bool bWireframe = false );

	for(int i=0; i<Asura_Camera::GetNumberOfCameras(); i++)
	{
		if (uCamVisFlags & (1 << i))
		{
			Asura_Camera::SetCameraIndex(i);

			Asura_Render::ApplyCameraSettings();

			Render_Rectangle( m_xPane, m_uColour, m_iTextureIndex, m_afU, m_afV );

		}
	}
}

