//
// Asura_Platform_SortedRender.cpp
//
// Created by Richard Rice - 30/06/2003
// 
// Copyright (C) 2003 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"
#include "Rendering/Asura_SortedRender.h"

// Asura PC
#include "Rendering/Asura_Direct3D.h"
#include "Rendering/Asura_Direct3D_SkinRenderer.h"

void Asura_SortedRender::Platform_BeginRender(void)
{
	#if defined ASURA_D3D_ENABLE_PIX

		const wchar_t* const wszName =

			#if defined ASURA_TARGET_SM3
				s_bTransparentPass ? L"Sorted Render (Transparent)" : L"Sorted Render (Opaque)";
			#else
				L"Sorted Render";
			#endif

	#endif

#if defined(ASURA_TARGET_SM3)
	Asura_Direct3D_SkinRenderer::ResetCount();
#endif

	D3DPERFCALL(BeginEvent(D3DCOLOR_XRGB(0xFF, 0xFF, 0xFF), wszName));
}

void Asura_SortedRender::Platform_EndRender(void)
{
	D3DPERFCALL(EndEvent());
}

u_int Asura_SortedRenderItem::Platform_GetSortBias( void ) const
{
    return m_eType;
}
