//////////////////////////////////////////////////////////////////////////////////////////
//
//  FILE        :  Asura_D3D_PS_Environment_Reflective.cpp
//
//  CREATED     :  Richard J. Fine  (30.3.2005)
//
//  Copyright (C) 2005 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////


#include "Core/Asura.h"

// This file's header.
#include "Rendering/Asura_Direct3D_Shaders.h"

static const char* g_szShaderCode =
{
	"ps.1.1				\n"
	"tex t0				\n"	// base texture
	"tex t1				\n" // reflection map

	"mov r0.rgb, t1 \n"
	"+mov r0.a, t0.a \n"
};

static Asura_Direct3D_PixelShader xReflectiveShader(ASURA_D3D_PS_ENVIRONMENT_REFLECTIVE, g_szShaderCode);

static const char* g_szNormalShaderCode =
{
"sampler sDiffuse1 : register( s0);	\n"	
"sampler sReflection1 : register( s1);	\n"	
"sampler sNormal1 : register( s2);	\n"	
"	\n"	
"struct PS_INPUT_20	\n"	
"{	\n"	
"	float2 uvTexCoord1 : TEXCOORD0;	\n"	
"	float3 uvwViewDirection	: TEXCOORD1;	\n"	
"	float4 xyzwScreenAxisX	: TEXCOORD2;	\n"	
"	float4 xyzwScreenAxisY	: TEXCOORD3;	\n"	
"};	\n"
"	\n"	
"struct PS_OUTPUT_20	\n"	
"{	\n"	
"	half4 cColour0	: COLOR0;	\n"	
"};	\n"	
"	\n"	
"PS_OUTPUT_20 main_Reflect_Normal( const PS_INPUT_20 xInput)	\n"	
"{	\n"	
"	half4 cDiffuseTexture = tex2D( sDiffuse1, xInput.uvTexCoord1); \n"
"	half4 cNormalTexture = tex2D( sNormal1, xInput.uvTexCoord1); \n"	
"	\n"	
"	half3 vView = normalize( xInput.uvwViewDirection.xyz);	\n"	
"	half3 vNormal = normalize( (2.0 * cNormalTexture.xyz) - 1.0);	\n"	
//"	half3 vNormal = {0, 0, 1};	\n"	
"	\n"	
"	half hNdotV = dot( vNormal.xyz, vView.xyz);	\n"	
"	\n"	
//"	half3 vReflection = normalize( (vNormal*2*hNdotV) - vView);	\n"	
"	half4 vReflection;	\n"	
"	vReflection.xyz = normalize( (vNormal.xyz*2*hNdotV) - vView.xyz);	\n"	
//"	vReflection.xyz = vView;	\n"	
"	vReflection.w = 1.0;	\n"	
"	\n"	
"	half hNdotR = dot( vNormal.xyz, vReflection.xyz);	\n"	
"	\n"	
"	half2 uvReflectionCoord1;	\n"
"	uvReflectionCoord1.x = dot( vReflection, xInput.xyzwScreenAxisX);	\n"	
"	uvReflectionCoord1.y = dot( vReflection, xInput.xyzwScreenAxisY);	\n"	
"	\n"	
"	half4 cReflectionTexture = tex2D( sReflection1, uvReflectionCoord1); \n"	
"	\n"	
"	half3 cColour = cReflectionTexture.xyz;	\n"	
"	\n"	
"	PS_OUTPUT_20 xOutput;	\n"	
"	\n"	
"	xOutput.cColour0.rgb = cColour;	\n"	
"	xOutput.cColour0.a = cDiffuseTexture.a;		\n"	
"	\n"	
//"	xOutput.cColour0.rgb = (0.5 * hNdotR) + 0.5;	\n"	
"	\n"	
"	return( xOutput);	\n"	
"	\n"	
"}	\n"

};

static Asura_Direct3D_PixelShader xReflectiveNormalShader(ASURA_D3D_PS_ENVIRONMENT_REFLECTIVE_NORMAL, g_szNormalShaderCode,
	2.0, ASURA_D3D_PS_CODE_TYPE_HLSL, "main_Reflect_Normal");
