//
// Asura_D3D_PS_Glow.cpp
//
// Created by RJF - 14 September 2004
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

// This file's header.
#include "Rendering/Asura_Direct3D_Shaders.h"

/**
* Extract Glow shader
* Takes the rendered scene and generates a glow texture from it
**/

static const char* const g_szPS_EXTRACT_GLOW_CODE =

"ps.1.1 \n"

// Expected constants:
// c0 - luminance constants
// c1 - glow scale
// c2 - glow offset

"tex t0 \n"
"dp3 r0, t0, c0 \n" // get luminance
"mad_x2 r0, r0.w, c1, c2 \n" // remap to range
"mul r1, r0, r0 \n"
"mul r0, r0, r1 \n" // cube
;

// Register the shader with Asura

const Asura_Direct3D_PixelShader g_xPS_EXTRACT_GLOW_SHADER(ASURA_D3D_PS_EXTRACTGLOW, g_szPS_EXTRACT_GLOW_CODE);

/**
* Apply Blur shader
* Takes the glow texture and renders it to the scene with blurring
**/

static const char* const g_szPS_APPLY_BLUR_CODE =

"ps.1.1 \n"

// Expecting constants:
// c0-c3	Blend weights for the 4 neighbor samples

"tex t0 \n"
"tex t1 \n"
"tex t2 \n"
"tex t3 \n"

"mul r0, t0, c0 \n"
"mad r0, t1, c1, r0 \n"
"mad r0, t2, c2, r0 \n"
"mad r0, t3, c3, r0 \n"
"mov r0.a, c0.a \n";			// Write out a constant alpha

//Register the shader

const Asura_Direct3D_PixelShader g_xPS_APPLY_BLUR_SHADER(ASURA_D3D_PS_APPLYBLUR, g_szPS_APPLY_BLUR_CODE);

