//////////////////////////////////////////////////////////////////////////////
//
// Asura_D3D_PS_Skin_SpecularSoft.cpp
//
// Created by AAM - 06/08/2004 12:25:17
//
// Copyright (c) 2004 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

#include "Core/Asura.h"

#ifdef ASURA_TOOLS

#include "Rendering/Asura_Direct3D_Shaders.h"

/******************************************************************************/
/* Constants                                                                  */
/******************************************************************************/

const char* const szCODE =
"ps.1.1 \n"

"tex t0 \n"	// Texture
"texcoord t1 \n"	// Direction to camera
"texcoord t2 \n"	// Normal

"mul_x2 r0, v0, t0 \n" // r0 = light*texture*2

"dp3_sat r1, t1_bx2, t2_bx2 \n" // r1 = N.V (texcoord clamps to [0,1])

// r1 = sat(N.V)^8 * texture alpha
"mul r1, r1, r1 \n"
"mul r1, r1, r1 \n"
"mul r1, r1, r1 \n"
"mul r1, r1, t0.a \n"

"mad r0, v0, r1, r0 \n"; // r0 (output) = light*sat(N.V)^8*texture alpha + light*texture*2

// Register the shader with Asura
const Asura_Direct3D_PixelShader xSHADER(ASURA_D3D_PS_TOOLS_SPECULARSOFT, szCODE);

#endif // #ifdef ASURA_TOOLS
