//
// Asura_D3D_VS_Object_Unlit.cpp
//
// Created by Richard Rice - 12/03/2003
// 
// Copyright (C) 2003 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

#include "Rendering/Asura_Direct3D_Shaders.h"

static DWORD ObjectUnlitVertex_Decl[] =
{
    D3DVSD_STREAM( 0 ),
    D3DVSD_REG( 0,	D3DVSDT_FLOAT3 ),
    D3DVSD_REG( 1,	D3DVSDT_FLOAT3 ),
    D3DVSD_REG( 2,	D3DVSDT_FLOAT2 ),
   
	D3DVSD_END()
};

// Expected constants:
//     c0    obj->screen matrix
//     c1            "
//     c2            "
//     c3            "
//     c4    colour
static char* ObjectUnlitVertexShaderCode=
{
    " vs.1.1            \n"

    // Transform to screen space and write to output position register.
    " m4x4 oPos, v0, c0 \n"

    // Copy colour to output colour register.
    " mov oD0, c4       \n"

	//and copy the texture coordinates , or whatever these are supposed to be... RAR
    " mov oT0.xy, v2    \n"
};

static Asura_Direct3D_VertexShader Shader(ASURA_D3D_VS_OBJECTUNLIT,ObjectUnlitVertexShaderCode, ObjectUnlitVertex_Decl);
