//
// Asura_D3D_VS_Outliner.cpp
//
// Created by SB - 07 November 2006
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//

#if defined(ASURA_USE_LINE_RENDERING)

#include "Core/Asura.h"

// This file's header.
#include "Rendering/Asura_Direct3D_Shaders.h"

// Vertex format
static Direct3D_VertexElement g_axVertexDeclOutline[] =
{
	{ 0,  0,	D3DDECLTYPE_FLOAT3,	D3DDECLMETHOD_DEFAULT,	D3DDECLUSAGE_POSITION,	0 },
	{ 0, 12,	D3DDECLTYPE_FLOAT2,	D3DDECLMETHOD_DEFAULT,	D3DDECLUSAGE_TEXCOORD,	0 },
	D3DDECL_END()
};

static Asura_Direct3D_VertexShader xOutlinerVertexShader(
	ASURA_D3D_VS_OUTLINE,

	"struct VS_OUTPUT\n"
	"{\n"
	"	float4 Position : POSITION0;\n"
	"	float2 Texcoord0 : TEXCOORD0;\n"
	"};\n"
	
	"VS_OUTPUT main(float4 Pos : POSITION0, float2 Texcoord : TEXCOORD0)\n"
	"{\n"
	"	VS_OUTPUT Out;\n"
	
	"	Out.Position = float4(Pos.x, Pos.y, 0.0f, 1.0f);\n"
	
	"	Out.Texcoord0 = Texcoord;\n"
	
	"	return Out;\n"
	"}\n"
	,

	g_axVertexDeclOutline,
	2.0f,
	ASURA_D3D_VS_CODE_TYPE_HLSL,
	"main"
);

#endif
