//////////////////////////////////////////////////////////////////////////////////////////
//
//  FILE        :  Asura_D3D_VS_PFX_HeatHaze.cpp
//
//  CREATED     :  Richard J. Fine  (5.11.2004)
//
//  Copyright (C) 2004 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////


#include "Core/Asura.h"


// This file's header.
#include "Rendering/Asura_Direct3D_Shaders.h"

// Vertex Declarator
// (for D3DGenericVertex structure)

static Direct3D_VertexElement auVSD[] =
{
	{	0,	0,	D3DDECLTYPE_FLOAT3,		D3DDECLMETHOD_DEFAULT,	D3DDECLUSAGE_POSITION,	0 },
	{	0, 12,	D3DDECLTYPE_FLOAT3,		D3DDECLMETHOD_DEFAULT,	D3DDECLUSAGE_NORMAL,	0 },
	{	0, 24,	D3DDECLTYPE_D3DCOLOR,	D3DDECLMETHOD_DEFAULT,	D3DDECLUSAGE_COLOR,		0 },
	{	0, 28,	D3DDECLTYPE_FLOAT2,		D3DDECLMETHOD_DEFAULT,	D3DDECLUSAGE_TEXCOORD,	0 },
	{	0, 36,	D3DDECLTYPE_FLOAT2,		D3DDECLMETHOD_DEFAULT,	D3DDECLUSAGE_TEXCOORD,	1 },
	D3DDECL_END()
};

const char* const szVS_PFX_HEATHAZE_PARTICLE_CODE =

// Expected constants
//   c0-c3 : ViewProj matrix
//   c4: 1/2, 1/fadeDist
//	 c5: bump scale x, bump scale y, bump offset x, bump offset y

"vs.1.1 \n"
"dcl_position0	v0 \n"
"dcl_color0		v1 \n"
"dcl_texcoord0	v2 \n"

// Position
"m4x4 r0, v0, c0 \n"

// Diffuse
"mov oD0, v1 \n"
"mad r1.x, r0.w, c4.y, c4.w \n"
"mul oD0.w, r1.x, v1.w \n"

// Texcoords
"mov oT0, v2 \n"

// oPos is in projection space - -w<=x<=w, -w<=y<=w, 0<=z<=w
"mov oPos, r0 \n"

// calculate 1/w into r1.x
"rcp r1.x, r0.w \n"

// map x,y to the -1,1 range into r0.xy by multiplying by 1/w
"mul r0.xy, r0.xy, r1.xx \n"
// map from [-1..1, -1..1] to [0..1, 1..0]
"mad r0.xy, r0.xy, c4.xz, c4.xx \n"
// move result into T2 for backbuffer sampling
"mov oT2.xy, r0.xy \n"
// Scale/offset result for heat haze sampling
"mad oT1.xy, r0.xy, c5.xy, c5.zw \n";

// Register the shader
const Asura_Direct3D_VertexShader xVS_PFX_HEATHAZE_SHADER(ASURA_D3D_VS_PFX_HEATHAZE, szVS_PFX_HEATHAZE_PARTICLE_CODE, auVSD);

