/******************************************************************************/
/* Parameters                                                                 */
/******************************************************************************/

bool   g_bFogEnabled : register( ps, b2 );
float2 g_xFogParams : register( ps, c6 ); // (fog near plane, 1 / (fog far plane - fog near plane))

// Fog colour comes after light info, since additive strips need to set it to black
float4 g_xFogColour : register( ps, c133 );

texture g_xFogTexture;
sampler g_xFogTextureSampler : register( ps, s1 ) = sampler_state
{
	Texture   = <g_xFogTexture>;
	AddressU  = CLAMP;
	AddressV  = CLAMP;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};

/******************************************************************************/
/* Functions                                                                  */
/******************************************************************************/

float4 ApplyFog( float4 xColour, float fDepth )
{
	if( g_bFogEnabled )
	{
		// Fog it
		float2 fLookup;
		fLookup.x = (fDepth - g_xFogParams.x) * g_xFogParams.y;
		fLookup.y = 0;

		const float4 fFogTextureColour = tex2D( g_xFogTextureSampler, fLookup );

		xColour.rgb = lerp( xColour.rgb, g_xFogColour.rgb, fFogTextureColour.a );
	}

	return xColour;
}