
//------------------------------------
#include "Shared.fxh"

const float4x4 g_xWorldViewProjectionMatrix;

//------------------------------------
struct VS_Input
{
	float4	xPosition					: POSITION0;
};

struct VS_Output
{
    float4	xPosition					: POSITION0;
    float   fLightspaceDistance			: TEXCOORD0;
};

//------------------------------------
VS_Output VShader(VS_Input IN)
{
	VS_Output	OUT;

    OUT.xPosition	= mul(IN.xPosition, g_xWorldViewProjectionMatrix);
    OUT.fLightspaceDistance = (OUT.xPosition.w - g_fShadowFrustumNearPlaneDistance) * g_fOneOverShadowFrustumPlaneSeparation;
    
    return	(OUT);
}

//------------------------------------
float4 PShader( const VS_Output xIn ) : COLOR
{
	return xIn.fLightspaceDistance.xxxx;
}

//-----------------------------------
technique Object_TextureAndLight_NormalMap
{
    pass p0
    {
//		Cullmode		= CW;
		VertexShader	= compile vs_3_0 VShader();
		PixelShader		= compile ps_3_0 PShader();
    }
}
