/////////////////////////////////////////////////////////////////////////////////////////
//
//	FILE:			Asura_Platform_Shape.h
//
//	AUTHOR:			Richard M. Smith (8 August 2002)
//
/////////////////////////////////////////////////////////////////////////////////////////


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PLATFORM_SHAPE_H__
#define ___ASURA_PLATFORM_SHAPE_H__ 1



//////////////
// INCLUDES //
//////////////
#include <stdlib.h>


/////////////
// DEFINES //
/////////////



struct MY_TEMP_FILENAME
{
    char m_szFilename[Asura_Shape_RenderData::NAME_BUFFER_SIZE];
};

/////////////
// CLASSES //
/////////////

class Asura_Mesh;

class Asura_Platform_Shape_RenderData : public Asura_Shape_RenderData
{
public:

// Constructor and destructor
	Asura_Platform_Shape_RenderData( const char* szFilename, const char* szMeshName );
	Asura_Platform_Shape_RenderData( const char*& pcChunkBuffer );
	Asura_Platform_Shape_RenderData( Asura_Mesh* pxMesh );
	virtual ~Asura_Platform_Shape_RenderData(){};
	
// Render
	void Render( const Asura_Vector_3& xPos, const Asura_Matrix_3x3& xOri, const unsigned int uAmbientRGBA, unsigned int uFlags = 0, const unsigned uCamVisFlags = 0xffffffff );


// Saving
	int GetChunkBufferSize( void );
	void FillInChunkBuffer( char*& pcChunkBuffer );

	void Load( Asura_Hash_ID uShapeHash );
	
#ifdef ASURA_TOOLS
// Rebuilding the Tools_Shape_Table (PC Only)
	void GetShapeFilename( char* szString, unsigned int uMaxLen );
	void GetShapeName( char* szString, unsigned int uMaxLen );

	Asura_Mesh*	GetMesh( void )
	{
		return m_pxTheMesh;
	}

	static bool IsShapeLoading( void )
	{
		return s_bLoadingShape;
	}

#endif ASURA_TOOLS

	//Used to update the fragment data in the Asura_Shape
	void GetFragmentHashFromMesh(Asura_Hash_ID& xOutputHash) const;

	int GetTextureIndex() const;
	short GetMaterialIndex() const;

private:

	Asura_Mesh*			m_pxTheMesh;
	MY_TEMP_FILENAME	m_xFilename;

	static bool			s_bLoadingShape;
};



#endif ___ASURA_PLATFORM_SHAPE_H__





////////////////////////////////////// End of file //////////////////////////////////////
