//////////////////////////////////////////////////////////////////////////////
//
// Asura_PC_ReplaceableSounds.h
//
// Created by AAM - 07/01/2004 12:41:17
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#if !defined __ASURA_PC_REPLACEABLESOUNDS_H__
#define __ASURA_PC_REPLACEABLESOUNDS_H__

#if !defined(ASURA_USE_AUDIO_SYSTEM)

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

#include "Core/Asura_PlatformBasics.h"	// MAX_PATH

/******************************************************************************/
/* Global Variables                                                           */
/******************************************************************************/

static const u_int ASURA_PC_SOUND_INVALID_BYTE_OFFSET = 0xffffffff;

/******************************************************************************/
/* Types                                                                      */
/******************************************************************************/

class Asura_PC_ReplaceableSoundData
{
public:
	Asura_PC_ReplaceableSoundData();

	u_int	m_uByteOffset;
	u_int	m_uFileSize;
	bool	m_bInMemory;

	#ifdef ASURA_TOOLS
		int m_iSoundID;
	#endif
};

class Asura_PC_ReplaceableSounds
{
protected:

	static Asura_PC_ReplaceableSoundData* s_pxReplaceableSoundData;
	static char s_szReplaceableSoundFile[MAX_PATH];

public:

	static bool Initialise( u_int uiNumEntries, const char* szFilename );
	static void Shutdown();
	static void Reset();
	static bool LoadReplaceableSound( int iLoadedSoundID );
	static bool ReplaceSound( int iExistingSoundLoadedID, int iNewSoundLoadedID );
	static bool AddReplaceableSoundInfo( int iSoundId, u_int uiByteOffset, u_int uiSize );

	#ifdef ASURA_TOOLS
		static void AddReplaceableSoundName( u_int uByteOffset, const char* pszFilename );
	#endif
};

#endif	//!defined(ASURA_USE_AUDIO_SYSTEM)

#endif // !defined __ASURA_PC_REPLACEABLESOUNDS_H__
