//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_FullScreenSFX_System.cpp
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
// Description:
//
//     PC-specific implementations of engine full screen SFX functionality.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

// Engine independent.
#include "Camera/Asura_Camera.h"
#include "Core/Asura_TextureFlags.h"
#include "Rendering/Asura_Render.h"
#include "Rendering/Asura_Viewport.h"
#include "SpecialFX/Asura_FullScreenSFX_System.h"

// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

void Asura_FullScreenSFX_System::Platform_RenderFade( u_int uARGB )
{
	const Asura_ViewingArea*	pxViewingArea	= Asura_Camera::GetViewingArea();
	const float 				fScreenWidth	= static_cast<float>(Asura_Viewport::GetWidth());
	const float 				fScreenHeight	= static_cast<float>(Asura_Viewport::GetHeight());
	const float 				fXOffset		= static_cast<float>(pxViewingArea->m_fXOffset * fScreenWidth);
	const float 				fYOffset		= static_cast<float>(pxViewingArea->m_fYOffset * fScreenHeight);
	const float 				fWidth			= static_cast<float>(pxViewingArea->m_fWidth * fScreenWidth);
	const float 				fHeight			= static_cast<float>(pxViewingArea->m_fHeight * fScreenHeight);

    Asura_Render::Overlay.Colour           = uARGB;
    Asura_Render::Overlay.TranslucencyMode = ASURA_TRANSLUCENCY_NORMAL;
    Asura_Render::Overlay.TextureIndex     = ASURA_TEXTURE_NONE;

    Asura_Render::Overlay.SetRectXY( fXOffset, fYOffset, fWidth, fHeight );
    Asura_Render::Overlay.Render();   
}

void Asura_FullScreenSFX_System::Platform_InitialiseMotionBlur()
{
}

void Asura_FullScreenSFX_System::Platform_RenderMotionBlur( u_char uMotionBlurAlpha )
{
}
