/**
*
* \file Asura_Platform_SpecialFX.cpp
*
* Created by Kevin Lea - 16/08/2002 10:44:30
*
* Copyright (C) 2002 Rebellion, All Rights Reserved.
*
* \brief
*
**/

#include "Core/Asura.h"

#include "SpecialFX/Asura_SpecialFX.h"

#include "Rendering/Asura_Direct3D.h"

void Asura_SpecialFX_System::Platform_Initialise(void)
{

}
void Asura_SpecialFX_System::Platform_Update(void)
{

}
void Asura_SpecialFX_System::Platform_BeginRender(const RenderType eRenderType)
{
	const wchar_t*	wszName;

	switch(eRenderType)
	{
		case RT_MAIN:
		{
			wszName	= L"SpecialFX (RT_MAIN)";
			break;
		}

		case RT_HUD_EFFECTS:
		{
			wszName	= L"SpecialFX (RT_HUD_EFFECTS)";
			break;
		}

		case RT_DECALS:
		{
			wszName	= L"SpecialFX (RT_DECALS)";
			break;
		}

		case RT_SKYBOX_EFFECTS:
		{
			wszName	= L"SpecialFX (RT_SKYBOX_EFFECTS)";
			break;
		}

		case RT_PROJECT_EFFECTS:
		{
			wszName	= L"SpecialFX (RT_PROJECT_EFFECTS)";
			break;
		}

		case RT_2D_EFFECTS:
		{
			wszName	= L"SpecialFX (RT_2D_EFFECTS)";
			break;
		}

#if defined(ASURA_USE_3DDECAL_SYSTEM)
		case RT_3D_DECALS_PRE_WORLD:
		{
			wszName	= L"SpecialFX (RT_3D_DECALS_PRE_WORLD)";
			break;
		}

		case RT_3D_DECALS_POST_WORLD:
		{
			wszName	= L"SpecialFX (RT_3D_DECALS_POST_WORLD()";
			break;
		}
#endif	//defined(ASURA_USE_3DDECAL_SYSTEM)

		default:
		{
			wszName	= L"SpecialFX (Unknown)";
			break;
		}
	}		// End of switch.

	D3DPERFCALL(BeginEvent(D3DCOLOR_XRGB(0xFF, 0xFF, 0xFF), wszName));
}
void Asura_SpecialFX_System::Platform_Render(void)
{
	// KJL - 15/07/2003 17:54:44 - removed old corona renderer
}
void Asura_SpecialFX_System::Platform_EndRender(const RenderType eRenderType)
{
	D3DPERFCALL(EndEvent());
}
void Asura_SpecialFX_System::Platform_Reset(void)
{

}
void Asura_SpecialFX_System::Platform_Shutdown(void)
{

}
