//******************************************************************* //
// File: Asura_Chunk_ResourceFile_PS2_Botanicals.cpp
//
// Created: 22 March 2006
//
// Description: 
//
//*******************************************************************

// system libraries
#include "Core/Asura.h"

#if defined( ASURA_USE_BOTANICALS )

#include "Core/Asura_Maths.h"
#include "Core/Asura_PlatformBasics.h"

// other libraries
#include "Botanicals/Asura_PS2_Botanicals_Store.h"
#include "ChunkSystem/Asura_Chunk_ResourceFile_PS2_Botanicals.h"
#include "Debugging/Asura_Logfile.h"

// internal dependencies

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Local Classes
//*******************************************************************


//*******************************************************************
// Function Definitions
//*******************************************************************

// The read function of the data
bool Asura_Chunk_ResourceFile_PS2_Botanicals::Process( Asura_Handle xFile )
{
	Asura_Assert( Version == ASURA_PS2_BOTANICALS_CHUNK_VERSION, "Invalid PS2 Botanicals version re-export the level" );

	// Only process latest version chunks
	if ( Version != ASURA_PS2_BOTANICALS_CHUNK_VERSION )
	{
		Asura_OutputToDebugger_Retail( ( "PS2 Botanicals Version mismatch %d re-export the level\n", Version ) );
		return false;
	}
	return Asura_PS2_Botanicals_Store::Load( xFile );
}


//*******************************************************************
//
// (c) 2006 Rebellion (Derby)
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif //defined( ASURA_USE_BOTANICALS )
