//******************************************************************* //
// File: Asura_Chunk_ResourceFile_PS2_Carpet.cpp
//
// Created: 01 March 2006
//
// Description: 
//
//*******************************************************************

// system libraries
#include "Core/Asura.h"

#if defined( ASURA_USE_CARPET)

// main header
#include "ChunkSystem/Asura_Chunk_ResourceFile_PS2_Carpet.h"

// other libraries
//#include "Core/Asura_PlatformBasics.h"
#include "Carpet/Asura_PS2_Carpet_Mesh_Shared.h"
#include "Carpet/Asura_PS2_Carpet_Mesh_Store.h"
#include "Debugging/Asura_Logfile.h"

// internal dependencies

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Local Classes
//*******************************************************************


//*******************************************************************
// Function Definitions
//*******************************************************************

// The read function of the data
bool Asura_Chunk_ResourceFile_PS2_Carpet::Process( Asura_Handle xFile )
{
	// Only process latest version chunks
	Asura_Assert( Version == ASURA_PS2_CARPET_MESH_CHUNK_VERSION, "Invalid PS2 Carpet Mesh version re-export the level" );
	if ( Version != ASURA_PS2_CARPET_MESH_CHUNK_VERSION )
	{
		Asura_OutputToDebugger_Retail( ( "PS2 Carpet Version mismatch %d re-export the level\n", Version ) );
		return false;
	}
	return Asura_PS2_Carpet_Mesh_Store::Load( xFile );
}


//*******************************************************************
//
// (c) 2006 Rebellion (Derby)
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif //defined( ASURA_USE_CARPET)
