//////////////////////////////////////////////////////////////////////////////
//
// Asura_Chunk_ResourceFile_PS2_PartiallyStreamedSounds.h
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
// Description:
//
//     none
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_CHUNK_RESOURCEFILE_PS2_PARTIALLYSTREAMEDSOUNDS_H___
#define ___ASURA_CHUNK_RESOURCEFILE_PS2_PARTIALLYSTREAMEDSOUNDS_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "ChunkSystem/Asura_Chunk_ResourceFile.h"

// D E F I N E S /////////////////////////////////////////////////////////////

//
// Version history:
//
//     (MH - 11.03.2003) -  0 - Initial version. No longer supported.
//
//     (MP - 15.05.2003) -  1 - All data in a single chunk now. This makes
//                              skipping everything except the header data
//                              easier and more efficient at runtime.
//
#define ASURA_PS2_PSS_CHUNK_VERSION (1)

// using chunk flags to indicate whether the soundID is in fact a hashID.
static const u_int uASURA_PS2_PSS_FLAG_SOUNDIDS_ARE_DYNAMIC = 0x00000001;

// C L A S S E S /////////////////////////////////////////////////////////////

class Asura_Chunk_ResourceFile_PS2_PartiallyStreamedSounds : public Asura_Chunk_ResourceFile
{

    public:

        // T Y P E S /////////////////////////////////////////////////////////

        struct HdrEntry
        {
            int iSoundID;
            int iFrequency;
            int iOffset1;   // First part is non-streamed. This may be all or none of the sound data, depending on the streaming type.
            int iSize1;
            int iOffset2;   // Second part is streamed. This may be all or none of the sound data, depending on the streaming type.
            int iSize2;
        };

        // M E T H O D S /////////////////////////////////////////////////////

        bool Process( Asura_Handle hFile );

};
// End class Asura_Chunk_ResourceFile_PS2_PartiallyStreamedSounds.

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_CHUNK_RESOURCEFILE_PS2_PARTIALLYSTREAMEDSOUNDS_H___
