//////////////////////////////////////////////////////////////////////////////
//
// Asura_Chunk_ResourceFile_PS2_StrippedSkysphere.cpp
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

// Engine independent.
#include "Core/Asura_Handle.h"

// Engine platform-specific.
#include "ChunkSystem/Asura_Chunk_ResourceFile_PS2_StrippedSkysphere.h"
#include "SpecialFX/Asura_Platform_Skybox.h"
#include "SpecialFX/Asura_PS2_FractalSkyDefines.h"

// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

bool Asura_Chunk_ResourceFile_PS2_StrippedSkysphere::Process( Asura_Handle hFile )
{
    Asura_Assert( ASURA_PS2_FS__CHUNK_VERSION >= this->Version, "This skysphere version is too new. You need an updated build." );

    // Deal with out of date exports.
    if( this->Version < ASURA_PS2_FS__CHUNK_VERSION )
    {
        Asura_Assert( false, "This skysphere data is out of data. Please re-export from tools." );
        return false;
    }

    return Asura_PS2_LoadStrippedSkysphere( hFile, this->FileSize );
}
