//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS2_SystemInfo.h
//
// Copyright (c) 2003,2005 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PS2_SYSTEMINFO_H___
#define ___ASURA_PS2_SYSTEMINFO_H___ 1

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

struct tm;

// C L A S S E S /////////////////////////////////////////////////////////////

class Asura_PS2_SystemInfo
{

    public:

        // C L A S S   M E T H O D S /////////////////////////////////////////

        static void Initialise( void );

        // Output the system clock time and date in dd/mm/yy and hh:mm:ss
        // will be adjusted to daylight saving
        static void GetSystemDateAndTime( tm* pxDateAndTime );

        // Get various info about the console, daylight saving, date formats etc.
        // these return constants defined in <libscf.h>
        static int GetAspectRatio( void )    { return s_xConsoleInfo.iAspectRatio;    }
        static int GetDateFormat( void )     { return s_xConsoleInfo.iDateFormat;     }
        static int GetLanguage( void )       { return s_xConsoleInfo.iLanguage;       }
        static int GetSpdifSetting( void )   { return s_xConsoleInfo.iSpdif;          }
        static int GetDaylightSaving( void ) { return s_xConsoleInfo.iDaylightSaving; }
        static int Get24Hour( void )         { return s_xConsoleInfo.i24Hour;         }
        static int GetTimeZone( void )       { return s_xConsoleInfo.iTimeZone;       }

    private:

        // T Y P E S /////////////////////////////////////////////////////////

        struct ConsoleInfo
        {
            int iAspectRatio;
            int iDateFormat;
            int iLanguage;
            int iSpdif;
            int iDaylightSaving;
            int i24Hour;
            int iTimeZone;
        };

        // C L A S S   S T A T E /////////////////////////////////////////////

        static ConsoleInfo s_xConsoleInfo;

};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_PS2_SYSTEMINFO_H___
