//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_MemoryManagement.h (PS2)
//
// Created by Mike Healey.
//
// Copyright (c) 2002 Rebellion. All rights reserved.
//
// provides defines for platform-specific memory manager functionality
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PLATFORM_MEMORYMANAGEMENT_H___
#define ___ASURA_PLATFORM_MEMORYMANAGEMENT_H___ 1

// M A C R O S ///////////////////////////////////////////////////////////////

#define ASURA_MEMORYMANAGEMENT_PLATFORM_INIT_WHEN_DISABLED (0)

// T Y P E S /////////////////////////////////////////////////////////////////

typedef int				intptr_t;
typedef unsigned int	uintptr_t;

// P R O T O T Y P E S   A N D   I N L I N E   F U N C T I O N S /////////////

extern bool Asura_PS2_MemoryManagerLocked();

#ifdef ASURA_MEMORYMANAGEMENT_PROCESS_ALLOCATED_MEM
void Asura_PS2_EnsureCacheAlignedMemoryIsNotInCache( void* pvMem, unsigned uSize, unsigned uAlignment );
#endif

#ifndef ASURA_MEMORYMANAGEMENT_ENABLED

extern void* Asura_PS2_AllocateAlign(unsigned int bytes, enum ASURA_ALIGN_ID alignment);
extern void Asura_PS2_DeallocateAlign(void* address);

#include <malloc.h> // for PS2 memalign
inline void* Asura_AllocateAlign(unsigned int bytes, enum ASURA_ALIGN_ID alignment)
{
    void* pvMem = memalign( alignment, bytes );
#ifdef ASURA_MEMORYMANAGEMENT_PROCESS_ALLOCATED_MEM
    if( pvMem )
    {
        Asura_PS2_EnsureCacheAlignedMemoryIsNotInCache( pvMem, bytes, alignment );
    }
#endif
    return pvMem;
}

inline void Asura_DeallocateAlign(void* address)
{
	free(address);
}

#endif // #ifndef ASURA_MEMORYMANAGEMENT_ENABLED

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_PLATFORM_MEMORYMANAGEMENT_H___
