//////////////////////////////////////////////////////////////////////////////
//
// Compiler.h
//
// Copyright (c) 2001-2004 Rebellion. All rights reserved.
//
// Compiler-specific defines, directives, etc.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___COMPILER_H___
#define ___COMPILER_H___ 1

// D E F I N E S /////////////////////////////////////////////////////////////

//
// Compatibility stuff for the different compilers we (sometimes) use (or
// evaluate.)
//

#if defined(__VECTORC__)

    // Codeplay's VectorC:EE compiler.

    // Doesn't seem to support section stuff at the moment.
    #define ASURA_CODE_SECTION(name)

#elif defined(__SNC__)

    // The SN Systems compiler. (That is, their homebrew one, not the GNU
    // one.)

    #define ASURA_CODE_SECTION(name) __attribute__(( section(".text."name) ))

#else

    // Presumably the SN Systems GNU compiler. (Note: also need to deal with
    // the browse info pass here.)
    #if !defined(_MSC_VER) && !defined(__GNUC__)
    #error Hmm, what compiler is this then?
    #endif

    #define ASURA_CODE_SECTION(name) __attribute__(( section(".text."name) ))

#endif

//
// Misc.
//

// (MP - 17.10.2001) For debugging variables that are only used in a single
// source file and are not required in release builds.
#if _DEBUG
    #define DEBUGVAR static
#else
    #define DEBUGVAR static const
#endif

#ifdef ASURA_DEBUG_VARIABLE_SYSTEM
#define DVSVAR static
#else
#define DVSVAR static const
#endif

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // ___COMPILER_H___
