
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_Handler_System_Callbacks_PS2.h
// Author : Paul Cardy
// Date   : 01-Feb-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_HANDLER_SYSTEM_CALLBACKS_PS2_H__
#define __ASURA_HANDLER_SYSTEM_CALLBACKS_PS2_H__

#if defined(ASURA_USE_MULTIPLE_HANDLERS)

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Handlers/Asura_Handler_System_Callbacks.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : Asura_Handler_System_Callbacks_PS2
// Author       : Paul Cardy
// Date         : 01-Feb-2008
//
// Description  : Class used to instantiate platform-specific functions for use
//				  by the handler-system.
////////////////////////////////////////////////////////////////////////////////

class Asura_Handler_System_Callbacks_PS2 : public Asura_Handler_System_Callbacks
{
public:
	// Public functions...
	Asura_Handler_System_Callbacks_PS2(void);
	//	virtual ~Asura_Handler_System_Callbacks_PS2();

	// Overridden functions...
	virtual bool	CreateHandlerData(u_int& uHandlerIndex, const Asura_Hash_ID uHandlerHash, const u_int uDataIndex, const char* szName, const Asura_Hash_ID uParentHandlerHash);
	virtual	bool	DestroyHandlerData(u_int& uHandlerIndex, const Asura_Hash_ID uHandlerHash, const u_int uDataIndex);
	virtual void	ReparentAllHandlerData(const Asura_Hash_ID uHandlerHash, const Asura_Hash_ID uParentHandlerHash);
	virtual void	SetAllHandlerData(const Asura_Hash_ID uHandlerHash, const u_int uDataIndex);

	virtual bool	CreateZoneData(u_int& uHandlerIndex, const Asura_Hash_ID uHandlerHash, const u_int uDataIndex, const char* szName, const Asura_Hash_ID uParentHandlerHash, const Asura_Hash_ID uZoneHash, const bool bAllowEnvironment);
	virtual bool	DestroyZoneData(u_int& uHandlerIndex, const Asura_Hash_ID uHandlerHash, const u_int uDataIndex, const bool bAllowEnvironment);
	virtual void	ReparentAllZoneData(const Asura_Hash_ID uHandlerHash, const Asura_Hash_ID uParentHandlerHash);
	virtual void	SetAllZoneData(const Asura_Hash_ID uHandlerHash, const u_int uDataIndex, const bool bAllowEnvironment);

#if defined(ASURA_LOGFILES_ENABLED)
	virtual void	CreateReport(const Asura_Hash_ID uHandlerHash, Asura_Stream& xOutputStream);
#endif	//defined(ASURA_LOGFILES_ENABLED)


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private variables...

	// Private functions...
	Asura_Handler_System_Callbacks_PS2(const Asura_Handler_System_Callbacks_PS2& xOther);

	Asura_Handler_System_Callbacks_PS2&	operator=(const Asura_Handler_System_Callbacks_PS2& xOther);

};   // End of class 'Asura_Handler_System_Callbacks_PS2'.

#endif	//defined(ASURA_USE_MULTIPLE_HANDLERS)

#endif	// ifndef __ASURA_HANDLER_SYSTEM_CALLBACKS_PS2_H__


/// End of file. ///
