//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_Mem.h
//
// Copyright (c) 2007 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ASURA_PLATFORM_MEM_H___
#define ASURA_PLATFORM_MEM_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

// Stdlib independent.
#include <string.h>

// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

//
// Asura_Mem
//

inline int Asura_Mem::Platform_Compare( const void* pvMem1, const void* pvMem2, size_t uBytes )
{
    return memcmp( pvMem1, pvMem2, uBytes );
}

inline void* Asura_Mem::Platform_Copy( void* pvDest, const void* pvSrc, size_t uBytes )
{
    return memcpy( pvDest, pvSrc, uBytes );
}

inline void* Asura_Mem::Platform_Move(void* pDest, const void* pSrc, size_t uBytes)
{
	return(memmove(pDest, pSrc, uBytes));
}

inline void* Asura_Mem::Platform_SafeCopy( void* pDest, const void* pSrc, size_t uBytes )
{
	return(memcpy(pDest, pSrc, uBytes));
}

inline void* Asura_Mem::Platform_Set( void* pvMem, int iChar, size_t uCount )
{
    return memset( pvMem, iChar, uCount );
}

inline void Asura_Mem::Platform_PreFetchData( const void* pvData, const u_int uNumBytes )
{
}

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ASURA_PLATFORM_MEM_H___
