#include "vcl_sml.i"

.syntax new

.init_vf_all	 	; for all vf registers. 
.init_vi_all		; for all vi registers.

.macro DotProduct fOutput, xVector1, xVector2
	mul.xyz		\fOutput, \xVector1, \xVector2
	add.x		\fOutput, \fOutput, \fOutput[y]
	add.x		\fOutput, \fOutput, \fOutput[z]
.endm

--enter
	in_vf.xyz	xAlpha(vf01)
	in_vf.xyz	xBeta(vf02)
	in_vf.xyz	xCentre(vf03)
	in_vf.x		fRadius(vf04)
	in_vi 		iOutputSet(vi01)
--endenter

.global VU0_LOS_RayIntersectsSphere
VU0_LOS_RayIntersectsSphere:
	sub.xyz				xL, xCentre, xAlpha
	mul.x				fRSquared, fRadius, fRadius
	
	DotProduct			fD, xL, xBeta					;// dot product of l and beta
	
	iaddiu				iSignTest, vi00, 0x80
	DotProduct			fLSquared, xL, xL				;// dot product of l and itself

	iaddiu				iRGreaterThanL, vi00, 0x0
	IfX1GreaterThanX2	iSignTest, fRSquared, fLSquared, DistanceTestsSucceeded_1
	IfX1GreaterThanX2	iSignTest, vf00, fD, DistanceTestsFailed
	b					DistanceTestsSucceeded_2

DistanceTestsSucceeded_1:
	iaddiu				iRGreaterThanL, vi00, 0x1

DistanceTestsSucceeded_2:
	mul.x				fDSquared, fD, fD
	sub.x				fMSquared, fLSquared, fDSquared

	IfX1GreaterThanX2	iSignTest, fRSquared, fMSquared, DistanceTestsFailed
	iaddiu				iReturn, vi00, 0x1				 ;// succeeds if output not set but distance test passed
	ibeq				iOutputSet, vi00, OutputNotSet   ;// check if address of output was set by C function

	sub.x				fRMSquared, fMSquared, fRSquared
	sqrt				Q, fRMSquared[x]

	ibeq				iRGreaterThanL, vi00, DistanceNotZero	 ;// already calculated above

DistanceIsZero:
	move.x				fDistanceToIntersection, vf00
	b					Exit

DistanceNotZero:
	sub.x				fDistanceToIntersection, fD, Q
	b					Exit

DistanceTestsFailed:
	iaddiu				iReturn, vi00, 0x2
	move.x				fDistanceToIntersection, vf00
	b					Exit

OutputNotSet:
	move.x				fDistanceToIntersection, vf00
	b					Exit

Exit:

--exit
	out_vi		iReturn(vi02)							;// true / false
	out_vf.x	fDistanceToIntersection(vf05)
--endexit
