/* SCEI CONFIDENTIAL
 "PlayStation 2" Programmer Tool Runtime Library Release 2.4.2
 */
/*
 *              Emotion Engine Library Sample Program
 *
 *                    - easy mpeg streaming -
 *
 *                         Version 0.10
 *                             ASCII
 *
 *      Copyright (C) 2001 Sony Computer Entertainment Inc.
 *                        All Rights Reserved.
 *
 *                          ezmpegstr.h
 *          global definitions for mpeg streaming program
 *
 *       Version        Date            Design   Log
 *  --------------------------------------------------------------------
 *       0.10           08.21.2001      mikedean the first version
 */

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _EZMPEGSTR_H_
#define _EZMPEGSTR_H_

#define DISP_WIDTH       (640)
#define DISP_HEIGHT_PAL  (512)
#define DISP_HEIGHT_NTSC (448)

#define MAX_HEIGHT (512)
#define MAX_MBX    (DISP_WIDTH >> 4)
#define MAX_MBY    (MAX_HEIGHT >> 4)

#define ZERO_BUFF_SIZE  (0x800)

#define bound(val, x) ((((val) + (x) - 1) / (x))*(x))
#define min(x, y)	(((x) < (y))? (x): (y))

#define bss_align(val) \
    __attribute__ ((aligned(val))) __attribute__ ((section (".bss")))
#define data_align(val) __attribute__ ((aligned(val)))

#define UNCMASK 0x0fffffff
#define UNCBASE 0x20000000
#define DmaAddr(val) \
    ((void*)((unsigned int)(val) & UNCMASK))
#define UncachedAddr(val) \
    ((void*)(((unsigned int)(val) & UNCMASK) | UNCBASE))

#define PATH3_TAG_SIZE(x, y) (4 * 2 * bound(((x) * (y) * 6 + 10) * 4, 64))

// ldimage.c

void setLoadImageTags(u_int *tags, void *image,
	int x, int y, int  width, int height);
void setLoadImageTagsTile(u_int *tags, void *image,
	int x, int y, int  width, int height);
void loadImage(u_int *tags);

#endif /* _EZMPEGSTR_H_ */
