//////////////////////////////////////////////////////////////////////////////
//
// Asura_PlatformFileAccess.h
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
// Description:
//
//     PS2-specific additions to independent file access functionality.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PLATFORMFILEACCESS_H___
#define ___ASURA_PLATFORMFILEACCESS_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

// Engine independent.
#include "Core/Asura_Handle.h"

// C L A S S E S /////////////////////////////////////////////////////////////

class Asura_Platform_FileAccess
{

    public:

#ifdef ASURA_PS2_USE_MULTISTREAM_FOR_FILE_ACCESS
        // If a file that has been accessed using Asura_FileAccess methods is
        // now to be read using MS fastload stuff directly, you need to call
        // this first to ensure that internal buffers are flushed correctly.
        static void BeginDirectMultistreamAccess( Asura_Handle iHandle );

        // Once they're done, they should call this method to inform the main
        // file access system where they've reached in the file.
        static void EndDirectMultistreamAccess( Asura_Handle iHandle, u_int uFilePos );
#endif

};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_PLATFORMFILEACCESS_H___
