//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS2_VoiceRecognition.h
//
// Copyright (c) 2004 Rebellion. All rights reserved.
//
// Description:
//
//     Asura interface for ScanSoft voice recognition SDK
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PS2_VOICERECOGNITION_H___
#define ___ASURA_PS2_VOICERECOGNITION_H___ 1

#define ASURA_PS2_VOICERECOG_SCANSOFT	0
#define ASURA_PS2_VOICERECOG_FONIX		1

#ifndef ASURA_PS2_VOICERECOG_SDK
//#define ASURA_PS2_VOICERECOG_SDK ASURA_PS2_VOICERECOG_SCANSOFT
#define ASURA_PS2_VOICERECOG_SDK ASURA_PS2_VOICERECOG_FONIX
#endif

class Asura_PS2_VoiceRecognition
{
	public:

		static void Initialise( void );
		static void Update( void );
		static void Reset( void );
		static void Shutdown( void );

		// the button which must be held to capture speech can be changed at any time
		static void SetTalkButton( int iKeyID );

#if ASURA_PS2_VOICERECOG_SDK == ASURA_PS2_VOICERECOG_SCANSOFT
		// the language and grammar can only be changed before initialisation.
		// The string passed is not copied so it must be a global that exists all the time.
		static void SetLanguage(const char* szLanguageFile);
		static void SetGrammar(const char* szCTX, const char* szWRD);
		static const char* GetLanguageFile( void );
#else //ASURA_PS2_VOICERECOG_SDK == ASURA_PS2_VOICERECOG_FONIX
		static void SetLanguageFiles(const char* szVocabFile, 
			const char* szNeuralNetFile,
			const char* szUserDataFile,
			const char* szWordListFile);
#endif

	protected:
		
		static bool IsInitialised();
		static void Project_ProcessUtterance( u_int uAction, const char* szString );
		static void Project_HandleFailedUtterance( void );
		static bool Project_ShouldListen();

		static void CheckForErrors( void );

		static int s_iTalkButtonID;
};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_PS2_VOICERECOGNITION_H___
