//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_GameSpy_GT2.cpp
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#include "Debugging/Asura_Logfile.h"
#include "Network/Asura_GameSpy_GT2.h"

#ifdef ASURA_SUPPORT_EXTERNAL_NETWORK
#include "Network/Asura_PS2_EZNetCnf.h"
#endif

bool Asura_GameSpy_GT2::Platform_Initialise( void )
{
	bool bNetworkOK = Asura_PS2_EZNetCnf::IsConnectionActive() && Asura_PS2_EZNetCnf::IsConnectionOK();
	Asura_Assert(bNetworkOK, "network connection has not been brought up yet, you will crash");
	return bNetworkOK;
}

void Asura_GameSpy_GT2::Platform_Shutdown( void )
{
	// SNH - 14/04/2004 16:05:24 - leave the network connection open until specifically shut down
#ifdef ASURA_SUPPORT_EXTERNAL_NETWORK
//	Asura_PS2_EZNetCnf::ShutdownNetworkConnection();
#endif
}

bool Asura_GameSpy_GT2::Platform_CanUseLANBroadcast( void )
{
#ifdef ASURA_SUPPORT_EXTERNAL_NETWORK
    return Asura_PS2_EZNetCnf::CanUseLANBroadcast();
#else
    return false;
#endif
}
