//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_NetworkSession_GT2.cpp
//
// PC/PS2 version
//
// Copyright (c) 2004 Rebellion. All rights reserved.
//
// Description:
//
//     ANTS implementations of LAN session code
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#include "Network/Asura_NetTransport_System.h"
#include "Network/Asura_Network_Session.h"

#ifdef ASURA_SUPPORT_EXTERNAL_NETWORK

void Asura_Network_Session_System::Platform_Initialise(void)
{
	Asura_NetTransport_System::Initialise();
	Asura_NetTransport_System::StartSessionManager();
}


void Asura_Network_Session_System::Platform_Shutdown(void)
{
	Asura_NetTransport_System::Shutdown();
	Asura_NetTransport_System::StopSessionManager();
}


void Asura_Network_Session_System::Platform_Update(void)
{
	Asura_NetTransport_System::Update();
	Asura_NetTransport_System::UpdateLANSessions();
}

void Asura_Network_Session::Platform_PrepareConnection(void) const
{
	//This is needed on xbox to setup the secure connection
}

#endif //#ifdef ASURA_SUPPORT_EXTERNAL_NETWORK
