//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS2_RenderParticle.h
//
// Copyright (c) 2002-2004 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PS2_RENDERPARTICLE_H___
#define ___ASURA_PS2_RENDERPARTICLE_H___ 1

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Particle;
class Asura_Particle_Effect;
class Asura_Particle_Template;
class Asura_RGBA;
class Asura_Vector_3;

class Asura_PFX_Particle;
class Asura_PFX_Particle_Template;

// C L A S S E S /////////////////////////////////////////////////////////////

class Asura_PS2_ParticleSystem
{
    
    public:

        static void Initialise( void );
        static void Reset( void );
        static void Shutdown( void );
    
        static void BeginFrame( bool bHeathaze );
        static void EndFrame( void );

        static void RenderParticleSystem( const Asura_Particle_Template* pxParticleTemplate,
                                          const Asura_Particle * const * ppxParticles,
                                          u_int uNumParticles,
                                          const Asura_Particle_Effect* pxEffect = NULL,
                                          bool bAnyRotations = false );

        static void BeginParticleBatch( const Asura_Particle_Template* pxParticleTemplate, bool bAnyRotations, u_int uCamFlags );
        static void AddParticle( const Asura_Vector_3& xPos, float fSize, const Asura_RGBA& xRGBA, float fRot = 0.0f );
        static void EndParticleBatch( void );

};
// End class Asura_PS2_ParticleSystem.

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_PS2_RENDERPARTICLE_H___
