//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS3_BotanicalsShapes.cpp
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

#include "Core/Asura.h"

#include "Botanicals/Asura_PS3_Botanicals.h"

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_PS3_Botanicals_Shape::Asura_PS3_Botanicals_Shape
// Author       : Catalin Arsenescu
// Date         : 02-August-2007
////////////////////////////////////////////////////////////////////////////////
Asura_PS3_Botanicals_Shape::Asura_PS3_Botanicals_Shape()
: m_pxElements( NULL )
, m_uHashID( ASURA_HASH_ID_UNSET )
, m_iNumElements( 0 )
#if defined( ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS) && 1 == ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS
, m_uSectionCount( 0 )
#endif
#if defined( ASURA_BOTANICAL_SUPPORT_INTERACTIVE)
, m_pxBasicInteractive( NULL )
#endif
{
}
/// End of function 'Asura_PS3_Botanicals_Shape::Asura_PS3_Botanicals_Shape'. ///

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_PS3_Botanicals_Shape::~Asura_PS3_Botanicals_Shape
// Author       : Catalin Arsenescu
// Date         : 02-August-2007
////////////////////////////////////////////////////////////////////////////////
Asura_PS3_Botanicals_Shape::~Asura_PS3_Botanicals_Shape()
{
	delete[] m_pxElements;

	m_pxElements	= NULL;
	m_iNumElements	= 0;
}
/// End of function 'Asura_PS3_Botanicals_Shape::~Asura_PS3_Botanicals_Shape'. ///

#if defined( ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS) && 1 == ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS
////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_PS3_Botanicals_Shape::GetSectionCount
// Author       : Catalin Arsenescu
// Date         : 02-August-2007
////////////////////////////////////////////////////////////////////////////////
u_int Asura_PS3_Botanicals_Shape::GetSectionCount() const
{
	return( this->m_uSectionCount);
}
/// End of function 'Asura_PS3_Botanicals_Shape::GetSectionCount'. ///
#endif
