//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS3_BotanicalsTemplate.cpp
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

#include "Core/Asura.h"

#include "Botanicals/Asura_PS3_Botanicals.h"

// Asura independent headers
#include "Camera/Asura_Camera.h"
#include "Debugging/Asura_Assert.h"
#include "Core/Asura_Material_System.h"
#include "Core/Asura_TextureManagement.h"
#include "Rendering/Asura_Render.h"

#include "Botanicals/Asura_PS3_BotanicalsTemplate.h"

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_PS3_Botanicals_Template::Asura_PS3_Botanicals_Template
// Author       : Catalin Arsenescu
// Date         : 02-August-2007
////////////////////////////////////////////////////////////////////////////////
Asura_PS3_Botanicals_Template::Asura_PS3_Botanicals_Template()
: m_pxShape(NULL)
, m_pxInstances(NULL)
, m_iUID(0)
, m_iNumInstances(0)
, m_iOffsetToNextBase(0)
, m_pxVisibilityQueries(NULL)
{
}
/// End of function 'Asura_PS3_Botanicals_Template::Asura_PS3_Botanicals_Template'. ///

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_PS3_Botanicals_Template::~Asura_PS3_Botanicals_Template
// Author       : Catalin Arsenescu
// Date         : 02-August-2007
////////////////////////////////////////////////////////////////////////////////
Asura_PS3_Botanicals_Template::~Asura_PS3_Botanicals_Template()
{
	delete[] m_pxInstances;
	delete [] m_pxVisibilityQueries;
	m_iNumInstances = 0;
	m_pxInstances = NULL;

}
/// End of function 'Asura_PS3_Botanicals_Shape::~Asura_PS3_Botanicals_Shape'. ///

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_PS3_Botanicals_Template::GetInstanceCount
// Author       : Catalin Arsenescu
// Date         : 03-August-2007
////////////////////////////////////////////////////////////////////////////////
u_int Asura_PS3_Botanicals_Template::GetInstanceCount() const
{
	return( this->m_iNumInstances);
}
/// End of function 'Asura_PS3_Botanicals_Template::GetInstanceCount'. ///

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_PS3_Botanicals_Template::GetInstance
// Author       : Catalin Arsenescu
// Date         : 03-August-2007
////////////////////////////////////////////////////////////////////////////////
const Asura_BGR_Instance* Asura_PS3_Botanicals_Template::GetInstance( const u_int uInstanceIndex) const
{
	Asura_Assertf( uInstanceIndex < static_cast< u_int>( this->m_iNumInstances), ("Instance %d is out of %d range.", uInstanceIndex, this->m_iNumInstances));
	const Asura_BGR_Instance* const pxInstance = this->m_pxInstances + uInstanceIndex;

	return( pxInstance);
}
/// End of function 'Asura_PS3_Botanicals_Template::GetInstance'. ///
