//////////////////////////////////////////////////////////////////////////////
//
// Asura_Chunk_ResourceFile_PS3_Botanicals.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#if !defined __ASURA_CHUNK_RESOURCEFILE_PS3_BOTANICALS_H__
#define __ASURA_CHUNK_RESOURCEFILE_PS3_BOTANICALS_H__

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

// Asura Platform-independent
#include "ChunkSystem/Asura_Chunk_ResourceFile.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declaration...
////////////////////////////////////////////////////////////////////////////////
#ifdef ASURA_USE_BOTANICALS
	class Asura_PS3_Botanicals_Shape;
	class Asura_PS3_Botanicals_Element;
	class Asura_PS3_Botanicals_LODData;
	class Asura_PS3_Botanicals_Template;
#endif

class Asura_Chunk_Stream;

////////////////////////////////////////////////////////////////////////////////
//
// Asura_Chunk_ResourceFile_PS3_Botanicals
//
// Class used to process botanicals chunks
//
////////////////////////////////////////////////////////////////////////////////

class Asura_Chunk_ResourceFile_PS3_Botanicals : public Asura_Chunk_ResourceFile
{
protected:
	//Protected functions
#ifdef ASURA_USE_BOTANICALS
	void ProcessBotanicalsShape	( Asura_Chunk_Stream& xStream, Asura_PS3_Botanicals_Shape&		xCurrShape );
	void ProcessBotanicalElement( Asura_Chunk_Stream& xStream, Asura_PS3_Botanicals_Element&	xCurrElement );
	void ProcessBotanicalLOD	( Asura_Chunk_Stream& xStream, Asura_PS3_Botanicals_LODData&	xCurrentLOD );
	void Process2And1SidedMesh	( Asura_Chunk_Stream& xStream, Asura_PS3_Botanicals_LODData&	xCurrentLOD );
	void ProcessBillboards		( Asura_Chunk_Stream& xStream, Asura_PS3_Botanicals_LODData&	xCurrentLOD );
	void ProcessImposters		( Asura_Chunk_Stream& xStream, Asura_PS3_Botanicals_LODData&	xCurrentLOD );
	void ProcessBotanicalTemplate( Asura_Chunk_Stream& xStream, Asura_PS3_Botanicals_Template&	xCurrTemplate);
#endif //#ifdef ASURA_USE_BOTANICALS
public:
	enum
	{
		CURRENT_VERSION = 7
	};

	// Class functions
	void Process( const char* const szFilename, Asura_Chunk_Stream& xStream );
};

#endif // !defined __ASURA_CHUNK_RESOURCEFILE_PS3_BOTANICALS_H__
