//
// Asura_Chunk_ResourceFile_PS3_MaterialResponse.cpp
//
// Created by KJFL - 02 January 2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

#if defined ASURA_USE_MATERIAL_RESPONSE_SYSTEM

// This file's header.
#include "ChunkSystem/Asura_Chunk_ResourceFile_PS3_MaterialResponse.h"

#include "ChunkSystem/Asura_Chunk_Stream.h"
#include "Core/Asura_MaterialResponse_System.h"

// Asura PS3
#include "Rendering/Asura_PS3_MaterialResponse_System.h"
#include "ChunkSystem/Asura_Chunk_ResourceFile_PS3.h"

extern void Asura_PS3_MaterialResponse_UpdateTexture( Asura_Chunk_Stream& xStream, int iVersion );

void Asura_Chunk_ResourceFile_PS3_MaterialResponse::Process( const char* szFilename, Asura_Chunk_Stream& xStream )
{
	if( Version != ASURA_PS3_MATERIALRESPONSE_CHUNK_VERSION )
	{
		Asura_Assertf( false, ("Invalid material response chunk version (%d) encountered. Should be %d. You may need new code, or to re-export the level.", Version, ASURA_PS3_MATERIALRESPONSE_CHUNK_VERSION) );
		//return; BW this is non-fatal for the latest change in materials
	}

	u_int uNumberOfMaterials;
	xStream >> uNumberOfMaterials;

	Asura_PS3_MaterialResponse_System::UpdateDataTexture( xStream, Version, uNumberOfMaterials );
	
	if ( Version >= 4 )
	{
		xStream >> uNumberOfMaterials; // materials including slaves
	
		Asura_PS3_MaterialResponse_System::ReadPS3Material( xStream, uNumberOfMaterials );
	}
}

#endif // ASURA_USE_MATERIAL_RESPONSE_SYSTEM
