
///////////////////////////////////////////////////////////////////////////////
//
// File   : Compiler.h
// Author : Andy Tate
// Date   : 20-Jun-2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __COMPILER_H__
#define __COMPILER_H__

////////////////////////////////////////////////////////////////////////////////
// Includes
////////////////////////////////////////////////////////////////////////////////
#include <sys/types.h>

////////////////////////////////////////////////////////////////////////////////
// Macro definitions...
////////////////////////////////////////////////////////////////////////////////

// (MP - 12.04.2002) For use with debugging variables that are only used in
// a single file; the compiler should be able to optimise them out in release
// builds.
#ifdef NDEBUG
    #define DEBUGVAR static const
#else
    #define DEBUGVAR static
#endif

#ifdef ASURA_DEBUG_VARIABLE_SYSTEM
#define DVSVAR static
#else
#define DVSVAR static const
#endif

#define ASURA_CODE_SECTION(name)

#define ASURA_PLATFORM_HAS_LONG_LONG_TYPE (1)
#define ASURA_PLATFORM_IS_BIG_ENDIAN	  (1)
#define ASURA_PLATFORM_PS3				  (1)
#define ASURA_USE_PLATFORM_VECTORS		  (1)	

// T Y P E D E F S ///////////////////////////////////////////////////////////
typedef uint64_t uint64;
typedef int64_t int64;

#endif   // ifndef __COMPILER_H__


/// End of file. ///
