///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_Platform_FMV.cpp
// Author : Jason Turner
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

//Asura main header
#include "Core/Asura.h"

// independent includes
#include "Core/Asura_UserInput.h"
#include "FMV/Asura_FMV.h"

// Asura PS3 headers
#include "Rendering/Asura_PS3_Graphics.h"
#include "Rendering/Asura_PS3_SwapChain.h"

static u_int s_uPresentInterval = 0;

////////////////////////////////////////////////////////////////////////////////
//  Asura_FMV::Platform_Update
////////////////////////////////////////////////////////////////////////////////

bool Asura_FMV::Platform_Update()
{
	// if the graphics engine is shutting down, then we should too
	if ( Asura_PS3_Graphics::IsInShutdown() )
	{
		return false;
	}

	Asura_PS3_Graphics::CheckExitCallBack();
	return true;
}

////////////////////////////////////////////////////////////////////////////////
//  Asura_FMV::Platform_CheckForFMVSkip
////////////////////////////////////////////////////////////////////////////////

bool Asura_FMV::Platform_CheckForFMVSkip()
{
	if ( Asura_UserInput::HasAnyKeyBeenPressed() ) return true;

	return false;
}

////////////////////////////////////////////////////////////////////////////////
//  Asura_FMV::Platform_PrePlay
////////////////////////////////////////////////////////////////////////////////

void Asura_FMV::Platform_PrePlay()
{
	s_uPresentInterval = Asura_PS3_SwapChain::GetPresentInterval();
	Asura_PS3_SwapChain::SetPresentInterval( 0 );
	Asura_PS3_SwapChain::SetIsInFMV( true );
}

////////////////////////////////////////////////////////////////////////////////
//  Asura_FMV::Platform_PostPlay
////////////////////////////////////////////////////////////////////////////////

void Asura_FMV::Platform_PostPlay()
{
	Asura_PS3_SwapChain::SetPresentInterval( s_uPresentInterval );
	Asura_PS3_SwapChain::SetIsInFMV( false );
}

////////////////////////////////////////////////////////////////////////////////
