
// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#ifdef ASURA_USE_VIDEO_TO_TEXTURE_SYSTEM

// Engine independent.
#include "Debugging/Asura_Logfile.h"
#include "FMV/Asura_VideoToTexture_System.h"

// PS3 includes
#include <cell/sail.h>
#include <cell/sysmodule.h>


////////////////////////////////////////////////////////////////////////////////
//
// Asura_VideoToTexture_System::Platform_Initialise
//
////////////////////////////////////////////////////////////////////////////////

void Asura_VideoToTexture_System::Platform_Initialise()
{
	// load the libsail PRX
	int iRet = cellSysmoduleLoadModule(CELL_SYSMODULE_SAIL);
	Asura_Assertf(iRet == CELL_OK, ("cellSysmoduleLoadModule(CELL_SYSMODULE_SAIL): 0x%X\n", iRet));
}

////////////////////////////////////////////////////////////////////////////////
//
// Asura_VideoToTexture_System::Platform_Shutdown
//
////////////////////////////////////////////////////////////////////////////////

void Asura_VideoToTexture_System::Platform_Shutdown()
{
	int iRet = cellSysmoduleUnloadModule(CELL_SYSMODULE_SAIL);
	Asura_OutputToDebuggerAssert(iRet >= CELL_OK, ("cellSysmoduleUnloadModule() failed: 0x%X\n", iRet));
}

////////////////////////////////////////////////////////////////////////////////
//
// Asura_VideoToTexture_System::Platform_Update
//
////////////////////////////////////////////////////////////////////////////////

void Asura_VideoToTexture_System::Platform_Update()
{
}

#endif // ASURA_USE_VIDEO_TO_TEXTURE_SYSTEM
