//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS3_USBKeyboard.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PS3_USBKEYBOARD_H___
#define ___ASURA_PS3_USBKEYBOARD_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

// Engine platform-specific.
#include "Core/Asura_PlatformBasics.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

struct CellKbData;
struct CellKbInfo;

// C L A S S E S /////////////////////////////////////////////////////////////

class Asura_PS3_USBKeyboard
{

public:

    static void ResetInputBfr( void );
    static void GetInputBfr( const Asura_UnicodeChar** pwszInputBfr, u_int* puLen );

    void Initialise( u_int uID );
    void Reset( void );
    void Update( const CellKbInfo& xCurKBInfo, u_char* pucKeyOutput );

private:

    enum STATUS
    {
        STATUS_CONNECTED,
        STATUS_ERROR,        // Connected but initialisation failed or some other error occurred so we're ignoring it.
        STATUS_DISCONNECTED,
    };

    void HandleConnection( void );

    void TranslateKeyPresses( const CellKbData& xData, u_char* pucKeyOutput );
    void TranslateModifierKeys( const CellKbData& xData, u_char* pucKeyOutput );

    u_int  m_uID;
    STATUS m_eStatus;

    // Only valid when CONNECTED.
    u_int  m_uArrangement;

};
// End class Asura_PS3_USBKeyboard.

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_PS3_USBKEYBOARD_H___
