///////////////////////////////////////////////////////////////////////////////
//
// File: Asura_Platform_Qos_System.cpp
//
// Created by Martin G.Harris (9/4/2009)
// 
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
// Description: System for measuring the upload bandwidth of machines in the
//				lobby of online games. This information can then be used to
//              help determine which machine would make the best game server.
//
///////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"
#include "Network/Asura_Qos_System.h"

#ifdef ASURA_ENABLE_QOS_SYSTEM

// Includes
#include "Debugging/Asura_Assert.h"
#include "Network/Asura_QosSocket_BSD.h"


///////////////////////////////////////////////////////////////////////////////
// Asura_Qos_System
///////////////////////////////////////////////////////////////////////////////

void Asura_Qos_System::Platform_Initialise()
{
}


void Asura_Qos_System::Platform_Shutdown()
{
}

Asura_QosSocket* Asura_Qos_System::Platform_CreateSocket(bool bIsHost)
{
	return new Asura_QosSocket_BSD;
}


#endif //#ifdef ASURA_ENABLE_QOS_SYSTEM
