// SCE CONFIDENTIAL
// PLAYSTATION(R)3 Programmer Tool Runtime Library 250.001
// Copyright (C) 2008 Sony Computer Entertainment Inc.
// All Rights Reserved.

#ifndef __CELL_UTIL_SPURS_EVENT_FLAG_H__
#define __CELL_UTIL_SPURS_EVENT_FLAG_H__ 1

#include <cellUtilSpursDefine.h>
#include <cell/spurs/event_flag.h>

#ifdef __PPU__
#include <cellUtilSpurs.h>
#endif

__CELL_UTIL_SPURS_BEGIN

class EventFlag : public CellSpursEventFlag {
	EventFlag(const EventFlag&);
	EventFlag& operator =(const EventFlag&);

public:
	static const uint32_t ALIGN = CELL_SPURS_EVENT_FLAG_ALIGN;

#ifdef __PPU__
	static int initialize(EventFlag* eventFlag, const Spurs* spurs)
		{
			return cellSpursEventFlagInitializeIWL(
				const_cast<Spurs*>(spurs), eventFlag,
				CELL_SPURS_EVENT_FLAG_CLEAR_AUTO,
				CELL_SPURS_EVENT_FLAG_ANY2ANY);
		}

	int set(uint16_t bits)
		{
			return cellSpursEventFlagSet(this, bits);
		}

	int wait(uint16_t* mask, CellSpursEventFlagWaitMode mode = CELL_SPURS_EVENT_FLAG_OR)
		{
			return cellSpursEventFlagWait(this, mask, mode);
		}

	int tryWait(uint16_t* mask, CellSpursEventFlagWaitMode mode = CELL_SPURS_EVENT_FLAG_OR)
		{
			return cellSpursEventFlagTryWait(this, mask, mode);
		}

	int attachLv2EventQueue()
		{
			return cellSpursEventFlagAttachLv2EventQueue(this);
		}

	int detachLv2EventQueue()
		{
			return cellSpursEventFlagDetachLv2EventQueue(this);
		}
#endif
} __attribute__((aligned(CELL_SPURS_EVENT_FLAG_ALIGN)));

__CELL_UTIL_SPURS_END

#endif // __CELL_UTIL_SPURS_EVENT_FLAG_H__

// Local Variables:
// mode: C++
// c-file-style: "stroustrup"
// tab-width: 4
// End:
// vim:sw=4:sts=4:ts=4
