//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS3_Fog.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_PS3_FOG_H__
#define __ASURA_PS3_FOG_H__

/******************************************************************************/
/* Classes                                                                    */
/******************************************************************************/
class Asura_PS3_Texture;

////////////////////////////////////////////////////////////////////////////////
//
// Asura_PS3_Fog
//
// Manages fog on PS3
//
////////////////////////////////////////////////////////////////////////////////
struct Asura_PS3_FogParameters
{
	bool					m_bFogEnabled;
	float					m_afFogColour[3];
	float					m_fFogNearPlane;
	float					m_fOneOverFogDepth;
	Asura_PS3_Texture*		m_pxFogTexture;
};

class Asura_PS3_Fog
{
public:

	static void Initialise();
	static void Shutdown();

	static void UpdateForNewParameters();
	static void RenderFog();

	static Asura_PS3_FogParameters& GetFogParameters() {return s_xParams;}

private:
	static Asura_PS3_FogParameters s_xParams;
};

#endif // #ifndef __ASURA_PS3_FOG_H__
