//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS3_ScratchRenderMemory.h
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ASURA_PS3_SCRATCHRENDERMEMORY_H___
#define ASURA_PS3_SCRATCHRENDERMEMORY_H___ 1

// M A C R O S ///////////////////////////////////////////////////////////////

#ifndef ASURA_PS3_MAIN_VIDEO_SCRATCH_MEMORY_SIZE
#define ASURA_PS3_MAIN_VIDEO_SCRATCH_MEMORY_SIZE ( 1024 * 1024 * 5 )
#endif

// P R O T O T Y P E S   A N D   I N L I N E   F U N C T I O N S /////////////

class Asura_PS3_ScratchRenderMemory
{

public:

    static void Initialise( void );
    static void Reset( void );
    static void Shutdown( void );

    static void* AllocMainVideoMemory( u_int uNumBytes, u_int uAlignment = 128 );

    static void BeginFrame( void );
    static void EndFrame( void );

#ifdef ASURA_PS3_ALLOW_STATS
    static u_int GetCurMainVideoMemoryUsage( void ) { return s_auCurMemoryUsage[MEMTYPE_MAIN_VIDEO]; }
    static u_int GetMaxMainVideoMemoryUsage( void ) { return s_auMaxMemoryUsage[MEMTYPE_MAIN_VIDEO]; }
#endif

private:

    // Prevent instantiation
    Asura_PS3_ScratchRenderMemory( void );
    ~Asura_PS3_ScratchRenderMemory( void );

#ifdef ASURA_PS3_ALLOW_STATS
    enum MEMTYPE
    {
        MEMTYPE_MAIN_VIDEO,
        MEMTYPE_COUNT,
    };

    static u_int s_auCurMemoryUsage[MEMTYPE_COUNT];
    static u_int s_auMaxMemoryUsage[MEMTYPE_COUNT];
#endif

};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ASURA_PS3_SCRATCHRENDERMEMORY_H___
