#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_FP_HANDLES_H__
#define __ASURA_PS3_FP_HANDLES_H__

class Asura_PS3_FragmentShaderBase;

class Asura_PS3_FP_Handles
{
public:
	struct ASURA_PS3_OFFSETS
	{
		unsigned short* m_pOffsets;
	};

	Asura_PS3_FP_Handles( unsigned char ucElements, unsigned char ucTextureUnits )
	{
		m_ucElements		= ucElements;
		m_ucTextureUnits	= ucTextureUnits;

		if( ucTextureUnits > 0 )
		{
			m_pcTextureUnit	= new char[ m_ucTextureUnits ];
		}
		else
		{
			m_pcTextureUnit	= NULL;
		}

		if( ucElements > 0 )
		{
			m_pxOffsets		= new ASURA_PS3_OFFSETS[ m_ucElements ];
			for( unsigned char i = 0; i < m_ucElements; ++i )
			{
				m_pxOffsets[ i ].m_pOffsets = NULL;
			}
		}
		else
		{
			m_pxOffsets		= NULL;
		}
	}

	virtual ~Asura_PS3_FP_Handles()
	{
		if( m_pcTextureUnit )
		{
			delete[] m_pcTextureUnit;
			m_pcTextureUnit = NULL;
		}
		if( m_pxOffsets )
		{
			for( unsigned char i = 0; i < m_ucElements; ++i )
			{
				delete[] m_pxOffsets[ i ].m_pOffsets;
				m_pxOffsets[ i ].m_pOffsets = NULL;
			}
			delete[] m_pxOffsets;
			m_pxOffsets	= NULL;
		}
		m_ucElements		= 0;
		m_ucTextureUnits	= 0;
	}

	virtual void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader ) = 0;

	char*						m_pcTextureUnit;
	ASURA_PS3_OFFSETS*			m_pxOffsets;
	unsigned char				m_ucElements;
	unsigned char				m_ucTextureUnits;
};

#endif //#ifndef __ASURA_PS3_FP_HANDLES_H__
