//
// Apply_Shadows_FP.h
//
// Created by Catalin Arsenescu - 29 August 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_APPLY_SHADOWS_FP_H__
#define __ASURA_PS3_APPLY_SHADOWS_FP_H__

extern u_int _binary_PS3_ApplyShadows_FP0000_bin_start;
extern u_int _binary_PS3_ApplyShadows_FP0000_bin_end;

extern u_int _binary_PS3_ApplyShadows_FP0001_bin_start;
extern u_int _binary_PS3_ApplyShadows_FP0001_bin_end;

extern u_int _binary_PS3_ApplyShadows_FP0010_bin_start;
extern u_int _binary_PS3_ApplyShadows_FP0010_bin_end;

extern u_int _binary_PS3_ApplyShadows_FP0011_bin_start;
extern u_int _binary_PS3_ApplyShadows_FP0011_bin_end;

extern u_int _binary_PS3_ApplyShadows_FP0100_bin_start;
extern u_int _binary_PS3_ApplyShadows_FP0100_bin_end;

extern u_int _binary_PS3_ApplyShadows_FP0101_bin_start;
extern u_int _binary_PS3_ApplyShadows_FP0101_bin_end;

extern u_int _binary_PS3_ApplyShadows_FP0110_bin_start;
extern u_int _binary_PS3_ApplyShadows_FP0110_bin_end;

extern u_int _binary_PS3_ApplyShadows_FP0111_bin_start;
extern u_int _binary_PS3_ApplyShadows_FP0111_bin_end;

extern u_int _binary_PS3_ApplyShadows_FP1000_bin_start;
extern u_int _binary_PS3_ApplyShadows_FP1000_bin_end;

extern u_int _binary_PS3_ApplyShadows_FP1001_bin_start;
extern u_int _binary_PS3_ApplyShadows_FP1001_bin_end;

extern u_int _binary_PS3_ApplyShadows_FP1010_bin_start;
extern u_int _binary_PS3_ApplyShadows_FP1010_bin_end;

extern u_int _binary_PS3_ApplyShadows_FP1011_bin_start;
extern u_int _binary_PS3_ApplyShadows_FP1011_bin_end;

extern u_int _binary_PS3_ApplyShadows_FP1100_bin_start;
extern u_int _binary_PS3_ApplyShadows_FP1100_bin_end;

extern u_int _binary_PS3_ApplyShadows_FP1101_bin_start;
extern u_int _binary_PS3_ApplyShadows_FP1101_bin_end;

extern u_int _binary_PS3_ApplyShadows_FP1110_bin_start;
extern u_int _binary_PS3_ApplyShadows_FP1110_bin_end;

extern u_int _binary_PS3_ApplyShadows_FP1111_bin_start;
extern u_int _binary_PS3_ApplyShadows_FP1111_bin_end;

static Asura_PS3_GCM_FragmentShaderUniformParameter g_axFragmentShaderUniform[] =
{
	//m_szName, m_usArraySize, m_sizeInFloatsForOneElement, m_usaOffsets, m_faLastValues
	{ "g_xCameraViewSpaceToLightClipSpace",			4, 4, NULL, NULL },
	{ "g_xCameraViewSpaceToLightViewSpace",			4, 4, NULL, NULL },
	{ "g_xCameraViewSpaceToWorldSpace",				4, 4, NULL, NULL },
	{ "g_xLightPos",								1, 4, NULL, NULL },
	{ "g_xTwoOverScreen",							1, 2, NULL, NULL },
	{ "g_fScreenOffset",							1, 2, NULL, NULL },
	{ "g_fCameraTanHalfFOV",						1, 2, NULL, NULL },
	{ "g_fShadowFilterTextureScale",				1, 1, NULL, NULL },
	{ "g_fShadowFilterSize",						1, 1, NULL, NULL },
	{ "g_xShadowDirection",							1, 3, NULL, NULL },
	{ "g_fShadowStrength",							1, 1, NULL, NULL },
	{ "g_fShadowFrustumNearPlaneDistance",			1, 1, NULL, NULL },
	{ "g_fOneOverShadowFrustumPlaneSeparation",		1, 1, NULL, NULL },
	{ "g_xSelfShadowBias",							1, 3, NULL, NULL },
};

enum FRAGMENT_SHADER_UNIFORM
{
	FP_CameraViewSpaceToLightClipSpace,
	FP_CameraViewSpaceToLightViewSpace,
	FP_CameraViewSpaceToWorldSpace,
	FP_LightPos,
	FP_TwoOverScreen,
	FP_ScreenOffset,
	FP_CameraTanHalfFOV,
	FP_DepthAdjustment,
	FP_ShadowFilterTextureScale,
	FP_ShadowFilterSize,
	FP_ShadowDirection,
	FP_ShadowStrength,
	FP_ShadowFrustumNearPlaneDistance,
	FP_OneOverShadowFrustumPlaneSeparation,
	FP_SelfShadowBias,
	UE_ELEMENTS
};

static Asura_PS3_GCM_TextureUnitElement g_axTextureUnits[] = 
{
	//m_szName, m_ucArraySize, m_cTextureUnit
	{ "g_xNormalMtlBuffer",			1, NULL },
	{ "g_xDepthBuffer",			1, NULL },
	{ "g_xShadowBuffer",			1, NULL },
	{ "g_xShadowCubeBuffer",		1, NULL },
	{ "g_xKernelRotationSampler",	1, NULL },
};

enum TEXTURE_UNITS
{
	FP_NormalMtlBuffer,
	FP_DepthBuffer,
	FP_ShadowBuffer,
	FP_ShadowCubeBuffer,
	FP_KernelRotationSampler,
	TU_ELEMENTS
};

class Asura_PS3_ShadowSystem_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_ShadowSystem_Handles() : Asura_PS3_FP_Handles( UE_ELEMENTS, TU_ELEMENTS ) {}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		//Uniform parameters
		pxShader->InitUniformElement( FP_CameraViewSpaceToLightClipSpace,		"g_xCameraViewSpaceToLightClipSpace",		4 );
		pxShader->InitUniformElement( FP_CameraViewSpaceToLightViewSpace,		"g_xCameraViewSpaceToLightViewSpace",		4 );
		pxShader->InitUniformElement( FP_CameraViewSpaceToWorldSpace,			"g_xCameraViewSpaceToWorldSpace",			4 );
		pxShader->InitUniformElement( FP_LightPos,								"g_xLightPos",								1 );
		pxShader->InitUniformElement( FP_TwoOverScreen,							"g_xTwoOverScreen",							1 );
		pxShader->InitUniformElement( FP_ScreenOffset,							"g_fScreenOffset",							1 );
		pxShader->InitUniformElement( FP_CameraTanHalfFOV,						"g_fCameraTanHalfFOV",						1 );
		pxShader->InitUniformElement( FP_DepthAdjustment,						"g_xDepthAdjustment",						1 );
		pxShader->InitUniformElement( FP_ShadowFilterTextureScale,				"g_fShadowFilterTextureScale",				1 );
		pxShader->InitUniformElement( FP_ShadowFilterSize,						"g_fShadowFilterSize",						1 );
		pxShader->InitUniformElement( FP_ShadowDirection,						"g_xShadowDirection",						1 );
		pxShader->InitUniformElement( FP_ShadowStrength,						"g_fShadowStrength",						1 );
		pxShader->InitUniformElement( FP_ShadowFrustumNearPlaneDistance,		"g_fShadowFrustumNearPlaneDistance",		1 );
		pxShader->InitUniformElement( FP_OneOverShadowFrustumPlaneSeparation,	"g_fOneOverShadowFrustumPlaneSeparation",	1 );
		pxShader->InitUniformElement( FP_SelfShadowBias,						"g_xSelfShadowBias",						1 );

		//Texture units
		pxShader->InitTextureUnit( FP_NormalMtlBuffer,			"g_xNormalMtlBuffer",		CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_NEAREST, CELL_GCM_TEXTURE_NEAREST );
		pxShader->InitTextureUnit( FP_DepthBuffer,				"g_xDepthBuffer",			CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_NEAREST, CELL_GCM_TEXTURE_NEAREST );
		pxShader->InitTextureUnit( FP_ShadowBuffer,				"g_xShadowBuffer",			CELL_GCM_TEXTURE_BORDER, CELL_GCM_TEXTURE_BORDER, CELL_GCM_TEXTURE_LINEAR, CELL_GCM_TEXTURE_LINEAR );
		pxShader->InitTextureUnit( FP_ShadowCubeBuffer,			"g_xShadowCubeBuffer",		CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_NEAREST, CELL_GCM_TEXTURE_NEAREST );
		pxShader->InitTextureUnit( FP_KernelRotationSampler,	"g_xKernelRotationSampler",	CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_LINEAR, CELL_GCM_TEXTURE_LINEAR );
	}
};

#endif //#ifndef __ASURA_PS3_APPLY_SHADOWS_FP_H__
