//
// FSFX_Bloom_FP.h
//
// Created by Ben Weston - 5 March 2008
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_FSFX_BLOOM_FP_H__
#define __ASURA_PS3_FSFX_BLOOM_FP_H__

extern u_int _binary_PS3_FSFX_Bloom_FP_bin_start;
extern u_int _binary_PS3_FSFX_Bloom_FP_bin_end;

extern u_int _binary_PS3_FSFX_Bloom_FP0_bin_start;
extern u_int _binary_PS3_FSFX_Bloom_FP0_bin_end;
extern u_int _binary_PS3_FSFX_Bloom_FP1_bin_start;
extern u_int _binary_PS3_FSFX_Bloom_FP1_bin_end;
extern u_int _binary_PS3_FSFX_Bloom_FP2_bin_start;
extern u_int _binary_PS3_FSFX_Bloom_FP2_bin_end;
extern u_int _binary_PS3_FSFX_Bloom_FP3_bin_start;
extern u_int _binary_PS3_FSFX_Bloom_FP3_bin_end;



enum FRAGMENT_SHADER_UNIFORM_B
{
	FPBLOOM_BloomTint,
	FPBLOOM_BloomScale,
	FPBLOOM_BloomBias,
	FPBLOOM_BloomLevel,
	FPBLOOM_BloomRcpSizes,

	FPB_ELEMENTS
};

enum TEXTURE_UNITS_B
{
	FPB_BlurImage,
	FPB_InitialImage,
	FPB_TU_ELEMENTS
};

class Asura_PS3_FSFX_B_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_FSFX_B_Handles() : Asura_PS3_FP_Handles( FPB_ELEMENTS, FPB_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitUniformElement( FPBLOOM_BloomTint,	"g_xExtractTint", 1 );
		pxShader->InitUniformElement( FPBLOOM_BloomScale,	"g_fExtractScale", 1 );
		pxShader->InitUniformElement( FPBLOOM_BloomBias,	"g_fExtractBias", 1 );
		pxShader->InitUniformElement( FPBLOOM_BloomLevel,	"g_fApplyLevel", 1 );
		pxShader->InitUniformElement( FPBLOOM_BloomRcpSizes,	"g_xRcpScreenSizes", 1 );

//BW point sample? not good for final scale-up
		pxShader->InitTextureUnit( FPB_BlurImage, "g_xBlurImage", CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_LINEAR, CELL_GCM_TEXTURE_LINEAR
			, true
			);
		pxShader->InitTextureUnit( FPB_InitialImage, "g_xInitialImage", CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_LINEAR, CELL_GCM_TEXTURE_LINEAR
			, true
			);
	}
};

#endif //#ifndef __ASURA_PS3_FSFX_BLOOM_FP_H__
