//
// FSFX_DoubleVision_FP.h
//
// Created by Steve Barnett - 01 February 2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_FSFX_DOUBLEVISION_FP_H__
#define __ASURA_PS3_FSFX_DOUBLEVISION_FP_H__

extern u_int _binary_PS3_FSFX_DoubleVision_FP_bin_start;
extern u_int _binary_PS3_FSFX_DoubleVision_FP_bin_end;

enum FRAGMENT_SHADER_UNIFORM_DV
{
	FPDV_Data1,

	FPDV_ELEMENTS
};

enum TEXTURE_UNITS_DV
{
	FPDV_TextureSampler,
	FPDV_TU_ELEMENTS
};

class Asura_PS3_FSFX_DV_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_FSFX_DV_Handles() : Asura_PS3_FP_Handles( FPDV_ELEMENTS, FPDV_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitUniformElement( FPDV_Data1,	"g_fData1", 4 );

		pxShader->InitTextureUnit( FPDV_TextureSampler, "g_xTextureSampler", CELL_GCM_TEXTURE_MIRROR, CELL_GCM_TEXTURE_MIRROR, CELL_GCM_TEXTURE_LINEAR, CELL_GCM_TEXTURE_LINEAR
			, true
			);
	}
};

#endif //#ifndef __ASURA_PS3_FSFX_DOUBLEVISION_FP_H__
