//
// FSFX_RadialBlur_FP.h
//
// Created by Catalin Arsenescu - 11 September 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_FSFX_RADIALBLUR_FP_H__
#define __ASURA_PS3_FSFX_RADIALBLUR_FP_H__

extern u_int _binary_PS3_FSFX_RadialBlur_FP_bin_start;
extern u_int _binary_PS3_FSFX_RadialBlur_FP_bin_end;

enum FRAGMENT_SHADER_UNIFORM_RB
{
	FPRB_SampleWeights,

	FPRB_ELEMENTS
};

enum TEXTURE_UNITS_RB
{
	FPRB_Texture,

	FPRB_TU_ELEMENTS
};

class Asura_PS3_FSFX_RB_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_FSFX_RB_Handles() : Asura_PS3_FP_Handles( FPRB_ELEMENTS, FPRB_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitUniformElement( FPRB_SampleWeights,	"g_fSampleWeights",	1 );

		pxShader->InitTextureUnit( FPRB_Texture,	"g_xTexture",	CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_NEAREST, CELL_GCM_TEXTURE_NEAREST
			, true
			);
	}
};

#endif //#ifndef __ASURA_PS3_FSFX_RADIALBLUR_FP_H__
