//
// LightShaftCorona_FP.h
//
// Created by Catalin Arsenescu - 29 August 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_LIGHTSHAFTCORONA_FP_H__
#define __ASURA_PS3_LIGHTSHAFTCORONA_FP_H__

extern u_int _binary_PS3_LightShaft_Corona_FP_bin_start;
extern u_int _binary_PS3_LightShaft_Corona_FP_bin_end;

enum FRAGMENT_SHADER_UNIFORM_CORONA
{
	FPC_DepthAdjustment,

	FPC_ELEMENTS
};

enum TEXTURE_UNITS_CORONA
{
	FPC_DepthBufferSampler,
	FPC_TextureSampler,

	FPC_TU_ELEMENTS
};

class Asura_PS3_LightShaftC_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_LightShaftC_Handles() : Asura_PS3_FP_Handles( FPC_ELEMENTS, FPC_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitUniformElement( FPC_DepthAdjustment,		"g_xDepthAdjustment",		1 );

		pxShader->InitTextureUnit( FPC_DepthBufferSampler,	"g_xDepthBufferSampler",	CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_NEAREST, CELL_GCM_TEXTURE_NEAREST );
		pxShader->InitTextureUnit( FPC_TextureSampler,		"g_xTextureSampler",		CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_LINEAR_LINEAR, CELL_GCM_TEXTURE_LINEAR
			, true
			);
	}
};

#endif //#ifndef __ASURA_PS3_LIGHTSHAFTCORONA_FP_H__
