//
// OverlayQuad_FP.h
//
// Created by Catalin Arsenescu - 26 August 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_OVERLAYQUAD_FP_H__
#define __ASURA_PS3_OVERLAYQUAD_FP_H__

extern u_int _binary_PS3_Overlay_Quad_FP_bin_start;
extern u_int _binary_PS3_Overlay_Quad_FP_bin_end;

extern u_int _binary_PS3_Overlay_Quad_HDR_FP_bin_start;
extern u_int _binary_PS3_Overlay_Quad_HDR_FP_bin_end;

extern u_int _binary_PS3_Overlay_Quad_Gamma_FP_bin_start;
extern u_int _binary_PS3_Overlay_Quad_Gamma_FP_bin_end;

extern u_int _binary_PS3_Overlay_Quad_FudgedGamma_FP_bin_start;
extern u_int _binary_PS3_Overlay_Quad_FudgedGamma_FP_bin_end;

enum TEXTURE_UNITS
{
	FP_Sampler,

	FP_TU_ELEMENTS
};

class Asura_PS3_QuadOverlay_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_QuadOverlay_Handles() : Asura_PS3_FP_Handles( 0, FP_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitTextureUnit( FP_Sampler,	"xSampler",	CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_LINEAR_LINEAR, CELL_GCM_TEXTURE_LINEAR, false );
	}
};

class Asura_PS3_QuadOverlay_FudgedGamma_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_QuadOverlay_FudgedGamma_Handles() : Asura_PS3_FP_Handles( 0, FP_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitTextureUnit( FP_Sampler,	"xSampler",	CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_LINEAR_LINEAR, CELL_GCM_TEXTURE_LINEAR, true );
	}
};


class Asura_PS3_QuadOverlay_HDR_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_QuadOverlay_HDR_Handles() : Asura_PS3_FP_Handles( 0, FP_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitTextureUnit( FP_Sampler,	"xSampler",	CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_LINEAR_LINEAR, CELL_GCM_TEXTURE_LINEAR );
	}
};

#ifdef ASURA_PS3_USE_GAMMA_CORRECTION
enum FRAGMENT_SHADER_UNIFORM_BC
{
	FPQO_GAMMA,
	FPQO_ELEMENTS
};

class Asura_PS3_QuadOverlay_Gamma_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_QuadOverlay_Gamma_Handles() : Asura_PS3_FP_Handles( FPQO_ELEMENTS, FP_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitUniformElement( FPQO_GAMMA,	"g_fGamma",		1 );

		pxShader->InitTextureUnit( FP_Sampler,	"xSampler",	CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_LINEAR_LINEAR, CELL_GCM_TEXTURE_LINEAR );
	}
};
#endif

#endif //#ifndef __ASURA_PS3_OVERLAYQUAD_FP_H__
