//
// BotaniclasGeometry_VP.h
//
// Created by Catalin Arsenescu - 07 September 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_BOTANICALS_GEOMETRY_VP_H__
#define __ASURA_PS3_BOTANICALS_GEOMETRY_VP_H__

extern uint32_t _binary_PS3_Botanicals_Geometry_VP_bin_start;
extern uint32_t _binary_PS3_Botanicals_Geometry_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axVertexShaderGeometryUniform[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xViewProjectionMatrix",	    1, 4, NULL },
	{ "g_xCameraPosition",			    1, 1, NULL },
	{ "g_xUV_Offsets",					1, 1, NULL },
};

enum VERTEX_SHADER_UNIFORM_GEOMETRY
{
	VSG_ViewProjectionMatrix,
	VSG_CameraPosition,
	VSG_UV_Offsets,
};

class Asura_PS3_VP_BotanicalGeometry : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_BotanicalGeometry() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_Botanicals_Geometry_VP_bin_start, (unsigned char *)&_binary_PS3_Botanicals_Geometry_VP_bin_end, g_axVertexShaderGeometryUniform, sizeof ( g_axVertexShaderGeometryUniform ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~Asura_PS3_VP_BotanicalGeometry()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axVertexShaderGeometryUniform ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axVertexShaderGeometryUniform[ i ].CleanUp();
		}
	}
};

#endif //#ifndef __ASURA_PS3_BOTANICALS_GEOMETRY_VP_H__
