//
// Carpet_VP.h
//
// Created by Catalin Arsenescu - 12 November 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_CARPET_VP_H__
#define __ASURA_PS3_CARPET_VP_H__

extern uint32_t _binary_PS3_Carpet_VP_bin_start;
extern uint32_t _binary_PS3_Carpet_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axCarpetUniform[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xCameraPosition",				 1, 1, NULL },
	{ "xConstants.m_afTransform",		 4, 1, NULL },
	{ "xConstants.m_afBillboardRight",	 1, 1, NULL },
	{ "xConstants.m_afBillboardUp",		 1, 1, NULL },
	{ "xConstants.m_afCameraPlane",		 1, 1, NULL },
	{ "xConstants.m_afConstants2",		 1, 1, NULL },
	{ "xConstants.m_afCorners",			 4, 1, NULL },
	{ "xConstants.m_afWaves",			16, 1, NULL },
//	{ "xConstants.m_afFogGraphPlane",	 1, 1, NULL },
//	{ "xConstants.m_afFogGraphScale",	 2, 1, NULL },
//	{ "xConstants.m_afFogGraphCoeffs",	 2, 1, NULL },
//	{ "xConstants.m_afDynamicLightX",	 1, 1, NULL },
//	{ "xConstants.m_afDynamicLightY",	 1, 1, NULL },
//	{ "xConstants.m_afDynamicLightZ",	 1, 1, NULL },
	{ "xStyles.m_afDetails",			20, 1, NULL },
	{ "xStyles.m_afUV",					20, 1, NULL },
	{ "g_f4MovementScale",				 1, 1, NULL }
};

enum VERTEX_SHADER_UNIFORM
{
	VP_CameraPosition,
	VP_Transform,
	VP_BillboardRight,
	VP_BillboardUp,
	VP_CameraPlane,
	VP_Constants2,
	VP_Corners,
	VP_Waves,
//	VP_FogGraphPlane,
//	VP_FogGraphScale,
//	VP_FogGraphCoeffs,
//	VP_DynamicLightX,
//	VP_DynamicLightY,
//	VP_DynamicLightZ,
	VP_Details,
	VP_UV,
	VP_MovementScale
};

class Asura_PS3_VP_Carpet : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_Carpet() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_Carpet_VP_bin_start, (unsigned char *)&_binary_PS3_Carpet_VP_bin_end, g_axCarpetUniform, sizeof ( g_axCarpetUniform ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~Asura_PS3_VP_Carpet()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axCarpetUniform ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axCarpetUniform[ i ].CleanUp();
		}
	}
};

#endif //#ifndef __ASURA_PS3_CARPET_VP_H__
