//
// EnvDynamicLight_VP.h
//
// Created by Catalin Arsenescu - 26 August 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_ENV_DYNAMICLIGHT_VP_H__
#define __ASURA_PS3_ENV_DYNAMICLIGHT_VP_H__

extern uint32_t _binary_PS3_Env_DynamicLighting_VP_bin_start;
extern uint32_t _binary_PS3_Env_DynamicLighting_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axEnvironmentDLUniform[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xViewProjectionMatrix",	1, 4, NULL },
	{ "g_xCameraPosition",			1, 1, NULL },
	{ "g_xLightPosition",			1, 1, NULL },
	{ "g_fOneOverLightRange",		1, 1, NULL },
};

enum VERTEX_SHADER_UNIFORM_DL
{
	DL_LightPos = 2,
	DL_LightOneOverRange = 3
};

class Asura_PS3_VP_Env_DL : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_Env_DL() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_Env_DynamicLighting_VP_bin_start, (unsigned char *)&_binary_PS3_Env_DynamicLighting_VP_bin_end, g_axEnvironmentDLUniform, sizeof ( g_axEnvironmentDLUniform ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~Asura_PS3_VP_Env_DL()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axEnvironmentDLUniform ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axEnvironmentDLUniform[ i ].CleanUp();
		}
	}
};

#endif //#ifndef __ASURA_PS3_ENV_DYNAMICLIGHT_VP_H__
