//
// LightShaftCorona_VP.h
//
// Created by Catalin Arsenescu - 29 August 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_LIGHTSHAFTCORONA_VP_H__
#define __ASURA_PS3_LIGHTSHAFTCORONA_VP_H__

extern u_int _binary_PS3_LightShaft_Corona_VP_bin_start;
extern u_int _binary_PS3_LightShaft_Corona_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axVertexShaderUniformCorona[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xViewProjectionMatrix",	1, 4, NULL },
	{ "g_xPosOrient",				1, 4, NULL },
};

enum VERTEX_SHADER_UNIFORM_CORONA
{
	VPC_ViewProjectionMatrix,
	VPC_PosOrient,
};

class Asura_PS3_VP_LightShaft_Corona : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_LightShaft_Corona() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_LightShaft_Corona_VP_bin_start, (unsigned char *)&_binary_PS3_LightShaft_Corona_VP_bin_end, g_axVertexShaderUniformCorona, sizeof ( g_axVertexShaderUniformCorona ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~Asura_PS3_VP_LightShaft_Corona()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axVertexShaderUniformCorona ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axVertexShaderUniformCorona[ i ].CleanUp();
		}
	}
};

#endif //#ifndef __ASURA_PS3_LIGHTSHAFTCORONA_VP_H__
