//
// Object_VP.h
//
// Created by Catalin Arsenescu - 26 August 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_OBJECT_VP_H__
#define __ASURA_PS3_OBJECT_VP_H__

extern u_int _binary_PS3_Object_VP_bin_start;
extern u_int _binary_PS3_Object_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axVertexUniform[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xWorldViewProjectionMatrix",	1, 4, NULL },
	{ "g_xWorldMatrix",					1, 4, NULL },
	{ "g_xCameraPosition",				1, 1, NULL },
	{ "g_xUV_Offsets",					1, 1, NULL },
};

enum VERTEX_SHADER_UNIFORM
{
	VS_WorldViewProjectionMatrix,
	VS_WorldMatrix,
	VS_CameraPosition,
	VS_UV_Offsets,
};

class Asura_PS3_VP_ObjectH : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_ObjectH() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_Object_VP_bin_start, (unsigned char *)&_binary_PS3_Object_VP_bin_end, g_axVertexUniform, sizeof ( g_axVertexUniform ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~Asura_PS3_VP_ObjectH()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axVertexUniform ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axVertexUniform[ i ].CleanUp();
		}
	}
};

#endif //#ifndef __ASURA_PS3_OBJECT_VP_H__
