//
// SmoothSkin_SpuSkinning_VP.h
//
// Ben Weston - 30/05/08
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_SMOOTHSKIN_SPUSKINNING_VP_H__
#define __ASURA_PS3_SMOOTHSKIN_SPUSKINNING_VP_H__

extern uint32_t _binary_PS3_SmoothSkin_SpuSkinning_VP_bin_start;
extern uint32_t _binary_PS3_SmoothSkin_SpuSkinning_VP_bin_end;

extern uint32_t _binary_PS3_SmoothSkin_SpuSkinning_DM_VP_bin_start;
extern uint32_t _binary_PS3_SmoothSkin_SpuSkinning_DM_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axSpuSkinningParameters[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xWorldViewProjectionMatrix",	1, 4, NULL },
	{ "g_xWorldMatrix",					1, 4, NULL },
	{ "g_xCameraPosition",				1, 1, NULL },
	{ "g_axTransforms",				  450, 1, NULL },
	{ "g_xUV_Offsets",					1, 1, NULL },
};

static Asura_PS3_GCM_VertexShaderUniformParameter g_axSpuSkinningParametersDM[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xWorldViewProjectionMatrix",	1, 4, NULL },
	{ "g_xWorldMatrix",					1, 4, NULL },
	{ "g_xCameraPosition",				1, 1, NULL },
	{ "g_axTransforms",				  450, 1, NULL },
	{ "g_xUV_Offsets",					1, 1, NULL },
};


class Asura_PS3_VP_SmoothSkin_SpuSkinning : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_SmoothSkin_SpuSkinning() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_SmoothSkin_SpuSkinning_VP_bin_start, (unsigned char *)&_binary_PS3_SmoothSkin_SpuSkinning_VP_bin_end, g_axSpuSkinningParameters, NUM_SMOOTH_SKIN_PARAMETERS )
	{
	}

	~Asura_PS3_VP_SmoothSkin_SpuSkinning()
	{
		u_int i;
		for( i = 0; i < NUM_SMOOTH_SKIN_PARAMETERS; ++i )
		{
			g_axSpuSkinningParameters[ i ].CleanUp();
		}
	}
};

class Asura_PS3_VP_SmoothSkin_SpuSkinning_DM : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_SmoothSkin_SpuSkinning_DM() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_SmoothSkin_SpuSkinning_DM_VP_bin_start, (unsigned char *)&_binary_PS3_SmoothSkin_SpuSkinning_DM_VP_bin_end, g_axSpuSkinningParametersDM, NUM_SMOOTH_SKIN_PARAMETERS )
	{
	}

	~Asura_PS3_VP_SmoothSkin_SpuSkinning_DM()
	{
		u_int i;
		for( i = 0; i < NUM_SMOOTH_SKIN_PARAMETERS; ++i )
		{
			g_axSpuSkinningParametersDM[ i ].CleanUp();
		}
	}
};

#endif //#ifndef __ASURA_PS3_SMOOTHSKIN_SPUSKINNING_VP_H__
