// Asura_PS3_DSP_Params.h
// Thomas Young - 02.04.09
// Copyright (C) 2009 Rebellion, All Rights Reserved.

#ifndef _ASURA_PS3_DSP_PARAMS_H_
#define _ASURA_PS3_DSP_PARAMS_H_

// ***************************************************************************************************
// DO NOT #include any files here, this is included by DSP effect projects which need to be kept tiny
//
// This file lists the DSP parameters passed to each effect from the PS3 audio code.
// They do not necessarily match the parameters in Asura_Audio_DSP.h, since they may
// include additional PS3 specific data
//
// ***************************************************************************************************

namespace Asura_PS3_DSP_Params
{
	// __________________________________________________________________________

	struct AddNoise
	{
		static const unsigned int uNOISE_SAMPLES		= 512;
		static const unsigned int uSCRATCH_MEMORY_REQ	= uNOISE_SAMPLES * sizeof( float );

		float m_fNoiseAmount;

		void* m_pScratchMem;								// main memory for use in the effect
		unsigned int m_uScratchMemSize;						// size of this memory
	};

	// __________________________________________________________________________

	struct SimpleFilter
	{
		static const unsigned int uNUM_COEFFICIENTS		= 25;	// Must match Asura_DSP_Params_SimpleFilter::uFILTER_NUM_COEFFICIENTS
		static const unsigned int uSCRATCH_MEMORY_REQ	= 1024 * sizeof(float);//= 32 * sizeof( float );

		float m_fGain;
		bool m_bValid;

		float m_afCoefficients[ uNUM_COEFFICIENTS ];		// Precalced filter coefficients

		void* m_pScratchMem;								// main memory for use in the effect
		unsigned int m_uScratchMemSize;						// size of this memory
	};

	// __________________________________________________________________________
};

#endif