//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS3_MsgBox.h
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
// Description:
//
//     Wrapper Class for PS3 Utilities Message display
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ASURA_PS3_MSGBOX_H___
#define ASURA_PS3_MSGBOX_H___ 1

#include "Core/Asura_PlatformBasics.h"	// for Asura_UnicodeChar

#include <sysutil/sysutil_msgdialog.h>

class Asura_PS3_MsgBox
{
public:
	enum START_SOUND
	{
		START_SOUND_NONE = 0,
		START_SOUND_NORMAL,
		START_SOUND_ERROR
	};
	static bool DisplaySonyError(u_int uErrorCode);
	static bool DisplayMessage(const Asura_UnicodeChar* wszMessage, bool bOKButton = true, START_SOUND eSound = START_SOUND_NORMAL);
	static bool DisplayQuestion(const Asura_UnicodeChar* wszMessage, bool bHighlightYes = false, START_SOUND eSound = START_SOUND_NORMAL);
	static bool IsDisplaying() { return s_bDisplaying; }
	static bool LastQuestionAnswer() { return s_bLastQuestionAnswer; }
private:
	static void CallBack(int iButtonType, void* pUserData);

	static bool s_bDisplaying;
	static bool s_bLastQuestionAnswer;
	static char s_szMessage[CELL_MSGDIALOG_STRING_SIZE];
};


// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ASURA_PS3_MSGBOX_H___
