//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS3_SPURS_PFX.cpp
//
// Copyright (c) 2005 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////


#include "Core/Asura.h"

#include "Asura_PS3_SPURS_PFX.h"
#include "Debugging/Asura_Assert.h"

#include "PS3/PPU_SPU_UTILS/Asura_PS3_SPU_HelperStructs.h"
#include "PS3/PPU_SPU_UTILS/Asura_PS3_SPURS.h"
#include "PS3/PPU_SPU_UTILS/Asura_PS3_SPURS_TaskController.h"	


extern const char _binary_task_Pfx_Taskset_elf_start[];	

u_int							Asura_PS3_SPURS_PFX::m_uNumber_Of_SPU_Threads			= 1;
Asura_PS3_SPURS_TaskController*	Asura_PS3_SPURS_PFX::m_pxSPURS_PFX_TaskController	= NULL;

PFX_TaskParameters				Asura_PS3_SPURS_PFX::m_xTaskParams;


void Asura_PS3_SPURS_PFX::Initialise( u_int	uMaxQueueSize, u_int uQueueElementSize )
{
	m_pxSPURS_PFX_TaskController = new Asura_PS3_SPURS_TaskController( m_uNumber_Of_SPU_Threads, "PFX_Taskset", _binary_task_Pfx_Taskset_elf_start, uQueueElementSize, uMaxQueueSize );
}

void	Asura_PS3_SPURS_PFX::Shutdown( void )
{
	m_pxSPURS_PFX_TaskController->End();
	delete m_pxSPURS_PFX_TaskController;
}

void	Asura_PS3_SPURS_PFX::Begin( void )
{
	m_pxSPURS_PFX_TaskController->Begin( (void*)&m_xTaskParams );
}
