
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_Platform_Corona_System.cpp
// Author : Andy Tate
// Date   : 29-Jun-2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "SpecialFX/Asura_Corona_System.h"

// Asura header-files...
#include "Camera/Asura_Camera.h"
#include "Core/Asura_TiledTextureManagement.h"
#include "Rendering/Asura_Colour.h"
#include "Rendering/Asura_Render.h"

#include "Rendering/Shaders/Asura_PS3_GCM_Shader.h"
#include "Rendering/Asura_PS3_GCM_VertexBuffer.h"
#include "Rendering/Asura_PS3_Graphics.h"
#include "Rendering/Asura_PS3_FrameBuffer.h"
#include "Rendering/Asura_PS3_GCM_IndexBuffer.h"
#include "Rendering/Asura_PS3_RenderingOptions.h"
#include "Rendering/Asura_PS3_TextureManagement.h"
#include "Rendering/Asura_PS3_RenderingStates.h"
#include "SpecialFX/Asura_PS3_Corona_System.h"

// Game header-files...


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////
// All platform calls passed straight to Asura_Direct3D_CoronaSystem
void Asura_Corona_System::Platform_Initialise()		{ Asura_PS3_CoronaSystem::Initialise(); }
void Asura_Corona_System::Platform_Shutdown()		{ Asura_PS3_CoronaSystem::Shutdown(); }
void Asura_Corona_System::Platform_RenderStart(void){ Asura_PS3_CoronaSystem::RenderStart(); }
void Asura_Corona_System::Platform_RenderEnd(void)	{ Asura_PS3_CoronaSystem::RenderEnd(); }
void Asura_Corona_System::Platform_RenderCorona(const Asura_Corona* pxCorona, u_int uCamVisFlags)
													{ Asura_PS3_CoronaSystem::RenderCorona(pxCorona, uCamVisFlags); }

/// End of file. ///
