///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_PSP_BotanicalsShape.cpp
// Author : Catalin Arsenescu
// Date   : 09-March-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////
#include "Core\Asura.h"

#ifdef ASURA_USE_BOTANICALS

// This file's header
#include "Botanicals/Asura_PSP_BotanicalsShape.h"

// Asura independent headers
#include "Botanicals/Asura_Botanical_Game_Render_Instance.h"
#include "Debugging\Asura_Assert.h"

// Sony libraries

// PSP headers
#include "Botanicals/Asura_PSP_BotanicalsSystem.h"
#include "Botanicals/Asura_PSP_BotanicalsTemplate.h"
#include "Botanicals/Asura_PSP_BotanicalsElement.h"

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_PSP_BotanicalsShape::Asura_PSP_BotanicalsShape
// Author       : Catalin Arsenescu
// Date         : 09-March-2007
////////////////////////////////////////////////////////////////////////////////
Asura_PSP_BotanicalsShape::Asura_PSP_BotanicalsShape()
: m_pxElements(NULL)
, m_uHashID(0)
, m_uNumElements(0)
{
}
/// End of function 'Asura_PSP_BotanicalsShape::Asura_PSP_BotanicalsShape'. ///

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_PSP_BotanicalsShape::~Asura_PSP_BotanicalsShape
// Author       : Catalin Arsenescu
// Date         : 09-March-2007
////////////////////////////////////////////////////////////////////////////////
Asura_PSP_BotanicalsShape::~Asura_PSP_BotanicalsShape()
{
	delete[] m_pxElements;
	m_pxElements = NULL;
	m_uNumElements = 0;
}
/// End of function 'Asura_PSP_BotanicalsShape::~Asura_PSP_BotanicalsShape'. ///

#endif	//#ifdef ASURA_USE_BOTANICALS
