//*******************************************************************
//
// File: Asura_Platform_Botanicals_InstanceManager.cpp
//
// Created: 05 Oct 2006
//
// Description: 
//
//*******************************************************************

// system libraries
#include "Core/Asura.h"

#if defined( ASURA_USE_BOTANICALS )

#include "Debugging/Asura_PSP_Profiling.h"


// main header
#include "Botanicals/Asura_Botanicals_TemplateManager.h"
#include "Botanicals/Asura_Botanicals_InstanceManager.h"

// Platform specific files
#include "Botanicals/Asura_PSP_BotanicalsSystem.h"


// other libraries

// internal dependencies

//*******************************************************************
// Static 
//*******************************************************************

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Local Classes
//*******************************************************************


//*******************************************************************
// Function Definitions
//*******************************************************************

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Botanicals_InstanceManager::Platform_Initialise
// Author       : Catalin Arsenescu
// Date         : 12-March-2007
////////////////////////////////////////////////////////////////////////////////
void Asura_Botanicals_InstanceManager::Platform_Initialise()
{
	Asura_PSP_BotanicalsSystem::Initialise();
}
/// End of function 'Asura_Botanicals_InstanceManager::Platform_Initialise'. ///

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Botanicals_InstanceManager::Platform_Shutdown
// Author       : Catalin Arsenescu
// Date         : 12-March-2007
////////////////////////////////////////////////////////////////////////////////
void Asura_Botanicals_InstanceManager::Platform_Shutdown()
{
	Asura_PSP_BotanicalsSystem::Shutdown();
}
/// End of function 'Asura_Botanicals_InstanceManager::Platform_Shutdown'. ///

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Botanicals_InstanceManager::Platform_Reset
// Author       : Catalin Arsenescu
// Date         : 12-March-2007
////////////////////////////////////////////////////////////////////////////////
void Asura_Botanicals_InstanceManager::Platform_Reset()
{
	Asura_PSP_BotanicalsSystem::Reset();
}
/// End of function 'Asura_Botanicals_InstanceManager::Platform_Reset'. ///

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Botanicals_InstanceManager::Platform_Render
// Author       : Catalin Arsenescu
// Date         : 12-March-2007
////////////////////////////////////////////////////////////////////////////////
void Asura_Botanicals_InstanceManager::Platform_Render( const float fGlobalFade )
{
#ifdef ASURA_PSP_PROFILING
	Asura_PSP_Profiling::Signal( Asura_PSP_Profiling::ASURA_PSP_SIGNAL_BOTANICALS_START ); 
#endif //ASURA_PSP_PROFILING

	Asura_PSP_BotanicalsSystem::Render( fGlobalFade );

#ifdef ASURA_PSP_PROFILING
	Asura_PSP_Profiling::Signal( Asura_PSP_Profiling::ASURA_PSP_SIGNAL_BOTANICALS_END ); 
#endif //ASURA_PSP_PROFILING
}
/// End of function 'Asura_Botanicals_InstanceManager::Platform_Render'. ///

#endif //defined( ASURA_USE_BOTANICALS)

//*******************************************************************
//
// (c) 2006 Rebellion 
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************
