//////////////////////////////////////////////////////////////////////////////
//
// Asura_FlyCam.cpp
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
// Description:
//
//     Basic camera controlled by analogue sticks or buttons. Intended only
//     for debugging and prototyping purposes. 
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#ifdef ASURA_SUPPORT_FLYCAM

// This file's header.
#include "Camera/Asura_FlyCam.h"

// PSP
#include "Input/Asura_PlatformInput.h"

void Asura_FlyCam::Platform_Initialise(void)
{
	AddMoveForwardsBackwardsMapping(ASURA_PSP_KEYID_PAD1_TRIANGLE, ASURA_PSP_KEYID_PAD1_CROSS);
	AddMoveLeftRightMapping(ASURA_PSP_KEYID_PAD1_SQUARE, ASURA_PSP_KEYID_PAD1_CIRCLE);
	AddMoveUpDownMapping(ASURA_PSP_KEYID_PAD1_UP, ASURA_PSP_KEYID_PAD1_DOWN);

	AddRollMapping(ASURA_PSP_KEYID_PAD1_LEFT, ASURA_PSP_KEYID_PAD1_RIGHT);
	AddPitchMapping(ASURA_AXIS_PAD1_LSTICK_V);
	AddYawMapping(ASURA_AXIS_PAD1_LSTICK_H);

	AddFastMapping(ASURA_PSP_KEYID_PAD1_L1, ASURA_PSP_KEYID_PAD1_R1);

	AddResetRollMapping(ASURA_PSP_KEYID_PAD1_L3);

	AddInvertYMapping(ASURA_PSP_KEYID_PAD1_SELECT);
}

void Asura_FlyCam::Platform_Shutdown(void)
{
}

#endif // #ifdef ASURA_SUPPORT_FLYCAM
