//////////////////////////////////////////////////////////////////////////////
//
// Asura_Chunk_ResourceFile_PSP_SoundData.cpp
//
// Copyright (c) 2005 Rebellion. All rights reserved.
//
// Description:
//
//     chunk for concatenated VAG sound data, with header information at the
//     end.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header.
#include "ChunkSystem/Asura_Chunk_ResourceFile_PSP_SoundData.h"

// independent
#include "ChunkSystem/Asura_Chunk_Macros.h"

// PSP
#include "Sound/Asura_PSP_SAS.h"

// C L A S S   I M P L E M E N T A T I O N ///////////////////////////////////
bool Asura_Chunk_ResourceFile_PSP_SoundData::Process(Asura_Handle iFileHandle)
{
	u_int uVersion;
	ASURA_CHUNK_FILEEXTRACT( iFileHandle, uVersion, u_int );

	if (uVersion != uASURA_PSP_SOUNDDATA_CHUNK_VERSION)
	{
		Asura_Assert(false, "unsupported PSP sound data chunk version");
		return false;
	}

	u_int uSoundDataSize;
	u_int uNumEntries;
	ASURA_CHUNK_FILEEXTRACT( iFileHandle, uSoundDataSize, u_int );
	ASURA_CHUNK_FILEEXTRACT( iFileHandle, uNumEntries, u_int );

	return Asura_PSP_SAS::LoadSoundBlock(iFileHandle, uSoundDataSize, uNumEntries);
}

// E N D   O F   F I L E /////////////////////////////////////////////////////
