//
// Asura_PSP_Thread_Priorities.h
//
// Created by Andrew Weinkove - 6/12/05
//
// Thread priorities all set in one place for easy tweaking.
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PSP_THREAD_PRIORITIES_H__
#define __ASURA_PSP_THREAD_PRIORITIES_H__

#include <thread.h>

static const int iASURA_THREAD_PRIORITY_CALLBACKS = SCE_KERNEL_USER_HIGHEST_PRIORITY;
static const int iASURA_THREAD_PRIORITY_NETINTR = SCE_KERNEL_USER_HIGHEST_PRIORITY + 1;

static const int iASURA_THREAD_PRIORITY_ADHOC_CALLOUT = SCE_KERNEL_USER_HIGHEST_PRIORITY + 2;
static const int iASURA_THREAD_PRIORITY_ADHOCCTL = SCE_KERNEL_USER_HIGHEST_PRIORITY + 3;

static const int iASURA_THREAD_PRIORITY_INFRASTRUCTUREMODE_CALLOUT = SCE_KERNEL_USER_HIGHEST_PRIORITY + 2;
static const int iASURA_THREAD_PRIORITY_INFRASTRUCTUREMODE_APCTL = SCE_KERNEL_USER_HIGHEST_PRIORITY + 3;

static const int iASURA_THREAD_PRIORITY_SIMPLE_AUDIO_UPDATE_THREAD = SCE_KERNEL_USER_HIGHEST_PRIORITY + 4;
static const int iASURA_THREAD_PRIORITY_SAS_UPDATE_THREAD = SCE_KERNEL_USER_HIGHEST_PRIORITY + 5;
static const int iASURA_THREAD_PRIORITY_ATRAC_UPDATE_THREAD = SCE_KERNEL_USER_HIGHEST_PRIORITY + 6;
static const int iASURA_THREAD_PRIORITY_UTILITY_BASE = SCE_KERNEL_USER_HIGHEST_PRIORITY + 7;
static const int iASURA_THREAD_PRIORITY_KEEP_UMD_SPINNING = 32;

static const int iASURA_THREAD_PRIORITY_MAIN_THREAD_NORMAL = 32;
static const int iASURA_THREAD_PRIORITY_MAIN_THREAD_DURING_ADHOC = 64;

#endif //#ifndef __ASURA_PSP_THREAD_PRIORITIES_H__
