//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_MemoryManagement.h (PSP)
//
// Created by Mike Healey.
//
// Copyright (c) 2002 Rebellion. All rights reserved.
//
// provides defines for platform-specific memory manager functionality
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PLATFORM_MEMORYMANAGEMENT_H___
#define ___ASURA_PLATFORM_MEMORYMANAGEMENT_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

#include <malloc.h>
#include <stdint.h> // uintptr_t, etc.

// M A C R O S ///////////////////////////////////////////////////////////////

#define ASURA_MEMORYMANAGEMENT_PLATFORM_INIT_WHEN_DISABLED (0)

// P R O T O T Y P E S   A N D   I N L I N E   F U N C T I O N S /////////////

extern void Asura_PSP_EnableOutOfMemoryScreen(bool bEnable);

#ifndef ASURA_MEMORYMANAGEMENT_ENABLED

inline void* Asura_AllocateAlign(unsigned int bytes, enum ASURA_ALIGN_ID alignment)
{
	return memalign(alignment, bytes);
}

inline void Asura_DeallocateAlign(void* address)
{
	return free(address);
}

#endif


// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_PLATFORM_MEMORYMANAGEMENT_H___
