//
// Asura_PSP_GU.h
//
// Created by RJT - 04/04/07
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_PSP_GU_H__
#define __ASURA_PSP_GU_H__

// Include(s)
#include "ProjectSettings/Asura_PSPConfiguration.h"

#include <LibGU.h>
#include <LibGUM.h>
#ifdef ASURA_PSP_SCEEGU
	typedef uint8 u8;
	typedef uint16 u16;
	typedef uint32 u32;
	typedef int16 s16;
	typedef int32 s32;
	typedef float f32;
	#include "Sony\PSP\Include\SceePspGu.h"
	#include "Sony\PSP\Include\SceePspGum.h"
#endif

// GU library call wrappers
#ifdef ASURA_PSP_SCEEGU
	using namespace scee::Psp;
	#define GU_Init()								Gu::Init()
	#define GU_Display( p1 )						Gu::Display( static_cast< Gu::EDisplayStatus >( p1 ) )
	#define GU_Start( p1, p2, p3 )					Gu::Start( static_cast< Gu::EDisplayListMode >( p1 ), p2, p3 )
	#define GU_DrawBuffer( p1, p2, p3 )				Gu::DrawBuffer( static_cast< Gu::EColorFormat >( p1 ), reinterpret_cast< uint8 * >( p2 ), p3 )
	#define GU_DrawBufferList( p1, p2, p3 )			Gu::DrawBufferList( static_cast< Gu::EColorFormat >( p1 ), reinterpret_cast< uint8 * >( p2 ), p3 )
	#define GU_DispBuffer( p1, p2, p3, p4 )			Gu::DispBuffer( p1, p2, reinterpret_cast< uint8 * >( p3 ), p4 )
	#define GU_DepthBuffer( p1, p2 )				Gu::DepthBuffer( reinterpret_cast< uint8 * >( p1 ), p2 )
	#define GU_SetDither( p1 )						Gu::SetDither( p1 )
	#define GU_Enable( p1 )							Gu::Enable( static_cast< Gu::EFunctionName >( p1 ) )
	#define	GU_Disable( p1 )						Gu::Disable( static_cast< Gu::EFunctionName >( p1 ) )
	#define GU_Finish()								Gu::Finish()
	#define GU_Sync( p1, p2 )						Gu::Sync( static_cast< Gu::ESyncType >( p1 ), static_cast< Gu::ESyncMode >( p2 ) )
	#define GU_Term()								Gu::Term()
	#define GU_ClearColour( p1 )					Gu::ClearColor( p1 )
	#define GU_ClearColor( p1 )						Gu::ClearColor( p1 )
	#define GU_ClearDepth( p1 )						Gu::ClearDepth( p1 )
	#define GU_DepthMask( p1 )						Gu::DepthMask( p1 )
	#define GU_Clear( p1 )							Gu::Clear( p1 )
	#define GU_SwapBuffers()						Gu::SwapBuffers()
	#define GU_CallList( p1 )						Gu::CallList( p1 )
	#define GU_BlendFunc( p1, p2, p3, p4, p5 )		Gu::BlendFunc( static_cast< Gu::EBlendOperation >( p1 ), static_cast< Gu::EBlendFunction >( p2 ), static_cast< Gu::EBlendFunction >( p3 ), p4, p5 )
	#define GU_DepthFunc( p1 )						Gu::DepthFunc( static_cast< Gu::ETestFunction >( p1 ) )
	#define GU_AlphaFunc( p1, p2, p3 )				Gu::AlphaFunc( static_cast< Gu::ETestFunction >( p1 ), p2, p3 )
	#define GU_StencilFunc( p1, p2, p3 )			Gu::StencilFunc( static_cast< Gu::ETestFunction >( p1 ), p2, p3 )
	#define GU_Ambient( p1 )						Gu::Ambient( p1 )
	#define GU_StencilOp( p1, p2, p3 )				Gu::StencilOp( static_cast< Gu::EStencilOperation >( p1 ), static_cast< Gu::EStencilOperation >( p2 ), static_cast< Gu::EStencilOperation >( p3 ) )
	#define GU_ColourMaterial( p1 )					Gu::ColorMaterial( p1 )
	#define GU_ColorMaterial( p1 )					Gu::ColorMaterial( p1 )
	#define GU_ShadeModel( p1 )						Gu::ShadeModel( static_cast< Gu::EShadingType >( p1 ) )
	#define GU_DrawArray( p1, p2, p3, p4, p5 )		Gu::DrawArray( static_cast< Gu::EPrimitiveType >( p1 ), p2, p3, p4, p5 )
	#define GU_Offset( p1, p2 )						Gu::Offset( p1, p2 )
	#define GU_Viewport( p1, p2, p3, p4 )			Gu::Viewport( p1, p2, p3, p4 )
	#define GU_DepthRange( p1, p2 )					Gu::DepthRange( p1, p2 )
	#define GU_DepthOffset( p1 )					Gu::DepthOffset( p1 )
	#define GU_Scissor( p1, p2, p3, p4 )			Gu::Scissor( p1, p2, p3, p4 )
	#define GU_SetMatrix( p1, p2)					Gu::SetMatrix( static_cast< Gu::EMatrixType >( p1 ), p2 )
	#define GU_Light( p1, p2, p3, p4 )				Gu::Light( p1, static_cast< Gu::ELightType >( p2 ), p3, p4 )
	#define GU_LightMode( p1 )						Gu::LightMode( static_cast< Gu::ELightMode >( p1 ) )
	#define GU_LightAtt( p1, p2, p3, p4 )			Gu::LightAtt( p1, p2, p3, p4 )
	#define GU_LightColour( p1, p2, p3 )			Gu::LightColor( p1, p2, p3 )
	#define GU_LightColor( p1, p2, p3 )				Gu::LightColor( p1, p2, p3 )
	#define GU_Material( p1, p2 )					Gu::Material( p1, p2 )
	#define GU_Specular( p1 )						Gu::Specular( p1 )
	#define GU_TexMode( p1, p2, p3, p4 )			Gu::TexMode( static_cast< Gu::ETextureFormat >( p1 ), p2, static_cast< Gu::ETextureClutMode >( p3 ), static_cast< Gu::ETextureBufferMode >( p4 ) )
	#define	GU_TexLevelMode( p1, p2 )				Gu::TexLevelMode( static_cast< Gu::ETextureLevelMode >( p1 ), p2 )
	#define GU_TexFilter( p1, p2 )					Gu::TexFilter( static_cast< Gu::ETextureFilterMode >( p1 ), static_cast< Gu::ETextureFilterMode >( p2 ) )
	#define GU_TexImage( p1, p2, p3, p4, p5 )		Gu::TexImage( p1, p2, p3, p4, p5 )
	#define GU_TexFlush()							Gu::TexFlush()
	#define GU_TexFunc( p1, p2 )					Gu::TexFunc( static_cast< Gu::ETextureFunction >( p1 ), static_cast< Gu::ETextureColorComponent >( p2 ) )
	#define GU_TexWrap( p1, p2 )					Gu::TexWrap( static_cast< Gu::ETextureWrapMode >( p1 ), static_cast< Gu::ETextureWrapMode >( p2 ) )
	#define GU_TexScale( p1, p2 )					Gu::TexScale( p1, p2 )
	#define GU_TexOffset( p1, p2 )					Gu::TexOffset( p1, p2 )
	#define GU_TexSync()							Gu::TexSync()
	#define GU_FrontFace( p1 )						Gu::FrontFace( static_cast< Gu::EFrontFaceMode >( p1 ) )
	#define GU_ClearStencil( p1 )					Gu::ClearStencil( p1 )
	#define GU_Colour( p1 )							Gu::Color( p1 )
	#define GU_Color( p1 )							Gu::Color( p1 )
	#define	GU_TexMapMode( p1, p2, p3, p4 )			Gu::TexMapMode( static_cast< Gu::ETextureMapMode >( p1 ), p2, p3, static_cast< Gu::ETextureMapInput >( p4 ) )
	#define GU_ClutMode( p1, p2, p3, p4 )			Gu::ClutMode( static_cast< Gu::EColorFormat >( p1 ), p2, p3, p4 )
	#define GU_ClutLoad( p1, p2 )					Gu::ClutLoad( p1, p2 )
	#define GU_SpriteMode( p1, p2, p3, p4 )			Gu::SpriteMode( p1, p2, p3, p4 )
	#define GU_DrawSprite( p1, p2, p3, p4, p5, p6, p7 ) \
													Gu::DrawSprite( p1, p2, static_cast< uint16 >( p3 ), p4, p5, static_cast< Gu::ESpriteFlip >( p6 ), static_cast< Gu::ESpriteRotate >( p7 ) )
	#define GU_CopyImage( p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11 ) \
													Gu::CopyImage( static_cast< Gu::EColorFormat >( p1 ), p2, p3, p4, p5, p6, p7, p8, p9, p10, p11 )
	#define GU_DebugPrint( p1, p2, p3, p4 )			Gu::DebugPrint( p1, p2, p3, p4 )
	#define GU_DebugFlush()							Gu::DebugFlush()
	#define GU_Emission( p1 )						Gu::Emission( p1 )
	#define GU_CheckList()							Gu::CheckList()
	#define GU_DebugBegin()							Gu::DebugBegin()
	#define GU_DebugEnd()							Gu::DebugEnd()
	#define GU_SendList( p1, p2, p3, p4, p5 )		Gu::SendList( static_cast< Gu::EQueueType >( p1 ), p2, p3, p4, p5 )
	#define GU_DrawBufferC( p1, p2, p3, p4, p5 )	Gu::DrawBufferC( reinterpret_cast< uint8 * >( p1 ), p2, static_cast< Gu::EColorFormat >( p3 ), p4, p5 )
	#define GU_DispBufferC( p1, p2, p3, p4, p5 )	Gu::DispBufferC( reinterpret_cast< uint8 * >( p1 ), p2, static_cast< Gu::EColorFormat >( p3 ), p4, p5 )
	#define GU_SetCallback( p1, p2 )				Gu::SetCallback( static_cast< Gu::EInterruptType >( p1 ), p2 )
	#define GU_Signal( p1, p2 )						Gu::Signal( static_cast< Gu::ESignalMode >( p1 ), p2 )
	#define GU_Continue()							Gu::Continue()
	#define GU_Fog( p1, p2, p3 )					Gu::Fog( p1, p2, p3 )
	#define GU_PixelMask( p1 )						Gu::PixelMask( p1 )
	#define GU_ColorFunc( p1, p2, p3 )				Gu::ColorFunc( static_cast< Gu::ETestFunction >( p1 ), p2, p3 )	
	#define GU_ColourFunc( p1, p2, p3 )				Gu::ColourFunc( static_cast< Gu::ETestFunction >( p1 ), p2, p3 )	
	#define GU_GetMemory( p1 )						Gu::GetMemory( p1 )
	#define GU_BoneMatrix( p1, p2 )					Gu::BoneMatrix( p1, p2 )
	#define GU_TexSlope( p1 )						Gu::TexSlope( p1 )
	#define GU_MorphWeight( p1, p2 )				Gu::MorphWeight( p1, p2 )
	// NOTE: This parameter is passed into GU_TexMapMode
	#define GU_TexProjMapMode( p1 )					//Gu::TexProjMapMode( p1 )
	#define GU_Flush()								Gu::Flush()

	#define GUM_MatrixMode( p1 )					Gum::MatrixMode( static_cast< Gu::EMatrixType >( p1 ) )
	#define GUM_PushMatrix()						Gum::PushMatrix()
	#define GUM_LoadIdentity()						Gum::LoadIdentity()
	#define GUM_PopMatrix()							Gum::PopMatrix()
	#define	GUM_DrawArray( p1, p2, p3, p4, p5 )		Gum::DrawArray( static_cast< Gu::EPrimitiveType >( p1 ), p2, p3, p4, p5 )
	#define GUM_SetCurMatrix()						Gum::SetCurMatrix()
	#define GUM_StoreMatrix( p1 )					Gum::StoreMatrix( p1 )
	#define GUM_LoadMatrix( p1 )					Gum::LoadMatrix( p1 )
	#define GUM_MultMatrix( p1 )					Gum::MultMatrix( p1 )
	#define GUM_SetMatrixStack( p1, p2, p3, p4, p5 ) \
													Gum::SetMatrixStack( p1, p2, p3, p4, p5 )
	#define GUM_Translate( p1 )						Gum::Translate( p1 )
	#define GUM_Perspective( p1, p2, p3, p4 )		Gum::Perspective( p1, p2, p3, p4 )
	#define GUM_Ortho( p1, p2, p3, p4, p5, p6 )		Gum::Ortho( p1, p2, p3, p4, p5, p6 )
	#define GUM_Scale( p1 )							Gum::Scale( p1 )
	#define GUM_UpdateMatrix()						Gum::UpdateMatrix()
#else
	#define GU_Init()								sceGuInit()
	#define GU_Display( p1 )						sceGuDisplay( p1 )
	#define GU_Start( p1, p2, p3 )					sceGuStart( p1, p2, p3 )
	#define GU_DrawBuffer( p1, p2, p3 )				sceGuDrawBuffer( p1, reinterpret_cast< uint8 * >( p2 ), p3 )
	#define GU_DrawBufferList( p1, p2, p3 )			sceGuDrawBufferList( p1, reinterpret_cast< uint8 * >( p2 ), p3 )
	#define GU_DispBuffer( p1, p2, p3, p4 )			sceGuDispBuffer( p1, p2, reinterpret_cast< uint8 * >( p3 ), p4 )
	#define GU_DepthBuffer( p1, p2 )				sceGuDepthBuffer( reinterpret_cast< uint8 * >( p1 ), p2 )
	#define GU_SetDither( p1 )						sceGuSetDither( p1 )
	#define GU_Enable( p1 )							sceGuEnable( p1 )
	#define	GU_Disable( p1 )						sceGuDisable( p1 )
	#define GU_Finish()								sceGuFinish()
	#define GU_Sync( p1, p2 )						sceGuSync( p1, p2 )
	#define GU_Term()								sceGuTerm()
	#define GU_ClearColour( p1 )					sceGuClearColor( p1 )
	#define GU_ClearColor( p1 )						sceGuClearColor( p1 )
	#define GU_ClearDepth( p1 )						sceGuClearDepth( p1 )
	#define GU_DepthMask( p1 )						sceGuDepthMask( p1 )
	#define GU_Clear( p1 )							sceGuClear( p1 )
	#define GU_SwapBuffers()						sceGuSwapBuffers()
	#define GU_CallList( p1 )						sceGuCallList( p1 )
	#define GU_BlendFunc( p1, p2, p3, p4, p5 )		sceGuBlendFunc( p1, p2, p3, p4, p5 )
	#define GU_DepthFunc( p1 )						sceGuDepthFunc( p1 )
	#define GU_AlphaFunc( p1, p2, p3 )				sceGuAlphaFunc( p1, p2, p3 )
	#define GU_StencilFunc( p1, p2, p3 )			sceGuStencilFunc( p1, p2, p3 )
	#define GU_Ambient( p1 )						sceGuAmbient( p1 )
	#define GU_StencilOp( p1, p2, p3 )				sceGuStencilOp( p1, p2, p3 )
	#define GU_ColourMaterial( p1 )					sceGuColorMaterial( p1 )
	#define GU_ColorMaterial( p1 )					sceGuColorMaterial( p1 )
	#define GU_ShadeModel( p1 )						sceGuShadeModel( p1 )
	#define GU_DrawArray( p1, p2, p3, p4, p5 )		sceGuDrawArray( p1, p2, p3, p4, p5 )
	#define GU_Offset( p1, p2 )						sceGuOffset( p1, p2 )
	#define GU_Viewport( p1, p2, p3, p4 )			sceGuViewport( p1, p2, p3, p4 )
	#define GU_DepthRange( p1, p2 )					sceGuDepthRange( p1, p2 )
	#define GU_DepthOffset( p1 )					sceGuDepthOffset( p1 )
	#define GU_Scissor( p1, p2, p3, p4 )			sceGuScissor( p1, p2, p3, p4 )
	#define GU_SetMatrix( p1, p2)					sceGuSetMatrix( p1, p2 )
	#define GU_Light( p1, p2, p3, p4 )				sceGuLight( p1, p2, p3, p4 )
	#define GU_LightMode( p1 )						sceGuLightMode( p1 )
	#define GU_LightAtt( p1, p2, p3, p4 )			sceGuLightAtt( p1, p2, p3, p4 )
	#define GU_LightColour( p1, p2, p3 )			sceGuLightColor( p1, p2, p3 )
	#define GU_LightColor( p1, p2, p3 )				sceGuLightColor( p1, p2, p3 )
	#define GU_Material( p1, p2 )					sceGuMaterial( p1, p2 )
	#define GU_Specular( p1 )						sceGuSpecular( p1 )
	#define GU_TexMode( p1, p2, p3, p4 )			sceGuTexMode( p1, p2, p3, p4 )
	#define	GU_TexLevelMode( p1, p2 )				sceGuTexLevelMode( p1, p2 )
	#define GU_TexFilter( p1, p2 )					sceGuTexFilter( p1, p2 )
	#define GU_TexImage( p1, p2, p3, p4, p5 )		sceGuTexImage( p1, p2, p3, p4, p5 )
	// NOTE: This GU_TexFlush() is commented out as libgu does it each time GU_TexImage(...) is called
	#define GU_TexFlush()							//GU_TexFlush()
	#define GU_TexFunc( p1, p2 )					sceGuTexFunc( p1, p2 )
	#define GU_TexWrap( p1, p2 )					sceGuTexWrap( p1, p2 )
	#define GU_TexScale( p1, p2 )					sceGuTexScale( p1, p2 )
	#define GU_TexOffset( p1, p2 )					sceGuTexOffset( p1, p2 )
	#define GU_TexSync()							sceGuTexSync()
	#define GU_FrontFace( p1 )						sceGuFrontFace( p1 )
	#define GU_ClearStencil( p1 )					sceGuClearStencil( p1 )
	#define GU_Colour( p1 )							sceGuColor( p1 )
	#define GU_Color( p1 )							sceGuColor( p1 )
	#define	GU_TexMapMode( p1, p2, p3, p4 )			sceGuTexMapMode( p1, p2, p3 ); sceGuTexProjMapMode( p4 )
	#define GU_ClutMode( p1, p2, p3, p4 )			sceGuClutMode( p1, p2, p3, p4 )
	#define GU_ClutLoad( p1, p2 )					sceGuClutLoad( p1, p2 )
	#define GU_SpriteMode( p1, p2, p3, p4 )			sceGuSpriteMode( p1, p2, p3, p4 )
	#define GU_DrawSprite( p1, p2, p3, p4, p5, p6, p7 ) \
													sceGuDrawSprite( p1, p2, p3, p4, p5, p6, p7 )
	#define GU_CopyImage( p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11 ) \
													sceGuCopyImage( p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11 )
	#define GU_DebugPrint( p1, p2, p3, p4 )			sceGuDebugPrint( p1, p2, p3, p4 )
	#define GU_DebugFlush()							sceGuDebugFlush()
	#define GU_Emission( p1 )						
	#define GU_CheckList()							sceGuCheckList()
	#define GU_DebugBegin()
	#define GU_DebugEnd()
	#define GU_SendList( p1, p2, p3, p4, p5 )		sceGuSendList( p1, p2, p3, p4, p5 )
	#define GU_DrawBufferC( p1, p2, p3, p4, p5 )	sceGuDrawBuffer( p3, reinterpret_cast< void * >( p1 ), p2 )
	#define GU_DispBufferC( p1, p2, p3, p4, p5 )	sceGuDispBuffer( p4, p5, reinterpret_cast< void * >( p1 ), p2 )
	#define GU_SetCallback( p1, p2 )				sceGuSetCallback( p1, p2 )
	#define GU_Signal( p1, p2 )						sceGuSignal( p1, p2 )
	#define GU_Continue()							sceGuContinue()
	#define GU_Fog( p1, p2, p3 )					sceGuFog( p1, p2, p3 )
	#define GU_PixelMask( p1 )						sceGuPixelMask( p1 )
	#define GU_ColorFunc( p1, p2, p3 )				sceGuColorFunc( p1, p2, p3 )	
	#define GU_ColourFunc( p1, p2, p3 )				sceGuColourFunc( p1, p2, p3 )	
	#define GU_GetMemory( p1 )						sceGuGetMemory( p1 )
	#define GU_BoneMatrix( p1, p2 )					sceGuBoneMatrix( p1, p2 )
	#define GU_TexSlope( p1 )						sceGuTexSlope( p1 )
	#define GU_MorphWeight( p1, p2 )				sceGuMorphWeight( p1, p2 )
	// NOTE: This parameter is passed into GU_TexMapMode
	#define GU_TexProjMapMode( p1 )					//sceGuTexProjMapMode( p1 )
	#define GU_Flush()								sceGuFlush()

	#define GUM_MatrixMode( p1 )					sceGumMatrixMode( p1 )
	#define GUM_PushMatrix()						sceGumPushMatrix()
	#define GUM_LoadIdentity()						sceGumLoadIdentity()
	#define GUM_PopMatrix()							sceGumPopMatrix()
	#define	GUM_DrawArray( p1, p2, p3, p4, p5 )		sceGumDrawArray( p1, p2, p3, p4, p5 )
	#define GUM_SetCurMatrix()						sceGumSetCurMatrix()
	#define GUM_StoreMatrix( p1 )					sceGumStoreMatrix( p1 )
	#define GUM_LoadMatrix( p1 )					sceGumLoadMatrix( p1 )
	#define GUM_MultMatrix( p1 )					sceGumMultMatrix( p1 )
	#define GUM_SetMatrixStack( p1, p2, p3, p4, p5 ) \
													sceGumSetMatrixStack( p1, p2, p3, p4, p5 )
	#define GUM_Translate( p1 )						sceGumTranslate( p1 )
	#define GUM_Perspective( p1, p2, p3, p4 )		sceGumPerspective( p1, p2, p3, p4 )
	#define GUM_Ortho( p1, p2, p3, p4, p5, p6 )		sceGumOrtho( p1, p2, p3, p4, p5, p6 )
	#define GUM_Scale( p1 )							sceGumScale( p1 )
	#define GUM_UpdateMatrix()						sceGumUpdateMatrix()
#endif

#endif	//__ASURA_PSP_GU_H__