//
// Asura_PSP_Stencil_Enums.h
//
// Created by KOR - 17/01/2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
// This file should be used/updated whenever writing a graphics routine that uses the PSP stencil buffer.
// Keeping all stencil values here should ensure that no clashes happen.
// Note that these values are reserved only for the main draw buffer - for other buffers, any values can be used.

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_PSP_STENCIL_ENUMS_H__
#define __ASURA_PSP_STENCIL_ENUMS_H__

enum ASURA_PSP_STENCIL_VALUES
{
	ASURA_PSP_STENCIL_NONE		= 0,
	ASURA_PSP_STENCIL_OUTLINE	= 0x01,
	ASURA_PSP_STENCIL_WATER		= 0x02,
	ASURA_PSP_STENCIL_SPECIAL_TRANSLUCENCY = 0x03,
	ASURA_PSP_STENCIL_EDGE		= 0x04,
	ASURA_PSP_STENCIL_MASK		= 0x05,
	ASURA_PSP_STENCIL_BILINEAR	= 0x06,
	ASURA_PSP_STENCIL_GLOW		= 0xfd,
	ASURA_PSP_STENCIL_SKYBOX	= 0xfe,
};

#endif//__ASURA_PSP_STENCIL_ENUMS_H__
