//
// Asura_Platform_Module.cpp
//
// Created by Anthony Gregson - 20/09/04
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

#include "Rendering/Asura_Module.h"

#include "Rendering/Asura_PSP_RenderEnvironment.h"

// GPU profile
#include "Debugging/Asura_PSP_Profiling.h"

// Kevin Lea - 08/10/2001 16:50:44 - platform specific wrappers for Render call
void Asura_Module_Handler::Platform_BeginRender(void)
{
}

void Asura_Module_Handler::Platform_Render()
{
#ifdef ASURA_PSP_PROFILING
	Asura_PSP_Profiling::Signal( Asura_PSP_Profiling::ASURA_PSP_SIGNAL_ENVIRONMENT_START ); 
#endif // #ifdef ASURA_PSP_PROFILING

	Asura_PSP_RenderEnvironment::Render();

#ifdef ASURA_PSP_PROFILING
	Asura_PSP_Profiling::Signal( Asura_PSP_Profiling::ASURA_PSP_SIGNAL_ENVIRONMENT_END ); 
#endif // #ifdef ASURA_PSP_PROFILING

}
void Asura_Module_Handler::Platform_EndRender(void)
{
}
// MH 5.4.02 -- functions called by Initialise / Shutdown to setup platform specific stuff.
void Asura_Module_Handler::Platform_Initialise(void)
{
}
void Asura_Module_Handler::Platform_Shutdown(void)
{
}


/// End of file. ///
