
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_PSP_SimpleAudio.h
// Author : Andy Tate
// Date   : 21-Jun-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_PSP_SIMPLEAUDIO_H__
#define __ASURA_PSP_SIMPLEAUDIO_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include <kerneltypes.h>
#include "Core/Asura_Multithread.h"

#include "Asura_PSP_Atrac.h"

////////////////////////////////////////////////////////////////////////////////
// Defines...
////////////////////////////////////////////////////////////////////////////////

#define ASURA_PSP_SA_NUM_STEREO_CHANNELS	2
#define ASURA_PSP_SA_NUM_OUTPUT_BUFFERS		3		// Needs triple buffering for Atrac playing which uses read, decode and play buffers.
#define ASURA_PSP_SA_NUM_SAMPLES			2048
#define ASURA_PSP_SA_AUDIO_OUTPUT_SAMPLE	256


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : Asura_PSP_SimpleAudio
// Author       : Andy Tate
// Date         : 21-Jun-2006
//
// Description  : Wrapper class for SCE simple-audio.
////////////////////////////////////////////////////////////////////////////////

class Asura_PSP_SimpleAudio
{
public:
	// Public functions...
	static	void	Initialise	(void);
	static	void	Shutdown	(void);


protected:
	// Protected variables...


	// Protected functions...


private:
	// Private variables...
	static	SceUID	s_iThreadID;		// The ID of the thread to be created.

	static	u_int	s_uCurrentBuffer[ASURA_PSP_MAX_NUM_ATRAC_STREAMS];	// The current output buffer to use.


	// Private functions...
	Asura_PSP_SimpleAudio  (void);
	Asura_PSP_SimpleAudio  (const Asura_PSP_SimpleAudio& xOther);
	~Asura_PSP_SimpleAudio ();

	Asura_PSP_SimpleAudio&	operator=	(const Asura_PSP_SimpleAudio& xOther);

	// Thread function...
	static	int		UpdateThread	(SceSize args, ScePVoid argp);
	static	bool	DoAtracMixing	( short*& psOutputBufferOut, float& fAtracVolumeOut );

};   // End of class 'Asura_PSP_SimpleAudio'.


#endif   // ifndef __ASURA_PSP_SIMPLEAUDIO_H__


/// End of file. ///
