//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_FullScreenSFX_System.cpp
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
// Description:
//
//     PSP-specific implementations of engine full screen SFX functionality.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

// Engine independent.
#include "Core/Asura_TextureFlags.h"
#include "Rendering/Asura_Render.h"
#include "Rendering/Asura_Viewport.h"
#include "SpecialFX/Asura_FullScreenSFX_System.h"

// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

void Asura_FullScreenSFX_System::Platform_RenderFade( u_int uARGB )
{
    Asura_Render::Overlay.Colour           = uARGB;
    Asura_Render::Overlay.TranslucencyMode = ASURA_TRANSLUCENCY_NORMAL;
    Asura_Render::Overlay.TextureIndex     = ASURA_TEXTURE_NONE;

    const float fWidth  = static_cast<float>( Asura_Viewport::GetWidth() );
    const float fHeight = static_cast<float>( Asura_Viewport::GetHeight() );

    Asura_Render::Overlay.SetRectXY( 0.0f, 0.0f, fWidth, fHeight );

    Asura_Render::Overlay.Render();   
}

void Asura_FullScreenSFX_System::Platform_InitialiseMotionBlur()
{
}

void Asura_FullScreenSFX_System::Platform_RenderMotionBlur( u_char uMotionBlurAlpha )
{
}
