//////////////////////////////////////////////////////////////////////////////
//
// Asura_FlyCam.cpp
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
// Description:
//
//     Basic camera controlled by analogue sticks or buttons. Intended only
//     for debugging and prototyping purposes. 
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#ifdef ASURA_SUPPORT_FLYCAM

// This file's header.
#include "Camera/Asura_FlyCam.h"

// Wii
#include "Input/Asura_Wii_Input.h"

void Asura_FlyCam::Platform_Initialise(void)
{
	AddMoveForwardsBackwardsMapping(ASURA_WII_KEYID_CONTROLLER1_UP, ASURA_WII_KEYID_CONTROLLER1_DOWN);
	AddMoveLeftRightMapping(ASURA_WII_KEYID_CONTROLLER1_LEFT, ASURA_WII_KEYID_CONTROLLER1_RIGHT);
	AddMoveUpDownMapping(ASURA_WII_KEYID_CONTROLLER1_C, ASURA_WII_KEYID_CONTROLLER1_Z);

	AddRollMapping(ASURA_WII_KEYID_CONTROLLER1_MINUS, ASURA_WII_KEYID_CONTROLLER1_PLUS);
	AddPitchMapping(ASURA_AXIS_PAD1_LSTICK_V);
	AddYawMapping(ASURA_AXIS_PAD1_LSTICK_H);

	AddFastMapping(ASURA_WII_KEYID_CONTROLLER1_A);

	AddInvertYMapping(ASURA_WII_KEYID_CONTROLLER1_1);
}

void Asura_FlyCam::Platform_Shutdown(void)
{
}

#endif // #ifdef ASURA_SUPPORT_FLYCAM
