//
// Asura_Platform_Time_System.cpp
//
// Created by KOR - 09 October 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

// This file's header.
#include "Core/Asura_Time_System.h"

// Asura headers
#include "Debugging/Asura_Assert.h"

// Lib
#include <revolution/os.h>

//------------------------------------------------------------------------------
////////////////////////////////////////////////////////////////////////////////
//
// Asura_Time_System
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
//
// Platform_GetCurrentDateAndTime
//
////////////////////////////////////////////////////////////////////////////////
void Asura_Time_System::Platform_GetCurrentDateAndTime()
{
	OSCalendarTime xCalendarTime;

	OSTicksToCalendarTime(OSGetTime(), &xCalendarTime);
	s_xTime.m_usYear = xCalendarTime.year;
	s_xTime.m_ucMonth = xCalendarTime.mon;
	s_xTime.m_ucDayOfMonth = xCalendarTime.mday - 1; // this one isn't zero-based for some reason
	s_xTime.m_ucDayOfWeek = xCalendarTime.wday;
	s_xTime.m_ucHour = xCalendarTime.hour;
	s_xTime.m_ucMinute = xCalendarTime.min;
	s_xTime.m_ucSecond = xCalendarTime.sec;
}

// in minutes, where UTC = local time + bias 
int Asura_Time_System::Platform_GetTimeZoneBias()
{
	return 0;
}

//------------------------------------------------------------------------------
////////////////////////////////////////////////////////////////////////////////
//
// Asura_Time
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
//
// Platform_FillFromLibCTime
//
////////////////////////////////////////////////////////////////////////////////

void Asura_Time::Platform_FillFromLibCTime(u_int uLibCTime)
{
	Asura_Assert(0, "Not yet implemented");
}
