//
// Asura_Platform_Mem.h
//
// Created by KOR - 16 July 2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PLATFORM_MEM_H__
#define __ASURA_PLATFORM_MEM_H__

#include <string.h>

// platform replacement for memcmp
inline int Asura_Mem::Platform_Compare(const void* pMem1, const void* pMem2, size_t uBytes)
{
	return memcmp(pMem1, pMem2, uBytes);
}
    
// platform replacement for memcpy
inline void* Asura_Mem::Platform_Copy(void* pDest, const void* pSrc, size_t uBytes)
{
	return memcpy(pDest, pSrc, uBytes);
}

inline void* Asura_Mem::Platform_SafeCopy(void* pDest, const void* pSrc, size_t uBytes)
{
	return memcpy(pDest, pSrc, uBytes);
}

inline void* Asura_Mem::Platform_Move(void* pDest, const void* pSrc, size_t uBytes)
{
	return memmove(pDest, pSrc, uBytes);
}

// platform replacement for memset
inline void* Asura_Mem::Platform_Set(void* pMem, int iChar, size_t uCount)
{
	return memset(pMem, iChar, uCount);
}

inline void Asura_Mem::Platform_PreFetchData(const void* pData, const u_int uNumBytes)
{
	// Not yet implemented.
}

#endif//__ASURA_PLATFORM_MEM_H__
