//
// Asura_Wii_Profiling.h
//
// Created by KOR - 22 January 2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_WII_PROFILING_H__
#define __ASURA_WII_PROFILING_H__

#ifdef ASURA_WII_PROFILING

class Asura_Wii_Profiling
{
public:
	static void Initialise();
	static void Shutdown();

	static void RegisterLabel(int iProfileType, const char* szName);
	static void StartProfile(int iProfileType);
	static void StopProfile(int iProfileType);

	static void Render();
	static void ClearValues();

	static void StartGPUProfile(int iProfileType);
	static void StopGPUProfile(int iProfileType);

private:
	static bool s_bRenderingEnabled;
};

#else

class Asura_Wii_Profiling
{
public:
	static void Initialise() {}
	static void Shutdown() {}

	static void Render() {}
	static void ClearValues() {}
};


#endif //#ifdef ASURA_WII_PROFILING

#endif//__ASURA_WII_PROFILING_H__