//
// Asura_DebugFileStream.h
//
// Created by KOR - 09 October 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_DEBUGFILESTREAM_H__
#define __ASURA_DEBUGFILESTREAM_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core\Asura_Stream.h"
#include "Core\Asura_String.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

class Asura_DebugFileStream : public Asura_Stream
{
public:
	// Public functions...

	Asura_DebugFileStream(void)
	: m_pFile(NULL)
	, m_bCompressed(false)
	{

	}
	virtual ~Asura_DebugFileStream()
	{
		if (m_bIsOpen)
		{
			Close ();
		}
	}

	// File open/close functions...
			bool				Open			(const char* szFilename, const OpenType eOpenType, const bool bUseFullPath, const bool bCompressed = false);
			bool				OpenForReading	(const char* szFilename, const bool bUseFullPath)	{ return (Open(szFilename, READ_DATA, bUseFullPath)); }
			bool				OpenForWriting	(const char* szFilename, const bool bUseFullPath)	{ return (Open(szFilename, WRITE_DATA, bUseFullPath)); }

	// Virtual functions...
	virtual bool				Open			(const OpenType eOpenType);

	virtual	u_int				ReadData		(const u_int uNumberOfBytes, void* pData);
	virtual	u_int				SkipData		(const u_int uNumberOfBytes);
	virtual	u_int				WriteData		(const u_int uNumberOfBytes, const void* pData);

	virtual	bool				Close			(void);


protected:
	// Protected variables...


	// Protected functions...


private:
	// Private variables...

	// The name of the file to open...
	Asura_String	m_xFilename;

	// The file handle to be used...
	void * m_pFile;

	// Whether the file is to be compressed.
	bool m_bCompressed;



	// Private functions...

	Asura_DebugFileStream  (const Asura_DebugFileStream& xOther);

			Asura_DebugFileStream&	operator=		(const Asura_DebugFileStream& xOther);

};   // End of class 'Asura_DebugFileStream'.

#endif//__ASURA_DEBUGFILESTREAM_H__