//
// Asura_GX_Shadows.h
//
// Created by KOR - 10 October 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_GX_SHADOWS_H__
#define __ASURA_GX_SHADOWS_H__

#include "Core/Asura_Maths.h"

const u_int ASURA_GX_MAX_SHADOWS = 32;
const u_int ASURA_MAX_SHADOW_FANS = 1024;

struct Asura_GX_Shadow_Bone
{
	Asura_Vector_3	m_xPosition1;
	Asura_Vector_3	m_xPosition2;
	float			m_fSize;
	float			m_fAlpha;
};

struct Asura_GX_Shadow
{
	Asura_Vector_3		m_xPosition;
	Asura_Bounding_Box	m_xBB;
	Asura_Vector_3		m_xUOffset;
	Asura_Vector_3		m_xVOffset;
	Asura_Vector_3		m_xNOffset;
	float				m_fInvHeight;
	float				m_fInvWidth;
	float				m_fDepth;
	float				m_fAlpha;
};

struct Asura_GX_Shadow_Vertex
{
	Asura_Vector_3	m_xPosition;
	unsigned int	m_uColour;
	float			m_fU;
	float			m_fV;
};

class Asura_GX_ShadowRenderer
{
public:
	static void BeginRender();
	static void AddShadow(const Asura_Vector_3& xPosition1, const Asura_Vector_3& xPosition2, float fSize, float fAlpha = 0.375);
	static void EndRender(u_int uCamVisFlags, bool bBufferedRender, const Asura_Vector_3* pxBasePos = NULL );
private:
	//static Asura_Bounding_Box		s_xOverallBB;
	static int						s_iShadowTexture;
	//static Asura_GX_Shadow			s_axShadowBuffer[ASURA_GX_MAX_SHADOWS];
	static unsigned int				s_uNumShadows;
	//static Asura_Vector_3			s_xBasePos;
	//static Asura_GX_Shadow_Vertex	s_aaxVertexBuffer[ASURA_MAX_SHADOW_FANS][9];
	//static unsigned int				s_auNumVertices[ASURA_MAX_SHADOW_FANS];
	static Asura_GX_Shadow_Bone		s_axShadowBones[ASURA_GX_MAX_SHADOWS];
};

#endif//__ASURA_GX_SHADOWS_H__