//
// Asura_PlatformRenderWater.h
//
// Created by KOR - 09 October 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PLATFORMRENDERWATER_H__
#define __ASURA_PLATFORMRENDERWATER_H__

#include "Core/Asura_Maths.h"

#include <revolution/gx/gxstruct.h>

class Asura_GX_Water_Vertex
{
public:
	Asura_Vector_3 m_xPos;
	u_int m_uColour;
	Asura_Vector_2 m_xTexCoords;
};

// container class for the data packets
class Asura_Platform_Water_Packet
{
public:

	friend class Asura_Water_System;

	Asura_Platform_Water_Packet();
	~Asura_Platform_Water_Packet();

	//void Reset( void );

	void SetVertexCount(u_int uVertexCount);

	void AddVertex(float x, float y, float z, float r, float g, float b, float u, float v);

	void Close( void );

	void Render() const;
private:
	Asura_GX_Water_Vertex* m_pxVertices;
	u_int m_uVertexCount;
	u_int m_uCurrentWriteVertex;
};
// End class Asura_Platform_Water_Packet

class Asura_GX_Water
{
public:
	static void Initialise();
	static void Shutdown();

	static void RenderReflectionTexture();

	static const GXTexObj* GetReflectionTexture() { return &s_xSkyReflectionTex; }
private:
	static u_char*		s_pucSkyReflectionBuffer;
	static GXTexObj		s_xSkyReflectionTex;
};

#endif//__ASURA_PLATFORMRENDERWATER_H__