//
// Asura_Wii_Streaming_Sound_System.cpp
//
// Created by KOR - 10 October 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

// This file's header.
#include "Sound/Asura_Wii_StreamSound.h"

// Library headers
#include <string.h>

Asura_Wii_Streaming_Sound Asura_Wii_Streaming_Sound_System::s_axStreamingSounds[ASURA_WII_MAX_CONCURRENT_SOUNDSTREAMS];

void Asura_Wii_Streaming_Sound_System::Initialise(void)
{
	Asura_Wii_Streaming_Sound::Initialise();
}

void Asura_Wii_Streaming_Sound_System::Shutdown(void)
{
}

bool Asura_Wii_Streaming_Sound_System::Create(int iStreamID, const char* szFilename)
{
    return s_axStreamingSounds[iStreamID].Create(szFilename);
}

void Asura_Wii_Streaming_Sound_System::Play(int iStreamID, bool bLooping)
{
    s_axStreamingSounds[iStreamID].Play(bLooping);
}

void Asura_Wii_Streaming_Sound_System::Stop(int iStreamID)
{
    s_axStreamingSounds[iStreamID].Stop();
}

void Asura_Wii_Streaming_Sound_System::Release(int iStreamID)
{
    s_axStreamingSounds[iStreamID].Release();
}

void Asura_Wii_Streaming_Sound_System::Update(void)
{
    for (int u = 0; u < ASURA_WII_MAX_CONCURRENT_SOUNDSTREAMS; ++u)
    {
        s_axStreamingSounds[u].Update();
    }
}

void Asura_Wii_Streaming_Sound_System::Pause(int iStreamID)
{
    s_axStreamingSounds[iStreamID].Pause();
}

void Asura_Wii_Streaming_Sound_System::Resume(int iStreamID)
{
    s_axStreamingSounds[iStreamID].Resume();
}

void Asura_Wii_Streaming_Sound_System::SetVolume(int iStreamID, float fVol)
{
    s_axStreamingSounds[iStreamID].SetVolume(fVol);
}

void Asura_Wii_Streaming_Sound_System::UpdateVolume()
{
    for (int u = 0; u < ASURA_WII_MAX_CONCURRENT_SOUNDSTREAMS; ++u)
    {
        s_axStreamingSounds[u].UpdateVolume();
    }
}

float Asura_Wii_Streaming_Sound_System::GetLength(int iStreamID)
{
	return s_axStreamingSounds[iStreamID].GetLength();
}

float Asura_Wii_Streaming_Sound_System::GetPosition(int iStreamID)
{
	return s_axStreamingSounds[iStreamID].GetPosition();
}

bool Asura_Wii_Streaming_Sound_System::IsFinished(int iStreamID)
{
	return s_axStreamingSounds[iStreamID].IsFinished();
}

#ifndef ASURA_SUBMISSION_BUILD
void Asura_Wii_Streaming_Sound_System::DebugRender()
{
	for (int u = 0; u < ASURA_WII_MAX_CONCURRENT_SOUNDSTREAMS; ++u)
	{
		s_axStreamingSounds[u].DebugRender();
	}
}
#endif
