//
// Asura_Wii_StreamSound.h
//
// Created by KOR - 10 October 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_WII_STREAMSOUND_H__
#define __ASURA_WII_STREAMSOUND_H__

//Was included when we were using SoundGroup
//#include "Sound/Asura_Sound.h"

static const int ASURA_WII_MAX_CONCURRENT_SOUNDSTREAMS = 2;

#ifdef ASURA_USE_BINK
#include "Bink/Asura_Bink.h"
typedef class Asura_Wii_Bink Asura_Wii_Streaming_Sound;
#else
#include "Sound/Asura_Wii_Streaming_ADPCM.h"
typedef class Asura_Wii_Streaming_ADPCM Asura_Wii_Streaming_Sound;
#endif

class Asura_Wii_Streaming_Sound_System
{
	public:
		static void Initialise(void);
		static void Shutdown(void);
        static void Update(void);
		
		static bool Create(int iStreamID, const char* szFilename);
		static void Play(int iStreamID, bool bLooping);
		static void Stop(int iStreamID);
		static void Release(int iStreamID);

        static void Pause(int iStreamID);
        static void Resume(int iStreamID);
        static void SetVolume(int iStreamID, float fVol);
		//handle changes to sound group volumes
		static void UpdateVolume();

		static float GetLength(int iStreamID);
		static float GetPosition(int iStreamID);
		static bool IsFinished(int iStreamID);

#ifndef ASURA_SUBMISSION_BUILD
		static void DebugRender();
#endif
    private:
		static Asura_Wii_Streaming_Sound s_axStreamingSounds[ASURA_WII_MAX_CONCURRENT_SOUNDSTREAMS];
};

#endif//__ASURA_WII_STREAMSOUND_H__