// Asura_Chunk_ResourceFile_Xbox360_StreamingSounds.cpp
// Thomas Young 13.11.07
// Copyright (C) 2006 Rebellion, All Rights Reserved.

// I N C L U D E S ///////////////////////////////////////////////////////////

//Main Asura header
#include "Core/Asura.h"

#ifndef ASURA_USE_AUDIO_SYSTEM

//My header
#include "Asura_Chunk_ResourceFile_Xbox360_StreamedSounds.h"

//Engine independent headers
#include "ChunkSystem/Asura_Chunk_Stream.h"
#include "Sound/Asura_Sound.h"

//Xbox360 headers
#include "Sound/Asura_Xbox360_Sound.h"

// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

bool Asura_Chunk_ResourceFile_Xbox360_StreamedSounds::Process(const char* const szFilename, Asura_Chunk_Stream& xStream )
{
	int iVersion;
	xStream >> iVersion;	
	if( iVersion > ASURA_XBOX360_STREAMEDSOUNDS_CHUNK_VERSION )
	{
		Asura_Assert( false, "Chunk data is newer than this build. You need new code." );
		return false;
	}
	else if( iVersion < ASURA_XBOX360_STREAMEDSOUNDS_CHUNK_VERSION )
	{
		Asura_Assert( false, "Chunk data is older than this build. You need new data." );
		return false;
	}
	else
	{
		Asura_Xbox360_LoadChunkedSoundData (xStream);
		return true;
	}
}

#endif

//eof
