
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_PlatformBasics.h
// Author : Kevin Floyer-Lea
// Date   : 20-Jun-2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_PLATFORMBASICS_H__
#define __ASURA_PLATFORMBASICS_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>

#include "Core/Asura_MemoryManagement_DebugOff.h"
#include <xtl.h>
#include "Core/Asura_MemoryManagement_DebugOn.h"

////////////////////////////////////////////////////////////////////////////////
// Macro definitions...
////////////////////////////////////////////////////////////////////////////////

#define ASURA_UNICODE_CHAR_DISTINCT_TYPE     (1)
#define ASURA_ZLIB_PREVENT_DIRECT_DECOMPRESS (1)

////////////////////////////////////////////////////////////////////////////////
// Typedef declarations...
////////////////////////////////////////////////////////////////////////////////

typedef char	Asura_Char;
typedef wchar_t	Asura_UnicodeChar;

////////////////////////////////////////////////////////////////////////////////
// Functions...
////////////////////////////////////////////////////////////////////////////////

template< class T > static inline void SAFE_RELEASE( T*& ptObject )
{
	if( ptObject )
	{
		ptObject->Release();
	}

	ptObject = NULL;
}

template< class T > static inline void SAFE_RELEASE_ARRAY( T* ptObjects, const u_int uCount )
{
	for( u_int u = 0; u < uCount; ++u)
	{
		SAFE_RELEASE( ptObjects[u] );
	}
}

#endif   // ifndef __ASURA_PLATFORMBASICS_H__

/// End of file. ///
