
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_Platform_Assert.h
// Author : Kevin Floyer-Lea
// Date   : 20-Jun-2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_PLATFORM_ASSERT_H__
#define __ASURA_PLATFORM_ASSERT_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura_MemoryManagement_DebugOff.h"
// for DebugBreak()
#include <xtl.h>
#include "Core/Asura_MemoryManagement_DebugOn.h"

////////////////////////////////////////////////////////////////////////////////
// Macro definitions...
////////////////////////////////////////////////////////////////////////////////

//#define ASURA_XBOX360_DEBUG_TEXT_ASSERTS

#if defined(ASURA_ASSERT)

#define ASURA_PLATFORM_DEBUGBREAK() DebugBreak()

// Internal functions
const char* Asura_Platform_Assert_GetLogFileName();

#else

#define ASURA_PLATFORM_DEBUGBREAK()

#endif	//defined(ASURA_ASSERT)
 

// KJFL - 22 March 2006 - Static, i.e. compile-time, assertions
// For documentation see http://asurawiki.rebellion.co.uk/twiki/bin/viewauth/Programming/AsuraStaticAssert

template<bool b> struct ASURA_STATIC_ASSERTION_FAILURE;
template <> struct ASURA_STATIC_ASSERTION_FAILURE<true> {};

#define ASURA_COMBINE_LITERALS( a, b ) a ## b
#define ASURA_STATIC_ASSERT_UNIQUENAME( a ) ASURA_COMBINE_LITERALS( ASURA_STATIC_ASSERT_FAILED_, a )

#define ASURA_STATIC_ASSERT( bCondition ) static ASURA_STATIC_ASSERTION_FAILURE<(bCondition != 0)> ASURA_STATIC_ASSERT_UNIQUENAME(__COUNTER__) 


#endif   // ifndef __ASURA_PLATFORM_ASSERT_H__


/// End of file. ///
