
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_Platform_CPUProfile.h
// Author : Kevin Floyer-Lea
// Date   : 20-Jun-2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_PLATFORM_CPUPROFILE_H__
#define __ASURA_PLATFORM_CPUPROFILE_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Macro declaration...
////////////////////////////////////////////////////////////////////////////////

// TODO: implement proper profiling code for Xbox360...

#ifdef ASURA_USE_PROFILING_SYSTEM
#include "Debugging/Asura_CPUProfile_Renderer.h"
#define	ASURA_CPU_PROFILE__START(x) Asura_CPUProfile_Renderer::StartProfile(x);
#define	ASURA_CPU_PROFILE__END(x) Asura_CPUProfile_Renderer::StopProfile(x);
#define ASURA_CPU_PROFILE__REGISTER_LABEL(x,y) Asura_CPUProfile_Renderer::SetName(x,y);

#if defined( ASURA_USE_PROFILING_SYSTEM_MULTITHREADED)
	#define ASURA_CPU_PROFILE__START_THREAD( x)	Asura_CPUProfile_Renderer::StartThread( (x))
	#define ASURA_CPU_PROFILE__STOP_THREAD() Asura_CPUProfile_Renderer::StopThread()
#endif

#else //#ifdef ASURA_PSP_PROFILING
#define	ASURA_CPU_PROFILE__START(x)
#define	ASURA_CPU_PROFILE__END(x)

#if defined( ASURA_USE_PROFILING_SYSTEM_MULTITHREADED)
	#define ASURA_CPU_PROFILE__START_THREAD( x)
	#define ASURA_CPU_PROFILE__STOP_THREAD()
#endif

#endif //#else #ifdef ASURA_PSP_PROFILING


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////


#endif   // ifndef __ASURA_PLATFORM_CPUPROFILE_H__


/// End of file. ///
