
//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_GPUProfile.cpp
//
// Created by: Dave Reed 13/05/07
//
// Copyright (c) 2004-2007 Rebellion. All rights reserved.
//
// Xbox360 GPU profile bars - basically a copy of the CPU profile renderer
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif


#ifndef ___ASURA_PLATFORM_GPUPROFILE_H___
#define ___ASURA_PLATFORM_GPUPROFILE_H___

#ifndef ASURA_USE_PROFILING_SYSTEM

#define	ASURA_GPU_PROFILE_START(x) 
#define	ASURA_GPU_PROFILE_END(x) 

#else

#define	ASURA_GPU_PROFILE_START(x) Asura_GPUProfile_Renderer::StartProfile(x);
#define	ASURA_GPU_PROFILE_END(x)   Asura_GPUProfile_Renderer::StopProfile(x);



enum Asura_GPUProfileIndex
{
	ASURA_GPUPROFILE_TOTALFRAME		= 0,	
	ASURA_GPUPROFILE_SKYBOX,
	ASURA_GPUPROFILE_ENVIRONMENT,
	ASURA_GPUPROFILE_SKINS,
	ASURA_GPUPROFILE_SHAPES,
	ASURA_GPUPROFILE_HIERARCHIES,
	ASURA_GPUPROFILE_BOTANICALS,
	ASURA_GPUPROFILE_CARPET,
	ASURA_GPUPROFILE_DECALS,
	ASURA_GPUPROFILE_RESOLVE,
	ASURA_GPUPROFILE_COPYTOEDRAM,
	ASURA_GPUPROFILE_CREATESHADOWS,
	ASURA_GPUPROFILE_APPLYSHADOWS,
	ASURA_GPUPROFILE_DEFERRED_PHOTONS,
	ASURA_GPUPROFILE_DEFERRED_PROJECTORS,
	ASURA_GPUPROFILE_WATER,
	ASURA_GPUPROFILE_FOG,
	ASURA_GPUPROFILE_PFX,	
	ASURA_GPUPROFILE_CORONAS,
	ASURA_GPUPROFILE_LIGHTSHAFTS,
	ASURA_GPUPROFILE_FSFX,
	ASURA_GPUPROFILE_HUD,
	ASURA_GPUPROFILE_MAX_TIMERS		= 32
};

class Asura_GPUProfile_Renderer
{
public:
	static void Initialise();
	static void Shutdown();

	static void StartProfile(int iProfileType);
	static void StopProfile(int iProfileType);

	static void Render(bool bIncludeText);
	static void ClearValues();

	static void EnableBars( bool bEnable ) { s_bBarsEnabled = bEnable; }
	static bool IsBarsEnabled( void ) { return s_bBarsEnabled; }
#ifdef ASURA_USE_DEBUG_TEXT
	static void EnableText( bool bEnable ) { s_bTextEnabled = bEnable; }
	static bool IsTextEnabled( void ) { return s_bTextEnabled; }
#endif

private:

	static bool s_bBarsEnabled;
#ifdef ASURA_USE_DEBUG_TEXT
	static bool s_bTextEnabled;
#endif
};


#endif // ASURA_USE_PROFILING_SYSTEM
#endif // #ifndef ___ASURA_PLATFORM_GPUPROFILE_H___

