//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_CommandConsole.cpp
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
// Description:
//
//     Xbox360-specific implementations of command console functionality.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#ifdef ASURA_SUPPORT_COMMAND_CONSOLE

// This file's header.
#include "Interface/Asura_CommandConsole.h"

// Engine independent.
#include "Input/Asura_ControlMap.h"
#include "Input/Asura_PlatformInput.h"

// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

void Asura_CommandConsole::Platform_Initialise( void )
{
    SetBorderX( 3.25f );

#ifdef ASURA_DEBUG_VARIABLE_SYSTEM
	// put DVS away from the edges.
	SetDVSBorder(0.05f);
#endif
}

#ifdef ASURA_DEBUG_VARIABLE_SYSTEM

void Asura_DebugVariableSystem::Platform_InitialiseDefaultControlMapping( void )
{
	// JAT 19/02/07 - DVS open/close on 360 with ASURA_USE_CONTROLMAP_MANAGER #define	
#ifdef ASURA_USE_CONTROLMAP_MANAGER
	s_xControlMap.AddKeyMapping( KEYMAP_CLOSE,					ASURA_XBOX360_KEYID_PAD1_BACK, Asura_ControlMapping::ON_DEBOUNCED_PRESS );
#endif // #ifdef ASURA_USE_CONTROLMAP_MANAGER
	s_xControlMap.AddKeyMapping( KEYMAP_MOVERIGHT,              ASURA_XBOX360_KEYID_PAD1_RIGHT,   Asura_ControlMapping::ON_PRESS );
	s_xControlMap.AddKeyMapping( KEYMAP_MOVELEFT,               ASURA_XBOX360_KEYID_PAD1_LEFT,    Asura_ControlMapping::ON_PRESS );
	s_xControlMap.AddKeyMapping( KEYMAP_MOVEUP,                 ASURA_XBOX360_KEYID_PAD1_UP,      Asura_ControlMapping::ON_PRESS );
	s_xControlMap.AddKeyMapping( KEYMAP_MOVEDOWN,               ASURA_XBOX360_KEYID_PAD1_DOWN,    Asura_ControlMapping::ON_PRESS );
	s_xControlMap.AddKeyMapping( KEYMAP_INCREASEVALUE,          ASURA_XBOX360_KEYID_PAD1_Y, Asura_ControlMapping::ON_PRESS );
	s_xControlMap.AddKeyMapping( KEYMAP_DECREASEVALUE,          ASURA_XBOX360_KEYID_PAD1_A, Asura_ControlMapping::ON_PRESS );
	s_xControlMap.AddKeyMapping( KEYMAP_INCREASEVALUEINCREMENT, ASURA_XBOX360_KEYID_PAD1_B, Asura_ControlMapping::ON_PRESS );
	s_xControlMap.AddKeyMapping( KEYMAP_DECREASEVALUEINCREMENT, ASURA_XBOX360_KEYID_PAD1_X, Asura_ControlMapping::ON_PRESS );
}

#endif

#endif
