//////////////////////////////////////////////////////////////////////////////
//
// Asura_Xbox360_Friends.h
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
// Description:
//
//     wrapper for 360 friends API
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ASURA_XBOX360_FRIENDS_H___
#define ASURA_XBOX360_FRIENDS_H___ 1

#include <xbox.h>

class Asura_Xbox360_Friends
{
public:

	static void Initialise();
	static void Shutdown();
	static void Refresh();
	static bool ShowFriendsGUI();
	static bool IsPlayerAFriend(XUID xXuid);	// doesn't count self as friend

	// accessors to get the array e.g. for friends leaderboard calls
	static const XUID* GetFriendsList();
	static const XUID* GetFriendsListIncludingSelf();
	static u_int GetNumFriends();
	static u_int GetNumFriendsIncludingSelf();

private:

	static XUID* s_pxFriendsXUIDs;
	static u_int s_uNumFriends;
};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ASURA_XBOX360_FRIENDS_H___
