//
// Asura_Xbox360_IndexBuffer.h
//
// Created by KJFL - 05 October 2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//

#if defined ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#if !defined __ASURA_XBOX360_INDEXBUFFER_H__
#define __ASURA_XBOX360_INDEXBUFFER_H__

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

#include "Rendering/Asura_Xbox360_Graphics.h"

/******************************************************************************/
/* Classes                                                                    */
/******************************************************************************/

////////////////////////////////////////////////////////////////////////////////
//
// Asura_Xbox360_IndexBuffer
//
// Class wrapping an index buffer on Xbox 360
//
////////////////////////////////////////////////////////////////////////////////

class Asura_Xbox360_IndexBuffer
{
public:	
	
	// Constructor / destructor
	Asura_Xbox360_IndexBuffer();
	~Asura_Xbox360_IndexBuffer();

	// Functions

	void CreateStatic( const u_int uSizeInBytes );
	void Destroy();

	void* Lock();
	void Unlock();

	void Bind() const;

	bool IsEmpty() const;

	bool GetDesc(D3DINDEXBUFFER_DESC* pxDesc);

private:

	// Data
	Direct3D_IndexBuffer* m_pxBuffer;
};

#endif // !defined __ASURA_XBOX360_INDEXBUFFER_H__
