//////////////////////////////////////////////////////////////////////////////
//
// Asura_Xbox360_Achievements_System.h
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
// Description:
//
//     Asura wrapper class for 360's achievements SDK
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ASURA_XBOX360_ACHIEVEMENTS_SYSTEM_H___
#define ASURA_XBOX360_ACHIEVEMENTS_SYSTEM_H___ 1

#ifdef ASURA_USE_REWARDS

class Asura_ProducerConsumerQueue;

class Asura_Xbox360_Achievements_System
{
public:
	static void Initialise();

	static void Shutdown();

	static void Reset();

	static bool IsInitComplete();

	static u_int Project_ConvertReward(u_int uRewardIndex); //project function to map independent reward index to Achievement id. return -1 if no Achievement mapped (none ps3 reward)

	static void UnlockAchievement(u_int uAchievement);	//Wrapper for SDK code to unlock a reward.

	static bool IsAchievementUnlocked(u_int uAchievement);	//Possibly wrapper for SDK code to query if a reward is unlocked, but this is time consuming for some platforms, so the list will need to be enumerated and stored at initialisation.

	static const u_int s_uInvalid_Achievement = 999;

private:
	static u_int Project_GetNumAchievements();

	static void Threaded_Unlock(void* pData, u_int uAchievement);

	static Asura_ProducerConsumerQueue* s_pxWorkerThread;
	static bool s_bInitComplete;
	static u_int s_uNumAchievements;
	static bool* s_pbAchievements;
	static char* s_pxAchievementData;
};
#endif // #ifdef ASURA_USE_REWARDS

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ASURA_XBOX360_ACHIEVEMENTS_SYSTEM_H___
