/******************************************************************************/
/* Parameters                                                                 */
/******************************************************************************/

shared const float4x4 g_xViewProjectionMatrix;

const float4 g_xColour;

/******************************************************************************/
/* Functions                                                                  */
/******************************************************************************/

float4 VShader( const float4 xInPos : POSITION ) : POSITION
{
	return mul( xInPos, g_xViewProjectionMatrix );
}

float4 PShader() : COLOR
{
	return g_xColour;
}

/******************************************************************************/
/* Techniques                                                                 */
/******************************************************************************/

technique
{
	pass
	{
		AlphaTestEnable = FALSE;
		CullMode = NONE;

		VertexShader = compile vs_3_0 VShader();
		PixelShader = compile ps_3_0 PShader();
	}
}