/******************************************************************************/
/* Parameters                                                                 */
/******************************************************************************/

const sampler g_xSceneTexture = sampler_state
{
	AddressU = CLAMP;
	AddressV = CLAMP;
};

const sampler g_xDepthTexture = sampler_state
{
	AddressU = CLAMP;
	AddressV = CLAMP;
};

/******************************************************************************/
/* Functions                                                                  */
/******************************************************************************/

struct VS_Output
{
    float4	xPosition					: POSITION0;    
	float2	xUV							: TEXCOORD0;
};


VS_Output VShader( const float4 xIn : POSITION, const float2 xUV : TEXCOORD0)
{
	VS_Output xOutput;
	xOutput.xPosition = xIn;
	xOutput.xUV = xUV;

	return xOutput;
}

void PShader( const float2 xUV : TEXCOORD0, out float4 xColour : COLOR)
{
	asm
	{
		tfetch2D xColour, xUV, g_xSceneTexture, MinFilter=point, MagFilter=point, MipFilter=point, AnisoFilter=disabled, OffsetX=0.5, OffsetY=0.5
	};
}

float4 VShader2( const float4 xIn : POSITION) : POSITION
{
	return xIn;
}

float4 PShader2( const float4 xIn : POSITION) : COLOR
{
	return float4(1,1,1,1);
}



/******************************************************************************/
/* Techniques                                                                 */
/******************************************************************************/

technique
{
	pass
	{
		AlphaTestEnable = FALSE;
		CullMode = NONE;


		VertexShader = compile vs_3_0 VShader();
		PixelShader = compile ps_3_0 PShader();
	}
}
technique
{
	pass
	{
		AlphaTestEnable = FALSE;
		CullMode = NONE;


		VertexShader = compile vs_3_0 VShader2();
		PixelShader = compile ps_3_0 PShader2();
	}
}