
//------------------------------------
#include "Shared.fxh"

//------------------------------------

const bool g_bZBufferWrite;

sampler TextureSampler = sampler_state 
{
    AddressU  = WRAP;        
    AddressV  = WRAP;
    AddressW  = CLAMP;
};

struct vertexInput
{
    float4 Position	: POSITION0;
    float2 UV		: TEXCOORD0;
};

struct vertexOutput
{
    float4 Position : POSITION0;
    float2 UV		: TEXCOORD0;
};

//------------------------------------
vertexOutput VS_TransformDiffuse(vertexInput IN) 
{
    vertexOutput OUT;

    	OUT.Position	= mul(IN.Position , g_xViewProjectionMatrix);
	
	OUT.UV = IN.UV;
   
    return OUT;
}

float4 PS_GetTexture( vertexOutput IN ) : COLOR
{
	float4 xTexture = TexFetch2D_LinearLinearLinear( TextureSampler, IN.UV);
	return xTexture;
}


//-----------------------------------
technique OcclusionPass
{
    pass p0 
    {
		AlphaTestEnable = TRUE;
		CullMode = CW;
		ZEnable = TRUE;
		ZWriteEnable = <g_bZBufferWrite>;

		VertexShader = compile vs_1_1 VS_TransformDiffuse();
			
		PixelShader = compile ps_1_1 PS_GetTexture();
    }
}