/******************************************************************************/
/* Parameters                                                                 */
/******************************************************************************/

texture g_xTexture;
sampler g_xTextureSampler = sampler_state
{
	Texture = <g_xTexture>;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

float g_fXOffset1;
float g_fYOffset1;
float g_fXOffset2;
float g_fYOffset2;

/******************************************************************************/
/* Types                                                                      */
/******************************************************************************/
struct Vertex
{
	float4 m_xPosition : POSITION;
	float2 m_xUV       : TEXCOORD;
};

/******************************************************************************/
/* Functions                                                                  */
/******************************************************************************/

Vertex VShader( const Vertex xIn )
{
	return xIn;
}

float4 PShader( const Vertex xIn ) : COLOR
{
	float2 vOffset1 = float2( g_fXOffset1, g_fYOffset1 );
	float2 vOffset2 = float2( g_fXOffset2, g_fYOffset2 );
	return float4( ( tex2D( g_xTextureSampler, xIn.m_xUV - vOffset1 ).rgb + tex2D( g_xTextureSampler, xIn.m_xUV + vOffset2 ).rgb ) * 0.5, 1.0f );
}


/******************************************************************************/
/* Techniques                                                                 */
/******************************************************************************/

technique
{
	pass
	{
		VertexShader = compile vs_3_0 VShader();
		PixelShader = compile ps_3_0 PShader();
	}
}