/******************************************************************************/
/* Parameters                                                                 */
/******************************************************************************/

bool   g_bFogEnabled : register( ps, b0 );
float2 g_xFogParams : register( ps, c8 ); // (fog near plane, 1 / (fog far plane - fog near plane))

// Fog colour comes after light info, since additive strips need to set it to black
float3 g_xFogColour : register( ps, c133 );

sampler1D g_xFogTexture : register( ps, s1 ) = sampler_state
{
	AddressU = CLAMP;
};

/******************************************************************************/
/* Functions                                                                  */
/******************************************************************************/

float4 ApplyFog( float4 xColour, float fDepth )
{
	if( g_bFogEnabled )
	{
		// Fog it
		const float fLookup = (fDepth - g_xFogParams.x) * g_xFogParams.y;
		float4 fFogTextureColour;

		asm
		{
			tfetch1D fFogTextureColour, fLookup, g_xFogTexture, MinFilter=linear, MagFilter=linear, MipFilter=point, AnisoFilter=disabled
		};

		xColour.rgb = lerp( xColour.rgb, g_xFogColour, fFogTextureColour.a );
	}

	return xColour;
}