
// Normal-map related variables...

shared bool     g_bHasNormalMaps;
shared	bool	g_bDualPassNormalMap;


//------------------------------------
float3 CalculateNormal3 (sampler xSampler,
						 float2 xUV)
{
	float3	xNormal	= tex2D (xSampler, xUV);
	
	// Current range is 0..1, change it to -1..1...
	xNormal	*= 2.0;
	xNormal	-= 1.0;
	xNormal = normalize(xNormal);

	xNormal.y = -xNormal.y;
	// Return the normal...
	return	(xNormal);
}

float4 CalculateNormal4 (sampler xSampler,
						 float2 xUV)
{
	float4	xNormal	= TexFetch2D_LinearLinearLinear (xSampler, xUV);

	// That's in 0..1 range. Bias and scale into -1..1, and calculate z
	xNormal.xy = xNormal.xy * 2.0h - 1.0h;

	// Our normal maps are output upside-down. TODO: do this in a preprocessing step
	xNormal.y = -xNormal.y;
	xNormal.z = sqrt( 1.0h - dot( xNormal.xy, xNormal.xy ) );
	xNormal.w = 1.0h;
	xNormal.xyz = normalize(xNormal.xyz);
	return	(xNormal);
}


float CalculateDisplacement (sampler xSampler,
							 float2 xUV)
{
	// Extract the alpha from the texture...
	return	(tex2D(xSampler, xUV).a);
}


/// End of file. ///
