/******************************************************************************/
/* Parameters                                                                 */
/******************************************************************************/

const sampler2D g_xStencilTexture = sampler_state
{
	AddressU = CLAMP;
	AddressV = CLAMP;
};

/******************************************************************************/
/* Types                                                                      */
/******************************************************************************/

struct Vertex
{
	float4 m_xPosition : POSITION;
//	float2 m_xUV       : TEXCOORD;
};

/******************************************************************************/
/* Functions                                                                  */
/******************************************************************************/

Vertex VShader( const Vertex xIn )
{
	return xIn;
}

float2 g_xVPOSOffsetVector : register(ps, c20);
float4 PShader( float2 ScreenPos : VPOS ) : COLOR
{
	float ColumnIndex = (ScreenPos.x + 0.99999f) / 80;
    float HalfColumn = frac( ColumnIndex );
    float2 TexCoord = ScreenPos;
    if( HalfColumn > 0.5f )
        TexCoord.x -= ( 80 / 2 );
    else
        TexCoord.x += ( 80 / 2 );

	TexCoord += g_xVPOSOffsetVector;

	float4 xStencil;
	asm
	{
		tfetch2D xStencil, TexCoord, g_xStencilTexture, UnnormalizedTextureCoords=true, MinFilter=point, MagFilter=point, MipFilter=point, AnisoFilter=disabled, OffsetX=0.5, OffsetY=0.5
	};

	return xStencil.zyxw;
}

/******************************************************************************/
/* Techniques                                                                 */
/******************************************************************************/

technique
{
	pass
	{
		AlphaTestEnable = FALSE;
		CullMode = NONE;
		ZEnable = FALSE;

		VertexShader = compile vs_3_0 VShader();
		PixelShader = compile ps_3_0 PShader();
	}
}