// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Interface for Cypher implementations.

#ifndef BD_CYPHER_3DES_H
#define BD_CYPHER_3DES_H

#include <bdCore/bdMemory/bdMemory.h>
#include <bdCore/bdCrypto/bdCypher.h>

#include <bdCore/bdContainers/bdByteBuffer.h>

class bdCypher3Des : public bdCypher
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		/// Default constructor
		bdCypher3Des();

		/// Virtual destructor
		virtual ~bdCypher3Des();

		virtual bdBool encrypt(const bdUByte8 *key,
							   const bdUInt keySize,
							   const bdUByte8 *iv,
							   const bdUByte8 *pt,
							   bdUByte8 *ct,
							   bdUInt &size);

		virtual bdBool decrypt(const bdUByte8 *key,
							   const bdUInt keySize,
							   const bdUByte8 *iv,
							   const bdUByte8 *ct,
							   bdUByte8 *pt,
							   bdUInt &size);

	protected:
};

#endif // BD_CYPHER_3DES_H

