// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Identifier for security key data.

#ifndef BD_SECURITY_ID_H
#define BD_SECURITY_ID_H

#include <bdCore/bdCore.h>

#define BD_SECURITY_ID_LENGTH		(8)

#ifndef BD_PLATFORM_XBOX

/// Represents a security key data identifier.
class bdSecurityID
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		/// Basic constructor.
		bdSecurityID();

		/// Equals operator to allow easy comparison of bdSecurityIDs.
		/// \param other[in] The sec id to compare with this one.
		/// \return
		///  - True if the 2 sec ids match.
		///  - False otherwise.
		bdBool operator == (const bdSecurityID &other) const;

	public:
	
		bdUByte8 ab[BD_SECURITY_ID_LENGTH];

};

#else
typedef XNKID bdSecurityID;
#endif // #ifndef BD_PLATFORM_XBOX

#endif // BD_SECURITY_ID_H

