// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Security key, used to identify trusted remote entities.

#ifndef BD_SECURITY_KEY_H
#define BD_SECURITY_KEY_H

#include <bdCore/bdCore.h>

#define BD_SECURITY_KEY_LENGTH		(16)

#ifndef BD_PLATFORM_XBOX

/// Represents a security key.
class bdSecurityKey
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		/// Basic constructor.
		bdSecurityKey();

		/// Equals operator to allow easy comparison of bdSecurityKeys.
		/// \param other[in] The sec key to compare with this one.
		/// \return
		///  - True if the 2 sec keys match.
		///  - False otherwise.
		bdBool operator == (const bdSecurityKey &other) const;

	public:
	
		bdUByte8 ab[BD_SECURITY_KEY_LENGTH];

};

#else
typedef XNKEY bdSecurityKey;
#endif //#ifndef BD_PLATFORM_XBOX

#endif // BD_SECURITY_KEY_H

