// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Provides an interface for writing to a file.

#ifndef BD_OF_STREAM_H
#define BD_OF_STREAM_H

#include <bdCore/bdMemory/bdMemory.h>
#include <bdCore/bdStreams/bdOStream.h>
#include <bdCore/bdStreams/bdDefaultFileStreambuf.h>

/// Provides a stream interface for writing data from files.
class bdOfStream : public bdOStream
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		/// Constructor. Attempts to open a file for writing using a
		/// bdDefaultFileStreambuf. The bdDefaultFileStreambuf will be 
		/// constructed automatically in bdDefaultFileStreambuf::WRITE mode.
		/// \param filename[in] The name of the file to open.
		bdOfStream(const bdNChar8 *const filename);

	protected:

		/// The file stream buffer manipulated by this file stream.
		bdDefaultFileStreambuf m_fileStreambuf;

};

#endif // BD_OF_STREAM_H
