// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#include "MatchMakingQueries.h"

FindSessionByIDResult::FindSessionByIDResult()
: m_gotResult(false)
{
}

bdBool FindSessionByIDResult::handleResult(const bdUInt numReplies, bdBitBufferRef buffer)
{
	bdBool ok = true;
	if (numReplies > 0)
	{
		m_gotResult = m_customMMInfo.deserialize(buffer);
	}
	return ok;
}

FindSessions::FindSessions(bdUInt maxNumResults)
: bdCustomQueryParams(FINDSESSIONS, maxNumResults)
{
}

void FindSessions::serialize(bdBitBuffer& buffer)
{
    bdCustomQueryParams::serialize(buffer);
	
}

FindSessionsResult::FindSessionsResult()
{
}

bdBool FindSessionsResult::handleResult(const bdUInt numReplies, bdBitBufferRef buffer)
{
	bdBool ok = true;
	if (numReplies > 0)
	{
		m_numResults = numReplies;
		for (bdUInt i=0; i<numReplies && ok; i++)
		{
			ok = m_customMMInfo[i].deserialize(buffer);
		}
	}
	return ok;
}
