// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#include "bdMatchMakingQueries.h"

bdFindSessionByIDResult::bdFindSessionByIDResult()
: m_gotResult(false)
{
}

bdBool bdFindSessionByIDResult::handleResult(bdUInt numReplies, bdBitBufferRef buffer)
{
	bdBool ok = true;
	if (numReplies > 0)
	{
		m_gotResult = m_customMMInfo.deserialize(buffer);
	}
	return ok;
}

bdFindSessionsByGameType::bdFindSessionsByGameType(bdUInt maxNumResults,
						 	     bdInt pGameType)
: bdCustomQueryParams(BD_FINDSESSIONSBYGAMETYPE, maxNumResults),
  m_pGameType(pGameType)
{
}

void bdFindSessionsByGameType::serialize(bdBitBuffer& buffer)
{
    bdCustomQueryParams::serialize(buffer);
	
	buffer.writeInt32(m_pGameType);
}

bdFindSessionsByGameTypeResult::bdFindSessionsByGameTypeResult()
: m_numResults(0)
{
}

bdBool bdFindSessionsByGameTypeResult::handleResult(bdUInt numReplies, bdBitBufferRef buffer)
{
	bdBool ok = true;
	if (numReplies > 0)
	{
		m_numResults = numReplies;
		bdBool ok = true;
		for (bdUInt i=0; i<numReplies && ok; i++)
		{
			ok = m_customMMInfo[i].deserialize(buffer);
		}
	}
	return ok;
}

bdFindSessionsByPublicOpen::bdFindSessionsByPublicOpen(bdUInt maxNumResults,
													   bdUInt publicOpen)
													   : bdCustomQueryParams(BD_FIND_SESSIONS_BY_PUBLIC_OPEN, maxNumResults),
													   m_publicOpen(publicOpen)
{
}

void bdFindSessionsByPublicOpen::serialize(bdBitBuffer &buffer)
{
	bdCustomQueryParams::serialize(buffer);
	buffer.writeInt32(m_publicOpen);
}

bdFindSessionsByPublicOpenResult::bdFindSessionsByPublicOpenResult()
: m_numResults(0)
{
}

bdBool bdFindSessionsByPublicOpenResult::handleResult(bdUInt numRows, bdBitBufferRef buffer)
{
	bdBool ok = true;
	if(numRows > 0)
	{
		m_numResults = numRows;
		for (bdUInt i=0; i<numRows && ok; i++)
		{
			ok = m_MMInfo[i].deserialize(buffer);
		}
	}
	return ok;
}
