
// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#include "SampleLeaderboard1.h"

SampleLeaderboard1::SampleLeaderboard1()
: bdStatsInfo(0),
  m_kills(0),    
  m_deaths(0),   
  m_assists(0),   
  m_started(0),   
  m_completed(0),   
  m_pcWins(0)
{
}

SampleLeaderboard1::~SampleLeaderboard1()
{
}
		
SampleLeaderboard1::SampleLeaderboard1(const bdUInt64 rating,
					     const bdInt64 kills,
					     const bdUInt deaths,
					     const bdUInt assists,
					     const bdUInt started,
					     const bdUInt completed,
					     const bdUInt64 pcWins)
: bdStatsInfo(rating),
  m_kills(kills),
  m_deaths(deaths),
  m_assists(assists),
  m_started(started),
  m_completed(completed),
  m_pcWins(pcWins)
{

}


		
		
bdInt64 SampleLeaderboard1::getKills() const
{
	return m_kills;
}

void SampleLeaderboard1::setKills(bdInt64 kills)
{
	m_kills = kills;
}
          
bdUInt SampleLeaderboard1::getDeaths() const
{
	return m_deaths;
}

void SampleLeaderboard1::setDeaths(bdUInt deaths)
{
	m_deaths = deaths;
}
          
bdUInt SampleLeaderboard1::getAssists() const
{
	return m_assists;
}

void SampleLeaderboard1::setAssists(bdUInt assists)
{
	m_assists = assists;
}
          
bdUInt SampleLeaderboard1::getStarted() const
{
	return m_started;
}

void SampleLeaderboard1::setStarted(bdUInt started)
{
	m_started = started;
}
          
bdUInt SampleLeaderboard1::getCompleted() const
{
	return m_completed;
}

void SampleLeaderboard1::setCompleted(bdUInt completed)
{
	m_completed = completed;
}
          
bdUInt64 SampleLeaderboard1::getPcWins() const
{
	return m_pcWins;
}

void SampleLeaderboard1::setPcWins(bdUInt64 pcWins)
{
	m_pcWins = pcWins;
}
          
					 
void SampleLeaderboard1::serialize(bdBitBuffer &buffer)
{
	// Call up to the base class to serialize the standard statistics info.
	bdStatsInfo::serialize(buffer);

	// Serialize the custom attributes.
	// Only serialize them if the associated dirty flag is set. writeDirtyFlag
	// both writes the flag and returns its value, for easy delta compression.
	buffer.writeInt64(m_kills);
	buffer.writeUInt32(m_deaths);
	buffer.writeUInt32(m_assists);
	buffer.writeUInt32(m_started);
	buffer.writeUInt32(m_completed);
	buffer.writeUInt64(m_pcWins);
	
}


bdBool SampleLeaderboard1::deserialize(bdBitBufferRef buffer)
{
	// Call up to the base class to deserialize the standard matchmaking info.
	bdBool ok = bdStatsInfo::deserialize(buffer);

	ok = ok && buffer->readInt64(m_kills);

	bdInt32 tempdeaths = 0;
	ok = ok && buffer->readInt32(tempdeaths);
	m_deaths = static_cast<bdUInt32>(tempdeaths);

	bdInt32 tempassists = 0;
	ok = ok && buffer->readInt32(tempassists);
	m_assists = static_cast<bdUInt32>(tempassists);

	bdInt32 tempstarted = 0;
	ok = ok && buffer->readInt32(tempstarted);
	m_started = static_cast<bdUInt32>(tempstarted);

	bdInt32 tempcompleted = 0;
	ok = ok && buffer->readInt32(tempcompleted);
	m_completed = static_cast<bdUInt32>(tempcompleted);

	bdInt64 temppcWins = 0;
	ok = ok && buffer->readInt64(temppcWins);
	m_pcWins = static_cast<bdUInt64>(temppcWins);

	return ok;
}
