
// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE:


#ifndef BD_SAMPLELEADERBOARD1_INFO_H
#define BD_SAMPLELEADERBOARD1_INFO_H

#include <bdLobby/bdStats/bdStatsInfo.h>
#include <bdLobby/bdLobbyCommon/bdCustomQueryparams.h>
		 
#define SAMPLELEADERBOARD1 (1u)


/// This class derives from bdStatsInfo to add custom data attributes.
/// It also overrides the base class serialize/deserialize functions so that the
/// custom attributes are transmitted and received correctly
/// See the stats tutorial for more info.

class SampleLeaderboard1 : public bdStatsInfo
{
	public:
	
		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		SampleLeaderboard1();

		~SampleLeaderboard1();
		
		SampleLeaderboard1(const bdUInt64 rating,
							const bdInt64 kills,
							const bdUInt deaths,
							const bdUInt assists,
							const bdUInt started,
							const bdUInt completed,
							const bdUInt64 pcWins);
							
		bdInt64 getKills() const;

		void setKills(bdInt64 kills);

		bdUInt getDeaths() const;

		void setDeaths(bdUInt deaths);

		bdUInt getAssists() const;

		void setAssists(bdUInt assists);

		bdUInt getStarted() const;

		void setStarted(bdUInt started);

		bdUInt getCompleted() const;

		void setCompleted(bdUInt completed);

		bdUInt64 getPcWins() const;

		void setPcWins(bdUInt64 pcWins);


		/// Serialize all matchmaking info into a buffer.
		/// This is used to transmit this information to the service.
		/// \param param[out]	The buffer into which the member variables are 
		///						serialized.
		virtual void serialize(bdBitBuffer &buffer);

		/// Deserialize matchmaking info from a buffer.
		/// This is used to decode matchmaking results received from the service.
		/// \param param[in]	The buffer from which the matchmaking attributes
		///						should be deserialized.
		virtual bdBool deserialize(bdBitBufferRef buffer);

	protected:
		bdInt64 m_kills;
		bdUInt m_deaths;
		bdUInt m_assists;
		bdUInt m_started;
		bdUInt m_completed;
		bdUInt64 m_pcWins;
		
};

#endif // BD_CUSTOM_STATISTICS_INFO_H
