// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#ifndef BD_LOBBY_STRINGS_H
#define BD_LOBBY_STRINGS_H

#include<bdLobby/bdLobbyCommon/bdLobbyServicesCommon.h>
#include<bdLobby/bdMessageStore/bdMessageStore.h>

class bdGetFriendsResult;
class bdGetBlockListResult;
class bdGetGroupNamesResult;
class bdGetGroupedFriendsResult;
class bdGetProposalListResult;
class bdCheckTeamMembershipResult;
class bdGetTeamMembersResult;
class bdCreateTeamResult;
class bdGetTeamsProposalListResult;
class bdGetChannelMemberNamesResult;
class bdGetChannelMembersResult;
class bdGetFileResult;
class bdUploadFileResult;
class bdSessionCreateResult;
class bdStatsQueryResult;
class bdListFilesResult;
class bdGetChannelsResult;

/// Sample of Profiles class to be auto-generated by IMP-Profiles
class LobbyStrings
{
public:

	LobbyStrings();

	~LobbyStrings();

	bdBool formatErrorString(bdUInt32 errorCode);
	bdNChar8* getLastError();

	bdBool formatMessageString(bdUInt32 messageCode);
	bdNChar8* getLastMessage();

	bdBool formatMessageBriefDesc(bdLobbyMessageRef lobbyMessage);
	bdBool formatMessageDesc(bdLobbyMessageRef lobbyMessage);

	/// Appends the friends list to the supplied string
	void appendFriendsText(const bdGetFriendsResult& friendsList, bdString* screenText);

	/// Appends to the supplied string
	void appendGroupedFriendsText(const bdGetGroupedFriendsResult& friendsList, bdString* screenText);

	/// Appends to the supplied string
	void appendGroupNamesText(const bdGetGroupNamesResult& groupList, bdString* screenText);
	
	/// Appends to the supplied string
	void appendBlockListText(const bdGetBlockListResult& blockList, bdString* screenText);

	/// Appends to the supplied string
	void appendProposalListText(const bdGetProposalListResult& proposalList, bdString* screenText);

	/// Appends to the supplied string
	void appendTeamMembersText(const bdGetTeamMembersResult& membersList, bdString* screenText);

	/// Appends to the supplied string
	void appendTeamMembershipText(const bdCheckTeamMembershipResult& membershipList, bdString* screenText);

	/// Appends to the supplied string
	void appendTeamCreationText(const bdCreateTeamResult& creationResult, bdString* screenText);

	/// Appends to the supplied string
	void appendTeamProposalListText(const bdGetTeamsProposalListResult& proposalList, bdString* screenText);

	/// Appends to the supplied string
	void appendChannelsText(const bdGetChannelsResult& channelsList, bdString* screenText);

	/// Appends to the supplied string
	void appendChannelMembersText(const bdGetChannelMembersResult& membershipList, bdString* screenText);

	/// Appends to the supplied string
	void appendListFilesText(const bdListFilesResult& fileslist, bdString* screenText);

	/// Appends to the supplied string
	void appendGetFileText(const bdGetFileResult& file, bdString* screenText);

	/// Appends to the supplied string
	void appendUploadFileText(const bdUploadFileResult& file, bdString* screenText);

	/// Appends to the supplied string
	void appendSessionText(const bdSessionCreateResult& session, bdString* screenText);

	/// Appends to the supplied string
	void appendStatsQueryText(const bdStatsQueryResult& stats, bdString* screenText);

	/// Appends one msg in the local store to the supplied string
	/// and removes the message
	void consumeMessage(bdMessageStore* msgManager, bdString* screenText);

	/// Appends all msgs in the local store to the supplied string
	/// and removes those messages
	void consumeMessages(bdMessageStore* msgManager, bdString* screenText);

	/// Same as consumeMessages, but does not remove the messages from the local store
	void appendMessages(bdMessageStore* msgManager, bdString* screenText);

private:

	bdHashMap<bdUInt32,bdNChar8*> m_errorsHashmap;
	bdNChar8 m_lastError[128];

	bdHashMap<bdUInt32,bdNChar8*> m_messsageHashmap;
	bdNChar8 m_lastMessage[256];
};

#endif
