// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Describes a chat channel. 

#ifndef BD_CHANNEL_INFO_H
#define BD_CHANNEL_INFO_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdLobbyCommon/bdLobbyServicesCommon.h>

/// Describes a chat channel.
/// This class is the basis for the result set returned from the chat service
/// following a call to bdChannelChat::getChannelList.
class bdChannelInfo
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS
		
		bdChannelInfo();

		~bdChannelInfo();

		bdBool deserialize(bdBitBufferRef buffer);

		bdUInt64 m_channelID;
		bdNChar8 m_channelName[BD_MAX_CHANNELNAME_LENGTH];
		bdUByte8 m_channelType;
		bdUInt32 m_numSubscribers;
		bdUInt32 m_maxSubscribers;
};

#endif // BD_CHANNEL_INFO_H
