// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: The result set of a call to bdFriends::getGroupNames().

#ifndef BD_GET_GROUP_NAMES_RESULT_H
#define BD_GET_GROUP_NAMES_RESULT_H

#include <bdCore/bdCore.h>

#include <bdLobby/bdLobbyCommon/bdLobbyServicesCommon.h>
#include <bdLobby/bdLobbyCommon/bdQueryResult.h>

/// The result set of a call to bdFriends::getGroupNames().
/// An instance of this class should be passed to bdFriends::handleTask following
/// successful completion of a task returned from getGroupNames() function.
class bdGetGroupNamesResult : public bdQueryResult
{
	public:
		BD_DECLARE_NEW_AND_DELETE_OPERATORS
		
		class bdFriendGroup
		{
			public:

				BD_DECLARE_NEW_AND_DELETE_OPERATORS

				~bdFriendGroup(){};

				bdUByte8 m_groupID;
				bdNChar8 m_groupName[BD_MAX_GROUPNAME_LENGTH];
		};

		bdGetGroupNamesResult();

		virtual ~bdGetGroupNamesResult();

		virtual bdBool handleResult(const bdUInt numResults, 
									bdBitBufferRef buffer);

		/// After passing an instance of this class to bdFriends::handleTask,
		/// this array will contain entries for each group.
		bdArray<bdFriendGroup> m_friendgroups;
};

#endif // BD_GET_GROUP_NAMES_RESULT_H
