// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: The result set of a call to bdFriends::getProposalList().

#ifndef BD_GET_PROPOSAL_LIST_RESULT_H
#define BD_GET_PROPOSAL_LIST_RESULT_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdLobbyCommon/bdLobbyServicesCommon.h>
#include <bdLobby/bdLobbyCommon/bdQueryResult.h>

/// The result set of a call to bdFriends::getProposalList().
/// An instance of this class should be passed to bdFriends::handleTask following
/// successful completion of a task returned from getProposalList() function.
class bdGetProposalListResult : public bdQueryResult
{
	public:
		BD_DECLARE_NEW_AND_DELETE_OPERATORS
		
		class bdPotentialFriend
		{
			public:
				BD_DECLARE_NEW_AND_DELETE_OPERATORS
				~bdPotentialFriend(){};
				bdOnlineUserID m_userID;
				bdNChar8 m_userName[BD_MAX_USERNAME_LENGTH];
		};

		bdGetProposalListResult();

		virtual ~bdGetProposalListResult();

		virtual bdBool handleResult(const bdUInt numResults, 
									bdBitBufferRef buffer);

		/// After passing an instance of this class to bdFriends::handleTask,
		/// this array will contain an entry for each user a proposal has been 
		/// previously sent to, which has not yet been accepted or rejected.
		bdArray<bdPotentialFriend> m_proposalList;
};

#endif // BD_GET_PROPOSAL_LIST_RESULT_H
