// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// Purpose: A base class for implementing parameters to pass to pre-configured
//			custom queries.

#ifndef BD_CUSTOM_QUERY_PARAMS_H
#define BD_CUSTOM_QUERY_PARAMS_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdLobbyCommon/bdQueryParams.h>

/// A base class for implementing parameters to pass to pre-configured
///	custom queries.
class bdCustomQueryParams : public bdQueryParams
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdCustomQueryParams(const bdUInt queryID, 
							const bdUInt maxNumResults);

		virtual ~bdCustomQueryParams();

		virtual void serialize(bdBitBuffer &buffer);

		/// the ID of the custom query on the server
		bdUInt m_queryID;

		/// max number of rows to be returned as results
		bdUInt m_maxNumResults;

		bdUInt m_startIndex;
};

#endif // BD_CUSTOM_QUERY_PARAMS_H
