// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS
// PURPOSE: The result set obtained following a call to bdMatchMaking::createSession.

#ifndef BD_SESSION_CREATE_RESULT_H
#define BD_SESSION_CREATE_RESULT_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdLobbyCommon/bdQueryResult.h>

/// The result set obtained following a call to bdMatchMaking::createSession.
class bdSessionCreateResult : public bdQueryResult
{
	public:
		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		// Constructor.
		bdSessionCreateResult();

		virtual bdBool handleResult(const bdUInt numResults, 
									bdBitBufferRef buffer);

		/// Security ID assigned by server to the new session.
		bdSecurityID m_secID;

		/// Security key assigned by server to the new session.
		bdSecurityKey m_secKey;
};

#endif // BD_SESSION_CREATE_RESULT_H
