// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Collection of classes that are used in conjuction with the messaging
//	service. Games can derive from these for title specific messages.

#ifndef BD_LOBBY_MESSAGE_H
#define BD_LOBBY_MESSAGE_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdLobbyCommon/bdLobbyServicesCommon.h>
#include <bdLobby/bdMessageStore/bdMessageTypes/bdLobbyMessageType.h>

/// Contains common entries of a message
class bdLobbyMessage : public bdReferencable
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdLobbyMessage(const bdUInt messageType);

		virtual ~bdLobbyMessage();

		virtual bdBool deserialize(bdBitBufferRef buffer);

		/// The message type
		bdLobbyMessageType m_msgType;

		/// The user ID of the intended recipient of this messages
		bdOnlineUserID m_recipientID;

		/// A unique message ID
		bdUInt64 m_msgID;

		/// Time stamp when the message was created
		bdUInt32 m_timeStamp;

		/// Flag indicating whether this message has been read previously
		bdBool m_isRead;
};

BD_REFERENCE(bdLobbyMessage);

#endif // BD_LOBBY_MESSAGE_H
