// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Function to compare 2 bdLobbyMessages to facilitate sorting them.

#ifndef BD_LOBBY_MESSAGE_SORT_H
#define BD_LOBBY_MESSAGE_SORT_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdMessageStore/bdLobbyMessage.h>

class bdLobbyMessageCompare
{
	public:

		/// bdLobbyMessage comparison functor.
		/// Compares bdLobbyMessages using their timestamp. This can be used as
		/// the default comparison functor when calling
		/// bdMessageStore::sortMessages()
		/// \param x[in]
		/// \param y[in]
		/// \return
		/// - True if bdLobbyMessage \a x has a timestamp less than that
		///		of \a y.
		///	- False otherwise.
		inline bdBool operator() (const bdLobbyMessageRef& x,
								  const bdLobbyMessageRef& y) const
		{
			const bdBool lessThan = x->m_timeStamp < y->m_timeStamp;
			return lessThan;
		}
};

#endif // BD_LOBBY_MESSAGE_SORT_H
