// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Collection of classes that are used in conjuction with the messaging
//	service. 

#ifndef BD_CHANNEL_NOTIFICATION_MESSAGE_H
#define BD_CHANNEL_NOTIFICATION_MESSAGE_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdMessageStore/bdLobbyMessage.h>

BD_REFERENCE(bdChannelNotificationMessage);

class bdChannelNotificationMessage : public bdLobbyMessage
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdChannelNotificationMessage(const bdUInt messageType);

		bdChannelNotificationMessage();

		virtual ~bdChannelNotificationMessage();

		virtual bdBool deserialize(bdBitBufferRef buffer);

		/// The ID of the user that caused this notification
		bdOnlineUserID m_originatorID;

		/// The name of the user that caused this notification
		bdNChar8 m_originatorName[BD_MAX_USERNAME_LENGTH];

		/// The ID of the user that caused this notification
		bdUInt64 m_channelID;

		/// The name of the user that caused this notification
		bdNChar8 m_channelName[BD_MAX_CHANNELNAME_LENGTH];

};

#endif // BD_CHANNEL_NOTIFICATION_MESSAGE_H


