// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Collection of classes that are used in conjuction with the messaging
//	service. Games can derive from these for title specific messages.

#ifndef BD_FRIEND_CUSTOM_MESSAGE_H
#define BD_FRIEND_CUSTOM_MESSAGE_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdMessageStore/bdMessageTypes/bdUserNotificationMessage.h>

BD_REFERENCE(bdFriendCustomMessage);

class bdFriendCustomMessage: public bdUserNotificationMessage
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdFriendCustomMessage(const bdUInt messageType);

		virtual ~bdFriendCustomMessage();

		virtual bdBool deserialize(bdBitBufferRef buffer);

		/// The payload
		bdByteBufferRef m_data;
};

#endif // BD_FRIEND_CUSTOM_MESSAGE_H
