// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#include <bdLobby/bdMessageStore/bdMessageTypes/bdFriendshipProposalMessage.h>

bdFriendshipProposalMessage::bdFriendshipProposalMessage(const bdUInt messageType)
: bdUserNotificationMessage(messageType),
  m_attachmentSize(0),
  m_attachment(BD_NULL)
{
}

bdFriendshipProposalMessage::~bdFriendshipProposalMessage()
{
	if(m_attachment)
	{
		bdMemory::deallocate(m_attachment);
	}
}

bdBool bdFriendshipProposalMessage::deserialize(bdBitBufferRef buffer)
{
	bdBool ok = bdUserNotificationMessage::deserialize(buffer);
	ok = ok && buffer->readUInt16(m_attachmentSize);
	
	if (ok && (m_attachmentSize > 0))
	{
		if(m_attachment)
		{
			bdMemory::deallocate(m_attachment);
		}
		m_attachment = bdMemory::allocate(m_attachmentSize);
		
		bdUInt32 size = m_attachmentSize;
		ok = ok && buffer->readBlob(static_cast<bdUByte8*>(m_attachment), size);
	}

	return ok;
}
