// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Collection of classes that are used in conjuction with the messaging
//	service. Games can derive from these for title specific messages.

#ifndef BD_TEAM_CUSTOM_MESSAGE_H
#define BD_TEAM_CUSTOM_MESSAGE_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdMessageStore/bdMessageTypes/bdTeamNotificationMessage.h>

BD_REFERENCE(bdTeamCustomMessage);

class bdTeamCustomMessage: public bdTeamNotificationMessage
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdTeamCustomMessage(const bdUInt messageType);

		virtual ~bdTeamCustomMessage();

		virtual bdBool deserialize(bdBitBufferRef buffer);

		/// The payload
		bdByteBufferRef m_data;
};

#endif // BD_TEAM_CUSTOM_MESSAGE_H
