// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Collection of classes that are used in conjuction with the messaging
//	service. Games can derive from these for title specific messages.

#ifndef BD_TEAM_INVITATION_MESSAGE_H
#define BD_TEAM_INVITATION_MESSAGE_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdMessageStore/bdMessageTypes/bdTeamNotificationMessage.h>

BD_REFERENCE(bdTeamInvitationMessage);

/// Represents an invitation to a team
class bdTeamInvitationMessage: public bdTeamNotificationMessage
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdTeamInvitationMessage(const bdUInt messageType);

		virtual ~bdTeamInvitationMessage();

		virtual bdBool deserialize(bdBitBufferRef buffer);

		bdUInt16 m_attachmentSize;
		void *m_attachment;
};

#endif // BD_TEAM_INVITATION_MESSAGE_H
