// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#include <bdLobby/bdMessageStore/bdMessageTypes/bdTeamSessionInvitationMessage.h>

bdTeamSessionInvitationMessage::bdTeamSessionInvitationMessage(const bdUInt messageType)
: bdTeamNotificationMessage(messageType),
  m_attachmentSize(0),
  m_attachment(BD_NULL)
{
}

bdTeamSessionInvitationMessage::~bdTeamSessionInvitationMessage()
{
	if(m_attachment)
	{
		bdMemory::deallocate(m_attachment);
	}
}

bdBool bdTeamSessionInvitationMessage::deserialize(bdBitBufferRef buffer)
{
	bdBool ok = bdTeamNotificationMessage::deserialize(buffer);
	bdUInt length =  BD_SECURITY_ID_LENGTH;
	ok = ok && buffer->readBlob(&m_secID.ab[0], length);
	ok = ok && buffer->readUInt16(m_attachmentSize);

	if (ok && (m_attachmentSize > 0))
	{
		if(m_attachment)
		{
			bdMemory::deallocate(m_attachment);
		}
		m_attachment = bdMemory::allocate(m_attachmentSize);

		bdUInt32 size = m_attachmentSize;
		ok = ok && buffer->readBlob(static_cast<bdUByte8*>(m_attachment),size);
	}

	return ok;
}
