// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Collection of classes that are used in conjuction with the messaging
//	service. Games can derive from these for title specific messages.

#ifndef BD_TEAM_SESSION_INVITATION_MESSAGE_H
#define BD_TEAM_SESSION_INVITATION_MESSAGE_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdMessageStore/bdMessageTypes/bdTeamNotificationMessage.h>

BD_REFERENCE(bdTeamSessionInvitationMessage);

/// Represents an invitation to a game session
class bdTeamSessionInvitationMessage: public bdTeamNotificationMessage
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdTeamSessionInvitationMessage(const bdUInt messageType);

		virtual ~bdTeamSessionInvitationMessage();

		virtual bdBool deserialize(bdBitBufferRef buffer);

		/// The security ID that is needed to connect to the game sessions
		bdSecurityID m_secID;
		bdUInt16 m_attachmentSize;
		void * m_attachment;
};

#endif // BD_TEAM_SESSION_INVITATION_MESSAGE_H
