// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Collection of classes that are used in conjuction with the messaging
//	service. Games can derive from these for title specific messages.

#ifndef BD_USER_NOTIFICATION_MESSAGE_H
#define BD_USER_NOTIFICATION_MESSAGE_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdMessageStore/bdLobbyMessage.h>

BD_REFERENCE(bdUserNotificationMessage);

class bdUserNotificationMessage : public bdLobbyMessage
{
	public:
		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdUserNotificationMessage(const bdUInt messageType);

		virtual ~bdUserNotificationMessage();

		virtual bdBool deserialize(bdBitBufferRef buffer);

		/// The ID of the user that caused this notification
		bdOnlineUserID m_originatorID;

		/// The name of the user that caused this notification
		bdNChar8 m_originatorName[BD_MAX_USERNAME_LENGTH];

};

#endif // BD_USER_NOTIFICATION_MESSAGE_H


