// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS



template <typename T, bdUInt ARRAY_SIZE>
bdLeaderBoardResult<T, ARRAY_SIZE>::bdLeaderBoardResult()
: m_totalLeaderboardEntries(0)
{
}

template <typename T, bdUInt ARRAY_SIZE>
bdLeaderBoardResult<T, ARRAY_SIZE>::~bdLeaderBoardResult()
{
}

template <typename T, bdUInt ARRAY_SIZE>
bdBool bdLeaderBoardResult<T, ARRAY_SIZE>::handleResult(const bdUInt numResults,
														bdBitBufferRef buffer)
{
	bdBool ok = buffer->readUInt32(m_totalLeaderboardEntries);
	const bdUInt resultsToRead = BD_MIN(numResults , ARRAY_SIZE);
	if(resultsToRead != numResults )
	{
		BD_WARN("bdLeaderBoardResultTemplate", "Received %u results but can only store %u.",
					numResults, ARRAY_SIZE );
	}


	for(bdUInt i=0; ok && (i < resultsToRead); i++)
	{
		ok = m_leaderBoardEntries[i].deserialize(buffer);
		if(ok)
		{
			m_numResults++;
		}
	}

	return ok;
}
