// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE:  Container class for storing title specific search results.
//	A game should create a subclass for each title specific query.
//  Search parameters are stored in bdQueryParams.


#ifndef BD_START_ARBITRATED_SESSION_RESULT
#define BD_START_ARBITRATED_SESSION_RESULT

#include <bdCore/bdCore.h>
#include <bdLobby/bdLobbyCommon/bdQueryResult.h>

BD_REFERENCE(bdBitBuffer);

/// Container class for storing title specific search results.
///	A game should create a subclass for each title specific query.
/// Search parameters are stored in bdQueryParams.
class bdStartArbitratedSessionResult : public bdQueryResult
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		/// Default constructor
		bdStartArbitratedSessionResult();

		/// Virtual destructor.
		virtual ~bdStartArbitratedSessionResult();

		/// Handles a result set for a title specific query.
		/// \param numRows[in] : The number of rows in the result set.
		/// \param values[in] : The actual values of each data field.
		virtual bdBool handleResult(const bdUInt /*numResults*/, 
									bdBitBufferRef /*buffer*/);

		bdUInt64 m_nonce;
};

#endif // BD_START_ARBITRATED_SESSION_RESULT
