// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS


#include <bdLobby/bdStats/bdStatsSubmission.h>

#define BD_LOG_LEVEL "statsSubmission"


bdStatsSubmission::bdStatsSubmission()
: m_statsInfo(BD_NULL)
{
}

bdStatsSubmission::~bdStatsSubmission()
{
}

bdStatsSubmission::bdStatsSubmission(const bdLeaderBoardID leaderboardID,
									 const bdStats::bdWriteType writeType,
									 bdStatsInfo* const statsInfo)
: m_leaderboardID(leaderboardID),
  m_writeType(writeType),
  m_statsInfo(statsInfo)
{
}

void bdStatsSubmission::setLeaderboardID(const bdLeaderBoardID newLeaderboardID)
{
	m_leaderboardID = newLeaderboardID;
}
bdLeaderBoardID bdStatsSubmission::getLeaderboardID() const
{
	return m_leaderboardID;
}

void bdStatsSubmission::setWriteType(const bdStats::bdWriteType newWriteType)
{
	m_writeType = newWriteType;
}

bdStats::bdWriteType bdStatsSubmission::getWriteType() const
{
	return m_writeType;
}

void bdStatsSubmission::setStatsInfo(bdStatsInfo* const newStatsInfo)
{
	m_statsInfo = newStatsInfo;
}

bdStatsInfo* bdStatsSubmission::getStatsInfo() const
{
	return m_statsInfo;
}

bdBool bdStatsSubmission::serialize(bdBitBuffer &buffer)
{
	if (m_statsInfo)
	{
		buffer.writeUInt32(m_leaderboardID);
		buffer.writeUInt64(m_statsInfo->getEntityID());
		buffer.writeUByte8(static_cast<bdUByte8>(m_writeType));
		buffer.writeUInt32(m_statsInfo->getNumFields());
		m_statsInfo->serialize(buffer);

		return true;
	}

	return false;
}

bdBool bdStatsSubmission::deserialize(bdBitBufferRef buffer)
{
	BD_ASSERT(g_assertFalse, "Not implemented.");
	return false;
}
