// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Used for obtaining the result set following a call to bdStorage::getFile.

#ifndef BD_GET_FILE_RESULT_H
#define BD_GET_FILE_RESULT_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdLobbyCommon/bdQueryResult.h>
#include <bdLobby/bdStorage/bdLobbyFile.h>

/// Result set for use following a call to bdStorage::getFile.
class bdGetFileResult : public bdQueryResult
{
	public:
		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdGetFileResult(){};

		virtual ~bdGetFileResult();

		virtual bdBool handleResult(const bdUInt numResults, 
									bdBitBufferRef buffer);

		/// After passing an instance of this class to bdStorage::handleTask,
		/// this array will contain bdLobbyFile instances for each file returned.
		bdArray<bdLobbyFileRef> m_files; 
};

#endif // BD_GET_FILE_RESULT_H
