// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Used for obtaining the file ID following a call to bdStorage::uploadFile().

#ifndef BD_UPLOAD_FILE_RESULT_H
#define BD_UPLOAD_FILE_RESULT_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdLobbyCommon/bdQueryResult.h>

/// Used for obtaining the file ID following a call to bdStorage::uploadFile().
class bdUploadFileResult : public bdQueryResult
{
	public:
		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdUploadFileResult(){};

		virtual ~bdUploadFileResult(){};

		virtual bdBool handleResult(const bdUInt numResults, 
									bdBitBufferRef buffer);

		/// After passing an instance of this class to bdStorage::handleTask,
		/// this will contain the file ID allocated by the storage service for
		/// the uploaded file.
		bdUInt64 m_fileID;
};

#endif // BD_UPLOAD_FILE_RESULT_H
