// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Result set container for bdTeams::checkTeamMembership tasks.

#ifndef BD_CHECK_TEAM_MEMBERSHIP_RESULT_H
#define BD_CHECK_TEAM_MEMBERSHIP_RESULT_H

#include <bdLobby/bdLobbyCommon/bdLobbyServicesCommon.h>
#include <bdLobby/bdLobbyCommon/bdQueryResult.h>

/// Result set container for bdTeams::checkTeamMembership tasks. 
/// An instance of this class should be passed to bdTeams::handleTask upon 
/// successful completion of a bdTeams::checkTeamMembership task.
class bdCheckTeamMembershipResult : public bdQueryResult
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		enum bdTeamMemberStatus
		{
			BD_ORDINARY		= 0,
			BD_ADMIN		= 1,
			BD_OWNER		= 2
		};

		class bdTeam
		{
			public:
				BD_DECLARE_NEW_AND_DELETE_OPERATORS
				// Default constructor
				bdTeam();
				~bdTeam(){};
				bdOnlineUserID m_teamID;
				bdNChar8 m_teamName[BD_MAX_TEAMNAME_LENGTH];
				bdUByte8 m_memberStatus;
		};

		bdCheckTeamMembershipResult();

		virtual ~bdCheckTeamMembershipResult();

		virtual bdBool handleResult(const bdUInt numResults, 
									bdBitBufferRef buffer);

		/// Following a call to bdTeams::handleTask with an instance of this 
		/// class, this array will be populated.
		bdArray<bdTeam> m_teams;
};

#endif // BD_CHECK_TEAM_MEMBERSHIP_RESULT_H
