// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#ifndef BD_IN_STREAM_H
#define BD_IN_STREAM_H

#include <bdCore/bdCore.h>
#include <bdNet/bdStream/bdStreamId.h>

BD_REFERENCE(bdConnection);
BD_REFERENCE(bdInStream);

class bdInStream : public bdReferencable
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		/// Constructor
		bdInStream(const bdStreamId &streamId, const bdConnectionRef connection);

		/// Virtual destructor
		virtual ~bdInStream();

		virtual void receiveData(const bdBitBufferRef buffer,
								 const bdBitBufferRef unencBuffer) = 0;

		const bdStreamId &getStreamId() const;

		bdConnectionRef getConnection() const;

	protected:

		bdStreamId m_streamId;

		bdConnectionRef m_connection;

};

#endif // BD_IN_STREAM_H
