// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#ifndef BD_STREAM_ID_H
#define BD_STREAM_ID_H

#include <bdCore/bdCore.h>

#include <bdNet/bdStream/bdStreamTypes.h>

class bdStreamId
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		/// Constructor
		bdStreamId(const bdCommonAddrRef addr,
				   const bdStreamNum streamNum);

		/// Virtual Destructor
		~bdStreamId();

		bdBool operator==(const bdStreamId &other) const;

		bdCommonAddrRef getAddr() const;

		bdStreamNum getStreamNum() const;

	protected:

		bdCommonAddrRef m_addr;
		bdStreamNum m_streamNum;
};

class bdStreamIdHash
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdUInt getHash(const bdStreamId &streamId) const;
};


#endif // BD_STREAM_ID_H
