// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: WIN32 PS2 PS3 PSP-INFRA UNIX OSX
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: A listener class for LAN discovery related events

#ifndef BD_UPNP_LISTENER_H
#define BD_UPNP_LISTENER_H

#include <bdCore/bdCore.h>

class bdUPnPListener
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdUPnPListener();

		virtual ~bdUPnPListener();

		/// Called in the event of UPnP failure.
		virtual void onUPnPError();

		/// called when UPnP delivery has completed.
		/// \param numDevices[in] The number of UPnP capable devices detected
		virtual void onDiscovery(bdUInt numDevices);

		/// called when the query for existing port mappings completes.
		/// \param collisionDetected[in] indicates whether the external port requested is already mapped.
		virtual void onQueryResponse(bdBool collisionDetected);

		/// called when the port mapping responses have been received.
		/// \param succeeded[in] indicates whether the port mapping was successful.
		virtual void onMapResponse(bdBool succeeded);
};

#endif //BD_UPNP_LISTENER_H
