// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Used for accessing system error handling operations for a platform.

#ifndef BD_PLATFORM_ERROR_H
#define BD_PLATFORM_ERROR_H

#include <bdPlatform/bdPlatformCoreTypes/bdPlatformCoreTypes.h>

#define BD_COMPILE_ASSERT(expr, msg) typedef bdNChar8 bdCompileAssert_##msg[(expr) ? 1 : -1]

/// Get the system-level error code.
/// \return Returns the value of extern int errno from <errno.h>.
inline bdInt BD_CALL bdGetErrno();

/// Abort the program.
inline void BD_CALL bdAbort();

#include <bdPlatform/bdPlatformError/bdPlatformError.inl>

#endif // BD_PLATFORM_ERROR_H
