// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: WIN32 PS2 UNIX OSX PSP-INFRA PS3
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: DTLS cookie ack packet.


#ifndef BD_DTLS_COOKIE_ACK_H
#define BD_DTLS_COOKIE_ACK_H

#include <bdCore/bdCore.h>
#include <bdSocket/bdDTLS/bdPacket/bdDTLSHeader.h>

class bdDTLSCookieAck : public bdDTLSHeader
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdDTLSCookieAck();

		virtual ~bdDTLSCookieAck();

		bdDTLSCookieAck(bdUInt16 vtag, const bdUByte8 key[BD_ECC_EXPORTED_KEY_SIZE]);

		virtual bdBool serialize(void *data,const bdUInt size,
			const bdUInt offset, bdUInt &newOffset) const;
		virtual bdBool deserialize(const void* data, const bdUInt size,
			const bdUInt offset, bdUInt &newOffset);

		const bdUByte8 *getECCKey() const;

	protected:

		bdUByte8 m_ECCKey[BD_ECC_EXPORTED_KEY_SIZE];
};

#endif // BD_DTLS_COOKIE_ACK_H



