// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: WIN32 PS2 UNIX OSX PSP-INFRA PS3
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#ifndef BD_IP_DISCOVERY_CLIENT_H
#define BD_IP_DISCOVERY_CLIENT_H

#include <bdCore/bdCore.h>

class bdIPDiscoveryClient
{

	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		/// Constructor
		bdIPDiscoveryClient(bdDefaultSocket *socket, const bdAddr &server);

		/// Virtual destructor
		virtual ~bdIPDiscoveryClient();

		bdBool startDiscovery();

		bdBool isPending() const;

		bdBool wasSuccess() const;

		/// Returns the public IP address and port.
		/// This function only returns a meaningful value after the discovery has been completed.
		/// \return The public IP address and port to which the local address is mapped to.
		const bdAddr& getPublicAddress() const;

		void pump();

	protected:

		bdDefaultSocket *m_socket;

		// The address at which the server is located
		bdAddr m_serverAddr;

		// The address the NAT has mapped our local address to
		bdAddr m_publicAddr;

		bdBool m_success;

		bdUByte8 m_retries;

		bdStopwatch m_timer;
};

#endif // BD_IP_DISCOVERY_CLIENT_H
