
#ifndef _MFnNonExtendedLight
#define _MFnNonExtendedLight
//
//-
// ==========================================================================
// Copyright (C) 1995 - 2006 Autodesk, Inc., and/or its licensors.  All 
// rights reserved.
// 
// The coded instructions, statements, computer programs, and/or related 
// material (collectively the "Data") in these files contain unpublished 
// information proprietary to Autodesk, Inc. ("Autodesk") and/or its 
// licensors,  which is protected by U.S. and Canadian federal copyright law 
// and by international treaties.
// 
// The Data may not be disclosed or distributed to third parties or be 
// copied or duplicated, in whole or in part, without the prior written 
// consent of Autodesk.
// 
// The copyright notices in the Software and this entire statement, 
// including the above license grant, this restriction and the following 
// disclaimer, must be included in all copies of the Software, in whole 
// or in part, and all derivative works of the Software, unless such copies 
// or derivative works are solely in the form of machine-executable object 
// code generated by a source language processor.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND. 
// AUTODESK DOES NOT MAKE AND HEREBY DISCLAIMS ANY EXPRESS OR IMPLIED 
// WARRANTIES INCLUDING, BUT NOT LIMITED TO, THE WARRANTIES OF 
// NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE, 
// OR ARISING FROM A COURSE OF DEALING, USAGE, OR TRADE PRACTICE. IN NO 
// EVENT WILL AUTODESK AND/OR ITS LICENSORS BE LIABLE FOR ANY LOST 
// REVENUES, DATA, OR PROFITS, OR SPECIAL, DIRECT, INDIRECT, OR 
// CONSEQUENTIAL DAMAGES, EVEN IF AUTODESK AND/OR ITS LICENSORS HAS 
// BEEN ADVISED OF THE POSSIBILITY OR PROBABILITY OF SUCH DAMAGES. 
// ==========================================================================
//+
//
// CLASS:    MFnNonExtendedLight
//
// *****************************************************************************
//
// CLASS DESCRIPTION (MFnNonExtendedLight)
//
// MFnNonExtendedLight facilitates manipulation of dependency graph nodes
// representing non-extended lights.  This includes point lights, directional
// lights, and spotlights.
//
// *****************************************************************************

#if defined __cplusplus

// *****************************************************************************

// INCLUDED HEADER FILES


#include <maya/MFnDagNode.h>
#include <maya/MObject.h>
#include <maya/MStatus.h>
#include <maya/MFnNonAmbientLight.h>

// *****************************************************************************

// DECLARATIONS

// *****************************************************************************

// CLASS DECLARATION (MFnNonExtendedLight)

/// Manage Non-extended Light dependency Nodes. (OpenMaya) (OpenMaya.py)
/**
  Facilitate the creation and manipulation of non-extended light nodes.
*/
#ifdef _WIN32
#pragma warning(disable: 4522)
#endif // _WIN32

class OPENMAYA_EXPORT MFnNonExtendedLight : public MFnNonAmbientLight 
{

	declareDagMFn(MFnNonExtendedLight,MFnNonAmbientLight);
public:
	///
	float         shadowRadius( MStatus * ReturnStatus = NULL ) const;
	///
	MStatus       setShadowRadius( const float& shadow_radius );
	///
	bool          castSoftShadows( MStatus * ReturnStatus = NULL ) const;
	///
	MStatus       setCastSoftShadows( const bool& cast_soft_shadows );
	///
	bool          useDepthMapShadows( MStatus * ReturnStatus = NULL ) const;
	///
	MStatus       setUseDepthMapShadows( const bool& use_depth_map );
	///
	short         depthMapFilterSize( MStatus * ReturnStatus ) const;
	///
	MStatus       setDepthMapFilterSize( const short& depth_map_filter_size );
	///
	short         depthMapResolution( MStatus * ReturnStatus ) const;
	///
	MStatus       setDepthMapResolution( const short& depth_map_resolution );
	///
	float         depthMapBias( MStatus * ReturnStatus ) const;
	///
	MStatus       setDepthMapBias( const float& depth_map_bias );

BEGIN_NO_SCRIPT_SUPPORT:

 	declareDagMFnConstConstructor( MFnNonExtendedLight,MFnNonAmbientLight );
	
END_NO_SCRIPT_SUPPORT:

protected:
// No protected members

private:
// No private members

};

#ifdef _WIN32
#pragma warning(default: 4522)
#endif // _WIN32

// *****************************************************************************
#endif /* __cplusplus */
#endif /* _MFnNonExtendedLight */



