#ifndef _MHWShaderSwatchGenerator
#define _MHWShaderSwatchGenerator

//
//-
// ==========================================================================
// Copyright (C) 1995 - 2006 Autodesk, Inc., and/or its licensors.  All 
// rights reserved.
// 
// The coded instructions, statements, computer programs, and/or related 
// material (collectively the "Data") in these files contain unpublished 
// information proprietary to Autodesk, Inc. ("Autodesk") and/or its 
// licensors,  which is protected by U.S. and Canadian federal copyright law 
// and by international treaties.
// 
// The Data may not be disclosed or distributed to third parties or be 
// copied or duplicated, in whole or in part, without the prior written 
// consent of Autodesk.
// 
// The copyright notices in the Software and this entire statement, 
// including the above license grant, this restriction and the following 
// disclaimer, must be included in all copies of the Software, in whole 
// or in part, and all derivative works of the Software, unless such copies 
// or derivative works are solely in the form of machine-executable object 
// code generated by a source language processor.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND. 
// AUTODESK DOES NOT MAKE AND HEREBY DISCLAIMS ANY EXPRESS OR IMPLIED 
// WARRANTIES INCLUDING, BUT NOT LIMITED TO, THE WARRANTIES OF 
// NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE, 
// OR ARISING FROM A COURSE OF DEALING, USAGE, OR TRADE PRACTICE. IN NO 
// EVENT WILL AUTODESK AND/OR ITS LICENSORS BE LIABLE FOR ANY LOST 
// REVENUES, DATA, OR PROFITS, OR SPECIAL, DIRECT, INDIRECT, OR 
// CONSEQUENTIAL DAMAGES, EVEN IF AUTODESK AND/OR ITS LICENSORS HAS 
// BEEN ADVISED OF THE POSSIBILITY OR PROBABILITY OF SUCH DAMAGES. 
// ==========================================================================
//+
//
// CLASS:    MHWShaderSwatchGenerator
//
// *****************************************************************************
//
// CLASS DESCRIPTION (MHWShaderSwatchGenerator)
//
// This MHWShaderSwatchGenerator is derived from MSwatchRenderBase
// which provides an interface for a plugin shader to provide a custom rendered
// image which can be used as a swatch which is displayed in hypershade and
// the Attribute Editor.
//
// *****************************************************************************

#if defined __cplusplus

#ifdef _WIN32
#pragma warning(disable: 4522)
#endif // _WIN32

// INCLUDED HEADER FILES


#include <maya/MSwatchRenderBase.h>
#include <maya/MSwatchRenderRegister.h>
#include <maya/MSwatchRenderBase.h>

// CLASS DECLARATION (MHWShaderSwatchGenerator)

/// Hardware shader swatch generator utility class (OpenMayaUI) (OpenMayaUI.py)
/**

Hardware shader swatch generator utility class

*/

class OPENMAYAUI_EXPORT MHWShaderSwatchGenerator : public MSwatchRenderBase
{
public:
	///
	MHWShaderSwatchGenerator( MObject obj, MObject renderObj, int res );

	///
	static MSwatchRenderBase* createObj(MObject obj, MObject renderObj, int res);

	///
	static const MString& initialize();

	///
	static void getSwatchBackgroundColor(float& r, float& g, float& b, float& a);

	///
	virtual bool doIteration();

protected:
// No protected members

private:
// No private members

};


#ifdef _WIN32
#pragma warning(default: 4522)
#endif // _WIN32

// *****************************************************************************

#endif /* __cplusplus */
#endif /* _MHWShaderSwatchGenerator */


