//-----------------------------------------------------------------------------
//                           PS2 Shell System Core
//
// Macros for your debugging pleasure
//
// $Workfile: shellAssert.h $
// $Author: Mdean $
// $Date: 11/02/03 14:00 $
// $Revision: 3 $
//
// Copyright (c) 2002-3 Sony Computer Entertainment Europe.
// All Rights Reserved.
//
//-----------------------------------------------------------------------------


#ifdef __cplusplus
extern "C" {
#endif

#undef WARNING
#undef PRINT
#undef ASSERT

#ifdef NDEBUG

#if __GNUC__ == 2 && __GNUC_MINOR__ <= 95
#define PRINT(A...) ((void)0)
#define WARNING(e,F...) ((void)0)
#define ASSERT(e,F...) ((void)0)
#else
#define PRINT(ignore) 
#define WARNING(ignore)
#define ASSERT(ignore)
#endif

#else

#if __GNUC__ == 2 && __GNUC_MINOR__ <= 95
#define PRINT(A...) do{scePrintf("%s(%d) : ",__FILE__,__LINE__); scePrintf(##A); scePrintf("\n");} while(0)
#define WARNING(e,F...) do{if(!(e)) {scePrintf("Warning in \"%s\" at line %d\n(%s) == FALSE\n", __FILE__, __LINE__, #e); scePrintf(##F);scePrintf("\n");}} while(0)
#define ASSERT(e,F...) do{if(!(e))   {scePrintf("Assert in \"%s\" at line %d\n(%s) == FALSE\n", __FILE__, __LINE__, #e); scePrintf(##F);scePrintf("\n"); while(1) {}} } while(0)
#else
#define PRINT(ignore) 
#define WARNING(ignore) 
#define ASSERT(ignore) 
#endif


#endif /* NDEBUG */

#ifdef __cplusplus
}
#endif
