/*
* SCE CONFIDENTIAL
* PSP(TM) Graphic Library Samples
* Copyright (C) 2004-2006 Sony Computer Entertainment Europe
* All Rights Reserved.
*
* sceePspGu - GeCommands.h
*   header file
*
*   Date            Design      Log
*  ----------------------------------------------------
*   2006-01-06      srubens     version 1.6.1
*   2005-12-12      srubens     version 1.6.0
*   2005-10-31      srubens     version 1.5.0
*   2005-09-27      srubens     version 1.4.1
*   2005-09-23      srubens     version 1.4.0
*   2005-08-23      srubens     version 1.3.0
*   2005-08-12      srubens     version 1.2.1b
*   2005-07-29      srubens     version 1.2.0
*   2005-07-21      srubens     version 1.1.1
*   2005-07-20      srubens     version 1.1.0
*   2005-04-05      srubens     version 1.0.0
*   2004-04-23      srubens     initial implementation
*/

// ------------------------------------------------------------------------------
// SCE CONFIDENTIAL
// PSP(TM) Graphic Library Samples
// Copyright (C) 2004-2006 Sony Computer Entertainment Europe.
// All Rights Reserved.
// ------------------------------------------------------------------------------
// FILE:			$File: GeCommands.h $
// FIRST VERSION:	23/04/2004
// FIRST AUTHOR:	Sebastien Rubens
// LAST AUTHOR:		$Author: srubens  $
// VERSION:			$DateTime:  $
// REVISION:		$Revision:  $
// CHANGE:			$Change:  $
//
// DESCRIPTION:
//	This library is a libgu like library with a few changes (works on devkit and emulator).
//	This library also exist for PC, to create offline packets.
//	There is also a display parser/debugger as another library.
// ------------------------------------------------------------------------------


#ifndef	SCEEPSPGU_CMD_H
#define	SCEEPSPGU_CMD_H
namespace scee {
namespace Psp {
namespace Gu {
// ------------------------------------------------------------------------------
// ENUMS
// ------------------------------------------------------------------------------
typedef enum
{
	CMD_NOP			=	0x00000000,
	CMD_VADR		=	0x00000001,
	CMD_IADR		=	0x00000002,
					//	0x00000003,
	CMD_PRIM		=	0x00000004,
	CMD_BEZIER		=	0x00000005,
	CMD_SPLINE		=	0x00000006,
	CMD_BBOX		=	0x00000007,
	CMD_JUMP		=	0x00000008,
	CMD_BJUMP		=	0x00000009,
	CMD_CALL		=	0x0000000A,
	CMD_RET			=	0x0000000B,
	CMD_END			=	0x0000000C,
					//	0x0000000D,
	CMD_SIGNAL		=	0x0000000E,
	CMD_FINISH		=	0x0000000F,
	CMD_BASE		=	0x00000010,
					//	0x00000011,
	CMD_VTYPE		=	0x00000012,
	CMD_OFFSET		=	0x00000013,
	CMD_ORIGIN		=	0x00000014,
	CMD_REGION1		=	0x00000015,
	CMD_REGION2		=	0x00000016,
	CMD_LTE			=	0x00000017,
	CMD_LE0			=	0x00000018,
	CMD_LE1			=	0x00000019,
	CMD_LE2			=	0x0000001A,
	CMD_LE3			=	0x0000001B,
	CMD_CLE			=	0x0000001C,
	CMD_BCE			=	0x0000001D,
	CMD_TME			=	0x0000001E,
	CMD_FGE			=	0x0000001F,
	CMD_DTE			=	0x00000020,
	CMD_ABE			=	0x00000021,
	CMD_ATE			=	0x00000022,
	CMD_ZTE			=	0x00000023,
	CMD_STE			=	0x00000024,
	CMD_AAE			=	0x00000025,
	CMD_PCE			=	0x00000026,
	CMD_CTE			=	0x00000027,
	CMD_LOE			=	0x00000028,
					//	0x00000029,
	CMD_BONEN		=	0x0000002A,
	CMD_BONED		=	0x0000002B,
	CMD_WEIGHT0		=	0x0000002C,
	CMD_WEIGHT1		=	0x0000002D,
	CMD_WEIGHT2		=	0x0000002E,
	CMD_WEIGHT3		=	0x0000002F,
	CMD_WEIGHT4		=	0x00000030,
	CMD_WEIGHT5		=	0x00000031,
	CMD_WEIGHT6		=	0x00000032,
	CMD_WEIGHT7		=	0x00000033,
					//	0x00000034,
					//	0x00000035,
	CMD_DIVIDE		=	0x00000036,
	CMD_PPM			=	0x00000037,
	CMD_PFACE		=	0x00000038,
					//	0x00000039,
	CMD_WORLDN		=	0x0000003A,
	CMD_WORLDD		=	0x0000003B,
	CMD_VIEWN		=	0x0000003C,
	CMD_VIEWD		=	0x0000003D,
	CMD_PROJN		=	0x0000003E,
	CMD_PROJD		=	0x0000003F,
	CMD_TGENN		=	0x00000040,
	CMD_TGEND		=	0x00000041,
	CMD_SX			=	0x00000042,
	CMD_SY			=	0x00000043,
	CMD_SZ			=	0x00000044,
	CMD_TX			=	0x00000045,
	CMD_TY			=	0x00000046,
	CMD_TZ			=	0x00000047,
	CMD_SU			=	0x00000048,
	CMD_SV			=	0x00000049,
	CMD_TU			=	0x0000004A,
	CMD_TV			=	0x0000004B,
	CMD_OFFSETX		=	0x0000004C,
	CMD_OFFSETY		=	0x0000004D,
					//	0x0000004E,
					//	0x0000004F,
	CMD_SHADE		=	0x00000050,
	CMD_NREV		=	0x00000051,
					//	0x00000052,
	CMD_MATERIAL	=	0x00000053,
	CMD_MEC			=	0x00000054,
	CMD_MAC			=	0x00000055,
	CMD_MDC			=	0x00000056,
	CMD_MSC			=	0x00000057,
	CMD_MAA			=	0x00000058,
					//	0x00000059,
					//	0x0000005A,
	CMD_MK			=	0x0000005B,
	CMD_AC			=	0x0000005C,
	CMD_AA			=	0x0000005D,
	CMD_LMODE		=	0x0000005E,
	CMD_LTYPE0		=	0x0000005F,
	CMD_LTYPE1		=	0x00000060,
	CMD_LTYPE2		=	0x00000061,
	CMD_LTYPE3		=	0x00000062,
	CMD_LX0			=	0x00000063,
	CMD_LY0			=	0x00000064,
	CMD_LZ0			=	0x00000065,
	CMD_LX1			=	0x00000066,
	CMD_LY1			=	0x00000067,
	CMD_LZ1			=	0x00000068,
	CMD_LX2			=	0x00000069,
	CMD_LY2			=	0x0000006A,
	CMD_LZ2			=	0x0000006B,
	CMD_LX3			=	0x0000006C,
	CMD_LY3			=	0x0000006D,
	CMD_LZ3			=	0x0000006E,
	CMD_LDX0		=	0x0000006F,
	CMD_LDY0		=	0x00000070,
	CMD_LDZ0		=	0x00000071,
	CMD_LDX1		=	0x00000072,
	CMD_LDY1		=	0x00000073,
	CMD_LDZ1		=	0x00000074,
	CMD_LDX2		=	0x00000075,
	CMD_LDY2		=	0x00000076,
	CMD_LDZ2		=	0x00000077,
	CMD_LDX3		=	0x00000078,
	CMD_LDY3		=	0x00000079,
	CMD_LDZ3		=	0x0000007A,
	CMD_LKA0		=	0x0000007B,
	CMD_LKB0		=	0x0000007C,
	CMD_LKC0		=	0x0000007D,
	CMD_LKA1		=	0x0000007E,
	CMD_LKB1		=	0x0000007F,
	CMD_LKC1		=	0x00000080,
	CMD_LKA2		=	0x00000081,
	CMD_LKB2		=	0x00000082,
	CMD_LKC2		=	0x00000083,
	CMD_LKA3		=	0x00000084,
	CMD_LKB3		=	0x00000085,
	CMD_LKC3		=	0x00000086,
	CMD_LKS0		=	0x00000087,
	CMD_LKS1		=	0x00000088,
	CMD_LKS2		=	0x00000089,
	CMD_LKS3		=	0x0000008A,
	CMD_LKO0		=	0x0000008B,
	CMD_LKO1		=	0x0000008C,
	CMD_LKO2		=	0x0000008D,
	CMD_LKO3		=	0x0000008E,
	CMD_LAC0		=	0x0000008F,
	CMD_LDC0		=	0x00000090,
	CMD_LSC0		=	0x00000091,
	CMD_LAC1		=	0x00000092,
	CMD_LDC1		=	0x00000093,
	CMD_LSC1		=	0x00000094,
	CMD_LAC2		=	0x00000095,
	CMD_LDC2		=	0x00000096,
	CMD_LSC2		=	0x00000097,
	CMD_LAC3		=	0x00000098,
	CMD_LDC3		=	0x00000099,
	CMD_LSC3		=	0x0000009A,
	CMD_CULL		=	0x0000009B,
	CMD_FBP			=	0x0000009C,
	CMD_FBW			=	0x0000009D,
	CMD_ZBP			=	0x0000009E,
	CMD_ZBW			=	0x0000009F,
	CMD_TBP0		=	0x000000A0,
	CMD_TBP1		=	0x000000A1,
	CMD_TBP2		=	0x000000A2,
	CMD_TBP3		=	0x000000A3,
	CMD_TBP4		=	0x000000A4,
	CMD_TBP5		=	0x000000A5,
	CMD_TBP6		=	0x000000A6,
	CMD_TBP7		=	0x000000A7,
	CMD_TBW0		=	0x000000A8,
	CMD_TBW1		=	0x000000A9,
	CMD_TBW2		=	0x000000AA,
	CMD_TBW3		=	0x000000AB,
	CMD_TBW4		=	0x000000AC,
	CMD_TBW5		=	0x000000AD,
	CMD_TBW6		=	0x000000AE,
	CMD_TBW7		=	0x000000AF,
	CMD_CBP			=	0x000000B0,
	CMD_CBW			=	0x000000B1,
	CMD_XBP1		=	0x000000B2,
	CMD_XBW1		=	0x000000B3,
	CMD_XBP2		=	0x000000B4,
	CMD_XBW2		=	0x000000B5,
					//	0x000000B6,
					//	0x000000B7,
	CMD_TSIZE0		=	0x000000B8,
	CMD_TSIZE1		=	0x000000B9,
	CMD_TSIZE2		=	0x000000BA,
	CMD_TSIZE3		=	0x000000BB,
	CMD_TSIZE4		=	0x000000BC,
	CMD_TSIZE5		=	0x000000BD,
	CMD_TSIZE6		=	0x000000BE,
	CMD_TSIZE7		=	0x000000BF,
	CMD_TMAP		=	0x000000C0,
	CMD_TSHADE		=	0x000000C1,
	CMD_TMODE		=	0x000000C2,
	CMD_TPF			=	0x000000C3,
	CMD_CLOAD		=	0x000000C4,
	CMD_CLUT		=	0x000000C5,
	CMD_TFILTER		=	0x000000C6,
	CMD_TWRAP		=	0x000000C7,
	CMD_TLEVEL		=	0x000000C8,
	CMD_TFUNC		=	0x000000C9,
	CMD_TEC			=	0x000000CA,
	CMD_TFLUSH		=	0x000000CB,
	CMD_TSYNC		=	0x000000CC,
	CMD_FOG1		=	0x000000CD,
	CMD_FOG2		=	0x000000CE,
	CMD_FC			=	0x000000CF,
	CMD_TSLOPE		=	0x000000D0,
					//	0x000000D1,
	CMD_FPF			=	0x000000D2,
	CMD_CMODE		=	0x000000D3,
	CMD_SCISSOR1	=	0x000000D4,
	CMD_SCISSOR2	=	0x000000D5,
	CMD_MINZ		=	0x000000D6,
	CMD_MAXZ		=	0x000000D7,
	CMD_CTEST		=	0x000000D8,
	CMD_CREF		=	0x000000D9,
	CMD_CMSK		=	0x000000DA,
	CMD_ATEST		=	0x000000DB,
	CMD_STEST		=	0x000000DC,
	CMD_SOP			=	0x000000DD,
	CMD_ZTEST		=	0x000000DE,
	CMD_BLEND		=	0x000000DF,
	CMD_FIXA		=	0x000000E0,
	CMD_FIXB		=	0x000000E1,
	CMD_DITH1		=	0x000000E2,
	CMD_DITH2		=	0x000000E3,
	CMD_DITH3		=	0x000000E4,
	CMD_DITH4		=	0x000000E5,
	CMD_LOP			=	0x000000E6,
	CMD_ZMSK		=	0x000000E7,
	CMD_PMSK1		=	0x000000E8,
	CMD_PMSK2		=	0x000000E9,
	CMD_XSTART		=	0x000000EA,
	CMD_XPOS1		=	0x000000EB,
	CMD_XPOS2		=	0x000000EC,
					//	0x000000ED,
	CMD_XSIZE		=	0x000000EE
}	ECommand;


// ------------------------------------------------------------------------------
#define si_GetCmdU32(cmd)	(static_cast<u32>(cmd) << 24)


// ------------------------------------------------------------------------------
}	// namespace Gu
}	// namespace Psp
}	// namespace scee
#endif	// SCEEPSPGU_CMD_H
