/*
* SCE CONFIDENTIAL
* PSP(TM) Graphic Library Samples
* Copyright (C) 2004-2006 Sony Computer Entertainment Europe
* All Rights Reserved.
*
* sceeTypes - sceeTypes.h
*   PSP generic types
*
*   Date            Design      Log
*  ----------------------------------------------------
*   2006-01-06      srubens     version 1.6.1
*   2005-12-12      srubens     version 1.6.0
*   2005-10-31      srubens     version 1.5.0
*   2005-09-27      srubens     version 1.4.1
*   2005-09-23      srubens     version 1.4.0
*   2005-08-23      srubens     version 1.3.0
*   2005-08-12      srubens     version 1.2.1b
*   2005-07-29      srubens     version 1.2.0
*   2005-07-21      srubens     version 1.1.1
*   2005-07-20      srubens     version 1.1.0
*   2005-04-05      srubens     version 1.0.0
*   2004-04-23      srubens     initial implementation
*/

// ------------------------------------------------------------------------------
// SCE CONFIDENTIAL
// PSP(TM) Graphic Library Samples
// Copyright (C) 2004-2006 Sony Computer Entertainment Europe.
// All Rights Reserved.
// ------------------------------------------------------------------------------
// FILE:			$File: sceeTypes.h $
// FIRST VERSION:	23/04/2004
// FIRST AUTHOR:	Sebastien Rubens
// LAST AUTHOR:		$Author: srubens  $
// VERSION:			$DateTime:  $
// REVISION:		$Revision:  $
// CHANGE:			$Change:  $
//
// DESCRIPTION:
//	Generic types used in the library.
// ------------------------------------------------------------------------------


#ifndef	SCEETYPES_H
#define	SCEETYPES_H
// ------------------------------------------------------------------------------
// TYPEDEF
// ------------------------------------------------------------------------------
// Notes:
//	Don't use #else or #elif because it creates a compiler error if multiples
//	and incompatibles compiler options are used

#if		!(defined(_MSC_VER) || defined(__GNUC__) || defined(__SNC__) || defined(__MWERKS__))
	#error The compiler is not recognized
#endif	// !(defined(_MSC_VER) || defined(__GNUC__) || defined(__SNC__) || defined(__MWERKS__))

#if		defined(_MSC_VER)
	#define __attribute__(x)
#endif	// defined(_MSC_VER)

#if		defined(_MSC_VER)
	typedef unsigned char		u8;
	typedef signed char			s8;
	typedef unsigned short		u16;
	typedef signed short		s16;
	typedef unsigned int		u32;
	typedef signed int			s32;
	typedef float				f32;
#endif	// defined(_MSC_VER)

#if		((defined(_PSP) || defined(SN_TARGET_PSP_HW)) && (defined(__GNUC__) || defined(__SNC__) || defined(__MWERKS__)))
	typedef unsigned char		u8;
	typedef signed char			s8;
	typedef unsigned short		u16;
	typedef signed short		s16;
	typedef unsigned int		u32;
	typedef signed int			s32;
	typedef float				f32;
#endif	// (defined(_PSP) && (defined(__GNUC__) || defined(__SNC__) || defined(__MWERKS__)))


// ------------------------------------------------------------------------------
#endif	// SCEETYPES_H
