/*
[SCE CONFIDENTIAL]
$PSDocId$
                  Copyright (C) 2002-4 Sony Computer Entertainment America
                                                     All Rights Reserved
//  ------------------------------------------------------------------------

File: eznetctl_i18n.h

auxiliary i18n data types and interfaces for those linking with
eznetcnf/sample/i18n_eu.c.

//  ------------------------------------------------------------------------
*/

#ifndef _EZNETCTL_I18N_H
#define _EZNETCTL_I18N_H


#include <libeenet.h>
#include <eenetctl.h>
#include <eenetctlerrno.h>
#include <eenetctlstat.h>
#include <sys/socket.h>
#include <net/if.h>


#ifdef  __cplusplus
extern "C" {
#endif

/*  --------------------------------------------------------
 *  --------------------------------------------------------
 */

typedef union {
    sceEENetCtlStatDhcp_t   dhcp;
    sceEENetCtlStatPpp_t    ppp;
    sceEENetCtlStatPppoe_t  pppoe;
} ezNetCtlIfstat_u;

typedef void (*cbFormat_f) ( char *, size_t, const char *,
                             ezNetCtlStatus_t *, ezNetCtlIfstat_u * );

typedef struct {
    int lo;
    int hi;
    const char *msg;
    cbFormat_f  callback;
} ezMsgFormat_t;

        // non-RPC localization functions
void    ezNetCtlSwapMessageTables(ezMsgFormat_t *, ezMsgFormat_t *, ezMsgFormat_t *);
void    ezNetCtlSetLanguage(unsigned int);
void    ezNetCtlSetScfLanguage(void);

        // internal functions
void    ezNetCtlLocalizeMessage(char *, size_t, ezNetCtlStatus_t *, ezNetCtlIfstat_u *);
void    ezNetCtlRecreateIfstat(const char *, ezNetCtlStatus_t *, ezNetCtlIfstat_u *);

        // internal formatter callbacks
void    cbFormatAuthMessage(char *, size_t, const char *, 
                            ezNetCtlStatus_t *, ezNetCtlIfstat_u *);
void    cbFormatPPPStatus  (char *, size_t, const char *, 
                            ezNetCtlStatus_t *, ezNetCtlIfstat_u *);
void    cbFormatLineSpeed  (char *, size_t, const char *, 
                            ezNetCtlStatus_t *, ezNetCtlIfstat_u *);
void    cbFormatPhoneNumber(char *, size_t, const char *, 
                            ezNetCtlStatus_t *, ezNetCtlIfstat_u *);


#ifdef  __cplusplus
}
#endif


#endif	// _EZNETCTL_I18N_H
