//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_AVP3Alien_StalkThreat.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_AVP3ALIEN_STALKTHREAT_H__
#define __AVP_BEHAVIOUR_AVP3ALIEN_STALKTHREAT_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Axon_Project_Brain;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_AVP3Alien_StalkThreat
//
// Slowly move to an intermediate range from the threat and maintain it?
// Move around in the player's peripheral vision and dodge/disappear when shot at?
// Going for the first one currently. Second one could perhaps be a SpookThreat behaviour?
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_AVP3Alien_StalkThreat : public Axon_Project_Behaviour
{
    typedef Axon_Project_Behaviour PARENT;

public:
    AVP_Behaviour_AVP3Alien_StalkThreat( Axon_Project_Brain* pxBrain );

    virtual bool Activate();
    virtual void Deactivate();
    virtual void Update( const float fTimeslice );
    virtual void PerFrameUpdate( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
    virtual void RenderDebugInfo();
#endif

private:
    enum State
    {
        STATE_IDLE,
		STATE_WANDER,
        STATE_TRACK_THREAT,
		STATE_FREEZE,
		STATE_SCARE_THREAT,
		STATE_CHARGE,
		STATE_GRAPPLE,	// TEMP - TODO: remove after demo
		STATE_CIRCLE,

		NUM_STATES
	};

	void SwitchToState( const State eNextState );
	bool CheckGrappleAngles( const AVP_ServerEntity_Actor* const pxTargetActor );
	bool DoGrapple( Asura_Guid uTargetGuid );
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_AVP3ALIEN_STALKTHREAT_H__
