//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_GS2Node_AnimMessages.cpp
//
// Copyright (C) 2009 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// core
#include "Core/Asura.h"

// header
#include "Behaviour/BehaviourTypes/AVP_Behaviour_GS2Node_AnimMessages.h"

// asura
#include "ChunkSystem/Asura_Chunk_Stream.h"

// axon

// avp
#include "Behaviour/AVP_BehaviourParams.h"
#include "Behaviour/BehaviourTypes/AVP_Behaviour_Types.h"
#include "Core/BrainTypes/AVP_Brain_Actor.h"

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_GS2Node_AnimMessages
//
//////////////////////////////////////////////////////////////////////////////

AVP_Behaviour_GS2Node_AnimMessages::AVP_Behaviour_GS2Node_AnimMessages( AVP_Brain_Actor* pxBrain )
: PARENT( AVP_BEHAVIOUR_TYPE_GS2_NODE_ANIMMESSAGES, pxBrain )
{
}

void AVP_Behaviour_GS2Node_AnimMessages::ReadFromChunkStream( Asura_Chunk_Stream& xStream )
{
	u_int uVersion;
	xStream >> uVersion;

	PARENT::ReadFromChunkStream( xStream );

	if ( uVersion == uCURRENT_CHUNK_VERSION )
	{
	}
	else
	{
		Asura_Assertf( false, ( "AVP_Behaviour_GS2Node_AnimMessages::ReadFromChunkStream - unhandled chunk version (%u)", uVersion ) );
	}
}

void AVP_Behaviour_GS2Node_AnimMessages::WriteToChunkStream( Asura_Chunk_Stream& xStream ) const
{
	xStream << uCURRENT_CHUNK_VERSION;

	PARENT::WriteToChunkStream( xStream );
}

//////////////////////////////////////////////////////////////////////////////
//
// AVP_BehaviourParams_GS2Node_AnimMessages
//
//////////////////////////////////////////////////////////////////////////////

AVP_BehaviourParams_GS2Node_AnimMessages::AVP_BehaviourParams_GS2Node_AnimMessages( const u_int uBehaviourType )
: PARENT( AVP_BP_TYPE_GS2_NODE_ANIMMESSAGES, uBehaviourType )
{
}

void AVP_BehaviourParams_GS2Node_AnimMessages::ReadFromChunkStream( Asura_Chunk_Stream& xStream )
{
	u_int uVersion;
	xStream >> uVersion;

	PARENT::ReadFromChunkStream( xStream );

	if ( uVersion == uCURRENT_CHUNK_VERSION )
	{
	}
	else
	{
		Asura_Assertf( false, ( "AVP_BehaviourParams_GS2Node_AnimMessages::ReadFromChunkStream - unhandled chunk version (%u)", uVersion ) );
	}
}

void AVP_BehaviourParams_GS2Node_AnimMessages::WriteToChunkStream( Asura_Chunk_Stream& xStream ) const
{
	xStream << uCURRENT_CHUNK_VERSION;

	PARENT::WriteToChunkStream( xStream );
}

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////
