//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_GS2Node_RouteTraverse.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_GS2NODE_ROUTETRAVERSE_H__
#define __AVP_BEHAVIOUR_GS2NODE_ROUTETRAVERSE_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// axon
#include "Behaviour/BehaviourTypes/Axon_Behaviour_GS2Interface.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_GS2Node_RouteTraverse
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_GS2Node_RouteTraverse : public Axon_Behaviour_GS2Interface
{
	typedef Axon_Behaviour_GS2Interface PARENT;

public:
	AVP_Behaviour_GS2Node_RouteTraverse( AVP_Brain_Actor* pxBrain );

	virtual bool       ShouldExitGamescene()		{ return ( GetNextGamesceneEntityGuid() == ASURA_GUID_UNREGISTERED ); }
	virtual bool	   HasNextGuidControl()			{ return true; }
	virtual Asura_Guid GetNextGamesceneEntityGuid() { return m_uLinkToTake; }
	virtual float      GetRemainingTimeslice()		{ return m_fRemainingTimeslice; }

protected:
	virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );
	virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;
	virtual bool Activate();
	virtual void PerFrameUpdate( const float fTimeslice );

	Asura_Guid ChooseLinkToTake();

	AVP_Brain_Actor* GetActorBrain() const;

private:
	Asura_Guid m_uLinkToTake;
	float	   m_fRemainingTimeslice;

	static const u_int uCURRENT_CHUNK_VERSION = 0;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_GS2NODE_ROUTETRAVERSE_H__
