//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_LightTest.cpp
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// core
#include "Core/Asura.h"

// header
#include "Behaviour/BehaviourTypes/Alien/AVP_Behaviour_Alien_LightTest.h"

// asura
#ifndef ASURA_NO_DEBUG_OUTPUT
#include "Rendering/Asura_Font_System.h"
#endif

// axon
#include "Behaviour/BehaviourTypes/AVP_Behaviour_Types.h"
#include "Behaviour/BehaviourTypes/Alien/AVP_Behaviour_Alien_AvoidLight.h"
#include "Core/BrainTypes/AVP_Brain_Actor_Alien.h"

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_LightTest
//
//////////////////////////////////////////////////////////////////////////////

AVP_Behaviour_Alien_LightTest::AVP_Behaviour_Alien_LightTest( AVP_Brain_Actor_Alien* pxBrain )
: PARENT( pxBrain, AVP_BEHAVIOUR_TYPE_ALIEN_LIGHTTEST )
{
}

void AVP_Behaviour_Alien_LightTest::CreateChildBehaviours()
{
	// Avoid light.
	AVP_BehaviourTree_Element* pxBTE = static_cast< AVP_BehaviourTree_Element* >( GetProjectBrain()->CreateBehaviour( AVP_BEHAVIOUR_TYPE_ALIEN_AVOIDLIGHTTEST ) );
	if ( pxBTE )
	{
		LinkChild( pxBTE );
		pxBTE->SetPriority( 10 );
		pxBTE->SetProbability( 1.0f );
	}
}

#ifndef ASURA_NO_DEBUG_OUTPUT
void AVP_Behaviour_Alien_LightTest::RenderDebugInfo()
{
	PARENT::RenderDebugInfo();

	Asura_Font_System::Print( GetProjectBrain()->GetDebugOutputPos().x, GetProjectBrain()->GetDebugOutputPos().y, 0.5f, 0xffffffff,
		ASURA_TEXTFORMAT_CENTREJUSTIFIED, "Alien Light Test" );
	GetProjectBrain()->GetDebugOutputPos().y += 10.0f;
}
#endif

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////
