//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_MoveBetweenCover.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_ALIEN_MOVEBETWEENCOVER_H__
#define __AVP_BEHAVIOUR_ALIEN_MOVEBETWEENCOVER_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Chunk_Stream;
class AVP_Brain_Actor_Alien;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_MoveBetweenCover
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_Alien_MoveBetweenCover : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_Alien_MoveBetweenCover( Axon_Project_Brain* pxBrain );

protected:
	virtual void Deactivate();
	virtual void PerFrameUpdate( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:
	enum State
	{
		UNSET,
		MOVING_TO_NEAREST_COVER,
		MOVING_TO_COVER,
		IN_COVER,
		MOVING_AWAY_FROM_THREAT,
		WANDERING_LOCALLY,
		WAITING,
		NUM_STATES
	};

	void SwitchToState( const int iNewState );
	AVP_Brain_Actor_Alien* GetAlienBrain() const;

	u_short FindNearestCoverWPID() const;
	u_short FindRandomCoverWPID() const;

private:
	float m_fCoverRefreshTimer;
	Asura_Vector_3 m_xWanderBasePosition;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_ALIEN_MOVEBETWEENCOVER_H__
