//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_Root.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_ALIEN_ROOT_H__
#define __AVP_BEHAVIOUR_ALIEN_ROOT_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Chunk_Stream;
class AVP_Brain_Actor_Alien;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_Root
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_Alien_Root : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_Alien_Root( Axon_Project_Brain* pxBrain );

protected:
	virtual void Deactivate();
	virtual void PerFrameUpdate( const float fTimeslice );
	virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );
	virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:
	enum State
	{
		UNSET,
		STANDARD,
		SWARM,
		DISAPPEAR,
		HIDE,
		INJURED,
		DESTROY,
		AGGRESIVE,
		HIDE_IN_SHADOWS,
		AMBUSH,
		NUM_STATES
	};

	void SwitchToCorrectBehaviourState( const int iBehaviour );
	void SwitchToState( const int iNewState );
	AVP_Brain_Actor_Alien* GetAlienBrain() const;

private:
	static const u_int uCURRENT_CHUNK_VERSION = 0;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_ALIEN_ROOT_H__
