//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_Stalk.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_ALIEN_STALK_H__
#define __AVP_BEHAVIOUR_ALIEN_STALK_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

struct AVP_AlienTeam_Knowledge;
class AVP_Brain_Actor_Alien;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_Stalk
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_Alien_Stalk : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_Alien_Stalk( Axon_Project_Brain* pxBrain );

	bool CanFinish() const;

protected:
	virtual bool Activate();
	virtual void Deactivate();
	virtual void PerFrameUpdate( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

	AVP_Brain_Actor_Alien* GetAlienBrain() const;

private:
	enum State
	{
		UNSET,
		MOVING_IN,
		WAITING,
		BACKING_OFF,
		MOVING_AWAY,
		AVOIDING_LIGHT,
		MOVING_ABOUT,
		FINISHED
	};

	void SwitchToState( int iState );
	// Determine if we are in the open or in cover, etc, and update our movement mode accordingly.
	void UpdateMovementMode();

private:
	float m_fIdealDistance;
	// We keep this locally because we avoid for a minimum amount of time, during which we may no longer be in range of the lights.
	float m_fLightAvoidTimer;
	Asura_Vector_3 m_xLightCentroid;
	float m_fBurstTimer;

#ifndef ASURA_NO_DEBUG_OUTPUT
	static const char* s_aszStateStrings[];
#endif
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_ALIEN_STALK_H__
