//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_Swarm.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_ALIEN_SWARM_H__
#define __AVP_BEHAVIOUR_ALIEN_SWARM_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// asura
#include "Network/Asura_Guid.h"

// axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_Alien;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_Swarm
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_Alien_Swarm : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_Alien_Swarm( Axon_Project_Brain* pxBrain );

protected:
	virtual void Deactivate();
	virtual void PerFrameUpdate( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:
	enum State
	{
		UNSET,
		SWARMING_IN,
		ATTACKING,
		CYCLING_ROUND,
		NUM_STATES
	};

	void SwitchToState( const int iNewState, Asura_Guid uGuid = ASURA_GUID_UNREGISTERED );
	AVP_Brain_Actor_Alien* GetAlienBrain() const;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_ALIEN_SWARM_H__
