//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_SwarmIn.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_ALIEN_SWARMIN_H__
#define __AVP_BEHAVIOUR_ALIEN_SWARMIN_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Message;
class AVP_Brain_Actor_Alien;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_SwarmIn
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_Alien_SwarmIn : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_Alien_SwarmIn( Axon_Project_Brain* pxBrain );

protected:
	virtual void Deactivate();
	virtual void PerFrameUpdate( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:
	enum State
	{
		UNSET,
		SWARMING_IN,
		NUM_STATES
	};

	void EstablishLeadership();
	void SwitchToState( const int iNewState );
	AVP_Brain_Actor_Alien* GetAlienBrain() const;

private:
	// If we are a leader the leader guid will be us.
	// If we are not a leader the leader guid will be either our leader or unregistered, in which case we are a loner.
	bool m_bIsLeader;
	Asura_Guid m_uLeaderGuid;

	float m_fPrevSwarmRouteAge;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_ALIEN_SWARMIN_H__
