///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Behaviour_AlienQueen.h
// Author : David Wooldridge
// Date   : 11/11/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////


// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_ALIENQUEEN_H__
#define __AVP_BEHAVIOUR_ALIENQUEEN_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Behaviour/Axon_Project_Behaviour.h"

// asura
#include "Core/Asura_LinkList.h"


// axon
#include "Core/AxonAVP_Messages.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_AlienQueen;


class AVP_Behaviour_AlienQueen : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_AlienQueen( AVP_Brain_Actor_AlienQueen* pxBrain );
	~AVP_Behaviour_AlienQueen();

protected:
	virtual void Deactivate();
	virtual void PerFrameUpdate( const float fTimeslice );
	virtual void Update( const float fTimeslice );
	virtual bool HandleMessage( const Asura_Message* pxMessage );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

	AVP_Brain_Actor_AlienQueen* GetAlienQueenBrain() const;

private:
	enum State
	{
		IDLE,				// Do nothing, 
		WANDER,				// Wander around the maze
		STALK,				// Stalk the player (just follow him for a while)
		ATTACKING,			// Attack the player
		STUNNED,			// Stay at position for certain time and play stunned anim. 
		ROARING,			// Roar on spot or at current target. 
	};

	void SwitchToState( const State eNextState );
	void SwitchToStateFromBehaviourData();

	State m_eCurrentState;
	float m_fTimeInState;
	float m_fTimeSinceLastFindTarget;
	float m_fInsertTimer;
	float m_fFarFromSpawnDistanceSquared;
};


#endif


