///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Behaviour_AlienQueen_Attack.h
// Author : Andy McCabe
// Date   : 24/11/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_ALIENQUEEN_ATTACK_H__
#define __AVP_BEHAVIOUR_ALIENQUEEN_ATTACK_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_AlienQueen;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_AlienQueen_Attack
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_AlienQueen_Attack : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_AlienQueen_Attack( AVP_Brain_Actor_AlienQueen* pxBrain );

protected:
	virtual bool Activate();
	virtual void Deactivate();
	virtual void PerFrameUpdate( const float fTimeslice );
	virtual bool HandleMessage( const Asura_Message* pxMessage );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:
	enum State
	{
		UNSET,
		REQUESTED_PRIMARY_ATTACK,
		STARTED_PRIMARY_ATTACK,
		REQUESTED_SLASH_ATTACK,
		STARTED_SLASH_ATTACK,
		STARTED_LOOP_SLASH_ATTACK,
		REQUESTED_CLAWSWIPEKILL_ATTACK,
		STARTED_CLAWSWIPEKILL_ATTACK,
		REQUESTED_SPIT_ACID_ATTACK,
		STARTED_SPIT_ACID_ATTACK,
		FINISHED,

		NUM_STATES
	};
	void SwitchToState( const State eNextState );

	AVP_Brain_Actor_AlienQueen* GetAlienQueenBrain() const;

	void RequestMelee( const u_int uMeleeType );
	void RequestSpitAcidMove();
	void SetupSlashAttack( bool bSetNumberOfAttacks );
	float GetTargetsHealthPercentage() const;
	void UpdateLookAndAimDirections();

	u_int m_uMeleeType;
	Asura_Hash_ID m_uInitialMeleeMoveHash;
	enum MeleeHandedness
	{
		NONE,
		LEFT,
		RIGHT
	} m_eMeleeHandedness;
	u_int m_uNumRemainingAttacks;
	u_int m_uNumRemainingCyclesRound;

#ifndef ASURA_NO_DEBUG_OUTPUT
	static const char* s_aszStateStrings[ NUM_STATES ];
#endif

};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_ALIENQUEEN_ATTACK_H__
