//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_AlienQueen_GS2Move.h
// Callum Hope
// Copyright (C) 2009 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// F I L E   W R A P P E R ///////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_Behaviour_AlienQueen_GS2Move_H__
#define __AVP_Behaviour_AlienQueen_GS2Move_H__ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

// asura
#include "Network/Asura_Guid.h"

// avp axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_AlienQueen;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_AlienQueen_GS2Move
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_AlienQueen_GS2Move : public Axon_Project_Behaviour
{
	public:
		AVP_Behaviour_AlienQueen_GS2Move( AVP_Brain_Actor_AlienQueen* pxBrain );
		bool GetToPosition( const Asura_Vector_3& xDestination, Asura_Guid uGS2NodeGuid = ASURA_GUID_UNREGISTERED );

	protected:
		virtual bool Activate();
		virtual void Deactivate();
		virtual void Update( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
		virtual void RenderDebugInfo();
#endif

		AVP_Brain_Actor_AlienQueen* GetAlienQueenBrain() const;

	private:
		enum State
		{
			UNSET,
			MOVE_TO_POSITION,
			FINISHED,

			NUM_STATES
		};

		void CalculateMove();
		void SwitchToState( const State eNextState );
	private:
		State m_eCurrentState;
		float m_fTimeInState;
		float m_fArrivalRange;
		Asura_Vector_3 m_xDestination;
		bool m_bDestinationSet;
		Asura_Guid m_uGS2NodeGuid;

		typedef Axon_Project_Behaviour PARENT;
};

//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_Behaviour_AlienQueen_GS2Move_H__
