///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Behaviour_AlienQueen_Stunned.h
// Author : Callum Hope
// Date   : 31/3/09
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_ALIENQUEEN_STUNNED_H__
#define __AVP_BEHAVIOUR_ALIENQUEEN_STUNNED_H__ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

// axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_AlienQueen;

// C L A S S /////////////////////////////////////////////////////////////////

class AVP_Behaviour_AlienQueen_Stunned : public Axon_Project_Behaviour
{
public:

	AVP_Behaviour_AlienQueen_Stunned( AVP_Brain_Actor_AlienQueen* pxBrain );
	virtual bool HandleMessage( const Asura_Message* pxMessage );

protected:
	virtual void Deactivate();
	virtual void Update( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:
	enum State
	{
		INIT,
		REQUEST_STUNNED,
		STARTED_STUNNED,
		FINISHED
	};

	void SwitchToState( const State eNextState );
	void RequestStunnedStumbleMove();

	AVP_Brain_Actor_AlienQueen* GetAlienQueenBrain() const;

	State m_eCurrentState;
	float m_fTimeInState;

	typedef Axon_Project_Behaviour PARENT;

};

//////////////////////////////////////////////////////////////////////////////

#endif 