//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_FaceHugger_Pet.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_FACEHUGGER_PET_H__
#define __AVP_BEHAVIOUR_FACEHUGGER_PET_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_FaceHugger;
class AVP_Behaviour_FaceHugger_MoveToPrey;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_FaceHugger_Pet
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_FaceHugger_Pet : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_FaceHugger_Pet( AVP_Brain_Actor_FaceHugger* pxBrain );

protected:
	virtual void Deactivate();
	virtual void Update( const float fTimeslice );
	virtual void PerFrameUpdate( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:
	enum State
	{
		WAIT,
		FORCE_WAIT,
		GET_TO_MASTER,
		MOVE_TO_PRAY,
		ATTACKING,
		DESPAWN,
		DIE,
		NUM_STATES
	};
	void SwitchToState( const State eNextState );

	void CalculateAndMoveToDestination();		
	bool NeedToRecalculateDestination() const;
	bool ShouldAttack(const AVP_Behaviour_FaceHugger_MoveToPrey* pxBehaviour) const;
	void CalculateAndMoveToSpawnpoint();		

	AVP_Brain_Actor_FaceHugger* GetFaceHuggerBrain() const;

private:

	State m_eCurrentState;
	float m_fTimeInState;
	Asura_Vector_3 m_xMasterLastPosition;
	Asura_Vector_3 m_xMasterLastForwardDirection;
	bool m_bBeOnRightSide;
	float m_fTimeSinceLastFindTarget;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_FACEHUGGER_PET_H__
