//---------------------------------------------------------------------------
// File			: AVP_Behaviour_Marine_AttackSelector.h
// Created		: 
// Created By	: Gareth Thomas
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//---------------------------------------------------------------------------

// BEGIN FILE WRAPPER ///////////////////////////////////////
#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif
#ifndef __AVP_BEHAVIOUR_MARINE_ATTACKSELECTOR_H__
#define __AVP_BEHAVIOUR_MARINE_ATTACKSELECTOR_H__ 1
// END FILE WRAPPER ///////////////////////////////////////////

// INCLUDES ///////////////////////////////////////////////////////////
#include "Behaviour/Axon_Project_Behaviour.h"

#include "Core/BrainTypes/AVP_Brain_Actor_Marine.h"

// FORWARD DECLARATIONS ///////////////////////////////////
class AVP_Tactical_System;
class AVP_Knowledge_System_Actor;
class AVP_ServerActor_Human;

//---------------------------------------------------------------------------
// Class		: AVP_Behaviour_Marine_AttackSelector
// Description	: 
//---------------------------------------------------------------------------
class AVP_Behaviour_Marine_AttackSelector : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:

	// InCover Update State Enum
	enum UpdateState
	{
		UNSET,
		ATTACK_ADVANCE,
		ATTACK_FALLBACK,
		ATTACK_SUPPORT,
		ATTACK_STANDGROUND,
		ATTACK_SMARTGUN,
		ATTACK_TRAVELLING,
		MAX_STATES
	};

	// Construction / Deconstruction
	AVP_Behaviour_Marine_AttackSelector( AVP_Brain_Actor_Marine* pxBrain );
	virtual ~AVP_Behaviour_Marine_AttackSelector( void );

	// Public Member Virtual Functions...
	virtual bool 					Activate( void );
	virtual void 					Deactivate( void );
	virtual void					PerFrameUpdate( const float fTimeslice );
	#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void					RenderDebugInfo( void );
	#endif

protected:

	// Protected Member Data Access...
	UpdateState						GetUpdateState( void ) const			{ return m_eUpdateState; }
	AVP_Brain_Actor_Marine*			GetMarineBrain( void )					{ return m_pxMarineBrain; }
	AVP_Tactical_System*			GetTacticalSystem( void )				{ return m_pxMarineBrain->GetTacticalSystem(); }
	AVP_Knowledge_System_Actor*		GetKnowledgeSystem( void )				{ return m_pxMarineBrain->GetKnowledgeSystem(); }
	AVP_ServerActor_Human*			GetOurActor( void )						{ return m_pxMarineBrain->GetHumanActor(); }
	void							SetUpdateState( UpdateState eState )	{ m_eUpdateState = eState; }
	u_int							GetWeaponType( void )					{ return m_uWeaponType; }
	

	// Protected Member Functions...
	float							GetAvgThreatDistanceSq( void );
	void							SwitchToState( UpdateState eState );
	bool							AreWeSuitableToBeTheAssaulter();

private:

	// Private Member Variables...
	UpdateState						m_eUpdateState;
	AVP_Brain_Actor_Marine*			m_pxMarineBrain;
	u_int							m_uWeaponType;
	bool							m_bIsAssaulter;
	float							m_fLastHealth;

	enum { CURRENT_CHUNK_VERSION = 1 };
};

#endif //__AVP_BEHAVIOUR_MARINE_ATTACKSELECTOR_H__

/// End Of File 'AVP_Behaviour_Marine_AttackSelector.h'
