//---------------------------------------------------------------------------
// File			: AVP_Behaviour_Marine_MeleeCounter.h
// Created		: 
// Created By	: Gareth Thomas
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//---------------------------------------------------------------------------

// BEGIN FILE WRAPPER ///////////////////////////////////////
#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif
#ifndef __AVP_BEHAVIOUR_MARINE_MELEECOUNTER_H__
#define __AVP_BEHAVIOUR_MARINE_MELEECOUNTER_H__ 1
// END FILE WRAPPER ///////////////////////////////////////////

// INCLUDES ///////////////////////////////////////////////////////////
#include "Behaviour/Axon_Project_Behaviour.h"

// FORWARD DECLARATIONS ///////////////////////////////////
class AVP_Brain_Actor_Marine;

//---------------------------------------------------------------------------
// Class		: AVP_Behaviour_Marine_MeleeCounter
// Description	: 
//---------------------------------------------------------------------------
class AVP_Behaviour_Marine_MeleeCounter : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:

	// InCover Update State Enum
	enum MeleeCounterUpdateState
	{
		UNSET,
		MAX_STATES
	};

	// Construction / Deconstruction
	AVP_Behaviour_Marine_MeleeCounter					(AVP_Brain_Actor_Marine* pxBrain);
	virtual ~AVP_Behaviour_Marine_MeleeCounter			(void)							{}

	// Public Member Virtual Functions...
	virtual bool 					Activate			(void);
	virtual void 					Deactivate			(void);
	virtual void 					Pause				(void);
	virtual void 					Unpause				(void);
	virtual void 					Update				(const float fTimeslice);
	virtual void					PerFrameUpdate		(const float fTimeslice);

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void					RenderDebugInfo		(void);
#endif

	// Public Member Functions...
	MeleeCounterUpdateState			GetUpdateState		(void) const					{return m_eUpdateState;}
	AVP_Brain_Actor_Marine*			GetMarineBrain		(void)							{return m_pxMarineBrain;}

protected:

private:

	// Private Member Variables...
	AVP_Brain_Actor_Marine*			m_pxMarineBrain;
	MeleeCounterUpdateState			m_eUpdateState;

	enum { CURRENT_CHUNK_VERSION = 0 };

};

#endif //__AVP_BEHAVIOUR_MARINE_MELEECOUNTER_H__

/// End Of File 'AVP_Behaviour_Marine_MeleeCounter.h'
