//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Predator_Seeking.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_PREDATOR_SEEKING_H__
#define __AVP_BEHAVIOUR_PREDATOR_SEEKING_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// avp axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_Predator;
class AVP_ServerNode_VantagePoint_Predator;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Predator_Seeking
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_Predator_Seeking : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_Predator_Seeking( AVP_Brain_Actor_Predator* pxBrain );

protected:
	virtual bool Activate();
	virtual void Deactivate();
	virtual void PerFrameUpdate( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

	AVP_Brain_Actor_Predator* GetPredatorBrain() const;

private:
	enum State
	{
		UNSET,
		SEEK,
		LOOK_AROUND,
		FINISHED,
		NUM_STATES
	};

	void SwitchToState( const State eNextState );
	void LookAround(bool bNewLookAround);
	void SelectVP();

	const AVP_ServerNode_VantagePoint_Predator* SelectClosestVPTo(const Asura_Vector_3& xCenter);
	const AVP_ServerNode_VantagePoint_Predator* SelectRandomVPAround(const Asura_Vector_3& xCenter, float fMaxRange);

	bool ShouldAlert();
	bool UpdateAlert();

private:

	State m_eCurrentState;
	float m_fTimeInState;
	float m_fLookAroundTime;
	Asura_Vector_3 m_xDesiredAimDirection;
	const AVP_ServerNode_VantagePoint_Predator* m_pxDestinationVP;
	const AVP_ServerNode_VantagePoint_Predator* m_pxCurrentVP;
	float m_fTimeTillLookAround;
	Asura_Vector_3 m_xEstimatedPosition;
	float m_fEstimateThreatAge;
	bool m_bAlertByVision;

};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_PREDATOR_SEEKING_H__
