//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Predator_Sneaking.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_PREDATOR_SNEAKING_H__
#define __AVP_BEHAVIOUR_PREDATOR_SNEAKING_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// avp axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_Predator;
class AVP_ServerNode_VantagePoint_Predator;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Predator_Sneaking
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_Predator_Sneaking : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_Predator_Sneaking( AVP_Brain_Actor_Predator* pxBrain );

	void SetDestination(Asura_Vector_3 xDestination, bool bWaitForCloak);
	void AimAt(const Asura_Vector_3& xAimTarget);
	void AimWhereYouMove();

	float GetLengthLeftOnPath() const;


protected:
	virtual bool Activate();
	virtual void Deactivate();
	virtual void PerFrameUpdate( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

	AVP_Brain_Actor_Predator* GetPredatorBrain() const;

private:
	enum State
	{
		UNSET,
		CLOAK,
		MOVE_TO_POSITION,
		FINISHED,
		NUM_STATES
	};

	void SwitchToState( const State eNextState );
private:
	bool PlanPath();

	State m_eCurrentState;
	float m_fTimeInState;
	Asura_Vector_3 m_xDestination;
	int m_iRetries;
	bool m_bWaitForCloak;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_PREDATOR_SNEAKING_H__
