//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Predator_Test.cpp
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// core
#include "Core/Asura.h"

// header
#include "Behaviour/BehaviourTypes/Predator/AVP_Behaviour_Predator_Test.h"

// asura
#include "Network/Asura_Network.h"

// axon
#include "Behaviour/BehaviourTypes/AVP_Behaviour_Types.h"
#include "Core/BrainTypes/AVP_Brain_Actor_Predator.h"

// avp
#include "Actor/Vertebrates/Alien/AVP_Alien_MeleeCounter_System.h"
#include "Entity/AVP_Messages.h"
#include "Entity/PhysicalObject/Actor/Vertebrates/AVP_Vertebrate_Messages.h"

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Predator_Test
//
//////////////////////////////////////////////////////////////////////////////

AVP_Behaviour_Predator_Test::AVP_Behaviour_Predator_Test( AVP_Brain_Actor_Predator* pxBrain )
: PARENT( pxBrain, AVP_BEHAVIOUR_TYPE_PREDATOR_TEST )
{
}

void AVP_Behaviour_Predator_Test::Update( const float fTimeslice )
{
	PARENT::Update( fTimeslice );

	UpdateStateTimer( fTimeslice );
	if ( GetStateTimer() > 2.0f )
	{
		ResetStateTimer();

		// Send a normal melee request message.
		Asura_Message* pxMessage = Asura_Network::CreateMessage( AVP_MSGID_REQUEST_MELEE, sizeof( AVP_Message_Vertebrate_RequestMelee ) );
		if ( pxMessage )
		{
			AVP_Message_Vertebrate_RequestMelee* pxData = static_cast< AVP_Message_Vertebrate_RequestMelee* >( pxMessage->GetData() );

			pxData->SetType( AVP_MELEEATTACK_TYPE_NORMAL );
			pxData->SetTargetGuid( ASURA_GUID_UNREGISTERED );

			pxMessage->SetToGuid( GetProjectBrain()->GetOwnerGuid() );
			pxMessage->SetFromGuid( GetProjectBrain()->GetOwnerGuid() );
			Asura_Network::Send( pxMessage );
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////
