//////////////////////////////////////////////////////////////////////////////
//
// AVP_Brain_Team.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BRAIN_TEAM_H__
#define __AVP_BRAIN_TEAM_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// avp
#include "Core/BrainTypes/Axon_Project_Brain.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_ServerEntity_Team;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Brain_Team
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Brain_Team : public Axon_Project_Brain
{
    typedef Axon_Project_Brain PARENT;

public:
    virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );
    virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;

    static u_int GetLargestBehaviourSize();

protected:
    // Shouldn't be able to create one of these directly.
    AVP_Brain_Team( AVP_ServerEntity_Team* pxTeam );
    AVP_ServerEntity_Team* GetTeam() const { return m_pxTeam; }

private:
    AVP_ServerEntity_Team* m_pxTeam;

    enum { CURRENT_CHUNK_VERSION = 0 };
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BRAIN_TEAM_H__
