//////////////////////////////////////////////////////////////////////////////
//
// AVP_Brain_Team_Marine.cpp
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// core
#include "Core/Asura.h"

// header
#include "Core/BrainTypes/AVP_Brain_Team_Marine.h"

// asura
#include "ChunkSystem/Asura_Chunk_Stream.h"

// avp
#include "Entity/Controller/AVP_ServerEntity_Team_Marine.h"

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Brain_Team_Marine
//
//////////////////////////////////////////////////////////////////////////////

AVP_Brain_Team_Marine::AVP_Brain_Team_Marine( AVP_ServerEntity_Team_Marine* pxMarineTeam )
: PARENT( pxMarineTeam )
{
}

void AVP_Brain_Team_Marine::ReadFromChunkStream( Asura_Chunk_Stream& xStream )
{
    int iVersion;
    xStream >> iVersion;

    PARENT::ReadFromChunkStream( xStream );

    if ( iVersion == CURRENT_CHUNK_VERSION )
    {
    }
    else
    {
        Asura_Assertf( false, ( "AVP_Brain_Team_Marine::ReadFromChunkStream - unhandled version (%d)", iVersion ) );
    }
}

void AVP_Brain_Team_Marine::WriteToChunkStream( Asura_Chunk_Stream& xStream ) const
{
    xStream << CURRENT_CHUNK_VERSION;

    PARENT::WriteToChunkStream( xStream );
}

AVP_ServerEntity_Team_Marine* AVP_Brain_Team_Marine::GetMarineTeam() const
{
    return static_cast< AVP_ServerEntity_Team_Marine* >( GetTeam() );
}

u_int AVP_Brain_Team_Marine::GetLargestBehaviourSize()
{
    return 0;
}

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////
