//////////////////////////////////////////////////////////////////////////////
//
// AVP_Knowledge_System.h
//
// Created by NJD - 06 December 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_KNOWLEDGE_SYSTEM_H__
#define __AVP_KNOWLEDGE_SYSTEM_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// AVP
#include "Entity/PhysicalObject/Actor/AVP_ServerEntity_Actor.h"

// Axon
#include "Knowledge/KnowledgeSystemTypes/Axon_Knowledge_System_Standard.h"
#include "Core/Axon_Sound_Registry.h"
#include "Knowledge/Axon_Knowledge.h"
#include "Knowledge/SenseTypes/Axon_Sense_Types.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Axon_Project_Brain;
class Axon_Sense_Hearing;
class Axon_Sense_Touch;
class Axon_Sense_Vision;

enum AVP_Sound_Type
{
	AVP_SOUND_TYPE_SCREAM = AXON_SOUND_TYPE_FIRST_PROJECT_SPECIFIC,
	AVP_SOUND_TYPE_PRED_ROAR,
	AVP_SOUND_TYPE_ALIEN_ROAR,
	AVP_SOUND_TYPE_HUMAN_HURT,
	AVP_SOUND_TYPE_JUMP_LANDING,
	AVP_SOUND_TYPE_MELEE_ATTACK,
	AVP_SOUND_TYPE_DISTRACTION,
	AVP_SOUND_TYPE_MOTION_TRACKER_BLIP,
	AVP_SOUND_TYPE_RELOAD,
	AVP_SOUND_TYPE_MINE_TRIGGER,
	AVP_SOUND_MAX_TYPES,
};

enum AVP_Sense_Type
{
    AVP_SENSE_AWARENESS = AXON_SENSE_TYPE_FIRST_PROJECT_SPECIFIC,
	AVP_SENSE_TYPE_MOTION_TRACKER,
	AVP_MAX_SENSE_TYPES,
};

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Knowledge_System
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Knowledge_System : public Axon_Knowledge_System_Standard
{
    typedef Axon_Knowledge_System_Standard PARENT;

    friend class AVP_Sense_Hearing;
    friend class AVP_Sense_Touch;
    friend class AVP_Sense_Vision;
	friend class AVP_Sense_MotionTracker;

public:
	AVP_Knowledge_System( Axon_Project_Brain* pxBrain );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual bool Verify() { return true; }
#endif
    virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );
    virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;

protected:
    Axon_Project_Brain* GetBrain() const { return m_pxBrain; }

protected:
    Axon_Project_Brain* m_pxBrain;

private:
    enum { CURRENT_CHUNK_VERSION = 0 };
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_KNOWLEDGE_SYSTEM_H__
