//////////////////////////////////////////////////////////////////////////////
//
// AVP_Sense_Hearing.h
//
// Created by NJD - 06 December 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_SENSE_HEARING_H__
#define __AVP_SENSE_HEARING_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

//	axon
#include "Knowledge/SenseTypes/Axon_Sense_Hearing.h"

//	AVP
#include "Entity/PhysicalObject/Actor/AVP_ServerEntity_Actor.h"
#include "Knowledge/AVP_Knowledge_System_Actor.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Knowledge_System_Actor;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Sense_Hearing
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Sense_Hearing : public Axon_Sense_Hearing
{
    typedef Axon_Sense_Hearing PARENT;

public:
    AVP_Sense_Hearing(AVP_Knowledge_System_Actor* pxAVPKnowledgeSystem);
    virtual ~AVP_Sense_Hearing();

    virtual void ReadFromChunkStream(Asura_Chunk_Stream& xStream);
    virtual void WriteToChunkStream(Asura_Chunk_Stream& xStream) const;
    virtual void Update(const float fTimeslice);

	virtual void AddToHearingList(Axon_Knowledge* pxNewKnowledge);
	virtual void DeleteFromHearingList(const Axon_Knowledge* pxKnowledgeToRemove);

protected:
	
	virtual void InitialiseFromBlueprint( const Asura_Blueprint& xBlueprint );
	virtual bool ShouldCullSound(const Axon_Sound_Registry::SoundEntry* pxEntry);

	void	InitFromSettingsBlueprint();
	
	bool	IsFriendlySoundOfTypeToIgnore(const Axon_Sound_Registry::SoundEntry* pxEntry);
	bool	IsFriendlyFootstepSound(const Axon_Sound_Registry::SoundEntry* pxEntry);
	bool	ShouldCullSoundTypeFromAlertLevel(const Axon_Sound_Registry::SoundEntry* pxEntry, const Asura_Guid uSourceGuid);
	AVP_Knowledge_System_Actor* GetAVPKnowledgeSystem();

private:
	// The pointer to the actor this system belongs to.
	AVP_ServerEntity_Actor* m_pxActor;
	float m_fKowledgeLifeTime;

	enum { CURRENT_CHUNK_VERSION = 0 };
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_SENSE_HEARING_H__
