//////////////////////////////////////////////////////////////////////////////
//
// AVP_Sense_Hearing_Predator.h
//
// Created by NJD - 06 December 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_SENSE_HEARING_PREDATOR_H__
#define __AVP_SENSE_HEARING_PREDATOR_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

//	axon
#include "Knowledge/SenseTypes/Axon_Sense_Hearing.h"

//	AVP
#include "Entity/PhysicalObject/Actor/AVP_ServerEntity_Actor.h"
#include "Knowledge/AVP_Knowledge_System_Predator.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Knowledge_System_Predator;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Sense_Hearing_Predator
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Sense_Hearing_Predator : public Axon_Sense_Hearing
{
    typedef Axon_Sense_Hearing PARENT;

public:
    AVP_Sense_Hearing_Predator(AVP_Knowledge_System_Predator* pxAVPKnowledgeSystem);
    virtual ~AVP_Sense_Hearing_Predator();

    virtual void ReadFromChunkStream(Asura_Chunk_Stream& xStream);
    virtual void WriteToChunkStream(Asura_Chunk_Stream& xStream) const;
    virtual void Update(const float fTimeslice);

	virtual void AddToHearingList(Axon_Knowledge* pxNewKnowledge);
	virtual void DeleteFromHearingList(const Axon_Knowledge* pxKnowledgeToRemove);

	const Axon_Knowledge* CanHear(Asura_Guid uGuid) const;

protected:
	
	virtual void InitialiseFromBlueprint( const Asura_Blueprint& xBlueprint );

	void InitFromSettingsBlueprint();
	
	AVP_Knowledge_System_Predator* GetAVPKnowledgeSystem();

private:
	// The pointer to the actor this system belongs to.
	AVP_ServerEntity_Actor* m_pxActor;
	float m_fKowledgeLifeTime;

	enum { CURRENT_CHUNK_VERSION = 0 };
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_SENSE_HEARING_PREDATOR_H__
