////////////////////////////////////////////////////////////////////////////////
////
//// AVP_Sense_AlienTeam_Vision.cpp
////
//// Copyright (C) 2007 Rebellion. All Rights Reserved.
////
////////////////////////////////////////////////////////////////////////////////
//
//// I N C L U D E S ///////////////////////////////////////////////////////////
//
//// core
//#include "Core/Asura.h"
//
//// header
//#include "Knowledge/SenseTypes/AVP_Sense_Vision_AlienTeam.h"
//
//// asura
//#include "ChunkSystem/Asura_Chunk_Stream.h"
//
//// axon
//#include "Core/BrainTypes/AVP_Brain_Team_Alien.h"
//#include "Knowledge/AVP_Knowledge_System.h"
//#include "Knowledge/AVP_Knowledge_System_AlienTeam.h"
//
//// avp
//#include "Entity/Controller/AVP_ServerEntity_Team_Alien.h"
//#include "Entity/PhysicalObject/Actor/AVP_ServerEntity_Actor.h"
//#include "Entity/PhysicalObject/Actor/Vertebrates/Alien/AVP_ServerActor_Alien.h"
//#include "Tactical/AVP_Tactical_System.h"
//
////////////////////////////////////////////////////////////////////////////////
////
//// AVP_Sense_AlienTeam_Vision
////
////////////////////////////////////////////////////////////////////////////////
//
//AVP_Sense_AlienTeam_Vision::AVP_Sense_AlienTeam_Vision( AVP_Knowledge_System_AlienTeam* pxAlienTeamKnowledgeSystem )
//: PARENT( pxAlienTeamKnowledgeSystem )
//, m_xVisionList()
//{
//}
//
//AVP_Sense_AlienTeam_Vision::~AVP_Sense_AlienTeam_Vision()
//{
//	DestroyAllKnowledge();
//}
//
//void AVP_Sense_AlienTeam_Vision::ReadFromChunkStream( Asura_Chunk_Stream& xStream )
//{
//	int iVersion;
//	xStream >> iVersion;
//
//	// No parent function to call.
//	//PARENT::ReadFromChunkStream( xStream );
//
//	// Our data to go here.
//	if ( iVersion == CURRENT_CHUNK_VERSION )
//	{
//
//	}
//	else
//	{
//		Asura_Assertf( false, ( "AVP_Sense_AlienTeam_Vision::ReadFromChunkStream - unhandled version (%d)", iVersion ) );
//	}
//}
//
//void AVP_Sense_AlienTeam_Vision::WriteToChunkStream( Asura_Chunk_Stream& xStream ) const
//{
//	xStream << CURRENT_CHUNK_VERSION;
//
//	// No parent function to call.
//	//PARENT::WriteToChunkStream( xStream );
//
//	// Our data to go here.
//}
//
//void AVP_Sense_AlienTeam_Vision::Update( const float fTimeslice )
//{
//	// Invalidate all entites on the list
//	for ( Asura_Hashed_List_It< AVP_AlienTeam_Knowledge > xVisionIt( &m_xVisionList ); !xVisionIt.Done(); xVisionIt.Next() )
//	{
//		AVP_AlienTeam_Knowledge* pxKnowledge = xVisionIt.GetCurrent();
//
//		if( pxKnowledge )
//		{
//			pxKnowledge->m_bIsDestroyed = true;
//		}
//	}
//
//	// Go through the actors and add them to our knowledge list
//	const AVP_ServerEntity_Team_Alien* pxAlienTeam = GetAlienTeamKnowledgeSystem()->GetAlienTeamBrain()->GetAlienTeam();
//	for ( Asura_Hashed_List_ConstIt< AVP_ServerEntity_Actor > xIt( AVP_ServerEntity_Actor::GetList() ); !xIt.Done(); xIt.Next() )
//	{
//		// Ignore inactive or dead actors.
//		const AVP_ServerEntity_Actor* pxActor = xIt.GetCurrent();
//		if ( !pxActor || !pxActor->IsEntityActive() || pxActor->IsDead() )
//		{
//			continue;
//		}
//
//		// Ignore friends.
//		if ( AVP_Tactical_System::GetAllegiance( *pxAlienTeam, *pxActor ) != AVP_ALLEGIANCE_ENEMY )
//		{
//			continue;
//		}
//
//		// Add or update this knowledge.
//		AVP_AlienTeam_Knowledge* pxExistingKnowledge = m_xVisionList.FindObject( pxActor->GetGuid(), false ); // Check 'destroyed' knowledge as well.
//		if ( pxExistingKnowledge )
//		{
//			pxExistingKnowledge->m_xPosition	= pxActor->GetPosition();
//			pxExistingKnowledge->m_bIsDestroyed = false;
//		}
//		else
//		{
//			AVP_AlienTeam_Knowledge* pxKnowledge = m_pxKnowledgeSystem->CreateKnowledge();
//			if ( pxKnowledge )
//			{
//				pxKnowledge->m_uThreatGuid		= pxActor->GetGuid();
//				pxKnowledge->m_iThreatClass		= AVP_Knowledge_System_AlienTeam::GetThreatClassFromClassification( *pxActor );
//				pxKnowledge->m_fThreatTypeBonus	= GetAlienTeamKnowledgeSystem()->GetThreatClassMultiplier( pxKnowledge->m_iThreatClass );
//				pxKnowledge->m_xPosition		= pxActor->GetPosition();
//				//pxKnowledge->m_xOrientation		= pxActor->GetOrientation();
//
//				// Add it to the knowledge list.
//				m_xVisionList.AddToList( pxKnowledge );
//			}
//		}
//	}
//
//	// Remove destroyed entites from list.
//	for ( Asura_Hashed_List_Deleter_It< AVP_AlienTeam_Knowledge > xVisionDeleteIt( &m_xVisionList ); !xVisionDeleteIt.Done(); xVisionDeleteIt.Next() )
//	{
//		AVP_AlienTeam_Knowledge* pxKnowledge = xVisionDeleteIt.GetCurrent();
//
//		if( pxKnowledge && pxKnowledge->m_bIsDestroyed )
//		{
//			xVisionDeleteIt.DeleteCurrent();
//			m_pxKnowledgeSystem->DestroyKnowledge( pxKnowledge );
//		}
//	}
//}
//
//AVP_Knowledge_System_AlienTeam* AVP_Sense_AlienTeam_Vision::GetAlienTeamKnowledgeSystem() const
//{
//	return static_cast< AVP_Knowledge_System_AlienTeam* >( GetKnowledgeSystem() );
//}
//
//bool AVP_Sense_AlienTeam_Vision::ShouldCullOnRangeOrFOV( const AVP_ServerEntity_Actor* pxActor )
//{
//	// Aliens are omniscient at the moment. Will need to redo this after the designers have decided what they want.
//	return false;
//}
//
////////////////////////////////////////////////////////////////////////////////
////
//// 
////
////////////////////////////////////////////////////////////////////////////////
//
//void AVP_Sense_AlienTeam_Vision::DestroyAllKnowledge()
//{
//    Asura_Hashed_List_Deleter_It< AVP_AlienTeam_Knowledge > xVisionListIter( &m_xVisionList );
//    while ( !xVisionListIter.Done() )
//    {
//        AVP_AlienTeam_Knowledge* pxToDelete = xVisionListIter.GetCurrent();
//        if ( pxToDelete )
//        {
//            xVisionListIter.DeleteCurrent();
//            m_pxKnowledgeSystem->DestroyKnowledge( pxToDelete );
//        }
//    }
//}
