//////////////////////////////////////////////////////////////////////////////
//
// AVP_AI_Navigation.h
//
// Copyright (C) 2009 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_AI_NAVIGATION_H__
#define __AVP_AI_NAVIGATION_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// asura
#include "AI/Asura_AI_Navigation.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//
// AVP_AI_Navigation_System
//
//////////////////////////////////////////////////////////////////////////////

class AVP_AI_Navigation_System : public Asura_AI_Navigation_System
{
	typedef Asura_AI_Navigation_System PARENT;

public:
	struct AVPUserDefinedWaypoint : public UserDefinedWaypoint
	{
		float m_fRadius;
		Asura_LinkList< u_int > m_xLinkedUDWs;

		AVPUserDefinedWaypoint() : m_fRadius( 1.0f ), m_xLinkedUDWs() {}

		virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );
		virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;

		#ifdef ASURA_TOOLS
		bool IsLiftWaypoint() const;
		void AddLink( const u_int uUDWID );
		void RemoveLink( const u_int uUDWID );
		#endif

	private:
		static const u_int uCURRENT_CHUNK_VERSION = 0;
	};

	virtual UserDefinedWaypoint* CreateUserDefinedWaypoint() { return new AVPUserDefinedWaypoint; }
	virtual void DestroyUserDefinedWaypoint( UserDefinedWaypoint* pxUDW ) { delete pxUDW; }
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_AI_NAVIGATION_H__
