//////////////////////////////////////////////////////////////////////////////
//
// AVP_Actor_ObjectiveHandler.h
//
// (AJK - 16.01.2009) Created
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __AVP_ACTOR_OBJECTIVE_HANDLER__
#define __AVP_ACTOR_OBJECTIVE_HANDLER__

// Asura
#include "Core/Asura_LinkList.h"
#include "Core/Asura_Maths.h"

class AVP_ServerEntity_Actor;
class Asura_Vector_3;

class AVP_Actor_ObjectiveHandler
{
public :          
	AVP_Actor_ObjectiveHandler(  AVP_ServerEntity_Actor& xOwner );
	~AVP_Actor_ObjectiveHandler();

	void Update();
	void SetObjectiveToTrack( Asura_Guid      uGuid      ); // Set objective and room node, used by player info
	void SetObjectiveChanged( bool bTrue ) { m_bObjectiveChanged = bTrue; }

private:
	void                         DoRouteFindingTasks();
	void						 CalcRoute();
    Asura_Guid					 FindRoomNodeContainingPosition(const Asura_Vector_3& xPosition);
	void                         FindRoomNodeToTrack();
	void                         FindCurrentRouteRoomNode();
	void                         FindNextRouteRoomNode();
	void                         FindCurAndNextRouteRoomNodes();
	void                         UpdateObjectiveArrow();
	bool                         GetDirToNextNode ( Asura_Vector_3& xDirection );
	void                         UpdateObjectiveClampedAngle(float fNewAngle);

	AVP_ServerEntity_Actor&      m_xOwner;
	Asura_Guid                   m_uObjectiveToTrack;     // If moving, this will trigger a recalc of the route at intervals
	Asura_Guid					 m_uRoomNodeToTrack;      // The objective is in this room
	float						 m_fRouteCalcInterval;    // Use this to recalc route periodically
	Asura_Guid                   m_uCurrentRouteRoomNode;
	Asura_Guid                   m_uNextRouteRoomNode;
	bool                         m_bObjectiveChanged;     // Objective change
    bool                         m_bObjectiveMoving;
	Asura_Guid                   m_PlayerCurrentRoomNode;
	Asura_Vector_2	             m_xArrowPosition;
	float                        m_fClampedAngle;

	Asura_LinkList< Asura_Guid > m_xRoute;
};


#endif // #ifndef __AVP_ACTOR_OBJECTIVE_HANDLER__
