//////////////////////////////////////////////////////////////////////////////
//
// AVP_Actor_PickupHandler.h
//
// (AJK - 02.09.2008) Created
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __AVP_ACTOR_PICKUPHANDLER__
#define __AVP_ACTOR_PICKUPHANDLER__

class AVP_ServerEntity_Pickup;
class AVP_ClientEntity_Pickup;
class AVP_ServerEntity_Actor;
class AVP_ClientEntity_Actor;
class AVP_Pickup;
class AVP_Inventory_System;

class AVP_Actor_PickupHandler
{

public :          

	AVP_Actor_PickupHandler(Asura_Guid uActorGuid);

	void UpdateServer();
    void UpdateClient();
	void OnPickup(AVP_ServerEntity_Actor* pxOwner, AVP_ServerEntity_Pickup* pxPickup, bool bSetAsCurrent = true);
	void SendCollectMessage(const AVP_ServerEntity_Actor* pxOwner, AVP_ServerEntity_Pickup* pxPickup, float fQuantity, float fSecondaryQuantity, bool bSetAsCurrent = true);
	void SendRequestMessage();

	bool CanCurrentWeaponBeDropped() const;
	bool IsSpaceForNewWeapon() const;

	static bool CanCollect(const AVP_ServerEntity_Pickup& pxPickup, const AVP_ServerEntity_Actor& pxOwner, float& fThisColDistSqrd, bool bClientRequest = false);
	static bool CanCollect(const AVP_ClientEntity_Pickup& pxPickup, const AVP_ClientEntity_Actor& pxOwner, float& fThisColDistSqrd);
	static bool IsThisPickupStoreFull(const AVP_Pickup& xPickupObject, const AVP_Inventory_System& xInventory);

	// Get/Set
	Asura_Guid	GetNearestPickupGuid() const { return m_uNearestPickupGuid;  }
	bool		HasRequestedPickup()   const { return m_bHasRequestedPickup; }

	bool        GetOverrideAimDirectionUsage()  const { return m_bOverrideAimDirectionUsage;   }
	void        SetOverrideAimDirectionUsage( bool bSet)  { m_bOverrideAimDirectionUsage = bSet; }

private:
	
	Asura_Guid m_uActorGuid;
	Asura_Guid m_uNearestPickupGuid; //Used when sending a request from the client, and after for rendering information about it...

	bool m_bHasRequestedPickup;
	bool m_bOverrideAimDirectionUsage;

};


#endif // #ifndef __AVP_ACTOR_PICKUPHANDLER__
