
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Actor_PlayerAnimStateHandler.h
// Author : Will Plano
// Date   : 22/02/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_ACTOR_PLAYERANIMSTATEHANDLER_H__
#define __AVP_ACTOR_PLAYERANIMSTATEHANDLER_H__

#include "Core/Asura_Maths.h"

#include "Core/AVP_Interpolator.h"

class AVP_Actor_AnimStateData;
class AVP_ClientEntity_Actor;

class AVP_Actor_PlayerAnimStateHandler
{
public:
	AVP_Actor_PlayerAnimStateHandler( AVP_ClientEntity_Actor& xClient );
	virtual ~AVP_Actor_PlayerAnimStateHandler();
	
	virtual void Initialise() = 0;
	virtual void Update();
	
	void UpdateMovementParametrics( const float fTargetSpeedParametric, float fTargetAngle );

	float GetSpeedParametric() const;
	float GetMoveAngle() const;

protected:
#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void	RenderDebugInfo( Asura_Vector_3& xOutputPos );
#endif

	bool GetSpeedFromDirectionalStateData( const AVP_Actor_AnimStateData* pxStateData, float& fSpeed );

	AVP_ClientEntity_Actor& m_xOwnerActor;

private:

#if defined(ASURA_SUPPORT_COMMAND_CONSOLE)
	static u_int s_uConsoleVarReferenceCount;
#endif
	AVP_Interpolator< float >* m_pxSpeedInterpolator;
	AVP_Angle_Interpolator* m_pxAngleInterpolator;

	mutable float m_fSpeedParametric;
	mutable float m_fMoveAngle;

	AVP_Actor_PlayerAnimStateHandler(const AVP_Actor_PlayerAnimStateHandler& xOther);
	AVP_Actor_PlayerAnimStateHandler&	operator=(const AVP_Actor_PlayerAnimStateHandler& xOther);
};

#endif	// __AVP_ACTOR_PLAYERANIMSTATEHANDLER_H__
