
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Human_PlayerAnimStateData.cpp
// Author : Will Plano
// Date   : 27/09/2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Actor/Vertebrates/AVP_Vertebrate_PlayerAnimStateData.h"

#include "Core/Asura_Maths.h"

////////////////////////////////////////////////////////////////////////////////

static const char* const g_aszState[AVP_Vertebrate_PlayerAnimStateHandler::MOVESTATE_END] =
{
	"",
	"Crouch",
	"Jump",
	"Fall",
	"Ironsights",
	"IronsightsCrouch"
};

static const char* const g_szMove = "Move";

static const char* const g_aszSpeed[AVP_Vertebrate_PlayerAnimStateHandler::MOVESPEED_END] = 
{
	"Idle",
	"Slow",
	"Medium",
	"Fast"
};

const Asura_String AVP_Vertebrate_PlayerAnimStateData::GetStateDescription(u_int uState, u_int uSpeed)
{
	Asura_Assert(uState < AVP_Vertebrate_PlayerAnimStateHandler::MOVESTATE_END, "Invalid player anim state.");
	Asura_Assert(uSpeed < AVP_Vertebrate_PlayerAnimStateHandler::MOVESPEED_END, "Invalid player anim direction.");

	const u_int uMaxState = AVP_Vertebrate_PlayerAnimStateHandler::MOVESTATE_END - 1;
	const u_int uMaxSpeed = GetNumSpeeds( uState ) - 1;
	uState = Asura_Maths::Min(uState, uMaxState);
	uSpeed = Asura_Maths::Min(uSpeed, uMaxSpeed);
	Asura_String xRet( g_aszState[ uState ] );
	if ( uSpeed > AVP_Vertebrate_PlayerAnimStateHandler::MOVESPEED_IDLE )
	{
		if ( !xRet.IsBlank() )
		{
			xRet += '.';
		}
		xRet += g_szMove;
	}
	if ( uSpeed == AVP_Vertebrate_PlayerAnimStateHandler::MOVESPEED_IDLE || uMaxSpeed > AVP_Vertebrate_PlayerAnimStateHandler::MOVESPEED_SLOW )
	{
		if ( !xRet.IsBlank() )
		{
			xRet += '.';
		}
		xRet += g_aszSpeed[ uSpeed ];
	}
	return xRet;
}

/// End of file. ///
