///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_AlienQueen_AIAnimStateMachine.cpp
// Author : David Wooldridge
// Date   : 06/11/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Actor/Vertebrates/AlienQueen/AVP_AlienQueen_AIAnimStateMachine.h"

#include "Rendering/Asura_Font_System.h"

#include "Actor/Vertebrates/AlienQueen/AVP_AlienQueen_AIAnimStateConnections.h"
#include "Actor/Vertebrates/AlienQueen/AVP_AlienQueen_AIAnimStateData.h"
#include "Blueprint/AVP_Blueprint_HashIDs.h"
#include "Entity/PhysicalObject/Actor/AVP_ServerEntity_Actor.h"


void AVP_AlienQueen_AIAnimStateMachine::Initialise()
{
	AVP_AlienQueen_AIAnimStateData::Initialise( m_xServerActor.GetAnimStateBlueprintType() );
	PARENT::Initialise();
}

const AVP_Actor_AnimStateData* AVP_AlienQueen_AIAnimStateMachine::GetStateAnimData( const u_int uState ) const
{
	return AVP_AlienQueen_AIAnimStateData::GetAnimStateData( m_xServerActor.GetAnimStateBlueprintType(), uState );
}

const AVP_Actor_AIAnimStateConnectionData* AVP_AlienQueen_AIAnimStateMachine::GetConnectionData( const u_int uFromState, const u_int uToState ) const
{
	return AVP_AlienQueen_AIAnimStateConnections::GetConnectionData( uFromState, uToState );
}

#ifndef ASURA_NO_DEBUG_OUTPUT

void AVP_AlienQueen_AIAnimStateMachine::RenderDebugInfo()
{
	PARENT::RenderDebugInfo();
	// nothing to add
}

#endif