///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_AlienQueen_AnimationHandler.h
// Author : David Wooldridge
// Date   : 06/11/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_ALIENQUEEN_ANIMATIONHANDLER_H__
#define __AVP_ALIENQUEEN_ANIMATIONHANDLER_H__

#include "Animation/Asura_Animation.h"

#include "Actor/Vertebrates/AVP_Vertebrate_AnimationHandler.h"
#include "Animation/AVP_Animation_IK_Chain_Tail.h"


class AVP_ClientActor_AlienQueen;


class AVP_AlienQueen_AnimationHandler : public AVP_Vertebrate_AnimationHandler
{
public:
	// Public functions...
	AVP_AlienQueen_AnimationHandler(AVP_ClientActor_AlienQueen& xOwner);
	//virtual ~AVP_AlienQueen_AnimationHandler ();
	virtual void Initialise( void );

	virtual void HandleAnimationRequest	(const AVP_Message_Actor_RequestAnimation& xAnimRequestData);

protected:
	AVP_Animation_IK_Chain_Tail m_xTailIKChain;

	AVP_ClientActor_AlienQueen&	m_xOwnerAlienQueen;

	// Protected functions...
	void CreateRequestedAnimation( const Asura_Hash_ID uAnimHashID, const u_int uAnimFlags );

private:
	// Private typedefs...
	typedef AVP_Vertebrate_AnimationHandler PARENT;

	// Private variables...

	// Private functions...
	void InitialiseIKSolver();

	AVP_AlienQueen_AnimationHandler  (void);
	AVP_AlienQueen_AnimationHandler  (const AVP_AlienQueen_AnimationHandler& xOther);

	AVP_AlienQueen_AnimationHandler&	operator=	(const AVP_AlienQueen_AnimationHandler& xOther);

};   // End of class 'AVP_FaceHugger_AnimationHandler'.


#endif