
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Human_AIAnimStateData.h
// Author : Will Plano
// Date   : 21/02/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_HUMAN_AIANIMSTATEDATA_H__
#define __AVP_HUMAN_AIANIMSTATEDATA_H__

#include "Core/Asura_HashTree.h"

#include "Actor/Vertebrates/Human/AVP_Human_AIAnimStateMachine.h"

#include "Entity/PhysicalObject/Actor/Vertebrates/Human/AVP_ServerActor_Human.h"

class AVP_Actor_AnimStateData;

class AVP_Human_AIAnimStateData
{
public:
	static const AVP_Actor_AnimStateData* GetAnimStateData( const Asura_Hash_ID uAnimStateBlueprintType, const Asura_Hash_ID uCurrentWeaponHash, u_int uState, const bool bAiming = true, AVP_Human_AIAnimStateMachine::CoverType eCoverType = AVP_Human_AIAnimStateMachine::COVER_TYPE_BEGIN );

	static void InitialiseWeaponData( const Asura_Hash_ID uAnimStateBlueprintType, const Asura_Hash_ID uHash ) { GetWeaponDataByHash( uAnimStateBlueprintType, uHash ); }
	static void ResetStorage() { s_xHashTree.Reset(); }

private:
	struct AVP_Human_AIAnimWeaponStateData
	{
		AVP_Human_AIAnimWeaponStateData();
		~AVP_Human_AIAnimWeaponStateData();
		void InitialiseFromBlueprint( const Asura_Hash_ID uAnimStateBlueprintType, const Asura_Hash_ID uWeaponBlueprintHash );
	
		AVP_Actor_AnimStateData** m_aappxAnimStateData[ AVP_Human_AIAnimStateMachine::AIMINGSTATE_END ][ AVP_Human_AIAnimStateMachine::HUMAN_STATE_END ];
	};

	static const AVP_Human_AIAnimWeaponStateData* GetWeaponDataByHash( const Asura_Hash_ID uAnimStateBlueprintType, const Asura_Hash_ID uHash );

	static Asura_TemplateHashTree< AVP_Human_AIAnimWeaponStateData > s_xHashTree;

	AVP_Human_AIAnimStateData();
	AVP_Human_AIAnimStateData(const AVP_Human_AIAnimStateData& xOther);
	AVP_Human_AIAnimStateData&	operator=(const AVP_Human_AIAnimStateData& xOther);
};

#endif // __AVP_HUMAN_AIANIMSTATEDATA_H__
