////////////////////////////////////////////////////////////////
//
// File:		AVP_Human_MeleeCounter_System.cpp
// Author:		Chris Wallace
// Date:		23-Jan-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
////////////////////////////////////////////////////////////////

///////////////////////////////////////////////
// #includes
///////////////////////////////////////////////
#include "Core/Asura.h"

// This files header
#include "Actor/Vertebrates/Human/AVP_Human_MeleeCounter_System.h"

#include "Entity/AVP_Entity_Classification.h"
#include "Entity/PhysicalObject/Actor/Vertebrates/Human/Marine/AVP_ServerActor_Marine.h"
#include "Inventory/AVP_Inventory_HashIDs.h"
#include "Inventory/AVP_Inventory_System.h"
#include "Moves/Vertebrates/Human/AVP_Human_MovesMelee.h"

///////////////////////////////////////////////
// #defines
///////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
//
// Class :	AVP_Human_MeleeCounter_System
//
//////////////////////////////////////////////////////////////////////

AVP_Human_MeleeCounter_System::AVP_Human_MeleeCounter_System(AVP_ServerActor_Human& xOwner)
: AVP_Vertebrate_MeleeCounter_System(xOwner)
{
}

//////////////////////////////////////////////////////////////////////
// AVP_Human_MeleeCounter_System :: GetMeleeMoveHash
//////////////////////////////////////////////////////////////////////
Asura_Hash_ID AVP_Human_MeleeCounter_System::GetMeleeMoveHash(u_int uType) const
{
	switch (uType)
	{
		case AVP_HUMAN_MELEEATTACK_TYPE_RETALIATION:
		{
			return AVP_Human_Move_Melee_Retaliation_Start::GetStaticHash();
		}

		default:
		{
			return PARENT::GetMeleeMoveHash(uType);
		}
	}
}

//////////////////////////////////////////////////////////////////////
// AVP_Human_MeleeCounter_System :: GetAttackImpulseStrength
//////////////////////////////////////////////////////////////////////
float AVP_Human_MeleeCounter_System::GetAttackImpulseStrength() const
{
	switch (m_uCurrentAttackType)
	{
		case AVP_HUMAN_MELEEATTACK_TYPE_RETALIATION:
		{
			return 100.0f;
		}

		default:
		{
			return PARENT::GetAttackImpulseStrength();
		}
	}

}

/// End of file. ///
