
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Predalien_AIAnimStateMachine.cpp
// Author : Will Plano
// Date   : 27/02/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Actor/Vertebrates/Predalien/AVP_Predalien_AIAnimStateMachine.h"

#include "Actor/Vertebrates/Predalien/AVP_Predalien_AIAnimStateConnections.h"
#include "Actor/Vertebrates/Predalien/AVP_Predalien_AIAnimStateData.h"
#include "Entity/PhysicalObject/Actor/AVP_ServerEntity_Actor.h"

////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////

void AVP_Predalien_AIAnimStateMachine::Initialise()
{
	AVP_Predalien_AIAnimStateData::Initialise( m_xServerActor.GetAnimStateBlueprintType() );

	PARENT::Initialise();
}

const AVP_Actor_AnimStateData* AVP_Predalien_AIAnimStateMachine::GetStateAnimData( const u_int uState ) const
{
	return AVP_Predalien_AIAnimStateData::GetAnimStateData( m_xServerActor.GetBlueprintTypeHashID(), uState );
}


#ifndef ASURA_NO_DEBUG_OUTPUT

void AVP_Predalien_AIAnimStateMachine::RenderDebugInfo()
{
	PARENT::RenderDebugInfo();
}
#endif

const AVP_Actor_AIAnimStateConnectionData* AVP_Predalien_AIAnimStateMachine::GetConnectionData( const u_int uFromState, const u_int uToState ) const
{
	return AVP_Predalien_AIAnimStateConnections::GetConnectionData( uFromState, uToState );
}

/// End of file. ///
