///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Predator_InteractionHandler.h
// Author : Ali Jakamy
// Date   : 23-10-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef AVP_PREDATOR_INTERACTIONHANDLER
#define AVP_PREDATOR_INTERACTIONHANDLER

#include "Actor/AVP_Actor_InteractionHandler.h"

class AVP_ClientEntity_InteractObject;

class AVP_Predator_InteractionHandler : public AVP_Actor_InteractionHandler
{
public:
	AVP_Predator_InteractionHandler(AVP_ClientEntity_Actor& xOwner);

	virtual void Update();
	virtual bool HandleInteraction(AVP_INTERACTION_TYPES eType, int iKeyType, float fKeyValue) const;

	virtual bool IsInteracting() const;
	virtual bool IsInIdleInteraction() const;

	static bool GetIsPredatorInteractionMove(const Asura_Hash_ID uMoveHash);

#if defined(ASURA_SUPPORT_COMMAND_CONSOLE)
	static void CreateConsoleVars();
#endif	// defined(ASURA_SUPPORT_COMMAND_CONSOLE)
private:
   
	void UpdateDisengage();
	void HandleDisengage();
	bool IsEngagedWithPuzzle() const;

	static bool		s_bPredatorEngagedInPuzzle;

	bool		 m_bDisengage;
	Asura_Guid   m_uPuzzleToDisengageGuid;
	typedef AVP_Actor_InteractionHandler PARENT;
};   

#endif   