
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Predator_PlayerAnimStateHandler.h
// Author : Will Plano
// Date   : 25/02/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_PREDATOR_PLAYERANIMSTATEHANDLER_H__
#define __AVP_PREDATOR_PLAYERANIMSTATEHANDLER_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Actor/Vertebrates/AVP_Vertebrate_PlayerAnimStateHandler.h"

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_PlayerAnimStateHandler : public AVP_Vertebrate_PlayerAnimStateHandler
{
public:
	// Public enumerated types...

	// Public functions...
	AVP_Predator_PlayerAnimStateHandler( AVP_ClientEntity_Actor& xClient ) : PARENT( xClient ), m_bCurrentCrouch(false) {}
	virtual ~AVP_Predator_PlayerAnimStateHandler() {}

	virtual void Initialise();

	virtual void Update();

protected:
#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo( Asura_Vector_3& xOutputPos );
#endif

private:
	typedef AVP_Vertebrate_PlayerAnimStateHandler PARENT;

	bool m_bCurrentCrouch;

	AVP_Predator_PlayerAnimStateHandler(const AVP_Predator_PlayerAnimStateHandler& xOther);
	AVP_Predator_PlayerAnimStateHandler&	operator=(const AVP_Predator_PlayerAnimStateHandler& xOther);

}; // End of class 'AVP_Predator_PlayerStateHandler'.

#endif // ifndef __AVP_PREDATOR_PLAYERSTATEHANDLER_H__

/// End of file. ///
