
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_AnimFlags.h
// Author : Andy Tate
// Date   : 31-Oct-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_ANIMFLAGS_H__
#define __AVP_ANIMFLAGS_H__

////////////////////////////////////////////////////////////////////////////////
// Global Defines...
////////////////////////////////////////////////////////////////////////////////

#define AVP_ANIMFLAG_FOOTSTEP_REAR_LEFT			0x00000001
#define AVP_ANIMFLAG_FOOTSTEP_REAR_RIGHT		0x00000002
#define AVP_ANIMFLAG_FOOTSTEP_FRONT_LEFT		0x00000004
#define AVP_ANIMFLAG_FOOTSTEP_FRONT_RIGHT		0x00000008
#define AVP_ANIMFLAG_BODYFALL_HEAVY				0x00000010
#define AVP_ANIMFLAG_BODYFALL_LIGHT				0x00000020
#define AVP_ANIMFLAG_COMPLETE					0x00000040
#define AVP_ANIMFLAG_SEPARATE_CHARACTERS		0x00000080
#define AVP_ANIMFLAG_TRACK_TARGET				0x00000100
#define AVP_ANIMFLAG_ACTION_1					0x00000200
#define AVP_ANIMFLAG_SHOW_MELEE_COUNTERBAR		0x00000400	// EP - 62/11/08 - Added for showing counter melee bar.
#define AVP_ANIMFLAG_FOOTSTEP_REAR_LEFT_RUN		0x00000800
#define AVP_ANIMFLAG_FOOTSTEP_REAR_RIGHT_RUN	0x00001000
#define AVP_ANIMFLAG_FOOTSTEP_FRONT_LEFT_RUN	0x00002000
#define AVP_ANIMFLAG_FOOTSTEP_FRONT_RIGHT_RUN	0x00004000
#define AVP_ANIMFLAG_END_ANIM					0x00008000
#define AVP_ANIMFLAG_MELEE_COUNTER				0x00010000
#define AVP_ANIMFLAG_ALLOW_NEW_MELEE			0x00020000
#define AVP_ANIMFLAG_GRAPPLE_APPLY_DAMAGE		0x00040000
//#define AVP_ANIMFLAG_GRAPPLE_APPLY_RAGDOLL		0x00080000	// AJG - 02/09/08 - Not in use at this time, consider for replacement
#define AVP_ANIMFLAG_ALLOW_NEW_COUNTER			0x00100000
#define AVP_ANIMFLAG_ALLOW_NEW_BLOCK			0x00200000
#define AVP_ANIMFLAG_ACTIVATE_TARGET_FOLLOW		0x00400000
#define AVP_ANIMFLAG_RESET_LOOK					0x00800000
#define AVP_ANIMFLAG_TRIGGER_ATTACHMENT			0x01000000
#define AVP_ANIMFLAG_MELEE_DAMAGE				0x02000000
#define AVP_ANIMFLAG_ALIEN_THRASH				0x04000000 // Temporary for SPS demo. May develop into a marker for character downed states, but at this point I'm not sure if an anim flag is needed there anyway.
#define AVP_ANIMFLAG_TRIGGER_DETACHMENT			0x08000000
#define AVP_ANIMFLAG_JUMP_LAND					0x10000000
#define AVP_ANIMFLAG_NOT_IK_HANDS_AND_TAIL		0x20000000
#define AVP_ANIMFLAG_NOT_IK_FEET				0x40000000
#define AVP_ANIMFLAG_CREATE_RAGDOLL				0x80000000

#endif   // ifndef __AVP_ANIMFLAGS_H__


/// End of file. ///
