
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_AnimationAttachment_Ragdoll.h
// Author : Will Plano
// Date   : 10/01/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_ANIMATIONATTACHMENT_RAGDOLL_H__
#define __AVP_ANIMATIONATTACHMENT_RAGDOLL_H__

#include "Animation/Asura_AnimationAttachment.h"
#include "Core/Asura_Maths.h"

class AVP_AnimationAttachment_Ragdoll : public Asura_AnimationAttachment
{
public:
	AVP_AnimationAttachment_Ragdoll( Asura_Handle iRagdollWrapperHandle, const u_int uBoneID ) : m_iRagdollWrapperHandle( iRagdollWrapperHandle ), m_uBoneID( uBoneID ), m_xOldPos( Asura_Maths::ZeroVector3 ), m_bNeedsDeleting( false ) {}
	virtual ~AVP_AnimationAttachment_Ragdoll() {}

	Asura_Handle GetRagdollWrapperHandle() { return m_iRagdollWrapperHandle; }
	virtual void Update( float fTime, bool bIgnoreTimerFrameStamp );

	virtual bool NeedsDeleting() const { return m_bNeedsDeleting; }

private:
	virtual Asura_AnimationAttachment* Clone( Asura_Animation* pxParent ) { return NULL; }

	Asura_Handle	m_iRagdollWrapperHandle;
	u_int			m_uBoneID;
	Asura_Vector_3	m_xOldPos;
	bool			m_bNeedsDeleting;
};

#endif	// __AVP_ANIMATIONATTACHMENT_RAGDOLL_H__

