///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_BoneDataModifier_TailStab.h
// Author : Will Plano
// Date   : 08/01/2009
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_AVP_BONEDATAMODIFIER_TAILSTAB_H__
#define __AVP_AVP_BONEDATAMODIFIER_TAILSTAB_H__

#include "Animation/Asura_Animation_BoneDataModifier.h"

#include "Core/Asura_Maths.h"

class AVP_BoneDataModifier_TargetRelative : public Asura_Animation_BoneDataModifier
{
public:
	AVP_BoneDataModifier_TargetRelative( Asura_Animation* pxAnimation, const Asura_Vector_3& xRelativeOSTargetPosition, const u_int uNumBones, const int* const aiBones, const bool bRescale );
	virtual ~AVP_BoneDataModifier_TargetRelative();

	void SetOSTargetPosition( const Asura_Vector_3& xOSTargetPos ) { m_xCurrentOSTargetPosition = xOSTargetPos; }

	void TweenIn( const float fTweenTime );
	void TweenOut( const float fTweenTime );

	virtual void UpdateTimers( const float fTime );
	virtual void UpdateBoneData( const int iFirstBone, const int iLastBone );

private:
	typedef Asura_Animation_BoneDataModifier PARENT;

	const Asura_Vector_3&		m_xRelativeOSTargetPosition;
	Asura_Vector_3				m_xCurrentOSTargetPosition;
	Asura_Vector_3*				m_axRestPoseOSBonePos;
	const int*					m_aiBone;
	u_int						m_uNumBones;
	u_int						m_uNumTimerUpdatesAtLastBoneUpdate;
	float						m_fBlend;
	float						m_fInvTweenTime;
	
	union
	{
		u_int					m_uFlags;
		struct
		{
			u_int				m_bTweenIn	: 1,
								m_bRescale	: 1,
											: 0;
		};
	};

}; // end class AVP_Animation_IK_Chain_Tail

#endif   // ifndef __AVP_AVP_BONEDATAMODIFIER_TAILSTAB_H__

/// End of file. ///
