
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Hierarchy_Skin.h
// Author : Andy Tate
// Date   : 26-Oct-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_HIERARCHY_SKIN_H__
#define __AVP_HIERARCHY_SKIN_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Animation/Asura_Hierarchy.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Hierarchy_Skin
// Author       : Andy Tate
// Date         : 26-Oct-2006
//
// Description  : Class used to override the default hierarchy behaviour from
//				  Asura, specifically the "ApplyMirroring()" function.
////////////////////////////////////////////////////////////////////////////////

class AVP_Hierarchy_Skin : public Asura_Hierarchy_Skin
{
public:
	// Public functions...
	AVP_Hierarchy_Skin          (void)	{}
//	virtual ~AVP_Hierarchy_Skin ();

	// Overridden mirroring functions...
//	virtual	int		GetMirroredBone	(int iBone) const;
	virtual	void	ApplyMirroring	(int iBone, bool bDeltaAnim, Asura_Quat& xQuat, Asura_Vector_3& xPos) const;


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private variables...

	// Private functions...
	AVP_Hierarchy_Skin  (const AVP_Hierarchy_Skin& xOther);

	AVP_Hierarchy_Skin&	operator=	(const AVP_Hierarchy_Skin& xOther);

};   // End of class 'AVP_Hierarchy_Skin'.


#endif   // ifndef __AVP_HIERARCHY_SKIN_H__


/// End of file. ///
