//////////////////////////////////////////////////////////////////////////////
//
// AVP_Blueprint_HashIDs.h
//
// Created by NJD - 27 October 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BLUEPRINT_HASHIDS_H__
#define __AVP_BLUEPRINT_HASHIDS_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//
// Hash IDs for blueprint types.
//
// PLEASE: Try to keep these in alphabetical order, so people can quickly see
//         if a hash they need has already been added.
//
//////////////////////////////////////////////////////////////////////////////

static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_ACTORS				= 0x766161D2;	// Asura_GetHashID( "Actor Initialisation" )
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_ACTOR_SOUNDS			= 0x2351E9CF;	// Asura_GetHashID( "Actor Sounds" )
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_ACTOR_STATE			= 0xE85F76A6;	// Asura_GetHashID( "Actor State" )
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_AI_SETTINGS			= 0x7AD7BD1B;	// Asura_GetHashID( "AI Settings" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_ANIMSTATE_ALIEN		= 0x8E4646E8;	// AnimState_Alien
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_ANIMSTATE_ALIENQUEEN = 0x7308E142;   // AnimState_AlienQueen
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_ANIMSTATE_CIVILIAN	= 0xEBAD23C2;	// AnimState_Civilian
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_ANIMSTATE_FACEHUGGER	= 0x60353936;	// AnimState_FaceHugger
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_ANIMSTATE_MARINE		= 0x4E65E1C1;	// AnimState_Marine
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_ANIMSTATE_PREDATOR	= 0xF0E6D336;	// AnimState_Predator
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_ANIMSTATE_PREDALIEN  = 0x2befd8e7;	// AnimState_Predalien
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_ANIMSTATE_SENTRYGUN	= 0x9AA8F0A2;	// AnimState_Sentrygun
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_ATTACHMENTS			= 0xD3F3CBB0;	// Asura_GetHashID( "Attachments" )
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_DAMAGE				= 0xB02E8B6F;	// Damage
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_DIALOGUE				= 0xF20FD9D8;	// Dialogue
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_ENV_HOOKS        	= 0xC06926BD;	// Asura_GetHashID( "Env Hooks" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_GAMEPLAYVOLUMES		= 0xf34957b3;	// GamePlayVolumes
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_GRAPPLE				= 0x10B5D14F;	// Asura_GetHashID( "Grapple" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_GRAPPLEALIEN			= 0x7A8604B6;	// Asura_GetHashID( "Grapple Alien" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_GRAPPLEPREDATOR		= 0x7E8F9AA8;	// Asura_GetHashID( "Grapple Predator" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_GRAPPLEPREDALIEN		= 0x7e8f9aa8;	// Asura_GetHashID( "Grapple Predator" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_GRAPPLEANIMATION		= 0x859A5315;	// Asura_GetHashID( "GrappleAnimation" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_GRAPPLEDESIGN		= 0xEECB1BCD;	// Asura_GetHashID( "GrappleDesign" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_GRAPPLEEFFECTS		= 0x207A60D3;	// Asura_GetHashID( "GrappleEffects" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_INVENTORY_ITEMS		= 0xFE9347E4;	// Asura_GetHashID( "InventoryItems" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_LEVELS				= 0xBE11D56F;	// Asura_GetHashID( "Levels" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_MELEE				= 0x062F8D74;	// Asura_GetHashID( "Melee" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_MOVESALIEN			= 0xA42B4FE9;	// Asura_GetHashID( "Moves Alien" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_MOVESHUMAN			= 0xA4921A4F;	// Asura_GetHashID( "Moves Human" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_MOVESPREDATOR		= 0xD8F99E95;	// Asura_GetHashID( "Moves Predator" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_MOVESPREDALIEN		= 0x46367968; 	// Asura_GetHashID( "Moves Predalien" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_MOVESALIENQUEEN		= 0xA19650E1;   // Asura_GetHashID( "Moves AlienQueen" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_MULTIPLAYER			= 0x2184E15A;	// Asura_GetHashID( "Multiplayer" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_PHYSICAL_OBJECTS 	= 0x6B08945D;	// Asura_GetHashID( "PhysicalObjects" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_PHEROMONE 			= 0xB9180E43;	// Asura_GetHashID( "Pheromone" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_PICKUPS          	= 0xDD8C4577;	// Asura_GetHashID( "Pickups" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_PLAYERS				= 0xE294C1B2;	// Asura_GetHashID( "Players" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_PROJECTILES			= 0xC80473AA;	// Asura_GetHashID( "Projectiles" );
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_SURFACEEFFECTS		= 0xAD905FB5;	// Asura_GetHashID( "SurfaceEffects" )
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_WEAPONEFFECTS		= 0xB1E55F66;	// Asura_GetHashID( "WeaponEffects" )
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_EFFECTTYPES			= 0x642EF188;	// Asura_GetHashID( "EffectTypes" )
static const Asura_Hash_ID uAVP_BLUEPRINT_TYPE_VIBRATIONS          	= 0x68BF6021;	// Asura_GetHashID( "Vibrations" );

//////////////////////////////////////////////////////////////////////////////
//	
// Hash IDs for blueprint names.
//
// PLEASE: Try to keep these in alphabetical order, so people can quickly see
//         if a hash they need has already been added.
//
//////////////////////////////////////////////////////////////////////////////

static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ACTOR_SURFACE_TYPES	= 0x4ED5305B;	// "Actor Surface Types"	//	uAVP_BLUEPRINT_NAME_DAMAGETYPE

static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGETYPE			= 0x9643cb29;	// Asura_GetHashID("DamageType");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGETYPE_CAUSE_DECLOAK	= 0x66f44855; //"DamageCauseDecloak"

static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_SURFACEEFFECT		= 0x3725b07e;	// Asura_GetHashID("SurfaceEffect");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_SURFACETYPE			= 0xac705d67;	// Asura_GetHashID("SurfaceType");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_SURFACETYPE_MATERIAL	= 0x23da6c0d;	// Asura_GetHashID("Material Surface Types");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_SURFACETYPE_MATERIAL_METAL = 0x062fab07; //"Metal"

// Alien related blueprints...
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIEN				= 0x058996C7;	// Asura_GetHashID("Alien");

static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIENMULTIPLAYER		= 0x8E591833;	// Asura_GetHashID("AlienMultiplayer");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIENSINGLEPLAYER	= 0xCA776D70;	// Asura_GetHashID("AlienSinglePlayer");

static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIEN_VARIANT_01		= 0x71B07275; 	// Asura_GetHashID("Alien Variant 01");

// Human related blueprints...
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_HUMAN				= 0x05F0612D;	// Asura_GetHashID("Human");

static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MARINEMULTIPLAYER	= 0x1F2D8658;	// Asura_GetHashID("MarineMultiPlayer");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MARINESINGLEPLAYER	= 0x5430C3EB;	// Asura_GetHashID("MarineSinglePlayer");

// Predator related blueprints...
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATOR				= 0xB31282F7;	// Asura_GetHashID("Predator");

static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATORMULTIPLAYER	= 0xD193AE03;	// Asura_GetHashID("PredatorMultiPlayer");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATORSINGLEPLAYER	= 0xEE8F91A0;	// Asura_GetHashID("PredatorSinglePlayer");

// Inventory related blueprints...
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_INVENTORYITEM_CLOAK		= 0x05A5DBD0;	// Asura_GetHashID("Cloak");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_INVENTORYITEM_VISIONMODE	= 0x8A2C618B;	// Asura_GetHashID("VisionMode");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_INVENTORYITEM_WEAPON		= 0xD0CDC21C;	// Asura_GetHashID("Weapon");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_INVENTORYITEM_AMMOTYPE	= 0xA2AC3708;	// Asura_GetHashID("AmmoType");

// Melee related blueprints
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MELEE					= 0x062F8D74;	// Asura_GetHashID("Melee");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MELEEOTHER				= 0xF5E1F864;	// Asura_GetHashID("OtherMelee");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MELEEWRISTBLADES			= 0x9D83FBCA;	// Asura_GetHashID("WristbladesMelee");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MELEETHIRD				= 0xDE012E46;	// Asura_GetHashID("Melee3rdPerson");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MELEEOTHERTHIRD			= 0xE4401156;	// Asura_GetHashID("OtherMelee3rdPerson");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MELEEWRISTBLADESTHIRD	= 0xE47480B0;	// Asura_GetHashID("WristbladesMelee3rdPerson");

static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_WRISTBLADES				= 0x1EE973EA;	// Asura_GetHashID("Wristblades");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_WRISTBLADES_THIRDPERSON	= 0x1AE42C90;	// Asura_GetHashID("Wristblades3rdPerson");

static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIENHEADBITE_HUMANVICTIM				= 0x8EF7DDF6;	// Asura_GetHashID("AlienHeadbiteHumanVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIENHEADBITE_PREDATORVICTIM				= 0x1EFCCC9E;	// Asura_GetHashID("AlienHeadbitePredatorVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIENBACKHEADBITE_HUMANVICTIM			= 0xC76F352F;	// Asura_GetHashID("AlienBackHeadbiteHumanVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIENBACKHEADBITE_PREDATORVICTIM			= 0x26CBFEC5;	// Asura_GetHashID("AlienBackHeadbitePredatorVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIENSTEALTHKILL_HUMANVICTIM				= 0xD1C7F0FB;	// Asura_GetHashID("AlienStealthKillHumanVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIENSTEALTHKILL_PREDATORVICTIM			= 0x32D21F79;	// Asura_GetHashID("AlienStealthKillPredatorVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIENPOUNCE_HUMANVICTIM					= 0x8C908294;	// Asura_GetHashID("AlienPounceHumanVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIENPOUNCE_PREDATORVICTIM				= 0x65397B40;	// Asura_GetHashID("AlienPouncePredatorVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATORCOUNTER_STANDINGALIENCLAW		= 0xB01D385E;	// Asura_GetHashID("CounterStandingAlienClaw");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATORCOUNTER_STANDINGTAILSTAB			= 0x213F1111;	// Asura_GetHashID("CounterStandingAlienTailStab");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATORCOUNTER_ALIENPOUNCE				= 0x4A6DBE2D;	// Asura_GetHashID("CounterAlienPounceLeap");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATORCOUNTER_ALIENCRAWLSTANDATTACK	= 0xBA4EEF62;	// Asura_GetHashID("CounterAlienCrawlStandAttack");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATORCOUNTER_PREDALIENRIGHTCLAW		= 0x24e73ae9;	// Asura_GetHashID("CounterPredalienRightClawSwipe");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATORCOUNTER_PREDALIENLEFTCLAW		= 0x2a47c98a;	// Asura_GetHashID("CounterPredalienLeftClawSwipe");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATORCOUNTER_PREDALIENJUMPDOWN		= 0x4a86ae9a;   // Asura_GetHashID("CounterPredalienJumpDown");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_STANDINGTAILSTAB_HUMANVICTIM				= 0xD682B057;	// Asura_GetHashID("StandingTailStabHumanVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_STANDINGTAILSTAB_PREDATORVICTIM			= 0x92D4D29D;	// Asura_GetHashID("StandingTailStabPredatorVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PICKUPHUMAN								= 0x0A0A8431;	// Asura_GetHashID("PickupHuman");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_STEALTHPICKUPHUMAN						= 0xCBE4992B;	// Asura_GetHashID("PredatorStealthKillHumanVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PICKUPDOWNEDALIEN						= 0x890F26AA;	// Asura_GetHashID("PickupDownedAlien");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PICKUPALIENCROUCHING						= 0xD691823F;	// Asura_GetHashID("PickupAllfoursAlien");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PICKUPALIENSTANDING						= 0xF03B08FF;	// Asura_GetHashID("PickupStandingAlien");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_STEALTHPICKUPALIENCROUCHING				= 0x7181B345;	// Asura_GetHashID("PredatorStealthKillAlienVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_STEALTHPICKUPALIENSTANDING				= 0xE20D7991;	// Asura_GetHashID("PredatorStealthKillAlienStandingVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATOR_GRAPPLEPREDALIEN1				= 0x7eaab575;  	// Asura_GetHashID("PredatorGrapple1PredalienVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATOR_GRAPPLEPREDALIEN2				= 0x603c9354;  	// Asura_GetHashID("PredatorGrapple2PredalienVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATOR_GRAPPLEPREDALIENKILL			= 0x4b4e92b8;  	// Asura_GetHashID("PredatorGrappleKillPredalienVictim");

static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_FACEHUGGER_PREDATORVICTIM				= 0x0a1eebe2;   // Asura_GetHashID("FaceHuggerHugPredatorVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_FACEHUGGER_MARINEVICTIM					= 0x3007a532;   // Asura_GetHashID("FaceHuggerHugHumanVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_FACEHUGGER_MARINEVICTIM_3RD				= 0x5aff9d83;   // Asura_GetHashID("FaceHuggerHugHuman3rdVictim");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_FACEHUGGER_PREDATORVICTIM_3RD			= 0xd5aa98d3;   // Asura_GetHashID("FaceHuggerHugPredator3rdVictim");

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MINPOUNCEDISTANCE						= 0x51B5E2C3;	// Asura_GetHashID("PounceDistanceMin");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIENINJURED2ARMS_HUMANVICTIM			= 0x71509646;	// Asura_GetHashID("AlienInjured2ArmsHumanVictim")
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIENINJURED2ARMS_PREDATORVICTIM			= 0x516d724e;	// Asura_GetHashID("AlienInjured2ArmsPredatorVictim")

static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIENQUEEN_HUMANVICTIM					= 0x176BC4B4;   // Asura_GetHashID("AlienQueenKillHumanVictim");

//static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_SURFACEEFFECTS							= 0x3725b07e;	// Asura_GetHashID("SurfaceEffect") // SurfaceEffect ... THIS IS NOT USED AT ALL. EP.10.DEC.2008

static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDALIENGRAPPLE_PREDATORVICTIM			= 0x6c2dcdc8; 	// Asura_GetHashID("PredalienGrapplePredatorVictim");


// Multiplayer related blueprints

// Multiplayer gamemodes
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DISRUPTION_DOMINATION			= 0x5865bc81; //"DisruptionDomination"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DEATH_MATCH						= 0x00000c89; //"DM"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_HUNT								= 0x00310b93; //"Hunt"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_INSTANT_ACTION					= 0x2a47f757; //"InstantAction"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_SPECIES_TEAM_DEATH_MATCH			= 0x14398fe2; //"SpeciesTeamDM"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_SURVIVOR							= 0xa0990cf6; //"Survivor"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MIXED_SPECIES_TEAM_DEATH_MATCH	= 0x469693C7; //"MixedSpeciesTeamDM"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DOMINATION						= 0x64ED096E; //"Domination"

// Multiplayer teams
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIEN_DISRUPTION_DOMINATION				= 0xaa2f29c8; //"AlienDisruptionDomination"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIEN_DEATH_MATCH						= 0xc97f0d90; //"AlienDM"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIEN_HUNT								= 0x65f3e6da; //"AlienHunt"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIEN_SPECIES_TEAM_DEATH_MATCH			= 0x9cdb747b; //"AlienSpeciesTeamDM"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIEN_SURVIVOR							= 0x675eecbd; //"AlienSurvivor"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIEN_MIXED_SPECIES_TEAM_DEATH_MATCH		= 0x1098a6ce; //"AlienMixedSpeciesTeamDM"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALIEN_DOMINATION							= 0x91ba1375; //"AlienDomination"

static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MARINE_DISRUPTION_DOMINATION				= 0xa513d543; //"MarineDisruptionDomination"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MARINE_DEATH_MATCH						= 0x0ea031cb; //"MarineDM"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MARINE_HUNT								= 0xe75ce855; //"MarineHunt"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MARINE_INSTANT_ACTION					= 0x605b54d5; //"MarineInstantAction"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MARINE_SPECIES_TEAM_DEATH_MATCH			= 0x4a4ced60; //"MarineSpeciesTeamDM"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MARINE_SURVIVOR							= 0x2124b8b8; //"MarineSurvivor"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MARINE_MIXED_SPECIES_TEAM_DEATH_MATCH	= 0x6e17f509; //"MarineMixedSpeciesTeamDM"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MARINE_DOMINATION						= 0xf13cccb0; //"MarineDomination"

static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATOR_DISRUPTION_DOMINATION			= 0xa2b81df8; //"PredatorDisruptionDomination"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATOR_DEATH_MATCH						= 0x387dadc0; //"PredatorDM"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATOR_HUNT							= 0x0fcb3b0a; //"PredatorHunt"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATOR_SPECIES_TEAM_DEATH_MATCH		= 0xfbc7d64b; //"PredatorSpeciesTeamDM"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATOR_SURVIVOR						= 0xf010a8ed; //"PredatorSurvivor"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATOR_MIXED_SPECIES_TEAM_DEATH_MATCH	= 0x0e30e6fe; //"PredatorMixedSpeciesTeamDM"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREDATOR_DOMINATION						= 0x387dadc0; //"PredatorDM"

// Pickups
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PICKUP              					= 0xC5150A7C; //Asura_GetHashID("Pickup");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PICKUP_WEAPON              			= 0xD0CDC21C; //Asura_GetHashID("Weapon");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PICKUP_AMMO            			    = 0x002DBECE; //Asura_GetHashID("Ammo");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PICKUP_HEALTH              			= 0xB735025C; //Asura_GetHashID("Health");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PICKUP_TOOL              			= 0x00366998; //Asura_GetHashID("Tool");
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PICKUP_AUDIODIARY              		= 0x5C9ABDAD; //Asura_GetHashID("AudioDiary");
//////////////////////////////////////////////////////////////////////////////
//
// Hash IDs for blueprint parameters.
//
// PLEASE: Try to keep these in alphabetical order, so people can quickly see
//         if a hash they need has already been added.
//
//////////////////////////////////////////////////////////////////////////////

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALWAYSRAGDOLL				= 0x5d20de74;	// AlwaysRagdoll

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SKIN						= 0x0035E57D;	// Skin
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CONTAINER_TRAIL				= 0x34274E25;	// ContainerTrail
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MARKERPOINT					= 0x0E875596;	// MarkerPoint
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DEFAULTANIM					= 0xE5FA8FD2;	// DefaultAnim

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FIRSTPERSON_SKIN_MAIN			= 0xFFED3AE1;	//Asura_GetHashID("FirstPerson.Skin.Main")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FIRSTPERSON_SKIN_HEAD			= 0xFFEB0308;	//Asura_GetHashID("FirstPerson.Skin.Head")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FIRSTPERSON_SKIN_ARMS			= 0xFFE806BF;	//Asura_GetHashID("FirstPerson.Skin.Arms")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_THIRDPERSON_SKIN_MAIN			= 0xBE7B9F98;	//Asura_GetHashID("ThirdPerson.Skin.Main")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_THIRDPERSON_SKIN_HEAD			= 0xBE7967BF;	//Asura_GetHashID("ThirdPerson.Skin.Head")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_THIRDPERSON_SKIN_ARMS			= 0xBE766B76;	//Asura_GetHashID("ThirdPerson.Skin.Arms")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_THIRDPERSON_SKIN_DAMAGED_MAIN	= 0xC4D17F61;	//Asura_GetHashID("ThirdPerson.SkinDamaged.Main")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_THIRDPERSON_SKIN_DAMAGED_HEAD	= 0xC4CF4788;	//Asura_GetHashID("ThirdPerson.SkinDamaged.Head")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_THIRDPERSON_SKIN_DAMAGED_ARMS	= 0xC4CC4B3F;	//Asura_GetHashID("ThirdPerson.SkinDamaged.Arms")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DEADCORPSE_REMOVETIME		= 0x31456E31;	//Asura_GetHashID("DeadCorpseRemoveTime")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DEADCORPSE_FADETIME			= 0xDE164829;	//Asura_GetHashID("DeadCorpseFadeTime")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HEADSPLIT_INITIALDELAY		= 0xBAC8FA46;	//Asura_GetHashID("Headsplit.Acid.Delay")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HEADSPLIT_DAMAGEINTERVAL	= 0x53584922;	//Asura_GetHashID("Headsplit.Acid.Interval")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HEADSPLIT_NUMDAMAGES		= 0xB048B2E6;	//Asura_GetHashID("Headsplit.Acid.Number")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HEADSPLIT_RADIUS			= 0xB5FE442F;	//Asura_GetHashID("Headsplit.Acid.Radius")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HEADSPLIT_DAMAGE			= 0x9E1E630C;	//Asura_GetHashID("Headsplit.Acid.Damage")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PFXDAMAGE_TYPE				= 0xA2DB5BD7;	//Asura_GetHashID("PFXDamage.Type")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PFXDAMAGE_INITIALDELAY		= 0x1CE82C5C;	//Asura_GetHashID("PFXDamage.InitialDelay")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PFXDAMAGE_DAMAGEINTERVAL	= 0x6A76FD91;	//Asura_GetHashID("PFXDamage.DamageInterval")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PFXDAMAGE_DAMAGE			= 0x3CD2A4CC;	//Asura_GetHashID("PFXDamage.Damage")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PFXDAMAGE_LIFETIME			= 0x2D4459E6;	//Asura_GetHashID("PFXDamage.Lifetime")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PFXDAMAGE_SCALE				= 0xB877D04D;	//Asura_GetHashID("PFXDamage.Scale")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FATAL_PLASMA_IMPULSE		  = 0xE6CBF64D;	//Asura_GetHashID("FatalPlasma.Impulse")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FATAL_PLASMA_IMPULSE_VARIANCE = 0xF430C0F2;	//Asura_GetHashID("FatalPlasma.Impulse.Variance")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MOVEMENTANIMDURATIONMODIFIER= 0xc29acfab;	// MovementAnimDurationModifier
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ANIMSTATEBLUEPRINTTYPE		= 0xab91672d;	// AnimStateBlueprintType
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ANGLE						= 0x058A78D3;	// Asura_GetHashID( "Angle" )

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ATTACHMENT_CHANCEOFDROPDEATH	= 0xFA35993A; // Asura_GetHashID("ChanceOfDropDeath")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ATTACHMENT_CHANCEOFDROPHEADBIT	= 0x16C5D073; // Asura_GetHashID("ChanceOfDropHeadbit")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ATTACHMENT_DELETEONDEATH		= 0x41CC2BEA; // Asura_GetHashID("DeleteOnDeath")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ATTACHMENT_DELETEONDECAPITATION	= 0xCB8635A3; // Asura_GetHashID("DeleteOnDecapitation")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ATTACHMENT_DROPONDECAPITATION	= 0x94BB57E7; // Asura_GetHashID("DropOnDecapitation")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ATTACHMENT_PHYSICSBLUEPRINT		= 0xDD10E647; // Asura_GetHashID("Physics")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_COLLISION_OBJ_X_MAX			= 0x47E96EC5;	// Asura_GetHashID( "CollisionBoxXMax" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_COLLISION_OBJ_X_MIN			= 0x47E96FB3;	// Asura_GetHashID( "CollisionBoxXMin" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_COLLISION_OBJ_Y_MAX			= 0x47E9E324;	// Asura_GetHashID( "CollisionBoxYMax" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_COLLISION_OBJ_Y_MIN			= 0x47E9E412;	// Asura_GetHashID( "CollisionBoxYMin" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_COLLISION_OBJ_Z_MAX			= 0x47EA5783;	// Asura_GetHashID( "CollisionBoxZMax" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_COLLISION_OBJ_Z_MIN			= 0x47EA5871;	// Asura_GetHashID( "CollisionBoxZMin" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_COLLISIONPROXY				= 0xED23327C;	// CollisionProxy
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DEFAULT_POSTURE				= 0xfceab767;	// DefaultPosture
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DEFAULT_FOV					= 0x287382EC;	// Asura_GetHashID( "DefaultFOV" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DEATHCAM_VISION_MODE		= 0xA453B4A6;	// Asura_GetHashID( "DeathcamVisionMode" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DEFAULT_VISION_MODE			= 0x25FE1A8C;	// Asura_GetHashID( "DefaultVisionMode" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ENERGY						= 0xb2973288;	// Energy			
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_NUMENERGYBLOCKS				= 0xae2b38a6;	// Energy.NumBlocks
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDHUD_INFO_STICKTIME		= 0x62D89A85;	// Asura_GetHashID( "HUD.TargetInfo.StickTime" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FSFX_FADE_TIME				= 0xE839D6A8;	// Asura_GetHashID( "FSFXFadeTime" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FSFX_INTENSITY				= 0x705138B4;	// Asura_GetHashID( "FSFXIntensity" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FSFX_TEMPLATE				= 0x7A1617D9;	// Asura_GetHashID( "FSFXTemplate" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HDR_ADAPTATION_RATE			= 0x1BA140E9;	// Asura_GetHashID( "HDRAdaptationRate" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HDR_ALLOW_TORCH_OVERRIDE	= 0x5af8f095;	// Asura_GetHashID( "HDRAllowTorchOverride" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HDR_BLACK_POINT				= 0xD3C2C467;	// Asura_GetHashID( "HDRBlackPoint" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HDR_DYNAMIC_EXPOSURE		= 0x8DE39090;	// Asura_GetHashID( "HDRDynamicExposure" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HDR_FIXED_LUMINANCE			= 0xC436AC7A;	// Asura_GetHashID( "HDRFixedLuminance" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HDR_MAX_LUMINANCE			= 0x6C0F420A;	// Asura_GetHashID( "HDRMaxLuminance" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HDR_MIN_LUMINANCE			= 0x88566CDC;	// Asura_GetHashID( "HDRMinLuminance" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HDR_REGION_BLX				= 0x16A3E3C4;	// Asura_GetHashID( "HDRRegionBLx" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HDR_REGION_BLY				= 0x16A3E3C5;	// Asura_GetHashID( "HDRRegionBLy" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HDR_REGION_TRX				= 0x16A42810;	// Asura_GetHashID( "HDRRegionTRx" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HDR_REGION_TRY				= 0x16A42811;	// Asura_GetHashID( "HDRRegionTRy" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HDR_SCENE_LUMINANCE			= 0x438C3662;	// Asura_GetHashID( "HDRSceneLuminance" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HDR_WHITE_POINT				= 0x44CD927D;	// Asura_GetHashID( "HDRWhitePoint" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MATERIAL_OVERRIDE			= 0x44A269F3;	// Asura_GetHashID( "MaterialOverride" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_NUMHEALTHBLOCKS				= 0x8c764f7a;	// Health.NumBlocks
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_TAPJUMPVELOCITY				= 0x4248862e;	// TapJumpVelocity
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_STENCIL_ALIEN_SKINS			= 0x8167EAEB;	// Asura_GetHashID( "StencilAlienSkins" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SURFACETYPE_WOUND			= 0xd9d887cc;	// SurfaceType.Wound
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SURFACETYPE_FATAL			= 0xd8e295bd;	// SurfaceType.Fatal
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DISABLE_LIGHTING			= 0x9580FDF4;	// Asura_GetHashID( "DisableLighting" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ZOOM_LEVEL_1_FOV			= 0x301E860D;	// Asura_GetHashID( "ZoomLevel1FOV" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ZOOM_LEVEL_2_FOV			= 0x301EFA6C;	// Asura_GetHashID( "ZoomLevel2FOV" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ZOOM_LEVEL_3_FOV			= 0x301F6ECB;	// Asura_GetHashID( "ZoomLevel3FOV" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ZOOM_SPEED_SCALE			= 0xF0AAD576;	// Asura_GetHashID( "ZoomSpeedScale" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_INNER_TARGETING_RADIUS		= 0xab8c4f6d;	// Asura_GetHashID( "InnerTargetingRadius" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_OUTER_TARGETING_RADIUS		= 0x546b4ea8;	// Asura_GetHashID( "OuterTargetingRadius" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_TORCH						= 0x0696D3FC;	// Asura_GetHashID( "Torch" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FLARE						= 0x05cfefce;	// Asura_GetHashID( "Flare" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_STIM						= 0x00360745;	// Stim
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_BATTERY						= 0xEC41AE0D;	// Battery
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FACE						= 0x002FD65D;	// Face
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHERMONEEMITSGLOW			= 0xD2B10AA2;	// Pheromone.EmitsGlow
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHERMONEGLOWR				= 0x1392E25C;	// Pheromone.Glow.R
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHERMONEGLOWG				= 0x1392E251;	// Pheromone.Glow.G
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHERMONEGLOWB				= 0x1392E24C;	// Pheromone.Glow.B

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_LIGHTFALLEFFECTMINDISTANCE		= 0x1e76862d;	// Landing.JumpLandLightMinFallDist
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_NORMALFALLEFFECTMINDISTANCE		= 0x17a7419c;	// Landing.JumpLandNormalMinFallDist
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HEAVYFALLEFFECTMINDISTANCE		= 0x173141dc;	// Landing.JumpLandHeavyMinFallDist

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_INTERACTIONANIMBLUEPRINT_ALIEN_HUD		= 0x035bb604;	// AnimBlueprint.Alien.HUD
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_INTERACTIONANIMBLUEPRINT_ALIEN_TP		= 0xad8717cf;	// AnimBlueprint.Alien.TP
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_INTERACTIONANIMBLUEPRINT_MARINE_HUD		= 0xfa0b9497;	// AnimBlueprint.Marine.HUD
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_INTERACTIONANIMBLUEPRINT_MARINE_TP		= 0x62e79adc;	// AnimBlueprint.Marine.TP
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_INTERACTIONANIMBLUEPRINT_PREDATOR_HUD	= 0x9512a44c;	// AnimBlueprint.Predator.HUD
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_INTERACTIONANIMBLUEPRINT_PREDATOR_TP	= 0x1d954087;	// AnimBlueprint.Predator.TP

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SRO_ANGLELIMIT_FORWARDS		= 0x194af5f6;	// SurfaceReorientation.AngleLimit.Forwards
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SRO_ANGLELIMIT_SIDEWAYS		= 0x097d1ce3;	// SurfaceReorientation.AngleLimit.Sideways
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SRO_ANGLELIMIT_BACKWARDS	= 0xe3e87648;	// SurfaceReorientation.AngleLimit.Backwards

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_GRAPPLEDIFFICULTIES	= 0x95E01868;	// Asura_GetHashID("GrappleDifficulties");

// Alien-specific parameters since they don't have weapons.
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_GRAPPLESET_CROUCHED	= 0xA44B91E5;	// Asura_GetHashID("GrappleSet_Crouched");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_GRAPPLESET_DOWNED	= 0xBB6639CD;	// Asura_GetHashID("GrappleSet_Downed");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_GRAPPLESET_STANDING	= 0x73E4D258;	// Asura_GetHashID("GrappleSet_Standing");

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MISSIONTIME_HOURS	= 0xC4DDFB3A; // MissionTime.Hours
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MISSIONTIME_MINUTES	= 0x032CF24A; // MissionTime.Minutes
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MISSIONTIME_SECONDS	= 0x39211FEA; // MissionTime.Seconds

//////////////////////////////////////////////////////////////////////////
// Inventory Item BP Parameters
//////////////////////////////////////////////////////////////////////////
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SUBTYPE						= 0x90af2d7a;	// Asura_GetHashID( "SubType" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_IMAGE_NOTSELECTED			= 0xe4e94a5b;	// Image.NotSelected
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_IMAGE_SELECTED				= 0x506091ce;	// Image.Selected
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_IMAGE_NOTSELECTED_EMPTY		= 0x3E69EF34;	// Image.EmptyNotSelected
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_IMAGE_SELECTED_EMPTY		= 0xF980C395;	// Image.EmptySelected
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_IMAGE_UNSELECTABLE			= 0xab891d62;	// Image.Unselectable
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_WEAPONSELECTOR_INDEX		= 0x3A1F4C22;	// HUD.DisplayConditionIndex
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP           			= 0xC5150A7C;	// Pickup

// Cloak parameters
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CLOAK_DRAIN					= 0x93E19C70;	// EnergyDrain
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CLOAK_DRAINWALKING			= 0x698A4B09;	// EnergyDrainWalking
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CLOAK_DRAINRUNNING			= 0x83499B4F;	// EnergyDrainRunning
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CLOAK_DRAINSPRINTING		= 0x2F888918;	// EnergyDrainSprinting
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CLOAK_DRAINCROUCHING		= 0x302af178;	// EnergyDrainCrouching
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CLOAK_VISIBILITYDISTANCE	= 0x52A4BD07;	// VisibilityDistance
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CLOAK_VISIBILITYANGLE		= 0x82113101;	// VisibilityAngle

// Weapon parameters
static const char* const szAVP_BLUEPRINT_ENUMERATIONNAME_WEAPON					= "Weapon";
static u_int uAVP_BLUEPRINT_ENUMERATIONDIGITS_WEAPON							= 2;
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAMHASH_DEFAULTWEAPON				= 0x769E239D;	// DefaultWeapon

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_AI_ACTOR_ANIM_ACTIVATION		= 0x307a2df4;	// AIActorAnimActivation
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_AI_ACTOR_ANIM_DEACTIVATION		= 0x7ae18db5;	// AIActorAnimDeactivation
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ANIMSTATE_BLUEPRINT_HUD				= 0x46a79329;	// AnimState.HUD
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ANIMSTATE_BLUEPRINT_TP				= 0xe3c6e3ae;	// AnimState.ThirdPerson
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ANIMSTATE_BLUEPRINT_TP_AIMING		= 0xe42fbebd;	// AnimState.ThirdPerson.Aiming
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ANIMSTATE_BLUEPRINT_TP_NEUTRAL		= 0x4b1b8387;	// AnimState.ThirdPerson.Neutral
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ANIMSTATE_BLUEPRINT_TP_LOWCOVER		= 0x5c09f723;	// AnimState.ThirdPerson.LowCover
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ANIMSTATE_BLUEPRINT_TP_MIDCOVER		= 0x51d5ab22;	// AnimState.ThirdPerson.MediumCover
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ANIMSTATE_BLUEPRINT_TP_HIGHCOVER	= 0x1e54a115;	// AnimState.ThirdPerson.HighCover
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PLAYER_ACTOR_ANIM_ACTIVATION_FIRST_PERSON	= 0xE1C9C08A;	// PlayerActorAnimActivationFirstPerson
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PLAYER_ACTOR_ANIM_ACTIVATION_THIRD_PERSON	= 0x25554E01;	// PlayerActorAnimActivationThirdPerson
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PLAYER_ACTOR_ANIM_DEACTIVATION_FIRST_PERSON	= 0x9CBAFC73;	// PlayerActorAnimDeactivationFirstPerson
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PLAYER_ACTOR_ANIM_DEACTIVATION_THIRD_PERSON	= 0x6c8b9c9c;	// PlayerActorAnimDeactivationThirdPerson
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_WEAPON_BULLETBY_SOUND			= 0x57FE2FD6;	// BulletBySound
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_NUM_MAX_CLICKS					= 0xF873F64F;	// MaxClicks
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CLICK_SOUND_HASH				= 0x8AE88296;	// ClickHash
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_WEAPON_ANIM_ACTIVATION			= 0x18cf8303;	// WeaponAnimActivation
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_WEAPON_ANIM_DEACTIVATION		= 0xa335db04;	// WeaponAnimDeactivation
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_WEAPON_ANIM_REST				= 0x98099381;	// WeaponAnimRest
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_WEAPON_TYPE						= 0x51dde356;	// WeaponType
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_WEAPON_PERMENANT_ANIM			= 0x567D3021;	// WeaponAnimPermenant
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ADS_FOV_DECREASE				= 0xedb831bb;	// ADSFOVDecrease
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ADS_NEAR_CLIP_PLANE				= 0x9fa7a028;	// ADSNearClip
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_USES_LOCKON						= 0xbe281716;	// UsesLockOn
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_LOCKON_RANGE					= 0x2fe52333;	// LockOnRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_LOCKON_TIME						= 0x64a55217;	// LockOnTime
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SPREAD_HEAT_UP					= 0x9e05efbe;	// SpreadHeatUp
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MIN_SPREAD						= 0x42091245;	// MinSpread
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MAX_SPREAD						= 0x13fdfbd7;	// MaxSpread
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SPREAD_COOLDOWNDELAY			= 0x12f4de65;	// SpreadCoolDownDelay
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_NUM_PROJ_PER_SHOT				= 0xbdf7c4b3;	// NumProjectilesPerShot
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_AMMOTYPE						= 0xA2AC3708;	// AmmoType
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CLOAKED_ENERGY_COST				= 0x20f01404;	// CloakedEnergyCost
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_WEAPON_SLOTINDEX				= 0xc1ca08a0;	// FixedSlotIndex
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_BURST_SIZE						= 0x95783921;	// BurstSize
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_AMMO_PER_SHOT					= 0x0C550F7E;	// AmmoUsePerShot
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ANIM_PLAYER_CONSOLE_OPEN		= 0xa73cd311;	// Anim.Player.Console.Open
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ANIM_AI_CONSOLE_OPEN			= 0x558fb6aa;	// Anim.AI.Console.Open
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ANIM_PLAYER_CONSOLE_CLOSE		= 0x3fb2ca11;	// Anim.Player.Console.Close
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ANIM_AI_CONSOLE_CLOSE			= 0x5bbc5998;	// Anim.AI.Console.Close
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ANIM_PLAYER_STIM				= 0xc6bc31d5;	// Anim.Player.Stim
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ANIM_AI_STIM					= 0xa374be6e;	// Anim.AI.Stim
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_WEAPONRECOILRETURNTIME			= 0xbcbfee29;	// Recoil.ReturnTime
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_WEAPONRECOILHORIZONTAL			= 0xbfb30250;	// Recoil.Horizontal
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_WEAPONRECOILVERTICAL			= 0x01b978a2;	// Recoil.Vertical
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_RECOILUPDOWNFACTOR				= 0x3a410078;	// Recoil.UpDownFactor
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MIN_BURST_FIRE_SHOTS			= 0x38928185;   // BurstFire.Min.Shots
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MAX_BURST_FIRE_SHOTS			= 0x0a876b17;   // BurstFire.Max.Shots
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MIN_AI_BURST_FIRE_GAP			= 0x61d0170c;	// BurstFire.AI.Min.Gap
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MAX_AI_BURST_FIRE_GAP			= 0x54b63d1e;	// BurstFire.AI.Max.Gap
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_AI_MIN_FIRE_TIME				= 0xb2ddbd2d;	//"AIMinFireTime"
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_AI_MAX_FIRE_TIME				= 0xdb3e8a3f;	//"AIMaxFireTime"
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_GRAPPLESET						= 0x965234B3;	// Asura_GetHashID("GrappleSet");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_LOCKON_PFX_BP					= 0xB6D30E5B;	// LockOnEffect

// Tool params
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_TOOL_TYPE						= 0xC56E6CD2;	// ToolType

// RangedWeapon parameters
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SUBTYPE_PRIMARY				= 0x2CFDB57E;	// SubTypePrimaryFire
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SUBTYPE_SECONDARY			= 0xB00A9670;	// SubTypeSecondaryFire
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SPREAD_COOL_DOWN			= 0x554cd5de;	// SpreadCoolDown
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_WEAPON_ANIM_RELOAD			= 0xbbef8206;	// WeaponAnimReload
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_NUM_TAGS					= 0x88caac9f;	// NumTags
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_AIMING_FSFX					= 0x0EC4705C;	// AimingFSFX
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_INTO_SCOPE_ANIM				= 0x010D7C05;	// IntoScopeAnim
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_OUTOF_SCOPE_ANIM			= 0xCD799E60;	// OutofScopeAnim
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_AMMOCOUNTER_MARKER1			= 0x810AA8B7;	// AmmoCounter.Marker1
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_AMMOCOUNTER_MARKER2			= 0x810AA8B8;	// AmmoCounter.Marker2
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_AMMOCOUNTER_ATTACHMENT		= 0xFFF4B3A3;	// AmmoCounter.Attachment



// SubType parameters
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MAXQUANTITY					= 0x28B065EF;	// MaxQuantity
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_INITIALQUANTITY				= 0x1A7037CF;	// InitialQuantity

// WeaponSubType parameters
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DAMAGEAMOUNT				= 0xF3684C87;	// DamageAmount
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_AUTORELOAD_ENABLE			= 0x8CB0C66D;	// ForceReload.Enable
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_AUTORELOAD_WHENAMMOFALLTO	= 0x50FA6128;	// ForceReload.WhenAmmoFallTo
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_IMPULSESTRENGTH				= 0x5B2F3036;	// ImpulseStrength
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MAXRANGE					= 0x19565259;	// MaxRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_RATEOFFIRE					= 0xAAB7656D;	// RateOfFire
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HASCROSSHAIR				= 0x9b23f2c8;	// HasCrossHair

// RangedWeaponSubType parameters
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SOUND_FIRE_BEGIN			= 0xBBAAEC04;	// SoundFireBegin
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SOUND_FIRE_LOOP				= 0x4822FBE9;	// SoundFireLoop
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SOUND_FIRE_END				= 0xC04316F6;	// SoundFireEnd
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SOUND_CHARGING				= 0xbf4bac80;	// SoundCharging
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_BEAMTYPE					= 0x4EC53369;	// BeamType
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PFX_CHARGING				= 0x2d29ed9d;	// PFX.Charging
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CAMERASHAKE					= 0x27B6127F;	// RecoilCameraShake
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MARKERPOINT_MUZZLE_HUD		= 0x1CB5222C;	// MuzzleMarkerPoint.FirstPerson
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MARKERPOINT_MUZZLE_THIRD	= 0x6040AFA3;	// MuzzleMarkerPoint.ThirdPerson
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PROJECTILETYPE				= 0x3E123CA3;	// ProjectileType
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_IS_FULL_AUTO				= 0x1C3963E8;	// IsFullAuto
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_IS_CHARGED_SHOT				= 0x85B86BC0;	// IsChargedShot
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_USES_DYNAMIC_AMMO			= 0x0702e441;	// UsesDynamicAmmo
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MAXCHARGEPERSHOT			= 0x02571d7f;	// MaxChargePerShot
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MINCHARGEPERSHOT			= 0xfe888f51;	// MinChargePerShot
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CHARGEPERSECOND				= 0xc9fb939d;	// ChargePerSecond
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DAMAGEMULTIPLIERPERCHARGE	= 0xdadbbda1;	// DamageMultiplierPerCharge
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PERM_REMOVE_CHARGE			= 0x6e8e8704;	// PermanentlyLoseCharge
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MUZZLEFLASH_FIRE_1P			= 0x802D7858;	// MuzzleFlash.Fire.1P
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MUZZLEFLASH_FIRE_3P			= 0x802D7896;	// MuzzleFlash.Fire.3P
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MUZZLEFLASH_HOT_1P			= 0xBD8E443F;	// MuzzleFlash.Hot.1P
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MUZZLEFLASH_HOT_3P			= 0xBD8E447D;	// MuzzleFlash.Hot.3P
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MUZZLEFLASH_HOT_NBTP		= 0xA394E752;	// MuzzleFlash.Hot.NBulletsToPlay
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MUZZLEFLASH_RELOAD_1P		= 0x54F141D5;	// MuzzleFlash.Reload.1P
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MUZZLEFLASH_RELOAD_3P		= 0x54F14213;	// MuzzleFlash.Reload.3P



// Beam template parameters
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DECAYRATE					= 0x07FF779A;	// DecayRate
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ENDFARCOLOUR				= 0x1D669928;	// EndFarColour
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ENDNEARCOLOUR				= 0xA201FB0F;	// EndNearColour
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ENDRADIUS					= 0x93BEA52D;	// EndRadius
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FARSPEED					= 0x3805CB90;	// FarSpeed
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HACKEDALPHA					= 0x5D54D9DE;	// HackedAlpha
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_INITFARCOLOUR				= 0x274DF0DF;	// InitialFarColour
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_INITNEARCOLOUR				= 0xD5059A38;	// InitialNearColour
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_INITRADIUS					= 0x2ABA40D6;	// InitialRadius
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_NEARSPEED					= 0x858C511F;	// NearSpeed
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_TEXTURETILE					= 0x603E2249;	// TextureTile

// Predator/Predalien jump parameters (selected per-weapon)
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_TARGETEDJUMPSET				= 0xD2EF4584;	// Asura_GetHashID("TargetedJumpSet")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MAXDISTANCE					= 0x86798D59;	// Asura_GetHashID("MaxDistance")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HEIGHTCHANGE				= 0x92B1EB97;	// Asura_GetHashID("HeightChange")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HEADROOM					= 0xBD8C5EBB;	// Asura_GetHashID("Headroom")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FIRSTPERSONANIM				= 0xBCA4E196;	// Asura_GetHashID("FirstPersonAnim")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_THIRDPERSONANIM				= 0x0C2EDB8D;	// Asura_GetHashID("ThirdPersonAnim")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_THIRDPERSONANIM_RUN			= 0xc0e117de;	// Asura_GetHashID("ThirdPersonAnimRun")

// Alien Jump over parameters
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_JUMPOVERSET					= 0x9eddfb20;   // Asura_GetHashID("JumpOverSet")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_NOMINALDISTANCE				= 0x6941b8d1;   // Asura_GetHashID("NominalDistance")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_P1_HORIZONTAL				= 0xe6212a71;   // Asura_GetHashID("P1.Horizontal")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_P1_VERTICAL_LOW				= 0x64c387e9;   // Asura_GetHashID("P1.Vertical.Low")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_P1_VERTICAL_HIGH			= 0x33ab8bad;   // Asura_GetHashID("P1.Vertical.High")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_P2_HORIZONTAL				= 0xedd2cfd0;   // Asura_GetHashID("P2.Horizontal")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_P2_VERTICAL_LOW				= 0x64c387e9;   // Asura_GetHashID("P2.Vertical.Low")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_P2_VERTICAL_HIGH			= 0x33ab8bad;   // Asura_GetHashID("P2.Vertical.High")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREFERENCE					= 0xa8fcbcdb;   // Asura_GetHashID("Preference")


// Vision mode parameters
static const char* const szAVP_BLUEPRINT_ENUMERATIONNAME_VISIONMODE			= "VisionMode";
static u_int uAVP_BLUEPRINT_ENUMERATIONDIGITS_VISIONMODE					= 2;

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DISABLESMOTIONTRACKER		= 0xFB139E17;	// Asura_GetHashID( "DisablesMotionTracker" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DISABLESTORCH				= 0x04767851;	// Asura_GetHashID( "DisablesTorch" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FOCUSLOCKMULTALIEN			= 0x3bdd7543;	// Asura_GetHashID( "FocusLockMultiplierAlien" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FOCUSLOCKMULTANDROID		= 0xbd7e65eb;	// Asura_GetHashID( "FocusLockMultiplierAndroid" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FOCUSLOCKMULTHUMAN			= 0x3c443fa9;	// Asura_GetHashID( "FocusLockMultiplierHuman" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FOCUSLOCKMULTPREDATOR		= 0xdd0242fb;	// Asura_GetHashID( "FocusLockMultiplierPredator" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_BUSTEDVISION				= 0x57eea0ff;	// Asura_GetHashID( "DisruptedVisionMode" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DSP          				= 0x000185C1;	// Asura_GetHashID( "DSP" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_TARGETGLOW_R				= 0x01768D22;	// Asura_GetHashID( "TargetGlow.R" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_TARGETGLOW_G				= 0x01768D17;	// Asura_GetHashID( "TargetGlow.G" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_TARGETGLOW_B				= 0x01768D12;	// Asura_GetHashID( "TargetGlow.B" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_LASERCOLOUR_R				= 0xAE4C449B;	// Asura_GetHashID( "LaserColour.R" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_LASERCOLOUR_G				= 0xAE4C4490;	// Asura_GetHashID( "LaserColour.G" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_LASERCOLOUR_B				= 0xAE4C448B;	// Asura_GetHashID( "LaserColour.B" )

// Landing data
static const char* const szAVP_BLUEPRINT_PARAM_LANDING_ANIMFIRSTPERSON	= "Landing.HUD.";
static const char* const szAVP_BLUEPRINT_PARAM_LANDING_ANIMTHIRDPERSON	= "Landing.ThirdPerson.";
static const char* const szAVP_BLUEPRINT_PARAM_LANDING_DAMAGE			= "Landing.Damage.";
static const char* const szAVP_BLUEPRINT_PARAM_LANDING_MINFALLDISTANCE	= "Landing.MinDistance.";

// Mantling data
static const char* const szAVP_BLUEPRINT_PARAM_MANTLE				= "Mantle";
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MANTLE_MAXHEIGHT	= 0x00999B8B;	// Asura_GetHashID("MaxHeight");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MANTLE_REQUIRESJUMP	= 0xB3DAE86E;	// Asura_GetHashID("RequiresJumpInput");

// Fidget idle animations
static const char* const szAVP_BLUEPRINT_ENUMERATIONNAME_IDLEANIM_NAME_ANIM	= "Anim.";

//////////////////////////////////////////////////////////////////////////
// Grapple parameters
//////////////////////////////////////////////////////////////////////////
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLESET_ALIEN_AIPOUNCE				= 0xEB8D67DA;	// Asura_GetHashID("Alien_AIPounce");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLESET_ALIEN_INJURED				= 0xC7858BE9;	// Asura_GetHashID("Alien_Injured");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLESET_PREDATOR_FRONT				= 0xF92E1480;	// Asura_GetHashID("Predator_TrophyKill_Front");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLESET_PREDATOR_BACK				= 0xC5F727B0;	// Asura_GetHashID("Predator_TrophyKill_Back");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLESET_PREDATOR_COUNTER_LEFTCLAW	= 0x5A501E11;	// Asura_GetHashID("Predator_Counter_ClawLeft");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLESET_PREDATOR_COUNTER_RIGHTCLAW	= 0xF00A0552;	// Asura_GetHashID("Predator_Counter_ClawRight");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDESCRIPTION_ANIMSET				= 0x45F8C25E;	// Asura_GetHashID("AnimationSet");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDESCRIPTION_DAMAGE				= 0xB02E8B6F;	// Asura_GetHashID("Damage");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDESCRIPTION_DIFFICULTY_ATTACKER	= 0x612C0945;	// Asura_GetHashID("Attacker_Difficulty");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDESCRIPTION_DIFFICULTY_VICTIM	= 0x93C529D2;	// Asura_GetHashID("Victim_Difficulty");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDESCRIPTION_SOUNDSET_ATTACKER	= 0x7B0A10FD;	// Asura_GetHashID("Attacker_SoundSet");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDESCRIPTION_SOUNDSET_VICTIM		= 0x4A9BF0CA;	// Asura_GetHashID("Victim_SoundSet");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_ACTIVEGRAPPLE_CRITICALSUCCESS_START= 0x107FC578;	// Asura_GetHashID("CriticalSuccess.Start");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_ACTIVEGRAPPLE_CRITICALSUCCESS_END	= 0xE44FD771;	// Asura_GetHashID("CriticalSuccess.End");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_ACTIVEGRAPPLE_SUCCESS_START		= 0xF781A2B7;	// Asura_GetHashID("Success.Start");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_ACTIVEGRAPPLE_SUCCESS_END			= 0xB455F870;	// Asura_GetHashID("Success.End");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_ACTIVEGRAPPLE_DURATION				= 0x89444D94;	// Asura_GetHashID("Duration");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_ACTIVEGRAPPLE_INITIALDELAY			= 0xFCCDA542;	// Asura_GetHashID("SliderDelay");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_ACTIVEGRAPPLE_COMPLETEDDELAY		= 0x04222E52;	// Asura_GetHashID("ResultDisplayTime");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_ACTIVEGRAPPLE_SOUND_GRAPPLESTART	= 0x5BEE3EF2;	// Asura_GetHashID("Sound.GrappleStart");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_ACTIVEGRAPPLE_SOUND_MARKERSTART	= 0xD4D8D5AC;	// Asura_GetHashID("Sound.ActivateMarker");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_ACTIVEGRAPPLE_SOUND_WIN			= 0x93E65E7D;	// Asura_GetHashID("Sound.Win");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_ACTIVEGRAPPLE_SOUND_LOSE			= 0xE8E08894;	// Asura_GetHashID("Sound.Lose");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMSET_ATTACKER_HUD		= 0x95D1C8F0;	// Asura_GetHashID("Attacker_Anims_HUD");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMSET_ATTACKER_TP			= 0xE3CCF763;	// Asura_GetHashID("Attacker_Anims_TP");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMSET_VICTIM_HUD			= 0xB87BE2C3;	// Asura_GetHashID("Victim_Anims_HUD");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMSET_VICTIM_TP			= 0xB35ED730;	// Asura_GetHashID("Victim_Anims_TP");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMSET_FORWARDOFFSET		= 0x74D7AB5D;	// Asura_GetHashID("InitialOffset_Forward");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMSET_UPOFFSET			= 0x0514F703;	// Asura_GetHashID("InitialOffset_Up");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMSET_FRONTATTACK			= 0x64F22C9F;	// Asura_GetHashID("IsFaceToFace");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMS_START					= 0x068AC462;	// Asura_GetHashID("Start");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMS_WIN					= 0x646D1EAA;	// Asura_GetHashID("Win_Normal");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMS_CRITICALWIN			= 0x16B074A2;	// Asura_GetHashID("Win_Critical");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMS_LOSE					= 0xB65EC151;	// Asura_GetHashID("Lose_Normal");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMS_CRITICALLOSE			= 0xB2C40989;	// Asura_GetHashID("Lose_Critical");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMS_START_EVENT			= 0x1BA1A230;	// Asura_GetHashID("Start_Event_Entry");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMS_WIN_EVENT				= 0xDBA6D078;	// Asura_GetHashID("Win_Normal_Event_Entry");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMS_CRITICALWIN_EVENT		= 0xD180F270;	// Asura_GetHashID("Win_Critical_Event_Entry");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMS_LOSE_EVENT			= 0x4DAEB09F;	// Asura_GetHashID("Lose_Normal_Event_Entry");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEANIMS_CRITICALLOSE_EVENT	= 0xE11164D7;	// Asura_GetHashID("Lose_Critical_Event_Entry");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTENTRY_EVENTDATA		= 0x01E68544;	// Asura_GetHashID("EventData");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTENTRY_STARTFRAME		= 0xA4A526A5;	// Asura_GetHashID("StartPoint_FrameNumber");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTENTRY_STARTANIMFLAG	= 0x15A4DFAE;	// Asura_GetHashID("StartPoint_AnimFlag");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTENTRY_ENDFRAME			= 0xA002C34C;	// Asura_GetHashID("EndPoint_FrameNumber");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTENTRY_ENDANIMFLAG		= 0xBEA9DC67;	// Asura_GetHashID("EndPoint_AnimFlag");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_TYPE				= 0x00368F3A;	// Asura_GetHashID("Type");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_MARKERPOINT		= 0x0E875596;	// Asura_GetHashID("MarkerPoint");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_SKINELEMENT		= 0x0D2482DF;	// Asura_GetHashID("SkinElement");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_GIBANIMATION		= 0xF10F43C4;	// Asura_GetHashID("GibAnimation");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_RAGDOLLDIR_RT		= 0x23AC2F99;	// Asura_GetHashID("RagdollDirection_Right");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_RAGDOLLDIR_DN		= 0x22289385;	// Asura_GetHashID("RagdollDirection_Down");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_RAGDOLLDIR_FW		= 0x79729502;	// Asura_GetHashID("RagdollDirection_Forward");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_RAGDOLLDIR_CONE	= 0x38022E8D;	// Asura_GetHashID("RagdollDirection_ConeAngle");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_RAGDOLLIMPULSE	= 0xF4BE1032;	// Asura_GetHashID("RagdollImpulse");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_GIBDIR_RT			= 0x073F499C;	// Asura_GetHashID("GibDirection_Right");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_GIBDIR_DN			= 0x8C98AD22;	// Asura_GetHashID("GibDirection_Down");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_GIBDIR_FW			= 0xC4A73A45;	// Asura_GetHashID("GibDirection_Forward");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_GIBDIR_CONE		= 0x88A28F10;	// Asura_GetHashID("GibDirection_ConeAngle");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_GIBIMPULSE		= 0x50A0DD35;	// Asura_GetHashID("GibImpulse");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_PFXEFFECT			= 0xBFBAF153;	// Asura_GetHashID("PFXEffect");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_ATTACHTOMARKER	= 0x052B73BA;	// Asura_GetHashID("AttachToMarker");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_CAMERAOFFSET_RT	= 0x3DC1C315;	// Asura_GetHashID("CameraOffset_Right");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_CAMERAOFFSET_DN	= 0x7594A089;	// Asura_GetHashID("CameraOffset_Down");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_CAMERAOFFSET_FW	= 0x6471397E;	// Asura_GetHashID("CameraOffset_Forward");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_COLOUR_RED		= 0x52FFDF9E;	// Asura_GetHashID("Colour_Red");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_COLOUR_GREEN		= 0x91F166D0;	// Asura_GetHashID("Colour_Green");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_COLOUR_BLUE		= 0x0CF4EAED;	// Asura_GetHashID("Colour_Blue");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_FADEIN			= 0x48643F5C;	// Asura_GetHashID("Fade_InDuration");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_FADEOUT			= 0x0883299F;	// Asura_GetHashID("Fade_OutDuration");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_POWER				= 0x065E8905;	// Asura_GetHashID("Power");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEEVENTDATA_RANGE				= 0x0674393D;	// Asura_GetHashID("Range");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDAMAGE_ATTACKERWIN_AMOUNT			= 0x31614DED;	// Asura_GetHashID("Attacker_Damage_Normal");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDAMAGE_ATTACKERWIN_TYPE				= 0x18B5BDF3;	// Asura_GetHashID("Attacker_DamageType_Normal");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDAMAGE_ATTACKERCRITICALWIN_AMOUNT	= 0x7755DF25;	// Asura_GetHashID("Attacker_Damage_Critical");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDAMAGE_ATTACKERCRITICALWIN_TYPE		= 0xDB4E65AB;	// Asura_GetHashID("Attacker_DamageType_Critical");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDAMAGE_ATTACKERMULTIPLIER			= 0xEFF8FFCA;	// Asura_GetHashID("Attacker_HitMultiplier");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDAMAGE_VICTIMWIN_AMOUNT				= 0x5AF44640;	// Asura_GetHashID("Victim_Damage_Normal");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDAMAGE_VICTIMWIN_TYPE				= 0xD49E54C6;	// Asura_GetHashID("Victim_DamageType_Normal");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDAMAGE_VICTIMCRITICALWIN_AMOUNT		= 0x880C0EB8;	// Asura_GetHashID("Victim_Damage_Critical");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDAMAGE_VICTIMCRITICALWIN_TYPE		= 0x3F6C93BE;	// Asura_GetHashID("Victim_DamageType_Critical");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDAMAGE_VICTIMMULTIPLIER				= 0x198BF81D;	// Asura_GetHashID("Victim_HitMultiplier");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLEDIFFICULTIES_DIFFICULTY		= 0x6D0BF7BB;	// Asura_GetHashID("Difficulty");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLESOUNDS_GRAPPLESTART			= 0x4A9E6C73;	// Asura_GetHashID("GrappleStart");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLESOUNDS_MARKERSTART			= 0xD833A6ED;	// Asura_GetHashID("ActivateMarker");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLESOUNDS_WIN					= 0x0001CBDC;	// Asura_GetHashID("Win");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_GRAPPLESOUNDS_LOSE					= 0x0032C715;	// Asura_GetHashID("Lose");

//////////////////////////////////////////////////////////////////////////
// Player BP Parameters...
//////////////////////////////////////////////////////////////////////////

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_BREATHING_SOUND	= 0xC4B6FFA3;	// Asura_GetHashID("Breathing.Sound");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_INCREASEHEALTH_FSFX				= 0x3815CF2F;	// Asura_GetHashID("IncreaseHealth.FSFX");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_INCREASEHEALTH_FSFXSTRENGTH		= 0x4C2C8070;	// Asura_GetHashID("IncreaseHealth.FSFXStrength");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_INCREASEHEALTH_FSFXATTACKDURATION	= 0x635C84CB;	// Asura_GetHashID("IncreaseHealth.FSFXAttackDuration");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_INCREASEHEALTH_FSFXSUSTAINDURATION	= 0x6C35E9A8;	// Asura_GetHashID("IncreaseHealth.FSFXSustainDuration");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_INCREASEHEALTH_FSFXDECAYDURATION	= 0x15F1207F;	// Asura_GetHashID("IncreaseHealth.FSFXDecayDuration");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_DAMAGE_FSFX						= 0x2E52957E;	// Asura_GetHashID("Damage.FSFX");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_DAMAGE_FSFXSTRENGTH				= 0xF56187BF;	// Asura_GetHashID("Damage.FSFXStrength");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_DAMAGE_FSFXATTACKDURATION			= 0x2F7C94DA;	// Asura_GetHashID("Damage.FSFXAttackDuration");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_DAMAGE_FSFXSUSTAINDURATION			= 0x2417DB79;	// Asura_GetHashID("Damage.FSFXSustainDuration");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_DAMAGE_FSFXDECAYDURATION			= 0x5E975290;	// Asura_GetHashID("Damage.FSFXDecayDuration");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_DAMAGE_PFX_ACID					= 0xC7CC8FA8;	// Asura_GetHashID("Hud.Acid.PFX");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_DAMAGE_FSFX_ACID					= 0x31C108B9;	// Asura_GetHashID("Hud.Acid.FSFX");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_DAMAGE_FSFXSTRENGTH_ACID			= 0x94728FFA;	// Asura_GetHashID("Hud.Acid.FSFXStrength");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_DAMAGE_FSFXATTACKDURATION_ACID		= 0xE0B744D5;	// Asura_GetHashID("Hud.Acid.FSFXAttackDuration");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_DAMAGE_FSFXSUSTAINDURATION_ACID	= 0x9A332ADE;	// Asura_GetHashID("Hud.Acid.FSFXSustainDuration");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_DAMAGE_FSFXDECAYDURATION_ACID		= 0x8D993735;	// Asura_GetHashID("Hud.Acid.FSFXDecayDuration");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_HEALTH1_SOUNDMIXERPRESET			= 0xFAA39B32;	// Asura_GetHashID("Health1.SoundMixerPreset");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_HEALTH1_FSFX						= 0xE0FE9758;	// Asura_GetHashID("Health1.FSFX");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_HEALTH1_FSFXSTRENGTH				= 0xC2C30F99;	// Asura_GetHashID("Health1.FSFXStrength");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_HEALTH1_PARAMETRIC   				= 0xA2490FC9;	// Asura_GetHashID("Health1.Parametric");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_HEALTH2_SOUNDMIXERPRESET			= 0xBF357D51;	// Asura_GetHashID("Health2.SoundMixerPreset");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_HEALTH2_FSFX						= 0xE2B36FF7;	// Asura_GetHashID("Health2.FSFX");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_HEALTH2_FSFXSTRENGTH				= 0xA4A0D938;	// Asura_GetHashID("Health2.FSFXStrength");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_HEALTH2_PARAMETRIC   				= 0xA9FAB528;	// Asura_GetHashID("Health2.Parametric");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_HEALTH3_SOUNDMIXERPRESET			= 0x83C75F70;	// Asura_GetHashID("Health3.SoundMixerPreset");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_HEALTH3_FSFX						= 0xE4684896;	// Asura_GetHashID("Health3.FSFX");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_HEALTH3_FSFXSTRENGTH				= 0x867EA2D7;	// Asura_GetHashID("Health3.FSFXStrength");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_HEALTH3_PARAMETRIC   				= 0xB1AC5A87;	// Asura_GetHashID("Health3.Parametric");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_PAUSE_FSFX          				= 0xFA777757;	// Asura_GetHashID("Pause.FSFX");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_PAUSE_FADETIME        				= 0xBC3EAC41;	// Asura_GetHashID("Pause.FadeTime");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_DEATH_FSFX							= 0xF4852999;	// Asura_GetHashID("Death.FSFX");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_DEATH_FSFXSTRENGTH					= 0x9CF7D0DA;	// Asura_GetHashID("Death.FSFXStrength");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_DEATH_FSFXFADEDURATION				= 0xCDC27429;	// Asura_GetHashID("Death.FSFXFadeDuration");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_FOCUS_FSFX			= 0xBF3245B5;	// Asura_GetHashID("Focus.FSFX");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_FOCUS_SOUND_BEGIN	= 0xA58B6EF4;	// Asura_GetHashID("Focus.Sound.Begin");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_FOCUS_SOUND_END	= 0xD94795E6;	// Asura_GetHashID("Focus.Sound.End");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_FOCUS_SOUND_LOOP	= 0x4FAE5AF9;	// Asura_GetHashID("Focus.Sound.Loop");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_TARGETINFO_SOUND_BEGIN	= 0xD9879D5B;	// Asura_GetHashID("TargetInfo.Sound.Begin");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_TARGETINFO_SOUND_LOOP	= 0x1FCF43B2;	// Asura_GetHashID("TargetInfo.Sound.Loop");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_TARGETINFO_SOUND_END	= 0xCF7A320D;	// Asura_GetHashID("TargetInfo.Sound.End");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_SPRINT_FSFX		= 0xE84A91B3;	// Asura_GetHashID("Sprint.FSFX");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_SPRINT_SOUND_BEGIN	= 0x9B034936;	// Asura_GetHashID("Sprint.Sound.Begin");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_SPRINT_SOUND_END	= 0x4C1518A8;	// Asura_GetHashID("Sprint.Sound.End");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_SPRINT_SOUND_LOOP	= 0x36913077;	// Asura_GetHashID("Sprint.Sound.Loop");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_SELECTOR_SOUND_OPEN	= 0x7CFEFEF9;	// Asura_GetHashID("Selector.Open");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_SELECTOR_SOUND_CANCEL	= 0xA7AE88DF;	// Asura_GetHashID("Selector.Close.Cancel");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_SELECTOR_SOUND_ACCEPT	= 0xA45C0F6D;	// Asura_GetHashID("Selector.Close.Accept");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_SELECTOR_SOUND_CHANGE	= 0x244E7C9F;	// Asura_GetHashID("Selector.Change");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_SPRINT_TIME		= 0xe850ca21;	// Sprint.Time
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_SPRINT_CHARGE_TIME	= 0xa245a3d5;	// Sprint.ChargeTime

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_MELEEJUMP_FSFX			= 0xC964212B;	// Asura_GetHashID("MeleeJump.FSFX");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_MELEEJUMP_SOUND_LOOP	= 0x87EF45EF;	// Asura_GetHashID("MeleeJump.Sound.Loop");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_TARGETEDJUMP_FSFX			= 0xD0681C2F;	// Asura_GetHashID("TargetedJump.FSFX");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_TARGETEDJUMP_SOUND_LOOP	= 0x9063EDF3;	// Asura_GetHashID("TargetedJump.Sound.Loop");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_ZOOM_FSFX			= 0x5FCB9B9A;	// Asura_GetHashID("Zoom.FSFX");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_ZOOM_SOUND_ZOOMIN	= 0x8712FC32;	// Asura_GetHashID("Zoom.Sound.ZoomIn");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_ZOOM_SOUND_ZOOMOUT	= 0x5B4CA1E1;	// Asura_GetHashID("Zoom.Sound.ZoomOut");

static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_HITBYPLASMA_FADETIME = 0x7446A981;  // Asura_GetHashID("Damage.HitByPlasmaDuration");
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_HITBYACID_FADETIME = 0x9BD040BC; // Asura_GetHashID("Damage.HitByAcidDuration");

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SPRINTFOVDECREASE	= 0x020f87f9;	// FOV.SprintDecrease
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SPRINTFOVFADEIN		= 0x1389e389;	// FOV.SprintFadeInTime
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SPRINTFOVFADEOUT	= 0xa70ecfe4;	// FOV.SprintFadeOutTime

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HUDSTATE_FADETIME	= 0xE7E48223;	// HUD.StateFadeTime

//////////////////////////////////////////////////////////////////////////
// Projectile BP Parameters
//////////////////////////////////////////////////////////////////////////

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ANGULARDRAG					= 0x80E16918;	// AngularDrag
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DOBALLISTICADJUSTMENT		= 0x59c43147;	// DoBallisticAdjustment
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DOLOSCOLLISIONS				= 0x80cf4c26;	// DoLOSCollisions
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_AVOIDEDBYAI					= 0x45819193;   // Asura_GetHashID( "AvoidedByAI" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FORWARDPREDICTEDBYAI		= 0xcdc0c752;   // Asura_GetHashID( "ForwardPredictedByAI" )
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DRAG						= 0x002F2D34;	// Drag
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ELASTICITY					= 0xD97F79B9;	// Elasticity
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FRICTION					= 0xAB1486FA;	// Friction
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_GRAVITYSCALE				= 0xB65BD7BC;	// GravityScale
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_IMPACTTYPE					= 0x808bb980;	// ImpactType
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MARKERPOINT_LINK			= 0x29494a90;	// MarkerPointLink
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MARKERPOINT_TRAIL			= 0x0054AA30;	// MarkerPointTrail
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MASS						= 0x003306F4;	// Mass
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MUZZLEVELOCITY				= 0xDA28923E;	// MuzzleVelocity
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_NUMCORPSES					= 0x101A233E;	// NumCorpsesToCollect
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ONLYCOLLIDEEITHENVANDSTATICS= 0xfcb8d489;	// OnlyCollideWithEnvironmentAndStatics
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PFX_EXPLOSION				= 0x4728CC13;	// PFXExplosion
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PFX_TRAIL					= 0x599CBA04;	// PFXTrail
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_TIMER						= 0x06940745;	// Timer
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_EMBEDANGLE					= 0xd554899a;	// EmbedAngle
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_RESTANIM					= 0xd0a1ad65;	// AnimRest
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_IMPACT_DAMAGE_TYPE_BP		= 0xff85a8ef;	// ImpactDamageType
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_IMPACT_DAMAGE_NEARRANGE		= 0x0ace07ed;	// ImpactDamageAtNearRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_IMPACT_DAMAGE_FARRANGE		= 0xe1676bae;	// ImpactDamageAtFarRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_IMPACT_IMPULSE_NEARRANGE	= 0x2b2e5ef3;	// ImpactImpulseAtNearRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_IMPACT_IMPULSE_FARRANGE		= 0x0bbd1be8;	// ImpactImpulseAtFarRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_IMPACT_NEARRANGE			= 0x153fdb8f;	// ImpactNearRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_IMPACT_FARRANGE				= 0xd97b9bcc;	// ImpactFarRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_RADIAL_DAMAGE_TYPE_BP		= 0xde875a88;	// RadialDamageType
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CAMERASHAKE_TYPE_BP			= 0xC76DDD6C;	// OnDestructCameraShake
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_RADIAL_DAMAGE_NEARRANGE		= 0x3e470834;	// RadialDamageAtNearRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_RADIAL_DAMAGE_FARRANGE		= 0x8839c687;	// RadialDamageAtFarRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_RADIAL_IMPULSE_NEARRANGE	= 0x66d5678c;	// RadialImpulseAtNearRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_RADIAL_IMPULSE_FARRANGE		= 0x3f361c2f;	// RadialImpulseAtFarRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_RADIAL_NEARRANGE			= 0xeae512d6;	// RadialNearRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_RADIAL_FARRANGE				= 0x5c3edfa5;	// RadialFarRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SEC_RADIAL_DAMAGE_TYPE_BP	= 0x2dc263fc;	// SecondaryRadialDamageType
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SEC_RADIAL_DAMAGE_NEARRANGE	= 0x63483440;	// SecondaryRadialDamageAtNearRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SEC_RADIAL_DAMAGE_FARRANGE	= 0x4f9ce8fb;	// SecondaryRadialDamageAtFarRang
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SEC_RADIAL_IMPULSE_NEARRANGE= 0xe1f9bd00;	// SecondaryRadialImpulseAtNearRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SEC_RADIAL_IMPULSE_FARRANGE	= 0x6437483b;	// SecondaryRadialImpulseAtFarRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SEC_RADIAL_NEARRANGE		= 0xc4290ae2;	// SecondaryRadialNearRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SEC_RADIAL_FARRANGE			= 0xb5d5b619;	// SecondaryRadialFarRange
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SOUND						= 0x0688c90f;	// Sound
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CONTAINERATTACHMENT			= 0xB187B864;	// ContainerAttachment
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CONTAINERATTACHMENT_MARKERPOINT	= 0x67554F0C;// ContainerAttachment.MarkerPoint



static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HACKINGTOOL					= 0x42566a39;	// HackingTool

//////////////////////////////////////////////////////////////////////////
// Flare
//////////////////////////////////////////////////////////////////////////

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_COLOUR						= 0xaf3ebdcc;	// Colour
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DURATION					= 0x89444d94;	// Duration
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FADEOUTTIME					= 0x8798d11f;	// FadeOutTime
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHOTONRANGE					= 0x0ffe614b;	// Photon.Range
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHOTONINTENSITY				= 0x86be8941;	// Photon.Intensity
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHOTONOFFSET				= 0xeaf23e45;	// Photon.Offset
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHOTONFADESTART				= 0x6625b517;	// Photon.Fade.StartDistance
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHOTONFADEDISTANCE			= 0xac82f609;	// Photon.Fade.OverDistance
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHOTONFALLOFFPOWER			= 0x9498b0b9;	// Photon.Falloff.Power
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHOTONFALLOFFSCALE			= 0x94bd30fe;	// Photon.Falloff.Scale
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHOTONDISTANCEFADE			= 0x155c56c3;	// Photon.Fade.Enable
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHOTONCORONA				= 0xd6fc50ce;	// Photon.Corona
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHOTONENVSHADOWS			= 0xa93b6c92;	// Photon.EnvironmentShadows
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHOTONCASTOWNSHADOWS		= 0x8113593e;	// Photon.CastOwnShadows
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHOTONCONTRIBUTETOAVG		= 0x26fdfde3;	// Photon.ContributeToAverageShadow
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHOTONSHADOWNOISE			= 0xbb7fc788;	// Photon.ShadowNoise
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PHOTONSCALEBYBRIGHTNESS		= 0x886d0401;	// Photon.ScaleStrengthByBrightness
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FLICKER						= 0xd1fd41f8;	// Flicker
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SOUNDCREATE					= 0x8df122cb;	// SoundCreate

// Melee-related parameters (that we don't use the enumerator for)
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MELEE_FIRSTPERSON				= 0xDE1AEC11;	// Asura_GetHashID("MeleeFirstPerson")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_MELEE_THIRDPERSON				= 0x21A67988;	// Asura_GetHashID("MeleeThirdPerson")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_BLOCK_FIRSTPERSON				= 0x98937B58;	// Asura_GetHashID("BlockFirstPerson")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_BLOCK_THIRDPERSON				= 0xDC1F08CF;	// Asura_GetHashID("BlockThirdPerson")

static const char* const szAVP_BLUEPRINT_PARAM_FLINCH								= "Flinch";
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FLINCH_FIRSTPERSON					= 0xD7F7519D;	// Asura_GetHashID("FirstPersonAnims")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FLINCH_THIRDPERSON					= 0x79AC9686;	// Asura_GetHashID("ThirdPersonAnims")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FLINCH_MINATTACKSTRENGTH			= 0x0B64449B;	// Asura_GetHashID("MinAttackImpulse")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FLINCH_USESMOVE						= 0x8F361C12;	// Asura_GetHashID("InterruptMovement") // Note the very different parameter name - "Use Move" is fairly meaningless to animators/designers.
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FLINCH_DISABLESURFACEREORIENTATION	= 0x0C44884C;	// Asura_GetHashID("DetachFromWalls") // Similarly, "Disable surface reorientation" isn't that clear outside of the code.
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FLINCH_RESETAIMDIRECTION			= 0x3DA3CAA9;	// Asura_GetHashID("ResetAimDirection")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FLINCH_ORIENTATETOIMPACTDIRECTION	= 0x046CB491;	// Asura_GetHashID("OrientateToImpactDirection") // This will probably have to imply disabling surface reorientation.
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FLINCH_PROBABILITY					= 0x2B0C0F69;	// Asura_GetHashID("EarlyRestartProbability")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FLINCH_MINDELAY						= 0x30A5D9EF;	// Asura_GetHashID("DelayMin")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FLINCH_MAXDELAY						= 0x30A5D901;	// Asura_GetHashID("DelayMax")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_BLOCKWRISTBLADESREADY_FIRSTPERSON	= 0x5481A7BF;	// Asura_GetHashID("BlockWristbladesReadyFirstPerson")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_BLOCKWRISTBLADESREADY_THIRDPERSON	= 0x980D3536;	// Asura_GetHashID("BlockWristbladesReadyThirdPerson")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_INITIALOFFSET					= 0x25E338D7;	// Asura_GetHashID("InitialOffset")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_WRISTBLADES_READY				= 0x9DCA47F9;	// Asura_GetHashID("WristbladesReady");

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALIEN_FIRSTPERSON				= 0x10E18430;	// Asura_GetHashID("HUDAlien")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALIENSTART_FIRSTPERSON			= 0xEBE45E32;	// Asura_GetHashID("HUDAlienStart")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALIENKILL_FIRSTPERSON			= 0xFF56278E;	// Asura_GetHashID("HUDAlienKill")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALIENCOUNTERED_FIRSTPERSON		= 0x58F2056B;	// Asura_GetHashID("HUDAlienCountered")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALIENDIE_FIRSTPERSON			= 0x73975250;	// Asura_GetHashID("HUDAlienDie")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALIENCOUNTER_FIRSTPERSON		= 0x2E71BBCC;	// Asura_GetHashID("HUDAlienCounter")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALIEN_THIRDPERSON				= 0x79ABACCB;	// Asura_GetHashID("ThirdPersonAlien")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALIENSTART_THIRDPERSON			= 0xBBB25E77;	// Asura_GetHashID("ThirdPersonAlienStart")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALIENKILL_THIRDPERSON			= 0x2F548AA9;	// Asura_GetHashID("ThirdPersonAlienKill")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALIENCOUNTERED_THIRDPERSON		= 0x958C5B30;	// Asura_GetHashID("ThirdPersonAlienCountered")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALIENDIE_THIRDPERSON			= 0xF1029FD5;	// Asura_GetHashID("ThirdPersonAlienDie")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALIENCOUNTER_THIRDPERSON		= 0x42C0BED1;	// Asura_GetHashID("ThirdPersonAlienCounter")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDATOR_FIRSTPERSON			= 0xC04730EE;	// Asura_GetHashID("HUDPredator")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDATORSTART_FIRSTPERSON		= 0xD962F834;	// Asura_GetHashID("HUDPredatorStart")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDATORKILL_FIRSTPERSON		= 0xF67B454C;	// Asura_GetHashID("HUDPredatorKill")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDATORCOUNTERED_FIRSTPERSON	= 0xD1AFCE6D;	// Asura_GetHashID("HUDPredatorCountered")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDATORDIE_FIRSTPERSON			= 0x9C9884D2;	// Asura_GetHashID("HUDPredatorDie")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDATORCOUNTER_FIRSTPERSON		= 0xB6B1DD4E;	// Asura_GetHashID("HUDPredatorCounter")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDATOR_THIRDPERSON			= 0x3DB27E73;	// Asura_GetHashID("ThirdPersonPredator")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDATORSTART_THIRDPERSON		= 0x4EF455CF;	// Asura_GetHashID("ThirdPersonPredatorStart")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDATORKILL_THIRDPERSON		= 0x0ACA4851;	// Asura_GetHashID("ThirdPersonPredatorKill")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDATORCOUNTERED_THIRDPERSON	= 0x3DD2E688;	// Asura_GetHashID("ThirdPersonPredatorCountered")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDATORDIE_THIRDPERSON			= 0xC68A8D2D;	// Asura_GetHashID("ThirdPersonPredatorDie")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDATORCOUNTER_THIRDPERSON		= 0x0D624029;	// Asura_GetHashID("ThirdPersonPredatorCounter")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HUMAN_FIRSTPERSON				= 0x11484E96;	// Asura_GetHashID("HUDHuman")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HUMANSTART_FIRSTPERSON			= 0x9C3A238C;	// Asura_GetHashID("HUDHumanStart")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HUMANDIE_FIRSTPERSON			= 0x2D72A62A;	// Asura_GetHashID("HUDHumanDie")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HUMANCOUNTER_FIRSTPERSON		= 0x206B92A6;	// Asura_GetHashID("HUDHumanCounter")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HUMAN_THIRDPERSON				= 0x7A127731;	// Asura_GetHashID("ThirdPersonHuman")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HUMANSTART_THIRDPERSON			= 0x6C0823D1;	// Asura_GetHashID("ThirdPersonHumanStart")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HUMANDIE_THIRDPERSON			= 0xAADDF3AF;	// Asura_GetHashID("ThirdPersonHumanDie")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HUMANCOUNTER_THIRDPERSON		= 0x34BA95AB;	// Asura_GetHashID("ThirdPersonHumanCounter")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDATORLEFTCLAW_FIRSTPERSON	= 0x9C2A49D4;	// Asura_GetHashID("HUDPredatorLeftClaw")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDATORRIGHTCLAW_FIRSTPERSON	= 0x2395F14D;	// Asura_GetHashID("HUDPredatorRightClaw")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDATORLEFTCLAW_THIRDPERSON	= 0x1B864259;	// Asura_GetHashID("ThirdPersonPredatorLeftClaw")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PREDATORRIGHTCLAW_THIRDPERSON	= 0x8FB90968;	// Asura_GetHashID("ThirdPersonPredatorRightClaw")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALIENLEFTCLAW_FIRSTPERSON		= 0x1C663B16;	// Asura_GetHashID("HUDAlienLeftClaw")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALIENRIGHTCLAW_FIRSTPERSON		= 0xAAD8284B;	// Asura_GetHashID("HUDAlienRightClaw")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALIENLEFTCLAW_THIRDPERSON		= 0x91F798B1;	// Asura_GetHashID("ThirdPersonAlienLeftClaw")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ALIENRIGHTCLAW_THIRDPERSON		= 0xE7727E10;	// Asura_GetHashID("ThirdPersonAlienRightClaw")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ATTACKER_ACTIVEGRAPPLE			= 0x9DA465BA;	// Asura_GetHashID("ActiveGrapple.Attacker")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_VICTIM_ACTIVEGRAPPLE			= 0xC044888D;	// Asura_GetHashID("ActiveGrapple.Victim")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ATTACKER_FSFX					= 0x780FDAD5;	// Asura_GetHashID("FSFX_Attacker")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_VICTIM_FSFX						= 0x45B08868;	// Asura_GetHashID("FSFX_Victim")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ATTACKER_PFX_EFFECT				= 0xCE559661;	// Asura_GetHashID("PFXEffect_Attacker")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_VICTIM_PFX_EFFECT				= 0x1507B6F4;	// Asura_GetHashID("PFXEffect_Victim")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ATTACKER_PFX_MARKER				= 0xD160A9D8;	// Asura_GetHashID("PFXMarker_Attacker")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_VICTIM_PFX_MARKER				= 0x6FDF3C2B;	// Asura_GetHashID("PFXMarker_Victim")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DISRUPT_EQUIPMENT				= 0x3ea1a819;	// DisruptEquipment

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_TROPHYANIM						= 0x9F6BF041;	// Asura_GetHashID("TrophyAnim")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_TAILLASH_DAMAGE					= 0x78DA5BA9;	// Asura_GetHashID("Melee_TailLash_Damage")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_TAILLASH_IMPULSE				= 0xBF9DDBFB;	// Asura_GetHashID("Melee_TailLash_Impulse")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_TAILSTAB_DAMAGE					= 0xD077C8F1;	// Asura_GetHashID("Melee_TailStab_Damage")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_TAILSTAB_IMPULSE				= 0x5BAE17B3;	// Asura_GetHashID("Melee_TailStab_Impulse")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_TAILATTACK_RANGE				= 0x995079C3;	// Asura_GetHashID("Melee_TailLash_Range")

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_HASDEFAULTATTACK				= 0x77F6476F;	// Asura_GetHashID("HasDefaultAttack");

//////////////////////////////////////////////////////////////////////////
// Parameters for Directional Blend Anim Template Regions
//////////////////////////////////////////////////////////////////////////

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DIRBLENDTEMPLATE				= 0x3e5c0821;	// DirectionalBlendTemplate

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ACWANGLE						= 0x45115a3a;	// ACW.Angle
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ACWANIM							= 0x9f2197ca;	// ACW.Anim
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_ACWTWEENFLAGS					= 0xf8a47bf6;	// ACW.TweenOnFlags
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CWANGLE							= 0x17234ad9;	// CW.Angle
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CWANIM							= 0x42cf974b;	// CW.Anim
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_CWTWEENFLAGS					= 0x805f6a77;	// CW.TweenOnFlags

/////////////////////////////////////////
// Parameters for skin element details //
/////////////////////////////////////////

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SKINELEMENT_DAMAGEMULTIPLIER		= 0xD64DCA70;	// Asura_GetHashID("DamageMultiplier")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SKINELEMENT_DESTRUCTIONBLOODPFX		= 0xD9D713BA;	// Asura_GetHashID("DestructionBloodPFX")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SKINELEMENT_DESTRUCTIONDECAL		= 0x882B423B;	// Asura_GetHashID("DestructionDecal")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SKINELEMENT_ESSENTIAL				= 0x9F31734E;	// Asura_GetHashID("Essential")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SKINELEMENT_GIBSKIN					= 0x0169953D;	// Asura_GetHashID("GibSkin")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SKINELEMENT_INITIALHEALTH			= 0x19E0D6A0;	// Asura_GetHashID("InitialHealth")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_SKINELEMENT_MARKERPOINT				= 0x0E875596;	// Asura_GetHashID("MarkerPoint")

static const char* const szAVP_BLUEPRINT_ENUMERATION_PARAM_SKINELEMENT_GIBPFXEFFECT	= "GibPFXEffect";
static const char* const szAVP_BLUEPRINT_ENUMERATION_PARAM_SKINELEMENT_GIBPFXMARKER	= "GibPFXMarker";

/////////////////////////////////////
// Parameters for death animations //
/////////////////////////////////////

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FIRSTPERSONDEATH				= 0x4C34C711;	// Asura_GetHashID("DeathFirstPerson");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_THIRDPERSONDEATH				= 0x8FC05488;	// Asura_GetHashID("DeathThirdPerson");

static const char* const szAVP_BLUEPRINT_ENUMERATIONNAME_DEATHANIM_NAME_HEADLOSS	= "HeadRemoved";
// These fragments will be combined into the string we use to enumerate the parameters in the order Forward/Backward -> Left/Right -> Strong/Weak (e.g "ForwardLeftWeak").
static const char* const szAVP_BLUEPRINT_ENUMERATIONNAMEFRAGMENT_DEATHANIM_FORWARD	= "Forward";
static const char* const szAVP_BLUEPRINT_ENUMERATIONNAMEFRAGMENT_DEATHANIM_BACKWARD	= "Backward";
static const char* const szAVP_BLUEPRINT_ENUMERATIONNAMEFRAGMENT_DEATHANIM_LEFT		= "Left";
static const char* const szAVP_BLUEPRINT_ENUMERATIONNAMEFRAGMENT_DEATHANIM_RIGHT	= "Right";
static const char* const szAVP_BLUEPRINT_ENUMERATIONNAMEFRAGMENT_DEATHANIM_STRONG	= "Strong";
static const char* const szAVP_BLUEPRINT_ENUMERATIONNAMEFRAGMENT_DEATHANIM_WEAK		= "Weak";
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_DEATHANIM_STRONGTHRESHOLD			= 0x8ABBFC88;	// Asura_GetHashID("StrongImpactPower");

// Damage type details
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_ACID		            = 0xdbc3e26c;	// "AcidDamage" 
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_BITE		            = 0xF53B1667;	// "BiteDamage" This can be used similarly to dismember damage, but causes the headbit element to become visible if the head is hit.
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_BLADE		            = 0x5F6FA987;	// "BladeDamage" A type of damage that will chop limbs off instead of destroying them
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_BULLET                = 0x3EB9A6F1;   // "BulletDamage"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_BURN					= 0xF4C605FE;   // "BurnDamage" damage done by burn effect of some object or actor.
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_CLAW		            = 0xA8CBAA8E;	// "ClawDamage"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_DISC		            = 0x0C205544;	// "DiscDamage" A type of damage that will chop limbs off instead of destroying them
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_DISMEMBER	            = 0xe76a5a17;	// "DismemberDamage" DismemberDamage is special
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_DROPSHIP_MISSILE		= 0x51916C4A;	// "DropshipMissileDamage"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_EXPLOSIVE	            = 0x78D37F94;	// "ExplosiveDamage"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_EXPLOSIVEIMPACTDAMAGE = 0x4346C09A;	// "ExplosiveImpactDamage"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_FLAME		            = 0x59ED0862;	// "FlameDamage"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_GRAPPLE	            = 0xee8fe57e;	// "GrappleDamage" damage hash ID used by melee system
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_MELEE		            = 0xde1331e3;	// "MeleeDamage" damage hash ID used by melee system
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_PLASMA				= 0x4F109731;	// "PlasmaDamage"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_PLASMA_DISRUPTION		= 0x47093995;	// "PlasmaDisruption"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_PLASMA_IMPACT			= 0xD848EE77;	// "PlasmaImpactDamage"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_SPEAR					= 0xDCE48488;	// "SpearDamage"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_TAIL		            = 0x7BE043BF;	// "TailDamage"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_TASER                 = 0xDCBE5C02;   // "TaserDamage"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_VOLUME	            = 0xb7323709;	// "VolumeDamage" damage from volumes, innit
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_FALLING	            = 0x3D9E94B6;	// "FallingDamage"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_DAMAGE_MINE					= 0x051be582;	// "MineDamage"


// Damage-multiplier parameters...
static const char* const	szAVP_BLUEPRINT_ENUMERATIONNAME_DAMAGEMULTIPLIER	= "DamageMultiplier";
static u_int				uAVP_BLUEPRINT_ENUMERATIONDIGITS_DAMAGEMULTIPLIER	= 2;
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_DAMAGETYPE						= 0x9643CB29;	// DamageType
static const Asura_Hash_ID	uAVP_BLUEPRINT_PARAM_DAMAGEMULTIPLIER				= 0xD64DCA70;	// DamageMultiplier

// Multiplayer game-mode parameters
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_AI_SPAWN_POINTS_ON								= 0xc5c18bdf; //"AI Spawn Points On"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ALLOW_MIXED_TEAMS								= 0x61452afa; //"Allow Mixed Teams"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_CAPTURE_POINTS_ON								= 0x6627e5e2; //"Capture Points On"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_CTF_ON											= 0xaf814fca; //"CTF On"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_FRIENDLY_FIRE_ON									= 0x05ff0594; //"Friendly Fire On"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_HP_FORCE_TEAM_CHANGE								= 0x435a98ae; //"Hunter-Prey - Force Team Change"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_HP_HUNTER_KILL_PREY_JOIN							= 0x540212c2; //"Hunter-Prey - Hunter Kill Prey Join"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_HP_PREY_KILL_HUNTER_SWITCH						= 0x0cbd284c; //"Hunter-Prey - Prey Kill Hunter Switch"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_LIVES_AVAILABLE_PER_TEAM							= 0xe3e89ab0; //"Lives available per team"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MAX_NUMBER_OF_PLAYERS							= 0x96c241e4; //"Max number of players"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_MUTUALLY_EXCLUSIVE_TEAMS							= 0x1aa11835; //"Mutually exclusive teams"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_NUMBER_OF_TEAMS									= 0xc177d524; //"Number of teams"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PLAYER_RATIO_ALIEN								= 0x8d127700; //"Player Ratio - Alien"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PLAYER_RATIO_HUMAN								= 0x8d794166; //"Player Ratio - Human"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PLAYER_RATIO_PREDATOR							= 0x04778c1e; //"Player Ratio - Predator"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PLAYER_SCORE_CAPTURE_CONTROL_POINT				= 0x702d3573; //"Player Score - Capture Control Point"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PLAYER_SCORE_CAPTURE_FLAG						= 0x747c3446; //"Player Score - Capture Flag"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PLAYER_SCORE_DEFEND_CONTROL_POINT_BONUS			= 0x58422b22; //"Player Score - Defend Control Point Bonus"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PLAYER_SCORE_HUNTER_KILL_PRIMARY_PREY_BONUS		= 0x0ed43a35; //"Player Score - Hunter Kill Primary Prey Bonus"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PLAYER_SCORE_HUNTER_KILL_SECONDARY_PREY_BONUS	= 0xf7973b03; //"Player Score - Hunter Kill Secondary Prey Bonus"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PLAYER_SCORE_KILL_FLAG_CARRIER_BONUS				= 0x0eca7b05; //"Player Score - Kill Flag Carrier Bonus"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PLAYER_SCORE_PREY_KILL_HUNTER_BONUS				= 0x6dc8b5d7; //"Player Score - Prey Kill Hunter Bonus"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PLAYER_SCORE_RETURN_FLAG_BONUS					= 0x42e3a71b; //"Player Score - Return Flag Bonus"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREY_SURVIVOR_MULTIPLIER_FIRST					= 0xc26a7d40; //"Prey Survivor Multiplier - 1st"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREY_SURVIVOR_MULTIPLIER_SECOND					= 0xc26a8056; //"Prey Survivor Multiplier - 2nd"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PREY_SURVIVOR_MULTIPLIER_THIRD					= 0xc26a8493; //"Prey Survivor Multiplier - 3rd"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_RESPAWN_USE_WAVE_SPAWNING						= 0x50156cca; //"Respawn - Use Wave Spawning"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_RESPAWN_DELAY									= 0x71201c8b; //"Respawn Delay"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_RESPAWN_TYPE										= 0x774aab32; //"Respawn Type"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_RESPAWN_UPON_DEATH								= 0xe4ba1686; //"Respawn upon death"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_SCORE_LIMIT										= 0x02a8e8ad; //"Score Limit"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_TEAM_ONE											= 0xcbaf232e; //"Team 1"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_TEAM_TWO											= 0xcbaf232f; //"Team 2"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_TEAM_THREE										= 0xcbaf2330; //"Team 3"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_TEAM_LIVES_ON									= 0x677d1dfb; //"Team Lives On"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_TEAM_SCORE_ALL_ENEMIES_DEAD						= 0x93958681; //"Team Score - All Enemies Dead"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_TEAM_SCORE_CAPTURE_ALL_CONTROL_POINTS			= 0x44cd3bc3; //"Team Score - Capture All Control Points"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_TEAM_SCORE_HOLD_CONTROL_POINT					= 0x9e0bceb0; //"Team Score - Hold Control Point"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_TEAM_SCORE_KILLS_ADD_TO_SCORE					= 0x4c5411fb; //"Team Score - Kills Add To Score"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_TEAM_VICTORY_ON									= 0x6906b450; //"Team Victory On"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_TIME_LIMIT										= 0x5E72F738; //"Time Limit (mins)"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PERSECUTOR_MODE_ON								= 0x2f1ec40f; //"Persecutor - Persecutor mode on"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_PERSECUTOR_KILLS_NEEDED_TO_PERSECUTE				= 0x4eef73f0; //"Persecutor - Kills needed to persecute"

// Multiplayer team parameters
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_ROLE							= 0x00358076; //"Role"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_SCORE_KILL_ALIEN				= 0x7fe82026; //"Score - Kill Alien"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_SCORE_KILL_ASSIST			= 0x7d8324ea; //"Score - Kill Assist"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_SCORE_KILL_HUMAN				= 0x804eea8c; //"Score - Kill Human"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_SCORE_KILL_PERSECUTOR_BONUS	= 0x0fc75196; //"Score - Kill Persecutor Bonus"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_SCORE_KILL_PREDATOR			= 0xf2668938; //"Score - Kill Predator"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_SCORE_KILL_TEAMMATE			= 0xdbead923; //"Score - Kill Teammate"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_SCORE_KILL_YOURSELF			= 0x16b93440; //"Score - Kill Yourself"
static const Asura_Hash_ID uAVP_BLUEPRINT_NAME_SPECIES						= 0x8849413c; //"Species"


//////////////////////////////////////////////////////////////////////////
// Pickups parameters
//////////////////////////////////////////////////////////////////////////
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_SINGLEPLAYERINVENTORYITEMBLUEPRINT = 0x5fa4542d;	// InventoryItemBlueprintSinglePlayer
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_MULTIPLAYERINVENTORYITEMBLUEPRINT = 0x06c5e5d6;	// InventoryItemBlueprintMultiplayer
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_PICK_DISTANCE          = 0xF1B85B16; //Asura_GetHashID("PickDistance");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_SKIN_OVERRIDE          = 0xB7823449; //Asura_GetHashID("SkinOverride");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_TYPE                   = 0xC689FBB6; //Asura_GetHashID("PickupType");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_AUTOPICKUP             = 0x1A0BA8EB; //Asura_GetHashID("AutoPickup");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_ALLEGIANCE             = 0x843F8D15; //Asura_GetHashID("Allegiance");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_CASTSHADOW             = 0xCA247920; //Asura_GetHashID("Shadow"); 
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_SKIN_DESTROYED         = 0xDBE38D3C; //Asura_GetHashID("SkinDestroyed");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_MASS					  = 0x003306F4; //Asura_GetHashID("Mass");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_SOUND				  = 0x0AA2EC13; //Asura_GetHashID("PickupSound")
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_REST_ANIM              = 0xEBE913E5; //Asura_GetHashID("RestAnim")
	// Intelligent amounts
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_SCARCE_MINIMUM         = 0xE3AC2C0B; //Asura_GetHashID("ScarceMinimum");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_SCARCE_MAXIMUM         = 0xD692521D; //Asura_GetHashID("ScarceMaximum");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_MEDIUM_MINIMUM         = 0x2FEFA2F9; //Asura_GetHashID("MediumMinimum");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_MEDIUM_MAXIMUM         = 0x22D5C90B; //Asura_GetHashID("MediumMaximum");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_PLENTY_MINIMUM         = 0xD5F1CFE4; //Asura_GetHashID("PlentyMinimum");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_PLENTY_MAXIMUM         = 0xC8D7F5F6; //Asura_GetHashID("PlentyMaximum");
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_PICKUP_AMMO_TYPE			  = 0xA2AC3708; //Asura_GetHashID("AmmoType");

//////////////////////////////////////////////////////////////////////////
// Audio Diaries
//////////////////////////////////////////////////////////////////////////
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_AUDIODIARY_SPEAKERNAME  = 0x6D3DC30A;	// "SpeakerName"
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_AUDIODIARY_DATERECORDED = 0x6CB00A5E;	// "Date"
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_AUDIODIARY_DIALOGUE     = 0xF20FD9D8;	// "SpeakerName"

//////////////////////////////////////////////////////////////////////////
// Dropship animation
//////////////////////////////////////////////////////////////////////////
static const Asura_Hash_ID uAVP_DROPSHIP_ANIM_IDLE = 0xbe79d9b3; //"ThirdPerson.Skin.Idle"
static const Asura_Hash_ID uAVP_DROPSHIP_ANIM_FLAPS_RIGHTLEFT = 0x300e33f3; //"ThirdPerson.Skin.Rudder_RightLeft"
static const Asura_Hash_ID uAVP_DROPSHIP_ANIM_FLAPS_DOWNUP = 0xe78ae4ed; //"ThirdPerson.Skin.Rudder_DownUp"
static const Asura_Hash_ID uAVP_DROPSHIP_ANIM_THRUSTERS_FRONTBACK = 0x72a831e0; //"ThirdPerson.Skin.Thrusters_FrontBack"
static const Asura_Hash_ID uAVP_DROPSHIP_ANIM_FRONT_PODS_CLOSE_TO_OPEN = 0x2aa84f52; //"ThirdPerson.Skin.FrontMissiles_Open"
static const Asura_Hash_ID uAVP_DROPSHIP_ANIM_FRONT_PODS_OPEN_TO_CLOSE = 0x29b6d5f0; //"ThirdPerson.Skin.FrontMissiles_Close"
static const Asura_Hash_ID uAVP_DROPSHIP_ANIM_BACK_PODS_CLOSE_TO_OPEN = 0xdce6129c; //"ThirdPerson.Skin.Pods_Open"
static const Asura_Hash_ID uAVP_DROPSHIP_ANIM_BACK_PODS_OPEN_TO_CLOSE = 0xbf317be6; //"ThirdPerson.Skin.Pods_Close"
static const Asura_Hash_ID uAVP_DROPSHIP_ANIM_BACK_PODS_DOORS_CLOSE_TO_OPEN = 0x1f7f5431; //"ThirdPerson.Skin.PodsDoors_Open"
static const Asura_Hash_ID uAVP_DROPSHIP_ANIM_BACK_PODS_DOORS_OPEN_TO_CLOSE = 0xcfc06cf1; //"ThirdPerson.Skin.PodsDoors_Close"

static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FIDGETMINTIME = 0x5cb70847;	// TimeBetweenFidgets.Min
static const Asura_Hash_ID uAVP_BLUEPRINT_PARAM_FIDGETMAXTIME = 0x5cb70759;	// TimeBetweenFidgets.Max

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////
//  Animation initialisation helper lists
////////////////////////////////////////////////////////////
static const u_int s_uNumHumanAIWeapons = 7;
static const Asura_Hash_ID s_auHumanAIWeaponHash[ s_uNumHumanAIWeapons ] = 
{
	0x92e089b2,	// PulseRifleNPC
	0x08f9b20a,	// PistolNPC
	0x04efecaa,	// SmartgunNPC
	0xb227c91b,	// ShotgunNPC
	0x6b844761,	// FlamethrowerNPC
	0x5280e722,	// ScopedPulseRifleNPC
	0x058f6a9f	// UnarmedNPC
};

static const u_int s_uNumHumanSinglePlayerWeapons = 8;
static const Asura_Hash_ID s_auHumanSinglePlayerWeaponHash[ s_uNumHumanSinglePlayerWeapons ] = 
{
	0x42e9fe70,	// PulseRiflePlayer
	0x7c87d718,	// PistolPlayer
	0x8f781878,	// SmartgunPlayer
	0x27161a67,	// ShotgunPlayer
	0xd9a0ae61,	// FlamethrowerPlayer
	0x09c36b00,	// ScopedPulseRiflePlayer
	0xee844f4a,	// TequilaPlayer
	0xe8b6cb2e	// BatteryPlayer
};

static const u_int s_uNumHumanMultiPlayerWeapons = 7;
static const Asura_Hash_ID s_auHumanMultiPlayerWeaponHash[ s_uNumHumanMultiPlayerWeapons ] = 
{
	0x5a845f2b,	// PulseRifleMultiPlayer
	0x507baf83,	// PistolMultiPlayer
	0x225d4a23,	// SmartgunMultiPlayer
	0xea2e2594,	// ShotgunMultiPlayer
	0xc0e2fdda,	// FlamethrowerMultiPlayer
	0x34684c9b,	// ScopedPulseRifleMultiPlayer
	0xd6dc8691	// TequilaMultiPlayer
};

static const u_int s_uNumPredatorAIWeapons = 2;
static const Asura_Hash_ID s_auPredatorAIWeaponHash[ s_uNumPredatorAIWeapons ] = 
{
	0xa522bc33,	// PlasmaCasterNPC
	0x4129b6b7	// WristBladesNPC
};

static const u_int s_uNumPredatorSinglePlayerWeapons = 4;
static const Asura_Hash_ID s_auPredatorSinglePlayerWeaponHash[ s_uNumPredatorSinglePlayerWeapons ] = 
{
	0x085d304f,	// PlasmaCasterPlayer
	0x1877f74b,	// WristBladesPlayer
	0x53f921d5,	// PredMinePlayer 
	0x213064b6	// DiscPlayer
};

static const u_int s_uNumPredatorMultiPlayerWeapons = 4;
static const Asura_Hash_ID s_auPredatorMultiPlayerWeaponHash[ s_uNumPredatorMultiPlayerWeapons ] = 
{
	0x1ef080ac,	// PlasmaCasterMultiPlayer
	0x9ca6b730,	// WristBladesMultiPlayer
	0x00cc92e6,	// PredMineMultiPlayer
	0xfdc0f4a5	// DiscMultiPlayer
};

#endif //__AVP_BLUEPRINT_HASHIDS_H__
