//////////////////////////////////////////////////////////////////////////////
//
// Asura_Project_Time_System.cpp
//
// Copyright (c) 2004 Rebellion. All rights reserved.
//
// Created by Nick Davis.
//
// AVP version by Mike Healey
//
// TODO - if you're copying this file to a real project, names need localising.
//
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//
// includes
//
//////////////////////////////////////////////////////////////////////////////

// core
#include "Core/Asura.h"

// header
#include "Core/Asura_Time_System.h"

#include "Debugging/Asura_Assert.h"

//////////////////////////////////////////////////////////////////////////////
//
// Asura_Time_System
//
//////////////////////////////////////////////////////////////////////////////

const Asura_UnicodeChar* Asura_Time_System::Project_GetDayOfWeekName(int iWeekDay)
{
	Asura_Assert(iWeekDay >= 0 && iWeekDay < 7, "invalid week day");
	const Asura_UnicodeChar* aszDays[7] = { L"Sunday", L"Monday", L"Tuesday", L"Wednesday", L"Thursday", L"Friday", L"Saturday" };
    return aszDays[iWeekDay];
}

const Asura_UnicodeChar* Asura_Time_System::Project_GetMonthName(int iMonth)
{
	Asura_Assert(iMonth >= 0 && iMonth < 12, "invalid week day");
	const Asura_UnicodeChar* aszMonths[12] = { L"January", L"February", L"March", L"April", L"May", L"June", 
												L"July", L"August", L"September", L"October", L"November", L"December" };
    return aszMonths[iMonth];
}

const Asura_UnicodeChar* Asura_Time_System::Project_GetDayOfWeekShortName(int iWeekDay)
{
	Asura_Assert(iWeekDay >= 0 && iWeekDay < 7, "invalid week day");
	const Asura_UnicodeChar* aszDays[7] = { L"Sun", L"Mon", L"Tue", L"Wed", L"Thu", L"Fri", L"Sat" };
    return aszDays[iWeekDay];
}

ASURA_DATE_FORMAT Asura_Time_System::Project_GetDateFormat()
{
    return ASURA_DATE_DDMMYYYY;
}

ASURA_TIME_FORMAT Asura_Time_System::Project_GetTimeFormat()
{
    return ASURA_12_HOUR;
}

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////
