///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_State_FMV.cpp
// Author : Catalin Arsenescu
// Date   : 24/04/08
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Core/States/AVP_State_FMV.h"

// Asura independent header-files...
#include "ChunkSystem/Asura_Chunk_Loaders.h"
#include "Core/Asura_Core.h"

// Game independent header-files...
#include "Core/AVP_Core.h"
#include "Core/AVP_StateMachine.h"
#include "FMV/AVP_FMV.h"
#include "GUIMenu/AVP_GUIMenu_System.h"

#if defined(ASURA_TOOLS)
// Tools header-files...
#include "Tools_System.h"
#endif	// defined(ASURA_TOOLS)


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function : AVP_State_FMV::Enter
// Author	: Catalin Arsenescu
// Date		: 24/04/08
////////////////////////////////////////////////////////////////////////////////

void AVP_State_FMV::Enter(const u_int uPreviousState)
{
	// Ensure we've cleared down any unwanted data...
	AVP_FMV::Initialise();
}

/// End of function 'AVP_State_FMV::Enter'. ///



////////////////////////////////////////////////////////////////////////////////
// Function : AVP_State_FMV::Update
// Author	: Catalin Arsenescu
// Date		: 24/04/08
////////////////////////////////////////////////////////////////////////////////

void AVP_State_FMV::Update()
{
	// Play the FMV...
	AVP_FMV::Play(m_szFilename, false, ASURA_LT_L_ENGLISH);

	// Once we're done we'll change state...
	GetParentMachine().ChangeState(m_uNextState);
}

/// End of function 'AVP_State_FMV::Update'. ///



////////////////////////////////////////////////////////////////////////////////
// Function : AVP_State_FMV::Render
// Author	: Catalin Arsenescu
// Date		: 24/04/08
////////////////////////////////////////////////////////////////////////////////

void AVP_State_FMV::Render() const
{
	AVP_Core::BeginRender(false);
	{
		AVP_GUIMenu_System::Render(true);
	}
	AVP_Core::EndRender();
}

/// End of function 'AVP_State_FMV::Render'. ///



////////////////////////////////////////////////////////////////////////////////
// Function : AVP_State_FMV::Exit
// Author	: Catalin Arsenescu
// Date		: 24/04/08
////////////////////////////////////////////////////////////////////////////////

void AVP_State_FMV::Exit(const u_int uNextState)
{
	AVP_FMV::Shutdown();
}

/// End of function 'AVP_State_FMV::Exit'. ///


/// End of file. ///
