
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_ConnectionState_EndGameInitialisation.h
// Author : Andy Tate
// Date   : 25-Feb-2009
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_CONNECTIONSTATE_ENDGAMEINITIALISATION_H__
#define __AVP_CONNECTIONSTATE_ENDGAMEINITIALISATION_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/States/Connection/AVP_State_Connection.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class AVP_Connection;


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_ConnectionState_EndGameInitialisation
// Author       : Andy Tate
// Date         : 25-Feb-2009
//
// Description  : Class used to handle the end of game initialisation.
////////////////////////////////////////////////////////////////////////////////

class AVP_ConnectionState_EndGameInitialisation : public AVP_State_Connection
{
public:
	// Public functions...
	AVP_ConnectionState_EndGameInitialisation(AVP_Connection& xParentMachine)	: PARENT(xParentMachine)	{}
	//virtual ~AVP_ConnectionState_EndGameInitialisation();

	// Overridden functions...
	virtual	void 		Enter(const u_int uPreviousState);
	virtual	void 		Update(void);
	virtual	void 		Render(void) const;
	virtual	void 		Exit(const u_int uNextState);

	virtual	const char*	GetName(void) const	{ return("End game initialisation"); }


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private typedefs...
	typedef AVP_State_Connection PARENT;

	// Private variables...
	static volatile bool	s_bInitialisationComplete;

	// Private functions...
	AVP_ConnectionState_EndGameInitialisation(void);
	AVP_ConnectionState_EndGameInitialisation(const AVP_ConnectionState_EndGameInitialisation& xOther);

	AVP_ConnectionState_EndGameInitialisation&	operator=(const AVP_ConnectionState_EndGameInitialisation& xOther);

	void	PerformInitialiseCompletion(void);

	static void PerformInitialiseCompletion(const void* pUserData)
	{
		const AVP_ConnectionState_EndGameInitialisation*	pxConstThis	= static_cast<const AVP_ConnectionState_EndGameInitialisation*>(pUserData);
		AVP_ConnectionState_EndGameInitialisation*			pxThis		= const_cast<AVP_ConnectionState_EndGameInitialisation*>(pxConstThis);

		pxThis->PerformInitialiseCompletion();
	}

};   // End of class 'AVP_ConnectionState_EndGameInitialisation'.


#endif   // ifndef __AVP_CONNECTIONSTATE_ENDGAMEINITIALISATION_H__


/// End of file. ///
