
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_CoreState_DevelopmentFrontend.h
// Author : Anthony Gregson
// Date   : 21/11/07
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_CORESTATE_DEVELOPMENTFRONTEND_H__
#define __AVP_CORESTATE_DEVELOPMENTFRONTEND_H__

#if defined(AVP_USE_DEVELOPMENT_FRONT_END)

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/States/Core/AVP_State_Core.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class AVP_StateMachine_Core;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class  : AVP_CoreState_DevelopmentFrontend
// Author : Anthony Gregson
// Date   : 21/11/07
////////////////////////////////////////////////////////////////////////////////

class AVP_CoreState_DevelopmentFrontend : public AVP_State_Core
{
	typedef AVP_State_Core PARENT;

public:
	// Public functions...
	AVP_CoreState_DevelopmentFrontend(AVP_StateMachine_Core& xParentMachine)
		: PARENT(xParentMachine)
	{
	}
//	virtual ~AVP_State_DevelopmentFrontend();

	// Overridden functions...
	virtual	void Enter(const u_int uPreviousState);
	virtual	void Update();
	virtual	void Render() const;
	virtual	void Exit(const u_int uNextState);

	virtual	const char*	GetName(void) const	{ return("Development Frontend"); }

protected:

private:

};   // End of class 'AVP_CoreState_DevelopmentFrontend'.

#endif	// defined(AVP_USE_DEVELOPMENT_FRONT_END)

#endif   // ifndef __AVP_CORESTATE_DEVELOPMENTFRONTEND_H__


/// End of file. ///
