
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_CoreState_Game.h
// Author : Anthony Gregson
// Date   : 21/11/07
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_CORESTATE_GAME_H__
#define __AVP_CORESTATE_GAME_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/States/Core/AVP_State_Core.h"

#include "Core/AVP_Connection.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class AVP_StateMachine_Core;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_CoreState_Game
// Author       : Andy Tate
// Date         : 12-Mar-2007
//
// Description  : Class to handle network connection.
////////////////////////////////////////////////////////////////////////////////

class AVP_CoreState_Game : public AVP_State_Core
{
	typedef AVP_State_Core PARENT;

public:
	// Public functions...
	AVP_CoreState_Game(AVP_StateMachine_Core& xParentMachine);
//	virtual ~AVP_CoreState_Game();

	// Overridden functions...
	virtual	void Enter(const u_int uPreviousState);
	virtual	void Update();
	virtual	void Render() const;
	virtual	void Exit(const u_int uNextState);

	virtual	const char*	GetName(void) const	{ return("Game"); }

	virtual void RequestQuitApplication();

protected:
	// Sub-state machine
	AVP_Connection m_xConnection;

private:

};   // End of class 'AVP_CoreState_Game'.


#endif   // ifndef __AVP_CORESTATE_GAME_H__


/// End of file. ///
