///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_CoreState_MultiplayerLobby.h
// Author : Anthony Gregson
// Date   : 21/11/07
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_CORESTATE_MULTIPLAYERLOBBY_H__
#define __AVP_CORESTATE_MULTIPLAYERLOBBY_H__

#if defined(ASURA_SUPPORT_LOBBY)

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/States/AVP_State.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class AVP_StateMachine;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class  : AVP_CoreState_MultiplayerLobby
// Author : Anthony Gregson
// Date   : 21/11/07
////////////////////////////////////////////////////////////////////////////////

class AVP_CoreState_MultiplayerLobby : public AVP_State
{
	typedef AVP_State PARENT;

public:
	// Public functions...
	AVP_CoreState_MultiplayerLobby(AVP_StateMachine& xParentMachine)
		: PARENT(xParentMachine)
	{
	}
	//	virtual ~AVP_CoreState_MultiplayerLobby();

	// Overridden functions...
	virtual	void Enter(const u_int uPreviousState);
	virtual	void Update();
	virtual	void Render() const;
	virtual	void Exit(const u_int uNextState);

	virtual	const char*	GetName(void) const	{ return("Game Frontend"); }


protected:

private:

};   // End of class 'AVP_CoreState_MultiplayerLobby'.

#endif	//defined(ASURA_SUPPORT_LOBBY)

#endif   // ifndef __AVP_CORESTATE_MULTIPLAYERLOBBY_H__


/// End of file. ///
