///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_StateMachine_GameFrontend.cpp
// Author : Rav Tharanee
// Date   : 25/02/09
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

#if defined(AVP_USE_GAME_FRONTEND) || defined(ASURA_SUPPORT_LOBBY)

// This file's header...
#include "Core/States/Core/AVP_StateMachine_GameFrontend.h"

// Game independent header-files...
#include "Core/AVP_Core.h"
#if defined(AVP_USE_GAME_FRONTEND)
#include "Core/States/AVP_State_FMV.h"
#include "Core/States/Core/AVP_CoreState_Frontend.h"
#include "Core/States/Core/AVP_CoreState_LoadingFrontend.h"
#endif	//defined(AVP_USE_GAME_FRONTEND)
#if defined(ASURA_SUPPORT_LOBBY)
#include "Core/States/Core/AVP_CoreState_MultiplayerLobby.h"
#endif	//defined(ASURA_SUPPORT_LOBBY)
#if defined(AVP_USE_GAME_FRONTEND)
#include "FrontEnd/AVP_GameFrontEnd.h"
#endif	//defined(AVP_USE_GAME_FRONTEND)
#include "GUIMenu/AVP_GUIMenu_System.h"

AVP_StateMachine_GameFrontend::AVP_StateMachine_GameFrontend( void ) : AVP_StateMachine( AVP_StateMachine_GameFrontend::MAX_STATES )
{
#if defined(AVP_USE_GAME_FRONTEND)
	RegisterState(STATE_LOADINGFRONTEND, new AVP_CoreState_LoadingFrontend(*this));
	RegisterState(STATE_FRONTEND, new AVP_CoreState_Frontend(*this));
#endif	//defined(AVP_USE_GAME_FRONTEND)
#if defined(ASURA_SUPPORT_LOBBY)
	RegisterState(STATE_MULTIPLAYERLOBBY, new AVP_CoreState_MultiplayerLobby(*this));
#endif	//defined(ASURA_SUPPORT_LOBBY)
}

void AVP_StateMachine_GameFrontend::Initialise()
{
	PARENT::Initialise();
	ChangeState( STATE_LOADINGFRONTEND );
}

void AVP_StateMachine_GameFrontend::Update( void )
{
	PARENT::Update();
}

void AVP_StateMachine_GameFrontend::Shutdown()
{
	PARENT::Shutdown();

#if defined(AVP_USE_GAME_FRONTEND)
	AVP_GameFrontEnd::Shutdown();
#endif	//defined(AVP_USE_GAME_FRONTEND)

	AVP_Core::ShutdownEffects();
	AVP_Core::Reset();
}

void	AVP_StateMachine_GameFrontend::RequestQuitApplication( void )
{
	ChangeState( STATE_SHUTTINGDOWN );
}

#endif	//defined(AVP_USE_GAME_FRONTEND) || defined(ASURA_SUPPORT_LOBBY)
