
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_State_Core.cpp
// Author : Anthony Gregson
// Date   : 21/11/07
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header
#include "Core/States/Core/AVP_State_Core.h"

// Asura includes

// Project includes
#include "Core/AVP_StateMachine_Core.h"

AVP_State_Core::AVP_State_Core(AVP_StateMachine_Core& xParentMachine)
: PARENT(xParentMachine)
{
}

AVP_StateMachine_Core& AVP_State_Core::GetParentCoreMachine()
{
	return static_cast<AVP_StateMachine_Core&>(m_xParentMachine);
}

const AVP_StateMachine_Core& AVP_State_Core::GetParentCoreMachine() const
{
	return static_cast<const AVP_StateMachine_Core&>(m_xParentMachine);
}

void AVP_State_Core::RequestQuitApplication()
{
	// By default, we can just change state to shutting down.
	GetParentMachine().ChangeState(AVP_StateMachine_Core::STATE_SHUTTINGDOWN);
}

/// End of file. ///
