
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_State_Playing.h
// Author : Anthony Gregson
// Date   : 03/12/07
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_STATE_PLAYING_H__
#define __AVP_STATE_PLAYING_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/States/AVP_State.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class AVP_StateMachine_Playing;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class  : AVP_State_Playing
// Author : Anthony Gregson
// Date   : 03/12/07
////////////////////////////////////////////////////////////////////////////////

class AVP_State_Playing : public AVP_State
{
public:
	// Public functions...
	AVP_State_Playing(AVP_StateMachine_Playing& xParentMachine);
	virtual ~AVP_State_Playing() {}

	// Since we can only create one of these using a playing state machine, add standard functions to cast straight to that type in case one of the subclasses needs to access playing machine-only values.
	AVP_StateMachine_Playing& GetParentPlayingMachine();
	const AVP_StateMachine_Playing& GetParentPlayingMachine() const;

private:
	typedef AVP_State PARENT;
};   // End of class 'AVP_State_Playing'.


#endif   // ifndef __AVP_STATE_PLAYING_H__


/// End of file. ///
