
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Cutscene.h
// Author : Andy Tate
// Date   : 15-Jul-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_CUTSCENE_H__
#define __AVP_CUTSCENE_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

// Asura
#include "Cutscene/Asura_Cutscene.h"

// AVP
#include "Core/AVP_Settings.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Cutscene
// Author       : Andy Tate
// Date         : 15-Jul-2008
//
// Description  : Class used to handle AvP3 specific cut-scenes.
////////////////////////////////////////////////////////////////////////////////

class AVP_Cutscene : public Asura_Cutscene
{
public:
	// Public functions...
	AVP_Cutscene(const Asura_String& xName)	: PARENT(xName)	{}
	//virtual ~AVP_Cutscene();

	// Overridden functions...
	virtual void RenderSubtitle(const Asura_UnicodeChar* wszText, float fAlpha) const
	{
		if(AVP_Settings::GetCurrentProfile()->GetSounds().GetShowSubtitles())
		{
			PARENT::RenderSubtitle(wszText, fAlpha);
		}
	}


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private typedefs...
	typedef Asura_Cutscene PARENT;

	// Private variables...

	// Private functions...
	AVP_Cutscene(void);
	AVP_Cutscene(const AVP_Cutscene& xOther);

	AVP_Cutscene&	operator=(const AVP_Cutscene& xOther);

};   // End of class 'AVP_Cutscene'.


#endif   // ifndef __AVP_CUTSCENE_H__


/// End of file. ///
