//////////////////////////////////////////////////////////////////////////////
//
// AVP_ServerEntity_Squad_FaceHugger.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_SERVERENTITY_SQUAD_FACEHUGGER_H__
#define __AVP_SERVERENTITY_SQUAD_FACEHUGGER_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// asura
#include "Core/Asura_List.h"
#include "Core/Asura_Maths.h"

// avp
#include "Entity/Controller/AVP_ServerEntity_Squad.h"

// axon
#include "Core/AxonAVP_Messages.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_ServerActor_FaceHugger;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_ServerEntity_Squad_FaceHugger
//
//////////////////////////////////////////////////////////////////////////////

class AVP_ServerEntity_Squad_FaceHugger : public AVP_ServerEntity_Squad
{
	typedef AVP_ServerEntity_Squad PARENT;
	friend class ToolsAVP_Entity_Squad_FaceHugger;

public:
	AVP_ServerEntity_Squad_FaceHugger( Asura_Guid uGuid );
	virtual ~AVP_ServerEntity_Squad_FaceHugger();

	virtual void InitialiseFromBlueprint( const Asura_Blueprint& xBlueprint );
	virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );
	virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;
	virtual bool HandleMessage( const Asura_Message* pxMessage );

	const AVP_FaceHuggerBehaviourData& GetBehaviourData() const { return m_xBehaviourData; }

#ifdef ASURA_TOOLS
	virtual bool CanBeIncludedInTemplate() const { return ( this != s_pxDefaultSquad && this != s_pxDefaultPetSquad ); }
#endif

	static AVP_ServerEntity_Squad_FaceHugger* FindEntity( const Asura_Guid uGuid, const bool bIgnoreDestroyed = true ) { return s_xList.FindEntity( uGuid, bIgnoreDestroyed ); }
	static Asura_Hashed_List< AVP_ServerEntity_Squad_FaceHugger >* GetList() { return &s_xList; }
	static AVP_ServerEntity_Squad_FaceHugger* GetDefaultSquad() { return s_pxDefaultSquad; }
	static AVP_ServerEntity_Squad_FaceHugger* GetDefaultPetSquad() { return s_pxDefaultPetSquad; }
	static void InitialiseMempools();
	static void ShutdownMempools();

	Asura_LinkList_ConstIt< Asura_Guid > GetGPVolumeIDIter() const;

private:
	virtual void* AllocateMemberData( const Asura_Guid uMemberGuid );
	virtual void  ReturnMemberData( void* pData );

	struct MemberData
	{
		u_int uDummy;
		void Reset() {}
	};

	AVP_FaceHuggerBehaviourData m_xBehaviourData;

	Asura_LinkList< Asura_Guid > m_xGPVolumesIDList;

	static Asura_Hashed_List< AVP_ServerEntity_Squad_FaceHugger > s_xList;
	static Asura_Mempool* s_pxMemberDataMempool;
	static AVP_ServerEntity_Squad_FaceHugger* s_pxDefaultSquad;
	static AVP_ServerEntity_Squad_FaceHugger* s_pxDefaultPetSquad;

	static const u_int uCURRENT_CHUNK_VERSION = 2;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_SERVERENTITY_SQUAD_FACEHUGGER_H__
