
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_ClientEntity_AcidDamage.h
// Author : Andy Tate
// Date   : 28-Feb-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_CLIENTENTITY_ACIDDAMAGE_H__
#define __AVP_CLIENTENTITY_ACIDDAMAGE_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/Asura_Entity_Renderable.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class Asura_Message;

class AVP_Message_AcidDamage_Create;


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_ClientEntity_AcidDamage
// Author       : Andy Tate
// Date         : 28-Feb-2008
//
// Description  : Client-side class to handle displaying of acid-damage.
////////////////////////////////////////////////////////////////////////////////

class AVP_ClientEntity_AcidDamage : public Asura_Entity_Renderable
{
public:
	// Public typedefs...
	typedef Asura_Classified_List<AVP_ClientEntity_AcidDamage> AcidDamageList;

	// Public functions...
	static AVP_ClientEntity_AcidDamage*	Create(const Asura_Message* pxMessage);

	// Overridden functions...
	virtual void	Update(void);

	// Accessor functions...
	static AVP_ClientEntity_AcidDamage*	FindEntity(const Asura_Guid uGuid)	{ return(s_xList.FindEntity(uGuid)); }
	static const AcidDamageList&		GetList(void)						{ return(s_xList); }


protected:
	// Protected variables...

	// Protected functions...
	AVP_ClientEntity_AcidDamage(const AVP_Message_AcidDamage_Create& xMessage);
	virtual ~AVP_ClientEntity_AcidDamage();

	// Overridden functions...
	virtual void	Render(void);


private:
	// Private typedefs...
	typedef Asura_Entity_Renderable PARENT;

	// Private variables...
	u_int			m_uPFXHandle;
	Asura_Vector_3	m_xSurfaceNormal;
	Asura_Vector_3	m_xPosition;

	// Static variables...
	static AcidDamageList	s_xList;

	// Private functions...
	AVP_ClientEntity_AcidDamage(void);
	AVP_ClientEntity_AcidDamage(const AVP_ClientEntity_AcidDamage& xOther);

	AVP_ClientEntity_AcidDamage&	operator=(const AVP_ClientEntity_AcidDamage& xOther);

};   // End of class 'AVP_ClientEntity_AcidDamage'.


#endif   // ifndef __AVP_CLIENTENTITY_ACIDDAMAGE_H__


/// End of file. ///
