//--------------------------------------------------------------------------------------
//	File	:	AVP_ServerNode_FleePoint.h
//	Author	:	Gareth Thomas
//	Created	:	06 / 03 / 08
//	Copyright (C) 2006 Rebellion, All Rights Reserved.
//--------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------
// BEGIN FILE WRAPPER
#ifdef ASURA_USE_PRAGMA_ONCE 
#pragma once
#endif
#ifndef __AVP_SERVERNODE_FLEEPOINT_H__
#define __AVP_SERVERNODE_FLEEPOINT_H__ 1
// END FILE WRAPPER
//--------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------
//	INCLUDES
//--------------------------------------------------------------------------------------
#include "Entity/Locations/Asura_ServerEntity_Node.h"

//--------------------------------------------------------------------------------------
//	Class	:	AVP_ServerNode_FleePoint
//	Created	:	18 / 12 / 07
//	Author	:	Gareth Thomas
//--------------------------------------------------------------------------------------
class AVP_ServerNode_FleePoint : public Asura_ServerEntity_Node
{

public:

	// Public Overridden functions...
	virtual void						WriteToChunkStream		(Asura_Chunk_Stream& xStream) const;
	virtual void						ReadFromChunkStream		(Asura_Chunk_Stream& xStream);
	virtual bool 						CanBeSavedToChunk		(void) const							{return(true);}
	virtual bool						IsFilledFromChunkBuffer	(void) const							{return(false);}
	virtual bool						HasClientEntities		(void) const							{return (false);}
	virtual void						PostLoadInitialise		(void);

	// Public Static Functions...
	static AVP_ServerNode_FleePoint*								Create(const Asura_Guid uGuid);
	static AVP_ServerNode_FleePoint*								FindEntity(Asura_Guid uGuid)			{return s_xList.FindEntity(uGuid);}
	static const Asura_Hashed_List<AVP_ServerNode_FleePoint>*		GetList(void)							{return &s_xList;}

#ifdef ASURA_TOOLS
	virtual void ApplyChangesForTemplateInstance(class Tools_EntityTemplateInstance* pxInstance);
	virtual bool CanBeIncludedInTemplate() const { return true; }
#endif

	u_int		GetNumFleeActions	( void )									{ return m_uNumFleeActions; }
	Asura_Guid	GetFleeActionGuid	( u_int uIndex )							{ return m_pxFleeActions[ uIndex ]; }
	void		SetActionGuids		(Asura_Guid* pxGuids, u_int uNumGuids);

protected:

	// Construction / Destruction
	AVP_ServerNode_FleePoint(const Asura_Guid uGuid);
	virtual ~AVP_ServerNode_FleePoint(void);

private:

	Asura_Guid*					m_pxFleeActions;
	u_int						m_uNumFleeActions;

	// Friend classes
	friend class ToolsAVP_Node_FleePoint;

	// Private typedefs
	typedef Asura_ServerEntity_Node PARENT;

	// Chunk Version
	enum { CURRENT_CHUNK_VERSION = 1 };

	// Private statics
	static Asura_Hashed_List<AVP_ServerNode_FleePoint> s_xList;
};

#endif   // __AVP_SERVERNODE_FLEEPOINT_H__
