//--------------------------------------------------------------------------------------
//	File	:	AVP_ServerEntity_LookAt.h
//	Author	:	Gareth Thomas
//	Created	:	18 / 12 / 2007
//	Copyright (C) 2006 Rebellion, All Rights Reserved.
//--------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------
// BEGIN FILE WRAPPER
#ifdef ASURA_USE_PRAGMA_ONCE 
#pragma once
#endif
#ifndef __AVP_SERVERENTITY_LOOKAT_H__
#define __AVP_SERVERENTITY_LOOKAT_H__ 1
// END FILE WRAPPER
//--------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------
//	INCLUDES
//--------------------------------------------------------------------------------------
#include "Entity/Locations/Asura_ServerEntity_Node.h"

//--------------------------------------------------------------------------------------
//	Class	:	AVP_ServerEntity_LookAt
//	Created	:	18 / 12 / 07
//	Author	:	Gareth Thomas
//--------------------------------------------------------------------------------------
class AVP_ServerEntity_LookAt : public Asura_ServerEntity_Node
{

public:

	// Public Overridden functions...
	virtual void						WriteToChunkStream		(Asura_Chunk_Stream& xStream) const;
	virtual void						ReadFromChunkStream		(Asura_Chunk_Stream& xStream);
	virtual bool 						CanBeSavedToChunk		(void) const							{return(true);}
	virtual bool						IsFilledFromChunkBuffer	(void) const							{return(false);}
	virtual bool						HasClientEntities		(void) const							{return (false);}
	virtual void						PostLoadInitialise		(void);

	// Public Member Functions...
	Asura_Guid							GetLinkedLookAt			(void)									{return m_uLinkedLookAt;}
	void								SetLinkedLookAt			(Asura_Guid uLookAt)					{m_uLinkedLookAt = uLookAt;}

	// Public Static Functions...
	static AVP_ServerEntity_LookAt*								Create(const Asura_Guid uGuid);
	static AVP_ServerEntity_LookAt*								FindEntity(Asura_Guid uGuid)			{return s_xList.FindEntity(uGuid);}
	static const Asura_Hashed_List<AVP_ServerEntity_LookAt>*	GetList(void)							{return &s_xList;}

#ifdef ASURA_TOOLS
	virtual void ApplyChangesForTemplateInstance(class Tools_EntityTemplateInstance* pxInstance);
	virtual bool CanBeIncludedInTemplate() const { return true; }
#endif

protected:

	// Construction / Destruction
	AVP_ServerEntity_LookAt(const Asura_Guid uGuid);
	virtual ~AVP_ServerEntity_LookAt(void);

private:

	// Friend classes
	friend class ToolsAVP_Entity_LookAt;

	// Private typedefs
	typedef Asura_ServerEntity_Node PARENT;

	// Chunk Version
	enum { CURRENT_CHUNK_VERSION = 0 };

	// Private statics
	static Asura_Hashed_List<AVP_ServerEntity_LookAt> s_xList;

	// Private member variables
	Asura_Guid					m_uLinkedLookAt;
};

#endif   // ifndef __AVP_SERVERENTITY_LOOKAT_H__
