//////////////////////////////////////////////////////////////////////////////
//
// AVP_ServerNode_VantagePoint.cpp
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// core
#include "Core/Asura.h"

// header
#include "Entity/Locations/VantagePoint/AVP_ServerNode_VantagePoint.h"

// asura
#include "ChunkSystem/Asura_Chunk_Stream.h"

//////////////////////////////////////////////////////////////////////////////
//
// AVP_ServerNode_VantagePoint
//
//////////////////////////////////////////////////////////////////////////////

AVP_ServerNode_VantagePoint::AVP_ServerNode_VantagePoint( Asura_Guid uGuid )
: PARENT( uGuid )
, m_bHasValidOrientation(true)
{
}

void AVP_ServerNode_VantagePoint::WriteToChunkStream( Asura_Chunk_Stream& xStream ) const
{
	xStream << CURRENT_CHUNK_VERSION;

	PARENT::WriteToChunkStream( xStream );
}

void AVP_ServerNode_VantagePoint::ReadFromChunkStream( Asura_Chunk_Stream& xStream )
{
	u_int uVersion;
	xStream >> uVersion;

	if (uVersion == CURRENT_CHUNK_VERSION)
	{
		PARENT::ReadFromChunkStream( xStream );
	}
	else if (uVersion == 0)
	{
		m_bHasValidOrientation = false;
		Asura_ServerEntity_Node::ReadFromChunkStream( xStream );
	}
}

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////
