//////////////////////////////////////////////////////////////////////////////
//
// AVP_ServerNode_VantagePoint.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_SERVERNODE_VANTAGEPOINT_H__
#define __AVP_SERVERNODE_VANTAGEPOINT_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// asura
#include "Entity/Locations/OrientedNode/Asura_ServerNode_OrientedNode.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Chunk_Stream;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_ServerNode_VantagePoint
//
//////////////////////////////////////////////////////////////////////////////

class AVP_ServerNode_VantagePoint : public Asura_ServerNode_OrientedNode
{
	typedef Asura_ServerNode_OrientedNode PARENT;

public:
	AVP_ServerNode_VantagePoint( Asura_Guid uGuid );

	virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;
	virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );

	// helper function for transition from version 0 that was inheriting from Asura_ServerEntity_Node
	bool HasValidOrientation() { return m_bHasValidOrientation; }

private:
	bool m_bHasValidOrientation;
	enum { CURRENT_CHUNK_VERSION = 1 };
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_SERVERNODE_VANTAGEPOINT_H__
