//////////////////////////////////////////////////////////////////////////////
//
// AVP_PlayerObjective_LocationMarker.h
//
// Created by AJK 25/02/2009
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef AVP_PLAYEROBJECTIVE_LOCATIONMARKER
#define AVP_PLAYEROBJECTIVE_LOCATIONMARKER

// Asura
#include "Core/Asura_Maths.h"
#include "Entity/Asura_Entity.h"
#include "Network/Asura_Guid.h"

class AVP_ServerEntity_LocationMarker : public Asura_Entity_Server
{
public:

	static AVP_ServerEntity_LocationMarker*						     Create(Asura_Guid uGuid)	   { return new AVP_ServerEntity_LocationMarker(uGuid); }
	static AVP_ServerEntity_LocationMarker*						     FindEntity(Asura_Guid uGuid)  { return s_xList.FindEntity(uGuid); }
	static const Asura_Hashed_List<AVP_ServerEntity_LocationMarker>* GetList()            		   { return &s_xList; }
	
	virtual void						WriteToChunkStream						( Asura_Chunk_Stream& xStream ) const;
	virtual void						ReadFromChunkStream						( Asura_Chunk_Stream& xStream );
	virtual bool 						CanBeSavedToChunk						( void ) const						{ return ( true ); }
	virtual bool						IsFilledFromChunkBuffer					( void ) const						{ return ( false ); }
	virtual bool						HasClientEntities						( void ) const						{ return ( false ); }

	void                  SetPosition ( const Asura_Vector_3& xPos ) { m_xPosition = xPos; }
	const Asura_Vector_3& GetPosition() const { return m_xPosition; }
	void                  SetPlayerObjectiveGuid ( Asura_Guid uGuid ) { m_uPlayerObjectiveGuid = uGuid; }
	Asura_Guid            GetPlayerObjectiveGuid() const { return m_uPlayerObjectiveGuid; }

protected:

	AVP_ServerEntity_LocationMarker( const Asura_Guid uGuid);
	virtual ~AVP_ServerEntity_LocationMarker(void);

private:

	enum { CURRENT_CHUNK_VERSION };

	Asura_Guid     m_uPlayerObjectiveGuid;
	Asura_Vector_3 m_xPosition;


	static Asura_Hashed_List < AVP_ServerEntity_LocationMarker > s_xList;
	friend class ToolsAVP_Entity_LocationMarker;

	typedef Asura_Entity_Server PARENT;
};

#endif // #ifndef AVP_OBJECTIVE_LOCATIONMARKER