//////////////////////////////////////////////////////////////////////////////
//
// AVP_ClientActor_Vehicle.h
//
// Copyright (c) 2007 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef AVP_CLIENTACTOR_VEHICLE_H___
#define AVP_CLIENTACTOR_VEHICLE_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

// Asura
#include "Sound/Asura_Sound_Event_System.h"

// AVP
#include "Actor/AVP_Actor_DynamicStat.h"
#include "Actor/Vertebrates/Human/AVP_Human_Description.h"
#include "Entity/PhysicalObject/Actor/AVP_ClientEntity_Actor.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Collision_Object;
class Asura_Message;

class AVP_Message_Actor_ClientUpdate;
class AVP_Movement_System;

// C L A S S E S /////////////////////////////////////////////////////////////

class AVP_ClientActor_Vehicle : public AVP_ClientEntity_Actor
{
public:
	// Public functions...
	virtual	bool HandleMessage(const Asura_Message* pxMessage);

	// Static list functions...
	static AVP_ClientActor_Vehicle* FindEntity( Asura_Guid uGUID )				{ return s_xList.FindEntity( uGUID ); }
	static const Asura_Hashed_List<AVP_ClientActor_Vehicle>* GetList( void )		{ return &s_xList; }

protected:
	// Protected functions...
	void ProcessClientUpdate(const AVP_Message_Actor_ClientUpdate* pxData, float fServerTime, bool bProcessPosAndOri = true);

	AVP_ClientActor_Vehicle(const u_short usFlagsToIgnore);
	virtual ~AVP_ClientActor_Vehicle();

private:
	// Private typedefs...
	typedef AVP_ClientEntity_Actor PARENT;

	static Asura_Hashed_List<AVP_ClientActor_Vehicle> s_xList;

	// Private functions...
};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef AVP_CLIENTACTOR_VEHICLE_H___
