//////////////////////////////////////////////////////////////////////////////
//
// AVP_ServerActor_Vehicle.cpp
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header.
#include "Entity/PhysicalObject/Actor/Vehicles/AVP_ServerActor_Vehicle.h"

// Engine independent.
#include "Affectors/Asura_Affector.h"
#include "Affectors/Asura_Affector_System.h"
#include "ChunkSystem/Asura_Chunk_Stream.h"
#include "Core/Asura_Timers.h"
#include "Mesh/Asura_Env_System.h"
#include "Network/Asura_Network.h"
#include "Network/Asura_Message.h"
#include "Shapes/Asura_Shape_System.h"
#include "Physics/Asura_Physics.h"
#include "Camera/Asura_Camera.h"

// Project independent.
#include "Actor/AVP_Actor_InputHandler.h"
#include "Core/AVP_Settings.h"
#include "Entity/AVP_Entity_Classification.h"
#include "Entity/AVP_Messages.h"
#include "Entity/PhysicalObject/Actor/AVP_Actor_Messages.h"
#include "Moves/AVP_Movement_System.h"
//#include "Entity/Controller/AVP_ServerEntity_AIPointController.h"

// Axon
#include "Core/Axon_Messages.h"
#include "Core/Axon_System.h"
#include "Core/Axon_Sound_Registry.h"
#include "Core/BrainTypes/Axon_Project_Brain.h"
#include "Behaviour/BehaviourTypes/AVP_Behaviour_Types.h"

// Constant variables...

// Static variables...
Asura_Hashed_List<AVP_ServerActor_Vehicle> AVP_ServerActor_Vehicle::s_xList(2);

// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

AVP_ServerActor_Vehicle::AVP_ServerActor_Vehicle(const u_short usFlagsToIgnore,
												 const Asura_Guid uGUID)
: Asura_Entity_Server(uGUID)
, PARENT(usFlagsToIgnore, uGUID)
{
	Classification = AVP_ENTITYCLASS_VEHICLE;

	// Add to the list...
	s_xList.AddToList(this);
}

AVP_ServerActor_Vehicle::~AVP_ServerActor_Vehicle ()
{
	// Remove from the list...
	s_xList.RemoveFromList(this);
}

void AVP_ServerActor_Vehicle::Update()
{
    PARENT::Update();
}

/// End of file. ///
