///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_ClientActor_Marine.cpp
// Author : Gareth Thomas
// Modified to Marine : Chris Wallace
// Date   : 12 / 02 / 2008
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////
#include "Core/Asura.h"

// This file's header...
#include "Entity/PhysicalObject/Actor/Vertebrates/Human/Marine/AVP_ClientActor_Marine.h"

// Game independent header-files...
#include "Entity/AVP_Entity_Classification.h"

////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////
Asura_Hashed_List<AVP_ClientActor_Marine>	AVP_ClientActor_Marine::s_xList;

//------------------------------------------------------------------------------
// AVP_ClientActor_Marine:: Constructor
//------------------------------------------------------------------------------
AVP_ClientActor_Marine::AVP_ClientActor_Marine(void)
: AVP_ClientActor_Human()
{
	Classification = AVP_ENTITYCLASS_MARINE;

	// Don't forget to store us in the list...
	s_xList.AddToList(this);
}
/// End of function 'AVP_ClientActor_Marine::AVP_ClientActor_Marine'. ///

//------------------------------------------------------------------------------
// AVP_ServerActor_Marine:: Deconstructor
//------------------------------------------------------------------------------
AVP_ClientActor_Marine::~AVP_ClientActor_Marine ()
{
	// Don't forget to remove us from the list...
	s_xList.RemoveFromList(this);
}
/// End of function 'AVP_ClientActor_Marine::~AVP_ClientActor_Marine'. ///

//------------------------------------------------------------------------------
// AVP_ServerActor_Marine:: Create
//------------------------------------------------------------------------------
AVP_ClientActor_Marine* AVP_ClientActor_Marine::Create(const Asura_Message* pxMessage)
{
	AVP_ClientActor_Marine*	pxClient	= new AVP_ClientActor_Marine;

	// Initialise the entity...
	pxClient->HandleMessage(pxMessage);

	// Return the entity...
	return(pxClient);

}
/// End of function 'AVP_ClientActor_Marine::Create'. ///

/// End of file. ///
