///////////////////////////////////////////////////////////////////////////////
// File   : AVP_ClientActor_Marine.h
// Author : Gareth Thomas
// Date   : 12 / 02 / 2008
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_CLIENTACTOR_MARINE_H__
#define __AVP_CLIENTACTOR_MARINE_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/Actor/Vertebrates/Human/AVP_ClientActor_Human.h"
#include "Sound/Asura_Sound_Event_System.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////
class AVP_ClientActor_Human;

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_ClientActor_Marine
// Author       : Gareth Thomas
// Date         : 12 / 02 / 2008
// Description  : This class handles the operation of the Marine actor, the
//				  Marine is AI controlled.
////////////////////////////////////////////////////////////////////////////////
class AVP_ClientActor_Marine : public AVP_ClientActor_Human
{

public:

	// Public functions...
	static	AVP_ClientActor_Marine*	Create	(const Asura_Message* pxMessage);

	// Static Public Functions...
	static	AVP_ClientActor_Marine*							FindEntity	(const Asura_Guid uGuid)	{ return(s_xList.FindEntity(uGuid)); }
	static	const Asura_Hashed_List<AVP_ClientActor_Marine>*	GetList		(void)						{ return(&s_xList); }


protected:		

	// Protected functions...
	AVP_ClientActor_Marine         (void);
	virtual ~AVP_ClientActor_Marine	();

private:

	// Private typedefs...
	typedef AVP_ClientActor_Human PARENT;

	// Static Private Member variables
	static	Asura_Hashed_List<AVP_ClientActor_Marine>	s_xList;

	// Private functions...
	AVP_ClientActor_Marine (const AVP_ClientActor_Marine& xOther);
	AVP_ClientActor_Marine&	operator=	(const AVP_ClientActor_Marine& xOther);

};   // End of class 'AVP_ClientActor_Marine'.

#endif   // ifndef __AVP_CLIENTACTOR_MARINE_H__

/// End of file. ///
