//////////////////////////////////////////////////////////////////////////////
//
// AVP_Sentrygun_Messages.h
//
// Copyright (c) 2007 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef AVP_SENTRYGUN_MESSAGES__
#define AVP_SENTRYGUN_MESSAGES__ 1

#include "Entity/PhysicalObject/Actor/AVP_Actor_Messages.h"
#include "Entity/PhysicalObject/Actor/Weapons/Sentrygun/AVP_ClientWeapon_Sentrygun.h"

class AVP_ServerWeapon_Sentrygun;

////////////////////////////////////////////////////////////////////////////////
// Class : AVP_Message_Sentrygun_PlaySound
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_Sentrygun_PlaySound
{
	public:
		AVP_ClientWeapon_Sentrygun::Sound GetSound() const { return m_eSound; }
		void SetSound( const AVP_ClientWeapon_Sentrygun::Sound eSound ) { m_eSound = eSound; }

	private:
		AVP_ClientWeapon_Sentrygun::Sound m_eSound;

		AVP_Message_Sentrygun_PlaySound();
};

////////////////////////////////////////////////////////////////////////////////
// Class : AVP_Message_SentryGun_ClientUpdate
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_SentryGun_ClientUpdate : public AVP_Message_Actor_ClientUpdate
{
	public:
		// Accessor functions...
		bool GetLightOn() const		{ return m_bLightOn; }
		void SetLightOn( bool bLightOn )	{ m_bLightOn = bLightOn; } 

		void FillSentryGun( const AVP_ServerWeapon_Sentrygun &xSentryGun );

	#ifdef ASURA_SUPPORT_NETMSG_SYSTEM
		static void RegisterFields( u_short usMsgID, u_short usEntityClassification );
		static void RegisterFields( Asura_NetMsg* pxNetMsg );
		static u_char GetNumFields() { return static_cast<u_char>( 1 + AVP_Message_Actor_ClientUpdate::GetNumFields() ); }
	#endif//#ifdef ASURA_SUPPORT_NETMSG_SYSTEM

	private:
		bool m_bLightOn;
};

////////////////////////////////////////////////////////////////////////////////
// Class	: AVP_Message_SentryGun_Set_SweepSpeed
// Author	: Callum Hope CAH
//	
// Desc		: STATIC MESSAGE FOR INITIALISATION THROUGH TEMPLATE [ 1 / 6 ]
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_SentryGun_Set_SweepSpeed
{
	public:

		// CHANGE THE DATA - CHANGE THE VERSION!
		enum { CURRENT_MSG_VERSION = 0 };

		void Initialise()
		{
			m_uVersion = CURRENT_MSG_VERSION;
			m_fSpeed = 0.5f;
		}

		u_int m_uVersion;
		float m_fSpeed;		
};

////////////////////////////////////////////////////////////////////////////////
// Class	: AVP_Message_SentryGun_Set_VisionRange
// Author	: Callum Hope CAH
//	
// Desc		: STATIC MESSAGE FOR INITIALISATION THROUGH TEMPLATE [ 2 / 6 ]
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_SentryGun_Set_VisionRange
{
	public:

		// CHANGE THE DATA - CHANGE THE VERSION!
		enum { CURRENT_MSG_VERSION = 0 };

		void Initialise()
		{
			m_uVersion = CURRENT_MSG_VERSION;
			m_fRange = 100.0f;
		}

		u_int m_uVersion;
		float m_fRange;		
};

////////////////////////////////////////////////////////////////////////////////
// Class	: AVP_Message_SentryGun_Set_HorizontalFOV
// Author	: Callum Hope CAH
//	
// Desc		: STATIC MESSAGE FOR INITIALISATION THROUGH TEMPLATE [ 3 / 6 ]
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_SentryGun_Set_HorizontalFOV
{
	public:

		// CHANGE THE DATA - CHANGE THE VERSION!
		enum { CURRENT_MSG_VERSION = 0 };

		void Initialise()
		{
			m_uVersion = CURRENT_MSG_VERSION;
			m_fHorFov = 30.0f;
		}

		u_int m_uVersion;
		float m_fHorFov;		
};

////////////////////////////////////////////////////////////////////////////////
// Class	: AVP_Message_SentryGun_Set_VerticalFOV
// Author	: Callum Hope CAH
//	
// Desc		: STATIC MESSAGE FOR INITIALISATION THROUGH TEMPLATE [ 4 / 6 ]
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_SentryGun_Set_VerticalFOV
{
	public:

		// CHANGE THE DATA - CHANGE THE VERSION!
		enum { CURRENT_MSG_VERSION = 0 };

		void Initialise()
		{
			m_uVersion = CURRENT_MSG_VERSION;
			m_fVerFov = 30.0f;
		}

		u_int m_uVersion;
		float m_fVerFov;		
};

////////////////////////////////////////////////////////////////////////////////
// Class	: AVP_Message_SentryGun_Set_FiringArc
// Author	: Callum Hope CAH
//	
// Desc		: STATIC MESSAGE FOR INITIALISATION THROUGH TEMPLATE [ 5 / 6 ]
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_SentryGun_Set_FiringArc
{
	public:

		// CHANGE THE DATA - CHANGE THE VERSION!
		enum { CURRENT_MSG_VERSION = 0 };

		void Initialise()
		{
			m_uVersion = CURRENT_MSG_VERSION;
			m_fArc = 80.0f;
		}

		u_int m_uVersion;
		float m_fArc;		
};

////////////////////////////////////////////////////////////////////////////////
// Class	: AVP_Message_SentryGun_Set_LethalRange
// Author	: Callum Hope CAH
//	
// Desc		: STATIC MESSAGE FOR INITIALISATION THROUGH TEMPLATE [ 6 / 6 ]
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_SentryGun_Set_LethalRange
{
	public:

		// CHANGE THE DATA - CHANGE THE VERSION!
		enum { CURRENT_MSG_VERSION = 0 };

		void Initialise()
		{
			m_uVersion = CURRENT_MSG_VERSION;
			m_fRange = 0.0f;
		}

		u_int m_uVersion;
		float m_fRange;		
};

////////////////////////////////////////////////////////////////////////////////
// Class	: AVP_Message_SentryGun_Switch_PlayAninmation
// Author	: Callum Hope CAH
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_SentryGun_Switch_PlayAninmation
{
public:
	Asura_Hash_ID GetAnimHash() const { return m_uAnimID; }
	void SetAnimHash( Asura_Hash_ID uAnimID ) { m_uAnimID = uAnimID; }

private:
	Asura_Hash_ID m_uAnimID;
};

////////////////////////////////////////////////////////////////////////////////
// Class	: AVP_Message_SentryGun_Toggle_Dry_Fire
// Author	: Callum Hope CAH
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_SentryGun_Toggle_Dry_Fire
{
public:

	// CHANGE THE DATA - CHANGE THE VERSION!
	enum { CURRENT_MSG_VERSION = 0 };

	bool GetDryFireToggle() const { return m_bToggleDryFire; }
	void SetToggleToDryFire( bool bToggle ) { m_bToggleDryFire = bToggle; }

	void Initialise()
	{
		m_uVersion = CURRENT_MSG_VERSION;
		m_bToggleDryFire = false;
	}

	u_int m_uVersion;
	bool m_bToggleDryFire;
};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef AVP_SENTRYGUN_MESSAGES__
