//////////////////////////////////////////////////////////////////////////////
//
// AVP_ClientEntity_InteractInvisiSwitch.h
//
// Created by CAH 25/02/2009
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef AVP_CLIENTENTITY_INTERACTSENTRYGUNINVISISWITCH
#define AVP_CLIENTENTITY_INTERACTSENTRYGUNINVISISWITCH

//////////////////////////////////////////////////////////////////////////////
// INCLUDES

// AVP
#include "Core/AVP_Settings.h"
#include "Entity/PhysicalObject/Interact/AVP_ClientEntity_InteractObject.h"

//////////////////////////////////////////////////////////////////////////////
// FORWARD DECLARATIONS

class AVP_Message_InteractInvisiSwitch_ClientCreate;
class AVP_ServerEntity_Actor;

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_ClientEntity_InteractInvisiSwitch
// Author       : Callum Hope CAH
// Date         : 25/02/09
////////////////////////////////////////////////////////////////////////////////

class AVP_ClientEntity_InteractInvisiSwitch : public AVP_ClientEntity_InteractObject
{
public:
	static void																Create( const Asura_Message* pxMsg );
	static AVP_ClientEntity_InteractInvisiSwitch*							FindEntity( Asura_Guid uGuid ) { return s_xList.FindEntity( uGuid ); }
	static const Asura_Hashed_List<AVP_ClientEntity_InteractInvisiSwitch>*	GetList() { return &s_xList; }

	virtual bool HandleMessage(const Asura_Message* pxMessage);

	virtual InteractionType	GetInteractionObjectType() const { return INTERACTION_TYPE_SENTRYGUNINVISISWITCH; };

	Asura_Hash_ID GetAnimHashForSpeciesInteraction( AVP_Settings::Species eSpecies );

protected:
	AVP_ClientEntity_InteractInvisiSwitch();
	virtual ~AVP_ClientEntity_InteractInvisiSwitch();

	void ProcessClientCreate( const AVP_Message_InteractInvisiSwitch_ClientCreate* pxData, float fServerTime, bool bProcessPosAndOri );
	
	virtual void InitialiseFromBlueprint( const Asura_Blueprint& xBlueprint );
	
private:

	Asura_Hash_ID			m_uMarineDisableTPAnim;
	Asura_Hash_ID			m_uAlienDestroyTPAnim;
	Asura_Hash_ID			m_uPredatorDestroyTPAnim;

	static Asura_Hashed_List<AVP_ClientEntity_InteractInvisiSwitch> s_xList;
	typedef AVP_ClientEntity_InteractObject PARENT;
};

#endif // #ifndef AVP_CLIENTENTITY_INTERACTSENTRYGUNINVISISWITCH
