//////////////////////////////////////////////////////////////////////////////
//
// AVP_ServerEntity_InteractInvisiSwitch.h
//
// Created by CAH 25/02/2009
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_SERVERENTITY_INTERACTSENTRYGUNINVISISWITCH__
#define __AVP_SERVERENTITY_INTERACTSENTRYGUNINVISISWITCH__

//////////////////////////////////////////////////////////////////////////////
// INCLUDES

// AVP
#include "Entity/PhysicalObject/Interact/AVP_ServerEntity_InteractObject.h"

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_ServerEntity_InteractInvisiSwitch
// Author       : Callum Hope CAH
// Date         : 25/02/09
////////////////////////////////////////////////////////////////////////////////

class AVP_ServerEntity_InteractInvisiSwitch : public AVP_ServerEntity_InteractObject
{
public:
	static AVP_ServerEntity_InteractInvisiSwitch* Create(Asura_Guid uGuid)					{ return new AVP_ServerEntity_InteractInvisiSwitch(uGuid); }
	static AVP_ServerEntity_InteractInvisiSwitch* FindEntity(Asura_Guid uGuid)				{ return s_xList.FindEntity(uGuid); }
	static const Asura_Hashed_List<AVP_ServerEntity_InteractInvisiSwitch>* GetList()		{ return &s_xList; }    

	virtual bool	HandleMessage(const Asura_Message* pxMessage);
	virtual void	ReadFromChunkStream(Asura_Chunk_Stream& xStream);
	virtual void	WriteToChunkStream(Asura_Chunk_Stream& xStream) const;
	virtual bool	GetHasCreateMessage() const { return true; }
	virtual void	MakeCreateMessage( Asura_Guid uRequestingClient, bool bSendGuaranteed /*= false*/ );
	virtual void	PostLoadInitialise();

#ifdef ASURA_TOOLS
	static void		CreateFromTools(Asura_Guid uGuid);
	virtual bool	CanBeIncludedInTemplate() const;
	virtual void    ApplyChangesForTemplateInstance( Tools_EntityTemplateInstance* pxInstance );
#endif

protected:

	AVP_ServerEntity_InteractInvisiSwitch( Asura_Guid uGuid = ASURA_GUID_UNREGISTERED );
	virtual ~AVP_ServerEntity_InteractInvisiSwitch();

private:

#ifdef ASURA_TOOLS
	friend class ToolsAVP_Entity_InteractInvisiSwitch;
#endif

	typedef AVP_ServerEntity_InteractObject PARENT;
	static Asura_Hashed_List<AVP_ServerEntity_InteractInvisiSwitch> s_xList;
};

#endif // #ifndef __AVP_SERVERENTITY_INTERACTSENTRYGUNINVISISWITCH__
