//////////////////////////////////////////////////////////////////////////////
//
// AVP_ServerEntity_InteractHackingPoint.h
//
// Created by AJK 24/11/2008
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////


#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_SERVERENTITY_INTERACTHACKINGPOINT__
#define __AVP_SERVERENTITY_INTERACTHACKINGPOINT__

// AVP
#include "Entity/PhysicalObject/Interact/ToolReceptacle/AVP_ServerEntity_InteractToolReceptacle.h"

class AVP_ServerEntity_InteractHackingPoint : public AVP_ServerEntity_InteractToolReceptacle
{
public:

	enum
	{
		FLAG_BATTERY_INSIDE       = 0x00000001,
	};

	static AVP_ServerEntity_InteractHackingPoint* Create(Asura_Guid uGuid)					{ return new AVP_ServerEntity_InteractHackingPoint(uGuid); }
	static AVP_ServerEntity_InteractHackingPoint* FindEntity(Asura_Guid uGuid)				{ return s_xList.FindEntity(uGuid); }
	static const Asura_Hashed_List<AVP_ServerEntity_InteractHackingPoint>* GetList()		{ return &s_xList; }    

	virtual bool	HandleMessage(const Asura_Message* pxMessage);
	virtual void	ReadFromChunkStream(Asura_Chunk_Stream& xStream);
	virtual void	WriteToChunkStream(Asura_Chunk_Stream& xStream) const;
	virtual bool	GetHasCreateMessage() const { return true; }
	virtual void	MakeCreateMessage( Asura_Guid uRequestingClient, bool bSendGuaranteed /*= false*/ );

#ifdef ASURA_TOOLS
	static void		CreateFromTools(Asura_Guid uGuid);
	virtual bool	CanBeIncludedInTemplate() const;
	virtual void    ApplyChangesForTemplateInstance( Tools_EntityTemplateInstance* pxInstance );
#endif // #ifdef ASURA_TOOLS

	void			AttachHackingToolToLeftHand(Asura_Guid uActorGuid, bool bHideTool);

	#ifdef ASURA_TOOLS
	virtual bool SupportsCustomEvents() const { return true; }
	virtual int GetNumCustomEvents() const { return NUM_MESSAGE_BLOCKS; }
	virtual unsigned short* GetCustomEvent(int iIndex);
	virtual void GetCustomEventName(int iEventIndex, Asura_String& xEventName);
	#endif

protected:

	enum
	{
		MESSAGE_BLOCK_INSERT_HACKING_TOOL,
		MESSAGE_BLOCK_REMOVE_HACKING_TOOL,
		NUM_MESSAGE_BLOCKS,
	};

	AVP_ServerEntity_InteractHackingPoint( Asura_Guid uGuid = ASURA_GUID_UNREGISTERED );
	virtual ~AVP_ServerEntity_InteractHackingPoint();

	unsigned short	m_usMarineInsertHackingToolMessageBlock;
	unsigned short	m_usMarineRemoveHackingToolMessageBlock;

private:

	enum
	{
		CURRENT_CHUNK_VERSION = 0
	};

	void SendMarineInsertHackingToolMessage();
	void SendMarineRemoveHackingToolMessage();

	typedef AVP_ServerEntity_InteractToolReceptacle PARENT;

#ifdef ASURA_TOOLS
	friend class ToolsAVP_Entity_InteractHackingPoint;
#endif

	static Asura_Hashed_List<AVP_ServerEntity_InteractHackingPoint> s_xList;
};

#endif // #ifndef __AVP_SERVERENTITY_INTERACTHACKINGPOINT__
