
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_PhysicsObject_Messages.cpp
// Author : Andy Tate
// Date   : 13-Sep-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Entity/PhysicalObject/PhysicsObject/AVP_PhysicsObject_Messages.h"

#include "Entity/Asura_Entity_Classification.h"
#include "Network/Asura_Message.h"
#include "Network/Asura_NetMsg.h"

// Game independent header-files...
#include "Entity/PhysicalObject/PhysicsObject/AVP_ServerEntity_PhysicsObject.h"

#ifdef ASURA_SUPPORT_NETMSG_SYSTEM
void AVP_Message_PhysicsObject_ClientUpdate::RegisterFields(u_short usMsgID, u_short usEntityClassification)
{
	Asura_Assert(usMsgID == ASURA_MSG_CLIENTUPDATE, "invalid msg ID");
	Asura_Assert(!Asura_NetMsg::FindNetMsgObject(usMsgID, usEntityClassification), "already exists");
	Asura_Assert(usEntityClassification == AsuraEntityClass_PhysicsObject, "Unexpected entity classification.");

	u_char ucNumFields = GetNumFields();

	Asura_NetMsg* pxNetMsg = new Asura_NetMsg(usMsgID, usEntityClassification, ucNumFields, sizeof(AVP_Message_PhysicsObject_ClientUpdate));
	RegisterFields(pxNetMsg);
	pxNetMsg->EndRegistration();
}
#endif // ASURA_SUPPORT_NETMSG_SYSTEM

/// End of file. ///
