
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_PhysicsObject_Messages.h
// Author : Andy Tate
// Date   : 13-Sep-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_PHYSICSOBJECT_MESSAGES_H__
#define __AVP_PHYSICSOBJECT_MESSAGES_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/AVP_PhysicalObject_Messages.h"
#include "Entity/PhysicalObject/PhysicsObject/AVP_ServerEntity_PhysicsObject.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class Asura_NetMsg;

class AVP_ServerEntity_PhysicsObject;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Message_PhysicsObject_ClientUpdate
// Author       : Andy Tate
// Date         : 13-Sep-2007
//
// Description  : Class to handle the message-data for a physics-object.
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_PhysicsObject_ClientUpdate : public AVP_Message_PhysicalObject_ClientUpdate
{
public:
	// Public functions...
	void FillPhysics(const AVP_ServerEntity_PhysicsObject* pxPhysicsObj) { FillPhysicalObject(pxPhysicsObj); }

#ifdef ASURA_SUPPORT_NETMSG_SYSTEM
	static u_char GetNumFields() { return PARENT::GetNumFields(); }
	static void RegisterFields( Asura_NetMsg* pxNetMsg ) { PARENT::RegisterFields( pxNetMsg ); }
	static void RegisterFields( u_short usMsgID, u_short usEntityClassification );
#endif

protected:
	// Protected variables...

	// Protected functions...


private:
	// Private typedefs...
	typedef AVP_Message_PhysicalObject_ClientUpdate PARENT;

	// Private variables...

};   // End of class 'AVP_Message_PhysicsObject_ClientUpdate'.

class AVP_Message_PhysicsObject_ClientCreate : public AVP_Message_PhysicalObject_ClientCreate
{
public:
	void FillPhysics(const AVP_ServerEntity_PhysicsObject* pxPhysicsObj) { FillCreatePhysicalObject( pxPhysicsObj ); }

protected:
	// Protected variables...

	// Protected functions...


private:
	// Private typedefs...
	typedef AVP_Message_PhysicalObject_ClientCreate PARENT;

	// Private variables...

};

#endif   // ifndef __AVP_PHYSICSOBJECT_MESSAGES_H__


/// End of file. ///
