//////////////////////////////////////////////////////////////////////////////
//
// AVP_Pickup_Ammo.h
//
// (AJK - 27.08.2008) Created
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __AVP_PICKUP_AMMO__
#define __AVP_PICKUP_AMMO__

// AVP
#include "Entity/PhysicalObject/Pickup/AVP_Pickup.h"
#include "Inventory/AVP_Inventory_HashIDs.h"

class AVP_Pickup_Ammo : public AVP_Pickup
{
	friend class AVP_Pickup;

public :          

	virtual void		  InitFromBlueprint();
	virtual Asura_Hash_ID GetGroupHash() const { return uAVP_INVENTORY_GROUPHASH_AMMO; }

	// Getters

	Asura_Hash_ID GetAmmoType() const { return m_uAmmoTypeHash; }

	int GetScarceMinimum() const { return m_iScarceMinimum; }
	int GetScarceMaximum() const { return m_iScarceMaximum; }
	int GetMediumMinimum() const { return m_iMediumMinimum; }
	int GetMediumMaximum() const { return m_iMediumMaximum; }
	int GetPlentyMinimum() const { return m_iPlentyMinimum; }
	int GetPlentyMaximum() const { return m_iPlentyMaximum; }

protected :

	AVP_Pickup_Ammo(Asura_Hash_ID);

private	:
	
	Asura_Hash_ID m_uAmmoTypeHash;

	// Intelligent Amounts
	int m_iScarceMinimum;
	int m_iScarceMaximum;
	int m_iMediumMinimum;
	int m_iMediumMaximum;
	int m_iPlentyMinimum;
	int m_iPlentyMaximum;
};

#endif // #ifndef __AVP_PICKUP_AMMO__
