//////////////////////////////////////////////////////////////////////////////
//
// AVP_Pickup_Tool.h
//
// (AJK - 19.11.2008) Created
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __AVP_PICKUP_TOOL__
#define __AVP_PICKUP_TOOL__

// AVP
#include "Entity/PhysicalObject/Pickup/AVP_Pickup_Weapon.h"
#include "Inventory/AVP_Inventory_HashIDs.h"

class AVP_Pickup_Tool : public AVP_Pickup_Weapon
{
	friend class AVP_Pickup;

public :    

	static const Asura_Hash_ID s_uHackingToolHash     = 0x42566A39; // "HackingTool"
	static const Asura_Hash_ID s_uBatteryPlayerHash   = 0xE8B6CB2E; // "BatteryPlayer"
	static const Asura_Hash_ID s_uHumanHudMarkerPoint = 0xFBC7E11E; // "humanHUD_position"

	virtual void		  InitFromBlueprint();
	Asura_Hash_ID         GetDestroyedSkin() const { return m_uSkinDestroyed; }
	virtual Asura_Hash_ID GetGroupHash() const;

protected :

	AVP_Pickup_Tool(Asura_Hash_ID);

private	:
	typedef AVP_Pickup_Weapon PARENT;
	Asura_Hash_ID m_uSkinDestroyed;
};

#endif // #ifndef __AVP_PICKUP_TOOL__
