
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_ClientEntity_Projectile.h
// Author : Andy Tate
// Date   : 14-Nov-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_CLIENTENTITY_PROJECTILE_H__
#define __AVP_CLIENTENTITY_PROJECTILE_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/AVP_ClientEntity_PhysicalObject.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_ProjectileClientUpdate;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_ClientEntity_Projectile
// Author       : Andy Tate
// Date         : 14-Nov-2006
//
// Description  : Abstract class to handle generic projectiles.
////////////////////////////////////////////////////////////////////////////////

class AVP_ClientEntity_Projectile : public AVP_ClientEntity_PhysicalObject
{
public:
	// Public functions...

	// Overridden functions...
//	virtual	void	Update			(void);
	virtual	bool	HandleMessage	(const Asura_Message* pxMessage);

	// Static list accessors...
	static	AVP_ClientEntity_Projectile*							FindEntity	(const Asura_Guid uGuid)	{ return(s_xList.FindEntity(uGuid)); }
	static	const Asura_Hashed_List<AVP_ClientEntity_Projectile>*	GetList		(void)						{ return(&s_xList); }

	Asura_Guid GetOwnerGuid()	{ return m_uOwnerGuid;	}

protected:
	// Protected variables...
	Asura_Guid m_uOwnerGuid;

	// Protected functions...
	void	ProcessClientUpdate( const AVP_Message_ProjectileClientUpdate* pxData, float fServerTime, const bool bProcessPosAndOri = true );

	AVP_ClientEntity_Projectile          (void);
	virtual ~AVP_ClientEntity_Projectile ();

	// Abstract event functions...

private:
	// Private typedefs...
	typedef AVP_ClientEntity_PhysicalObject PARENT;

	// Private variables...
	static	Asura_Hashed_List<AVP_ClientEntity_Projectile>	s_xList;

	// Private functions...
	AVP_ClientEntity_Projectile  (const AVP_ClientEntity_Projectile& xOther);

	AVP_ClientEntity_Projectile&	operator=	(const AVP_ClientEntity_Projectile& xOther);

};   // End of class 'AVP_ClientEntity_Projectile'.


#endif   // ifndef __AVP_CLIENTENTITY_PROJECTILE_H__


/// End of file. ///
