//--------------------------------------------------------------------------------------
//	File	:	AVP_ServerEntity_SpawnPoint.h
//	Created	:	22 / 10 / 07
//	Author	:	Gareth Thomas
//	Copyright (C) 2006 Rebellion, All Rights Reserved.
//--------------------------------------------------------------------------------------
#ifdef ASURA_USE_PRAGMA_ONCE 
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE
#ifndef __AVP_SERVERENTITY_SPAWNPOINT_H__
#define __AVP_SERVERENTITY_SPAWNPOINT_H__ 1

//--------------------------------------------------------------------------------------
//	INCLUDES
//--------------------------------------------------------------------------------------
#include "Entity/Asura_Entity.h"

// Forward Declarations

class Tools_EntityTemplateInstance;

//--------------------------------------------------------------------------------------
//	Class	:	AVP_ServerEntity_SpawnPoint
//	Created	:	22 / 10 / 07
//	Author	:	Gareth Thomas
//--------------------------------------------------------------------------------------
class AVP_ServerEntity_SpawnPoint : public Asura_Entity_Server
{
public:

	//	Public Overridden functions
	virtual void						WriteToChunkStream				(Asura_Chunk_Stream& xStream) const;
	virtual void						ReadFromChunkStream				(Asura_Chunk_Stream& xStream);
	virtual bool 						CanBeSavedToChunk				(void) const								{return(true);}
	virtual bool						IsFilledFromChunkBuffer			(void) const								{return(false);}

    virtual bool                        HasClientEntities() const { return false; }

	//	Public Static Functions
	static AVP_ServerEntity_SpawnPoint*	Create							(const Asura_Guid uGuid);
	static AVP_ServerEntity_SpawnPoint*	FindEntity						(Asura_Guid uGuid)							{return s_xList.FindEntity(uGuid);}

	static const Asura_Hashed_List<AVP_ServerEntity_SpawnPoint>* GetList(void)										{return &s_xList;}

	//	Public Functions
	void								SetPosition						(const Asura_Vector_3& xPosition)			{m_xPosition = xPosition;}
	const Asura_Vector_3&				GetPosition						(void) const								{return m_xPosition;}

	void								SetOrientation					(const Asura_Matrix_3x3& xOrientation)		{m_xOrientation = xOrientation;}
	const Asura_Matrix_3x3&				GetOrientation					(void) const								{return m_xOrientation;}

	Asura_Guid							GetOutGameScene					(void) const								{return m_uGameSceneOutGuid;}
	Asura_Guid							GetInGameScene					(void) const								{return m_uGameSceneInGuid;}

#ifdef ASURA_TOOLS
	virtual bool CanBeIncludedInTemplate() const;
	virtual void ApplyChangesForTemplateInstance( Tools_EntityTemplateInstance* pxInstance );
#endif

protected:

	//	Construction / Deconstruction
	AVP_ServerEntity_SpawnPoint											(const Asura_Guid uGuid);
	virtual ~AVP_ServerEntity_SpawnPoint								(void);

	//	Protected variables
	Asura_Vector_3						m_xPosition;
	Asura_Matrix_3x3					m_xOrientation;
	Asura_Guid							m_uGameSceneOutGuid;
	Asura_Guid							m_uGameSceneInGuid;
// 	Asura_Hash_ID						m_uSpawnBlueprintTypeHashID;
// 	Asura_Hash_ID						m_uSpawnBlueprintHashID;

private:

	//	Friend classes
	friend class ToolsAVP_Entity_SpawnPoint;

	//	Private typedefs
	typedef Asura_Entity_Server PARENT;

	// Chunk Version
	enum {CURRENT_CHUNK_VERSION = 3};

	//	Private statics
	static Asura_Hashed_List<AVP_ServerEntity_SpawnPoint> s_xList;
};
/// End of class 'AVP_ServerEntity_BombTarget'. ///

#endif   /// ifndef __AVP_SERVERENTITY_BOMBTARGET_H__
