//--------------------------------------------------------------------------------------
//	File	:	AVP_ServerEntity_HumanSpawnPoint.h
//	Created	:	25 / 02 / 08
//	Author	:	Gareth Thomas
//	Copyright (C) 2006 Rebellion, All Rights Reserved.
//--------------------------------------------------------------------------------------
#ifdef ASURA_USE_PRAGMA_ONCE 
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE
#ifndef __AVP_SERVERENTITY_HUMANSPAWNPOINT_H__
#define __AVP_SERVERENTITY_HUMANSPAWNPOINT_H__ 1

//--------------------------------------------------------------------------------------
//	INCLUDES
//--------------------------------------------------------------------------------------
#include "Entity/Asura_Entity.h"

#include "Entity/AVP_Entity_Classification.h"
#include "Entity/Spawners/AVP_ServerEntity_SpawnPoint.h"

// Forward Declarations

class AVP_ServerActor_Human;
class Tools_EntityTemplateInstance;

//--------------------------------------------------------------------------------------
//	Class	:	AVP_ServerEntity_HumanSpawnPoint
//	Created	:	22 / 10 / 07
//	Author	:	Gareth Thomas
//--------------------------------------------------------------------------------------
class AVP_ServerEntity_HumanSpawnPoint : public AVP_ServerEntity_SpawnPoint
{
public:
	AVP_ServerActor_Human* Spawn(Asura_Hash_ID uBlueprintTypeHashID, Asura_Hash_ID uBlueprintHashID, u_int uClassification, Asura_Guid uSquadControllerGuid);

	virtual void PostLoadInitialise(void) {}

	virtual void WriteToChunkStream(Asura_Chunk_Stream& xStream) const;
	virtual void ReadFromChunkStream(Asura_Chunk_Stream& xStream);

	static AVP_ServerEntity_HumanSpawnPoint*							Create(const Asura_Guid uGuid);
	static AVP_ServerEntity_HumanSpawnPoint*							FindEntity(Asura_Guid uGuid)	{return s_xList.FindEntity(uGuid);}
	static const Asura_Hashed_List<AVP_ServerEntity_HumanSpawnPoint>*	GetList(void)					{return &s_xList;}

	void		SetCivilianGuardzoneGuid(Asura_Guid uGuid)		{m_uCivilianGuardZoneGuid = uGuid;}
	Asura_Guid	GetCivilianGuardZoneGuid(void)					{return m_uCivilianGuardZoneGuid;}

#ifdef ASURA_TOOLS
	virtual bool CanBeIncludedInTemplate() const;
	virtual void ApplyChangesForTemplateInstance( Tools_EntityTemplateInstance* pxInstance );
#endif

protected:	
	AVP_ServerEntity_HumanSpawnPoint( const Asura_Guid uGuid );
	virtual ~AVP_ServerEntity_HumanSpawnPoint();

	void					SendAddToSquadMessage		(Asura_Guid uSquadGuid, Asura_Guid uHumanoidGuid);
	void					SetupSpawnedHuman			(AVP_ServerActor_Human* pxSpawnedHumanoid, Asura_Hash_ID uBlueprintTypeHashID, Asura_Hash_ID uBlueprintHashID);
	AVP_ServerActor_Human*	CreateSpecifiedHumanoidType	(u_int uClassification);

private:

	Asura_Guid m_uCivilianGuardZoneGuid;

	//	Friend classes
	friend class ToolsAVP_Entity_HumanSpawnPoint;

	//	Private typedefs
	typedef AVP_ServerEntity_SpawnPoint PARENT;

	// Chunk Version
	enum { CURRENT_CHUNK_VERSION = 1 };

	//	Private statics
	static Asura_Hashed_List< AVP_ServerEntity_HumanSpawnPoint > s_xList;
};
/// End of class 'AVP_ServerEntity_HumanSpawnPoint'. ///

#endif   /// ifndef __AVP_SERVERENTITY_HUMANSPAWNPOINT_H__
