//
// AVP_ClientEntity_InteractionTrigger.h
//
// Created by Chris Wallace - 06-March-2007
// 
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __AVP_CLIENTENTITY_INTERACTIONTRIGGER_H__
#define __AVP_CLIENTENTITY_INTERACTIONTRIGGER_H__

#include "Entity/Triggers/Asura_ClientEntity_AdvancedVolumeTrigger.h"
#include "Entity/Triggers/AVP_Trigger_Messages.h"
//#include "Entity/Triggers/AVP_ServerEntity_InteractionTrigger.h"

class AVP_ClientEntity_InteractionTrigger : public Asura_ClientEntity_AdvancedVolumeTrigger
{
	friend class ToolsAVP_Entity_InteractionTrigger;

public :
		AVP_ClientEntity_InteractionTrigger(Asura_Guid uGuid);
		AVP_ClientEntity_InteractionTrigger(Asura_Guid uGuid,const char*& pcChunkBuffer);

		~AVP_ClientEntity_InteractionTrigger();

		static void Create(const Asura_Message* pxMessage);

		virtual bool HandleMessage(const Asura_Message* pxMessage);
		void ProcessClientUpdate(const AVP_Message_InteractionTrigger_ClientUpdate* pxData);

		//checks to see if a point lies in any of the volumes associated with this trigger
		bool Contains(const Asura_Vector_3& xPosition) const;

		int GetListFlags(void) const { return(m_iListFlags); }

		static const Asura_Hashed_List<AVP_ClientEntity_InteractionTrigger>* GetList() { return &s_xList; }
		static AVP_ClientEntity_InteractionTrigger* FindEntity(Asura_Guid uGuid) { return s_xList.FindEntity(uGuid); }
	
protected :
		bool IsTriggered(void);
		bool IsUnTriggered(void);
		void OnUnTrigger();
		virtual bool IsVolumeOccupied(){return false;}

private:

	static Asura_Hashed_List<AVP_ClientEntity_InteractionTrigger> s_xList;

	typedef Asura_ClientEntity_AdvancedVolumeTrigger PARENT;
};


#endif //__AVP_CLIENTENTITY_INTERACTIONTRIGGER_H__
