/**
*
* \file AVP_ServerEntity_WaypointBlockerVolume.h
*
* Created by Anthony Gregson - 11/12/07
*
* Copyright (C) 2007 Rebellion, All Rights Reserved.
*
**/

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __AVP_SERVERENTITY_WAYPOINTBLOCKERVOLUME_H__
#define __AVP_SERVERENTITY_WAYPOINTBLOCKERVOLUME_H__

/************/
/* Includes.*/
/************/
#include "Entity/Triggers/Asura_ServerEntity_WaypointBlockerVolume.h"

class AVP_ServerEntity_WaypointBlockerVolume : public Asura_ServerEntity_WaypointBlockerVolume
{

public :

	AVP_ServerEntity_WaypointBlockerVolume( Asura_Guid uGuid );

	virtual ~AVP_ServerEntity_WaypointBlockerVolume();

	// static members for list management
	static AVP_ServerEntity_WaypointBlockerVolume* FindEntity( Asura_Guid uGuid )
	{
		return s_xList.FindEntity(uGuid);
	}
	static Asura_Hashed_List<AVP_ServerEntity_WaypointBlockerVolume>* GetList()
	{
		return &s_xList;
	}

	void SetBlockHuman(bool bHuman) { m_bBlockHuman = bHuman; }
	bool GetBlockHuman() const { return m_bBlockHuman; }
	void SetBlockAlein(bool bAlien) { m_bBlockAlien = bAlien; }
	bool GetBlockAlein() const { return m_bBlockAlien; }
	void SetBlockPredator(bool bPredator) { m_bBlockPredator = bPredator; }
	bool GetBlockPredator() const { return m_bBlockPredator; }
	
	virtual void BlockLinks(bool bBlockLinks);
	virtual	void ReadFromChunkStream( Asura_Chunk_Stream& xStream );
	virtual	void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;
	virtual void PostLoadInitialise();


	typedef Asura_ServerEntity_WaypointBlockerVolume PARENT;

	static AVP_ServerEntity_WaypointBlockerVolume* Create( Asura_Guid uGuid) { return new AVP_ServerEntity_WaypointBlockerVolume(uGuid); }

private:

	bool m_bBlockHuman;
	bool m_bBlockAlien;
	bool m_bBlockPredator;

	enum { CURRENT_CHUCK_VERSION = 1 };

	static Asura_Hashed_List<AVP_ServerEntity_WaypointBlockerVolume> s_xList;

	friend class ToolsAVP_Entity_WaypointBlockerVolume;
};


#endif//__AVP_SERVERENTITY_WAYPOINTBLOCKERVOLUME_H__
