
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Vent_Messages.cpp
// Author : Will Plano
// Date   : 12/03/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

#include "Entity/Vent/AVP_Vent_Messages.h"

#include "Entity/Locations/OrientedNode/GamesceneNode/Asura_ServerNode_GS2Node.h"
#include "Entity/Locations/Spline/GamesceneSpline/Asura_ServerNode_GS2Spline.h"
#include "Entity/Vent/AVP_ServerEntity_Vent.h"

void AVP_Message_Vent_ClientCreate::FillVent( const AVP_ServerEntity_Vent* pxVent )
{
	m_xPosition = pxVent->GetPosition();
	m_xOrientation = pxVent->GetOrientation();

	m_bStartDamaged = pxVent->IsDamaged();
	m_bStartActive = pxVent->IsEntityActive();

	m_uUndamagedSkinHash = pxVent->GetUndamagedSkinHash();
	m_uDamagedSkinHash = pxVent->GetDamagedSkinHash();

	Asura_Matrix_3x3 xTempOri;
	m_uNumExitPoints = pxVent->m_uNumExitPoints;
	for (u_int u=0; u<m_uNumExitPoints; ++u)
	{
		m_axExitPositions[u] = pxVent->m_pxExitPoints[u].m_xPosition;
		pxVent->m_pxExitPoints[u].m_xOrientation.ToMatrix(xTempOri);
		m_axExitNormals[u] = Asura_Vector_3(-xTempOri.e12, -xTempOri.e22, -xTempOri.e32);
	}
}
