////////////////////////////////////////////////////////
// 
// AVP_GameFrontEnd.h
// Author : Gordon Hayes
// Date   : 02-May-2007
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
/////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __AVP_GAMEFRONTEND_H__
#define __AVP_GAMEFRONTEND_H__

#if defined(AVP_USE_GAME_FRONTEND)

class AVP_GameFrontEnd
{
public:
	static void Initialise();
	static void Shutdown();
	static void SetupConsoleCommands();
	static bool ConsoleCmd_PlayMusic(u_int uPlay, bool bInterrogate, bool bHelp );

	static void PlayMusic();
	static void StopMusic();

	// Accessor functions...
	static void RequestDevLobby(void)	{ s_bDevLobbyRequested = true; s_bGameLobbyRequested = false; s_bSetupComplete = true; }
	static void RequestGameLobby(void)	{ s_bDevLobbyRequested = false; s_bGameLobbyRequested = true; s_bSetupComplete = true; }
	static void RequestStartGame(void)	{ s_bDevLobbyRequested = false; s_bGameLobbyRequested = false; s_bSetupComplete = true; }

	static bool	IsInitialised(void)			{ return(s_uMenuPageHash != ASURA_HASH_ID_UNSET); }
	static bool IsDevLobbyRequested(void)	{ return(s_bDevLobbyRequested); }
	static bool IsGameLobbyRequested(void)	{ return(s_bGameLobbyRequested); }
	static bool	IsSetupComplete(void)		{ return(s_bSetupComplete); }

private:
	// Private variables...
	static bool				s_bSetupComplete;
	static bool				s_bDevLobbyRequested;
	static bool				s_bGameLobbyRequested;
	static Asura_Hash_ID	s_uMenuPageHash;
	static Asura_Handle     s_iMusicTrackHandle;
};

#endif	//defined(AVP_USE_GAME_FRONTEND)

#endif//__AVP_GAMEFRONTEND_H__
