
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Inventory_HashIDs.h
// Author : Andy Tate
// Date   : 16-Nov-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_INVENTORY_HASHIDS_H__
#define __AVP_INVENTORY_HASHIDS_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Global constants...
////////////////////////////////////////////////////////////////////////////////

// Group constants...
Asura_Char const* const	szAVP_INVENTORY_GROUPNAME_VISIONMODE	= "VisionMode";
Asura_Char const* const	szAVP_INVENTORY_GROUPNAME_WEAPON		= "Weapon";

const Asura_Hash_ID	uAVP_INVENTORY_GROUPHASH_VISIONMODE		= 0x8A2C618B;	// Asura_GetHashID("VisionMode");
const Asura_Hash_ID	uAVP_INVENTORY_GROUPHASH_WEAPON			= 0xD0CDC21C;	// Asura_GetHashID("Weapon");
const Asura_Hash_ID	uAVP_INVENTORY_GROUPHASH_HEALTH			= 0xB735025C;	// Asura_GetHashID("Health");
const Asura_Hash_ID	uAVP_INVENTORY_GROUPHASH_AMMO			= 0x002DBECE;	// Asura_GetHashID("Ammo");
const Asura_Hash_ID	uAVP_INVENTORY_GROUPHASH_TOOL           = 0x00366998;   // Asura_GetHashID("Tool");
const Asura_Hash_ID	uAVP_INVENTORY_GROUPHASH_AUDIODIARY     = 0x5C9ABDAD;   // Asura_GetHashID("AudioDiary");

// Weapon constants...
const Asura_Hash_ID uAVP_INVENTORY_WEAPONHASH_WEAPON00		= 0xd465b11c;	// Weapon00 // For adding on indexes starting from 1 - Not a weapon in itself

const Asura_Hash_ID uAVP_INVENTORY_WEAPONHASH_WEAPON01		= 0xd465b11d;	// Weapon01
const Asura_Hash_ID uAVP_INVENTORY_WEAPONHASH_WEAPON02		= 0xd465b11e;	// Weapon02
const Asura_Hash_ID uAVP_INVENTORY_WEAPONHASH_WEAPON03		= 0xd465b11f;	// Weapon03
const Asura_Hash_ID uAVP_INVENTORY_WEAPONHASH_WEAPON04		= 0xd465b120;	// Weapon04

const Asura_Hash_ID uAVP_INVENTORY_WEAPONHASH_TEQUILA_SP	= 0xee844f4a;	// TequilaPlayer
const Asura_Hash_ID uAVP_INVENTORY_WEAPONHASH_TEQUILA_MP	= 0xd6dc8691;	// TequilaMultiPlayer

// Permanently active item constants...
Asura_Char const* const	szAVP_INVENTORY_ITEMNAME_CLOAK	= "Cloak";
Asura_Char const* const szAVP_INVENTORY_ITEMNAME_FLARE	= "Flare";

const Asura_Hash_ID	uAVP_INVENTORY_ITEMHASH_CLOAK	= 0x05A5DBD0;	// Asura_GetHashID("Cloak");
const Asura_Hash_ID uAVP_INVENTORY_ITEMHASH_FLARE	= 0x05cfefce;	// Flare
const Asura_Hash_ID uAVP_INVENTORY_ITEMHASH_STIM	= 0x00360745;	// Stim
const Asura_Hash_ID uAVP_INVENTORY_ITEMHASH_TORCH	= 0x0696d3fc;	// Torch

#endif   // ifndef __AVP_INVENTORY_HASHIDS_H__

/// End of file. ///
