
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_InventoryGroup_VisionModes.cpp
// Author : Andy Tate
// Date   : 28-Nov-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Inventory/Groups/AVP_InventoryGroup_VisionModes.h"

// Game independent header-files...
#include "Inventory/AVP_Inventory_HashIDs.h"
#include "Inventory/Items/AVP_InventoryItem_VisionMode.h"


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_InventoryGroup_VisionModes::CreateItemFromBlueprint
// Author       : Andy Tate
// Date         : 7-Dec-2007
////////////////////////////////////////////////////////////////////////////////

AVP_Inventory_Item* AVP_InventoryGroup_VisionModes::CreateItemFromBlueprint(const Asura_Hash_ID uBlueprintHash,
																			const Asura_Hash_ID uNameHash)
{
	AVP_Inventory_Item*	pxNewItem = new AVP_InventoryItem_VisionMode(*this, uBlueprintHash, uNameHash);
	if ( pxNewItem )
	{
		pxNewItem->InitialiseFromBlueprint();
	}
	return(pxNewItem);
}

/// End of function 'AVP_InventoryGroup_VisionModes::CreateItemFromBlueprint'. ///


AVP_Inventory_Item* AVP_InventoryGroup_VisionModes::CreateItemFromType( const int iType, const Asura_Hash_ID uBlueprintHash, const Asura_Hash_ID uNameHash )
{
	if ( iType == AVP_INVENTORYITEMTYPE_VISION_MODE )
	{
		return new AVP_InventoryItem_VisionMode( *this, uBlueprintHash, uNameHash );
	}
	else
	{
		return PARENT::CreateItemFromType( iType, uBlueprintHash, uNameHash );
	}
}

////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_InventoryGroup_VisionModes::AVP_InventoryGroup_VisionModes
// Author       : Andy Tate
// Date         : 28-Nov-2007
////////////////////////////////////////////////////////////////////////////////

AVP_InventoryGroup_VisionModes::AVP_InventoryGroup_VisionModes(AVP_Inventory_System& xSystem)
: PARENT(xSystem, szAVP_INVENTORY_GROUPNAME_VISIONMODE, false)
{
	// Initialise the flags...
	SetAllowSelectionOfEmptyItems(true);
	SetIgnoredByChunkStream(true);
	SetGroupType(VISION_MODE);
}
/// End of function 'AVP_InventoryGroup_VisionModes::AVP_InventoryGroup_VisionModes'. ///


/// End of file. ///
