
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_InventoryWeapon_DropshipMissile.h
// Author : Sharon Galtzur
// Date   : 24-Sep-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_INVENTORYWEAPON_DROPSHIP_MISSILE_H__
#define __AVP_INVENTORYWEAPON_DROPSHIP_MISSILE_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Inventory/Items/Weapons/AVP_InventoryWeapon_RangedWeapon.h"
#include "Inventory/Items/Weapons/AVP_RangedWeapon_SubType.h"
#include "Inventory/Groups/AVP_InventoryGroup_Weapons.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class Asura_Physics_Object;
class AVP_ClientActor_Vertebrate;
class AVP_ServerActor_Vertebrate;
class AVP_Predator_Tag;
class AVP_Predator_TagHandler;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_InventoryWeapon_DropshipMissile
// Author       : Chris Wallace
// Date         : 13-Nov-2007
//
// Description  : Class to handle either client or server-side updating of the
//				  DropshipMissile weapon.
////////////////////////////////////////////////////////////////////////////////

class AVP_InventoryWeapon_DropshipMissile : public AVP_InventoryWeapon_RangedWeapon
{
public:

	AVP_InventoryWeapon_DropshipMissile( AVP_Inventory_Group& xParentGroup, const Asura_Hash_ID uHash, const Asura_Hash_ID uBlueprintHash );


protected:
	virtual void SendCreateProjectileMessage( const AVP_GenericProjectileData* pxProjectileData, const AVP_RangedWeapon_SubType* pxSubType, u_int uUsageType, Asura_Hash_ID uMuzMP, float fRange, float fMaxRange, const Asura_Vector_3& xActorVel, const Asura_Vector_3& xFirePosition, const Asura_Vector_3& xShotDirection, const Asura_Matrix_3x3& xShotOrientation, Asura_Guid* puTargetGuid = NULL );

	virtual void CalculateFiringDataForSubType( const AVP_ClientEntity_Actor& xActor, Asura_Hash_ID uMuzMP, float fMuzVel, float fMaxRange, Asura_Vector_3& xFirePosition, Asura_Vector_3& xFireDirection, Asura_Matrix_3x3& xMuzzleOri, float& fRange, Asura_Guid* puTargetGuid = NULL );


private:
	typedef AVP_InventoryWeapon_RangedWeapon PARENT;

	AVP_InventoryWeapon_DropshipMissile(void);
	AVP_InventoryWeapon_DropshipMissile(const AVP_InventoryWeapon_DropshipMissile& xOther);

	AVP_InventoryWeapon_DropshipMissile& operator=(const AVP_InventoryWeapon_DropshipMissile& xOther);
};   

#endif   // ifndef __AVP_INVENTORYWEAPON_DROPSHIP_MISSILE_H__


/// End of file. ///
