
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_InventoryWeapon_MeleeWeapon.cpp
// Author : Anthony Gregson
// Date   : 24/04/08
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Inventory/Items/Weapons/AVP_InventoryWeapon_MeleeWeapon.h"

// Game independent header-files...
#include "Actor/Vertebrates/Predator/AVP_Predator_InputHandler.h"
#include "Actor/Vertebrates/AVP_Vertebrate_MeleeCounter_System.h"
#include "Entity/PhysicalObject/Actor/Vertebrates/Predator/AVP_ClientActor_Predator.h"
#include "Entity/PhysicalObject/Actor/Vertebrates/Predator/AVP_ServerActor_Predator.h"
#include "Inventory/AVP_Inventory_HashIDs.h"
#include "Inventory/AVP_Inventory_System.h"
#include "Moves/AVP_Movement_System.h"


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_InventoryWeapon_MeleeWeapon::AVP_InventoryWeapon_MeleeWeapon
// Author       : Anthony Gregson
// Date         : 24/04/08
////////////////////////////////////////////////////////////////////////////////

AVP_InventoryWeapon_MeleeWeapon::AVP_InventoryWeapon_MeleeWeapon( AVP_Inventory_Group& xParentGroup, const Asura_Hash_ID uHash, const Asura_Hash_ID uBlueprintHash )
: PARENT(AVP_INVENTORYITEMTYPE_WEAPON_MELEE, xParentGroup, uHash, uBlueprintHash, "Melee Weapon")
{
	// Initialise the remaining data...

	// If we add any melee-weapon-specific blueprint parameters, they'll go here.
	// At a guess, they'll involve damage values and ranges, since most of the actual handling of melee weapons is in the melee/counter system.
}

/// End of function 'AVP_InventoryWeapon_MeleeWeapon::AVP_InventoryWeapon_MeleeWeapon'. ///




/// End of file. ///
