
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_InventoryWeapon_MeleeWeapon.h
// Author : Andy Tate
// Date   : 27-Nov-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_INVENTORYWEAPON_MELEEWEAPON_H__
#define __AVP_INVENTORYWEAPON_MELEEWEAPON_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Inventory/Items/AVP_InventoryItem_Weapon.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_InventoryWeapon_MeleeWeapon
// Author       : Anthony Gregson
// Date         : 24/04/08
//
// Description  : Replacement for the specific wristblades class, able to handle generic melee weapons if we need it.
////////////////////////////////////////////////////////////////////////////////

class AVP_InventoryWeapon_MeleeWeapon : public AVP_InventoryItem_Weapon
{
public:
	// Public enumerated types...
	// Public functions...
	AVP_InventoryWeapon_MeleeWeapon(AVP_Inventory_Group& xParentGroup, const Asura_Hash_ID uHash, const Asura_Hash_ID uBlueprintHash);
//	virtual ~AVP_InventoryWeapon_MeleeWeapon();

	// Overridden functions...
	virtual void	StartUsing(const u_int uUsageType)	{}
	virtual void	Use(void)							{}
	virtual void	StopUsing(const u_int uUsageType)	{}

protected:
	// Protected variables...

	// Protected functions...

	// Overridden functions...

private:
	// Private typedefs...
	typedef AVP_InventoryItem_Weapon PARENT;

	// Private variables...

	// Private functions...
	AVP_InventoryWeapon_MeleeWeapon(void);
	AVP_InventoryWeapon_MeleeWeapon(const AVP_InventoryWeapon_MeleeWeapon& xOther);

	AVP_InventoryWeapon_MeleeWeapon&	operator=(const AVP_InventoryWeapon_MeleeWeapon& xOther);

};   // End of class 'AVP_InventoryWeapon_MeleeWeapon'.


#endif   // ifndef __AVP_INVENTORYWEAPON_MELEEWEAPON_H__


/// End of file. ///
