
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_InventoryWeapon_Shotgun.h
// Author : Chris Wallace
// Date   : 04-Feb-2009
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_INVENTORYWEAPON_SHOTGUN_H__
#define __AVP_INVENTORYWEAPON_SHOTGUN_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Animation/IK/Asura_Animation_IK_Chain_MarkerPoint.h"
#include "Animation/IK/Asura_Animation_IK_Solver.h"

#include "Inventory/Items/Weapons/AVP_InventoryWeapon_RangedWeapon.h"
#include "Inventory/Items/Weapons/AVP_RangedWeapon_SubType.h"
#include "Inventory/Groups/AVP_InventoryGroup_Weapons.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_InventoryWeapon_Shotgun
// Author       : Chris Wallace
// Date         : 04-Feb-2009
//
// Description  : Class to handle either client or server-side updating of the
//				  shotgun weapon.
////////////////////////////////////////////////////////////////////////////////

class AVP_InventoryWeapon_Shotgun : public AVP_InventoryWeapon_RangedWeapon
{
public:
	// Public enumerated type...

	// Public functions...
	AVP_InventoryWeapon_Shotgun( AVP_Inventory_Group& xParentGroup, const Asura_Hash_ID uHash, const Asura_Hash_ID uBlueprintHash );
	
	// Overridden functions...
	//virtual void	Use(void);
	//virtual int	GetSubTypeIndexFromUsageType( const u_int uUsageType ) const;
	//virtual void	InitialiseFromBlueprint();

	virtual void ProcessPlayerInput( const AVP_ClientEntity_Actor& xActor );
	
	// 	// Static initialisation functions...

protected:
	// Protected variables...

	// Protected functions...
	void CheckForAutomaticReload(void);

	virtual void HandleReload( void );

	//virtual void	StartUsing(const u_int uUsageType);

	//virtual void	OnStateChange(const u_int uOldState, const u_int uNewState);
	//virtual void	UpdateClientState(AVP_ClientEntity_Actor& xClient);
	//virtual	void	UpdateServerState(AVP_ServerEntity_Actor& xServer);

	virtual bool HandleHalfShot(int& iFullBulletsToFire);


private:
	// Protected variables...
	
	// Private typedefs...
	typedef AVP_InventoryWeapon_RangedWeapon PARENT;

};   // End of class 'AVP_InventoryWeapon_Shotgun'.


#endif   // ifndef __AVP_INVENTORYWEAPON_SHOTGUN_H__


/// End of file. ///
