
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_InventoryWeapon_Taser.cpp
// Author : Chris Wallace
// Date   : 10-Nov-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Inventory/Items/Weapons/AVP_InventoryWeapon_Taser.h"

// Asura independent header-files...

// Game independent header-files...
#include "Inventory/AVP_Inventory_Group.h"
#include "Inventory/AVP_Inventory_HashIDs.h"
#include "Inventory/AVP_Inventory_System.h"
#include "Inventory/Items/Weapons/AVP_Taser_ClientEffectsHandler.h"

AVP_InventoryWeapon_Taser::AVP_InventoryWeapon_Taser( AVP_Inventory_Group& xParentGroup, const Asura_Hash_ID uHash, const Asura_Hash_ID uBlueprintHash )
: PARENT(xParentGroup, uHash, uBlueprintHash)
{
	m_eItemType = AVP_INVENTORYITEMTYPE_TASER;
}

AVP_RangedWeapon_ClientEffectsHandler* AVP_InventoryWeapon_Taser::CreateClientEffectsHandler(Asura_Hash_ID uBlueprintHash, Asura_Hash_ID uOwnerGuid)
{
	return new AVP_Taser_ClientEffectsHandler(uBlueprintHash, uOwnerGuid);
}

/// End of file. ///
