
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_InventoryWeapon_Taser.h
// Author : Chris Wallace
// Date   : 10-Nov-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_INVENTORYWEAPON_TASER_H__
#define __AVP_INVENTORYWEAPON_TASER_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Animation/IK/Asura_Animation_IK_Chain_MarkerPoint.h"
#include "Animation/IK/Asura_Animation_IK_Solver.h"

#include "Inventory/Items/Weapons/AVP_InventoryWeapon_RangedWeapon.h"
#include "Inventory/Items/Weapons/AVP_RangedWeapon_SubType.h"
#include "Inventory/Groups/AVP_InventoryGroup_Weapons.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_InventoryWeapon_Taser
// Author       : Chris Wallace
// Date         : 10-Nov-2008
//
// Description  : Class to handle either client or server-side updating of the
//				  taser weapon.
////////////////////////////////////////////////////////////////////////////////

class AVP_InventoryWeapon_Taser : public AVP_InventoryWeapon_RangedWeapon
{
public:
	// Public enumerated type...
	AVP_InventoryWeapon_Taser( AVP_Inventory_Group& xParentGroup, const Asura_Hash_ID uHash, const Asura_Hash_ID uBlueprintHash );

	// Public functions...

	// Overridden functions...

	// 	// Static initialisation functions...

protected:
	// Protected variables...

	// Protected functions...
	AVP_RangedWeapon_ClientEffectsHandler* CreateClientEffectsHandler(Asura_Hash_ID uBlueprintHash, Asura_Hash_ID uOwnerGuid);
	
private:
	// Private typedefs...
	typedef AVP_InventoryWeapon_RangedWeapon PARENT;

	// Private functions...

};   // End of class 'AVP_InventoryWeapon_Taser'.


#endif   // ifndef __AVP_INVENTORYWEAPON_TASER_H__


/// End of file. ///
