
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_InventoryWeapon_Unarmed.h
// Author : Anthony Gregson
// Date   : 20/11/08
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_INVENTORYWEAPON_UNARMED_H__
#define __AVP_INVENTORYWEAPON_UNARMED_H__

#include "Inventory/Items/AVP_InventoryItem_Weapon.h"


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_InventoryWeapon_Unarmed
// Author       : Anthony Gregson
// Date         : 20/11/08
//
// Description  : Do-nothing unarmed weapon, so we can at least work out that someone is unarmed.
////////////////////////////////////////////////////////////////////////////////

class AVP_InventoryWeapon_Unarmed : public AVP_InventoryItem_Weapon
{
public:
	AVP_InventoryWeapon_Unarmed(AVP_Inventory_Group& xParentGroup, const Asura_Hash_ID uHash, const Asura_Hash_ID uBlueprintHash);
//	virtual ~AVP_InventoryWeapon_Unarmed();

	virtual void	StartUsing(const u_int uUsageType)	{}
	virtual void	Use(void)							{}
	virtual void	StopUsing(const u_int uUsageType)	{}

private:
	typedef AVP_InventoryItem_Weapon PARENT;

	AVP_InventoryWeapon_Unarmed(void);
	AVP_InventoryWeapon_Unarmed(const AVP_InventoryWeapon_Unarmed& xOther);

	AVP_InventoryWeapon_Unarmed&	operator=(const AVP_InventoryWeapon_Unarmed& xOther);
};


#endif   // ifndef __AVP_INVENTORYWEAPON_UNARMED_H__


/// End of file. ///
