///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Move_Interaction.h
// Author : Will Plano
// Date   : 12/06/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_MOVE_INTERACTION_H__
#define __AVP_MOVE_INTERACTION_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Moves/AVP_Moves.h"

class AVP_Move_Interaction_BeginWeaponAway : public AVP_Move
{
public:
	AVP_Move_Interaction_BeginWeaponAway( Asura_Movement_System& xParentSystem );
	virtual ~AVP_Move_Interaction_BeginWeaponAway() {}

	static Asura_Hash_ID GetStaticHash() { return 0x7ce2e532; } //AVP_Move_Interaction_Begin

	Asura_Guid GetInteractionObject() const { return m_uInteractionGuid; }
	Asura_Hash_ID GetNextMoveHash() const { return m_uNextMoveHash; }
	bool GetOn() const { return m_bOn; }

protected:
	virtual	bool ShouldStart() const { return false; }
	virtual bool Start( const Asura_Msg_Move* pxStartMsg );

	Asura_Guid		m_uInteractionGuid;
	Asura_Hash_ID	m_uNextMoveHash;
	bool			m_bOn;

private:
	typedef AVP_Move PARENT;
};

class AVP_Move_Interaction : public AVP_Move
{
public:
	AVP_Move_Interaction( Asura_Movement_System& xParentSystem );
	virtual ~AVP_Move_Interaction() {}

	static Asura_Hash_ID GetStaticHash() { return 0xffb9cf88; } //AVP_Move_Interaction

protected:
	virtual bool Start( const Asura_Msg_Move* pxStartMsg );
	virtual bool ShouldStart() const;
	virtual void Finish();
	virtual void Abort();

	Asura_MoveData_OrientationInterpolation m_xOrientationInterpolationData;
	Asura_MoveData_PositionInterpolation m_xPositionInterpolationData;

private:
	typedef AVP_Move PARENT;
};

class AVP_Move_Interaction_EndWeaponBack : public AVP_Move
{
public:
	AVP_Move_Interaction_EndWeaponBack( Asura_Movement_System& xParentSystem );
	virtual ~AVP_Move_Interaction_EndWeaponBack() {}

	static Asura_Hash_ID GetStaticHash() { return 0xe7e383a4; } //AVP_Move_Interaction_End

protected:
	virtual bool Start( const Asura_Msg_Move* pxStartMsg );

private:
	typedef AVP_Move PARENT;
};

#endif   // ifndef __AVP_MOVE_INTERACTION_H__

/// End of file. ///
