
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Alien_MovesTail.h
// Author : Chris Wallace
// Date   : 29-Oct-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_ALIEN_MOVESTAIL_H__
#define __AVP_ALIEN_MOVESTAIL_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Moves/Vertebrates/AVP_MovesMelee.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Alien_Move_Melee_TailAttack_Start
// Author       : Anthony Gregson
// Date         : 02/12/08
////////////////////////////////////////////////////////////////////////////////

// Common start move for tail attacks, allowing us to set up the tail IK in a standardised way.
class AVP_Alien_Move_Melee_TailAttack_Start : public AVP_Move_Melee_GenericAttack_Start
{
public:
	AVP_Alien_Move_Melee_TailAttack_Start(Asura_Movement_System& xParentSystem, const Asura_Hash_ID uHash,
											const Asura_Hash_ID uFirstPersonBlueprintHash, const Asura_Hash_ID uThirdPersonBlueprintHash, const char* szBaseParameterName,
											const Asura_Hash_ID uHitReturnMove, const Asura_Hash_ID uCounteredReturnMove, const Asura_Hash_ID uMissReturnMove);

protected:
	virtual bool Start(const Asura_Msg_Move* pxStartMsg);
	virtual void Finish();
	virtual void Abort();

private:
	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Alien_Move_Melee_TailLash_Start
// Author       : Anthony Gregson
// Date         : 02/12/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Alien_Move_Melee_TailLash_Start : public AVP_Alien_Move_Melee_TailAttack_Start
{
public:
	AVP_Alien_Move_Melee_TailLash_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x4FDA17BA; } // Asura_GetHashID("AVP_Alien_Move_Melee_TailLash_Start")); }

private:
	typedef AVP_Alien_Move_Melee_TailAttack_Start PARENT;
};

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Alien_Move_Melee_TailLash_Return_Hit
// Author       : Anthony Gregson
// Date         : 02/12/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Alien_Move_Melee_TailLash_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	AVP_Alien_Move_Melee_TailLash_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0xB82FEBAC; } // Asura_GetHashID("AVP_Alien_Move_Melee_TailLash_Return_Hit")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Alien_Move_Melee_TailLash_Return_Countered
// Author       : Anthony Gregson
// Date         : 02/12/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Alien_Move_Melee_TailLash_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	AVP_Alien_Move_Melee_TailLash_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0xFD21F4F4; } // Asura_GetHashID("AVP_Alien_Move_Melee_TailLash_Return_Countered")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Alien_Move_Melee_TailLash_Return_Miss
// Author       : Anthony Gregson
// Date         : 02/12/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Alien_Move_Melee_TailLash_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	AVP_Alien_Move_Melee_TailLash_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x4DCFD003; } // Asura_GetHashID("AVP_Alien_Move_Melee_TailLash_Return_Miss")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
};


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Alien_Move_Melee_TailStab_Start
// Author       : Anthony Gregson
// Date         : 12/01/09
////////////////////////////////////////////////////////////////////////////////

class AVP_Alien_Move_Melee_TailStab_Start : public AVP_Alien_Move_Melee_TailAttack_Start
{
public:
	AVP_Alien_Move_Melee_TailStab_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x73B5E172; } // Asura_GetHashID("AVP_Alien_Move_Melee_TailStab_Start")); }

private:
	typedef AVP_Alien_Move_Melee_TailAttack_Start PARENT;
};

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Alien_Move_Melee_TailStab_Return_Hit
// Author       : Anthony Gregson
// Date         : 12/01/09
////////////////////////////////////////////////////////////////////////////////

class AVP_Alien_Move_Melee_TailStab_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	AVP_Alien_Move_Melee_TailStab_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0xFD4574F4; } // Asura_GetHashID("AVP_Alien_Move_Melee_TailStab_Return_Hit")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Alien_Move_Melee_TailStab_Return_Countered
// Author       : Anthony Gregson
// Date         : 12/01/09
////////////////////////////////////////////////////////////////////////////////

class AVP_Alien_Move_Melee_TailStab_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	AVP_Alien_Move_Melee_TailStab_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x74ED683C; } // Asura_GetHashID("AVP_Alien_Move_Melee_TailStab_Return_Countered")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Alien_Move_Melee_TailStab_Return_Miss
// Author       : Anthony Gregson
// Date         : 12/01/09
////////////////////////////////////////////////////////////////////////////////

class AVP_Alien_Move_Melee_TailStab_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	AVP_Alien_Move_Melee_TailStab_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0xAB6B6FBB; } // Asura_GetHashID("AVP_Alien_Move_Melee_TailStab_Return_Miss")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
};


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Alien_Move_Melee_TailCharge_Start
// Author       : Anthony Gregson
// Date         : 12/01/09
////////////////////////////////////////////////////////////////////////////////

class AVP_Alien_Move_Melee_TailCharge_Start : public AVP_Move_Melee
{
public:
	AVP_Alien_Move_Melee_TailCharge_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x9C0B9E81; } //Asura_GetHashID("AVP_Alien_Move_Melee_TailCharge_Start");

private:
	typedef AVP_Move_Melee PARENT;
};


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Alien_Move_Melee_TailCharge_Loop
// Author       : Anthony Gregson
// Date         : 12/01/09
////////////////////////////////////////////////////////////////////////////////

class AVP_Alien_Move_Melee_TailCharge_Loop : public AVP_Move_Melee
{
public:
	AVP_Alien_Move_Melee_TailCharge_Loop(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x4D87A9A2; } //Asura_GetHashID("AVP_Alien_Move_Melee_TailCharge_Loop");

protected:
	virtual bool ShouldStart() const { return true; }

private:
	typedef AVP_Move_Melee PARENT;
};


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Alien_Move_Melee_TailCharge_End
// Author       : Anthony Gregson
// Date         : 12/01/09
////////////////////////////////////////////////////////////////////////////////

class AVP_Alien_Move_Melee_TailCharge_End : public AVP_Move_Melee
{
public:
	AVP_Alien_Move_Melee_TailCharge_End(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x97254E1D; } //Asura_GetHashID("AVP_Alien_Move_Melee_TailCharge_End");

private:
	typedef AVP_Move_Melee PARENT;
};



#endif   // ifndef __AVP_ALIEN_MOVESTAIL_H__

/// End of file. ///
