//----------------------------------//----------------------------------//----------------------------------//----------------------------------
//
// File   : AVP_Human_MovesGamescene.h
// Author : Gareth Thomas
// Date   : 01 / 07 / 2008
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
//----------------------------------//----------------------------------//----------------------------------//----------------------------------

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE
//----------------------------------//----------------------------------//----------------------------------//----------------------------------

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
#ifndef __AVP_HUMAN_MOVESGAMESCENE_H__
#define __AVP_HUMAN_MOVESGAMESCENE_H__
//----------------------------------//----------------------------------//----------------------------------//----------------------------------

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
// Include files...
//----------------------------------//----------------------------------//----------------------------------//----------------------------------
#include "Entity/PhysicalObject/Moves/Asura_MoveData_Animation.h"
#include "Entity/PhysicalObject/Moves/Asura_MoveData_OrientationInterpolation.h"
#include "Entity/PhysicalObject/Moves/Asura_MoveData_PositionInterpolation.h"
#include "Entity/PhysicalObject/Actor/Vertebrates/Human/AVP_Messages_Human.h"
#include "Moves/AVP_Moves.h"

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
// Forward declarations...
//----------------------------------//----------------------------------//----------------------------------//----------------------------------
class AVP_ClientActor_Human;

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
// Class declaration...
//----------------------------------//----------------------------------//----------------------------------//----------------------------------

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
//----------------------------------//----------------------------------//----------------------------------//----------------------------------
class AVP_Move_Human_MountGamescene : public AVP_Move
{
public:

	AVP_Move_Human_MountGamescene( Asura_Movement_System& xParentSystem ) : PARENT( xParentSystem, GetStaticHash() ) {}
	virtual const char* GetName( void ) const		{ return( "AVP_Move_Human_MountGamescene" ); }
	static Asura_Hash_ID GetStaticHash( void )		{ return( 0x8d47f47d ); } //"AVP_Move_Human_MountGamescene"

protected:

	// Protected variables...
	Asura_MoveData_PositionInterpolation		m_xPositionInterpolationData;
	Asura_MoveData_OrientationInterpolation		m_xOrientationInterpolationData;

	virtual bool Start( const Asura_Msg_Move* pxStartMsg );
	virtual	bool ShouldStart(void) const		{ return true; }

private:
	typedef AVP_Move PARENT;

	AVP_Move_Human_MountGamescene( void );
	AVP_Move_Human_MountGamescene( const AVP_Move_Human_MountGamescene& xOther );
	AVP_Move_Human_MountGamescene& operator = ( const AVP_Move_Human_MountGamescene& xOther );
};

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
#endif // __AVP_HUMAN_MOVESGAMESCENE_H__
//----------------------------------//----------------------------------//----------------------------------//----------------------------------