///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Human_MovesTequila.h
// Author : Will Plano
// Date   : 03/30/2009
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_HUMAN_MOVES_TEQUILA_H__
#define __AVP_HUMAN_MOVES_TEQUILA_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/Moves/Asura_MoveData_Animation.h"
#include "Moves/AVP_Moves.h"

class AVP_Human_Move_TequilaPutDown_Player : public AVP_Move_Puppeteer
{
public:
	// Public functions...
	AVP_Human_Move_TequilaPutDown_Player(Asura_Movement_System& xParentSystem);

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return 0x471cdf60; } // Asura_GetHashID("AVP_Human_Move_TequilaPutDown_Player")); }

protected:
	virtual bool Start(const Asura_Msg_Move* pxStartMsg);

private:
	typedef AVP_Move_Puppeteer PARENT;
};


class AVP_Human_Move_TequilaPickUp_Player : public AVP_Move_Puppeteer
{
public:

	AVP_Human_Move_TequilaPickUp_Player( Asura_Movement_System& xParentSystem );

	static Asura_Hash_ID GetStaticHash() { return 0xbbad4733; } // { Asura_Get_Hash_ID( "AVP_Human_Move_TequilaPickUp_Player" ); }

protected:
	Asura_MoveData_OrientationInterpolation	m_xOrientationInterpolationData;

	virtual bool Start( const Asura_Msg_Move* pxStartMsg );

private:
	typedef AVP_Move_Puppeteer PARENT;
};

class AVP_Human_Move_TequilaPutDown_Tequila : public AVP_Move_Puppet
{
public:
	// Public functions...
	AVP_Human_Move_TequilaPutDown_Tequila(Asura_Movement_System& xParentSystem);

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return 0x6505c28a; } // Asura_GetHashID("AVP_Human_Move_TequilaPutDown_Tequila")); }

protected:
	virtual bool Start(const Asura_Msg_Move* pxStartMsg);

private:
	typedef AVP_Move_Puppet PARENT;
};


class AVP_Human_Move_TequilaPickUp_Tequila : public AVP_Move_Puppet
{
public:

	AVP_Human_Move_TequilaPickUp_Tequila( Asura_Movement_System& xParentSystem );

	static Asura_Hash_ID GetStaticHash() { return 0x82825517; } // { Asura_Get_Hash_ID( "AVP_Human_Move_TequilaPickUp_Tequila" ); }

protected:
	Asura_MoveData_OrientationInterpolation	m_xOrientationInterpolationData;

	virtual bool Start( const Asura_Msg_Move* pxStartMsg );

private:
	typedef AVP_Move_Puppet PARENT;
};

#endif   // ifndef __AVP_HUMAN_MOVES_TEQUILA_H__
