//----------------------------------//----------------------------------//----------------------------------//----------------------------------
//
// File   : AVP_Human_MovesGamescene.h
// Author : Gareth Thomas
// Date   : 01 / 07 / 2008
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
//----------------------------------//----------------------------------//----------------------------------//----------------------------------

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE
//----------------------------------//----------------------------------//----------------------------------//----------------------------------

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
#ifndef __AVP_HUMAN_MOVES_MOVETOFLOOR_H__
#define __AVP_HUMAN_MOVES_MOVETOFLOOR_H__ 1
//----------------------------------//----------------------------------//----------------------------------//----------------------------------

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
// Include files...
//----------------------------------//----------------------------------//----------------------------------//----------------------------------
#include "Entity/PhysicalObject/Moves/Asura_MoveData_Animation.h"
#include "Entity/PhysicalObject/Actor/Vertebrates/Human/AVP_Messages_Human.h"
#include "Moves/AVP_Moves.h"

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
// Forward declarations...
//----------------------------------//----------------------------------//----------------------------------//----------------------------------
class AVP_ClientActor_Human;

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
// Class declaration...
//----------------------------------//----------------------------------//----------------------------------//----------------------------------

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
//----------------------------------//----------------------------------//----------------------------------//----------------------------------
class AVP_Move_Human_MoveToFloor : public AVP_Move
{
public:

	AVP_Move_Human_MoveToFloor( Asura_Movement_System& xParentSystem ) : PARENT( xParentSystem, GetStaticHash() ) {}
	virtual const char* GetName( void ) const		{ return( "AVP_Move_Human_MoveToFloor" ); }
	static Asura_Hash_ID GetStaticHash( void )		{ return( 0x6e6be664 ); } //"AVP_Move_Human_MoveToFloor"

protected:

	virtual bool Start( const Asura_Msg_Move* pxStartMsg );
	virtual	bool ShouldStart(void) const		{ return true; }

	Asura_MoveData_OrientationInterpolation m_xOrientationInterpolationData;

private:
	typedef AVP_Move PARENT;

	AVP_Move_Human_MoveToFloor( void );
	AVP_Move_Human_MoveToFloor( const AVP_Move_Human_MoveToFloor& xOther );
	AVP_Move_Human_MoveToFloor& operator = ( const AVP_Move_Human_MoveToFloor& xOther );
};

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
#endif // __AVP_HUMAN_MOVES_MOVETOFLOOR_H__
//----------------------------------//----------------------------------//----------------------------------//----------------------------------