//
// AVP_Multiplayer_GameCore.h
//
// Created by JG - 03 July 2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_MULTIPLAYER_GAMECORE_H__
#define __AVP_MULTIPLAYER_GAMECORE_H__

//----------------------------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////////////////////////
//  CLASS    :  AVP_Multiplayer_GameCore
//  CREATED  :  JG (3.7.2008)
//  DESC     :  Multiplayer specific game logic
//////////////////////////////////////////////////////////////////////////////////////////
//----------------------------------------------------------------------------------------
class AVP_Multiplayer_GameCore
{
public: 
	static void Initialise(); 
	static void Reset();
	static void Update(); 
	static void Render(); 
	static void Shutdown(); 

	static void BeginMultiplayerMatch(float fStartTime);
	static void EndMultiplayerMatch(); 
	static bool ShouldEndMultiplayerMatch(); 

	static bool IsMultiplayerMatchInProgress()		{ return s_bMultiplayerMatchInProgress; }

	static float GetMatchTimeLeft( void );

	// List of players
	static int GetNumberOfPlayers(); 
	static Asura_Guid FindNextPlayer(Asura_Guid uCurrentPlayerGuid); 
	static Asura_Guid FindPreviousPlayer(Asura_Guid uCurrentPlayerGuid); 
	static Asura_Guid FindFirstPlayerAlive(); 

	// Multiplayer game events
	static void OnActorGetsKilled( Asura_Guid uExecutorGuid, Asura_Guid uVictimGuid ); 
	static void OnActorPerformsSpecialKill( Asura_Guid uExecutorGuid ); 
	static void OnActorCapturesCommandPost( Asura_Guid uCapturerGuid ); 

protected:
	static void ActivateGameModeNode(int iGameMode); 
	static void DoGameModeSanityChecks(); 

	static int FindPlayerIndexByGuid(Asura_Guid uPlayerGuid); 
	static Asura_Guid FindPlayerGuidByIndex(int iIndex);

private:
	static float	s_fCurrentMatchStartTime;
	static bool		s_bMultiplayerMatchInProgress; 
};

#endif//__AVP_MULTIPLAYER_GAMECORE_H__