//
// AVP_Multiplayer_TeamScore.h
//
// Created by JG - 30 June 2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_MULTIPLAYER_TEAMSCORE_H__
#define __AVP_MULTIPLAYER_TEAMSCORE_H__

// Engine
#include "Core/Asura_List.h"

// Project 
#include "Core/AVP_Settings.h"

//----------------------------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////////////////////////
//  CLASS    :  AVP_Multiplayer_TeamScore
//  CREATED  :  JG (18.8.2008)
//  DESC     :  Storage class for team information such as score, lives pool, etc. 
//////////////////////////////////////////////////////////////////////////////////////////
//----------------------------------------------------------------------------------------
class AVP_Multiplayer_TeamScore
{
public:
	// Creation function
	static void Create( AVP_Settings::Team eTeam );

	// Destructor
	static void DestroyAll( void ); 

	// Update
	static void Update( void );
	
	// Accessor to team score for an specific team
	static AVP_Multiplayer_TeamScore* FindTeamScore( AVP_Settings::Team eTeam ); 

	// Reset team information
	void Reset( void ); 

	// Team id.
	AVP_Settings::Team	GetTeam( void )	const								{ return m_eTeam; }				
	
	// Team lives accessors
	void	SetNumberOfTeamLives( int iNumberOfTeamLives )				{ m_iNumberOfTeamLives = iNumberOfTeamLives; }
	int		GetNumberOfTeamLives( void ) const							{ return m_iNumberOfTeamLives; }

	// Team score accessors
	void	SetTeamScore( int iTeamScore )								{ m_iTeamScore = iTeamScore; }
	int		GetTeamScore( void ) const									{ return m_iTeamScore; }

	// Global accessors
	static  Asura_List<AVP_Multiplayer_TeamScore>& GetList( void )		{ return s_xTeamScoreList; }

protected:
	AVP_Settings::Team	m_eTeam; 
	int					m_iNumberOfTeamLives; 
	int					m_iTeamScore;

	// Contructor / destructor
	~AVP_Multiplayer_TeamScore(); 
	AVP_Multiplayer_TeamScore( AVP_Settings::Team eTeam ); 

private:
	static	Asura_List<AVP_Multiplayer_TeamScore>				s_xTeamScoreList; 
}; 

#endif//__AVP_MULTIPLAYER_TEAMSCORE_H__