//////////////////////////////////////////////////////////////////////////////
//
// Asura_Project_Network.cpp
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#include "Network/Asura_Network.h"

// Game independent header-files...
#include "Entity/AVP_Entity_Classification.h"
#include "Entity/AVP_Messages.h"

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

bool Asura_Network::Project_IsBotConnected( Asura_Guid uBotGUID )
{
    return false;
}

bool Asura_Network::Project_RemoveBot( Asura_Guid uBotGUID )
{
    return false;
}

Asura_Guid Asura_Network::Project_GetPlayerGUID( const Asura_UnicodeChar* wszPlayerName, bool bIncludeBots )
{
    return ASURA_GUID_UNREGISTERED;
}

const Asura_UnicodeChar* Asura_Network::Project_GetPlayerName( Asura_Guid uPlayerGUID )
{
    return 0;
}

#ifdef ASURA_SUPPORT_COMMAND_CONSOLE
bool Asura_Network::Project_ListClientPlayersInConsole()
{
    return false;
}

bool Asura_Network::Project_ListBotsInConsole()
{
    return false;
}
#endif // ASURA_SUPPORT_COMMAND_CONSOLE

#if ASURA_NETWORK_LOGGING

#define CASE_TO_STR( _str, _case ) \
        case (_case): (_str) = #_case; break

void Asura_Network::Project_GetMsgIDDesc(u_int uMsgID, const char** pszDesc)
{
	switch(uMsgID)
	{
		// START OF STATIC MESSAGES
		CASE_TO_STR(*pszDesc, AVP_MSGID_END_OF_LEVEL);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CONVERT_PLAYER_TO_AI);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CHUNK);
		CASE_TO_STR(*pszDesc, AVP_MSGID_FORCE_SPAWNED_HUMANS_TO_BE_SCARED);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_FORMATION_DIRECTION);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CHANGE_ALIEN_SPAWN_SETTINGS);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ADD_ALIENS_TO_SPAWN_QUEUE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SPAWN_ALIENS);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ADD_AI_OBJECTIVE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ADD_SQUAD_MEMBER);
		CASE_TO_STR(*pszDesc, AVP_MSGID_REMOVE_SQUAD_MEMBER);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ALIEN_TEAM_SET_BEHAVIOUR);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ALIEN_TEAM_ADD_SPAWNTOKEN);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ALIEN_TEAM_REMOVE_SPAWNTOKEN);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ALIEN_TEAM_PREPARE_ROOM);
		CASE_TO_STR(*pszDesc, AVP_MSGID_REQUEST_CLOAK_ON);
		CASE_TO_STR(*pszDesc, AVP_MSGID_REQUEST_CLOAK_OFF);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_PREFERRED_TARGET_TYPE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_REQUEST_TORCH_ON);
		CASE_TO_STR(*pszDesc, AVP_MSGID_REQUEST_TORCH_OFF);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ALIEN_TEAM_THREAT_BONUS);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SPAWN_HUMANOIDS);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CHANGE_HUMANOID_SPAWN_SETTINGS);
		CASE_TO_STR(*pszDesc, AVP_MSGID_MERGE_HUMANOID_SQUADS);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SPLIT_HUMANOID_SQUAD);
		CASE_TO_STR(*pszDesc, AVP_MSGID_LIGHT_CHANGE_EVENT);
		CASE_TO_STR(*pszDesc, AVP_MSGID_REQUEST_HUMANOID_PATROL);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PERFORM_AI_OBJECTIVE_ACTION);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SPAWN);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SPAWN_SET_MAX_SPAWN_COUNT);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SPAWN_RESET_SPAWN_COUNTER);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SPAWN_SET_MAX_IN_PLAY);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_ALIEN_SQUAD_BEHAVIOUR);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_ALIEN_SQUAD_BEHAVIOUR_PARAMS);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_AI_TARGET_PRIORITIES);
		CASE_TO_STR(*pszDesc, AVP_MSGID_RESET_AI_TARGET_PRIORITIES);
		CASE_TO_STR(*pszDesc, AVP_MSGID_INTERACTION_OBJECT_ENABLE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_INTERACTION_OBJECT_DISABLE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ACTIVATE_SELECTED_ENTITIES);
		CASE_TO_STR(*pszDesc, AVP_MSGID_DEACTIVATE_SELECTED_ENTITIES);
		CASE_TO_STR(*pszDesc, AVP_MSGID_AI_OBJECTIVE_COMPLETE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SENTRYGUN_ENABLE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SENTRYGUN_DISABLE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SENTRYGUN_DESTROY);
		CASE_TO_STR(*pszDesc, AVP_MSGID_NOTUSED_32813);
		CASE_TO_STR(*pszDesc, AVP_MSGID_NOTUSED_32814);
		CASE_TO_STR(*pszDesc, AVP_MSGID_NOTUSED_32815);
		CASE_TO_STR(*pszDesc, AVP_MSGID_NOTUSED_32816);
		CASE_TO_STR(*pszDesc, AVP_MSGID_NOTUSED_32817);
		CASE_TO_STR(*pszDesc, AVP_MSGID_NOTUSED_32818);
		CASE_TO_STR(*pszDesc, AVP_MSGID_NOTUSED_32819);
		CASE_TO_STR(*pszDesc, AVP_MSGID_NOTUSED_32820);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_SQUAD_ALERT_STATUS_TO_PASSIVE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CHANGE_OWNERSHIP_TO_TEAM1);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CHANGE_OWNERSHIP_TO_TEAM2);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CHANGE_OWNERSHIP_TO_TEAM3);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CAPTUREPOINT_LOCK);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CAPTUREPOINT_UNLOCK);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_FACEHUGGER_SQUAD_BEHAVIOUR);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CHANGE_MARINE_SQUAD_SETTINGS);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PROMOTE_TO_SQUAD_LEADER);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ATTACK_SCRIPTED_TARGET);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PICKUP_SET_INTELLIGENT_AMOUNT);
		CASE_TO_STR(*pszDesc, AVP_MSGID_STOP_ATTACKING_SCRIPTED_TARGET);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ADD_PLAYER_OBJECTIVE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_PLAYER_OBJECTIVE_COMPLETE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_DROPSHIP_ATTACK_MODE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_TRIGGER_INTERACTION_ON_LOCAL_PLAYER);
		CASE_TO_STR(*pszDesc, AVP_MSGID_DISABLE_PICKUP);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ENABLE_PICKUP);
		CASE_TO_STR(*pszDesc, AVP_MSGID_INTERACTION_OBJECT_INITIALISE_TO_ON);
		CASE_TO_STR(*pszDesc, AVP_MSGID_INTERACTION_OBJECT_INITIALISE_TO_OFF);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_PREDATOR_BEHAVIOUR);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CHANGE_HUMANOID_SQUAD_MOVEMENT_MODE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_FUNCTIONALITY_MOTION_TRACKER_ON);
		CASE_TO_STR(*pszDesc, AVP_MSGID_FUNCTIONALITY_MOTION_TRACKER_OFF);
		CASE_TO_STR(*pszDesc, AVP_MSGID_FUNCTIONALITY_VISION_MODES_ON);
		CASE_TO_STR(*pszDesc, AVP_MSGID_FUNCTIONALITY_VISION_MODES_OFF);
		CASE_TO_STR(*pszDesc, AVP_MSGID_FUNCTIONALITY_TORCH_ON);
		CASE_TO_STR(*pszDesc, AVP_MSGID_FUNCTIONALITY_TORCH_OFF);
		CASE_TO_STR(*pszDesc, AVP_MSGID_REPLENISH_PREDATOR_ENERGY);
		CASE_TO_STR(*pszDesc, AVP_MSGID_LOOK_AT_ENTITY);
		CASE_TO_STR(*pszDesc, AVP_MSGID_STOP_LOOKING_AT_ENTITY);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_GS2_MOVE_SPEED);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_HEALTH);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PLAYER_OBJECTIVE_SET_MARKER_LOCATION);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PLAYER_OBJECTIVE_SET_TARGET_ENTITY);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PLAYER_OBJECTIVE_SET_CURRENT);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PLAYER_OBJECTIVE_SET_COMPLETE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PLAYER_OBJECTIVE_SET_USE_OWN_LOCATION);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PLAYER_OBJECTIVE_SET_NO_MARKER);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PREDATOR_LOCK_POSITION_F);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PREDATOR_LOCK_POSITION_T);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PREDATOR_LOCK_POSITION_X);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PREDATOR_LOCK_POSITION_O);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_PICKUPABLE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_NOT_PICKUPABLE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_DROPPABLE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_NOT_DROPPABLE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_DESTROY_OCCUPIER);
		CASE_TO_STR(*pszDesc, AVP_MSGID_DEACTIVATE_OCCUPIER);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ADD_PLAYER_PICKUP);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CHANGE_HUMANOID_KNOWLEDGE_SETTINGS);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_SQUAD_ALERT_STATUS_TO_ACTIVE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_SQUAD_ALERT_STATUS_TO_AGGRESSIVE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_SENTRYGUN_SWEEP_SPEED);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_SENTRYGUN_VISION_RANGE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_SENTRYGUN_HOR_FOV);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_SENTRYGUN_VER_FOV);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_SENTRYGUN_FIRING_ARC);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_SENTRYGUN_LETHAL_RANGE);

		CASE_TO_STR(*pszDesc, AVP_MSGID_ATTACH_WEAPON);
		CASE_TO_STR(*pszDesc, AVP_MSGID_DETACH_WEAPON);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CREATE_ATTACHMENT);
		CASE_TO_STR(*pszDesc, AVP_MSGID_DESTROY_ATTACHMENT);
		CASE_TO_STR(*pszDesc, AVP_MSGID_DETACH_ATTACHMENT);
		CASE_TO_STR(*pszDesc, AVP_MSGID_MOUNT_LIFT);
		CASE_TO_STR(*pszDesc, AVP_MSGID_DISMOUNT_LIFT);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ALIENQUEEN_ADD_TO_TARGET_LIST);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ALIENQUEEN_REMOVE_FROM_TARGET_LIST);
		CASE_TO_STR(*pszDesc, AVP_MSGID_START_CAMERA_SHAKE );
		CASE_TO_STR(*pszDesc, AVP_MSGID_STOP_CAMERA_SHAKE );
		CASE_TO_STR(*pszDesc, AVP_MSGID_FACEHUGGER_HUG_ENTITY);
		CASE_TO_STR(*pszDesc, AVP_MSGID_DISMEMBER);
		CASE_TO_STR(*pszDesc, AVP_MSGID_FORCE_AIM);
		CASE_TO_STR(*pszDesc, AVP_MSGID_STOP_FORCE_AIM);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SENTRYGUN_DRYFIRE_TOGGLE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ALIENQUEEN_FORCE_ROAR);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ALIENQUEEN_SET_BEHAVIOUR);
		
		CASE_TO_STR(*pszDesc, AVP_MSGID_END_OF_STATIC_MESSAGES);
		// END OF STATIC MESSAGES

		// START OF NON STATIC MESSAGES
		CASE_TO_STR(*pszDesc, AVP_MSGID_PREDATORPLAYERCOMMANDS);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ALIENPLAYERCOMMANDS);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ALIENFACEHUGGERPLAYERCOMMANDS);
		CASE_TO_STR(*pszDesc, AVP_MSGID_HUMANPLAYERCOMMANDS);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PREDATORPLAYERCOMMANDS_COMPRESSED);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ALIENPLAYERCOMMANDS_COMPRESSED);
		CASE_TO_STR(*pszDesc, AVP_MSGID_HUMANPLAYERCOMMANDS_COMPRESSED);
		CASE_TO_STR(*pszDesc, AVP_MSGID_LAUNCH_PROJECTILE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CREATE_GENERICPROJECTILE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CREATE_PROJECTILE_DISC);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CREATE_PROJECTILE_MINE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CREATE_PROJECTILE_DROPSHIP_MISSILE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CREATE_PROJECTILE_FLARE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CREATE_PROJECTILE_FLAMETHROWER);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CREATE_PROJECTILE_ACIDSPIT);
		CASE_TO_STR(*pszDesc, AVP_MSGID_REQUEST_INTERACTION);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PICKUP_DISC);
		CASE_TO_STR(*pszDesc, AVP_MSGID_REQUEST_ANIMATION);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ATTACH_CORPSE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_DETACH_CORPSE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_DETACH_ALL_CORPSES);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CREATEGIB);
		CASE_TO_STR(*pszDesc, AVP_MSGID_RETURN_DISC);
		CASE_TO_STR(*pszDesc, AVP_MSGID_DESTROY_MINE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_DISC_LASER_TRACKING_ON);
		CASE_TO_STR(*pszDesc, AVP_MSGID_DISC_LASER_TRACKING_OFF);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_OBJECTIVE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_KILL_CLIENT_PLAYER);
		CASE_TO_STR(*pszDesc, AVP_MSGID_USE_STIM);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PLAY_DIALOGUE_EVENT);
		CASE_TO_STR(*pszDesc, AVP_MSGID_REGISTER_GUNFIRE_SOUND);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ENTITYDAMAGE_REQUEST_VICTIM);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ENTITYDAMAGE_REQUEST_LINEAR);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ENTITYDAMAGE_REQUEST_RADIAL);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ENTITYDAMAGE_REQUEST_VOLUME);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ENTITYDAMAGE_APPLY_TO_ENTITY);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ENTITYDAMAGE_APPLY_TO_ENVIRONMENT);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ENTITYDAMAGE_APPLYRADIAL_TO_BOTANICALS);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ENTITYDAMAGE_APPLYLINEAR_TO_BOTANICALS);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CREATE_ACID_DAMAGE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_JOINGAME_REQUEST);
		CASE_TO_STR(*pszDesc, AVP_MSGID_JOINGAME_RESPONSE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_JOINGAME_READY);
		CASE_TO_STR(*pszDesc, AVP_MSGID_GAME_TERMINATED);
		CASE_TO_STR(*pszDesc, AVP_MSGID_GAME_RESTART);
		CASE_TO_STR(*pszDesc, AVP_MSGID_GAME_ROTATE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_GAME_OVER);
		CASE_TO_STR(*pszDesc, AVP_MSGID_GRAPPLE_ATTACKER_UPDATE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_GRAPPLE_VICTIM_UPDATE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_GRAPPLE_START);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ACTIVEGRAPPLE_VALUE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ACTIVEGRAPPLE_RESULT);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SETPUPPETGUID);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CREATEPLAYERACTOR);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SETMULTIPLAYERTEAM);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ITEM_BEGIN_USING);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ITEM_BEGIN_IDLING);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ITEM_REQUEST_END_USAGE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_GAMESTATUS_FULLUPDATE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_ENABLE_IK_SOLVER);
		CASE_TO_STR(*pszDesc, AVP_MSGID_DISABLE_IK_SOLVER);
		CASE_TO_STR(*pszDesc, AVP_MSGID_REQUEST_MELEE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_COUNTER_MELEE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_MELEE_ATTACK_HIT);
		CASE_TO_STR(*pszDesc, AVP_MSGID_MELEE_ATTACK_PREPAREGRAPPLE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_MELEE_ATTACK_FAILED_TO_START);
		CASE_TO_STR(*pszDesc, AVP_MSGID_FLINCH);
		CASE_TO_STR(*pszDesc, AVP_MSGID_REQUEST_MELEE_EX);
		CASE_TO_STR(*pszDesc, AVP_MSGID_INITIALISECOMPLETE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_MOVESTART_SERVER);
		CASE_TO_STR(*pszDesc, AVP_MSGID_LEADER_MOVING_TO_AI_OBJECTIVE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_STOP_AI_OBJECTIVE_ACTIONS);
		CASE_TO_STR(*pszDesc, AVP_MSGID_INCOMING_MELEE_STARTED);
		CASE_TO_STR(*pszDesc, AVP_MSGID_INCOMING_MELEE_FINISHED);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SENTRYGUN_PLAYSOUND);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SENTRYGUN_SWITCH_PLAYANIMATION);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PHYSICS_REORIENTATION_RESET);
		CASE_TO_STR(*pszDesc, AVP_MSGID_COLLECT_PICKUP);
		CASE_TO_STR(*pszDesc, AVP_MSGID_REQUEST_PICKUP);
		CASE_TO_STR(*pszDesc, AVP_MSGID_DROP_PICKUP);
		CASE_TO_STR(*pszDesc, AVP_MSG_CLIENT_START_BURNING );
		CASE_TO_STR(*pszDesc, AVP_MSG_CLIENT_STOP_BURNING );
		CASE_TO_STR(*pszDesc, AVP_MSGID_MELEE_PLAYER_BACK );
		CASE_TO_STR(*pszDesc, AVP_MSGID_DISTRACT_AI );
		CASE_TO_STR(*pszDesc, AVP_MSGID_PLAY_DISTRACTION_SOUND );
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_TOOL_IN);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_TOOL_OUT);
		CASE_TO_STR(*pszDesc, AVP_MSGID_SET_HACKING_TOOL);
		CASE_TO_STR(*pszDesc, AVP_MSGID_RESTORE_PREVIOUS_WEAPON);
		CASE_TO_STR(*pszDesc, AVP_MSGID_INVENTORY_ITEM_RELOAD);
		CASE_TO_STR(*pszDesc, AVP_MSGID_LAUNCH_ACID_SPIT_PROJECTILE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_CLEAR_PLAYERS_LOF);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PICK_TEQUILA_UP);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PUT_TEQUILA_DOWN);
		CASE_TO_STR(*pszDesc, AVP_MSGID_REQUEST_TURN);
		CASE_TO_STR(*pszDesc, AVP_MSGID_LIGHT_CHANGE_EVENT_CODE);
		CASE_TO_STR(*pszDesc, AVP_MSGID_PLAY_REST_ANIM_PICKUP);
		// END OF NON STATIC MESSGES
		default:
		{
			break;
		}
	}
}

void Asura_Network::Project_GetEntityClassificationDesc( u_short usEntityClassification, const char** pszDesc )
{
    switch (usEntityClassification)
    {
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_ACTOR);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_ALIEN);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_ALIENCHESTBURSTER);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_ALIENFACEHUGGER);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_ALIENQUEEN);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_HUMAN);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_PREDATOR);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_PREDALIEN);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_MINE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_ACID_DAMAGE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_GS2SPLINE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_DISC);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_GIB);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_INTERACTIONTRIGGER);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_SPAWNPOINT);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_AIPOINTCONTROLLER);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_GOTOPOINT);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_VERTEBRATE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_VEHICLE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_PLAYER);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_ALIEN_HYBRID);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_PREDATORGRENADE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_ORIENTEDNODE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_GUARDZONE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_GS2NODE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_DAMAGEABLEOBJECT);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_SQUADCONTROLLER);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_TEAMCONTROLLER);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_TRIPMINE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_HUMANFLARE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_DROPSHIP);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_CARBINE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_INTERACTOBJECT);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_PISTOL);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_GS2ATTRACTOR);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_GENERICPROJECTILE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_CHECKPOINTNODE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_SHOTGUN);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_BOMBTARGET);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_PLAYERINFO);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_ALIENTEAM);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_ALIENSPAWNPOINT);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_GAMEPLAYVOLUME);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_MARINESQUAD);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_MARINETEAM);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_ANDROID);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_LOOKAT);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_FORMATIONPOINT);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_VANTAGEPOINT_PREDATOR);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_AI_OBJECTIVE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_AI_MARINE_OBJECTIVE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_CIVILIAN);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_MARINE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_HUMANSPAWNPOINT);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_COVERPOINT);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_FLEEPOINT);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_VENT);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_SPAWNCONTROLLER);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_SPAWNPOINT2);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_ALIENSQUAD);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_WEAPON);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_SENTRYGUN);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_GAMEMODE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_CAPTUREPOINT);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_SCOREBOARD);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_FACEHUGGERSQUAD);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_PICKUP);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_SHOOTAT);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_PLAYER_OBJECTIVE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_DROPSHIP_MISSILE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_INTERACT_PREDATOR_LOCK);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_INTERACT_TOOL_RECEPTACLE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_INTERACT_BATTERY_RECEPTACLE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_INTERACT_HACKING_POINT);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_INTERACT_SENTRYGUN_INVISISWITCH);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_INTERACT_RETINAL_SCANNER);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_COMMANDPOST); 
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_ROOMNODE);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_MOTIONTRACKERBLIP);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_PLAYER_PROXY);	
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_LOCATIONMARKER);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_WAYPOINTBLOCKERVOLUME);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_PROJECTILE_FLAMETHROWER);
		CASE_TO_STR(*pszDesc, AVP_ENTITYCLASS_PROJECTILE_ACIDSPIT);
		default:
		{
			break;
		}
    }
}

#undef CASE_TO_STR

#endif // ASURA_NETWORK_LOGGING

bool Asura_Network::Project_ShouldMessageBeSentToClient(const Asura_Message* pxMessage, Asura_Guid uClientID)
{
	return true;
}

bool Asura_Network::Project_ShouldMessageBeHandledOnClient(const Asura_Message* pxMessage)
{
	return true;
}

#if defined(ASURA_SUPPORT_EXTERNAL_NETWORK)
const Asura_NetMsg* Asura_Network::Project_RegisterNetMsg(u_short usMsgID, u_short usEntityClassification)
{
	return NULL;
}

bool Asura_Network::Project_IsMessageDataInNetworkByteOrder(u_short usMsgID, u_short usEntityClassification)
{
	return false;
}
#endif	//defined(ASURA_SUPPORT_EXTERNAL_NETWORK)

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////
