///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Overlay_Render.h
// Author : Chris Wallace
// Date   : 20-Dec-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_OVERLAY_RENDER_H__
#define __AVP_OVERLAY_RENDER_H__

#include "Rendering/Asura_Render.h"
#include "Core/Asura_TiledTextureManagement.h"

class AVP_Overlay_Render
{
public:
	static void SetUV(float u1, float v1, float u2, float v2);
	static void SetPixelPos(float x, float y, float w, float h);

	static bool SetFromTileHash(Asura_Hash_ID uTileHash, bool bMirrorX, bool bMirrorY, float x, float y);
	static bool SetFromTileHash(Asura_Hash_ID uTileHash, bool bMirrorX, bool bMirrorY, float x, float y, float fScaleX, float fScaleY);
	static bool SetFromTileHash(Asura_Hash_ID uTileHash, bool bMirrorX, bool bMirrorY, float x, float y, bool bCentreX, bool bCentreY);
	static bool SetFromTileHash(Asura_Hash_ID uTileHash, bool bMirrorX, bool bMirrorY, float x, float y, float fScaleX, float fScaleY, bool bCentreX, bool bCentreY);

	static bool SetFromTileHashClipped(Asura_Hash_ID uTileHash, bool bMirrorX, bool bMirrorY, float x, float y, float fScaleX, float fScaleY, float fMinX, float fMinY, float fMaxX, float fMaxY);

	static bool SetFromTileHashRotated(Asura_Hash_ID uTileHash, bool bMirrorX, bool bMirrorY, float x, float y, float fScaleX, float fScaleY, float fTheta);

	static float GetGraphicHeight(Asura_Hash_ID uTileHash);
	static float GetGraphicWidth(Asura_Hash_ID uTileHash);

	static u_int MultiplyAlphaValue(u_int uColour, float fRatio);
	static u_int MultiplyRedValue(u_int uColour, float fRatio);
	static u_int MultiplyGreenValue(u_int uColour, float fRatio);
	static u_int MultiplyBlueValue(u_int uColour, float fRatio);
};

#endif
