//////////////////////////////////////////////////////////////////////////////
//
// AVP_Dialogue_System.h
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
// Description:
//
//     handles AVP specific code wrt dialogue
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef ___AVP_DIALOGUE_SYSTEM_H___
#define ___AVP_DIALOGUE_SYSTEM_H___

#ifdef ASURA_USE_DIALOGUE_SYSTEM

class Asura_Entity_Client;
class Asura_Cutscene_Actor;
class Asura_Dialogue_Line;

class AVP_Dialogue_System
{
public:
	static void Initialise(void);
	static void Shutdown(void);

private:
	static Asura_Handle ProjectVoiceCreateEvent(const Asura_Dialogue_Line& xLine, Asura_Guid uSpeakerGuid, float fVolumeScale);

protected:
	static const Asura_Entity_Client* FindEntity( Asura_Guid uSpeakerGuid);
	static const Asura_Cutscene_Actor* FindActor(Asura_Guid uSpeakerGuid);

	static Asura_Handle CreateRadioDialogueVoice(const Asura_Dialogue_Line& xLine, Asura_Guid uSpeakerGuid, float fVolumeScale);


};

#endif // defined(ASURA_USE_DIALOGUE_SYSTEM)

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////
#endif // !defined(___AVP_DIALOGUE_SYSTEM_H___)
