///////////////////////////////////////////////////////////////////////////////
//
// File: AVP_CollisionFX_System.h
//
// Created by Martin G.Harris (25/09/2007)
// 
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
// Play SFX/PFX according to collision information from the physics system.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __AVP_COLLISION_FX_SYSTEM_H__
#define __AVP_COLLISION_FX_SYSTEM_H__

// Only compile this code if the symbol is defined.
#ifdef ASURA_USE_COLLISIONFX

// Includes
#include "SpecialFX/Asura_CFX_Effect.h"
#include "SpecialFX/Asura_CollisionFX_System.h"

/////////////////////
// Collision types //
/////////////////////
enum AVP_CFX_TYPE
{
	AVP_CFX_TYPE_PHYSICS_IMPACT	= iASURA_CFX_TYPE_PHYSICS_IMPACT,	// Physics impact collision.
	AVP_CFX_TYPE_PHYSICS_SLIDE  = iASURA_CFX_TYPE_PHYSICS_SLIDE,	// Physics sliding collision.

	// Project-specific collisions here...
	AVP_CFX_TYPE_PREDATOR_CLAW  = iASURA_CFX_TYPE_PROJECT_START,	// Predator claw hitting something.
};


////////////////////////////////////
// AVP_CFX_Effect_PFX_Sound_Event //
////////////////////////////////////
// Combined PFX and sound event CFX.
class AVP_CFX_Effect_PFX_Sound_Event: public Asura_CFX_Effect_PFX_Sound_Event
{
	typedef Asura_CFX_Effect_PFX_Sound_Event PARENT;

public:
	AVP_CFX_Effect_PFX_Sound_Event(Asura_Hash_ID uPFXHash,
								   Asura_Hash_ID uSEHash,
								   u_int uFlags = ASURA_CFX_FLAG_DEFAULT,
								   float fVolumeScale = 1.0f)

		: Asura_CFX_Effect_PFX_Sound_Event(uPFXHash, uSEHash, uFlags, fVolumeScale)
	{
	}

	// Update parameters with each collision.
	//virtual bool UpdateParameters(const Asura_Physics_CollisionFX_Report& xCollInfo);

protected:
};



////////////////////////////
// AVP_CollisionFX_System //
////////////////////////////
class AVP_CollisionFX_System
{
public:
	static Asura_Hash_ID GetSurfaceTypeHashFromEntity(Asura_Guid uGuid);
	static Asura_Hash_ID GetSurfaceTypeHashFromPolygon(u_int uFaceID);

	static Asura_CFX_Effect* CreateEffect(const Asura_Physics_CollisionFX_Report& xCollInfo, int iType);
};

#endif //ASURA_USE_COLLISIONFX

#endif //__AVP_COLLISION_FX_SYSTEM_H__
