///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_Project_Streaming_Zone.cpp
// Author : M.G.Harris
// Date   : 18-May-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"
#include "Streaming/Asura_Streaming_Zone.h"

// Asura includes
#include "Cutscene/Asura_Cutscene.h"
#include "Cutscene/Asura_Cutscene_Actor.h"
#include "Cutscene/Asura_Cutscene_System.h"
#include "Entity/PhysicalObject/Asura_ServerEntity_PhysicalObject.h"
#include "Rendering/Asura_Module.h"
#include "Streaming/Asura_Streaming_ZoneEntities.h"
#include "Streaming/Asura_Streaming_ZoneDataState.h"

// Project includes

////////////////////////////////
// Project_PostLoadInitialise //
////////////////////////////////
// Called after the zone is fully loaded, to give projects a chance to initialise any entities etc.
void Asura_Streaming_Zone::Project_PostLoadInitialise()
{
    // Trigger a pass on the physical objects to block any waypoint links they should.
    Asura_ServerEntity_PhysicalObject::BeginLinkBlockPass();
}


////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Streaming_Zone::Project_ModifyPathForNewlyCreatedZone
// Author       : Andy Tate
// Date         : 26-May-2006
////////////////////////////////////////////////////////////////////////////////

void Asura_Streaming_Zone::Project_ModifyPathForNewlyCreatedZone(const DataState eDataState,
																  Asura_String& xPath)
{
}
/// End of function 'Asura_Streaming_Zone::Project_ModifyPathForNewlyCreatedZone'. ///



///////////////////////////////////////////////////////////////////////////////
// Function		: Asura_Streaming_Zone::Project_ApplyCameraOffset
// Author		: RDM
// Date			: 13-Jun-2006
///////////////////////////////////////////////////////////////////////////////
bool Asura_Streaming_Zone::Project_ApplyCameraOffset( void )
{
	return false;
}
/// End of function 'Asura_Streaming_Zone::Project_ApplyCameraOffset'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Streaming_Zone::Project_CalculateHashForZoneName
// Author       : Andy Tate
// Date         : 17-Jul-2006
////////////////////////////////////////////////////////////////////////////////

Asura_Hash_ID Asura_Streaming_Zone::Project_CalculateHashForZoneName (const Asura_String& xName)
{
	// Use the name to calculate the hash-ID...
	return(Asura_GetHashID(xName.GetString()));
}

/// End of function 'Asura_Streaming_Zone::Project_CalculateHashForZoneName'. ///


/// End of file. ///
