///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_PC_Vertebrate_ControlMapper.cpp
// Author : Andy Tate
// Date   : 27-Sep-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
// JL - 01 April 2009 - Modified version of PC file, used in PC-CLI
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Actor/Vertebrates/AVP_PC_Vertebrate_ControlMapper.h"

// Asura independent header-files...

// Asura platform header-files...
#include "Input/Asura_PlatformInput.h"

// Game independent header-files...
#include "Actor/Vertebrates/AVP_Vertebrate_InputHandler.h"


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_PC_Vertebrate_ControlMapper::InitialiseControlsPC
// Author       : Andy Tate
// Date         : 27-Sep-2007
////////////////////////////////////////////////////////////////////////////////

void AVP_PC_Vertebrate_ControlMapper::InitialiseControlsPC(AVP_Actor_InputHandler& xInputHandler)
{
	AVP_Vertebrate_InputHandler&	xVertebrateInputHandler	= *(static_cast<AVP_Vertebrate_InputHandler*>(&xInputHandler));

	Asura_ControlMap&				xFirst					= xVertebrateInputHandler.GetMapFirstPerson();

	PARENT::InitialiseControlsPC(xInputHandler);

	// first person mappings
	xVertebrateInputHandler.MapAttacks(xFirst, ASURA_KEYID_MOUSEBUTTON1, ASURA_KEYID_MOUSEBUTTON2, ASURA_KEYID_MOUSEBUTTON1, ASURA_KEYID_MOUSEBUTTON2);
	xVertebrateInputHandler.MapFocusKeys(xFirst, ASURA_KEYID_MOUSEBUTTON2, ASURA_KEYID_MOUSEBUTTON2);
	xVertebrateInputHandler.MapMelee(xFirst, 'e', 'e', 'e');
	xVertebrateInputHandler.MapJump(xFirst, ASURA_KEYID_SPACE);
}

/// End of function 'AVP_PC_Vertebrate_ControlMapper::InitialiseControlsPC'. ///

// JL - 01 April 2009 - Stubbed out for PC-CLI to avoid using anything related to joysticks
void AVP_PC_Vertebrate_ControlMapper::InitialiseControlsPS2(AVP_Actor_InputHandler& xInputHandler) {}
void AVP_PC_Vertebrate_ControlMapper::InitialiseControlsPS3(AVP_Actor_InputHandler& xInputHandler) {}
void AVP_PC_Vertebrate_ControlMapper::InitialiseControlsXBox360(AVP_Actor_InputHandler& xInputHandler) {}

/// End of file. ///
