
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_PC_Alien_ControlMapper.cpp
// Author : Andy Tate
// Date   : 27-Sep-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
// JL - 01 April 2009 - Modified version of PC file, used in PC-CLI
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Actor/Vertebrates/Alien/AVP_PC_Alien_ControlMapper.h"

// Asura platform header-files...
#include "Input/Asura_PlatformInput.h"

// Game independent header-files...
#include "Actor/Vertebrates/Alien/AVP_Alien_InputHandler.h"

////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_PC_Alien_ControlMapper::InitialiseControlsPC
// Author       : Andy Tate
// Date         : 27-Sep-2007
////////////////////////////////////////////////////////////////////////////////

void AVP_PC_Alien_ControlMapper::InitialiseControlsPC(AVP_Actor_InputHandler& xInputHandler)
{
	AVP_Alien_InputHandler&	xAlienInputHandler	= *(static_cast<AVP_Alien_InputHandler*>(&xInputHandler));

	Asura_ControlMap&		xFirst				= xAlienInputHandler.GetMapFirstPerson();

	PARENT::InitialiseControlsPC(xInputHandler);

	xAlienInputHandler.MapMovementKeys(xFirst, 'w', 's', 'a', 'd', ASURA_KEYID_LEFTCTRL, ASURA_KEYID_LEFTSHIFT, 'c');
	xAlienInputHandler.MapTailAttack(xFirst, 'q');
	xAlienInputHandler.MapPetFacehuggerControl(xFirst, 'f');
	xAlienInputHandler.MapCreateDistraction(xFirst, 'v');
	xAlienInputHandler.MapReload(xFirst, ASURA_KEYID_VOID);
	xAlienInputHandler.MapHealth(xFirst, 'h');
	xAlienInputHandler.MapTransition(xFirst, ASURA_KEYID_LEFTCTRL);
}

/// End of function 'AVP_PC_Alien_ControlMapper::InitialiseControlsPC'. ///

// JL - 01 April 2009 - Stubbed out for PC-CLI to avoid using anything related to joysticks
void AVP_PC_Alien_ControlMapper::InitialiseControlsPS2(AVP_Actor_InputHandler& xInputHandler) {}
void AVP_PC_Alien_ControlMapper::InitialiseControlsPS3(AVP_Actor_InputHandler& xInputHandler) {}
void AVP_PC_Alien_ControlMapper::InitialiseControlsXBox360(AVP_Actor_InputHandler& xInputHandler) {}

/// End of file. ///
