
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_PC_Human_ControlMapper.cpp
// Author : Andy Tate
// Date   : 27-Sep-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
// JL - 01 April 2009 - Modified version of PC file, used in PC-CLI
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Actor/Vertebrates/Human/AVP_PC_Human_ControlMapper.h"

// Asura platform header-files...
#include "Input/Asura_PlatformInput.h"

// Game independent header-files...
#include "Actor/Vertebrates/Human/AVP_Human_InputHandler.h"

////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_PC_Human_ControlMapper::InitialiseControlsPC
// Author       : Andy Tate
// Date         : 27-Sep-2007
////////////////////////////////////////////////////////////////////////////////

void AVP_PC_Human_ControlMapper::InitialiseControlsPC(AVP_Actor_InputHandler& xInputHandler)
{
	AVP_Human_InputHandler&	xHumanInputHandler	= *(static_cast<AVP_Human_InputHandler*>(&xInputHandler));

	Asura_ControlMap&		xFirst				= xHumanInputHandler.GetMapFirstPerson();

	PARENT::InitialiseControlsPC(xInputHandler);

	// First-person mappings...
	xHumanInputHandler.MapMovementKeys(xFirst, 'w', 's', 'a', 'd', ASURA_KEYID_LEFTCTRL, ASURA_KEYID_LEFTSHIFT, 'c');
	xHumanInputHandler.MapVisionAndFlare(xFirst, 'q', 'f');
	xHumanInputHandler.MapTorch(xFirst, 't');
	xHumanInputHandler.MapZoom(xFirst, ASURA_KEYID_MOUSEWHEELUP, ASURA_KEYID_MOUSEWHEELDOWN, ASURA_KEYID_VOID);


//	xHumanInputHandler.MapADS(xFirst, ASURA_KEYID_MOUSEBUTTON3);

	// weapon and vision mode select mappings
	xHumanInputHandler.MapWeaponSelect( xFirst, '1', ASURA_KEYID_VOID, '3', ASURA_KEYID_VOID, ASURA_KEYID_VOID, ASURA_KEYID_VOID, '2', ASURA_KEYID_VOID );
	xHumanInputHandler.MapReload( xFirst, 'r' );
	xHumanInputHandler.MapHealth(xFirst, 'h');
}

/// End of function 'AVP_PC_Human_ControlMapper::InitialiseControlsPC'. ///


// JL - 01 April 2009 - Stubbed out for PC-CLI to avoid using anything related to joysticks
void AVP_PC_Human_ControlMapper::InitialiseControlsPS2(AVP_Actor_InputHandler& xInputHandler) {}
void AVP_PC_Human_ControlMapper::InitialiseControlsPS3(AVP_Actor_InputHandler& xInputHandler) {}
void AVP_PC_Human_ControlMapper::InitialiseControlsXBox360(AVP_Actor_InputHandler& xInputHandler) {}

/// End of file. ///
