
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_PC_Predator_ControlMapper.cpp
// Author : Andy Tate
// Date   : 27-Sep-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
// JL - 01 April 2009 - Modified version of PC file, used in PC-CLI
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "AVP_PC_Predator_ControlMapper.h"

// Asura platform header-files...
#include "Input/Asura_PlatformInput.h"

// Game independent header-files...
#include "Actor/Vertebrates/Predator/AVP_Predator_InputHandler.h"


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_PC_Predator_ControlMapper::InitialiseControlsPC
// Author       : Andy Tate
// Date         : 27-Sep-2007
////////////////////////////////////////////////////////////////////////////////

void AVP_PC_Predator_ControlMapper::InitialiseControlsPC(AVP_Actor_InputHandler& xInputHandler)
{
	AVP_Predator_InputHandler&	xPredatorInputHandler	= *(static_cast<AVP_Predator_InputHandler*>(&xInputHandler));

	Asura_ControlMap& 			xFirst 					= xPredatorInputHandler.GetMapFirstPerson();
	Asura_ControlMap&			xVisionSelector			= xPredatorInputHandler.GetMapVisionSelector();

	PARENT::InitialiseControlsPC(xInputHandler);

	// first person mappings
	xPredatorInputHandler.MapMovementKeys(xFirst, 'w', 's', 'a', 'd', ASURA_KEYID_LEFTCTRL, ASURA_KEYID_LEFTSHIFT, 'c');
	xPredatorInputHandler.MapVision(xFirst, ASURA_KEYID_VOID, 'q', ASURA_KEYID_VOID);
	xPredatorInputHandler.MapCloak(xFirst, 'f');
	xPredatorInputHandler.MapRecon( xFirst, 'e' );
	xPredatorInputHandler.MapZoom(xFirst, ASURA_KEYID_MOUSEWHEELUP, ASURA_KEYID_MOUSEWHEELDOWN, ASURA_KEYID_VOID);

	xPredatorInputHandler.MapLookMouse(xVisionSelector);
	xPredatorInputHandler.MapMenuToggle(xVisionSelector, ASURA_KEYID_ESCAPE);
	xPredatorInputHandler.MapObjectivesAndSelectToggle(xVisionSelector, ASURA_KEYID_BACKSPACE, ASURA_KEYID_TAB);
	xPredatorInputHandler.MapFreezeTime(xVisionSelector, 'p');
	xPredatorInputHandler.MapMovementKeys(xVisionSelector, 'w', 's', 'a', 'd', ASURA_KEYID_LEFTCTRL, ASURA_KEYID_LEFTSHIFT, 'c');

	// weapon and vision mode select mappings
	xPredatorInputHandler.MapVisionSelect( xVisionSelector, ASURA_KEYID_UP, ASURA_KEYID_DOWN, ASURA_KEYID_LEFT, ASURA_KEYID_RIGHT );

	xPredatorInputHandler.MapWeaponSelect( xFirst, '1', ASURA_KEYID_VOID, '2', '3', ASURA_KEYID_VOID, '4', '5', ASURA_KEYID_VOID );
	xPredatorInputHandler.MapReload( xFirst, 'r' );
	xPredatorInputHandler.MapHealth(xFirst, 'h');

}

/// End of function 'AVP_PC_Predator_ControlMapper::InitialiseControlsPC'. ///

// JL - 01 April 2009 - Stubbed out for PC-CLI to avoid using anything related to joysticks
void AVP_PC_Predator_ControlMapper::InitialiseControlsPS2(AVP_Actor_InputHandler& xInputHandler) {}
void AVP_PC_Predator_ControlMapper::InitialiseControlsPS3(AVP_Actor_InputHandler& xInputHandler) {}
void AVP_PC_Predator_ControlMapper::InitialiseControlsXBox360(AVP_Actor_InputHandler& xInputHandler) {}

/// End of file. ///
