
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Platform_Core.cpp
// Author : Andy Tate
// Date   : 4-Oct-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
// JL - 01 April 2009 - Edited PC version used in PC-CLI, it has all references
// to directX removed to make sure PC-CLI doesnt need directX installed to run
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Core/AVP_Core.h"

// Asura independent header-files...
#if !defined(ASURA_TOOLS)
#include "Camera/Asura_Camera.h"
#include "Core/Asura_Windows.h"
#include "Rendering/Asura_Direct3D.h"
#include "Rendering/Asura_Render.h"
#endif	// !defined(ASURA_TOOLS)

// Asura platform header-files...
#include "Input/Asura_PlatformInput.h"
#ifdef ASURA_PC_SUPPORT_STEAMWORKS
#include "Network/Steamworks/Asura_PC_Steamworks.h"
#endif

////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_Core::Platform_Initialise
// Author       : Andy Tate
// Date         : 4-Oct-2006
////////////////////////////////////////////////////////////////////////////////

void AVP_Core::Platform_Initialise (void)
{

#if !defined(ASURA_TOOLS)
 	if(Asura_Windows::RunningFullScreen())
 	{
 	}
 	else
 	{
	 	Asura_Camera::SetPhysicalScreenAspectRatio(16.0f / 9.0f);
 		Asura_Render::SetVideoMode(1280, 720);
 	}
#endif	// !defined(ASURA_TOOLS)
}

/// End of function 'AVP_Core::Platform_Initialise'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_Core::Platform_Shutdown
// Author       : Andy Tate
// Date         : 4-Oct-2006
////////////////////////////////////////////////////////////////////////////////

void AVP_Core::Platform_Shutdown (void)
{
	#ifdef ASURA_PC_SUPPORT_STEAMWORKS
	Asura_PC_Steamworks::Shutdown();
	#endif
}

/// End of function 'AVP_Core::Platform_Shutdown'. ///

#ifdef AVP_LOG_FILE_LOAD_MEMORY_USE
u_int AVP_Core::Platform_GetAvailableMemory()
{
	return 0; // 0 means we're not bothering to do the logging on this platform.
}
#endif //#ifdef AVP_LOG_FILE_LOAD_MEMORY_USE

void AVP_Core::Platform_BeginHUDRender( void ) {}

////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////


/// End of file. ///
