/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

#include "..\..\..\..\..\Asura\PC\Shaders\Shared.fxh"

/******************************************************************************/
/* Parameters                                                                 */
/******************************************************************************/

const texture g_xInitialImageTexture;
const sampler2D g_xInitialImage = sampler_state
{
	Texture = <g_xInitialImageTexture>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
	sRGBTexture = <g_bUseGammaCorrection>;
};

const texture g_xDisplacementMapTexture;
const sampler2D g_xDisplacementMap = sampler_state
{
	Texture = <g_xDisplacementMapTexture>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

const float g_fIntensity;

/******************************************************************************/
/* Constants                                                                  */
/******************************************************************************/



/******************************************************************************/
/* Types                                                                      */
/******************************************************************************/

struct Vertex
{
	float4 m_xPosition : POSITION;
	float2 m_xUV       : TEXCOORD;
};

/******************************************************************************/
/* Functions                                                                  */
/******************************************************************************/

Vertex VShader( const Vertex xIn )
{
	return xIn;
}

float4 PShader( const Vertex xIn ) : COLOR
{
	const half2 xDisplacement = tex2D( g_xDisplacementMap, xIn.m_xUV ).rg * 2.0f - 1.0f;

	return tex2D( g_xInitialImage, xIn.m_xUV + xDisplacement * g_fIntensity);

}

/******************************************************************************/
/* Techniques                                                                 */
/******************************************************************************/

technique
{
	pass
	{
		VertexShader = compile vs_3_0 VShader();
		PixelShader = compile ps_3_0 PShader();
	}
}