//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_Handler_System.h
//
// Copyright (c) 2007 Rebellion. All rights reserved.
//
// Description:
//
//     Performs functions on Asura subsystem handlers on aggregate.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#include "Core/Asura.h"

#ifdef ASURA_USE_MULTIPLE_HANDLERS

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef ___ASURA_PLATFORM_HANDLER_SYSTEM_H___
#define ___ASURA_PLATFORM_HANDLER_SYSTEM_H___ 1

#include "Core/AVP_Handler_System.h"

#include "Rendering/Asura_PlatformRenderObject.h"
#include "Rendering/Asura_Platform_RenderObjectHierarchy.h"

void AVP_Handler_System::Platform_SetCurrentHandler( Asura_Hash_ID uHandler )
{
	Asura_Direct3D_ObjectRenderer::SetCurrentHandler(uHandler);
	Asura_Direct3D_ObjectHierarchyRenderer::SetCurrentHandler(uHandler);
}

void AVP_Handler_System::Platform_DestroyHandler( Asura_Hash_ID uHandler )
{
	Asura_Direct3D_ObjectRenderer::DestroyHandler(uHandler);
	Asura_Direct3D_ObjectHierarchyRenderer::DestroyHandler(uHandler);
}

void AVP_Handler_System::Platform_CreateHandler( Asura_Hash_ID uHandler, Asura_Hash_ID uParentHandler )
{
	Asura_Direct3D_ObjectRenderer::CreateHandler(uHandler,uParentHandler);
	Asura_Direct3D_ObjectHierarchyRenderer::CreateHandler(uHandler,uParentHandler);
}

void AVP_Handler_System::Platform_CreateReport( Asura_Hash_ID uHandler, Asura_Stream& xLog )
{
	Asura_Direct3D_ObjectRenderer::WriteHandlerReport(uHandler,xLog);
	Asura_Direct3D_ObjectHierarchyRenderer::WriteHandlerReport(uHandler,xLog);
}

#endif //#ifdef ___ASURA_PLATFORM_HANDLER_SYSTEM_H___

#endif //#ifdef ASURA_USE_MULTIPLE_HANDLERS