//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_Project_Core.cpp
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#include "ChunkSystem/Asura_Chunk_Loaders.h"
#include "Core/Asura_Core.h"
#include "Core/Asura_UserInput.h"

#include "Rendering/Asura_Direct3D_UserOptions.h"

#ifndef ASURA_TOOLS
#include "Core/Asura_Windows.h"
#endif

#include "Network/Steamworks/Asura_PC_SteamworksServer.h"

void Asura_Core::PlatformProject_EarlyInitialise()
{
	// (AS - 13/9/2007) Enable multithreading due to loading screens being rendered from another thread
	Asura_Direct3D_UserOptions::SetMultiThreadingEnable(true);
}

void Asura_Core::PlatformProject_LateInitialise()
{
#ifndef ASURA_TOOLS
	Asura_Windows::SetPauseWhileMinimised(false);
#endif

#ifdef ASURA_PC_SUPPORT_STEAMWORKS
	if( Asura_PC_Steamworks::IsInitialised() )
	{
		Asura_PC_Steamworks::RegisterConsoleCmds();
	}
#endif
}
