//////////////////////////////////////////////////////////////////////////////
//
// AVP_Platform_Profile.cpp
//
// (AJK - 25.07.2008) Created
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// core
#include "Core/Asura.h"

// header
#include "Core/Profile/AVP_Profile.h"

// Asura
#include "ChunkSystem/Asura_SaveBlock.h"

// Tools ?
#ifdef ASURA_TOOLS
#include "PC/FileSystem/Tools_FileSystem.h"
#endif

void AVP_Profile::Platform_SetToDefaults()
{
}

bool AVP_Profile::Platform_FillFilename(Asura_StringBuffer<128>& xFilename)
{
	xFilename = "Profiles/";
	xFilename += m_xName.GetString();
	xFilename += ".prf";
	return true;
}

bool AVP_Profile::Platform_SaveFile(Asura_SaveBlock& xSaveBlock)
{
    Asura_StringBuffer<128> xFilename;

    Platform_FillFilename(xFilename);

	Asura_StringBuffer<128> xPath;

	xFilename.SplitFilename( &xPath, NULL, NULL );

    CreateDirectory(xPath.GetString(), NULL);
	FILE* pxFile = fopen(xFilename.GetString(), "wb");
	if(!fwrite(xSaveBlock.GetStartPtr(), xSaveBlock.GetSize(), 1, pxFile))
	{
		Asura_Assertf(false,("Error writing to %s.\n Error message : %s", xFilename.GetString()));
	}
	fclose(pxFile);

	return true;
}


#ifdef ASURA_TOOLS
bool AVP_Profile::Platform_DeleteFile()
{
	Asura_StringBuffer<128> xFilename;
	Platform_FillFilename(xFilename);
	return Tools_FileSystem::DeleteFileByName(xFilename.GetString());
}
#endif