///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Platform_FMV.cpp
// Author : Catalin Arsenescu
// Date   : 25/04/08
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

#include "Fmv/AVP_FMV.h"

#include "Core/Asura_UserInput.h"
#include "Cutscene/Asura_FMVSubtitles.h"
#include "Bink/Asura_Bink.h"

bool CheckForFMVSkip( void );

void AVP_FMV::Platform_Initialise ()
{
	//Dont need to do anything here
}

void AVP_FMV::Platform_Shutdown ()
{
	//Or here
}

bool AVP_FMV::Platform_Play(const char* szFilename, int iAudioStream, bool bLoop)
{
	//Make the filename valid
	char szPath[MAX_PATH];
	Asura_PrintfToBfr(szPath,"FMV\\%s.bik",MAX_PATH,0,szFilename);

	u_int uAudioStreamIdx = (u_int)iAudioStream;//( bLocalised ? Asura_LocalisedText::GetCurrentLanguage() : 0 );
	Asura_PC_Bink::Play( szPath, 0.5f, Asura_FMVSubtitles::RenderSubtitleByTime, CheckForFMVSkip, uAudioStreamIdx );

	return true;
}

bool CheckForFMVSkip( void )
{
	// Escape should probably always skip.
	if( Asura_UserInput::DebouncedKeyPressed(ASURA_KEYID_ESCAPE) ) { return true; }
	if( Asura_UserInput::DebouncedKeyPressed(ASURA_KEYID_SPACE) ) { return true; }
	if( Asura_UserInput::DebouncedKeyPressed(ASURA_KEYID_MOUSEBUTTON1) ) { return true; }
	if( Asura_UserInput::DebouncedKeyPressed(ASURA_KEYID_ENTER) ) { return true; }

	return false;
}

//eof
