///////////////////////////////////////////////////////////////////////////////
//
// File      : AVP_Rumble_System.cpp
// Author    : Ali Jakamy
// Created   : 25/03/2009
//
// Copyright (C) 2009 Rebellion. All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////
#include "Core/Asura.h"

// This file's header
#include "Input/AVP_Rumble_System.h"

// Asura Headers
#include "Input/Asura_Rumble_System.h"

Asura_Hash_ID AVP_Rumble_System::GetPlatformBuleprint( Asura_Hash_ID uBlueprint )
{
	return Asura_ConcatenateHashID( uBlueprint, "PC" );	
}

bool AVP_Rumble_System::GetPlatformSupport2Motors( )
{
	return true;
}

void AVP_Rumble_System::PlatformSetupRumbleMotor( AVP_Rumble* pxRumble, AVP_Rumble_Motor eMotor, Asura_Handle iRumble)
{
	if( eMotor == AVP_RUMBLE_MOTOR1)
	{
		pxRumble->m_apxMotorRumbles[ASURA_PC_RUMBLE_MOTOR1] = Asura_Rumble::GetRumblePointer(iRumble);
	}
	else if( eMotor == AVP_RUMBLE_MOTOR2)
	{
		pxRumble->m_apxMotorRumbles[ASURA_PC_RUMBLE_MOTOR2] = Asura_Rumble::GetRumblePointer(iRumble);
	}
	else
	{
		Asura_Assert(false, "PC has only two motors, shouldn't get here!");
	}
}

void AVP_Rumble::PlatformSetup()
{
	m_apxMotorRumbles[ASURA_PC_RUMBLE_MOTOR1] = NULL;
	m_apxMotorRumbles[ASURA_PC_RUMBLE_MOTOR2] = NULL;
}