///////////////////////////////////////////////////////////////////////////////
//
// File: AVP_Platform_CloakEffect.h
//
// Created by Andrew Southgate 03/12/2007
// 
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
// Handles rendering of the predators cloak
//
///////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#if !defined __AVP_PLATFORM_CLOAKEFFECT_H__
#define __AVP_PLATFORM_CLOAKEFFECT_H__

class Asura_Animation;
class Asura_Hierarchy_Skin;

class AVP_CloakEffect;

class AVP_Platform_CloakEffect
{
public:
	static void Initialise();
	static void Shutdown();
	static void Reset();
	static void RenderSkin( const AVP_CloakEffect *pxCloakEffect, const Asura_Animation& xAnimation,
		const Asura_Hierarchy_Skin& xSkin,
		Asura_AMatrix4x4_InParam xTransform,
		Asura_AMatrix4x4_InParam xInverseTransform,
		const Asura_AMatrix4x4* const pxBoneTransforms );
private:
	static void	OnEffectLoaded(class Asura_Direct3D_Effect* pxEffect);
	static void	OnEffectUnloaded(class Asura_Direct3D_Effect* pxEffect);
	static void	CaptureEffect(void);
};

#endif // __AVP_PLATFORM_CLOAKEFFECT_H__
