
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Platform_Human_InputHandler.cpp
// Author : Chris Wallace
// Date   : 6-Feb-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Actor/Vertebrates/Human/AVP_Human_InputHandler.h"

// Asura independent header-files...
#include "Input/Asura_ControlMapping_Key.h"

// Asura platform header-files...
#include "Input/Asura_PlatformInput.h"

// Game independent header-files...

// Game platform header-files...

// Tools header-files...


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_Human_InputHandler::Platform_InitialiseControlMap
// Author       : Andy Tate
// Date         : 4-Oct-2006
////////////////////////////////////////////////////////////////////////////////

void AVP_Human_InputHandler::Platform_InitialiseControlMap (void)
{
	Asura_ControlMap& xFirst = GetMapFirstPerson();
	Asura_ControlMap& xCutscene = GetMapCutscene();

	// first person mappings
	MapVisionAndFlare(xFirst, ASURA_PS3_KEYID_PAD1_L1, ASURA_PS3_KEYID_PAD1_L1);
	MapLookAxes(	xFirst, ASURA_AXIS_PAD1_RSTICK_H, ASURA_AXIS_PAD1_RSTICK_V);
	MapMovementAxes(xFirst, ASURA_AXIS_PAD1_LSTICK_V, ASURA_AXIS_PAD1_LSTICK_H, ASURA_KEYID_VOID, ASURA_PS3_KEYID_PAD1_L3, ASURA_PS3_KEYID_PAD1_CIRCLE);
	MapZoom(		xFirst, ASURA_PS3_KEYID_PAD1_UP, ASURA_PS3_KEYID_PAD1_DOWN, ASURA_KEYID_VOID);
	MapJump(		xFirst, ASURA_PS3_KEYID_PAD1_CROSS);
	MapAttacks(		xFirst, ASURA_PS3_KEYID_PAD1_R2, ASURA_PS3_KEYID_PAD1_L2, ASURA_PS3_KEYID_PAD1_L2, ASURA_PS3_KEYID_PAD1_R2);
	MapInteractAndReloadToSameKey(	xFirst, ASURA_PS3_KEYID_PAD1_SQUARE);
	MapMenuToggle(	xFirst, ASURA_PS3_KEYID_PAD1_START);
	MapObjectivesAndSelectToggle(xFirst, ASURA_PS3_KEYID_PAD1_SELECT, ASURA_PS3_KEYID_PAD1_SELECT);
	MapTorch(		xFirst, ASURA_PS3_KEYID_PAD1_DOWN);
	MapHealth(		xFirst, ASURA_PS3_KEYID_PAD1_TRIANGLE);
	MapFocusKeys(	xFirst, ASURA_PS3_KEYID_PAD1_L2, ASURA_PS3_KEYID_PAD1_L2);
//	MapADS(			xFirst, ASURA_PS3_KEYID_PAD1_R3 );
	MapMelee(		xFirst, ASURA_PS3_KEYID_PAD1_R1, ASURA_PS3_KEYID_PAD1_R1, ASURA_PS3_KEYID_PAD1_CROSS);

	// weapon and vision mode select mappings
	MapWeaponSelect(xFirst, ASURA_PS3_KEYID_PAD1_UP, ASURA_KEYID_VOID, ASURA_PS3_KEYID_PAD1_LEFT, ASURA_PS3_KEYID_PAD1_RIGHT);

	MapCutscene(	xCutscene, ASURA_PS3_KEYID_PAD1_CROSS);
	MapMenuToggle(	xCutscene, ASURA_PS3_KEYID_PAD1_START);
	MapObjectivesAndSelectToggle(xCutscene, ASURA_PS3_KEYID_PAD1_SELECT, ASURA_PS3_KEYID_PAD1_SELECT);
}

/// End of function 'AVP_Human_InputHandler::Platform_InitialiseControlMap'. ///



////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////


/// End of file. ///
