
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Platform_Core.cpp
// Author : Andy Tate
// Date   : 4-Oct-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Core/AVP_Core.h"

// Asura independent header-files...
#include "Input/Asura_PlatformInput.h"
#if defined(ASURA_SUPPORT_COMMAND_CONSOLE)
#include "Interface/Asura_CommandConsole.h"
#endif	// defined(ASURA_SUPPORT_COMMAND_CONSOLE)

// Asura platform header-files...
#include "Rendering/Asura_PS3_VideoMemoryManager.h"
#include "Rendering/Asura_PS3_Graphics.h"
#include "Rendering/Asura_PS3_DeferredRendering.h"

// Game independent header-files...

// Game platform header-files...

// Tools header-files...


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_Core::Platform_Initialise
// Author       : Andy Tate
// Date         : 4-Oct-2006
////////////////////////////////////////////////////////////////////////////////

void AVP_Core::Platform_Initialise (void)
{
//	extern int g_iFudgedShader;
//	extern int g_iFudgedSRGB;


	Asura_CommandConsole::AddVar( L"AVP.HUD.PS3.RenderToFrontBuffer", &AVP_Core::g_bRenderHUDToFrontBuffer, Asura_CommandConsole::REMOVE_AT_SHUTDOWN );
//	Asura_CommandConsole::AddVar( L"AVP.HUD.PS3.ForceFudgedShader", &g_iFudgedShader, 0, 2, Asura_CommandConsole::REMOVE_AT_SHUTDOWN );
//	Asura_CommandConsole::AddVar( L"AVP.HUD.PS3.ForceFudgedSRGB", &g_iFudgedSRGB, 0, 2, Asura_CommandConsole::REMOVE_AT_SHUTDOWN );
}

/// End of function 'AVP_Core::Platform_Initialise'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_Core::Platform_Shutdown
// Author       : Andy Tate
// Date         : 4-Oct-2006
////////////////////////////////////////////////////////////////////////////////

void AVP_Core::Platform_Shutdown (void)
{
}

/// End of function 'AVP_Core::Platform_Shutdown'. ///


////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_Core::Platform_Update
// Author       : Neil Young
// Date         : 7-May-2009
////////////////////////////////////////////////////////////////////////////////

void AVP_Core::Platform_Update()
{
}

/// End of function 'AVP_Core::Platform_Update'. ///

#ifdef AVP_LOG_FILE_LOAD_MEMORY_USE
u_int AVP_Core::Platform_GetAvailableMemory()
{
	u_int uFreeMem = Asura_PS3_VideoMemoryManager::GetFreeMain() + Asura_PS3_VideoMemoryManager::GetFreeLocal();

	return uFreeMem;
}
#endif //#ifdef AVP_LOG_FILE_LOAD_MEMORY_USE


void AVP_Core::Platform_BeginHUDRender()
{
	if (g_bRenderHUDToFrontBuffer)
	{
		// On PS3 we switch over to the front buffer which is at output res
		// rather than the backbuffer which is lower for speed
		// this means our 2D HUD elements are high res and crisp
		Asura_PS3_DeferredRendering::SwitchToFrontBuffer();
	}
}


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////


/// End of file. ///
