//
// Asura_EngineConfiguration.h
//
// Created by KJFL - Wednesday, February 04, 2004
//
//	Vanilla PS3 version.
// 
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_ENGINECONFIGURATION_H__
#define __ASURA_ENGINECONFIGURATION_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura_PlatformBasics.h"
#include "ProjectSettings/AVP_ProjectConfiguration.h"
#include "Shaders/Project_ShaderConfiguration.fxh"

#define ASURA_USE_SKYSPHERE										1

#ifdef AVP_SUBMISSION

	#define ASURA_PS3_SONY_SUBMISSION							1
	#define ASURA_PS3_PRESENT_INTERVAL							1

#else //#ifdef AVP_SUBMISSION

	#define ASURA_PS3_PRESENT_INTERVAL							0
	#define ASURA_PS3_ALLOW_STATS								1
  	#define ASURA_PS3_USE_GPU_PROFILE_BARS						1
  	#define ASURA_PS3_USE_COMMAND_BUFFER_INSPECTOR				1
	#define ASURA_PS3_ALLOW_SHADER_RELOAD						1

#endif //#ifdef AVP_SUBMISSION

#define ASURA_USE_VIDEO_TO_TEXTURE_SYSTEM						1
#define ASURA_PS3_INTERNAL_SCREEN_HEIGHT						630		// Default to 630p (1120 x 630 internally)
#define ASURA_PS3_MAIN_VIDEO_SCRATCH_MEMORY_SIZE				((2 * 1024 * 1024) + (2* 1024 * 1024))

#define ASURA_PLATFORM_MENU_MAX_SUPPORTED_CONTROLLERS			4
#define ASURA_LOCALISEDTEXT_PAGE_STORAGE_SIZE					11

#define ASURA_BOTANICAL_SUPPORT_INTERACTIVE						1
#define ASURA_BOTANICAL_SUPPORT_STATES							1
#define ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS				1

#define ASURA_SUPPORT_MULTITHREADED_JOB_QUEUE					1
#define ASURA_PFX_TEMPLATES_SUPPORT_DATABLOCK					1

//#define ASURA_PS3_USE_BALANCED_MEMORY_USAGE						1
#define ASURA_USE_ZPREPASS										1

#define ASURA_USE_ANIMATION_PLATFORM_RENDER_CACHE				1
//#define ASURA_PLATFORM_USE_FILE_SYSTEM_CACHE					1
#define ASURA_PS3_PROJECT_FILEDIR								"L:\\AVP\\PS3_Release"

#define ASURA_EDGE_ANTIALIASING									1

#define ASURA_PS3_INITIAL_VRAM_ALLOC_RECORDS					20000

//#define ASURA_USE_AMBIENT_OCCLUSION							1

#define ASURA_SUPPORT_LEADERBOARDS								1
#define ASURA_USE_MERIT_SYSTEM									1

#define ASURA_PS3_SAVEGAMES										1
#define ASURA_SUPPORT_DOWNLOADABLE_CONTENT						1

#define ASURA_PS3_MAX_SPU_SKINNING_TASKS						128

#define ASURA_USE_REWARDS										1

#define ASURA_TEXTURE_STREAMING_MEMORY_ALLOWED_MB				20

#define ASURA_ENABLE_QOS_SYSTEM									1
//#define ASURA_QOS_ENABLE_LOGGING								1

#define ASURA_SPURS_ENABLED										1
#ifdef ASURA_SPURS_ENABLED
	
	#define	SPURS_VIDEO
	#define	SPURS_PFX
	#define	SPURS_SKINNING
	#define SPURS_PHYSICS

#endif

// AVP defines
#define AVP_RENDER_SKYBOX_AFTER_SCENE							1
#define AVP_EXPORTED_LEVEL_FILE_EXTENSION						".ps3"
#define AVP_GENERATE_FULL_LEVEL_FILENAME(f)						"Envs\\" f ".ps3"

#define AVP_MAX_FRAME_RATE										60.0f
#define AVP_MAX_INGAME_FRAME_RATE								30.0f

#define AVP_PHEROMONES_ENABLED									1

#endif//__ASURA_ENGINECONFIGURATION_H__
