//
// FSFX_Laser_FP.h
//
// Created by Catalin Arsenescu - 11 October 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_LASER_FSFX_FP_H__
#define __ASURA_PS3_LASER_FSFX_FP_H__

extern uint32_t _binary_PS3_FSFX_Laser_FP_bin_start;
extern uint32_t _binary_PS3_FSFX_Laser_FP_bin_end;

enum FRAGMENT_FSFX_SHADER_UNIFORM
{
	FP_FSFX_Colour,
	FP_FSFX_ScreenHeight,
	FP_FSFX_ELEMENTS
};

enum TEXTURE_FSFX_UNITS
{
	FP_FSFX_SceneTextureSampler,
	FP_FSFX_TU_ELEMENTS
};

class Asura_PS3_Laser_FSFX_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_Laser_FSFX_Handles() : Asura_PS3_FP_Handles( FP_FSFX_ELEMENTS, FP_FSFX_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitUniformElement( FP_FSFX_Colour,		"g_xColour",		1 );
		pxShader->InitUniformElement( FP_FSFX_ScreenHeight,	"g_fScreenHeight",	1 );

		pxShader->InitTextureUnit( FP_FSFX_SceneTextureSampler,	"g_xSceneTextureSampler",	CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_LINEAR, CELL_GCM_TEXTURE_LINEAR );
	}
};

#endif //#ifndef __ASURA_PS3_LASER_FSFX_FP_H__
