///////////////////////////////////////////////////////////////////////////////
//
// File   : PheromoneTrail_FP.h
// Author : Andy Southgate
// Date   : 16-Jan-2009
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////


#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __PHEROMONETRAIL_FP_H__
#define __PHEROMONETRAIL_FP_H__


extern uint32_t _binary_PS3_PheromoneTrail_FP_bin_start;
extern uint32_t _binary_PS3_PheromoneTrail_FP_bin_end;

enum FRAGMENT_SHADER_UNIFORM
{
	FP_NoisePower,
	FP_CameraPosition,
	FP_DepthAdjustment,
	FP_ELEMENTS
};

enum TEXTURE_UNITS
{
	FP_NoiseTexture,
	FP_DepthTexture,
	FP_TU_ELEMENTS
};

class Asura_PS3_PheromoneTrail_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_PheromoneTrail_Handles() : Asura_PS3_FP_Handles( FP_ELEMENTS, FP_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitUniformElement( FP_NoisePower,		"g_xNoisePower",		1 );
		pxShader->InitUniformElement( FP_CameraPosition,	"g_xCameraPosition",	1 );
		pxShader->InitUniformElement( FP_DepthAdjustment,	"g_xDepthAdjustment",	1 );

		pxShader->InitTextureUnit( FP_NoiseTexture,		"g_xNoiseTextureSampler", CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_LINEAR_LINEAR, CELL_GCM_TEXTURE_LINEAR );
		pxShader->InitTextureUnit( FP_DepthTexture,		"g_xDepthTextureSampler", CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_NEAREST, CELL_GCM_TEXTURE_NEAREST );
	}
};

#endif // !defined(__PHEROMONETRAIL_FP_H__)

/// End of file. ///
