//
// CloakEffect_VP.h
//
// Created by Catalin Arsenescu - 11 October 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_CLOAKEFFECT_VP_H__
#define __ASURA_PS3_CLOAKEFFECT_VP_H__

extern uint32_t _binary_PS3_CloakEffect_VP_bin_start;
extern uint32_t _binary_PS3_CloakEffect_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axVertexShaderUniform[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xWorldViewProjectionMatrix",	1, 4, NULL },
	{ "g_xWorldViewMatrix",				1, 4, NULL },
	{ "g_xObjectSpaceCameraPosition",	1, 1, NULL },
	{ "g_axTransforms",				  450, 1, NULL },
	{ "g_xCloakFadeOut",				1, 1, NULL },
};
static Asura_PS3_GCM_VertexShaderUniformParameter g_axVertexShaderUniformCloakEffectStraightThrough[] =
{
	// COPY FROM ABOVE, we index it with the same enum
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xWorldViewProjectionMatrix",	1, 4, NULL },
	{ "g_xWorldViewMatrix",				1, 4, NULL },
	{ "g_xObjectSpaceCameraPosition",	1, 1, NULL },
	{ "g_axTransforms",				  450, 1, NULL },
	{ "g_xCloakFadeOut",				1, 1, NULL },
};

enum VERTEX_SHADER_UNIFORM
{
	SK_WorldViewProj,
	SK_WorldView,
	SK_ObjCamPos,
	SK_BoneTransforms,
	SK_CloakFadeOut
};

class AVP_PS3_VP_CloakEffect : public Asura_PS3_GCM_VertexShader
{
public:
	AVP_PS3_VP_CloakEffect() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_CloakEffect_VP_bin_start, (unsigned char *)&_binary_PS3_CloakEffect_VP_bin_end, g_axVertexShaderUniform, sizeof ( g_axVertexShaderUniform ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~AVP_PS3_VP_CloakEffect()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axVertexShaderUniform ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axVertexShaderUniform[ i ].CleanUp();
		}
	}
};


extern uint32_t _binary_PS3_CloakEffect_StraightThrough_VP_bin_start;
extern uint32_t _binary_PS3_CloakEffect_StraightThrough_VP_bin_end;

class AVP_PS3_VP_CloakEffect_StraightThrough : public Asura_PS3_GCM_VertexShader
{
public:
	AVP_PS3_VP_CloakEffect_StraightThrough() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_CloakEffect_StraightThrough_VP_bin_start, (unsigned char *)&_binary_PS3_CloakEffect_StraightThrough_VP_bin_end,
		g_axVertexShaderUniformCloakEffectStraightThrough, sizeof(g_axVertexShaderUniformCloakEffectStraightThrough)/sizeof(Asura_PS3_GCM_VertexShaderUniformParameter) )
	{
	}

	~AVP_PS3_VP_CloakEffect_StraightThrough()
	{
	}
};


#endif //#ifndef __ASURA_PS3_CLOAKEFFECT_VP_H__
