///////////////////////////////////////////////////////////////////////////////
//
// File: AVP_Platform_CloakEffect.h
//
// Created by Andrew Southgate 03/12/2007
// 
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
// Handles rendering of the predators cloak
//
///////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#if !defined __AVP_PLATFORM_CLOAKEFFECT_H__
#define __AVP_PLATFORM_CLOAKEFFECT_H__

class AVP_CloakEffect;
class Asura_PS3_CharacterRenderer_Skin;
class Asura_Platform_Animation_RenderCache;
class Asura_PS3_GCM_IndexBuffer;

class AVP_Platform_CloakEffect
{
public:
	static void Initialise();
	static void Shutdown();
	static void Reset();
	static void RenderCloakedSkin(	const AVP_CloakEffect *pxCloakEffect,
									const class Asura_Animation& xAnimation,
									const class Asura_Hierarchy_Skin& xSkin,
									Asura_AMatrix4x4_InParam xTransform,
									Asura_AMatrix4x4_InParam xInverseTransform,
									const Asura_AMatrix4x4* const pxBoneTransforms,
									u_int uSkinIdx);
	static void RenderHoles(const AVP_CloakEffect *pxCloakEffect,
							const class Asura_Animation& xAnimation,
							const class Asura_Hierarchy_Skin& xSkin,
							Asura_AMatrix4x4_InParam xTransform,
							Asura_AMatrix4x4_InParam xInverseTransform,
							const Asura_AMatrix4x4* const pxBoneTransforms,
							u_int uSkinIdx );

#if defined(ASURA_PS3_ALLOW_SHADER_RELOAD)
	static bool ReloadShaders( bool bHelp );
#endif

private:
	static Asura_PS3_GCM_IndexBuffer* SetupSkinning(	Asura_PS3_CharacterRenderer_Skin* pxCharacterStrips,
														const Asura_Animation& xAnimation,
														Asura_AMatrix4x4_InParam xTransform,
														Asura_AMatrix4x4_InParam xInverseTransform,
														const Asura_AMatrix4x4* const pxBoneTransforms,
														u_int uNumBones,
														u_int uSkinIdx,
														float fTransition,
														float fMaxVisibilityAngle,
														float fMaxVisibilityDistance );

	static int s_iNoiseTexture;
};

#endif // __AVP_PLATFORM_CLOAKEFFECT_H__
