/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

#include "..\..\..\..\..\Asura\Xbox360\Shaders\Shared.fxh"

/******************************************************************************/
/* Parameters                                                                 */
/******************************************************************************/

const sampler2D g_xInitialImage = sampler_state
{
	AddressU = CLAMP;
	AddressV = CLAMP;
};

const sampler2D g_xDisplacementMap = sampler_state
{
	AddressU = CLAMP;
	AddressV = CLAMP;
};

const float g_fIntensity;

/******************************************************************************/
/* Constants                                                                  */
/******************************************************************************/



/******************************************************************************/
/* Types                                                                      */
/******************************************************************************/

struct Vertex
{
	float4 m_xPosition : POSITION;
	float2 m_xUV       : TEXCOORD;
};

/******************************************************************************/
/* Functions                                                                  */
/******************************************************************************/

Vertex VShader( const Vertex xIn )
{
	return xIn;
}

float4 PShader( const Vertex xIn, float2 xScreenPos : VPOS) : COLOR
{
	const half2 xDisplacement = TexFetch2D_LinearLinearNone( g_xDisplacementMap, xIn.m_xUV ).rg * 2.0f - 1.0f;

	return TexFetch2D_LinearLinearLinear( g_xInitialImage, xIn.m_xUV + xDisplacement * g_fIntensity);

}
 
/******************************************************************************/
/* Techniques                                                                 */
/******************************************************************************/

technique
{
	pass
	{
		VertexShader = compile vs_3_0 VShader();
		PixelShader = compile ps_3_0 PShader();
	}
}