///////////////////////////////////////////////////////////////////////////////
//
// File: AVP_Platform_Laser.h
//
// Created by Andrew Southgate 12/11/2007
// 
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
// Handles rendering of the predators tri-laser thingy
//
///////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#if !defined __AVP_PLATFORM_LASER_H__
#define __AVP_PLATFORM_LASER_H__

#include "Rendering/Asura_Xbox360_Graphics.h"
#include "Rendering/Asura_Xbox360_VertexBuffer.h"
#include "Rendering/Asura_Xbox360_IndexBuffer.h"


class AVP_Platform_Laser_System
{
public:
	static void Initialise();
	static void Shutdown();
	static void Reset();
	static void RenderStart();
	static void SetupLaserParams(AVP_Laser *pxLaser);
	static void RenderLaser(AVP_Laser *pxLaser, const Asura_Vector_3 &xPosition, const Asura_Vector_3 &xRight, const Asura_Vector_3 &xDown, const Asura_Vector_3 &xForward, float fLength);
	static void RenderEnd();

	static void	CaptureEffect(void);
private:
	static Direct3D_VertexDeclaration*			s_pxLaserVertexDecl;
	static Asura_Xbox360_Effect*				s_pxLaserEffect;


	static Asura_Xbox360_Effect_System::Handle s_xColourHandle;
	static Asura_Xbox360_Effect_System::Handle s_xParamsHandle;
	static Asura_Xbox360_Effect_System::Handle s_xBeamFadeOffHandle;

	static Asura_Xbox360_Effect_System::Handle s_xTimeHandle;

	static Asura_Xbox360_Effect_System::Handle s_xNoiseTexHandle;
	static Asura_Xbox360_Effect_System::Handle s_xSceneTextureHandle;
	static Asura_Xbox360_Effect_System::Handle s_xDepthTextureHandle;

	static int								   s_iNoiseTexture;

};

#endif // __AVP_PLATFORM_LASER_H__