//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Cutscene_Object.cpp
//
// Created by Ali Jakamy 25/06/2008
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header.
#include "ToolsAVP_Cutscene_Object.h"

// AVP
#include "Cutscene/AVP_Cutscene_Event.h"

// Tools 
#include "Misc/Tools_Modal_Overlay.h"

// AVP Tools
#include "Cutscene/ToolsAVP_Cutscene_Event_CloakActor.h"
#include "Cutscene/ToolsAVP_Cutscene_Event_SetVisionMode.h"


void ToolsAVP_Cutscene_Object::AddEventsToSelectionOverlay(ListSelection_Overlay& xOverlay)
{
	PARENT::AddEventsToSelectionOverlay(xOverlay);

	xOverlay.AddItem("Set Vision Mode", AVP_CET_SetVisionMode);
	xOverlay.AddItem("Cloak Actor", AVP_CET_CloakActor);

}

Tools_Cutscene_Event* ToolsAVP_Cutscene_Object::AllocateToolsEvent(Asura_Cutscene_Event* pxEvent, int iEventID)
{
	switch(pxEvent->m_iType)
	{
		case AVP_CET_SetVisionMode :
			 return new ToolsAVP_Cutscene_Event_SetVisionMode(pxEvent, this, iEventID);

	 	case AVP_CET_CloakActor :
			 return new ToolsAVP_Cutscene_Event_CloakActor(pxEvent, this, iEventID);

		default :
			 return PARENT::AllocateToolsEvent(pxEvent, iEventID);
	}
}