//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_Squad.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLSAVP_ENTITY_SQUAD_H__
#define __TOOLSAVP_ENTITY_SQUAD_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Entity/Tools_Entity_Object.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_ServerEntity_Squad;

//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_Squad
//
//////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Entity_Squad : public Tools_Entity_Object
{
	typedef Tools_Entity_Object PARENT;

public:
	ToolsAVP_Entity_Squad( Asura_Entity* pxEntity );
	virtual ~ToolsAVP_Entity_Squad();

	virtual bool CanBeCopied() const { return true; }
	virtual bool HandlesThisMessage( int iMessageID );
	virtual bool HandlesThisEvent( int iEventID ) const;

	static ToolsAVP_Entity_Squad* FindEntity( Asura_Guid uGuid ) { return s_xList.FindEntity( uGuid ); }
	static Asura_Hashed_List< ToolsAVP_Entity_Squad >* GetList() { return &s_xList; }

private:
	AVP_ServerEntity_Squad* GetSquad() const;

	static Asura_Hashed_List< ToolsAVP_Entity_Squad > s_xList;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__TOOLSAVP_ENTITY_SQUAD_H__
