//
// ToolsAVP_Entity_GameMode.h
//
// Created by JG - 04 July 2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLSAVP_ENTITY_GAMEMODE_H__
#define __TOOLSAVP_ENTITY_GAMEMODE_H__

#include "Entity/Tools_Entity_Object.h"

// Forward declarations
class AVP_ServerEntity_GameMode;

////////////////////////////////////////////////////////////
//  Class declaration
////////////////////////////////////////////////////////////
class ToolsAVP_Entity_GameMode: public Tools_Entity_Object
{
public:
	// Constructor / destructor
	ToolsAVP_Entity_GameMode( Asura_Entity* pxEntity ); 
	virtual ~ToolsAVP_Entity_GameMode( void ); 

	// Don't offer any option for this to become active / inactive, it will be controlled by code
	virtual bool DealsInternallyWithActivate() const	{ return true; }
	
	// Handle activation / deactivation messages
	virtual bool HandlesThisEvent(int iEventID) const;

	// Public static functions
	static void				Project_Create( void );
	static Tools_Object*	CreateAndReturn( void );
	static Tools_Object*	Create( Asura_Entity* pxEntity );

	// Public funtions
	virtual bool			CanBeCopied() const { return false; }
	virtual Tools_Object*	CreateObjectOfThisType() const;

	virtual const char*		GetTypeDescription() { return "Game Mode"; }
	virtual void			AddOverlayControls( Asura_Overlay* pxOverlay, Asura_Vector_2& xOffset ); 
	virtual void			UpdateWhileSelected( void ); 

private:
	int									m_iGameMode;
	bool								m_bGameModeChanged; 
	typedef	Tools_Entity_Object			PARENT;
};


#endif//__TOOLSAVP_ENTITY_GAMEMODE_H__