//-----------------------------------------------------------------------------
// File			: ToolsAVP_Node_FormationPoint.h
// Author		: Gareth Thomas
// Created		: 18 / 12 / 2007
// Copyright (c) 2007 Rebellion. All rights reserved.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Begin File Wrapper
#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif
#ifndef __TOOLSAVP_NODE_FORMATIONPOINT_H___
#define __TOOLSAVP_NODE_FORMATIONPOINT_H___ 1
// End File Wrapper
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include "Entity/Locations/Tools_Entity_Node.h"

//-----------------------------------------------------------------------------
// Class		: ToolsAVP_Node_FormationPoint
// Author		: Gareth Thomas
// Created		: 18 / 12 / 2007
// Description	: Class to be used as a formation marker for marines and any 
// other entity types that need.
//-----------------------------------------------------------------------------
class ToolsAVP_Node_FormationPoint : public Tools_Entity_Node
{

public:

	// Public Construction / Deconstruction functions...
	ToolsAVP_Node_FormationPoint							(Asura_Entity* pxEntity);
	virtual ~ToolsAVP_Node_FormationPoint					(void);

	// Public Static functions...
	static void				Create						(void);
	static Tools_Object*	Create						(Asura_Entity* pxEntity);
	static Tools_Object*	CreateAndReturn				(void);
	static void				Project_Create				(void);

	// Public Overridden Virtual Functions...
	virtual bool			IsBaseOrDerivativeOf( int iToolsObjectType ) const;
	virtual bool			CanBeCopied					(void) const						{return true;}
	virtual Tools_Object*	CreateObjectOfThisType		(void) const;
	virtual const char*		GetTypeDescription			(void)								{return ("FormationPoint");}
	virtual void			OnSelection					(void);
	virtual void			OnDeselection				(void);

	static const Asura_Hashed_List<ToolsAVP_Node_FormationPoint>* GetList(void)					{return &s_xList;}

private:

	typedef Tools_Entity_Node PARENT;

	static Asura_Hashed_List<ToolsAVP_Node_FormationPoint>		s_xList;
	static ToolsAVP_Node_FormationPoint*						s_pxSelectedFormationPointNode;
};

#endif // __TOOLSAVP_NODE_FORMATIONPOINT_H___