//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Node_GS2Attractor.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLSAVP_NODE_GS2ATTRACTOR_H__
#define __TOOLSAVP_NODE_GS2ATTRACTOR_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// tools
#include "Entity/Locations/OrientedNode/GamesceneNode/ToolsAVP_Node_GS2Node.h"
#include "Entity/Locations/OrientedNode/GamesceneNode/AtttactorNode/Tools_EntityNode_GS2Attractor.h"
#include "Objects/ToolsAVP_Object_Type.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_ServerNode_GS2Node;

//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Node_GS2Attractor
//
//////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Node_GS2Attractor : public ToolsAVP_Node_GS2Node, public Tools_EntityNode_GS2Attractor
{
	typedef ToolsAVP_Node_GS2Node		  PARENT_AVPTOOLS;
	typedef Tools_EntityNode_GS2Attractor PARENT_TOOLS;

public:
	ToolsAVP_Node_GS2Attractor( Asura_Entity* pxEntity );

	virtual const char* GetTypeDescription() { return "AVP GS2 Attractor"; }
	virtual bool IsBaseOrDerivativeOf( int iToolsObjectType ) const;

	virtual void		  Render();
	virtual bool          CanBeCopied() const { return ( Type == TOT_Entity_AVPGS2Attractor ); }
	virtual void          Copy( const Tools_Object* pxObject );
	virtual Tools_Object* CreateObjectOfThisType() const;
	virtual bool GetParameter( Asura_Hash_ID uParamID, Tools_Parameter* pxParam ) const;
	virtual bool SetParameter( Asura_Hash_ID uParamID, const Tools_Parameter* pxParam );
	virtual bool HandlesThisMessage( int iMessageID );
	static void						   Create();
	static ToolsAVP_Node_GS2Attractor* Create( Asura_Entity* pxEntity );
	static ToolsAVP_Node_GS2Attractor* CreateAndReturn();

protected:
	virtual void AddPropertiesTabControls( Asura_Tabs_Dialog* pxTabsDialogue, Asura_Vector_2& xOffset );
	virtual void AddUnderTabsControls( Asura_Overlay* pxNewOverlay, Asura_Vector_2& xOffset );

	AVP_ServerNode_GS2Node* GetAVPGameNode() const;

private:
	static void CreateLinkedNode();
	static bool CanCreateLinkedNode();
	static void CreateLink();
	static bool CanCreateLink();
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__TOOLSAVP_NODE_GS2ATTRACTOR_H__
