//////////////////////////////////////////////////////////////////////////////
// 
// FILE : ToolsAVP_Entity_Alien.h
//
// AUTHOR : Martin G. Harris - Modified By Chris Wallace
//
// Copyright 2002 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLSAVP_ENTITY_ALIEN_H_
#define _TOOLSAVP_ENTITY_ALIEN_H_

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/Actor/ToolsAVP_Entity_Actor.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_ServerActor_Alien;

//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_Alien
//
//////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Entity_Alien : public ToolsAVP_Entity_Actor
{
public:
	static Tools_Object* Create( const bool bFullInit );
	static Tools_Object* Create( Asura_Entity* pxEntity );
	static void Project_Create();
	virtual Tools_Object* CreateObjectOfThisType( void ) const { return Create( false ); }

	virtual void AddOverlayControls( Asura_Overlay* pxNewOverlay, Asura_Vector_2& xOffset );

	virtual void OnSelection();
	virtual void OnDeselection();
	virtual Asura_Hash_ID GetDefaultBlueprintHashID() const { return 0xc97f0d2f; } // Asura_GetHashID( "AlienAI" )
	virtual const char* GetTypeDescription() { return "Alien"; }
	virtual void AddFilesToExportList(List<Asura_String>& nameList) const;

protected:
	ToolsAVP_Entity_Alien(AVP_ServerActor_Alien* pxActor);
	virtual void          RestoreMesh(); 

private:
	AVP_ServerActor_Alien* GetAlien() const;

	static void SetSquad();
	static void ClearSquad();
	static void SetThisSquad( Asura_Guid uSquadGuid );

private:
	static ToolsAVP_Entity_Alien* s_pxThisToolsAlien;

    typedef ToolsAVP_Entity_Actor PARENT;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //_TOOLSAVP_ENTITY_ALIEN_H_
