//////////////////////////////////////////////////////////////////////////////
// 
// FILE : ToolsAVP_Entity_FaceHugger.h
//
// AUTHOR : Martin G. Harris - Modified By Chris Wallace
//
// Copyright 2002 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLSAVP_ENTITY_FACEHUGGER_H_
#define _TOOLSAVP_ENTITY_FACEHUGGER_H_

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/Actor/ToolsAVP_Entity_Actor.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_ServerActor_FaceHugger;

//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_FaceHugger
//
//////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Entity_FaceHugger : public ToolsAVP_Entity_Actor
{
public:
	static Tools_Object* Create( const bool bFullInit );
    static Tools_Object* Create( Asura_Entity* pxEntity );
	static void Project_Create();
	virtual Tools_Object* CreateObjectOfThisType() const { return Create( false ); }

	virtual void AddOverlayControls( Asura_Overlay* pxNewOverlay, Asura_Vector_2& xOffset );

	virtual void OnSelection();
	virtual void OnDeselection();

	static void SetSquad();
	static void ClearSquad();
	static void SetThisSquad( Asura_Guid uSquadGuid );

protected:
	ToolsAVP_Entity_FaceHugger(AVP_ServerActor_FaceHugger* pxActor);

	virtual bool HandlesThisMessage( int iMessageID );

	virtual const char* GetTypeDescription() { return "FaceHugger"; }
	virtual void AddFilesToExportList(List<Asura_String>& nameList) const;

    virtual Asura_Hash_ID GetDefaultBlueprintHashID() const { return 0x4633fcb7; } // Asura_GetHashID( "Facehugger" )
	virtual void          RestoreMesh(); 
	
private:
	void Validate();

    typedef ToolsAVP_Entity_Actor PARENT;

	AVP_ServerActor_FaceHugger* m_pxFaceHugger; // cached pointer to entity

	static ToolsAVP_Entity_FaceHugger* s_pxThisTool;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //_TOOLSAVP_ENTITY_FACEHUGGER_H_
