//-----------------------------------------------------------------------------
// File		: ToolsAVP_Entity_Human.h
// Author	: Gareth Thomas
// Created	: 18 / 12 / 07
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Begin File Wrapper
#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif
#ifndef _TOOLSAVP_ENTITY_ANDROID_H_
#define _TOOLSAVP_ENTITY_ANDROID_H_
// End File Wrapper
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include "Entity/PhysicalObject/Actor/Vertebrates/Human/ToolsAVP_Entity_Human.h"
//#include "Objects/Tools_Object_System.h"
//#include "Tools_Mode.h"

//-----------------------------------------------------------------------------
// Forward Declarations
//-----------------------------------------------------------------------------

class AVP_ServerActor_Android;

//-----------------------------------------------------------------------------
// Class : ToolsAVP_Entity_Android
//-----------------------------------------------------------------------------
class ToolsAVP_Entity_Android : public ToolsAVP_Entity_Human
{
	typedef ToolsAVP_Entity_Human PARENT;

public:
	static Tools_Object*				Create( const bool bFullInit );
	static Tools_Object*				Create(Asura_Entity* pxEntity);
	static void							Project_Create();
	static ToolsAVP_Entity_Android*		FindEntity(Asura_Guid uGuid)			{return s_xList.FindEntity(uGuid);}

	virtual Tools_Object*				CreateObjectOfThisType() const { return Create( false ); }
	virtual void						OnSelection(void);
	virtual void						OnDeselection(void);
	virtual void						AddOverlayControls(Asura_Overlay* pxOverlay, Asura_Vector_2& xOffset);
	virtual bool						HandlesThisMessage( int iMessageID );
	virtual bool						HandlesThisEvent( int iEventID ) const;

protected:
	
	ToolsAVP_Entity_Android(AVP_ServerActor_Android* pxActor);
	virtual ~ToolsAVP_Entity_Android(void);

	virtual const char*					GetTypeDescription(void)				{return "Android";}
	virtual Asura_Hash_ID				GetDefaultBlueprintHashID(void) const	{return 0x05f0612d;} // Asura_GetHashID( "Human" ) // human for now as we have no android specific settings.
	virtual void						RestoreMesh(); 

	static void SelectSquad(void);

private:
	
	AVP_ServerActor_Android*							m_pxAndroid;
	static ToolsAVP_Entity_Android*						s_pxSelectedAndroid; 

	static Asura_Hashed_List<ToolsAVP_Entity_Android>	s_xList;
};

#endif //_TOOLSAVP_ENTITY_ANDROID_H_
