//////////////////////////////////////////////////////////////////////////////////////
// 
// FILE : ToolsAVP_Entity_Predalien.h
//
// AUTHOR : Martin G. Harris - Modified By Chris Wallace
//
// Copyright 2002 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLSAVP_ENTITY_PREDALIEN_H_
#define _TOOLSAVP_ENTITY_PREDALIEN_H_

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/Actor/ToolsAVP_Entity_Actor.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_ServerActor_Predalien;

//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_Predalien
//
//////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Entity_Predalien : public ToolsAVP_Entity_Actor
{
public:
	static Tools_Object* Create( const bool bFullInit );
    static Tools_Object* Create( Asura_Entity* pxEntity );
	static void Project_Create();
	virtual Tools_Object* CreateObjectOfThisType() const { return Create( false ); }

	virtual bool GetParameter( Asura_Hash_ID uParamID, Tools_Parameter* pxParam ) const;
	virtual bool SetParameter( Asura_Hash_ID uParamID, const Tools_Parameter* pxParam );
	virtual void UpdateWhileSelected();

protected:
	ToolsAVP_Entity_Predalien(AVP_ServerActor_Predalien* pxActor);

    virtual const char* GetTypeDescription() { return "Predalien"; }

	virtual void AddOverlayControls( Asura_Overlay* pxNewOverlay, Asura_Vector_2& xOffset );
	virtual void AddFilesToExportList(List<Asura_String>& nameList) const;

    virtual Asura_Hash_ID GetDefaultBlueprintHashID() const { return 0xaf3a2146; } // Asura_GetHashID( "Predalien" )
	virtual void RestoreMesh(); 

private:

	void RequestRefreshOverlay() { m_bRefreshOverlay = true; }

    typedef ToolsAVP_Entity_Actor PARENT;

	AVP_ServerActor_Predalien*	m_pxPredalien; // cached pointer to entity
	bool m_bRefreshOverlay;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //_TOOLSAVP_ENTITY_PREDALIEN_H_

