//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_InteractInvisiSwitch.h
//
// Created by CAH 26/2/09
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLSAVP_ENTITY_INTERACTSENTRYGUNINVISISWITCH__
#define __TOOLSAVP_ENTITY_INTERACTSENTRYGUNINVISISWITCH__

//////////////////////////////////////////////////////////////////////////////
// INCLUDES

#include "Entity/PhysicalObject/Interact/ToolsAVP_Entity_InteractObject.h"

//////////////////////////////////////////////////////////////////////////////
// FORWARD DECLARATIONS

class AVP_ServerEntity_InteractInvisiSwitch;

////////////////////////////////////////////////////////////////////////////////
// Class        : ToolsAVP_Entity_InteractInvisiSwitch
// Author       : Callum Hope CAH
// Date         : 26/02/09
////////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Entity_InteractInvisiSwitch : public ToolsAVP_Entity_InteractObject
{
public:
	static void												Create();
	static Tools_Object*									Create(Asura_Entity* pxEntity);
	static ToolsAVP_Entity_InteractInvisiSwitch*	FindEntity(Asura_Guid uGuid) { return s_xList.FindEntity(uGuid); }

	virtual bool CanBeCopied() const { return ( Type == TOT_Entity_InteractInvisiSwitch ); }
	virtual Tools_Object* CreateObjectOfThisType() const;

	virtual const char* GetTypeDescription() {return "Switch that allows different events depending on the species that interacts";}

	virtual	void Destroy();
	virtual bool HandlesThisEvent( int iEventID ) const;
	virtual bool HandlesThisMessage( int iMessageID );
	virtual void OnSelection();
	virtual void OnDeselection();

protected:
	ToolsAVP_Entity_InteractInvisiSwitch( AVP_ServerEntity_InteractInvisiSwitch* pxInteractObject );
	virtual ~ToolsAVP_Entity_InteractInvisiSwitch();

	Asura_Overlay* m_pxOverlay;

	static ToolsAVP_Entity_InteractInvisiSwitch* s_pxSelectedInvisiSwitch;

	static Asura_Hashed_List<ToolsAVP_Entity_InteractInvisiSwitch> s_xList;

	typedef ToolsAVP_Entity_InteractObject PARENT;
};

#endif // #ifndef __TOOLSAVP_ENTITY_INTERACTSENTRYGUNINVISISWITCH__
