//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_InteractHackingPoint.h
//
// Created by AJK 24/11/2008
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLSAVP_ENTITY_INTERACTHACKINGPOINT__
#define __TOOLSAVP_ENTITY_INTERACTHACKINGPOINT__

#include "Entity/PhysicalObject/Interact/ToolReceptacle/ToolsAVP_Entity_InteractToolReceptacle.h"

class AVP_ServerEntity_InteractHackingPoint;

class ToolsAVP_Entity_InteractHackingPoint : public ToolsAVP_Entity_InteractToolReceptacle
{
public:

	static void				Create();
	static Tools_Object*	Create(Asura_Entity* pxEntity);
	static ToolsAVP_Entity_InteractHackingPoint*	FindEntity(Asura_Guid uGuid)		{ return s_xList.FindEntity(uGuid); }

	virtual bool			CanBeCopied() const { return ( Type == TOT_Entity_InteractHackingPoint ); }
	virtual Tools_Object*	CreateObjectOfThisType() const;

	virtual const char*		GetTypeDescription(){return "Hacking point";}

	virtual void            AddActionsControls( Asura_Overlay* pxOverlay, Asura_Vector_2& xOffset );
	virtual bool			GetEventDescForMessageBlock( unsigned short usMessageBlockID, Asura_String& xOutputDesc );
	virtual bool			OwnsThisMessageBlock( unsigned short usMessageBlockID );
	virtual	void			Destroy();

protected:

	ToolsAVP_Entity_InteractHackingPoint(AVP_ServerEntity_InteractHackingPoint* pxInteractObject);
	virtual ~ToolsAVP_Entity_InteractHackingPoint();

	typedef ToolsAVP_Entity_InteractToolReceptacle PARENT;

	virtual bool AllowToolInside() { return false; }

	static void	EditOnMarineInsertHackingToolMessages();   //This differs with regard to species; Marine insert HackingTool, and trigget some power thing 
	static void	EditOnMarineRemoveHackingToolMessages(); // Marine remove HackingTool

	static ToolsAVP_Entity_InteractHackingPoint* s_pxSelectedReceptacle;
	static Asura_Hashed_List<ToolsAVP_Entity_InteractHackingPoint> s_xList;
};

#endif // #ifndef __TOOLSAVP_ENTITY_INTERACTHACKINGPOINT__
