//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_InteractRetinalScanner.h
//
// Created by AJK 22/12/2008
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLSAVP_ENTITY_INTERACTRETINALSCANNER__
#define __TOOLSAVP_ENTITY_INTERACTRETINALSCANNER__

#include "Entity/PhysicalObject/Interact/ToolReceptacle/ToolsAVP_Entity_InteractToolReceptacle.h"

class AVP_ServerEntity_InteractRetinalScanner;

class ToolsAVP_Entity_InteractRetinalScanner : public ToolsAVP_Entity_InteractToolReceptacle
{
public:

	static void				Create();
	static Tools_Object*	Create(Asura_Entity* pxEntity);
	static ToolsAVP_Entity_InteractRetinalScanner*	FindEntity(Asura_Guid uGuid)		{ return s_xList.FindEntity(uGuid); }

	virtual bool			CanBeCopied() const { return ( Type == TOT_Entity_InteractRetinalScanner ); }
	virtual Tools_Object*	CreateObjectOfThisType() const;

	virtual const char*		GetTypeDescription(){return "Retinal scanner";}

	virtual void            AddActionsControls( Asura_Overlay* pxOverlay, Asura_Vector_2& xOffset );
	virtual bool			GetEventDescForMessageBlock( unsigned short usMessageBlockID, Asura_String& xOutputDesc );
	virtual bool			OwnsThisMessageBlock( unsigned short usMessageBlockID );
	virtual	void			Destroy();
	virtual void			AddFilesToExportList(List<Asura_String>& xNameList) const;

protected:

	ToolsAVP_Entity_InteractRetinalScanner(AVP_ServerEntity_InteractRetinalScanner* pxInteractObject);
	virtual ~ToolsAVP_Entity_InteractRetinalScanner();

	virtual bool AllowToolInside() { return false; }

	typedef ToolsAVP_Entity_InteractToolReceptacle PARENT;

	void UpdateHeadBlueprint(Asura_Overlay* pxOverlay);

	static void ChooseBlueprint( int iThis );

	static void	EditOnPredatorUseHeadMessages();

	static ToolsAVP_Entity_InteractRetinalScanner* s_pxSelectedReceptacle;

	static Asura_Hashed_List<ToolsAVP_Entity_InteractRetinalScanner> s_xList;

};

#endif // #ifndef __TOOLSAVP_ENTITY_INTERACTRETINALSCANNER__
