//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_Lift.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
// Description:
//
//     Project override of asura lift class
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___TOOLSAVP_ENTITY_LIFT_H___
#define ___TOOLSAVP_ENTITY_LIFT_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

// Tools.
#include "Entity/Tools_Entity_Lift.h"

// Project tools.
#include "Entity/PhysicalObject/ToolsAVP_Entity_PhysicalObject.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_ServerEntity_Lift;

// C L A S S E S /////////////////////////////////////////////////////////////

class ToolsAVP_Entity_Lift : public ToolsAVP_Entity_PhysicalObject, public virtual Tools_Entity_Lift
{

public:
	virtual void AddFilesToExportList(List<Asura_String>& xNameList) const;

	virtual bool	CanBeCopied			(void) const			{ return true; }
	virtual bool	UseStreamCopy		(void) const			{ return true; }

    static void Create();
    static Tools_Object* Create( Asura_Entity* pxEntity );
    static ToolsAVP_Entity_Lift* FindEntity( Asura_Guid uGUID ) { return s_xList.FindEntity( uGUID ); }

    virtual void Edit( void );
	virtual void AddOverlayControls( Asura_Overlay* pxNewOverlay, Asura_Vector_2& xOffset );
    virtual bool GetParameter( Asura_Hash_ID uParamID, Tools_Parameter* pxParam ) const;
	virtual bool SetParameter( Asura_Hash_ID uParamID, const Tools_Parameter* pxParam );
    virtual const char* GetTypeDescription( void );
	virtual void OnSelection() { PARENT_ASURA::OnSelection(); PARENT::OnSelection(); }
	virtual void OnDeselection() { PARENT_ASURA::OnDeselection(); PARENT::OnDeselection(); }
	virtual bool HandlesThisEvent( int iEventID ) const { return ( PARENT_ASURA::HandlesThisEvent( iEventID ) || PARENT::HandlesThisEvent( iEventID ) ); }
    virtual bool HandlesThisMessage( int iMessageID );
    virtual void PrintInfo( float& fX, float& fY );
	virtual bool AddSharedParamDialogToOverlay( Asura_Overlay* pxOverlay, const Asura_Vector_2& xOffset, Asura_Hash_ID uParamID )
	{
		return( PARENT_ASURA::AddSharedParamDialogToOverlay(pxOverlay, xOffset, uParamID) || PARENT::AddSharedParamDialogToOverlay(pxOverlay, xOffset, uParamID) );
	}


	virtual void UpdateWhileSelected( void );
protected:

    ToolsAVP_Entity_Lift( AVP_ServerEntity_Lift* pxAVPLiftObj );        
    virtual ~ToolsAVP_Entity_Lift( void );

    AVP_ServerEntity_Lift* m_pxAVPLiftObj;

private:

    typedef Tools_Entity_Lift PARENT_ASURA;
    typedef ToolsAVP_Entity_PhysicalObject PARENT;

    friend class Tools_Entity_Lift;

    static Asura_Hashed_List<ToolsAVP_Entity_Lift> s_xList;

};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___TOOLSAVP_ENTITY_LIFT_H___
