///////////////////////////////////////////////////////////////////////////////
//
// File   : ToolsAVP_Entity_StartPoint.h
// Author : Anthony Gregson
// Date   : 09/10/07
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __TOOLSAVP_ENTITY_STARTPOINT_H__
#define __TOOLSAVP_ENTITY_STARTPOINT_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Interface/Asura_Dialog.h"

#include "Entity/Tools_Entity_StartPoint.h"

#include "Entity/Tools_Entity_Object.h"
#include "Objects/Tools_Object_System.h"


const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_STARTPOINT_BLUEPRINT			= 0xD12CF202; // Asura_GetHashID( "StartPoint_Blueprint")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_STARTPOINT_BLUEPRINT_FUNC    = 0x07EEDAE1; // Asura_GetHashID( "StartPoint_Blueprint_Func" )

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class Asura_Overlay;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : ToolsAVP_Entity_StartPoint
// Author		: Anthony Gregson
// Date			: 09/10/07
//
// Description  : Class to allow AvP to add an extra option to start points.
////////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Entity_StartPoint : public Tools_Entity_StartPoint
{
public:

	// Public functions...
	ToolsAVP_Entity_StartPoint(Asura_Entity* pxEntity);
	virtual ~ToolsAVP_Entity_StartPoint() {}

	virtual bool HandlesThisMessage(int iMessageID); 
	virtual void AddOverlayControls(Asura_Overlay* pxNewOverlay, Asura_Vector_2& xOffset);

	virtual bool GetParameter(Asura_Hash_ID uParamID, class Tools_Parameter* pxParam) const;
	virtual bool SetParameter(Asura_Hash_ID uParamID, const class Tools_Parameter* pxParam);

	void SetToolsSkinOverrideFromBlueprint( Asura_Hash_ID uBlueprintTypeHashID, Asura_Hash_ID uBlueprintHashID );

protected:
	// Protected functions...

	// Protected variables...

private:
	// Private functions...
	static void ChooseBlueprint( int iThis );

	// Private typedefs...
	typedef Tools_Entity_StartPoint PARENT;		 
};   // End of class 'ToolsAVP_Entity_SpawnPoint'.


#endif   // ifndef __TOOLSAVP_ENTITY_STARTPOINT_H__