//
// ToolsAVP_Entity_InteractionTrigger.h
//
// Created by Chris Wallace
// 
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLSAVP_ENTITY_INTERACTIONTRIGGER_H__
#define __TOOLSAVP_ENTITY_INTERACTIONTRIGGER_H__

#include "Entity/Tools_Entity_AdvancedVolumeTrigger.h"
#include "Objects/Tools_Object_System.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
/*-------------------------------------------**
** ToolsAVP_Entity_InteractionTrigger **
**-------------------------------------------*/

class ToolsAVP_Entity_InteractionTrigger : public Tools_Entity_AdvancedVolumeTrigger 
{
    friend class ToolsAVP_ChooseEntityForInteractionTrigger;

protected:
	ToolsAVP_Entity_InteractionTrigger( Asura_Entity* pxEntity );
	~ToolsAVP_Entity_InteractionTrigger();

public:
	static void Create();
	static void Project_Create();
	static Tools_Object* Create( Asura_Entity* pxEntity );
	const char* GetTypeDescription(){return "Interaction Trigger";}

	void AddOverlayControls(class Asura_Overlay* pxNewOverlay,class Asura_Vector_2& xOffset);

    void OnSelection();
    void OnDeselection();

private:

    static ToolsAVP_Entity_InteractionTrigger* s_pxThis;
    Tools_ChooseObject* m_pxChooseObject;

private:
	
    static void SetSpecificGuid();
    static void GoToObjectWithGuid();
    void SetSpecificGuid( Tools_Object* pxObject );
};

class ToolsAVP_ChooseEntityForInteractionTrigger : public Tools_ChooseObject
{
public :
	ToolsAVP_ChooseEntityForInteractionTrigger( ToolsAVP_Entity_InteractionTrigger* pxInteractionTrigger )
    : m_pxInteractionTrigger( pxInteractionTrigger )
    {}

    virtual bool CanBeSelected( Tools_Object* pxObject ) { return true; }
	virtual void ObjectSelected( Tools_Object* pxObject )
    {
        m_pxInteractionTrigger->SetSpecificGuid( pxObject );
    }
    virtual void OnFinish() { m_pxInteractionTrigger->m_pxChooseObject = 0; delete this; }

private:
    ToolsAVP_Entity_InteractionTrigger* m_pxInteractionTrigger;
};

#endif //__TOOLSAVP_ENTITY_INTERACTIONTRIGGER_H__
