//
// ToolsAVP_Entity_VolumeTrigger.h
//
// Created by Anthony Gregson - 11/12/07
// 
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLSAVP_ENTITY_VOLUMETRIGGER_H__
#define __TOOLSAVP_ENTITY_VOLUMETRIGGER_H__

#include "Entity/Tools_Entity_VolumeTrigger.h"
#include "Objects/Tools_Object_System.h"

class Asura_Overlay;
class Asura_Vector_2;

//////////////////////////////////////////////////////////////////////////////////////////////////
/*-------------------------------**
** ToolsAVP_Entity_VolumeTrigger **
**-------------------------------*/

class ToolsAVP_Entity_VolumeTrigger : public Tools_Entity_VolumeTrigger 
{
    friend class ToolsAVP_ChooseEntityForVolumeTrigger;
	typedef Tools_Entity_VolumeTrigger PARENT;

protected:
	ToolsAVP_Entity_VolumeTrigger(Asura_Entity* pxEntity);
	~ToolsAVP_Entity_VolumeTrigger();

public:
	static void Create();
	static Tools_Object* Create(Asura_Entity* pxEntity);

	void AddOverlayControls(Asura_Overlay* pxNewOverlay, Asura_Vector_2& xOffset);

    void OnSelection();
    void OnDeselection();

	virtual void Copy(const Tools_Object* pxObject);
	virtual Tools_Object* CreateObjectOfThisType() const;

protected:
	virtual bool AllowClientVolumes() const { return false; }

private:
    static ToolsAVP_Entity_VolumeTrigger* s_pxThis;
    Tools_ChooseObject* m_pxChooseObject;

private:
    static void SetSpecificGuid();
    static void GoToObjectWithGuid();
    void SetSpecificGuid(Tools_Object* pxObject);
};

class ToolsAVP_ChooseEntityForVolumeTrigger : public Tools_ChooseObject
{
public :
	ToolsAVP_ChooseEntityForVolumeTrigger( ToolsAVP_Entity_VolumeTrigger* pxVolumeTrigger )
    : m_pxVolumeTrigger( pxVolumeTrigger )
    {}

    virtual bool CanBeSelected( Tools_Object* pxObject ) { return true; }
	virtual void ObjectSelected( Tools_Object* pxObject )
    {
        m_pxVolumeTrigger->SetSpecificGuid( pxObject );
    }
    virtual void OnFinish() { m_pxVolumeTrigger->m_pxChooseObject = 0; delete this; }

private:
    ToolsAVP_Entity_VolumeTrigger* m_pxVolumeTrigger;
};

#endif //__TOOLSAVP_ENTITY_VOLUMETRIGGER_H__
