//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_ChooseObjects.cpp
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// core
#include "Core/Asura.h"

// header
#include "ToolsAVP_ChooseObjects.h"

// avp
#include "Entity/Controller/AVP_ServerEntity_Squad.h"
#include "Entity/Locations/LookAt/AVP_ServerEntity_LookAt.h"
#include "Entity/PhysicalObject/Actor/AVP_ServerEntity_Actor.h"

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

bool ToolsAVP_ChooseActorOrSquad::CanBeSelected( Tools_Object* pxObject )
{
	if ( pxObject )
	{
		return ( AVP_ServerEntity_Squad::FindEntity( pxObject->GetGuid() ) || AVP_ServerEntity_Actor::FindEntity( pxObject->GetGuid() ) );
	}
	else
	{
		return false;
	}
}

bool ToolsAVP_LookAtChooseObject::CanBeSelected( Tools_Object* pxObject )
{
	if ( pxObject )
	{
		if (pxObject->GetGuid() == m_uGuidToIgnore )
		{
			return false;
		}
		else
		{
			return ( AVP_ServerEntity_Actor::FindEntity( pxObject->GetGuid() ) || AVP_ServerEntity_LookAt::FindEntity( pxObject->GetGuid() ) );
		}
	}

	return false;
}

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////
