#ifdef ASURA_USE_AXON
//////////////////////////////////////////////////////////////////////////////
//
// Axon_BehaviourParams_GS2AttractorEnRoute.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AXON_BEHAVIOURPARAMS_GS2ATTRACTORENROUTE_H__
#define __AXON_BEHAVIOURPARAMS_GS2ATTRACTORENROUTE_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// axon
#include "Behaviour/Axon_BehaviourParams.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

template< typename T > class List;

//////////////////////////////////////////////////////////////////////////////
//
// Axon_BehaviourParams_GS2AttractorEnRoute
//
//////////////////////////////////////////////////////////////////////////////

class Axon_BehaviourParams_GS2AttractorEnRoute : public Axon_BehaviourParams
{
	typedef Axon_BehaviourParams PARENT;

public:
	Axon_BehaviourParams_GS2AttractorEnRoute( const Axon_BehaviourParams_GS2AttractorEnRoute& xAttParams );
	Axon_BehaviourParams_GS2AttractorEnRoute( const u_int uBehaviourType );

	virtual bool IsBaseOrDerivativeOf( const u_int uParamsType ) const;

	u_int m_uAnimSet;
	bool  m_bUseArrivalRange;
	float m_fArrivalRange;

protected:
	virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );
	virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;

private:
	enum { CURRENT_CHUNK_VERSION = 1 };

#ifdef ASURA_TOOLS
protected:
	virtual void Render();
	virtual void AddOverlayControls( Asura_Tabs_Dialog* pxTabsDialog, Asura_Vector_2& xOffset );
	virtual void AddFilesToExportList( List< Asura_String >& xNameList ) const;
	virtual bool GetParameter( const Asura_Hash_ID uParamID, Tools_Parameter* pxParam ) const;
	virtual bool SetParameter( const Asura_Hash_ID uParamID, const Tools_Parameter* pxParam );
	virtual bool Verify( const bool bAutomatic );
	virtual Axon_BehaviourParams* Clone() const;

private:
	static void PickAnimSet( int iThis );
	static bool IsUsingRange( int iThis );
#endif
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AXON_BEHAVIOURPARAMS_GS2ATTRACTORENROUTE_H__
#endif // ASURA_USE_AXON
