#ifdef ASURA_USE_AXON
//////////////////////////////////////////////////////////////////////////////
//
// Axon_Sense_Vision.h
//
// Created by NJD - 29 August 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AXON_SENSE_VISION_H__
#define __AXON_SENSE_VISION_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// asura
#include "Core/Asura_HashedList.h"

// axon
#include "Knowledge/Axon_Sense.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Blueprint;
class Asura_Chunk_Stream;
class Asura_Message;
class Asura_Vector_3;
struct Axon_Knowledge;

//////////////////////////////////////////////////////////////////////////////
//
// Axon_Sense_Vision
//
//////////////////////////////////////////////////////////////////////////////

class Axon_Sense_Vision : public Axon_Sense< Axon_Knowledge >
{
public:
    Axon_Sense_Vision( Axon_Knowledge_System< Axon_Knowledge >* pxKnowledgeSystem );
    virtual ~Axon_Sense_Vision();
    virtual void InitialiseFromBlueprint( const Asura_Blueprint& xBlueprint ) {}
    virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );
    virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;
    virtual void Update( const float fTimeslice );
    virtual bool HandleMessage( const Asura_Message* pxMessage );

    float GetRange() const { return m_fRange; }

    const Asura_Hashed_List< Axon_Knowledge >* GetList() const { return &m_xVisionList; }

protected:
    virtual bool ShouldCullOnRange( const float fRange, const Asura_Vector_3& xToEntity );
    virtual bool ShouldCullOnFOV( const float fRange, const Asura_Vector_3& xToEntity );
    virtual bool IsPointInFrustum( const Asura_Vector_3& xPoint );

    void DestroyAllKnowledge();

protected:
    float                               m_fRange;
    float                               m_fTanFovX;
    float                               m_fTanFovYUp;
    float                               m_fTanFovYDown;
    float                               m_fRangeModifier;
    Asura_Hashed_List< Axon_Knowledge > m_xVisionList;

private:
    struct ChunkData
    {
        enum { CURRENT_VERSION = 0 };
        float m_fRangeModifier;
    };
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AXON_SENSE_VISION_H__
#endif
