//
// Tools_BillboardPlant_Object.h
//
// Created by Andrew Weinkove - 06/12/02
// 
// Copyright (C) 2002 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_BILLBOARDPLANT_OBJECT_
#define _TOOLS_BILLBOARDPLANT_OBJECT_

#include "Objects/Tools_Object.h"
#ifdef ASURA_USE_BILLBOARD_PLANTS
class Tools_BillboardPlant_Object : public Tools_Object
{
	public :
		Tools_BillboardPlant_Object(const Asura_Vector_3& xPosition, const unsigned uPlantID);
		~Tools_BillboardPlant_Object();

		const char* GetTypeDescription(){return "Billboard Plant";}
		void CreateOverlay();
		void OnSelection();
		void OnDeselection();
		void UpdateWhileSelected();
		void Render();

		static void ChangePlantType();

		unsigned m_uPlantType;
		//static data for overlay
		static Asura_Vector_2 s_xOverlayPosition;
		static Tools_BillboardPlant_Object* s_pxThisPlant;
};

#endif //ASURA_USE_BILLBOARD_PLANTS
#endif //_TOOLS_BILLBOARDPLANT_OBJECT_

