//
// Tools_BillboardPlant_Scatter.h
//
// Created by Andrew Weinkove - 09/12/02
// 
// Copyright (C) 2002 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_BILLBOARDPLANT_SCATTER_
#define _TOOLS_BILLBOARDPLANT_SCATTER_

#include "Misc/list_tem.hpp"
#include "Misc/Tools_Polygon_Selection.h"
class Tools_BillboardPlant_Object;

#ifdef ASURA_USE_BILLBOARD_PLANTS

class Tools_BillboardPlant_Scatter
{
public:
	static void Scatter(unsigned uPlantType, float fNumberToCreate, float fClumpiness);
	static void Accept();
	static void Reject();
private:
	static void GetRandomPositionInPoly(const PolygonID &xPolygon, Asura_Vector_3 &xPosition);
	static bool IsPositionOKToCreatePlant(const Asura_Vector_3& xPosition, const unsigned uPlantType);
	static bool IsPlantClumped(Tools_BillboardPlant_Object *pxPlant);
	static Tools_BillboardPlant_Object *CreatePlant(const unsigned uPlantType);
	static bool CreateRandomPlant(const unsigned uPlantType);
	static bool CreateClumpedPlant(const unsigned uPlantType);
	// data.
	static List<Tools_BillboardPlant_Object*>s_listCurrentRandom;
	static float s_fClumpProximityMaxSquared;
	static float s_fPlantProximityMinSquared;
};

#endif //ASURA_USE_BILLBOARD_PLANTS

#endif //_TOOLS_BILLBOARDPLANT_OBJECT_

