///////////////////////////////////////////////////////////////////////////////
//
// File: Tools_Overlay_Decals.h
//
// Created by Dave Reed - 8/2/2007
// 
// Copyright (C) 2007 Rebellion (Derby), All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLS_OVERLAY_DECALS_H__
#define __TOOLS_OVERLAY_DECALS_H__

#ifdef ASURA_USE_DECAL_MANAGER


class Tools_Overlay_Decals
{
public:
	static void Initialise();
	static void Shutdown();
	static void Update();
	static void Render(void);

	static void ToggleOverlay();
	static bool IsOpen() { return s_bIsOpen; }
	static void Close();

	static bool SaveDecalTemplates(void);

	static void AddDecalMaterial();
	static void RemoveDecalMaterial();

	static void AddDecalSet();
	static void RemoveDecalSet();
	
	static void RebuildNameLists();
	static void ReleaseNameLists();

	static void PlaceTestDecal();

#if defined(ASURA_TARGET_SM3)
	static void ClearDecalTexture(int i);
	static void ChangeDecalTexture(int i);
#else
	static void ClearDecalTexture(void);
	static void ChangeDecalTexture(void);
#endif

	static void SelectedMaterialChanged(void);
	static void SelectedDecalSetChanged(void);

	static void RefreshOverlay(void);	

	static void FinishUVEdit(void);
	static void StartUVEdit(void);
	static void UpdateUVEdit(void);
	
	static const char* const GetDecalTemplatesFilename();

private:

	static class Tools_UV_Editor* s_pxUVEditor;

	static const char**	  s_pszMaterialNameList;
	static const char**	  s_pszDecalSetNameList;

	static void			  CreateOverlay();
	static int			  s_iEditingMaterial;
	static int			  s_iEditingSet;
	static int			  s_iSetMaterialIndex;
	static Asura_Vector_2 s_xPosition;
	static bool			  s_bIsOpen;
	static bool			  s_bUpdated;	
	static bool			  s_bModified;

	static int			  s_iSelectedDecalIndex;
	static int			  s_iReqestedNumDecalTypes;
	static bool			  s_bNumDecalTypesChanged;
	static bool			  s_bCurrentDecalTypeChanged;
	static bool			  s_bDecalTemplatesModified;


	static void EditMaterialResponseCB();
	static void CreateMaterialResponseCB();
};


#endif //#ifdef ASURA_USE_DECAL_MANAGER

#endif
