//////////////////////////////////////////////////////////////////////////////
//
// Tools_Object_LiftSplinePoint.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
// Description:
//
//     Tools control point for lift splines
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___TOOLS_OBJECT_LIFTSPLINEPOINT_H___
#define ___TOOLS_OBJECT_LIFTSPLINEPOINT_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

// tools
#include "Entity/Locations/Spline/Tools_Object_NodeSplinePoint.h"

//////////////////////////////////////////////////////////////////////////////
//
// Tools_Object_LiftSplinePoint
//
//////////////////////////////////////////////////////////////////////////////

class Tools_Object_LiftSplinePoint : public Tools_Object_NodeSplinePoint
{
    typedef Tools_Object_NodeSplinePoint PARENT;

public:
    Tools_Object_LiftSplinePoint(class Asura_ServerNode_LiftSpline* pxParentNode,
        class Tools_EntityNode_LiftSpline* pxParentTools,
        int iIndex,
        bool bIsEndPoint);
    virtual ~Tools_Object_LiftSplinePoint() {}

    virtual void UpdatePositionInAsuraData(bool /*updateLinkedObjects*/);
    virtual void UpdatePositionFromAsuraData();
    virtual const char* GetTypeDescription(){return "Lift Spline Control Point";}
    virtual void OnSelection();
    virtual void OnDeselection();
    virtual void Render();
	virtual void Update();

private:
    class Asura_ServerNode_LiftSpline* m_pxLiftParentNode;
    class Tools_EntityNode_LiftSpline* m_pxLiftParentTools;
    static Tools_Object_LiftSplinePoint* s_pxThisLiftSplinePoint;
};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___TOOLS_OBJECT_LIFTSPLINEPOINT_H___