// Tools_ApplyForce_Messages.h
// Emil Popovic- 22.4.09
// Copyright (C) 2008 Rebellion, All Rights Reserved.

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef ___TOOLS_APPLYFORCE_MESSAGES_H___
#define ___TOOLS_APPLYFORCE_MESSAGES_H___


struct Asura_StaticMessage;
class Asura_Overlay;
class Asura_Vector_2;
class Tools_Object;
class Asura_Msg_ApplyForce_Linear;
class Asura_Msg_ApplyForce_Radial;

#include "Core/Asura_String.h"


class Tools_ApplyForce_Messages
{
public:
	static void AddOverlayControls_LinearForce(Asura_StaticMessage* pxMessage, Asura_Overlay* pxOverlay, Asura_Vector_2& xOffset);
	static void AddOverlayControls_RadialForce(Asura_StaticMessage* pxMessage, Asura_Overlay* pxOverlay, Asura_Vector_2& xOffset);

protected:
	static void SetObjectNameString( Asura_String &xNameString, const Asura_Guid uGuid );
	static void OnSelect_ChooseLinearForcePosObject(Tools_Object* pxObject);
	static void OnSelect_ChooseRadialForcePosObject(Tools_Object* pxObject);
	static void ChooseLinearForcePosObject(void);
	static void ChooseRadialForcePosObject(void);
	static void ChooseBlueprintForApplyForceMsg(int pExtraInfoBPHash);
	static void ApplyLinearForce_SetCentreOfMassOffset();

	static Asura_Msg_ApplyForce_Linear* s_pxApplyLinearForceMessage;
	static Asura_Msg_ApplyForce_Radial* s_pxApplyRadialForceMessage;
	static Asura_String					 s_xObjectNameString;

};



#endif ___TOOLS_APPLYFORCE_MESSAGES_H___
