//
// Tools_EntityFilterOverlay.h
//
// Created by Richard Rice - 07/12/2004
// 
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_ENTITYFILTEROVERLAY_H_
#define _TOOLS_ENTITYFILTEROVERLAY_H_

#include "Core/Asura_String.h"
#include "Misc/list_tem.hpp"
#include "Misc/Tools_Modal_Overlay.h"


class Tools_EntityFilterOverlay : public Tools_Modal_Overlay
{
	public :
		Tools_EntityFilterOverlay(Asura_String xTitle,List<int>* pxFilterOutList);
		~Tools_EntityFilterOverlay();


	private :
		virtual void InitialiseOverlay(class Asura_Overlay* pxOverlay);

		static bool _IsIncluded(int iIndex,int iThis)
		{return ((Tools_EntityFilterOverlay*)iThis)->IsIncluded(iIndex);}

		static void _ToggleInclude(int iIndex,int iThis)
		{((Tools_EntityFilterOverlay*)iThis)->ToggleInclude(iIndex);}

		static void _CheckAll(int iThis)
		{((Tools_EntityFilterOverlay*)iThis)->CheckAll();}

		static void _CheckNone(int iThis)
		{((Tools_EntityFilterOverlay*)iThis)->CheckNone();}

		static void _Invert(int iThis)
		{((Tools_EntityFilterOverlay*)iThis)->Invert();}

		static void OkaySelected(){}

		bool IsIncluded(int iIndex);
		void ToggleInclude(int iIndex);
		void CheckAll();
		void CheckNone();
		void Invert();
		

		void AddToTypeList(const char* pszTypeName,int iType);

		List<ListSelectionItem*> m_xTypeList;
		int m_iSelectionIndex;

		List<int>* m_pxFilterOutList;

		char** m_ppszTypeStrings;

};



#endif //_TOOLS_ENTITYFILTEROVERLAY_H_
