//////////////////////////////////////////////////////////////////////////////////////
// 
// FILE : Tools_Entity_Actor.h
//
// AUTHOR : Martin G. Harris
//
// Copyright 2002 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_ENTITY_ACTOR_H_
#define _TOOLS_ENTITY_ACTOR_H_

#include "Tools_Entity_PhysicalObject.h"
// Forward declaration
class Asura_ServerEntity_Actor;

//////////////////////////////////////////////////////////////////////////////////
// Tools_Entity_Actor															//
//////////////////////////////////////////////////////////////////////////////////
class Tools_Entity_Actor : public virtual Tools_Entity_PhysicalObject
{
protected:
	Tools_Entity_Actor(Asura_ServerEntity_Actor* pxActor);
	virtual ~Tools_Entity_Actor() {}

	// virtual function overrides
    virtual const char* GetTypeDescription() { return "Actor"; }
	virtual void PrintInfo(float& x,float& y) {} // no need to call parent
	virtual void Copy(const Tools_Object* pxObject);

	static const char* GetNamePrefix() { return "Act_"; }
	virtual const char* GetMyNamePrefix() const { return Tools_Entity_Actor::GetNamePrefix(); }

protected:
	Asura_ServerEntity_Actor* m_pxActor; // cached pointer to entity
};

#endif //_TOOLS_ENTITY_ACTOR_H_

