// Tools_Entity_DynamicMusicTrigger_Object.h
// Thomas Young - 14.08.08
// Copyright (C) 2008 Rebellion, All Rights Reserved.

// F I L E   W R A P P E R ///////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef _TOOLS_ENTITY_DYNAMICMUSICTRIGGER_OBJECT_H_
#define _TOOLS_ENTITY_DYNAMICMUSICTRIGGER_OBJECT_H_

#ifdef ASURA_SUPPORT_DYNAMIC_MUSIC_SYSTEM

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Sound/Asura_Dynamic_Music_System_Triggers.h"
#include "Tools_Entity_Activatable_Object.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Channel_Graph_Block;
class Asura_Channel_Graph_Dialog;
class Asura_Channel_Graph_Channel;

// C L A S S   D E C L A R A T I O N S ///////////////////////////////////////

class Tools_Entity_DynamicMusicTrigger_Object : public Tools_Entity_Activatable_Object
{
	public :
	
		Tools_Entity_DynamicMusicTrigger_Object(Asura_Entity* pxEntity);
		static void Create();
		static Tools_Entity_DynamicMusicTrigger_Object* Create(bool bGenerateName);

		static void		HandleTrackRename				(Asura_Hash_ID uOldHash, Asura_Hash_ID uNewHash);	//Updates any triggers that were using a renamed track

		//virtual function overides
		const char*		GetTypeDescription				();
		virtual const char* GetMyNamePrefix				() const { return Tools_Entity_DynamicMusicTrigger_Object::GetNamePrefix(); }

		void			AddOverlayControls				(Asura_Overlay* pxOverlay,class Asura_Vector_2& xOffset);

		void			UpdateWhileSelected				();

		virtual void			Copy					(const Tools_Object*);
		virtual bool			CanBeCopied				() const { return (Type == TOT_Entity_DynamicMusicTrigger); }
		virtual Tools_Object*	CreateObjectOfThisType	() const;

		virtual void			Destroy					();

		void					OnSelection				();
		void					OnDeselection			();

		static const char*		GetNamePrefix			() { return "DMT_"; }

		static void				RecreateCurrentOverlay	();

	protected :

		void	RecreateOverlay				();

	private:

		static Tools_Entity_DynamicMusicTrigger_Object* s_pxThis;

		typedef Tools_Entity_Activatable_Object PARENT;

};

#endif //#ifdef ASURA_SUPPORT_DYNAMIC_MUSIC_SYSTEM

#endif //_TOOLS_ENTITY_DYNAMICMUSICTRIGGER_OBJECT_H_

//eof
