//////////////////////////////////////////////////////////////////////////////////////////
//
//  FILE        :  Tools_Entity_Explosion.h
//
//  CREATED     :  Adam A. Brown  (1.4.2003)
//
//  Copyright (C) 2003 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __TOOLS_ENTITY_EXPLOSION_H__
#define __TOOLS_ENTITY_EXPLOSION_H__

#include "SpecialFX/Asura_Extended_Particle_Enums.h"
#include "Entity/Tools_Entity_Activatable_Object.h"

class Asura_Explosion;


class Tools_Entity_Explosion: public Tools_Entity_Activatable_Object
{
public:
	Tools_Entity_Explosion(Asura_Entity* pxEntity);
	virtual ~Tools_Entity_Explosion();	

	//virtual function overides
	const char* GetTypeDescription(){ return "Particle Explosion"; }
	void UpdateWhileSelected();
	virtual bool UsesUnTriggerMessage() { return true; }

	static const char* GetNamePrefix() { return "EXP_"; }
	virtual const char* GetMyNamePrefix() const { return Tools_Entity_Explosion::GetNamePrefix(); }

	void AddOverlayControls(class Asura_Overlay* pxNewOverlay,class Asura_Vector_2& xOffset);

	virtual void OnSelection();
	virtual void OnDeselection();

	static void Create();
	static Tools_Object* Create(Asura_Entity* pxEntity);
	
	static void StartPreview();
	static void StopPreview();

	virtual void Copy(const Tools_Object*);
	virtual bool CanBeCopied() const {return Type == TOT_Entity_ExtendedParticleGenerator;}
	virtual Tools_Object* CreateObjectOfThisType() const;

protected:

	static void MakeNames();
	static void FreeNames();
	void ReleaseExplosion();

protected:

	ASURA_EXPLOSION_TEMPLATE m_eType;
	unsigned m_uExplosionGuid;
	int m_iListOffset;
	int m_iListSelection;

	bool m_bActive;

	static Tools_Entity_Explosion* s_pxThis;

	static char **s_pszNameList;
};


#endif//__TOOLS_ENTITY_EXPLOSION_H__
