//////////////////////////////////////////////////////////////////////////////////////////
//
//  FILE        :  Tools_Entity_Extended_Particle_Generator.h
//
//  CREATED     :  Adam A. Brown  (25.3.2003)
//
//  Copyright (C) 2003 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __TOOLS_ENTITY_EXTENDED_PARTICLE_GENERATOR_H__
#define __TOOLS_ENTITY_EXTENDED_PARTICLE_GENERATOR_H__

#include "Entity/Tools_Entity_Activatable_Object.h"
#include "SpecialFX/Asura_Extended_Particle_Enums.h"
#include "SpecialFX/Asura_Extended_Particle_Generator.h"


//------------------------------------------------------------------------------
////////////////////////////////////////////////////////////////////////////////
//
// The tools side of the particle generator entities.
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
class Tools_Entity_Extended_Particle_Generator: public Tools_Entity_Activatable_Object
{
public:
	Tools_Entity_Extended_Particle_Generator(Asura_Entity* pxEntity);
	virtual ~Tools_Entity_Extended_Particle_Generator();	

	//virtual function overides
	const char* GetTypeDescription(){ return "Extended Particle Generator"; }
	void UpdateWhileSelected();
	virtual bool UsesUnTriggerMessage() { return true; }

	virtual const char* GetMyNamePrefix() const { return Tools_Entity_Extended_Particle_Generator::GetNamePrefix(); }

	void AddOverlayControls(class Asura_Overlay* pxNewOverlay,class Asura_Vector_2& xOffset);

	virtual void OnSelection();
	virtual void OnDeselection();

	static void Create();
	static Tools_Object* Create(Asura_Entity* pxEntity);
	
	static void StartPreview();
	static void StopPreview();

	static const char* GetNamePrefix() { return "EPG_"; }

protected:

	static void MakeNames();

protected:

	bool m_bTriggered;
	ASURA_EXTENDED_PARTICLE_GENERATOR_TEMPLATE m_eType;

	int m_iListOffset;
	int m_iListSelection;

	int m_iDestructionCounter;
	bool m_bActive;

	static Tools_Entity_Extended_Particle_Generator* s_pxThis;

	static char **s_pszNameList;

	static Asura_Extended_Particle_Generator *s_pxPreviewGenerator;

};

#endif//__TOOLS_ENTITY_EXTENDED_PARTICLE_GENERATOR_H__
