//
// Tools_Entity_FMVTrigger_Object.h
//
// Created by Richard Rice - 12/06/2003
// 
// Copyright (C) 2003 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_ENTITY_FMVTRIGGER_OBJECT_H_
#define _TOOLS_ENTITY_FMVTRIGGER_OBJECT_H_

#include "Entity/Tools_Entity_Trigger_Object.h"

class Tools_Entity_FMVTrigger_Object : public Tools_Entity_Trigger_Object
{
	public :
		Tools_Entity_FMVTrigger_Object(Asura_Entity* pxEntity);
		static void Create();
		static Tools_Entity_FMVTrigger_Object* Create(bool bGenerateName);

		//virtual function overides
		virtual const char* GetTypeDescription(){return "FMV Trigger";}
		virtual void AddOverlayControls(class Asura_Overlay* pxOverlay,class Asura_Vector_2& xOffset);

		static const char* GetNamePrefix() { return "FMVT_"; }
		virtual const char* GetMyNamePrefix() const { return Tools_Entity_FMVTrigger_Object::GetNamePrefix(); }

		virtual void Copy(const Tools_Object*);
		virtual bool CanBeCopied() const {return Type == TOT_Entity_FMVTrigger;}
		virtual Tools_Object* CreateObjectOfThisType() const;

	protected :
		static void SelectFMV(int iThis){((Tools_Entity_FMVTrigger_Object*)iThis)->SelectFMV();}
		void SelectFMV();
};


#endif //_TOOLS_ENTITY_FMVTRIGGER_OBJECT_H_
