//
// Tools_Entity_MusicTrigger_Object.h
//
// Created by Richard Rice - 23/01/2004
// 
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_ENTITY_METAMUSICTRIGGER_OBJECT_H_
#define _TOOLS_ENTITY_METAMUSICTRIGGER_OBJECT_H_

#ifndef ASURA_SUPPORT_DYNAMIC_MUSIC_SYSTEM

#include "Entity/Tools_Entity_Activatable_Object.h"


class Tools_Entity_MetaMusicTrigger_Object : public Tools_Entity_Activatable_Object
{
	public :
		Tools_Entity_MetaMusicTrigger_Object(Asura_Entity* pxEntity);
		static void Create();
		static Tools_Entity_MetaMusicTrigger_Object* Create(bool bGenerateName);

		//virtual function overides
		const char* GetTypeDescription(){return "Meta Music Trigger";}

		virtual const char* GetMyNamePrefix() const { return Tools_Entity_MetaMusicTrigger_Object::GetNamePrefix(); }

		void AddOverlayControls(class Asura_Overlay* pxOverlay,class Asura_Vector_2& xOffset);

		void UpdateWhileSelected();

		virtual void Copy(const Tools_Object*);
		virtual bool CanBeCopied() const {return Type == TOT_Entity_MetaMusicTrigger;}
		virtual Tools_Object* CreateObjectOfThisType() const;

		//Updates any triggers that were using a renamed track
		static void HandleTrackRename(Asura_Hash_ID uOldID,Asura_Hash_ID uNewID);

		static const char* GetNamePrefix() { return "MMT_"; }

	protected :
		const char* GetTrackName() const;

		static void SelectMusicTrack(int iThis){((Tools_Entity_MetaMusicTrigger_Object*)iThis)->SelectMusicTrack();}
		void SelectMusicTrack();

		bool m_bAmbientChanged;
		bool m_bTensionChanged;
		bool m_bActionChanged;

		class Asura_Dialog* m_pxDialog_HighPriority;
		class Asura_Dialog* m_pxDialog_SelectTrack;
		class Asura_Dialog* m_pxDialog_ChangeTrack;
		class Asura_Dialog* m_pxDialog_RestartLastTrack;

};

#endif // #ifndef ASURA_SUPPORT_DYNAMIC_MUSIC_SYSTEM

#endif //_TOOLS_ENTITY_MUSICTRIGGER_OBJECT_H_

//eof
