//////////////////////////////////////////////////////////////////////////////
//
// Tools_Entity_PhysicsObject.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef TOOLS_ENTITY_PHYSICSOBJECT_H___
#define TOOLS_ENTITY_PHYSICSOBJECT_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

// Engine independent.
#include "Entity/Tools_Entity_PhysicalObject.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Tabs_Dialog;

// C O N S T A N T S /////////////////////////////////////////////////////////

const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_ANIM_LOOPING           = 0x79D8EB38; // Asura_GetHashID("Asura_PhysicsObject_Looping")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_ANIM_REVERSED          = 0x2AE84C88; // Asura_GetHashID("Asura_PhysicsObject_Reversed")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_USE_ANIM_MOVEMENT      = 0xE4D20741; // Asura_GetHashID("Asura_PhysicsObject_UseAnimMovement")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_NOSHADOW               = 0x9765B4E7; // Asura_GetHashID("Asura_PhysicsObject_NoShadow")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_NOCOLLISIONS           = 0x2F059FC8; // Asura_GetHashID("Asura_PhysicsObject_NoCollisions")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_IGNOREMODLINKING       = 0xB0DDA2A4; // Asura_GetHashID("Asura_PhysicsObject_IgnoreModuleLinking")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_HIDDEN                 = 0xDBB8D9F0; // Asura_GetHashID("Asura_PhysicsObject_Hidden")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_IGNOREFORLOS           = 0xD8383DFF; // Asura_GetHashID("Asura_PhysicsObject_IgnoreForLOS")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_FULLBRIGHT             = 0x2B03138F; // Asura_GetHashID("Asura_PhysicsObject_FullBright")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_BLOCKWAYPOINTLINKS     = 0xA56EEC31; // Asura_GetHashID("Asura_PhysicsObject_BlockWaypointLinks")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_BLOCKNAVDATAGENERATION = 0x9FC96D37; // Asura_GetHashID("Asura_PhysicsObject_BlockWaypointExpansion")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_COLLISIONPROXY         = 0xBC27C8C2; // Asura_GetHashID("Asura_PhysicsObject_CollisionProxy")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_GRAVITYSCALE           = 0x67FD4782; // Asura_GetHashID("Asura_PhysicsObject_GravityScale")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_ELASTICITY             = 0x1A2622FF; // Asura_GetHashID("Asura_PhysicsObject_Elasticity")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_FRICTION               = 0xE5C0C9C0; // Asura_GetHashID("Asura_PhysicsObject_Friction")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_DRAG                   = 0xC847C2FA; // Asura_GetHashID("Asura_PhysicsObject_Drag")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_ANGULARDRAG            = 0x54F3B990; // Asura_GetHashID("Asura_PhysicsObject_AngularDrag")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_PHYSICSOBJECT_MASS                   = 0xC84B9CBA; // Asura_GetHashID("Asura_PhysicsObject_Mass")

const u_int uTOOLS_PHYSICSOBJECT_OPTIONFLAG_NOCOLLISIONS   = 0x00000001;
const u_int uTOOLS_PHYSICSOBJECT_OPTIONFLAG_COLLISIONPROXY = 0x00000002;
const u_int uTOOLS_PHYSICSOBJECT_OPTIONFLAG_GRAVITYSCALE   = 0x00000004;
const u_int uTOOLS_PHYSICSOBJECT_OPTIONFLAG_ELASTICITY     = 0x00000008;
const u_int uTOOLS_PHYSICSOBJECT_OPTIONFLAG_FRICTION       = 0x00000010;
const u_int uTOOLS_PHYSICSOBJECT_OPTIONFLAG_DRAG           = 0x00000020;
const u_int uTOOLS_PHYSICSOBJECT_OPTIONFLAG_ANGULARDRAG    = 0x00000040;
const u_int uTOOLS_PHYSICSOBJECT_OPTIONFLAG_MASS           = 0x00000080;

// C L A S S E S /////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Tools_Entity_PhysicsObject												  //
//																			  //
// *NOTE*: only tools objects that have Asura_ServerEntitiy_PhysicsObject	  //
// entities associated with them should inherit from this class.              //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
class Tools_Entity_PhysicsObject : public virtual Tools_Entity_PhysicalObject
{

public:

	static void Project_Create( void );
    static void Project_CreateStatic( void );
    static Tools_Entity_PhysicsObject* FindEntity( Asura_Guid uGUID ) { return s_xList.FindEntity( uGUID ); }
	static const Asura_Hashed_List<Tools_Entity_PhysicsObject>* GetList( void ) { return &s_xList; }

	#ifndef TOOLS_USE_OLD_ENTITY_MANAGER
	virtual const char* GetShortName(){return "PHY";}
	#endif

	static const char* GetNamePrefix() { return "PHYS_"; }
	virtual const char* GetMyNamePrefix() const { return Tools_Entity_PhysicsObject::GetNamePrefix(); }

	bool IsStatic( void ) const;

protected:

	static bool IsNoneAnimatingObject();
	static void CloneObject();
	static void CloneAllSelectedObjects();
	static void SelectAllOfType();
	static void CopyShadowFlagToSelected(); //Possibly temporary means to allows setting of the no shadow flag on multiple objects quickly.

	static const char* const s_szLongName;
	static const char* const s_szShortName;
    static Tools_Entity_PhysicsObject* s_pxCurrentlySelectedObject;

	Tools_Entity_PhysicsObject();
	virtual ~Tools_Entity_PhysicsObject();

	virtual const char* GetTypeDescription( void );
	virtual const char* GetTypeDescriptionForObjectType(){return "Physics/Static";}
	virtual void AddOverlayControls(Asura_Overlay* pxNewOverlay, Asura_Vector_2& xOffset);
	
	virtual void PrintInfo(float& x,float& y) {}

	virtual void OnSelection();
	virtual void OnDeselection();
	virtual void UpdateWhileSelected();
	virtual bool ShouldHideDuringCutscene();
	


	virtual void Copy(const Tools_Object*);
	virtual bool CanBeCopied() const {return Type == TOT_Entity_PhysicsObject;}
	virtual Tools_Object* CreateObjectOfThisType() const;

	virtual bool GetParameter(Asura_Hash_ID uParamID,class Tools_Parameter* pxParam) const;
	virtual bool SetParameter(Asura_Hash_ID uParamID,const class Tools_Parameter* pxParam);
    bool AddSharedParamDialogToOverlay( Asura_Overlay* pxOverlay, const Asura_Vector_2& xOffset, Asura_Hash_ID uParamID );

	virtual bool UseModuleLinking();

	virtual bool HandlesThisMessage(int iMessageID);

	virtual Tools_Object* CloneObjectMain(const Asura_Vector_3& xOffset);

	virtual bool SupportsMerging() const {return IsStatic();}

    virtual u_int GetEnabledPhysicsOptions( void ) const;

	void UpdateName();

	void UpdateAnim();


    int		m_iAnimFlags;
	int		m_iCollisionProxy;
	float	m_fGravityScale;
	float	m_fElasticity;
	float	m_fFriction;
	float	m_fDrag;
	float	m_fAngularDrag;
	float	m_fMass;

	Asura_Tabs_Dialog*	m_pxTabsDialog;				// Stored so that more tabs can be added in derived classes
	Asura_Vector_2		m_xTabsOffset;				// Offset for the tabs dialog

private:
    
    typedef Tools_Entity_PhysicalObject PARENT;

	static Asura_Hashed_List<Tools_Entity_PhysicsObject> s_xList;

};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef TOOLS_ENTITY_PHYSICSOBJECT_H___
