//
// Tools_Entity_SplitterBlock_Object.h
//
// Created by Richard Rice - 18/09/2002
// 
// Copyright (C) 2002 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_ENTITY_SPLITTERBLOCK_OBJECT_H_
#define _TOOLS_ENTITY_SPLITTERBLOCK_OBJECT_H_

#include "Tools_Entity_Activatable_Object.h"

class Tools_Entity_SplitterBlock_Object : public Tools_Entity_Activatable_Object
{
	public :
		Tools_Entity_SplitterBlock_Object(Asura_Entity* entity);
		~Tools_Entity_SplitterBlock_Object();
		static void Create();
		static Tools_Entity_SplitterBlock_Object* Create(bool bGenerateName);
		
		//virtual function overides
		const char* GetTypeDescription(){return "Splitter Block";}
		void Destroy();
		void UpdateWhileSelected();

		static const char* GetNamePrefix() { return "SB_"; }
		virtual const char* GetMyNamePrefix() const { return Tools_Entity_SplitterBlock_Object::GetNamePrefix(); }

		void AddOverlayControls(class Asura_Overlay* pxNewOverlay,class Asura_Vector_2& xOffset);
		bool HandlesThisMessage(int messageID);
		virtual void PrintInfo(float& x,float& y);


		virtual void Copy(const Tools_Object*);
		virtual bool CanBeCopied() const {return Type == TOT_Entity_SplitterBlock;}
		virtual Tools_Object* CreateObjectOfThisType() const;

		virtual bool OwnsThisMessageBlock(unsigned short uMessageBlockID);
		virtual bool GetEventDescForMessageBlock(unsigned short usMessageBlockID,Asura_String& xOutputDesc);

		bool* m_pbActive;
		bool m_bToggledOutputDelay;
		u_int m_uSplitterFlags;

		void AddOutputBlock();
		void DeleteOutputBlock(int iIndex);

		virtual u_short* AddCustomEvent() { AddOutput(); return m_pxServerEntity->GetCustomEvent(m_pxServerEntity->GetNumCustomEvents() - 1); }
		virtual bool DeleteCustomEvent(int iIndex) { DeleteOutputBlock(iIndex); return true; }
		virtual bool RenameCustomEvent(int iIndex) { EditOutputName(iIndex); return true; }

		//overlay functions
		static void AddOutput();
		static void DeleteOutput();
		static void UpdateOutputTimerArray();
		static void EditMessages(int iIndex);
		static void EditOutputName(int iIndex);
		static void ReorderOutputs();
		static bool CanReorderOutputs();
		static bool IsRandomDelay();
};


#endif //_TOOLS_ENTITY_SPLITTERBLOCK_OBJECT_H_
