//
// Tools_Entity_TimelineTrigger_Object.h
//
// Created by Richard Rice - 03/05/2005
// 
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_ENTITY_TIMELINETRIGGER_OBJECT_H__
#define __TOOLS_ENTITY_TIMELINETRIGGER_OBJECT_H__


#include "Tools_Entity_Activatable_Object.h"

class Tools_Entity_TimelineTrigger_Object : public Tools_Entity_Activatable_Object
{
	public :
		Tools_Entity_TimelineTrigger_Object(Asura_Entity* pxEntity);
		~Tools_Entity_TimelineTrigger_Object();

		static void Create();
		static Tools_Entity_TimelineTrigger_Object* Create(bool bGenerateName);
		
		//virtual function overides
		const char* GetTypeDescription(){return "Timeline Trigger";}
		void Destroy();
		void UpdateWhileSelected();
		virtual void PrintInfo(float& x,float& y);
		virtual void OnDeselection();

		void AddOverlayControls(class Asura_Overlay* pxNewOverlay,class Asura_Vector_2& xOffset);
		bool HandlesThisMessage(int iMessageID);

		static const char* GetNamePrefix() { return "TLT_"; }
		virtual const char* GetMyNamePrefix() const { return Tools_Entity_TimelineTrigger_Object::GetNamePrefix(); }

		virtual void Copy(const Tools_Object*);
		virtual bool CanBeCopied() const {return Type == TOT_Entity_TimelineTrigger;}
		virtual Tools_Object* CreateObjectOfThisType() const;

		virtual bool OwnsThisMessageBlock(unsigned short usMessageBlockID);
		virtual bool GetEventDescForMessageBlock(unsigned short usMessageBlockID,Asura_String& xOutputDesc);

		//controls for editing messages to a timeline trigger
		static void AddOverlayControls_EnableMessage(struct Asura_StaticMessage* pxMessage,class Asura_Overlay* pxOverlay,class Asura_Vector_2& xOffset);
		static void AddOverlayControls_SetTriggerTime(struct Asura_StaticMessage* pxMessage,class Asura_Overlay* pxOverlay,class Asura_Vector_2& xOffset);
		
		static void EditEnableMessage(Asura_StaticMessage* pxMessage);

		virtual u_short* AddCustomEvent() { AddMessage(); return m_pxServerEntity->GetCustomEvent(m_pxServerEntity->GetNumCustomEvents() - 1); }
		virtual bool DeleteCustomEvent(int iIndex) { DeleteMessage((int)this, iIndex); return true; }
		virtual bool RenameCustomEvent(int iIndex) { RenameMessage((int)this, iIndex); return true; }
	
		const char* GetMessageBlockNameFromHash(Asura_Hash_ID uNameHash) const;

		u_short* AddTimelineTriggerMessageBlock(const char* szName = NULL);

		float* m_pfTime;
		bool* m_pbActive;

protected :
		//prompt for a message block to be chosen , returns index of selection , or -1
		int SelectMessageIndex(const char* pszMessage);
		Asura_Hash_ID SelectMessageHash(const char* pszMessage);

		//overlay functions
		static void AddMessage(int iThis){((Tools_Entity_TimelineTrigger_Object*)iThis)->AddMessage();}
		void AddMessage();

		static void DeleteMessage(int iThis){((Tools_Entity_TimelineTrigger_Object*)iThis)->DeleteMessage();}
		void DeleteMessage();

		void DeleteMessage(int iThis, int iIndex);
		void RenameMessage(int iThis, int iIndex);

		static void RenameMessage(int iThis){((Tools_Entity_TimelineTrigger_Object*)iThis)->RenameMessage();}
		void RenameMessage();


		static void EditMessages(int iIndex);

		static void DeselectAll(int iThis){((Tools_Entity_TimelineTrigger_Object*)iThis)->DeselectAll();}
		void DeselectAll();



		//sort messages by time
		void SortMessages();


		static void EditEnableMessage(int iMessage);

		bool m_bTimeChanged;

};

#endif //__TOOLS_ENTITY_TIMELINETRIGGER_OBJECT_H__
