//
// Tools_FSFX_DropDownList_Dialog.h
//
// Created by Richard Rice - 23/08/2006
// 
// Copyright (C) 2006 Rebellion,  All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLS_FSFX_DROPDOWNLIST_DIALOG_H__
#define __TOOLS_FSFX_DROPDOWNLIST_DIALOG_H__

#ifdef ASURA_USE_FSFX

#include "FSFX/Asura_FSFX_Template.h"
#include "Interface/Asura_Dialog.h"

#include "FSFX/Tools_FSFX_System.h"


//dialog control for selecting an FSFX template. RAR 23/08/2006
class Tools_FSFX_DropDownList_Dialog : public Asura_Hash_DropDownList_Dialog
{
public :
	Tools_FSFX_DropDownList_Dialog(Asura_Vector_2& xOffset, int iNumberOfLines,Asura_Hash_ID* puSelectedFSFX,bool* pbChangedFlag = 0 ,const char* szName = NULL)
	:Asura_Hash_DropDownList_Dialog(xOffset)
	{
		Initialise(xOffset,iNumberOfLines,puSelectedFSFX,pbChangedFlag,szName);
	}
protected :
	virtual u_int GetNumberOfHashValues() const
	{
		return Asura_FSFX_System::GetNumTemplates();
	}
	
	virtual const char* GetNameByIndex(int iIndex) const
	{
		const Asura_FSFX_Template* pxTemplate = Asura_FSFX_System::GetTemplateByIndex( iIndex );
		if( pxTemplate )
		{
			return pxTemplate->GetName();
		}
		else
		{
			return "*Error*";
		}
	}
};

#endif //ASURA_USE_FSFX
#endif //__TOOLS_FSFX_DROPDOWNLIST_DIALOG_H__