//
// Tools_Dialog_FacialAnimation_PickFace.h
//
// Created by Richard Rice 17/11/2008
// 
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_DIALOG_FACIALANIMATION_PICKFACE_H__
#define __TOOLS_DIALOG_FACIALANIMATION_PICKFACE_H__
#if defined(ASURA_USE_FACIAL_ANIMATION_SYSTEM)

#include "Interface/Asura_Dialog.h"

//Dialog control for picking a face. When clicked it will open a face selection overlay.
class Tools_Dialog_FacialAnimation_PickFace : public Asura_Function_Dialog
{
public :
	//szPrefix is a prefix added before the face name on the dialog
	//puFaceID is a pointer to the hash ID being edited
	//pbModified is an optional flag that will be set to true whenever the hash value is modified.
	Tools_Dialog_FacialAnimation_PickFace(const char* szPrefix,const Asura_Vector_2& xOffset,Asura_Hash_ID* puFaceID,bool* pbModified = 0);

private :
	virtual void PerFrameUpdate();

	void UpdateText();

	static void OnClicked(int iThis){((Tools_Dialog_FacialAnimation_PickFace*)iThis)->OnClicked();}
	void OnClicked();

	Asura_String m_xPrefix;
	Asura_Hash_ID* m_puFaceID;
	Asura_Hash_ID m_uFaceIDBackup;
	bool* m_pbModified;
};

#endif // defined(ASURA_USE_FACIAL_ANIMATION_SYSTEM)
#endif // __TOOLS_DIALOG_FACIALANIMATION_PICKFACE_H__