
///////////////////////////////////////////////////////////////////////////////
//
// File   : Tools_ModalOverlay_FacialAnimation_MuscleGroupSelectControlType.h
// Author : Andy Tate
// Date   : 3-Jul-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __TOOLS_MODALOVERLAY_FACIALANIMATION_MUSCLEGROUPSELECTCONTROLTYPE_H__
#define __TOOLS_MODALOVERLAY_FACIALANIMATION_MUSCLEGROUPSELECTCONTROLTYPE_H__

#if defined(ASURA_USE_FACIAL_ANIMATION_SYSTEM)

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "FacialAnimation/Asura_FacialAnimation_MuscleGroup.h"

#include "Misc/Tools_Modal_Overlay.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class Tools_FacialAnimation_Face_MuscleGroup;


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : Tools_ModalOverlay_FacialAnimation_MuscleGroupSelectControlType
// Author       : Andy Tate
// Date         : 23-May-2008
//
// Description  : Class to handle the modal selection of the control-type for a
//				  specified muscle-group used for a face with facial-animation.
////////////////////////////////////////////////////////////////////////////////

class Tools_ModalOverlay_FacialAnimation_MuscleGroupSelectControlType : public Tools_Modal_Overlay
{
public:
	// Public functions...
	Tools_ModalOverlay_FacialAnimation_MuscleGroupSelectControlType(void);
	//	virtual ~Tools_ModalOverlay_FacialAnimation_MuscleGroupSelectControlType();

	bool	DoModal(void);

	// Accessor functions...
	Asura_FacialAnimation_MuscleGroup::ControlType	GetControlType(void) const	{ return(static_cast<Asura_FacialAnimation_MuscleGroup::ControlType>(s_iControlType)); }


protected:
	// Protected variables...

	// Protected functions...

	// Overridden functions...
	virtual void	InitialiseOverlay(Asura_Overlay* pxOverlay);

	// Event functions...
	static void		OnOkaySelected(int iUserData);
	static void		OnCancelSelected(int iUserData);


private:
	// Private typedefs...
	typedef Tools_Modal_Overlay PARENT;

	// Private variables...
	bool		m_bAcceptControlType;	// A flag to say whether we've accepted the selected control-type.

	static int	s_iControlType;			// The control-type currently selected (only store one instance so that the last value is maintained across selections).

	// Private functions...
	Tools_ModalOverlay_FacialAnimation_MuscleGroupSelectControlType(const Tools_ModalOverlay_FacialAnimation_MuscleGroupSelectControlType& xOther);

	Tools_ModalOverlay_FacialAnimation_MuscleGroupSelectControlType&	operator=(const Tools_ModalOverlay_FacialAnimation_MuscleGroupSelectControlType& xOther);

};   // End of class 'Tools_ModalOverlay_FacialAnimation_MuscleGroupSelectControlType'.

#endif	//defined(ASURA_USE_FACIAL_ANIMATION_SYSTEM)

#endif   // ifndef __TOOLS_MODALOVERLAY_FACIALANIMATION_MUSCLEGROUPSELECTCONTROLTYPE_H__


/// End of file. ///
