
///////////////////////////////////////////////////////////////////////////////
//
// File   : Tools_FacialAnimation_FaceType_MuscleGroup.cpp
// Author : Andy Tate
// Date   : 9-May-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

#if defined(ASURA_USE_FACIAL_ANIMATION_SYSTEM)

// This file's header...
#include "FacialAnimation/Tools_FacialAnimation_FaceType_MuscleGroup.h"

// Asura independent header-files...
#include "ChunkSystem/Asura_Chunk_Loaders.h"
#include "ChunkSystem/Asura_Chunk_Stream.h"

// Tools header-files...
#include "Hierarchy/Tools_Animation_Files.h"


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Version	Author	Comment
// ~~~~~~~	~~~~~~	~~~~~~~
// 1		ART		Created.
////////////////////////////////////////////////////////////////////////////////
const u_int	Tools_FacialAnimation_FaceType_MuscleGroup::s_uChunkVersion	= 1;


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : Tools_FacialAnimation_FaceType_MuscleGroup::Tools_FacialAnimation_FaceType_MuscleGroup
// Author       : Andy Tate
// Date         : 9-May-2008
////////////////////////////////////////////////////////////////////////////////

Tools_FacialAnimation_FaceType_MuscleGroup::Tools_FacialAnimation_FaceType_MuscleGroup(const char* szName,
																					   const Asura_FacialAnimation_MuscleGroup::ControlType eControlType)
: m_xName(szName)
, m_eControlType(eControlType)
{
}

/// End of function 'Tools_FacialAnimation_FaceType_MuscleGroup::Tools_FacialAnimation_FaceType_MuscleGroup'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : Tools_FacialAnimation_FaceType_MuscleGroup::Tools_FacialAnimation_FaceType_MuscleGroup
// Author       : Andy Tate
// Date         : 9-May-2008
////////////////////////////////////////////////////////////////////////////////

Tools_FacialAnimation_FaceType_MuscleGroup::Tools_FacialAnimation_FaceType_MuscleGroup(Asura_Chunk_Stream& xStream)
{
	ReadFromChunkStream(xStream);
}

/// End of function 'Tools_FacialAnimation_FaceType_MuscleGroup::Tools_FacialAnimation_FaceType_MuscleGroup'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : Tools_FacialAnimation_FaceType_MuscleGroup::Tools_FacialAnimation_FaceType_MuscleGroup
// Author       : Andy Tate
// Date         : 9-May-2008
////////////////////////////////////////////////////////////////////////////////

Tools_FacialAnimation_FaceType_MuscleGroup::Tools_FacialAnimation_FaceType_MuscleGroup(const Asura_Hash_ID uHash,
																					   Asura_Chunk_Stream& xStream)
{
	ReadFromChunkStream(xStream);
}

/// End of function 'Tools_FacialAnimation_FaceType_MuscleGroup::Tools_FacialAnimation_FaceType_MuscleGroup'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : Tools_FacialAnimation_FaceType_MuscleGroup::ReadFromChunkStream
// Author       : Andy Tate
// Date         : 9-May-2008
////////////////////////////////////////////////////////////////////////////////

void Tools_FacialAnimation_FaceType_MuscleGroup::ReadFromChunkStream(Asura_Chunk_Stream& xStream)
{
	u_int	uVersion;

	// First, read (and verify) the chunk-version.
	xStream >> uVersion;

	switch(uVersion)
	{
		case 1:
		{
			u_int	uControlType;

			xStream >> m_xName;
			xStream >> uControlType;

			m_eControlType	= static_cast<Asura_FacialAnimation_MuscleGroup::ControlType>(uControlType);
			break;
		}

		default:
		{
			Asura_Assertf(false, ("Unexpected chunk-version %d", uVersion));
			break;
		}
	}		// End of switch.
}

/// End of function 'Tools_FacialAnimation_FaceType_MuscleGroup::ReadFromChunkStream'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : Tools_FacialAnimation_FaceType_MuscleGroup::WriteToChunkStream
// Author       : Andy Tate
// Date         : 9-May-2008
////////////////////////////////////////////////////////////////////////////////

void Tools_FacialAnimation_FaceType_MuscleGroup::WriteToChunkStream(Asura_Chunk_Stream& xStream) const
{
	const u_int	uControlType	= m_eControlType;

	// First write the chunk-version...
	xStream << s_uChunkVersion;

	xStream << m_xName;
	xStream << uControlType;
}

/// End of function 'Tools_FacialAnimation_FaceType_MuscleGroup::WriteToChunkStream'. ///

#endif	//defined(ASURA_USE_FACIAL_ANIMATION_SYSTEM)


/// End of file. ///
