//
// Tools_CollBox_Object.h
//
// Created by Richard Rice - 26/03/2004
// 
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_COLLBOX_OBJECT_H_
#define _TOOLS_COLLBOX_OBJECT_H_

#include "Objects/Tools_Object.h"

class Tools_CollBox_Object : public  Tools_Object
{
	public :
		Tools_CollBox_Object(int iModule,u_int uBoxID);
		~Tools_CollBox_Object();

		virtual void UpdatePositionInAsuraData(bool /*bUpdateLinkedObjects*/);

		virtual const char* GetName(){return "Coll Box";}
		virtual const char* GetTypeDescription(){return "Coll Box";}

		virtual void Render();

		virtual void OnSelection();
		virtual void OnDeselection();
		virtual bool IsHidden(){return false;}

		static void DeleteAll();

	private :
		void UpdateBoundingBox();

		struct Asura_Mesh_CollBoxInfo* GetCollisionBox();

		int m_iModuleIndex;
		u_int m_uBoxID;
		Asura_Mesh* m_pxMesh;

		Asura_Bounding_Box m_xBox;
		bool m_bBoxValid;

		static List<Tools_CollBox_Object*> s_xList;
};


#endif //_TOOLS_COLLBOX_OBJECT_H_
