//
// Tools_GUIMenu_Element_FMV.h
//
// Created by Martin Hutchings - 24/03/2009
// 
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_GUIMENU_ELEMENT_FMV_H_
#define _TOOLS_GUIMENU_ELEMENT_FMV_H_
#ifdef ASURA_USE_GUI_MENU_SYSTEM

#include "GUIMenu/Tools_GUIMenu_Element_Image.h"

class Asura_GUIMenu_Element_FMV;

class Tools_GUIMenu_Element_FMV : public Tools_GUIMenu_Element_Image
{
    typedef Tools_GUIMenu_Element_Image PARENT;
public :
	Tools_GUIMenu_Element_FMV(Asura_GUIMenu_Element_FMV* pxAsuraFMV,Tools_GUIMenu_Root* pxToolsParent);
	~Tools_GUIMenu_Element_FMV();

	virtual void Update();
	virtual void RenderUI();
	virtual void OnDeselection();
	virtual bool IsUsingKey(int iKey);
	virtual void Copy(const Tools_GUIMenu_Root* pxSource);

	virtual bool UsesTexture(int iTexture) const;

protected :
	virtual void SetRectangle(const Asura_Bounding_Rectangle& xRect);
	virtual void AddOverlayControls(Asura_Overlay* pxOverlay,Asura_Vector_2& xOffset);
	virtual void UpdateOverlayControls(Asura_Overlay* pxOverlay);
	virtual const char* GetLocalDataFlagName(u_int uFlagValue) const;
	virtual bool IsModifierTypeSupported( ASURA_GUIMENU_MODIFY_TYPE eType ) const;
	virtual void AddModifierOverlayControls(Asura_GUIMenu_Modifier* pxModifier, Asura_Vector_2& xOffset);
	virtual void InitialiseModifier(Asura_GUIMenu_Modifier* pxModifier);
	virtual void CleanupModifierEditing();

	virtual void CopyToAsura();
	virtual void CopyFromAsura();

private :

	void RegisterFMV();

	#define OVERLAY_VOID_CALLBACK(__FnName)\
	static void __FnName(int iThis){((Tools_GUIMenu_Element_FMV*)iThis)->__FnName();}\
	void __FnName();
	#define OVERLAY_BOOL_CALLBACK(__FnName)\
	static bool __FnName(int iThis){return ((Tools_GUIMenu_Element_FMV*)iThis)->__FnName();}\
	bool __FnName();

	OVERLAY_VOID_CALLBACK(SelectFMV);
	OVERLAY_VOID_CALLBACK(PlayFMV);
	OVERLAY_VOID_CALLBACK(StopFMV);
	OVERLAY_VOID_CALLBACK(SelectFMVTextureCallback);

	OVERLAY_BOOL_CALLBACK(CanPlayStop);
	OVERLAY_BOOL_CALLBACK(CanEditFMVFilename);	
	OVERLAY_BOOL_CALLBACK(CanEditLoop);	
	OVERLAY_BOOL_CALLBACK(CanEditSound);	
	OVERLAY_BOOL_CALLBACK(CanEditSoundTrack);	
	OVERLAY_BOOL_CALLBACK(CanCloseWhenComplete);	
	
	#undef OVERLAY_VOID_CALLBACK
	#undef OVERLAY_BOOL_CALLBACK
		
	Asura_GUIMenu_Element_FMV* m_pxAsuraFMV;

	Asura_String m_xFMVName;

	bool m_bFilenameUpdated;
	bool m_bLoop;
	bool m_bSound;
	u_int m_uSoundTrackIndex;

	bool m_bFMVSettingsChanged;
};




#endif //ASURA_USE_GUI_MENU_SYSTEM
#endif //_TOOLS_GUIMENU_ELEMENT_FMV_H_
