//
// Tools_GUIMenu_Menu_Page.h
//
// Created by Richard Rice - 30/11/2006
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif


#ifndef _TOOLS_GUIMENU_MENU_PAGE_H_
#define _TOOLS_GUIMENU_MENU_PAGE_H_
#ifdef ASURA_USE_GUI_MENU_SYSTEM

#include "GUIMenu/Tools_GUIMenu_Root.h"


class Asura_GUIMenu_Menu_Page;

class Tools_GUIMenu_Menu_Page : public Tools_GUIMenu_Root
{
	typedef Tools_GUIMenu_Root PARENT;
	friend class Tools_GUIMenu_PickItem_InitialWidget;

public :
	Tools_GUIMenu_Menu_Page(Asura_GUIMenu_Menu_Page* pxAsuraMenuPage,Tools_GUIMenu_Root* pxToolsParent);

	virtual bool CanBeResized() const {return true;}

	// SK 30.04.07 - added for Gordon Hayes -
	virtual bool CanBeMoved() const {return true;}

	virtual bool CanEditWidth() const;
	virtual bool CanEditHeight() const;

	virtual bool ConfirmDeletion();

	virtual bool IsMenu() const {return true;}
	virtual bool IsValidChildType(int iItemType) const;

	virtual void Copy(const Tools_GUIMenu_Root* pxSource);


	Asura_GUIMenu_Menu_Page* GetAsuraMenu() {return m_pxAsuraMenuPage;}

	virtual void CheckRequiredReferences();

	virtual void Update();

protected :
	virtual void AddOverlayControls(Asura_Overlay* pxOverlay,Asura_Vector_2& xOffset);
	virtual void UpdateOverlayControls(Asura_Overlay* pxOverlay);
	virtual void UpdateReferences(Asura_Hash_ID uOldID,Asura_Hash_ID uNewID,bool bPostCopy);
	virtual const char* GetLocalDataFlagName(u_int uFlagValue) const;

	virtual void SetRectangle(const Asura_Bounding_Rectangle& xRect);

private :

	#define OVERLAY_VOID_CALLBACK(__FnName)\
	static void __FnName(int iThis){((Tools_GUIMenu_Menu_Page*)iThis)->__FnName();}\
	void __FnName();

	OVERLAY_VOID_CALLBACK(EditInitialWidget)
	OVERLAY_VOID_CALLBACK(TransferMenu)

	#undef OVERLAY_VOID_CALLBACK

	#define OVERLAY_BOOL_CALLBACK(__FnName)\
	static bool __FnName(int iThis){return ((Tools_GUIMenu_Menu_Page*)iThis)->__FnName();}\
	bool __FnName();

	OVERLAY_BOOL_CALLBACK(CanEditMenuPageFlags)
	OVERLAY_BOOL_CALLBACK(CanEditOnInitCommand)
	OVERLAY_BOOL_CALLBACK(CanEditOnUpdateCommand)
	OVERLAY_BOOL_CALLBACK(CanEditOnDeInitCommand)

	#undef OVERLAY_BOOL_CALLBACK

	void SetInitialWidget(Tools_GUIMenu_Root* pxItem);


	Asura_Hash_ID m_uStartupWidgetID;

	Asura_GUIMenu_Menu_Page* m_pxAsuraMenuPage;

	bool	m_bCodeDrivenChanged;

};




#endif //ASURA_USE_GUI_MENU_SYSTEM
#endif //_TOOLS_GUIMENU_MENU_PAGE_H_
