//
// Tools_GUIMenu_Widget_Button.h
//
// Created by Richard Rice - 05/12/2006
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif


#ifndef _TOOLS_GUIMENU_WIDGET_BUTTON_H_
#define _TOOLS_GUIMENU_WIDGET_BUTTON_H_
#ifdef ASURA_USE_GUI_MENU_SYSTEM
#include "Interface/Asura_Dialog.h"

#include "Tools_GUIMenu_Widget_Base.h"

//#include "GUIMenu/Tools_GUIMenu_Widget_Base.h"


class Asura_GUIMenu_Widget_Button;

class Tools_GUIMenu_Widget_Button : public Tools_GUIMenu_Widget_Base
{
    typedef Tools_GUIMenu_Widget_Base PARENT;
public :
	Tools_GUIMenu_Widget_Button(Asura_GUIMenu_Widget_Button* pxAsuraButton,Tools_GUIMenu_Root* pxToolsParent);
	virtual ~Tools_GUIMenu_Widget_Button();

	virtual void Update( void);

	int		GetMenuSelectionIndex( void)	{	return m_iHotLinkMenuDropDownIndex;	}
	void	SetMenuSelectionIndex( int iIndex)	{	m_iHotLinkMenuDropDownIndex = iIndex;	}
	
	int		GetWidgetSelectionIndex( void)	{	return m_iHotLinkWidgetDropDownIndex;	}
	void	SetWidgetSelectionIndex( int iIndex)	{	m_iHotLinkWidgetDropDownIndex = iIndex;	}

	Asura_Hash_ID	GetSelectedMenuID( void)	{	return m_hashMenuID;	}
	void			SetSelectedMenuID( Asura_Hash_ID hashID)	{	m_hashMenuID = hashID;	}

	Asura_Hash_ID	GetSelectedWidgetID( void)	{	return m_hashWidgetID;	}
	void			SetSelectedWidgetID( Asura_Hash_ID hashID)	{	m_hashWidgetID = hashID;	}

	Asura_DropDown_List_Dialog* GetWidgetListBoxPtr( void)	{	return m_pxWidgetListBox;	}

	void			SetHotLink( Asura_Hash_ID hashID);
	Asura_Hash_ID	GetHotLink( void);

	virtual void AddToPreviewOverlay() const;

	virtual bool Verify();

	virtual void OnSelection();
	virtual void OnDeselection();

protected:
	virtual void AddOverlayControls(Asura_Overlay* pxOverlay,Asura_Vector_2& xOffset);
	virtual void UpdateOverlayControls(Asura_Overlay* pxOverlay);
	virtual void UpdateReferences(Asura_Hash_ID uOldID,Asura_Hash_ID uNewID,bool bPostCopy);
	virtual u_int GetFlagsToEdit() const;
	virtual const char* GetLocalDataFlagName(u_int uFlagValue) const;

	virtual void Copy(const Tools_GUIMenu_Root* pxSource);

private :
	static bool CanEditButtonLink();
	static bool CanEditButtonFlags();
	static bool CanEditButtonFlagTrapBackKeypress();
	static bool CanEditTimeBeforeAutoclick();

	static void MenuNameListBoxCallBack();
	static void WidgetNameListBoxCallBack();


	Asura_GUIMenu_Widget_Button* m_pxAsuraButton;

	int					 		m_iHotLinkMenuDropDownIndex;
	int					 		m_iHotLinkWidgetDropDownIndex;

	Asura_Hash_ID		 		m_hashMenuID;
	Asura_Hash_ID		 		m_hashWidgetID;

	Asura_DropDown_List_Dialog*  m_pxWidgetListBox;

	bool						m_bMaxActionsChanged;

	static Tools_GUIMenu_Widget_Button* s_pxSelectedButton;
};




#endif //ASURA_USE_GUI_MENU_SYSTEM
#endif //_TOOLS_GUIMENU_WIDGET_BUTTON_H_
