//
// Tools_GUIMenu_Widget_TextBox.h
//
// Created by Richard Rice - 05/12/2006
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif


#ifndef _TOOLS_GUIMENU_WIDGET_TEXTBOX_H_
#define _TOOLS_GUIMENU_WIDGET_TEXTBOX_H_
#ifdef ASURA_USE_GUI_MENU_SYSTEM

#include "GUIMenu/Tools_GUIMenu_Widget_Base.h"


class Asura_GUIMenu_Widget_TextBox;

class Tools_GUIMenu_Widget_TextBox : public Tools_GUIMenu_Widget_Base
{
	typedef Tools_GUIMenu_Widget_Base PARENT;
public :
	Tools_GUIMenu_Widget_TextBox(Asura_GUIMenu_Widget_TextBox* pxAsuraTextBox,Tools_GUIMenu_Root* pxToolsParent);

	virtual void CheckRequiredReferences();
	virtual void AddToPreviewOverlay() const;

protected :
	virtual void AddOverlayControls(Asura_Overlay* pxOverlay,Asura_Vector_2& xOffset);
	virtual const char* GetLocalDataFlagName(u_int uFlagValue) const;
	virtual void Copy(const Tools_GUIMenu_Root* pxSource);
	virtual void Update();

	//Sets some defaults for a newly created menu item
	virtual void InitialiseNewItem();
private :

	#define OVERLAY_BOOL_CALLBACK(__FnName)\
	static bool __FnName(int iThis){return ((Tools_GUIMenu_Widget_TextBox*)iThis)->__FnName();}\
	bool __FnName();

	OVERLAY_BOOL_CALLBACK(CanEditTextEntryDetails)
	OVERLAY_BOOL_CALLBACK(CanEditIsPasswordField)

	#undef OVERLAY_BOOL_CALLBACK


	Asura_GUIMenu_Widget_TextBox* m_pxAsuraTextBox;
	u_int m_uMaxTextEntryLength;
};




#endif //ASURA_USE_GUI_MENU_SYSTEM
#endif //_TOOLS_GUIMENU_WIDGET_TEXTBOX_H_
