//
// Tools_GUIMenu_XMLExporter.cpp
//
// Created by HE - 10 May 2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

// This file's header.
#include "GUIMenu/Tools_GUIMenu_XMLExporter.h"

#ifdef ASURA_USE_GUI_MENU_SYSTEM

// asura
#include "Core/Memory/Asura_Mem.h"
#include "Debugging/Asura_Assert.h"
#include "Debugging/Asura_Logfile.h"
#include "GUIMenu/Asura_GUIMenu_Menu_Page.h"

//tools
#include "GUIMenu/Tools_GUIMenu_Root.h"
#include "Tools_Mode_GUIMenu.h"

//libs
#include <stdarg.h>
#include <errno.h>
#include "Misc/list_tem.hpp"

const int iTABARRAYSIZE = 100;
const u_int uDEFAULTMAXBUFFERSIZE = 65536;

void Tools_GUIMenu_XMLExporter::StartXMLExport( const Asura_GUIMenu_Menu_Page* pxMenuPage )
{
	//export one menu file and write it to XML
	pxMenuPage->ExportToXMLStart( this );
}

char* Tools_GUIMenu_XMLExporter::MapObjectTypesToName( u_int uType )
{
	switch( uType )
	{
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_MENUPAGE:
		{
			return "MenuPage";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_ELEMENT_IMAGE:
		{
			return "Image";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_ELEMENT_TEXT:
		{
			return "Text";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_ELEMENT_PATH:
		{
			return "Path";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_ELEMENT_ANIMATION:
		{
			return "Animation";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_ELEMENT_STATUSTEXT:
		{
			return "StatusText";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_ELEMENT_FMV:
		{
			return "FMV";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_WIDGET_BUTTON:
		{
			return "Button";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_WIDGET_CHECKBOX:
		{
			return "CheckBox";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_WIDGET_SLIDER:
		{
			return "Slider";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_WIDGET_TEXTBOX:
		{
			return "TextBox";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_WIDGET_TEXTLISTBOX:
		{
			return "TextListBox";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_WIDGET_GROUP:
		{
			return "Group";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_WIDGET_ANIMATINGIMAGE:
		{
			return "AnimatingImage";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_WIDGET_PROGRESSBAR:
		{
			return "ProgressBar";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_WIDGET_NUMERIC:
		{
			return "Numeric";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_WIDGET_LISTBOX:
		{
			return "ListBox";
		}
		case Asura_GUIMenu_Root::ASURA_GUIMENU_TYPEID_WIDGET_LISTBOXENTRY:
		{
			return "ListBoxEntry";
		}
		default:
		{
			Asura_Assert(false, "Unknown element type, has Tools_GUIMenu_XMLExporter::MapObjectTypesToName() been kept up to date?");
			return "Unknown_Type";
		}
	}
}

#endif // ASURA_USE_GUI_MENU_SYSTEM
