//
// Tools_HelperObject_System.h
//
// Created by Richard Rice - 01/09/2006
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_HELPEROBJECT_SYSTEM__
#define __TOOLS_HELPEROBJECT_SYSTEM__

#ifdef ASURA_MAIN
#include "Core/Asura_String.h"
#endif

template<class T> class List;
class Tools_HelperObject;

class Tools_HelperObject_System
{
public :
	static void Initialise();
	static void Shutdown();

	static Tools_HelperObject* AllocateHelperObject();
	static void DeleteHelperObject(Tools_HelperObject* pxHelper);

	//Loads all the helper object files in the same directory as the asura file
	static void Load(const char* szAsuraFilename);

	static const List<Tools_HelperObject*>* GetList();

	#ifdef ASURA_MAIN
	//returns true if any sound event files are modified
	static bool IsModified();	
	//Save all sound event files (plus mixers)
	static void SaveAll();
	//save all files marked as modified
	static void SaveModified();

	static void SetModified(Tools_HelperObject*);

	static bool CanSaveToFile(const char* szName);
	#endif


private :
	#ifdef ASURA_MAIN
	static void Load();

	//adds path and extension to get full filename
	static void GetFullFilename(const char* szFilename,char* szBuffer,int iBufferSize);

	static bool SaveFile(const char* szFilename);
  	#endif

	static List<Tools_HelperObject*> s_xList;
	static bool s_bLoaded;

	#ifdef ASURA_MAIN
	static List<Asura_String> s_xModifiedFiles;
	#endif
};


#endif //__TOOLS_HELPEROBJECT_SYSTEM__