//
// Tools_Dialog_PickSkin.h
//
// Created by Richard Rice - 10/12/2008
// 
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_DIALOG_PICKSKIN_H__
#define __TOOLS_DIALOG_PICKSKIN_H__

#include "Interface/Asura_Dialog.h"

//Dialog that shows a button for selecting a skin.
class Tools_Dialog_PickSkin : public Asura_Function_Dialog
{
public :
	//szPrefix is a prefix added before the skin name on the dialog
	//puSkinID is a pointer to the hash ID being edited
	//pbModified is an optional flag that will be set to true whenever the hash value is modified.
	Tools_Dialog_PickSkin(const char* szPrefix,const Asura_Vector_2& xOffset,Asura_Hash_ID* puSkinID,bool* pbModified = 0);
	//Variation for affecting multiple selected objects
	Tools_Dialog_PickSkin(const char* szPrefix,const Asura_Vector_2& xOffset,Asura_Dialog_SharedValue<Asura_Hash_ID>* puSharedSkinID,bool* pbModified = 0);
private :
	virtual void PerFrameUpdate();

	void UpdateText();

	static void OnClicked(int iThis){((Tools_Dialog_PickSkin*)iThis)->OnClicked();}
	void OnClicked();

	Asura_Hash_ID GetSkinID(bool* pbMixedValue = 0) const;
	void SetSkinID(Asura_Hash_ID uSkinID);

	Asura_String m_xPrefix;
	Asura_Hash_ID* m_puSkinID;
	Asura_Dialog_SharedValue<Asura_Hash_ID>* m_puSharedSkinID;
	Asura_Hash_ID m_uSkinIDBackup;
	bool* m_pbModified;
};



#endif //__TOOLS_DIALOG_PICKSKIN_H__
