//////////////////////////////////////////////////////////////////////////////
//
// Tools_Tim2_Swizzler.h
//
// Copyright (c) 2003 Victor Suba / Eutechnyx Ltd.
// Portions copyright (c) 2003 SCEE.
// Portions copyright (c) 2003 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___TOOLS_TIM2_SWIZZLER_H___
#define ___TOOLS_TIM2_SWIZZLER_H___ 1

// B E G I N   N A M E S P A C E /////////////////////////////////////////////

namespace Tools_Tim2_Swizzler
{

// P R O T O T Y P E S   A N D   I N L I N E   F U N C T I O N S /////////////

// Display buffer modes
void writeTexPSMCT32(int dbp, int dbw, int dsax, int dsay, int rrw, int rrh, const void *pvSrc );
void readTexPSMCT32(int dbp, int dbw, int dsax, int dsay, int rrw, int rrh, void *pvDest);

void writeTexPSMCT16(int dbp, int dbw, int dsax, int dsay, int rrw, int rrh, const void *pvSrc);
void readTexPSMCT16(int dbp, int dbw, int dsax, int dsay, int rrw, int rrh, void *pvDest);

void writeTexPSMCT16S(int dbp, int dbw, int dsax, int dsay, int rrw, int rrh, const void *pvSrc);
void readTexPSMCT16S(int dbp, int dbw, int dsax, int dsay, int rrw, int rrh, void *pvDest);

// Z Buffer modes
void writeTexPSMZ32(int dbp, int dbw, int dsax, int dsay, int rrw, int rrh, const void *pvSrc);
void readTexPSMZ32(int dbp, int dbw, int dsax, int dsay, int rrw, int rrh, void *pvDest);

void readTexPSMZ16(int dbp, int dbw, int dsax, int dsay, int rrw, int rrh, const void *pvSrc);
void writeTexPSMZ16(int dbp, int dbw, int dsax, int dsay, int rrw, int rrh, void *pvDest);

void readTexPSMZ16S(int dbp, int dbw, int dsax, int dsay, int rrw, int rrh, const void *pvSrc);
void writeTexPSMZ16S(int dbp, int dbw, int dsax, int dsay, int rrw, int rrh, void *pvDest);

// Texture modes
void writeTexPSMT8(int dbp, int dbw, int dsax, int dsay, int rrw, int rrh, const void *pvSrc);
void readTexPSMT8(int dbp, int dbw, int dsax, int dsay, int rrw, int rrh, void *pvDest);

void writeTexPSMT4(int dbp, int dbw, int dsax, int dsay, int rrw, int rrh, const void *pvSrc);
void readTexPSMT4(int dbp, int dbw, int dsax, int dsay, int rrw, int rrh, void *pvDest);

// E N D   N A M E S P A C E /////////////////////////////////////////////////

}; // namespace Tools_Tim2_Swizzler

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___TOOLS_TIM2_SWIZZLER_H___
