//
// Tools_WindowsCursor.cpp
//
// Created by Richard Rice - 16/06/2008
// 
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"
#include "Interface/Tools_WindowsCursor.h"

Tools_WindowsCursorType Tools_WindowsCursor::s_eCursor = TOOLS_CURSOR_DEFAULT;
Tools_WindowsCursorType Tools_WindowsCursor::s_ePrevCursor = TOOLS_CURSOR_DEFAULT;


void Tools_WindowsCursor::SetCursor(Tools_WindowsCursorType eCursor)
{
	s_eCursor = eCursor;
}

void Tools_WindowsCursor::Update()
{
	//test
	#define USE_MAX_CURSOR 0
	#if USE_MAX_CURSOR
	static HCURSOR hScale = LoadCursorFromFile("graphics\\tools\\cursor\\Scale.cur");
	static HCURSOR hRotate = LoadCursorFromFile("graphics\\tools\\cursor\\Rotate.cur");
	static HCURSOR hCrosshair = LoadCursorFromFile("graphics\\tools\\cursor\\Crosshair.cur");
	static HCURSOR hFourArrow = LoadCursorFromFile("graphics\\tools\\cursor\\FourArrow.cur");
	#endif
	
	switch(s_eCursor)
	{
		default :
		case TOOLS_CURSOR_DEFAULT :
			if(s_ePrevCursor != TOOLS_CURSOR_DEFAULT)
			{
				::SetCursor(LoadCursor(0,IDC_ARROW));
			}
			break;
		case TOOLS_UVEDITCURSOR_SINGLESELECT :
			#if USE_MAX_CURSOR
			::SetCursor(hCrosshair);
			#else
			::SetCursor(LoadCursor(0,IDC_CROSS));
			#endif
			break;
		case TOOLS_CURSOR_ROTATE :
			#if USE_MAX_CURSOR
			::SetCursor(hRotate);
			#else
			::SetCursor(LoadCursor(0,IDC_NO));
			#endif
			break;
		case TOOLS_CURSOR_MOVE :
			#if USE_MAX_CURSOR
			::SetCursor(hFourArrow);
			#else
			::SetCursor(LoadCursor(0,IDC_SIZEALL));
			#endif
			break;
		case TOOLS_CURSOR_MOVELARGE :
			::SetCursor(LoadCursor(0,IDC_SIZEALL));
			break;
		case TOOLS_CURSOR_SCALE :
			#if USE_MAX_CURSOR
			::SetCursor(hScale);
			#else
			::SetCursor(LoadCursor(0,IDC_WAIT));
			#endif
			break;
		case TOOLS_CURSOR_PAN :
			::SetCursor(LoadCursor(0,IDC_HAND));
			break;
		case TOOLS_CURSOR_RESIZE_H :
			::SetCursor(LoadCursor(0,IDC_SIZEWE));
			break;
		case TOOLS_CURSOR_RESIZE_V :
			::SetCursor(LoadCursor(0,IDC_SIZENS));
			break;
		case TOOLS_CURSOR_RESIZE_TL_BR :
			::SetCursor(LoadCursor(0,IDC_SIZENWSE));
			break;
		case TOOLS_CURSOR_RESIZE_TR_BL :
			::SetCursor(LoadCursor(0,IDC_SIZENESW));
			break;
	}

	s_ePrevCursor = s_eCursor;
	s_eCursor = TOOLS_CURSOR_DEFAULT;
}
