//
// Tools_LightingTest_Object.h
//
// Created by Richard Rice - 14/03/2003
// 
// Copyright (C) 2003 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_LIGHTINGTEST_OBJECT_H_
#define _TOOLS_LIGHTINGTEST_OBJECT_H_

#include "Objects/Tools_Object.h"

class Asura_Animation;

class Tools_LightingTest_Object : public Tools_Object
{
	public :
		Tools_LightingTest_Object(const Asura_Vector_3* pxPosition,const Asura_Matrix_3x3* pxOrientaiton);
		~Tools_LightingTest_Object();

		virtual void Render();
		virtual bool UseLighting(){return true;}

		virtual const char* GetName(){return "Lighting Test";}
		virtual const char* GetTypeDescription(){return "Lighting Test";}

		virtual void OnSelection();
		virtual void OnDeselection();
//		virtual void UpdateWhileSelected();
		
	private :
		void CreateOverlay();
		void DeleteOverlay();

		static void ChooseSkin(int iThis){((Tools_LightingTest_Object*)iThis)->ChooseSkin();}
		void ChooseSkin();

		static void ChooseAnimation(int iThis){((Tools_LightingTest_Object*)iThis)->ChooseAnimation();}
		void ChooseAnimation();


		Asura_Animation* m_pxAnimation;

		static Asura_Vector_2 s_xOverlayPosition;

};


#endif //_TOOLS_LIGHTINGTEST_OBJECT_H_
