//
// Tools_PhotonMapping_VertexSampleStamp.cpp
//
// Created by KJFL - 2004-06-14 16:06:02
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

// This file's header.
#include "Lighting/Tools_PhotonMapping_VertexSampleStamp.h"
#include "Rendering/Asura_Module.h"
#include "Mesh/Asura_Mesh.h"

u_int	Tools_PhotonMapping_VertexSampleStamp::s_uCurrentSample  = 0;
u_int**	Tools_PhotonMapping_VertexSampleStamp::s_ppuSampleStamp = NULL;


void Tools_PhotonMapping_VertexSampleStamp::Initialise( void )
{
	u_int uNumberOfModules = Asura_Module_System::GetNumberOfModules();

	s_ppuSampleStamp = new u_int*[uNumberOfModules];

	for(u_int u=0; u<uNumberOfModules; u++)
	{
		s_ppuSampleStamp[u] = new u_int[Asura_Module_System::GetMeshForModule(u)->NumberOfVertices];
	}

}

void Tools_PhotonMapping_VertexSampleStamp::Shutdown( void )
{
	u_int uNumberOfModules = Asura_Module_System::GetNumberOfModules();

	for(u_int u=0; u<uNumberOfModules; u++)
	{
		delete [] s_ppuSampleStamp[u];
	}

	delete [] s_ppuSampleStamp;
	s_ppuSampleStamp = NULL;
}

void Tools_PhotonMapping_VertexSampleStamp::Reset( void )
{
	u_int uNumberOfModules = Asura_Module_System::GetNumberOfModules();

	u_int** ppuSampleStamp = s_ppuSampleStamp;
	if( NULL != ppuSampleStamp)
	{
		for(u_int u=0; u<uNumberOfModules; u++)
		{
			u_int* puSampleStamp = ppuSampleStamp[ u];
			if( NULL != puSampleStamp)
			{
				memset(puSampleStamp,0,Asura_Module_System::GetMeshForModule(u)->NumberOfVertices * sizeof(u_int));
			}
		}
	}

	s_uCurrentSample = 0;
}

