//////////////////////////////////////////////////////////////////////////////
//
// Tools_LipSync.h
//
// Created by Stuart Middleton - 20 June 2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLS_LIPSYNC_H__
#define __TOOLS_LIPSYNC_H__

#ifdef ASURA_USE_ARTICULATION_SYSTEM

#include "Annosoft/lib/liblipsync.h"
#include "Core/Asura_LocalisedText.h"

class Asura_LipSync_Articulation;
class IPhnMixtureArticulator;
class Asura_Dialogue_Line;

class Tools_LipSync
{

	friend class Asura_Chunk_LipSync;

public:
	static void Initialise();
	static void Shutdown();
	static void CreateArticulationData(const Asura_Dialogue_Line* pxDialogueLine, const Asura_Hash_ID uHash, bool bTextless, bool bRegen = false);
protected:
	static void GetLanguageVersionOfPath(char* szNew, const char* szOrig, int iLanguage);
private:
	static char* ReadTextFileIntoMemory(char* szFilename, long& nBytes);
	static Asura_LipSync_Articulation* CreateArticulationFromAnnosoftPhonemeData(IPhnMixtureArticulator* pxArt, Asura_Hash_ID uHash);
	static bool DoesFileExist(char* szFilename);
	static void CreateFolder(char* szFolderName);
	static bool GetFullPath(char* szFilename, char* szFullPathName, char* AddPath, bool bLocal);

	static char* g_pszLexData[ASURA_LT_L_NUM_LANGUAGES];
};

#endif

#endif

