#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_OPTIONSFILE_H_
#define __TOOLS_OPTIONSFILE_H_

#include "Core/Asura_String.h"

//for saving/loading a text file containing some preferences for the tools

class Tools_OptionsFile
{
	public :
		Tools_OptionsFile();
		~Tools_OptionsFile();
		static void Load();
		static void Save();

		// The display settings need to be loaded before the D3D device is created, which might not happen if they're just in Load()
		static void LoadDisplaySettings();

		//Need to get the subwindow flag even earlier ,since the switching back and forth is slightly flawed
		static void LoadSubwindowFlag(bool& bSubwindowFlag);

	
		static Tools_OptionsFile* GetThis(){return s_pxThis;}
	protected:
		//function for reading values of the form 'identifier = value'
		//(may move these elsewhere if/when I need to do other text files)
		static bool GetStringFromIniFileBuffer(const char* identifier,const char* buffer,Asura_String& output);
		static bool GetBoolFromIniFileBuffer(const char* identifier,const char* buffer,bool& output);
		static bool GetIntFromIniFileBuffer(const char* identifier,const char* buffer,int& output);
		static bool GetFloatFromIniFileBuffer(const char* identifier,const char* buffer,float& output);
	private :
		// (AW - 18.09.2003) - Virtual functions for adding project-specific data to options file.
		virtual void LoadProjectSpecificOptions(const char *pcBuffer) {}
		virtual void SaveProjectSpecificOptions(FILE* pxFile) {}
		static Tools_OptionsFile* s_pxThis;
};


#define ToolsIniDataDirectory "ToolsIniData"

#endif //__TOOLS_OPTIONSFILE_H_
