//
// Tools_CharacterProcessor.h
//
// Created by BM - 18/03/2003 12:37:07
//
// Copyright (C) 2003 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __TOOLS_CHARACTERPROCESSOR_H__
#define __TOOLS_CHARACTERPROCESSOR_H__

#include "Core/Asura_Maths.h"
class Asura_Mesh;
class Asura_Hierarchy_Skin;

class Tools_CharacterProcessor_Vertex
{
	public:
		float 			m_X;
		float			m_Y;
		float			m_Z;
		float			m_NX;
		float			m_NY;
		float			m_NZ;
		float			m_fU;
		float			m_fV;
		float			m_acIndex[4];
		float			m_afWeight[4];

		inline bool operator == ( const Tools_CharacterProcessor_Vertex& v) const
		{
		    if (  (m_X  == v.m_X)
				&& (m_Y == v.m_Y)
				&& (m_Z == v.m_Z)
				&& (m_NX == v.m_NX)
				&& (m_NY == v.m_NY)
				&& (m_NZ == v.m_NZ)
				&& (m_fU == v.m_fU)
				&& (m_fV == v.m_fV)
				&& (m_acIndex[0] == v.m_acIndex[0])
				&& (m_acIndex[1] == v.m_acIndex[1])
				&& (m_acIndex[2] == v.m_acIndex[2])
				&& (m_acIndex[3] == v.m_acIndex[3])
				&& (m_afWeight[0] == v.m_afWeight[0])
				&& (m_afWeight[1] == v.m_afWeight[1])
				&& (m_afWeight[2] == v.m_afWeight[2])
				&& (m_afWeight[3] == v.m_afWeight[3])
			  )
			{
				return true;
			}

			return false;
		}



};

class Tools_CharacterProcessor_Strip
{
	public:
		
		Tools_CharacterProcessor_Strip()
		{
			m_pxVertices = 0;
			m_pusIndices = 0;
		}
		
		~Tools_CharacterProcessor_Strip()
		{
			delete [] m_pxVertices;
			delete [] m_pusIndices;
		}

		u_int								m_uNumberOfIndices;
		u_int								m_uNumberOfTriangles;
		u_int								m_uNumberOfVertices;
											
		int									m_iMaterialID;

		Tools_CharacterProcessor_Vertex*	m_pxVertices;
		u_short*							m_pusIndices;
};



class Tools_CharacterProcessor
{
	public:
		static bool Initialise(Asura_Mesh* mesh,const Asura_Hierarchy_Skin* skin);
		static void Shutdown(void);

		static const Tools_CharacterProcessor_Strip* GetProcessedStrip();
		static u_int GetTotalNumberOfVertices(void);
		static u_int GetTotalNumberOfIndices(void);
		
		static Tools_CharacterProcessor_Strip*	s_pxProcessedStrip;
		static u_int							s_uTotalNumberOfVertices;
		static u_int							s_uTotalNumberOfIndices;
		static bool								s_bBeenInitialised;
	private:
};





#endif//__TOOLS_CHARACTERPROCESSOR_H__
