//////////////////////////////////////////////////////////////////////////////
//
// Tools_SmoothSkin_Processor_PS2.h
//
// Copyright (c) 2004 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___TOOLS_SMOOTHSKIN_PROCESSOR_PS2_H___
#define ___TOOLS_SMOOTHSKIN_PROCESSOR_PS2_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

// Stdlib platform-specific.
#include <windows.h>

// Tools.
#include "PS2/PS2Strip/NVTriStrip/NvTriStripObjects.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Tools_PS2_DMAChainWriter;
class Tools_SmoothSkin_Processor;
class Tools_SmoothSkin_SubElement;

// C L A S S E S /////////////////////////////////////////////////////////////

class Tools_SmoothSkin_PS2_Processor
{

    public:

        // C O N S T R U C T O R S   /   D E S T R U C T O R S ///////////////
        
        Tools_SmoothSkin_PS2_Processor( void );
        ~Tools_SmoothSkin_PS2_Processor( void );

        // M E T H O D S /////////////////////////////////////////////////////

        // Initialisation.
        bool Initialise( const Tools_SmoothSkin_Processor* pxSrcProcessor );
        void SetUVScales( float fUScale, float fVScale );
        
        // Output.
        bool OutputToChunk( HANDLE pvFile, const char *szSkinName ) const;

        // Query.
        u_int GetMaxStripLength( void ) const { return m_uMaxStripLength; }
        const Tools_SmoothSkin_Processor* GetSrcProcessor( void ) const { return m_pxSrcProcessor; }

    private:

        // F O R W A R D   D E C L A R A T I O N S ///////////////////////////

        class SubElementStripData;

        // M E T H O D S /////////////////////////////////////////////////////

        bool OutputStripDataChain( Tools_PS2_DMAChainWriter& xChainWriter, const SubElementStripData& xSubElementStripData ) const;

        // S T A T E /////////////////////////////////////////////////////////

        const Tools_SmoothSkin_Processor* m_pxSrcProcessor;

        u_int                             m_uMaxStripLength;
        SubElementStripData*              m_pxStripData;

        u_int*                            m_puSortedMaterials;

        float                             m_fUScale;
        float                             m_fVScale;

};
// End class Tools_SmoothSkin_PS2_Processor.

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___TOOLS_SMOOTHSKIN_PROCESSOR_PS2_H___
