//
// Tools_SmoothSkin_Processor_Wii.h
//
// Created by KOR - 09 January 2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLS_SMOOTHSKIN_PROCESSOR_WII_H__
#define __TOOLS_SMOOTHSKIN_PROCESSOR_WII_H__

class Tools_SmoothSkin_Processor;
class Tools_SmoothSkin_Processor_Wii_Strip;
class Asura_Chunk_Stream;
class Tools_Wii_DisplayListFactory;

class Tools_SmoothSkin_Processor_Wii_Strip
{
public:
	Tools_SmoothSkin_Processor_Wii_Strip()
		: m_uNumIndices(0)
		, m_pusIndices(NULL)
		, m_uMaxIndex(0)
		, m_iElementID(0)
	{
	}
	~Tools_SmoothSkin_Processor_Wii_Strip()
	{
		delete [] m_pusIndices;
	}

	u_int		m_uNumIndices;
	u_short*	m_pusIndices;
	u_int		m_uMaxIndex;
	int			m_iElementID;
};


class Tools_SmoothSkin_Wii_Processor
{
public:
	static Tools_Wii_DisplayListFactory * const s_pxDefaultDisplayListFactory;
	typedef void (*PROJECT_EXPORT_COLOUR_FN) (Asura_Chunk_Stream& xStream, const Tools_SmoothSkin_Processor* pxSrcProcessor);
	typedef int (*PROJECT_ID_OVERRIDE_FN) (const Tools_SmoothSkin_Processor *pProcessor, u_int uElement);

	bool OutputToChunk(const Tools_SmoothSkin_Processor* pxSrcProcessor, HANDLE hFile) const;
	static void SetProjectExportColourFunction(PROJECT_EXPORT_COLOUR_FN pfnFunction) { s_pfnColourExportFunction = pfnFunction; }
	static PROJECT_EXPORT_COLOUR_FN GetProjectExportColourFunction() { return s_pfnColourExportFunction; }
	static void SetProjectIDOverrideFunction(PROJECT_ID_OVERRIDE_FN pfnFunction) { s_pfnIDOverrideFunction = pfnFunction; }
	static void SetProjectDisplayListFactory(Tools_Wii_DisplayListFactory *pFactory) { s_pxDisplayListFactory = pFactory; }
	static void SetIncludeNormals(bool bIncludeNormals) { s_bIncludeNormals = bIncludeNormals; }
	static bool GetIncludeNormals() { return s_bIncludeNormals; }
	static const Tools_SmoothSkin_Processor_Wii_Strip* GetStrips() { return m_pxStrips; }
private:
	static Tools_Wii_DisplayListFactory *s_pxDisplayListFactory;
	static PROJECT_EXPORT_COLOUR_FN s_pfnColourExportFunction;
	static PROJECT_ID_OVERRIDE_FN s_pfnIDOverrideFunction;
	static Tools_SmoothSkin_Processor_Wii_Strip* m_pxStrips;
	static bool s_bIncludeNormals;
};

#endif//__TOOLS_SMOOTHSKIN_PROCESSOR_WII_H__