//
// Tools_Dialog.h
//
// Created by Richard Rice - 19/07/2002
// 
// Copyright (C) 2002 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_DIALOG_H__
#define __TOOLS_DIALOG_H__

#include "Interface/Asura_Dialog.h"

class Tools_Value_List;

class Asura_Overlay;

/*
Dialog used for choosing a value from an enumeration list.
*/

class Tools_Enumeration_Dialog : public Asura_Dialog
{
public :
	Tools_Enumeration_Dialog(const char* title,Asura_Vector_2 offset,int* value,Tools_Value_List* enumerationList,bool* pbModifiedFlag = 0);


private :
	void Update(const Asura_Vector_2& origin);
	void UpdateLabel(const char* text);

	void ChooseEnumerationValue();
	static void DialogClicked();



	Asura_String Title;
	bool Clicked;
	int* Value;
	Tools_Value_List* EnumerationList;
	bool* m_pbModifiedFlag;

	static Tools_Enumeration_Dialog* ClickedDialog;


};

class Tools_Dialog
{
public :
	//Get the index of the texture for use with Asura_Icon_Dialog
	static int GetIconTexture();
};

enum TOOLS_ICON
{
	TOOLS_ICON_DELETE,
	TOOLS_ICON_EYEDROP1,
	TOOLS_ICON_EYEDROP3,
	TOOLS_ICON_EYEDROP5,
	TOOLS_ICON_PADLOCK,
	TOOLS_ICON_DOUBLEARROW,
	TOOLS_ICON_SCALES,
	TOOLS_ICON_UNDO,
	TOOLS_ICON_REDO,
	TOOLS_ICON_GRAPH_SNAPLEFTEND,
	TOOLS_ICON_GRAPH_SNAPRIGHTEND,
	TOOLS_ICON_ARROW_UP,
	TOOLS_ICON_ARROW_DOWN,
	TOOLS_ICON_REFRESH,
	TOOLS_ICON_COPY,
	TOOLS_ICON_PASTE,
	TOOLS_ICON_A = 16,
	TOOLS_ICON_Z = TOOLS_ICON_A+25,

	TOOLS_ICON_UVEDIT_MOVE = 48,
	TOOLS_ICON_UVEDIT_ROTATE,
	TOOLS_ICON_UVEDIT_SCALE,
	TOOLS_ICON_UVEDIT_FREEFORM,
	TOOLS_ICON_UVEDIT_MIRROR_HORI,
	TOOLS_ICON_UVEDIT_MIRROR_VERT,
	TOOLS_ICON_UVEDIT_ZOOMEXTENT,
	TOOLS_ICON_UVEDIT_VERTEX,
	TOOLS_ICON_UVEDIT_EDGE,
	TOOLS_ICON_UVEDIT_POLYGON,
	TOOLS_ICON_UVEDIT_EDITPRIMARY,
	TOOLS_ICON_UVEDIT_EDITSECONDARY,
	TOOLS_ICON_UVEDIT_SHOWALLCHANNEL,

	TOOLS_ICON_NEW = 64
};



#endif // __TOOLS_DIALOG_H__
