#ifdef ASURA_USE_AXON
//////////////////////////////////////////////////////////////////////////////
//
// Tools_Object_Axon_ChooseObjects.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLS_OBJECT_AXON_CHOOSEOBJECTS_H__
#define __TOOLS_OBJECT_AXON_CHOOSEOBJECTS_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// tools
#include "Objects/Tools_Object.h"
#include "Objects/Tools_Object_System.h"

//////////////////////////////////////////////////////////////////////////////
//
// Tools_Object_Axon_ChooseObjects
//
//////////////////////////////////////////////////////////////////////////////

class Tools_ChooseObject_GS2Base : public Tools_ChooseObject
{
public:
	Tools_ChooseObject_GS2Base( Asura_Guid* puGuidToSet, bool* bChanged = NULL )
	: m_xGuidsToIgnore()
	, m_puGuidToSet( puGuidToSet )
	, m_pfnOnChosenGuid( NULL )
	, m_pfnOnChosenIntGuid( NULL )
	, m_iUserData( 0 )
	, m_pbChanged( bChanged )
	{}
	Tools_ChooseObject_GS2Base( void( *pfnOnChosen )( Asura_Guid ), bool* bChanged = NULL )
	: m_xGuidsToIgnore()
	, m_puGuidToSet( NULL )
	, m_pfnOnChosenGuid( pfnOnChosen )
	, m_pfnOnChosenIntGuid( NULL )
	, m_iUserData( 0 )
	, m_pbChanged( bChanged )
	{}
	Tools_ChooseObject_GS2Base( void( *pfnOnChosen )( int, Asura_Guid ), const int iUserData, bool* bChanged = NULL )
	: m_xGuidsToIgnore()
	, m_puGuidToSet( NULL )
	, m_pfnOnChosenGuid( NULL )
	, m_pfnOnChosenIntGuid( pfnOnChosen )
	, m_iUserData( iUserData )
	, m_pbChanged( bChanged )
	{}

	void AddGuidToIgnore( const Asura_Guid uGuid ) { m_xGuidsToIgnore.Push_Back( uGuid ); }

	virtual bool CanBeSelected( Tools_Object* pxObject );
	virtual void ObjectSelected( Tools_Object* pxObject );

private:
	Asura_LinkList< Asura_Guid > m_xGuidsToIgnore;

	Asura_Guid* m_puGuidToSet;
	void		( *m_pfnOnChosenGuid )( Asura_Guid );
	void		( *m_pfnOnChosenIntGuid )( int, Asura_Guid );
	const int   m_iUserData;
	bool*       m_pbChanged;
};

class Tools_ChooseObject_GS2Node : public Tools_ChooseObject_GS2Base
{
public:
	Tools_ChooseObject_GS2Node( Asura_Guid* puGuidToSet, bool* bChanged = NULL ) : Tools_ChooseObject_GS2Base( puGuidToSet, bChanged ) {}
	Tools_ChooseObject_GS2Node( void( *pfnOnChosen )( Asura_Guid ), bool* bChanged = NULL ) : Tools_ChooseObject_GS2Base( pfnOnChosen, bChanged ) {}
	Tools_ChooseObject_GS2Node( void( *pfnOnChosen )( int, Asura_Guid ), const int iUserData, bool* bChanged = NULL ) : Tools_ChooseObject_GS2Base( pfnOnChosen, iUserData, bChanged ) {}

	virtual bool CanBeSelected( Tools_Object* pxObject );
};

class Tools_ChooseObject_GS2AttractorTarget : public Tools_ChooseObject_GS2Base
{
public:
	Tools_ChooseObject_GS2AttractorTarget( Asura_Guid* puGuidToSet, bool* bChanged = NULL ) : Tools_ChooseObject_GS2Base( puGuidToSet, bChanged ) {}
	Tools_ChooseObject_GS2AttractorTarget( void( *pfnOnChosen )( Asura_Guid ), bool* bChanged = NULL ) : Tools_ChooseObject_GS2Base( pfnOnChosen, bChanged ) {}
	Tools_ChooseObject_GS2AttractorTarget( void( *pfnOnChosen )( int, Asura_Guid ), const int iUserData, bool* bChanged = NULL ) : Tools_ChooseObject_GS2Base( pfnOnChosen, iUserData, bChanged ) {}

	virtual bool CanBeSelected( Tools_Object* pxObject );
};

class Tools_ChooseObject_GS2Spline : public Tools_ChooseObject_GS2Base
{
public:
	Tools_ChooseObject_GS2Spline( Asura_Guid* puGuidToSet, bool* bChanged = NULL ) : Tools_ChooseObject_GS2Base( puGuidToSet, bChanged ) {}
	Tools_ChooseObject_GS2Spline( void( *pfnOnChosen )( Asura_Guid ), bool* bChanged = NULL ) : Tools_ChooseObject_GS2Base( pfnOnChosen, bChanged ) {}
	Tools_ChooseObject_GS2Spline( void( *pfnOnChosen )( int, Asura_Guid ), const int iUserData, bool* bChanged = NULL ) : Tools_ChooseObject_GS2Base( pfnOnChosen, iUserData, bChanged ) {}

	virtual bool CanBeSelected( Tools_Object* pxObject );
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__TOOLS_OBJECT_AXON_CHOOSEOBJECTS_H__
#endif // ASURA_USE_AXON