//
// Tools_SpecialGuid_Object.h
//
// Created by Richard Rice - 19/04/2006
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//


#include "Core/Asura.h"
#include "Objects/Tools_SpecialGuid_Object.h"

//asura
#include "Mesh/Asura_Env_System.h"
#include "Mesh/Asura_Env.h"
#include "Mesh/Asura_Mesh_System.h"

//tools
#include "Entity/Tools_Message_Editing.h"

//Static Data
Asura_Hashed_List<Tools_SpecialGuid_Object> Tools_SpecialGuid_Object::s_xList( 2 );
u_int Tools_SpecialGuid_Object::s_uNumObjects = 0;

Tools_SpecialGuid_Object::Tools_SpecialGuid_Object(Asura_Guid uGuid,const char* szName,const char* szMeshName)
:Tools_Object(TOT_SpecialGuid)
{
	s_uNumObjects++;

	m_xName = szName;
	m_uGuid = uGuid;

	//find the mesh to use
	Asura_Mesh* pxMesh = 0;
	if(szMeshName)
	{
		pxMesh = Asura_Mesh_System::GetMesh(szMeshName);
	}
	if(!pxMesh) pxMesh = Asura_Mesh_System::GetMesh("ToolsShape_CutsceneEvent");
	SetMesh(pxMesh);

    s_xList.AddToList( this );

	//determine a default location
	//place near the start position , and offset according to the number of objects that exist
	Position = Asura_Environment_System::GetEnvironment()->GetStartPosition();
	Position.y -= 2.0f;
	Position.z += (float)s_uNumObjects - 1.0f;
}

Tools_SpecialGuid_Object::~Tools_SpecialGuid_Object()
{
	s_uNumObjects--;
	s_xList.RemoveFromList( this );
}

bool Tools_SpecialGuid_Object::HandlesThisMessage(int iMessageID)
{
	//Going via the tools message editing function for this , since it already has stuff for
	//checking project specific messages. RAR 19/04/2006
	return Tools_Message_Editing::DoesSpecialGuidHandleThisMessage(m_uGuid,iMessageID);
}