//////////////////////////////////////////////////////////////////////////////
//
// VertexCache.h
//
// By: Nvidia.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___VERTEXCACHE_H___
#define ___VERTEXCACHE_H___ 1

// B E G I N   N A M E S P A C E /////////////////////////////////////////////

namespace NVTriStrip
{

// C L A S S E S /////////////////////////////////////////////////////////////

class VertexCache
{

public:

  VertexCache(int size);
  VertexCache();
  ~VertexCache();

  bool InCache(int entry) const;
  int AddEntry(int entry);
  void Clear();

  void Copy(VertexCache* inVcache);
  int At(int index);
  void Set(int index, int value);

private:

  int *entries;
  int numEntries;

};



inline bool VertexCache::InCache(int entry) const
{
  bool returnVal = false;

  for(int i = 0; i < numEntries; i++)
  {
    if(entries[i] == entry)
    {
      returnVal = true;
      break;
    }
  }

  return returnVal;
}


inline int VertexCache::AddEntry(int entry)
{
  int removed;

  removed = entries[numEntries - 1];

  //push everything right one
  for(int i = numEntries - 2; i >= 0; i--)
  {
    entries[i + 1] = entries[i];
  }

  entries[0] = entry;

  return removed;
}

// E N D   N A M E S P A C E /////////////////////////////////////////////////

} // namespace NVTriStrip.

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___VERTEXCACHE_H___

