//
// Tools_RenderCollisionMesh.h
//
// Created by Richard Rice - 20/09/2004
// 
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_RENDERCOLLISIONMESH_H__
#define __TOOLS_RENDERCOLLISIONMESH_H__

enum Tools_CollRenderMode
{
	TOOLS_COLLRENDER_NONE,
	TOOLS_COLLRENDER_SOLID,
	TOOLS_COLLRENDER_TRANS,
};


class Tools_RenderCollisionMesh_System
{
public :
	static void Initialise();
	static void Shutdown();

	//gets the number of times RenderModule should be called
	static int GetNumPasses();

	static void RenderModule(int iPass,int iModule);
	static void InvalidateModule(int iModule);

	static void AddRenderModeOverlayControls(class Asura_Overlay* pxOverlay,class Asura_Vector_2& xOffset);

	static bool IsRenderingCollMeshes();
	static void SetRenderMode(Tools_CollRenderMode eMode);
	static Tools_CollRenderMode GetRenderMode(){return (Tools_CollRenderMode)s_iRenderMode;}

	//cycle through the rendering modes
	static void NextRenderMode();

	//for translucent rendering mode
	static float GetZPenetration(){return s_fZPenetration;}
	static void SetZPenetration(float fZ){s_fZPenetration = fZ;}

private :

	static int s_iNumModules;
	static class Tools_RenderCollisionMesh** s_ppxRenderMeshes;

	//Polygons that shouldn't be had for the collision mesh polygons to be shown.
	static int s_iFlagsNotToShow;
	static bool s_bFlagsChanged;

	//values from Tools_CollRenderMode enum
	static int s_iRenderMode;
	static float s_fZPenetration;



};


#endif //__TOOLS_RENDERCOLLISIONMESH_H__
