//
// Tools_Mode_ShapeData.h
//
// Created by Andrew Weinkove - 07/04/2003
// 
// Copyright (C) 2002 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_MODE_SHAPEDATA_H__
#define __TOOLS_MODE_SHAPEDATA_H__

#include "Core/Asura_Hash.h"
#include "Core/Asura_Maths.h"
#include "Core/Asura_String.h"
#include "Tools_Mode.h"
class Asura_Shape;
class Asura_Mesh;

class Tools_Mode_ShapeData : public Tools_Mode
{
	public :
		
		void InitialiseMode(void);
		void ShutdownMode(void);

		void Update(void);
		void RenderWorld_PostToneMap(void);
		
		bool IsModified();
		void QuickSave();

		static unsigned GetFlags();
		static Asura_Bounding_Box *GetBB();
		static Asura_Hash_ID GetHashID();
		static void SetData(Asura_Hash_ID uHashID,unsigned uFlags, Asura_Bounding_Box *pxBB);
		static Asura_Mesh* GetMesh(){return s_pxMesh;}
		static const Asura_Vector_3& GetOffset(){return s_xOffset;}

	protected :
		virtual void AddOverlayControls(class Asura_Overlay* pxOverlay,class Asura_Vector_2& xOffset);

	private:
		static Asura_Hash_ID Tools_Mode_ShapeData::GetHashID(const char* pszFilename,bool bAssertIfNotObjectDir);

		enum DialogID
		{
			DialogID_Fragment,
		};

		void CreateShapeDataOverlay();
		static void EditBoundingBox();
		static bool HasBoundingBox();
		static void SetBoxToDefaults();
		static void RecalculateOffset();
		static void SelectFragmentType();

		static void UpdateFragmentName();
		static void UpdateOverlay();

		static bool s_bChangedCustomBB;
		static bool s_bChanged;
		static bool s_bChangedBB;
		static bool s_bUseCustomBB;
		static bool s_bHasNoCollisions;
		static bool s_bIsNeverRendered;
		static unsigned s_uFlags;
		static Asura_Bounding_Box s_xBB;
		static Asura_Vector_3 s_xOffset;
		static unsigned s_uVolumeEditID;
		static Asura_Vector_2 s_xShapeDataOverlayPosition;
		static Asura_Mesh* s_pxMesh;
		static Asura_String s_xFragmentName;
};



#endif // __TOOLS_MODE_SHAPEDATA_H__
