///////////////////////////////////////////////////////////////////////////////
//
// File      : Tools_WAV_Reader.h
// Author    : Philip Hall
// Created   : 01/10/2007
//
// Copyright (C) 2007 Rebellion. All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined __TOOLS_WAV_READER_H__
#define __TOOLS_WAV_READER_H__

#include "Core/Asura_PlatformBasics.h"


////PGH/////////////////////////////////////////
// MS WAV file format reader                 
////////////////////////////////////////////////
class Tools_WAV_Reader
{
public:	
	bool ReadHeader(const char* szFilename);
	
	// Inline accessors
	const WAVEFORMAT &GetHeader() const { return m_xWaveFormat; }
	int   GetDataOffset() const         { return m_iDataOffset; }
	u_int GetDataSize() const           { return m_uDataSize; }
	
protected:
	int	FindChunkInData(const char* pcData, int iDataSize, uint32 szChunkName);

	WAVEFORMAT  m_xWaveFormat; 
	int         m_iDataOffset;
	u_int       m_uDataSize;
};




#endif

