// Tools_Audio_Monitor.h
// Thomas Young - 30.03.09
// Copyright (C) 2009 Rebellion, All Rights Reserved.

// F I L E   W R A P P E R ///////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#if !defined __TOOLS_AUDIO_MONITOR_H__
#define __TOOLS_AUDIO_MONITOR_H__

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#ifdef ASURA_USE_AUDIO_SYSTEM

#include "Interface/Asura_Overlay.h"

// C L A S S   D E C L A R A T I O N S ///////////////////////////////////////

class Tools_Audio_Monitor : public Asura_Overlay
{
	public:
	
		static void CreateOverlay	( );
		static void DestroyOverlay	( );
		static void ToggleOverlay	( );
		static bool	IsOverlayOpen	( );

	private:
	
		Tools_Audio_Monitor		( Asura_Vector_2* const pxPos );
		~Tools_Audio_Monitor	();

		static void TransferModeData ( const int iMode );

		static Tools_Audio_Monitor*		s_pxThis;
		static Asura_Vector_2			s_xOverlayPos;

		char* s_pcAudioData;
};

#endif	// ASURA_USE_AUDIO_SYSTEM

#endif	// __TOOLS_AUDIO_MONITOR_H__

//eof
