//
// Tools_DialogueEvent_Dialogs.h
//
// Created by Richard Rice - 01/11/2006
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_DIALOGUEEVENT_DIALOGS__
#define __TOOLS_DIALOGUEEVENT_DIALOGS__

#ifdef ASURA_USE_DIALOGUE_SYSTEM

#include "Interface/Asura_Dialog.h"

//drop down list for selecting a dialogue character
class Tools_DialogueCharacter_Dialog : public Asura_Hash_DropDownList_Dialog
{
public :
	Tools_DialogueCharacter_Dialog(Asura_Vector_2& xOffset,int iNumberOfLines,Asura_Hash_ID* puCharacterID,bool* pbChangedFlag = 0 ,const char* szName = NULL)
	:Asura_Hash_DropDownList_Dialog(xOffset)
	{
		Initialise(xOffset,iNumberOfLines,puCharacterID,pbChangedFlag,szName);
	}
	
protected :
	virtual u_int GetNumberOfHashValues() const;
	virtual const char* GetNameByIndex(int iIndex) const;
	virtual const char* GetZeroHashText() const {return "*All*";}


};

//Dialog control for picking a dialogue event. When clicked it will open the dialogue event selection overlay.
class Tools_PickDialogueEvent_Dialog : public Asura_Function_Dialog
{
public :
	//szPrefix is a prefix added before the sound event name on the dialog
	//puEventHash is a pointer to the hash ID being edited
	//pbModified is an optional flag that will be set to true whenever the hash value is modified.
	Tools_PickDialogueEvent_Dialog(const char* szPrefix,const Asura_Vector_2& xOffset,Asura_Hash_ID* puEventHash,bool* pbModified = 0);

private :
	virtual void PerFrameUpdate();

	void UpdateEventLabel();

	static void OnClicked(int iThis){((Tools_PickDialogueEvent_Dialog*)iThis)->OnClicked();}
	void OnClicked();

	Asura_String m_xPrefix;
	Asura_Hash_ID* m_puEventHash;
	Asura_Hash_ID m_uEventBackup;
	bool* m_pbModified;
};

//dialog control to go along side the one above. This one just provides a convenient way of going to the edit
//event screen for the selected event
class Tools_EditDialogueEvent_Dialog : public Asura_Function_Dialog
{
public	:
	Tools_EditDialogueEvent_Dialog(const char* szName,const Asura_Vector_2& xOffset,Asura_Hash_ID* puEventHash);
private :
	virtual void PerFrameUpdate();

	static void OnClicked(int iThis){((Tools_EditDialogueEvent_Dialog*)iThis)->OnClicked();}
	void OnClicked();

	Asura_Hash_ID* m_puEventHash;
};



#endif //ASURA_USE_DIALOGUE_SYSTEM
#endif //__TOOLS_DIALOGUEEVENT_DIALOGS__