//
// Tools_PickSound.h
//
// Created by Richard Rice - 27/02/2021
// 
// Copyright (C) 2002 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_PICKSOUND_H__
#define __TOOLS_PICKSOUND_H__

#ifndef ASURA_USE_AUDIO_SYSTEM
#include "Sound/Asura_ProjectSoundIDs.h"  // project-supplied file
#endif



template <class T> class List;



class Tools_PickSound
{
	public:
		#ifdef ASURA_USE_AUDIO_SYSTEM

		static Asura_Hash_ID PickSoundFromDisk(Asura_Hash_ID uCurrentID,List<Asura_Hash_ID>* pxOutputSelectionList = 0, const char* szMessage = 0);

		static Asura_Hash_ID PickSoundForSoundEventSample(Asura_Hash_ID uCurrentID,List<Asura_Hash_ID>* pxOutputSelectionList = 0, const char* szMessage = 0);

		#else

		//If pxOutputSelectionList is non-null then it will be filled in with all the sounds selected by the user
		static Asura_Sound_ID Tools_PickSound::PickSoundFromDisk(Asura_Sound_ID eCurrentID,Asura_Sound_ID eMinID,Asura_Sound_ID eMaxID,List<Asura_Sound_ID>* pxOutputSelectionList = 0, const char* szMessage = 0);

		//loads sound if needed , and assigns it an SID in the range provided.
		//(or returns existing SID in that range).
		static Asura_Sound_ID Tools_PickSound::GetSoundIDForFilename(const char* pszRelativeFilename,Asura_Sound_ID eMinID,Asura_Sound_ID eMaxID);

		//If pxOutputSelectionList is non-null then it will be filled in with all the sounds selected by the user
		static Asura_Sound_ID Tools_PickSound::PickSoundForSoundEventSample(Asura_Sound_ID eCurrentID,List<Asura_Sound_ID>* pxOutputSelectionList = 0, const char* szMessage = 0);

		static Asura_Sound_ID Tools_PickSound::GetSoundIDForSoundEventFilename(const char* pszRelativeFilename);

		#endif
};

#endif //__TOOLS_PICKSOUND_H__
