//
// Tools_ReverbVolume.cpp
//
// Created by Richard Rice - 10/10/2007
// 
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"
#include "Sound/Tools_ReverbVolume.h"

#ifdef ASURA_USE_REVERBVOLUME_SYSTEM

#include "Interface/Asura_Dialog.h"
#include "Interface/Asura_Overlay.h"
#include "Sound/Asura_ReverbVolume.h"
#include "Sound/Asura_ReverbVolume_System.h"

#include "Load&Save/Tools_ModeDataFile.h"
#include "Load&Save/Tools_SaveAsura.h"
#include "Sound/Tools_Sound_System.h"
#include "Zone/Tools_Zone_Editor.h"


Tools_ReverbVolume_Editor::Tools_ReverbVolume_Editor()
:Tools_Zone_Editor(Asura_ReverbVolume_System::GetReverbVolumeController())
{
	TransferModeData(TOOLSMODEDATAFILE_LOAD,"ReverbVolume.dat");
}

Tools_ReverbVolume_Editor::~Tools_ReverbVolume_Editor()
{
	TransferModeData(TOOLSMODEDATAFILE_SAVE,"ReverbVolume.dat");
}


void Tools_ReverbVolume_Editor::AddZoneOverlayControls(class Asura_Overlay* pxOverlay,Asura_Vector_2& xOffset)
{
	Asura_ReverbVolume* pxReverbVolume = (Asura_ReverbVolume*) GetSelectedZone();
	Asura_Assert(pxReverbVolume, "");

	Asura_Dialog* pxDialog;

	#ifdef ASURA_USE_AUDIO_SYSTEM

		pxDialog = new Tools_Reverb_DropDownList_Dialog(xOffset, 16, &pxReverbVolume->m_uReverbType, &m_bChanged, "Reverb Type");
		pxDialog->SetHelpText("Reverb type to use while in this zone");

		pxOverlay->AddDialog(pxDialog);
		xOffset.y += Asura_Dialog::DefaultSpacing();

	#endif

	pxDialog = new Asura_Numerical_Dialog("Reverb Amount", xOffset, &pxReverbVolume->m_fReverbAmount, 0.0f, 1.0f, 0.01f, "%.2f", &m_bChanged);
	pxDialog->SetHelpText("Amount of reverb to apply");

	pxOverlay->AddDialog(pxDialog);
	xOffset.y += Asura_Dialog::DefaultSpacing();
}

void Tools_ReverbVolume_Editor::SetModified()
{
	Tools_SaveAsura::SetReverbVolumesModified();
}


#endif //ASURA_USE_REVERBVOLUME_SYSTEM

