//////////////////////////////////////////////////////////////////////////////
//
// Tools_Waypoint_Analysis.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLS_WAYPOINT_ANALYSIS_H__
#define __TOOLS_WAYPOINT_ANALYSIS_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Tabs_Dialog;
class Asura_Vector_2;
class Tools_Mode_Waypointing;

//////////////////////////////////////////////////////////////////////////////
//
// Tools_Waypoint_Analysis
//
//////////////////////////////////////////////////////////////////////////////

class Tools_Waypoint_Analysis
{
public:
    Tools_Waypoint_Analysis();
    virtual ~Tools_Waypoint_Analysis();

    virtual void Update();
    virtual void Shutdown();

    virtual void AddOverlayItemsToTabsDialogue( Asura_Tabs_Dialog* pxTabsDialogue, Asura_Vector_2& xOffset );
    virtual void RenderWorld();
	virtual void RenderText( float& fPrintX, float& fPrintY );

protected:
    virtual void AnalyseLink();
    virtual void StopLinkAnalysis();
    virtual void AnalyseRouteFind();
    virtual void StopRouteFindAnalysis();
    virtual void NextRouteFindStep();
    virtual void NextRouteFindSteps();

	static bool AllowedToAnalyseLinkStatic()			{ return s_pxThis->AllowedToAnalyseLink(); }
	static bool AllowedToStopLinkAnalysisStatic()		{ return s_pxThis->AllowedToStopLinkAnalysis(); }
	static bool AllowedToAnalyseRouteFindStatic()		{ return s_pxThis->AllowedToAnalyseRouteFind(); }
	static bool AllowedToStopRouteFindAnalysisStatic()  { return s_pxThis->AllowedToStopRouteFindAnalysis(); }
	static bool AllowedToIncrementRouteStepStatic()		{ return s_pxThis->AllowedToIncrementRouteStep(); }

	virtual bool AllowedToAnalyseLink();
	virtual bool AllowedToStopLinkAnalysis();
	virtual bool AllowedToAnalyseRouteFind();
	virtual bool AllowedToStopRouteFindAnalysis();
	virtual bool AllowedToIncrementRouteStep();

private:
    static void AnalyseLinkStatic()           { s_pxThis->AnalyseLink();           }
    static void StopLinkAnalysisStatic()      { s_pxThis->StopLinkAnalysis();      }
    static void AnalyseRouteFindStatic()      { s_pxThis->AnalyseRouteFind();      }
    static void StopRouteFindAnalysisStatic() { s_pxThis->StopRouteFindAnalysis(); }
    static void NextRouteFindStepStatic()     { s_pxThis->NextRouteFindStep();     }
    static void NextRouteFindStepsStatic()    { s_pxThis->NextRouteFindSteps();    }

protected:
    bool                     m_bLinkAnalysisSpeedChanged;
    bool                     m_bLinkAnalysisInProgress;
    bool                     m_bLinkAnalysisSuccessful;
    float                    m_fLinkAnalysisPlaybackSpeed;
    float                    m_fLinkAnalysisPlaybackTime;
    enum { MAX_POSITION_OUTPUTS = 500 };
    Asura_Vector_3*          m_pxPositionOutputArray;
    u_int                    m_uNumPositionOutputs;

    int                      m_iStartWaypoint;
    int                      m_iFinishWaypoint;

    bool                     m_bRouteFindInProgress;
    int                      m_iRouteFindStepIncrement;
    bool                     m_bRouteFindFinished;
    enum { MAX_ANALYSIS_ROUTE_LENGTH = 1024 };
    unsigned short*          m_pusRoute;
    int                      m_iRouteLength;

    static Tools_Waypoint_Analysis* s_pxThis;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__TOOLS_WAYPOINT_ANALYSIS_H__
