//////////////////////////////////////////////////////////////////////////////////////////
//
//  FILE        :  Tools_Extended_Particle_Rain_Shelter.h
//
//  CREATED     :  Adam A. Brown  (19.6.2003)
//
//  Copyright (C) 2003 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __TOOLS_EXTENDED_PARTICLE_RAIN_SHELTER_H__
#define __TOOLS_EXTENDED_PARTICLE_RAIN_SHELTER_H__


////////////////////////////////////////
// Includes
////////////////////////////////////////
#include "Core/Asura_String.h"
#include "SpecialFX/Asura_Extended_Particle_Rain_System.h"

#include "Objects/Tools_Object.h"


////////////////////////////////////////
// Forward declarations
////////////////////////////////////////
class Asura_Extended_Particle_Rain_Shelter;


//------------------------------------------------------------------------------
////////////////////////////////////////////////////////////////////////////////
//
// Tools_Extended_Particle_Rain_Shelter
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
class Tools_Extended_Particle_Rain_Shelter : public Tools_Object
{

public:
    ////////////////////////////////////////
	// Constructor / Destructor
	////////////////////////////////////////
    Tools_Extended_Particle_Rain_Shelter(Asura_Extended_Particle_Rain_Shelter* pxShelter);
    ~Tools_Extended_Particle_Rain_Shelter();


public:

    ////////////////////////////////////////
	// public statics
	////////////////////////////////////////
    static Tools_Object* Create(void);
	static void EditVolume();
    
	////////////////////////////////////////
	// public members
	////////////////////////////////////////
    void Destroy(void)
    {
        // delete the actual rain shelter
        Asura_Extended_Particle_Rain_System::DeleteRainShelter(m_pxShelter);
        Tools_Object::Destroy();
    }

    const char* GetName(){ return m_xName.GetString(); }
    const char* GetTypeDescription(){ return "Extended Rain Shelter"; }
    
    void UpdateWhileSelected();
    bool ConfirmDestruction(){ return false; }

    void CreateOverlay();
    void DeleteOverlay();

	void OnSelection();
	void OnDeselection();


protected:
    /* Data. */
    Asura_String m_xName;
    
    bool m_bChanged;

    Asura_Vector_3 m_xPrevPosition;
	Asura_Extended_Particle_Rain_Shelter *m_pxShelter;
	class Tools_Oriented_VolumeEdit_Object* VolumeObject;

    //static data for overlay
    static Asura_Vector_2 s_xOverlayPosition;
	static bool	s_bOverlayOn;
	static Tools_Extended_Particle_Rain_Shelter* s_pxThis;
};


#endif//__TOOLS_EXTENDED_PARTICLE_RAIN_SHELTER_H__
