//////////////////////////////////////////////////////////////////////////////////////////
//
//  FILE        :  Tools_Mode_Extended_Weather.h
//
//  CREATED     :  Adam A. Brown  (19.6.2003)
//
//  Copyright (C) 2003 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __TOOLS_MODE_EXTENDED_WEATHER_H__
#define __TOOLS_MODE_EXTENDED_WEATHER_H__


////////////////////////////////////////
// Includes
////////////////////////////////////////
#include "Core/Asura_Handle.h"
#include "Core/Asura_Maths.h"

#include "Tools_Mode.h"


////////////////////////////////////////
// Forward declarations.
////////////////////////////////////////
//class Tools_Weather_RainShelter;


//------------------------------------------------------------------------------
////////////////////////////////////////////////////////////////////////////////
//
// Tools Mode Extended Weather.
//
////////////////////////////////////////////////////////////////////////////////
//------------------------------------------------------------------------------
class Tools_Mode_Extended_Weather : public Tools_Mode
{
public:

	Tools_Mode_Extended_Weather()
	{
		s_pxThis = this;
	}
	
	virtual ~Tools_Mode_Extended_Weather()
	{
		s_pxThis = NULL;
	}

	virtual void InitialiseMode();
	virtual void Update();
	//virtual void Render();
	virtual void ShutdownMode();

	virtual void QuickSave();
 	virtual bool IsModified();

	virtual void SetModified() { s_bMadeChanges = true; }

public:

	// Logs current state of selection for undo
	static void PrepareUndo();
	static void Undo();
	static void Redo();

	static void TransferModeData(int iMode);

	//static void EnterSubMode( const TOOLS_WEATHER_SUBMODES eSubMode );
	//static void ExitMode( void );

	//static const TOOLS_WEATHER_SUBMODES GetSubMode(){ return s_eSubMode; };

private:
	static void HandleKeyboard();
	static void ToggleWeatherOverlay();
	static bool WeatherOverlayIsOn();
	static void CreateWeatherOverlay();

	static void CreateShelter(void);

    static void MoveSunToCamPos( void );

protected :
	virtual void AddWeatherOverlayControls(class Asura_Overlay* pxOverlay,class Asura_Vector_2& xOffset);

	
private:
	static Asura_Handle s_hMenuHandle;

	static Asura_Vector_2 s_xWeatherOverlayPosition;
	static bool	s_bWeatherOverlayOpen;

	//static TOOLS_WEATHER_SUBMODES	s_eSubMode;
	static bool	s_bRaining;
	static bool s_b2DEffect;

protected :
	static bool s_bMadeChanges;
	static Tools_Mode_Extended_Weather* s_pxThis;
};





#endif//__TOOLS_MODE_EXTENDED_WEATHER_H__
