//////////////////////////////////////////////////////////////////////////////
//
// main.cpp
//
// Copyright (c) 2005 Rebellion. All rights reserved.
//
// Description:
//
//     PC main
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////
#include <stdio.h>

#include "Core/Asura.h"

#include "Core/Asura_Maths.h"
#include "Core/Asura_Timers.h"
#include "Debugging/Asura_Logfile.h"
#include "Interface/Asura_CommandConsole.h"
#include "UnitTest/Asura_SpeedTest.h"
#include "UnitTest/Asura_UnitTest.h"

int main(int argc, char* argv[])
{
#ifdef ASURA_UNITTEST_BATCHMODE
	Asura_CommandConsole::EarlyInitialise();
	Asura_CommandConsole::LateInitialise();
	Asura_CommandConsole::Printf("Running unit tests...");
#else
	fputs("Running unit tests...", stdout);
#endif

	Asura_Random::Initialise();
	Asura_Timers::Initialise();

	Asura_UnitTest_TestResult xUnitTestResults;
	Asura_UnitTest_RunAllTests(xUnitTestResults);
#ifndef ASURA_UNITTEST_BATCHMODE
	Asura_SpeedTest_RunAllTests();
#endif

#ifdef ASURA_UNITTEST_BATCHMODE
	Asura_CommandConsole::Printf("Unit Test done...");
	Asura_CommandConsole::Shutdown();
#else
	fputs("Unit Test done, press enter: ",stdout);
	(void) fgetc(stdin);
#endif

	return xUnitTestResults.GetFailureCount();
}
// E N D   O F   F I L E /////////////////////////////////////////////////////
