//////////////////////////////////////////////////////////////////////////////
//
// Asura_EngineConfiguration.h
//
// Copyright (c) 2002 Rebellion. All rights reserved.
//
// Description:
//
//     Project-specific, PS2-specific defines
//
//     NB: All macros should either be #defined to a non-zero value or not
//     #defined at all. In particular do not #define them to 0; that will
//     still be regarded as on since they're checked for with #ifdef instead
//     of #if.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_ENGINECONFIGURATION_H___
#define ___ASURA_ENGINECONFIGURATION_H___ 1

// M A C R O S ///////////////////////////////////////////////////////////////

//
// Independent settings.
//

//#if _DEBUG || !defined(ASURA_PS2_CDEMUL)
//#define ASURA_ASSERT                                         (1)
//#endif
#define ASURA_CHUNK_USE_PER_BYTE_MACROS                      (1)
#define ASURA_GLASS_SHARD_NO_DYNAMICS                        (1)
#define ASURA_LOCALISEDTEXT_PAGE_STORAGE_SIZE                (31)       // Should be prime.

//#ifdef ASURA_PS2_SONY_SUBMISSION
//#define ASURA_NO_DEBUG_OUTPUT                                (1)
//#else
#define ASURA_LOGFILES_ENABLED                               (1)
//#endif

#define ASURA_MAIN                                           (1)
#define ASURA_MAX_NO_OF_BONES_PER_MODEL                      (41)
#define ASURA_MAX_NO_OF_HIERARCHY_ANIMS                      (768)
#define ASURA_MAX_NO_OF_HIERARCHY_SKINS                      (128)
#define ASURA_MAX_NO_OF_PARTICLE_EFFECTS                     (509)      // Must be prime.
#define ASURA_MAX_NO_OF_TEXTURE_TILES                        (275)

//#ifdef _DEBUG
//#define ASURA_MEMORYMANAGEMENT_ENABLED                       (1)
//#define ASURA_MEMORYMANAGEMENT_FILL                          (1)
//#endif

//#define ASURA_MEMORYMANAGEMENT_PROCESS_ALLOCATED_MEM         (1)
//#define ASURA_NO_NETWORK_LAG_COMPENSATION                    (1)
//#define ASURA_UPDATE_CLIENTENTITIES_EVERY_FRAME              (1)

#define ASURA_SORTEDRENDER_SORTALPHAONDISTANCE               (1)

#define ASURA_SOUND_DISABLE_OCCLUSION                        (1)

//#ifndef ASURA_PS2_SONY_SUBMISSION
//#define ASURA_SUPPORT_COMMAND_CONSOLE                        (1)
//#endif
//#ifdef ASURA_SUPPORT_COMMAND_CONSOLE
//#define ASURA_COMMAND_CONSOLE_MAX_VARS                       (128)
//#endif

//#define ASURA_SUPPORT_CONTROLLER_RUMBLE                      (1)
//#define ASURA_SUPPORT_DYNAMIC_REGION_LOADING                 (1)
//#define ASURA_SUPPORT_FMV_TEXTURES                           (1)
//#define ASURA_SUPPORT_WEATHER_SYSTEM                         (1)


//#define ASURA_TOOLS                                        (1)

//#if _DEBUG //|| !defined(ASURA_PS2_CDEMUL)
//#define ASURA_USE_DEBUG_TEXT                                 (1)
//#define ASURA_DEBUG_TEXT_MAX_BLOCKS                          (16)
//#define ASURA_DEBUG_TEXT_MAX_CHARS                           (512)
//#endif

//#define ASURA_SUPPORT_NETMSG_SYSTEM                          (1)
//#define ASURA_SUPPORT_EXTERNAL_NETWORK                       (1)
//#define ASURA_SUPPORT_MULTIPLAYER_COMMS                      (1)
//#define ASURA_SUPPORT_GAMESPY                                (1)
//#define ASURA_GAMESPY_USEANTS                                (1)    // get gamespy to use the net transport system rather than GT2
//#define ASURA_SUPPORT_GAMESPY_VOICE                          (1)

//#ifndef ASURA_PS2_SONY_SUBMISSION
//#define ASURA_ENABLE_INTERNET_SIMULATION                     (1)
//#endif

//#define ASURA_SUPPORT_SERVERCUTSCENES                        (1)

#define ASURA_RAGDOLL_USE_KNEE_FIX                           (1) 
#define ASURA_USE_CUTDOWN_RAGDOLL                            (1)

#define ASURA_USE_CLASSIFICATION_SORTED_ENTITIES             (1)
#ifdef ASURA_USE_CLASSIFICATION_SORTED_ENTITIES
#define ASURA_MAX_ENTITY_CLASSIFICATIONS                     (64)
#endif

//#define ASURA_USE_ORIGINAL_PARTICLE_SYSTEM                 (1)
//#define ASURA_USE_EXTENDED_PARTICLES                       (1)
//#define ASURA_USE_PFX                                        (1)

#ifndef ASURA_PS2_CDEMUL
#define ASURA_USE_PROFILING_SYSTEM                           (1)
#endif

#define ASURA_FONT_SYSTEM_SUPPORT_PIXEL_COORDINATES          (1)

//#define ASURA_USE_TANNOY                                     (1)
#define ASURA_DIALOGUE_CONTROLLER_MAX_STREAMS                (4)
#define ASURA_DIALOGUE_CONTROLLER_MEMORY_TYPE_COUNT          (10)

//#define ASURA_USE_PHYSICS_PHASE_ONE_RAGDOLL                  (1)

//#define ASURA_USE_WATER                                      (1)

//#define ASURA_USE_METAMUSICZONES                             (1)        // Support for defining zones for meta music system.
//#define ASURA_USE_PROJECTMETAMUSIC                           (1)        // Support other project overrides for meta music system.

//#ifndef ASURA_PS2_SONY_SUBMISSION
//#define ASURA_USE_SCREENSHOT_SYSTEM							 (1)
//#endif // #ifndef ASURA_PS2_SONY_SUBMISSION

//#define ASURA_MAX_NO_OF_BEAMS                                (128)

//#ifndef ASURA_PS2_SONY_SUBMISSION
//#define RT_SUPPORT_3D_SCREENSHOTS                            (1)
//#endif

//
// PS2 specific.
//

#ifndef ASURA_PS2_IN_VC
#define ASURA_PLATFORM_HAS_LONG_LONG_TYPE                    (1)
#endif

#define ASURA_PLATFORM_CAN_SUPPLY_FILE_DECOMPRESSOR_MEM      (1)
#define ASURA_PLATFORM_MAX_SAVE_PATH                         (13)
#define ASURA_PLATFORM_MENU_MAX_SUPPORTED_CONTROLLERS        (2)

#define ASURA_PS2_DECAL_BUFFER_POWER_2_SIZE                  (10)      // 2^10 = 1024 vertices; num vertices per decal varies depending on clipping.

#define ASURA_PS2_DEFERRED_RENDERING                         (1)

#ifdef ASURA_PS2_DEFERRED_RENDERING
#define ASURA_PS2_DEFERRED_RENDERING__VIF_BUFFER_SIZE        (0x20000) // 128Kb * 8 buffers = 940Kb.
#define ASURA_PS2_DEFERRED_RENDERING__GIF_BUFFER_SIZE        (0x2800)  // 10Kb.
#if _DEBUG
#define ASURA_PS2_DEFERRED_RENDERING__TRACK_BUFFER_USAGE     (1)       // Enables tracking of drawlist usage
#endif
#endif
#define ASURA_PS2_DISABLE_REVERB                             (1)       // Save SPU RAM.
//#define ASURA_PS2_ENV_USE_TRILINEAR                          (1)
//#if _DEBUG || !defined(ASURA_PS2_CDEMUL)
//#define ASURA_PS2_MAX_2D_LINES_PER_FRAME                     (256)     // For rendering BBs, etc.
//#endif
#define ASURA_PS2_MAX_NO_OF_OBJECTS                          (64)
#define ASURA_PS2_MAX_TOC_ENTRIES                            (525)
#define ASURA_PS2_PALETTISED_FOG                             (1)
//#define ASURA_PS2_RENDER_OBJECT_LOD_PER_CAMERA               (1)
//#define ASURA_PS2_SUPPORT_DYNAMIC_LOADING                    (1)
//#define ASURA_PS2_SUPPORT_EYETOY                             (0)
//#define ASURA_PS2_SUPPORT_GRAPHIC_NOVEL                      (1)
//#define ASURA_PS2_SUPPORT_PARTIALLY_STREAMED_SOUNDS          (1)
#define ASURA_PS2_USE_MULTISTREAM_FOR_FILE_ACCESS            (1)

//#define ASURA_PS2_ENABLE_DNAS                                (1)
//#define ASURA_PS2_SUPPORT_DLLS                               (1)
//#define ASURA_PS2_MAX_LOADED_DLLS                            (2)    // for DNAS and MP dlls

//#define ASURA_PS2_SUPPORT_USB_HEADSET                        (1)

#define ASURA_PS2_FADE_SHADOW_DIST_START                     (10.0f)
#define ASURA_PS2_FADE_SHADOW_DIST_END                       (15.0f)
#define ASURA_PS2_SHADOW_CASTING_BACKFACE_BIAS               (-0.05f)
#define ASURA_PS2_SHADOW_MAX_BUFFERS                         (8)

// Special case stuff for demo builds.
#ifdef DREDD_DEMO
    #define ASURA_PS2_DEMODISK      (1)
    #define ASURA_PS2_DEMODISK_ROOT "DREDD"

    #if !_DEBUG
        #define ASURA_PS2_SONY_SUBMISSION (1)
    #endif
#endif


// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_ENGINECONFIGURATION_H___
