#include "Core/Asura.h"

#include "UnitTest/Asura_UnitTest.h"
#include "Core/Asura_Time_System.h"

// Test the time-system
//class Test_Time_Sys;

class Asura_Time_System_UnitTest
{
	// Access class - written purely to test the internal funcs. of Asura_Time_Sys
	public:
		// DaysFrom1970() returns number of days since 1/1/70
		static int DaysFrom1970(const Asura_Time& xTime)
		{
			return Asura_Time_System::GetDayNumber(xTime);
		}	
};

ASURA_UNITTEST(Internal,Asura_Time_System)
{
	// Test the internal "Days from '70" function

	Asura_Time axT[] = {Asura_Time(2490, 0 ,0,0,0,0),
						Asura_Time(1972, 1,0 ,0,0,0),
						Asura_Time(1976, 1,27 ,0,0,0),
						Asura_Time(1982, 1,4 ,0,0,0)};

	int aiActual[] = {189927, 761, 2249, 4418};

	for (int i=0; i<4; ++i)
	{
		ASURA_UNITTEST_CHECK_EQUAL(Asura_Time_System_UnitTest::DaysFrom1970(axT[i]), aiActual[i] );
	}
}

