//////////////////////////////////////////////////////////////////////////////
//
// PS2_in_Lint.h
//
// Created by Mike Healey.
//
// Copyright (c) 2002 Rebellion. All rights reserved.
//
// lint options to suppress warnings from PS2 headers etc.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___PS2_IN_LINT_H___
#define ___PS2_IN_LINT_H___ 1

// (MH - 18.09.2002) casting char to u_long produces a warning about sign-extension
// disable this warning for the following macros.
//lint -emacro(571,SCE_VIF0_SET_CODE)
//lint -emacro(571,SCE_VIF0_SET_NOP)
//lint -emacro(571,SCE_VIF0_SET_STCYCL)
//lint -emacro(571,SCE_VIF0_SET_ITOP)
//lint -emacro(571,SCE_VIF0_SET_STMOD)
//lint -emacro(571,SCE_VIF0_SET_MARK)
//lint -emacro(571,SCE_VIF0_SET_FLUSHE)
//lint -emacro(571,SCE_VIF0_SET_MSCAL)
//lint -emacro(571,SCE_VIF0_SET_MSCNT)
//lint -emacro(571,SCE_VIF0_SET_STMASK)
//lint -emacro(571,SCE_VIF0_SET_STROW)
//lint -emacro(571,SCE_VIF0_SET_STCOL)
//lint -emacro(571,SCE_VIF0_SET_MPG)
//lint -emacro(571,SCE_VIF0_SET_UNPACK)
//lint -emacro(571,SCE_VIF1_SET_CODE)
//lint -emacro(571,SCE_VIF1_SET_NOP)
//lint -emacro(571,SCE_VIF1_SET_STCYCL)
//lint -emacro(571,SCE_VIF1_SET_OFFSET)
//lint -emacro(571,SCE_VIF1_SET_BASE)
//lint -emacro(571,SCE_VIF1_SET_ITOP)
//lint -emacro(571,SCE_VIF1_SET_STMOD)
//lint -emacro(571,SCE_VIF1_SET_MSKPATH3)
//lint -emacro(571,SCE_VIF1_SET_MARK)
//lint -emacro(571,SCE_VIF1_SET_FLUSHE)
//lint -emacro(571,SCE_VIF1_SET_FLUSH)
//lint -emacro(571,SCE_VIF1_SET_FLUSHA)
//lint -emacro(571,SCE_VIF1_SET_MSCAL)
//lint -emacro(571,SCE_VIF1_SET_MSCNT)
//lint -emacro(571,SCE_VIF1_SET_MSCALF)
//lint -emacro(571,SCE_VIF1_SET_STMASK)
//lint -emacro(571,SCE_VIF1_SET_STROW)
//lint -emacro(571,SCE_VIF1_SET_STCOL)
//lint -emacro(571,SCE_VIF1_SET_MPG)
//lint -emacro(571,SCE_VIF1_SET_DIRECT)
//lint -emacro(571,SCE_VIF1_SET_DIRECTHL)
//lint -emacro(571,SCE_VIF1_SET_UNPACK)
//lint -emacro(571,SCE_VIF1_SET_UNPACKR)
//lint -emacro(571,SCE_GIF_SET_TAG)
//lint -emacro(571,SCE_GIF_CLEAR_TAG)
//lint -emacro(571,SCE_GS_SET_ALPHA)
//lint -emacro(571,SCE_GS_SET_BITBLTBUF)
//lint -emacro(571,SCE_GS_SET_CLAMP)
//lint -emacro(571,SCE_GS_SET_COLCLAMP)
//lint -emacro(571,SCE_GS_SET_DIMX)
//lint -emacro(571,SCE_GS_SET_DTHE)
//lint -emacro(571,SCE_GS_SET_FBA)
//lint -emacro(571,SCE_GS_SET_FOG)
//lint -emacro(571,SCE_GS_SET_FOGCOL)
//lint -emacro(571,SCE_GS_SET_FRAME)
//lint -emacro(571,SCE_GS_SET_LABEL)
//lint -emacro(571,SCE_GS_SET_MIPTBP1)
//lint -emacro(571,SCE_GS_SET_MIPTBP2)
//lint -emacro(571,SCE_GS_SET_PABE)
//lint -emacro(571,SCE_GS_SET_PRIM)
//lint -emacro(571,SCE_GS_SET_PRMODE)
//lint -emacro(571,SCE_GS_SET_PRMODECONT)
//lint -emacro(571,SCE_GS_SET_RGBAQ)
//lint -emacro(571,SCE_GS_SET_SCANMSK)
//lint -emacro(571,SCE_GS_SET_SCISSOR)
//lint -emacro(571,SCE_GS_SET_SIGNAL)
//lint -emacro(571,SCE_GS_SET_ST)
//lint -emacro(571,SCE_GS_SET_TEST)
//lint -emacro(571,SCE_GS_SET_TEX0)
//lint -emacro(571,SCE_GS_SET_TEX1)
//lint -emacro(571,SCE_GS_SET_TEX2)
//lint -emacro(571,SCE_GS_SET_TEXA)
//lint -emacro(571,SCE_GS_SET_TEXCLUT)
//lint -emacro(571,SCE_GS_SET_TRXDIR)
//lint -emacro(571,SCE_GS_SET_TRXPOS)
//lint -emacro(571,SCE_GS_SET_TRXREG)
//lint -emacro(571,SCE_GS_SET_UV)
//lint -emacro(571,SCE_GS_SET_XYOFFSET)
//lint -emacro(571,SCE_GS_SET_XYZ)
//lint -emacro(571,SCE_GS_SET_XYZF)
//lint -emacro(571,SCE_GS_SET_ZBUF)
//lint -emacro(571,SCE_GS_SET_PMODE)
//lint -emacro(571,SCE_GS_SET_DISPLAY_NOINTERLACE)
//lint -emacro(571,SCE_GS_SET_DISPLAY_INTERLACE)
//lint -emacro(571,SCE_GS_SET_DISPFB)
//lint -emacro(571,SCE_GS_SET_SMODE2)
//lint -emacro(571,SCE_GS_SET_EXTBUF)
//lint -emacro(571,SCE_GS_SET_EXTDATA)
//lint -emacro(571,SCE_GS_SET_EXTWRITE)
//lint -emacro(571,SCE_GS_SET_BGCOLOR)

// Similar warnings about possible truncation...
//lint -emacro(647,SCE_GS_SET_ALPHA)
//lint -emacro(647,SCE_GS_SET_BITBLTBUF)
//lint -emacro(647,SCE_GS_SET_CLAMP)
//lint -emacro(647,SCE_GS_SET_COLCLAMP)
//lint -emacro(647,SCE_GS_SET_DIMX)
//lint -emacro(647,SCE_GS_SET_DTHE)
//lint -emacro(647,SCE_GS_SET_FBA)
//lint -emacro(647,SCE_GS_SET_FOG)
//lint -emacro(647,SCE_GS_SET_FOGCOL)
//lint -emacro(647,SCE_GS_SET_FRAME)
//lint -emacro(647,SCE_GS_SET_LABEL)
//lint -emacro(647,SCE_GS_SET_MIPTBP1)
//lint -emacro(647,SCE_GS_SET_MIPTBP2)
//lint -emacro(647,SCE_GS_SET_PABE)
//lint -emacro(647,SCE_GS_SET_PRIM)
//lint -emacro(647,SCE_GS_SET_PRMODE)
//lint -emacro(647,SCE_GS_SET_PRMODECONT)
//lint -emacro(647,SCE_GS_SET_RGBAQ)
//lint -emacro(647,SCE_GS_SET_SCANMSK)
//lint -emacro(647,SCE_GS_SET_SCISSOR)
//lint -emacro(647,SCE_GS_SET_SIGNAL)
//lint -emacro(647,SCE_GS_SET_ST)
//lint -emacro(647,SCE_GS_SET_TEST)
//lint -emacro(647,SCE_GS_SET_TEX0)
//lint -emacro(647,SCE_GS_SET_TEX1)
//lint -emacro(647,SCE_GS_SET_TEX2)
//lint -emacro(647,SCE_GS_SET_TEXA)
//lint -emacro(647,SCE_GS_SET_TEXCLUT)
//lint -emacro(647,SCE_GS_SET_TRXDIR)
//lint -emacro(647,SCE_GS_SET_TRXPOS)
//lint -emacro(647,SCE_GS_SET_TRXREG)
//lint -emacro(647,SCE_GS_SET_UV)
//lint -emacro(647,SCE_GS_SET_XYOFFSET)
//lint -emacro(647,SCE_GS_SET_XYZ)
//lint -emacro(647,SCE_GS_SET_XYZF)
//lint -emacro(647,SCE_GS_SET_ZBUF)
//lint -emacro(647,SCE_GS_SET_PMODE)
//lint -emacro(647,SCE_GS_SET_DISPLAY_NOINTERLACE)
//lint -emacro(647,SCE_GS_SET_DISPLAY_INTERLACE)
//lint -emacro(647,SCE_GS_SET_DISPFB)
//lint -emacro(647,SCE_GS_SET_SMODE2)
//lint -emacro(647,SCE_GS_SET_EXTBUF)
//lint -emacro(647,SCE_GS_SET_EXTDATA)
//lint -emacro(647,SCE_GS_SET_EXTWRITE)
//lint -emacro(647,SCE_GS_SET_BGCOLOR)

// (MP - 18.09.2002) Flag certain headers as library headers for Lint to stop
// it complaining about unused symbols, etc.
//lint +libh(Asura_PS2_MultistreamLib.h)

// (MP - 13.09.2002) Lint complains about the PS2's reent.h without this...
#define Long long
typedef unsigned Long ULong;

// (MP - 13.09.2002) We stop the PS2 std headers defining this in PS2_in_VC.h
// but then Lint complains.
typedef unsigned size_t;

// (MP - 18.09.2002) Lint complains about the lack of parentheses in some
// std library headers.
//lint -emacro(834, btoi)

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___PS2_IN_LINT_H___
