//////////////////////////////////////////////////////////////////////////////
//
// Tools_SmoothSkin_Processor_PS3.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___TOOLS_SMOOTHSKIN_PROCESSOR_PS3_H___
#define ___TOOLS_SMOOTHSKIN_PROCESSOR_PS3_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

#include <windows.h>

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Chunk_Memory_Stream;
class Tools_SmoothSkin_Processor;
class Tools_SmoothSkin_Vertex;
class Tools_SmoothSkin_SubElement;
class Tri_List;

// C L A S S E S /////////////////////////////////////////////////////////////


class Tools_SmoothSkin_Processor_PS3
{

public:

    Tools_SmoothSkin_Processor_PS3( void );
    ~Tools_SmoothSkin_Processor_PS3( void );

    bool Initialise( const Tools_SmoothSkin_Processor& xSrcProcessor );
    bool OutputToChunk( HANDLE pvFile ) const;

private:

	// Functions
    void WriteVtxToStream( const Tools_SmoothSkin_Vertex& xVtx, Asura_Chunk_Memory_Stream& xStream ) const;
	Tri_List* PartitionMesh( const u_short* puIndices, int iNumTris, int iNumVertices );

	// Types
	class ProcessedStrip;

	// Data
	const Tools_SmoothSkin_Processor*	m_pxSrcProcessor;
	ProcessedStrip*						m_pxProcessedStrips;
	u_int								m_uNumProcessedStrips;	
	u_int								m_uTotalVertices;
	u_int								m_uTotalIndices;
	u_int								m_uTotalTriangles;
};


//BW temp! put this somewhere good with a good name, if nothing equivalent exists already
//BW actually it's pretty much identical to Tools_SmoothSkin_SubElement => give that a better name then use for both.
class Tri_List 
{
	friend Tools_SmoothSkin_Processor_PS3;

public:
	Tri_List() { m_puIndices = NULL; m_uNumTris = 0; }
	Tri_List( u_int uNumTris ) { m_puIndices = new u_short[uNumTris*3]; m_uNumTris = uNumTris; }
	~Tri_List() { if ( m_puIndices ) delete[] m_puIndices; }

	u_int		GetNumTris() { return m_uNumTris; }
	u_short*	GetIndices() { return m_puIndices; }

protected:
	u_int		m_uNumTris;
	u_short*	m_puIndices;
};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___TOOLS_SMOOTHSKIN_PROCESSOR_PS3_H___
